*deck start_call_idl
c     change all keywords to lower case
      subroutine start_call_idl (STDOUT, IER)
C 
C     Routine to start IDL
C     STDOUT  Error output unit
C             IF STDOUT .le. 0 then STDOUT = 6
C     IER     Error flag
C             0 - No errors
C            -1 - IDL has been stopped and cannot be restarted.
C             1 - Unable to start IDL. Perhaps a license problem.
C     
C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_Win32Init, '_IDL_Win32Init'
CDEC$ ATTRIBUTES C :: IDL_Win32Init

      external IDL_Init !$pragma C(IDL_Init)

C   Define arguments for IDL_Init routine
      integer ARGC, ARGV, JUNKA
      integer STDOUT, IER
C
C       Flag for initialization
      integer*4 STARTIDL, LUOUT
      data STARTIDL/0/
C   Define Callable IDL common block
      common / CALLABLE_IDL / STARTIDL, LUOUT
C
C   See if IDL is initialized
C
      JUNKA =0
      ARGC =0
      ARGV =0
      IER = 0
      if (STDOUT .le. 0) then
        LUOUT = 6
      else 
        LUOUT = STDOUT
      endif
      if (STARTIDL .eq. 0) then
c        STARTIDL = IDL_Init(%val(4096), ARGC, ARGV)
        STARTIDL = IDL_Init(%val(32), ARGC, ARGV)
cWINDOWS
c       STARTIDL = IDL_Win32Init(%VAL(0), ARGC, ARGV, JUNKA)
        if (STARTIDL .eq. 0) then
          write (LUOUT, *) 'Unable to start IDL'
          IER = 1
        endif
      else if (STARTIDL .eq. -1) then
        write (LUOUT, *)
     &     'IDL has been stopped and cannot be restarted.'
        IER = -1
      endif
      call send_command('wait, 0', IER)
      call send_command('defsysv, "!CALLABLE_IDL", 1, 1 ', IER)
      return
      end

*deck end_call_idl
      subroutine end_call_idl (IER)
C 
C     routine to end callable IDL
C      IER is an ERROR flag
C         0 No error
C         1 IDL has not be started. No action taken.
C        -1 IDL has already been stopped. No action taken.
C
C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_Cleanup, '_IDL_Cleanup'
CDEC$ ATTRIBUTES C :: IDL_Cleanup

        external IDL_Cleanup !$pragma C(IDL_Cleanup)    

C
C       Flag for initialization
      integer*4 STARTIDL, LUOUT, IER

C   Define Callable IDL common block
      common / CALLABLE_IDL / STARTIDL, LUOUT
C
C   See if IDL is initialized
C
      if (STARTIDL .eq. 1) then

C   Shut down IDL
        call IDL_Cleanup(%val(1))
        STARTIDL = -1
        IER = 0
      else if (STARTIDL .eq. 0) then
        write(LUOUT, *) 'IDL has not been started. No action taken.'
        IER = 1
      else
        IER = -1
        write(LUOUT, *) 'IDL has already been stopped'
      endif 
      return
      end

*deck send_command
      subroutine send_command(COMAND, IER)
C 
C     routine to send a command to callable IDL
C     COMAND is an IDL command
C     IER      Error Flag.
C              0 No Errors
C             -1 Callable IDL not initialized
C              1 Command longer than 1023 Characters
C
C       Flag for initialization
      integer*4 STARTIDL, LUOUT

C   Define Callable IDL common block
      common / CALLABLE_IDL / STARTIDL, LUOUT

C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_ExecuteStr, '_IDL_ExecuteStr'
CDEC$ ATTRIBUTES C :: IDL_ExecuteStr

      external IDL_ExecuteStr !$pragma C(IDL_ExecuteStr)

      character*(*) COMAND

      integer  K, IER, I, J

      integer MAXCMD
      parameter (MAXCMD = 1024)
      character*(MAXCMD) CMD

      if (STARTIDL .ne. 1) then
        write(LUOUT ,1) 'Use START_CALL_IDL before sending commands'
1       format(a)
        IER = -1
        return
      endif
        K=99
      call cidl_strtrim(COMAND, K, I, J)
      if (K .eq. 0) then
        IER = 2
        write(LUOUT, 1) 'Nonblank command string must be provided'
        return
      endif

      if (K .ge. MAXCMD) then
        write(LUOUT, 1)' COMMAND LONGER THAN 1024 CHARACTERS'
        write(LUOUT, 1)'********** COMMAND TERMINATED **********'
        IER = 2
        return
      endif
      CMD = COMAND(I:J)//char(0)
         
      call IDL_ExecuteStr(%ref(CMD))
      IER =0
      return
      end

*deck send_real_var
      subroutine send_real_var (NAME, VAR, IER)
C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_StoreScalar, '_IDL_StoreScalar'
CDEC$ ATTRIBUTES C :: IDL_StoreScalar

CDEC$ ALIAS IDL_GetVarAddr1, '_IDL_GetVarAddr1'
CDEC$ ATTRIBUTES C :: IDL_GetVarAddr1

        external IDL_StoreScalar !$pragma C(IDL_StoreScalar)
        external IDL_GetVarAddr1 !$pragma C(IDL_GetVarAddr1)

C   Flag for initialization
      integer*4 STARTIDL, LUOUT

C   Define Callable IDL common block
      common / CALLABLE_IDL / STARTIDL, LUOUT

C   Define IDL Definitions  for IDL_ImportNamedArray

      integer IDL_TYP_FLOAT
      parameter (IDL_TYP_FLOAT = 4)
      integer K, IPOINT, I, J
      character *136 TMPCHAR
C
C   Passed parameters
      integer IER
      character*(*) NAME
      real VAR

      if (STARTIDL .ne. 1) then
        write(LUOUT,1) 'Use START_CALL_IDL before sending commands'
1       format(a)
        IER = -1
        return
      endif
      call cidl_strtrim(NAME, K, I, J)
      
      if (K .eq. 0) then
        IER = 1
        write(LUOUT, 1) 'Nonblank Variable name must be provided'
        return
      endif
      TMPCHAR= NAME(I:J)//char(0)
      call cidl_upcase(TMPCHAR, K)

      IPOINT = IDL_GetVarAddr1(%ref(TMPCHAR), %val(1))
      call IDL_StoreScalar(%val(IPOINT), %val(IDL_TYP_FLOAT), %ref(VAR))
c **********************************************************************
      IER = 0
      return
      end

*deck send_int_var
      subroutine send_int_var (NAME, VAR, IER)
C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_StoreScalar, '_IDL_StoreScalar'
CDEC$ ATTRIBUTES C :: IDL_StoreScalar

CDEC$ ALIAS IDL_GetVarAddr1, '_IDL_GetVarAddr1'
CDEC$ ATTRIBUTES C :: IDL_GetVarAddr1

        external IDL_StoreScalar !$pragma C(IDL_StoreScalar)
        external IDL_GetVarAddr1 !$pragma C(IDL_GetVarAddr1)

C   Flag for initialization
      integer*4 STARTIDL, LUOUT

C   Define Callable IDL common block
      common / CALLABLE_IDL / STARTIDL, LUOUT

C   Define IDL Definitions  for IDL_ImportNamedArray

      integer IDL_TYP_LONG
      parameter (IDL_TYP_LONG = 3)
      integer I, J, K, IPOINT
      character *136 TMPCHAR
C
C   Passed parameters
      integer IER
      character*(*) NAME
      integer VAR

      if (STARTIDL .ne. 1) then
        write(LUOUT,1) 'Use START_CALL_IDL before sending commands'
1       format(a)
        IER = -1
        return
      endif

      call cidl_strtrim(NAME, I, J, K)

      if (I .eq. 0) then
        IER = 1
        write(LUOUT, 1) 'Nonblank Variable name must be provided'
        return
      endif
      TMPCHAR= NAME(J:K)//char(0)
      call cidl_upcase(TMPCHAR, I)

      IPOINT = IDL_GetVarAddr1(%ref(TMPCHAR), %val(1))
      call IDL_StoreScalar(%val(IPOINT), %val(IDL_TYP_LONG), %ref(VAR))
c **********************************************************************
      IER = 0
      return
      end

*deck send_str_var
      subroutine send_str_var (NAME, VAR, IER)
C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_StoreScalar, '_IDL_StoreScalar'
CDEC$ ATTRIBUTES C :: IDL_StoreScalar

CDEC$ ALIAS IDL_GetVarAddr1, '_IDL_GetVarAddr1'
CDEC$ ATTRIBUTES C :: IDL_GetVarAddr1

        external IDL_StoreScalar !$pragma C(IDL_StoreScalar)
        external IDL_GetVarAddr1 !$pragma C(IDL_GetVarAddr1)

        structure /IDL_STRING/
           integer*4 SLENGTH
           integer*2 FLAG
           integer*4 VALUE
        end structure
        record /IDL_STRING/ IDLTITLE

C   Flag for initialization
      integer*4 STARTIDL, LUOUT

C   Define Callable IDL common block
      common / CALLABLE_IDL / STARTIDL, LUOUT

C   Define IDL Definitions  for IDL_ImportNamedArray

      integer IDL_TYP_STRING
      parameter (IDL_TYP_STRING = 7)
      integer I, J, K, IPOINT, M, len
      character *136 TMPCHAR
C
C   Passed parameters
      integer IER
      character*(*) NAME
      character*(*) VAR

      if (STARTIDL .ne. 1) then
        write(LUOUT,1) 'Use START_CALL_IDL before sending commands'
1       format(a)
        IER = -1
        return
      endif

      call cidl_strtrim(NAME, I, J, K)

      if (I .eq. 0) then
        IER = 1
        write(LUOUT, 1) 'Nonblank Variable name must be provided'
        return
      endif
      TMPCHAR= NAME(J:K)//char(0)
      call cidl_upcase(TMPCHAR, I)

      call cidl_strtrim(VAR, I, J, K)
      M = len(VAR) 
      VAR = VAR(J:K)
      if (I .eq. M) then
        IDLTITLE.SLENGTH = I-1
        IDLTITLE.FLAG = 0
        VAR(I:I) = char(0)
      else
        IDLTITLE.SLENGTH = I
        IDLTITLE.FLAG = 0
        I=I+1
        VAR(I:I) = char(0)
      endif
      IDLTITLE.VALUE = %loc(VAR)
      IPOINT = IDL_GetVarAddr1(%ref(TMPCHAR), %val(1))
      call IDL_StoreScalar(%val(IPOINT), %val(IDL_TYP_STRING), 
     &  %ref(IDLTITLE))
c **********************************************************************
      IER = 0
      return
      end


      subroutine send_byte_array (NAME, ARRAY, NDIM, IDIM, IER)

C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_ImportNamedArray, '_IDL_ImportNamedArray'
CDEC$ ATTRIBUTES C :: IDL_ImportNamedArray

        external IDL_ImportNamedArray !$pragma C(IDL_ImportNamedArray)

C   Flag for initialization
      integer*4 STARTIDL, LUOUT

C   Define Callable IDL common block
      common / CALLABLE_IDL / STARTIDL, LUOUT

C   Define IDL Definitions  for IDL_ImportNamedArray

      integer IDL_MAX_ARRAY_DIM
      integer IDL_TYP_BYTE
      parameter (IDL_MAX_ARRAY_DIM = 8)
      parameter (IDL_TYP_BYTE = 1)
      integer I, IER, J, K
      integer*4 DIM(IDL_MAX_ARRAY_DIM)
C
      character *136 TMPCHAR
C   Passed parameters
      integer NDIM, IDIM(*)
      character*(*) NAME
      real ARRAY(*)

      if (STARTIDL .ne. 1) then
        write(LUOUT,1) 'Use START_CALL_IDL before sending commands'
1       format(a)
        IER = -1
        return
      endif
      
      if (NDIM .gt. IDL_MAX_ARRAY_DIM) then
        IER = 1
        return
      endif
      do I = 1, NDIM
        DIM(I) = IDIM(I)
      enddo
      if (NDIM .lt. IDL_MAX_ARRAY_DIM) then
        do I = NDIM+1, IDL_MAX_ARRAY_DIM
          DIM(I) = 1
        enddo
      endif
      call cidl_strtrim(NAME, I, J, K)
      if (I .eq. 0) then
        IER = 2
        write(LUOUT, 1) 'Nonblank Variable name must be provided'
        return
      endif

      TMPCHAR= NAME(J:K)//char(0)
      call cidl_upcase(TMPCHAR, I)

      call IDL_ImportNamedArray(%ref(TMPCHAR), 
     & %val(NDIM), DIM, %val(IDL_TYP_BYTE), ARRAY, %val(0), %val(0))
      IER = 0
      return
      end

      subroutine send_real_array (NAME, ARRAY, NDIM, IDIM, IER)

C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_ImportNamedArray, '_IDL_ImportNamedArray'
CDEC$ ATTRIBUTES C :: IDL_ImportNamedArray

        external IDL_ImportNamedArray !$pragma C(IDL_ImportNamedArray)

C   Flag for initialization
      integer*4 STARTIDL, LUOUT

C   Define Callable IDL common block
      common / CALLABLE_IDL / STARTIDL, LUOUT

C   Define IDL Definitions  for IDL_ImportNamedArray

      integer IDL_MAX_ARRAY_DIM
      integer IDL_TYP_FLOAT
      parameter (IDL_MAX_ARRAY_DIM = 8)
      parameter (IDL_TYP_FLOAT = 4)
      integer I, IER, J, K
      integer*4 DIM(IDL_MAX_ARRAY_DIM)
C
      character *136 TMPCHAR
C   Passed parameters
      integer NDIM, IDIM(*)
      character*(*) NAME
      real ARRAY(*)

      if (STARTIDL .ne. 1) then
        write(LUOUT,1) 'Use START_CALL_IDL before sending commands'
1       format(a)
        IER = -1
        return
      endif
      
      if (NDIM .gt. IDL_MAX_ARRAY_DIM) then
        IER = 1
        return
      endif
      do I = 1, NDIM
        DIM(I) = IDIM(I)
      enddo
      if (NDIM .lt. IDL_MAX_ARRAY_DIM) then
        do I = NDIM+1, IDL_MAX_ARRAY_DIM
          DIM(I) = 1
        enddo
      endif
      call cidl_strtrim(NAME, I, J, K)
      if (I .eq. 0) then
        IER = 2
        write(LUOUT, 1) 'Nonblank Variable name must be provided'
        return
      endif

      TMPCHAR= NAME(J:K)//char(0)
      call cidl_upcase(TMPCHAR, I)

      call IDL_ImportNamedArray(%ref(TMPCHAR), 
     & %val(NDIM), DIM, %val(IDL_TYP_FLOAT), ARRAY, %val(0), %val(0))
      IER = 0
      return
      end

*deck send_integer_array
      subroutine send_integer_array (NAME, ARRAY, NDIM, IDIM, IER)

C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_ImportNamedArray, '_IDL_ImportNamedArray'
CDEC$ ATTRIBUTES C :: IDL_ImportNamedArray

        external IDL_ImportNamedArray !$pragma C(IDL_ImportNamedArray)

C   Flag for initialization
      integer*4 STARTIDL, LUOUT

C   Define Callable IDL common block
      common / CALLABLE_IDL / STARTIDL, LUOUT

C   Define IDL Definitions  for IDL_ImportNamedArray

      integer IDL_MAX_ARRAY_DIM
      integer IDL_TYP_LONG
      parameter (IDL_MAX_ARRAY_DIM = 8)
      parameter (IDL_TYP_LONG = 3)
      integer I, IER, J, K
      integer*4 DIM(IDL_MAX_ARRAY_DIM)
      character *136 TMPCHAR
C
C   Passed parameters
      integer NDIM, IDIM(*)
      character*(*) NAME
      integer ARRAY(*)

      if (STARTIDL .ne. 1) then
        write(LUOUT,1) 'Use START_CALL_IDL before sending commands'
1       format(a)
        IER = -1
        return
      endif

      if (NDIM .gt. IDL_MAX_ARRAY_DIM) then
        IER = 1
        return
      endif
      do I = 1, NDIM
        DIM(I) = IDIM(I)
      enddo
      if (NDIM .lt. IDL_MAX_ARRAY_DIM) then
        do I = NDIM+1, IDL_MAX_ARRAY_DIM
          DIM(I) = 1
        enddo
      endif

      call cidl_strtrim(NAME, I, J, K)
      
      if (I .eq. 0) then
        IER = 2
        write(LUOUT, 1) 'Nonblank Variable name must be provided'
        return
      endif
      TMPCHAR= NAME(J:K)//char(0)
      call cidl_upcase (TMPCHAR, I)

      call IDL_ImportNamedArray(%ref(TMPCHAR),
     & %val(NDIM), DIM, %val(IDL_TYP_LONG), ARRAY, %val(0), %val(0))
      IER = 0
      return
      end


*deck get_real_array
      subroutine get_real_array 
     & (NAME, ARRAY, NDIM, IDIM, NARRAY, NPASS, IER)
C **********************************************************************

C     Return a real array of NDIM dimensions. 
C
C     NAME  Name of variable in IDL
C     ARRAY Fortran array to receive data
C           Data will be packed into ARRAY
C     NDIM  Number of dimensions for "NAME"
C     IDIM  Array of NDIM elements with number of elements per dimension
C           IDIM(8) is always safe.
C     NARRAY Maximum size of ARRAY
C            NOTE: NARRAY can be of size=1
C                  See also GET_REAL_VAR
C     NPASS Maximum size of "NAME"
C     IER   Error Flag
C           -1 Callable IDL not started.
C           -2 Variable is undefined.
C          1 to 9 IDL type mismatch 
C              Error code is IDL type 1, Byte; 2, Int; 3, Long; 4, Float;
C                5, Double; 6, Complex; 7, String; 8, Structure; 9, DComplex
C 
C     
C **********************************************************************
C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_FindNamedVariable, '_IDL_FindNamedVariable'
CDEC$ ATTRIBUTES C :: IDL_FindNamedVariable

      external IDL_FindNamedVariable !$pragma C(IDL_FindNamedVariable)

C   Flag for initialization
      integer*4 STARTIDL, LUOUT

C   Define Callable IDL common block
      common / CALLABLE_IDL / STARTIDL, LUOUT

C   Define IDL Definitions  for IDL_ImportNamedArray

      integer I, J, K
      character *136 TMPCHAR

      integer VAR_PTR
      integer IDL_TYP_FLOAT
      parameter (IDL_TYP_FLOAT = 4)
C
C   Passed parameters
      integer NDIM, IDIM(*), NARRAY, NPASS, ITYPE, IER
      character*(*) NAME
      real ARRAY(*)

      if (STARTIDL .ne. 1) then
        write(LUOUT ,1) 'Use START_CALL_IDL before sending commands'
        IER = -1
        return
      endif
1       format(a)
2     format(a, i5, i5)
      
      call cidl_strtrim(NAME, I, J, K)
      if (I .eq. 0) then
        IER = -3
        write(LUOUT, 1) 'Nonblank Variable name must be provided'
        return
      endif
      call cidl_upcase(NAME, I)
      TMPCHAR = NAME(J:K)//char(0)
      VAR_PTR = 
     &   IDL_FindNamedVariable(%ref(TMPCHAR), %val(0))

      call VAR_PTR_2_VALUE(%val(VAR_PTR), ITYPE, 
     &   ARRAY, NDIM, IDIM, NARRAY, NPASS)

      if (ITYPE .ne. IDL_TYP_FLOAT) then 
        write (LUOUT, 2) 
     & '%GET_REAL_ARRAY: Float array not returned', ITYPE
        if (ITYPE .eq. 0) then
          IER = -2
        else
          IER = ITYPE
        endif
        return
      endif
      if (NPASS .gt. NARRAY) then
        write (LUOUT,2)
     & '%GET_REAL_ARRAY: Complete array not returned:', NPASS, NARRAY
        IER = -4
      endif
      return
      end

*deck get_str_var
      subroutine get_str_var (NAME, VARIABLE, NPASS, IER)
C **********************************************************************

C     Return a string variable
C
C     NAME     Name of variable in IDL
C     VARIABLE Fortran variable to receive data
C     NPASS    Number of elements returned. Should be 1.
C
C **********************************************************************
C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_FindNamedVariable, '_IDL_FindNamedVariable'
CDEC$ ATTRIBUTES C :: IDL_FindNamedVariable

      external IDL_FindNamedVariable !$pragma C(IDL_FindNamedVariable)

C   Flag for initialization
      integer*4 STARTIDL, LUOUT

C   Define Callable IDL common block
      common / CALLABLE_IDL / STARTIDL, LUOUT

C   Define IDL Definitions  for IDL_ImportNamedArray

      integer I, J, K
      character *136 TMPCHAR

      integer VAR_PTR
      integer IDL_TYP_STRING
      parameter (IDL_TYP_STRING = 7)
C
C   Passed parameters
      integer NPASS, ITYPE, IER, len
      character*(*) NAME
      character*(*) VARIABLE

      if (STARTIDL .ne. 1) then
        write(LUOUT,1) 'Use START_CALL_IDL before sending commands'
        IER = -1
        return
      endif
1     format(a)
2     format(a, i5, i5)
      call cidl_strtrim(NAME, I, J, K)
      if (I .eq. 0) then
        IER = -3
        write(LUOUT, 1) 'Nonblank Variable name must be provided'
        return
      endif

      TMPCHAR = NAME(J:K)//char(0)
      call cidl_upcase(TMPCHAR, I)
      VAR_PTR =
     &   IDL_FindNamedVariable(%ref(TMPCHAR), %val(0))
      call VAR_PTR_2_IDL_STR(%val(VAR_PTR), ITYPE,VARIABLE,NPASS,IER)
c **********************************************************************

      if (ITYPE .ne. IDL_TYP_STRING) then
        write (LUOUT, 2)
     & '%GET_STR_VAR: String variable not returned', ITYPE
        if (ITYPE .eq. 0) then
          IER = -2
        else
          IER = ITYPE
        endif
        return
      endif
      if (NPASS .eq. 0 .and. IER .ne. 0) return
      I = len(VARIABLE)
      if (NPASS .gt. I) then
        write (LUOUT,2)
     & '%GET_STR_VAR: Complete STRING not returned:', NPASS, I
        IER = 100+NPASS
      endif
      return
      end

*deck get_real_var
      subroutine get_real_var (NAME, VARIABLE, NPASS, IER)
C **********************************************************************

C     Return a real Variable
C
C     NAME     Name of variable in IDL
C     VARIABLE Fortran variable to receive data
C     NPASS    Number of elements returned. Should be 1.
C
C **********************************************************************
C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_FindNamedVariable, '_IDL_FindNamedVariable'
CDEC$ ATTRIBUTES C :: IDL_FindNamedVariable

      external IDL_FindNamedVariable !$pragma C(IDL_FindNamedVariable)

C   Flag for initialization
      integer*4 STARTIDL, LUOUT

C   Define Callable IDL common block
      common / CALLABLE_IDL / STARTIDL, LUOUT

C   Define IDL Definitions  for IDL_ImportNamedArray

      integer I, J, K
      character *136 TMPCHAR

      integer VAR_PTR
      integer IDL_TYP_FLOAT
      parameter (IDL_TYP_FLOAT = 4)
C
C   Passed parameters
      integer NDIM, IDIMM(8), NARRAY, NPASS, ITYPE, IER
      character*(*) NAME
      real VARIABLE

      NARRAY = 1
      if (STARTIDL .ne. 1) then
        write(LUOUT,1) 'Use START_CALL_IDL before sending commands'
        return
      endif
1       format(a)
2     format(a, i5, i5)
      call cidl_strtrim(NAME, I, J, K)
      if (I .eq. 0) then
        IER = -3
        write(LUOUT, 1) 'Nonblank Variable name must be provided'
        return
      endif

      TMPCHAR = NAME(J:K)//char(0)
C     call cidl_upcase(TMPCHAR, I)

      VAR_PTR =
     &   IDL_FindNamedVariable(%ref(TMPCHAR), %val(0))

      call VAR_PTR_2_VALUE(%val(VAR_PTR), ITYPE,
     &   VARIABLE, NDIM, IDIMM, NARRAY, NPASS)

      if (ITYPE .ne. IDL_TYP_FLOAT) then
        write (LUOUT, 2)
     & '%GET_REAL_VAR: Float variable not returned', ITYPE
        if (ITYPE .eq. 0) then
          IER = -2
        else
          IER = ITYPE
        endif
        return
      endif

      if (NPASS .gt. NARRAY) then
        write (LUOUT,2)
     & '%GET_REAL_VAR: Complete array not returned:', NPASS, NARRAY
        IER = -4
      endif

      return
      end

*deck get_integer_var
      subroutine get_integer_var (NAME, VARIABLE, NPASS, IER)
C **********************************************************************

C     Return a Integer Variable
C
C     NAME     Name of variable in IDL
C     VARIABLE Fortran variable to receive data
C     NPASS    Number of elements returned. Should be 1.
C
C **********************************************************************
C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_FindNamedVariable, '_IDL_FindNamedVariable'
CDEC$ ATTRIBUTES C :: IDL_FindNamedVariable

      external IDL_FindNamedVariable !$pragma C(IDL_FindNamedVariable)

C   Flag for initialization
      integer*4 STARTIDL, LUOUT

C   Define Callable IDL common block
      common / CALLABLE_IDL / STARTIDL, LUOUT

C   Define IDL Definitions  for IDL_ImportNamedArray

      integer I, J, K
      character *136 TMPCHAR

      integer VAR_PTR
      integer IDL_TYP_LONG
      parameter (IDL_TYP_LONG = 3)
C
C   Passed parameters
      integer NDIM, IDIMM(8), NARRAY, NPASS, ITYPE, IER
      character*(*) NAME
      integer VARIABLE

      NARRAY = 1
      if (STARTIDL .ne. 1) then
        write(LUOUT,1) 'Use START_CALL_IDL before sending commands'
        return
      endif
1       format(a)
2     format(a, i5, i5)
      call cidl_strtrim(NAME, I, J, K)
      if (I .eq. 0) then
        IER = -3
        write(LUOUT, 1) 'Nonblank Variable name must be provided'
        return
      endif
      TMPCHAR = NAME(J:K)//char(0)
      VAR_PTR =
     &   IDL_FindNamedVariable(%ref(TMPCHAR), %val(0))

      call VAR_PTR_2_VALUE(%val(VAR_PTR), ITYPE,
     &   VARIABLE, NDIM, IDIMM, NARRAY, NPASS)

      if (ITYPE .ne. IDL_TYP_LONG) then
        write (LUOUT, 2)
     & '%GET_INTEGER_VAR: Integer variable not returned', ITYPE
        if (ITYPE .eq. 0) then
          IER = -2
        else
          IER = ITYPE
        endif
        return
      endif

      if (NPASS .gt. NARRAY) then
        write (LUOUT,2)
     & '%GET_INTEGER_VAR: Complete array not returned:', NPASS, NARRAY
        IER = -4
      endif

      return
      end


*deck get_integer_array
      subroutine get_integer_array 
     &   (NAME, ARRAY, NDIM, IDIMM, NARRAY, NPASS, IER)
C **********************************************************************

C     Return a real array of NDIM dimensions.
C
C     NAME  Name of variable in IDL
C     ARRAY Fortran array to receive data
C           Data will be packed into ARRAY
C     NDIM  Number of dimensions for "NAME"
C     IDIM  Array of NDIM elements with number of elements per dimension
C           IDIM(8) is always save.
C     NARRAY Maximum size of ARRAY
C            NOTE: NARRAY can be of size=1
C                  See also GET_INTEGER_VAR
C     NPASS Maximum size of "NAME"
C
C **********************************************************************
C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_FindNamedVariable, '_IDL_FindNamedVariable'
CDEC$ ATTRIBUTES C :: IDL_FindNamedVariable

      external IDL_FindNamedVariable !$pragma C(IDL_FindNamedVariable)

C   Flag for initialization
      integer*4 STARTIDL, LUOUT

C   Define Callable IDL common block
      common / CALLABLE_IDL / STARTIDL, LUOUT

C   Define IDL Definitions  for IDL_ImportNamedArray

      integer I, J, K
      character *136 TMPCHAR

      integer VAR_PTR
      integer IDL_TYP_LONG
      parameter (IDL_TYP_LONG = 3)
C
C   Passed parameters
      integer NDIM, IDIMM(*), NARRAY, NPASS, ITYPE
      character*(*) NAME
      integer ARRAY(*)

      if (STARTIDL .ne. 1) then
        write(LUOUT,1) 'Use START_CALL_IDL before sending commands'
        return
      endif
1       format(a)
2     format(a, i5, i5)

      call cidl_strtrim(NAME, I, J, K)
      if (I .eq. 0) then
        IER = -3
        write(LUOUT, 1) 'Nonblank Variable name must be provided'
        return
      endif
      TMPCHAR = NAME(J:K)//char(0)

      VAR_PTR =
     &   IDL_FindNamedVariable(%ref(TMPCHAR), %val(0))

      call VAR_PTR_2_VALUE(%val(VAR_PTR), ITYPE,
     &   ARRAY, NDIM, IDIMM, NARRAY, NPASS)

      if (ITYPE .ne. IDL_TYP_LONG) then
        write (LUOUT, 2)
     & '%GET_INTEGER_ARRAY: Integer array not returned', ITYPE
        if (ITYPE .eq. 0) then
          IER = -2
        else
          IER = ITYPE
        endif
        return
      endif

      if (NPASS .gt. NARRAY) then
        write (LUOUT,2)
     & '%GET_INTEGER_ARRAY: Complete array not returned:', NPASS, NARRAY
        IER = -4
      endif

      return
      end

*deck var_ptr_2_idl_str
      subroutine VAR_PTR_2_IDL_STR(VPTR, ITYPE, VAR, NPASS, IER)
C
C       Declare a Fortran Record type that has a compatible form with
C       the IDL C struct IDL_VARIABLE for a floating point value.
C       Note this structure contains a union which is the size of
C       the largest data type.  This structure has been padded to
C       support the union.   Fortran records are not part of
C       F77, but most compilers have this option.

      include 'idl_variable.inc'

      record /IDL_VARIABLE/ VPTR

      character *(*) VAR
      integer ITYPE, NPASS, IER
      integer FLAG, ichar

      VAR = ' '
      ITYPE = ichar(VPTR.TYYPE)
      if (ITYPE .ne. 7) then
        NPASS = 0
        return
      endif

      FLAG = iand(ichar(VPTR.FLAGS), 4)
      if (FLAG .eq. 4) then
C       ARRAY
        NPASS = 0
        IER = -4
        return
      else
        IER = 0
        call IDL_STRING_2_STR(VPTR.VALUE, VAR, NPASS)
      endif
      return
      end

*deck idl_string_2_str
      subroutine IDL_STRING_2_STR(STR_STR, VAR, NPASS)
cWINDOWS
      external strncpy !$pragma C(strncpy)
      integer NPASS, L, len
      character *(*) VAR
      structure /IDL_STRING/
         integer*4 SLENGTH
         integer*2 FLAG
         integer*4 VALUE
      end structure
      record /IDL_STRING/ STR_STR
      NPASS = STR_STR.SLENGTH
      L = min(len(VAR), NPASS)
      VAR=' '
      if(L .gt. 0) call strncpy(%ref(VAR),%val(STR_STR.VALUE),%val(L))
c
cWINDOWS
c      IF(L .gt. 0) call XSTRNCPY(VAR, %val(STR_STR.VALUE), %val(L))
      return
      end
      subroutine XSTRNCPY(VAR,STR)
      character *(*) VAR, STR
      integer LV, LS, I, J
      integer ichar, len
C     Depending on how the computer passes strings these lengths could
C       be switched. Use the MINIMUM only.
      LV = len(VAR)
      LS = len(STR)
      M= min (LV, LS)
      do  I = 1, M
        J = ichar(STR(I:I))
        if (J .eq. 0) goto 2
        VAR(I:I) = char(J)
      enddo
2     continue
      return
      end
*deck var_ptr_2_value
      subroutine VAR_PTR_2_VALUE(VPTR, ITYPE, 
     &   ARRAY, NDIM, IDIMM, NARRAY, NPASS)
C
C       Declare a Fortran Record type that has a compatible form with
C       the IDL C struct IDL_VARIABLE for a floating point value.
C       Note this structure contains a union which is the size of
C       the largest data type.  This structure has been padded to
C       support the union.   Fortran records are not part of
C       F77, but most compilers have this option.

      include 'idl_variable.inc'

      record /IDL_VARIABLE/ VPTR

      integer ARRAY(*)
      integer ITYPE, NDIM, IDIMM(*), NARRAY, NPASS
      integer FLAG, iand, ichar

      ITYPE = ichar(VPTR.TYYPE)
      if (ITYPE .ne. 3  .and. ITYPE .ne. 4 .and. 
     &   ITYPE .ne. 1) then
        NPASS = 0
        return
      endif
      
      FLAG = iand(ichar(VPTR.FLAGS), 4)
      if (FLAG .eq. 4) then 
C       ARRAY
        call VAR_PTR_2_ARRAY(%val(VPTR.VALUE), 
     &    ARRAY, NDIM, IDIMM, NARRAY, NPASS)
      else 
        NPASS = 1
        NDIM = 1
        IDIMM(1) = 1
        if (NARRAY .lt. 1) NARRAY = 1
        ARRAY(1)=VPTR.VALUE
      endif
      return
      end

*deck var_ptr_2_array
      subroutine VAR_PTR_2_ARRAY(VALUE, 
     &    ARRAY, NDIM, IDIM, NARRAY, NPASS)
C
C     Convert an IDL_ARRAY to Fortran variables
C
      integer VALUE(*), ARRAY(*), NDIM, IDIM(*), NARRAY, NPASS
      integer IVAL, I
      
      NPASS = VALUE(3)
      IVAL = min(NPASS, NARRAY)
      NDIM = ishft(VALUE(5), -24)
      do I = 1, NDIM
        IDIM(I) = VALUE(5+I)
      enddo
      call MOVE_VAR_PTR_2_ARRAY(%val(VALUE(4)), ARRAY, IVAL)
      return
      end

*deck move_var_ptr_2_array
      subroutine MOVE_VAR_PTR_2_ARRAY(IA, IB, NP)
      integer IA(*), IB(*), NP, I
      do I = 1, NP
        IB(I)= IA(I)
      enddo
      return
      end

*deck idl_write
      subroutine idl_write(INPUT, FLAG)
c
c     This routine writes a string to an IDL display 
c
c     If flag is zero, no leading characters will be printed.
c       If flag is not zero, then the value of the IDL system variable
c          !MSG_PREFIX will be printed. (Default value = '% ')
c
      character *(*) INPUT
      integer FLAG
      integer I, len, DONE, ichar
      integer MAXLEN
      parameter (MAXLEN=1024)
      character*(MAXLEN) TEMP
C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_Message, '_IDL_Message'
CDEC$ ATTRIBUTES C :: IDL_Message

      external IDL_Message !$pragma C(IDL_Message)
C     check the length and set the last character to a char(0)
      I = len(INPUT)
      DONE = 0
      do while (I .gt. 0 .and. DONE .eq. 0)
        if (ichar(INPUT(I:I)) .ge. 33 .and.
     &    ichar(INPUT(I:I)) .le. 126) then
          DONE = 1
        else 
          I = I-1
        endif
      enddo

      if (I .gt. 0) then
        if (I .ge. MAXLEN) I = MAXLEN-1
        TEMP = INPUT(1:I)//char(0)
      else
        TEMP = ' '//char(0)
      endif
      if (FLAG .eq. 0) then
        call IDL_Message(%val(-1), %val(262144), %ref(TEMP))
      else
        call IDL_Message(%val(-1), %val(0), %ref(TEMP))
      endif
c **********************************************************************
      return
      end

*deck cidl_strtrim
      subroutine cidl_strtrim(INPUT, LENGTH, J, I)
      character INPUT*(*)
      integer len, I, J, K, LENGTH, ichar
C
C     FIND THE MINIMUM LENGTH
C
      K = len(INPUT)
C
C     FIND THE FIRST NONBLANK character
C
      do I = K, 1, -1
        if(ichar(INPUT(I:I)) .ge. 33 .and. 
     &    ichar(INPUT(I:I)) .le. 126) goto 2
      enddo
      LENGTH = 0
      return
C
C     CHECK FOR INITIAL BLANK characterS
C
2     J = 1
      if (I .gt. 1) then
        do J = 1, I-1
          if(ichar(INPUT(J:J)) .ge. 33 .and. 
     &      ichar(INPUT(J:J)) .le. 126)  goto 22
        enddo
        J=I
      endif
C
C     RETURN THE LENGTH AND THE VALUES
C
22    LENGTH = I+1-J
C     INPUT = INPUT(J:I)
       
      return
      end

*deck cidl_upcase
      subroutine cidl_upcase(WORD, LENGTH)
c
c converts word to upper case
c
      character*(*) WORD
      character*1 CTMP
      integer LENGTH, I, len, ichar
c
      LENGTH = min(len(WORD), LENGTH)
c
      do 1 I=1,LENGTH
c
c make sure character is alphabetic
c
        if( ichar(WORD(I:I)) .ge. 97  .and.
     &      ichar(WORD(I:I)) .le. 122      )then
          CTMP = char(ichar(WORD(I:I))-32)
          WORD(I:I) = CTMP
        endif
    1 continue
c
      return
      end
