*deck start_call_idl
      SUBROUTINE start_call_idl (STDOUT, IER)
C 
C     Routine to start IDL
C     STDOUT  Error output unit
C             IF STDOUT .LE. 0 then STDOUT = 6
C     IER     Error flag
C             0 - No errors
C            -1 - IDL has been stopped and cannot be restarted.
C             1 - Unable to start IDL. Perhaps a license problem.
C     
C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_Win32Init, '_IDL_Win32Init'
CDEC$ ATTRIBUTES C :: IDL_Win32Init
CDEC$ ALIAS IDL_ToutPush, '_IDL_ToutPush'
CDEC$ ATTRIBUTES C :: IDL_ToutPush

C      EXTERNAL IDL_Init !$pragma C(IDL_Init)
CWINDOWS
      EXTERNAL IDL_Win32Init, IDL_ToutPush
C   Define arguments for IDL_Init routine
      INTEGER ARGC, ARGV, JUNKA
      INTEGER STDOUT, IER
C
C       Flag for initialization
      EXTERNAL MY_IDL_PRINTIT
      INTEGER*4 STARTIDL, LUOUT
CWINDOWS
      INTEGER*4 FUNCTION_PTR
      DATA STARTIDL/0/
C   Define Callable IDL common block
      COMMON / CALLABLE_IDL / STARTIDL, LUOUT
C
C   See if IDL is initialized
C
      ARGC =0
      ARGV =0
      IER = 0
      IF (STDOUT .LE. 0) THEN
        LUOUT = 6
      ELSE 
        LUOUT = STDOUT
      ENDIF
      IF (STARTIDL .EQ. 0) THEN
c       STARTIDL = IDL_Init(%VAL(0), ARGC, ARGV)
CWINDOWS
      JUNKA=0
        STARTIDL = IDL_Win32Init(%VAL(4096), ARGC, ARGV, JUNKA)
        IF (STARTIDL .EQ. 0) THEN
          WRITE (LUOUT, *) 'Unable to start IDL'
          IER = 1
          RETURN
        ENDIF
CWINDOWS
        FUNCTION_PTR = %LOC(MY_IDL_PRINTIT)
        CALL IDL_ToutPush(FUNCTION_PTR)
        IER = 0
CWINDOWS
C       PRINT *, 'STARTIDL ', STARTIDL
      ELSE IF (STARTIDL .EQ. -1) THEN
        WRITE (LUOUT, *)
     &     'IDL has been stopped and cannot be restarted.'
        IER = -1
      ENDIF
      CALL send_command('wait, 0', IER)
      CALL send_command('defsysv, "!CALLABLE_IDL", 1, 1 ', IER)
      RETURN
      END

*deck MY_IDL_PRINTIT
      SUBROUTINE MY_IDL_PRINTIT (FLAG_VAL, PRINT_STR)
      INTEGER FLAG, FLAG_VAL
      CHARACTER*(*) PRINT_STR
      FLAG= %LOC(FLAG_VAL)
      IF ((FLAG .and. 4) .GT. 0) THEN
        WRITE(6, '(A)') PRINT_STR
      ELSE
        WRITE(6, '(A$)') PRINT_STR
      ENDIF
      RETURN
      END

*deck end_call_idl
      SUBROUTINE end_call_idl (IER)
C 
C     routine to end callable IDL
C      IER is an ERROR flag
C         0 No error
C         1 IDL has not be started. No action taken.
C        -1 IDL has already been stopped. No action taken.
C
C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_Cleanup, '_IDL_Cleanup'
CDEC$ ATTRIBUTES C :: IDL_Cleanup

        EXTERNAL IDL_Cleanup !$pragma C(IDL_Cleanup)    

C
C       Flag for initialization
      INTEGER*4 STARTIDL, LUOUT, IER

C   Define Callable IDL common block
      COMMON / CALLABLE_IDL / STARTIDL, LUOUT
C
C   See if IDL is initialized
C
      IF (STARTIDL .EQ. 1) THEN

C   Shut down IDL
        CALL IDL_Cleanup(%VAL(1))
        STARTIDL = -1
        IER = 0
      ELSE IF (STARTIDL .EQ. 0) THEN
        WRITE(LUOUT, *) 'IDL has not been started. No action taken.'
        IER = 1
      ELSE
        IER = -1
        WRITE(LUOUT, *) 'IDL has already been stopped'
      ENDIF 
      RETURN
      END

*deck send_command
      SUBROUTINE send_command(COMAND, IER)
C 
C     routine to send a command to callable IDL
C     COMAND is an IDL command
C     IER      Error Flag.
C              0 No Errors
C             -1 Callable IDL not initialized
C              1 Command longer than 1023 Characters
C
C       Flag for initialization
      INTEGER*4 STARTIDL, LUOUT

C   Define Callable IDL common block
      COMMON / CALLABLE_IDL / STARTIDL, LUOUT

C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_ExecuteStr, '_IDL_ExecuteStr'
CDEC$ ATTRIBUTES C :: IDL_ExecuteStr

      EXTERNAL IDL_ExecuteStr !$pragma C(IDL_ExecuteStr)
      INTEGER IDL_ExecuteStr
      CHARACTER*(*) COMAND

      INTEGER  K, IER, I, J

      INTEGER MAXCMD
      PARAMETER (MAXCMD = 1024)
      CHARACTER*(MAXCMD) CMD
      
      IF (STARTIDL .NE. 1) THEN
        WRITE(LUOUT ,1) 'Use START_CALL_IDL before sending commands'
1       FORMAT(A)
        IER = -1
        RETURN
      ENDIF
        K=99
      CALL cidl_strtrim(COMAND, K, I, J)
      IF (K .EQ. 0) THEN
        IER = 2
        WRITE(LUOUT, 1) 'Nonblank command string must be provided'
        RETURN
      ENDIF

      IF (K .GE. MAXCMD) THEN
        WRITE(LUOUT, 1)' COMMAND LONGER THAN 1024 CHARACTERS'
        WRITE(LUOUT, 1)'********** COMMAND TERMINATED **********'
        IER = 2
        RETURN
      ENDIF
      CMD = COMAND(I:J)//CHAR(0)
      IER = -1        
      IER = IDL_ExecuteStr(%REF(CMD))
      RETURN
      END

*deck send_real_var
      SUBROUTINE send_real_var (NAME, VAR, IER)
C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_StoreScalar, '_IDL_StoreScalar'
CDEC$ ATTRIBUTES C :: IDL_StoreScalar

CDEC$ ALIAS IDL_GetVarAddr1, '_IDL_GetVarAddr1'
CDEC$ ATTRIBUTES C :: IDL_GetVarAddr1

        EXTERNAL IDL_StoreScalar !$pragma C(IDL_StoreScalar)
        EXTERNAL IDL_GetVarAddr1 !$pragma C(IDL_GetVarAddr1)

C   Flag for initialization
      INTEGER*4 STARTIDL, LUOUT

C   Define Callable IDL common block
      COMMON / CALLABLE_IDL / STARTIDL, LUOUT

C   Define IDL Definitions  for IDL_ImportNamedArray

      INTEGER IDL_TYP_FLOAT
      PARAMETER (IDL_TYP_FLOAT = 4)
      INTEGER K, IPOINT, I, J
      CHARACTER *136 TMPCHAR
C
C   Passed parameters
      INTEGER IER
      CHARACTER*(*) NAME
      REAL VAR

      IF (STARTIDL .NE. 1) THEN
        WRITE(LUOUT,1) 'Use START_CALL_IDL before sending commands'
1       FORMAT(A)
        IER = -1
        RETURN
      ENDIF
      CALL cidl_strtrim(NAME, K, I, J)
      
      IF (K .EQ. 0) THEN
        IER = 1
        WRITE(LUOUT, 1) 'Nonblank Variable name must be provided'
        RETURN
      ENDIF
      TMPCHAR= NAME(I:J)//CHAR(0)
      CALL cidl_upcase(TMPCHAR, K)

      IPOINT = IDL_GetVarAddr1(%REF(TMPCHAR), %VAL(1))
      CALL IDL_StoreScalar(%VAL(IPOINT), %VAL(IDL_TYP_FLOAT), %REF(VAR))
c **********************************************************************
      IER = 0
      RETURN
      END

*deck send_int_var
      SUBROUTINE send_int_var (NAME, VAR, IER)
C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_StoreScalar, '_IDL_StoreScalar'
CDEC$ ATTRIBUTES C :: IDL_StoreScalar

CDEC$ ALIAS IDL_GetVarAddr1, '_IDL_GetVarAddr1'
CDEC$ ATTRIBUTES C :: IDL_GetVarAddr1

        EXTERNAL IDL_StoreScalar !$pragma C(IDL_StoreScalar)
        EXTERNAL IDL_GetVarAddr1 !$pragma C(IDL_GetVarAddr1)

C   Flag for initialization
      INTEGER*4 STARTIDL, LUOUT

C   Define Callable IDL common block
      COMMON / CALLABLE_IDL / STARTIDL, LUOUT

C   Define IDL Definitions  for IDL_ImportNamedArray

      INTEGER IDL_TYP_LONG
      PARAMETER (IDL_TYP_LONG = 3)
      INTEGER I, J, K, IPOINT
      CHARACTER *136 TMPCHAR
C
C   Passed parameters
      INTEGER IER
      CHARACTER*(*) NAME
      INTEGER VAR

      IF (STARTIDL .NE. 1) THEN
        WRITE(LUOUT,1) 'Use START_CALL_IDL before sending commands'
1       FORMAT(A)
        IER = -1
        RETURN
      ENDIF

      CALL cidl_strtrim(NAME, I, J, K)

      IF (I .EQ. 0) THEN
        IER = 1
        WRITE(LUOUT, 1) 'Nonblank Variable name must be provided'
        RETURN
      ENDIF
      TMPCHAR= NAME(J:K)//CHAR(0)
      CALL cidl_upcase(TMPCHAR, I)

      IPOINT = IDL_GetVarAddr1(%REF(TMPCHAR), %VAL(1))
      CALL IDL_StoreScalar(%VAL(IPOINT), %VAL(IDL_TYP_LONG), %REF(VAR))
c **********************************************************************
      IER = 0
      RETURN
      END

*deck send_str_var
      SUBROUTINE send_str_var (NAME, VAR, IER)
C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_StoreScalar, '_IDL_StoreScalar'
CDEC$ ATTRIBUTES C :: IDL_StoreScalar

CDEC$ ALIAS IDL_GetVarAddr1, '_IDL_GetVarAddr1'
CDEC$ ATTRIBUTES C :: IDL_GetVarAddr1

        EXTERNAL IDL_StoreScalar !$pragma C(IDL_StoreScalar)
        EXTERNAL IDL_GetVarAddr1 !$pragma C(IDL_GetVarAddr1)

        STRUCTURE /IDL_STRING/
           INTEGER*4 SLENGTH
           INTEGER*2 FLAG
           INTEGER*4 VALUE
        END STRUCTURE
        RECORD /IDL_STRING/ IDLTITLE

C   Flag for initialization
      INTEGER*4 STARTIDL, LUOUT

C   Define Callable IDL common block
      COMMON / CALLABLE_IDL / STARTIDL, LUOUT

C   Define IDL Definitions  for IDL_ImportNamedArray

      INTEGER IDL_TYP_STRING
      PARAMETER (IDL_TYP_STRING = 7)
      INTEGER I, J, K, IPOINT, M, LEN
      CHARACTER *136 TMPCHAR
C
C   Passed parameters
      INTEGER IER
      CHARACTER*(*) NAME
      CHARACTER*(*) VAR

      IF (STARTIDL .NE. 1) THEN
        WRITE(LUOUT,1) 'Use START_CALL_IDL before sending commands'
1       FORMAT(A)
        IER = -1
        RETURN
      ENDIF

      CALL cidl_strtrim(NAME, I, J, K)

      IF (I .EQ. 0) THEN
        IER = 1
        WRITE(LUOUT, 1) 'Nonblank Variable name must be provided'
        RETURN
      ENDIF
      TMPCHAR= NAME(J:K)//CHAR(0)
      CALL cidl_upcase(TMPCHAR, I)

      CALL cidl_strtrim(VAR, I, J, K)
      M = LEN(VAR) 
      VAR = VAR(J:K)
      IF (I .EQ. M) THEN
        IDLTITLE.SLENGTH = I-1
        IDLTITLE.FLAG = 0
        VAR(I:I) = CHAR(0)
      ELSE
        IDLTITLE.SLENGTH = I
        IDLTITLE.FLAG = 0
        I=I+1
        VAR(I:I) = CHAR(0)
      ENDIF
      IDLTITLE.VALUE = %LOC(VAR)
      IPOINT = IDL_GetVarAddr1(%REF(TMPCHAR), %VAL(1))
      CALL IDL_StoreScalar(%VAL(IPOINT), %VAL(IDL_TYP_STRING), 
     &  %REF(IDLTITLE))
c **********************************************************************
      IER = 0
      RETURN
      END


      SUBROUTINE send_byte_array (NAME, ARRAY, NDIM, IDIM, IER)

C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_ImportNamedArray, '_IDL_ImportNamedArray'
CDEC$ ATTRIBUTES C :: IDL_ImportNamedArray

        EXTERNAL IDL_ImportNamedArray !$pragma C(IDL_ImportNamedArray)

C   Flag for initialization
      INTEGER*4 STARTIDL, LUOUT

C   Define Callable IDL common block
      COMMON / CALLABLE_IDL / STARTIDL, LUOUT

C   Define IDL Definitions  for IDL_ImportNamedArray

      INTEGER IDL_MAX_ARRAY_DIM
      INTEGER IDL_TYP_BYTE
      PARAMETER (IDL_MAX_ARRAY_DIM = 8)
      PARAMETER (IDL_TYP_BYTE = 1)
      INTEGER I, IER, J, K
      INTEGER*4 DIM(IDL_MAX_ARRAY_DIM)
C
      CHARACTER *136 TMPCHAR
C   Passed parameters
      INTEGER NDIM, IDIM(*)
      CHARACTER*(*) NAME
      REAL ARRAY(*)

      IF (STARTIDL .NE. 1) THEN
        WRITE(LUOUT,1) 'Use START_CALL_IDL before sending commands'
1       FORMAT(A)
        IER = -1
        RETURN
      ENDIF
      
      IF (NDIM .GT. IDL_MAX_ARRAY_DIM) THEN
        IER = 1
        RETURN
      ENDIF
      DO I = 1, NDIM
        DIM(I) = IDIM(I)
      ENDDO
      IF (NDIM .LT. IDL_MAX_ARRAY_DIM) THEN
        DO I = NDIM+1, IDL_MAX_ARRAY_DIM
          DIM(I) = 1
        ENDDO
      ENDIF
      CALL cidl_strtrim(NAME, I, J, K)
      IF (I .EQ. 0) THEN
        IER = 2
        WRITE(LUOUT, 1) 'Nonblank Variable name must be provided'
        RETURN
      ENDIF

      TMPCHAR= NAME(J:K)//CHAR(0)
      CALL cidl_upcase(TMPCHAR, I)

      CALL IDL_ImportNamedArray(%REF(TMPCHAR), 
     & %VAL(NDIM), DIM, %VAL(IDL_TYP_BYTE), ARRAY, %VAL(0), %VAL(0))
      IER = 0
      RETURN
      END

      SUBROUTINE send_real_array (NAME, ARRAY, NDIM, IDIM, IER)

C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_ImportNamedArray, '_IDL_ImportNamedArray'
CDEC$ ATTRIBUTES C :: IDL_ImportNamedArray

        EXTERNAL IDL_ImportNamedArray !$pragma C(IDL_ImportNamedArray)

C   Flag for initialization
      INTEGER*4 STARTIDL, LUOUT

C   Define Callable IDL common block
      COMMON / CALLABLE_IDL / STARTIDL, LUOUT

C   Define IDL Definitions  for IDL_ImportNamedArray

      INTEGER IDL_MAX_ARRAY_DIM
      INTEGER IDL_TYP_FLOAT
      PARAMETER (IDL_MAX_ARRAY_DIM = 8)
      PARAMETER (IDL_TYP_FLOAT = 4)
      INTEGER I, IER, J, K
      INTEGER*4 DIM(IDL_MAX_ARRAY_DIM)
C
      CHARACTER *136 TMPCHAR
C   Passed parameters
      INTEGER NDIM, IDIM(*)
      CHARACTER*(*) NAME
      REAL ARRAY(*)

      IF (STARTIDL .NE. 1) THEN
        WRITE(LUOUT,1) 'Use START_CALL_IDL before sending commands'
1       FORMAT(A)
        IER = -1
        RETURN
      ENDIF
      
      IF (NDIM .GT. IDL_MAX_ARRAY_DIM) THEN
        IER = 1
        RETURN
      ENDIF
      DO I = 1, NDIM
        DIM(I) = IDIM(I)
      ENDDO
      IF (NDIM .LT. IDL_MAX_ARRAY_DIM) THEN
        DO I = NDIM+1, IDL_MAX_ARRAY_DIM
          DIM(I) = 1
        ENDDO
      ENDIF
      CALL cidl_strtrim(NAME, I, J, K)
      IF (I .EQ. 0) THEN
        IER = 2
        WRITE(LUOUT, 1) 'Nonblank Variable name must be provided'
        RETURN
      ENDIF

      TMPCHAR= NAME(J:K)//CHAR(0)
      CALL cidl_upcase(TMPCHAR, I)

      CALL IDL_ImportNamedArray(%REF(TMPCHAR), 
     & %VAL(NDIM), DIM, %VAL(IDL_TYP_FLOAT), ARRAY, %VAL(0), %VAL(0))
      IER = 0
      RETURN
      END

*deck send_integer_array
      SUBROUTINE send_integer_array (NAME, ARRAY, NDIM, IDIM, IER)

C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_ImportNamedArray, '_IDL_ImportNamedArray'
CDEC$ ATTRIBUTES C :: IDL_ImportNamedArray

        EXTERNAL IDL_ImportNamedArray !$pragma C(IDL_ImportNamedArray)

C   Flag for initialization
      INTEGER*4 STARTIDL, LUOUT

C   Define Callable IDL common block
      COMMON / CALLABLE_IDL / STARTIDL, LUOUT

C   Define IDL Definitions  for IDL_ImportNamedArray

      INTEGER IDL_MAX_ARRAY_DIM
      INTEGER IDL_TYP_LONG
      PARAMETER (IDL_MAX_ARRAY_DIM = 8)
      PARAMETER (IDL_TYP_LONG = 3)
      INTEGER I, IER, J, K
      INTEGER*4 DIM(IDL_MAX_ARRAY_DIM)
      CHARACTER *136 TMPCHAR
C
C   Passed parameters
      INTEGER NDIM, IDIM(*)
      CHARACTER*(*) NAME
      INTEGER ARRAY(*)

      IF (STARTIDL .NE. 1) THEN
        WRITE(LUOUT,1) 'Use START_CALL_IDL before sending commands'
1       FORMAT(A)
        IER = -1
        RETURN
      ENDIF

      IF (NDIM .GT. IDL_MAX_ARRAY_DIM) THEN
        IER = 1
        RETURN
      ENDIF
      DO I = 1, NDIM
        DIM(I) = IDIM(I)
      ENDDO
      IF (NDIM .LT. IDL_MAX_ARRAY_DIM) THEN
        DO I = NDIM+1, IDL_MAX_ARRAY_DIM
          DIM(I) = 1
        ENDDO
      ENDIF

      CALL cidl_strtrim(NAME, I, J, K)
      
      IF (I .EQ. 0) THEN
        IER = 2
        WRITE(LUOUT, 1) 'Nonblank Variable name must be provided'
        RETURN
      ENDIF
      TMPCHAR= NAME(J:K)//CHAR(0)
      CALL cidl_upcase (TMPCHAR, I)

      CALL IDL_ImportNamedArray(%REF(TMPCHAR),
     & %VAL(NDIM), DIM, %VAL(IDL_TYP_LONG), ARRAY, %VAL(0), %VAL(0))
      IER = 0
      RETURN
      END


*deck get_real_array
      SUBROUTINE get_real_array 
     & (NAME, ARRAY, NDIM, IDIM, NARRAY, NPASS, IER)
C **********************************************************************

C     Return a real array of NDIM dimensions. 
C
C     NAME  Name of variable in IDL
C     ARRAY Fortran array to receive data
C           Data will be packed into ARRAY
C     NDIM  Number of dimensions for "NAME"
C     IDIM  Array of NDIM elements with number of elements per dimension
C           IDIM(8) is always safe.
C     NARRAY Maximum size of ARRAY
C            NOTE: NARRAY can be of size=1
C                  See also GET_REAL_VAR
C     NPASS Maximum size of "NAME"
C     IER   Error Flag
C           -1 Callable IDL not started.
C           -2 Variable is undefined.
C          1 to 9 IDL type mismatch 
C              Error code is IDL type 1, Byte; 2, Int; 3, Long; 4, Float;
C                5, Double; 6, Complex; 7, String; 8, Structure; 9, DComplex
C 
C     
C **********************************************************************
C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_FindNamedVariable, '_IDL_FindNamedVariable'
CDEC$ ATTRIBUTES C :: IDL_FindNamedVariable

      EXTERNAL IDL_FindNamedVariable !$pragma C(IDL_FindNamedVariable)

C   Flag for initialization
      INTEGER*4 STARTIDL, LUOUT

C   Define Callable IDL common block
      COMMON / CALLABLE_IDL / STARTIDL, LUOUT

C   Define IDL Definitions  for IDL_ImportNamedArray

      INTEGER I, J, K
      CHARACTER *136 TMPCHAR

      INTEGER VAR_PTR
      INTEGER IDL_TYP_FLOAT
      PARAMETER (IDL_TYP_FLOAT = 4)
C
C   Passed parameters
      INTEGER NDIM, IDIM(*), NARRAY, NPASS, ITYPE, IER
      CHARACTER*(*) NAME
      REAL ARRAY(*)

      IF (STARTIDL .NE. 1) THEN
        WRITE(LUOUT ,1) 'Use START_CALL_IDL before sending commands'
        IER = -1
        RETURN
      ENDIF
1       FORMAT(A)
2     FORMAT(A, I5, I5)
      
      CALL cidl_strtrim(NAME, I, J, K)
      IF (I .EQ. 0) THEN
        IER = -3
        WRITE(LUOUT, 1) 'Nonblank Variable name must be provided'
        RETURN
      ENDIF
      TMPCHAR = NAME(J:K)//CHAR(0)
C     CALL cidl_upcase(NAME, I)
      VAR_PTR = 
     &   IDL_FindNamedVariable(%REF(TMPCHAR), %VAL(0))

      CALL VAR_PTR_2_VALUE(%VAL(VAR_PTR), ITYPE, 
     &   ARRAY, NDIM, IDIM, NARRAY, NPASS)

      IF (ITYPE .NE. IDL_TYP_FLOAT) THEN 
        WRITE (LUOUT, 2) 
     & '%GET_REAL_ARRAY: Float array not returned', ITYPE
        IF (ITYPE .EQ. 0) THEN
          IER = -2
        ELSE
          IER = ITYPE
        ENDIF
        RETURN
      ENDIF
      IF (NPASS .GT. NARRAY) THEN
        WRITE (LUOUT,2)
     & '%GET_REAL_ARRAY: Complete array not returned:', NPASS, NARRAY
        IER = -4
      ENDIF
      RETURN
      END

*deck get_str_var
      SUBROUTINE get_str_var (NAME, VARIABLE, NPASS, IER)
C **********************************************************************

C     Return a string variable
C
C     NAME     Name of variable in IDL
C     VARIABLE Fortran variable to receive data
C     NPASS    Number of elements returned. Should be 1.
C
C **********************************************************************
C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_FindNamedVariable, '_IDL_FindNamedVariable'
CDEC$ ATTRIBUTES C :: IDL_FindNamedVariable

      EXTERNAL IDL_FindNamedVariable !$pragma C(IDL_FindNamedVariable)

C   Flag for initialization
      INTEGER*4 STARTIDL, LUOUT

C   Define Callable IDL common block
      COMMON / CALLABLE_IDL / STARTIDL, LUOUT

C   Define IDL Definitions  for IDL_ImportNamedArray

      INTEGER I, J, K
      CHARACTER *136 TMPCHAR

      INTEGER VAR_PTR
      INTEGER IDL_TYP_STRING
      PARAMETER (IDL_TYP_STRING = 7)
C
C   Passed parameters
      INTEGER NPASS, ITYPE, IER
      CHARACTER*(*) NAME
      CHARACTER*(*) VARIABLE

      IF (STARTIDL .NE. 1) THEN
        WRITE(LUOUT,1) 'Use START_CALL_IDL before sending commands'
        IER = -1
        RETURN
      ENDIF
1       FORMAT(A)
2     FORMAT(A, I5, I5)
      CALL cidl_strtrim(NAME, I, J, K)
      IF (I .EQ. 0) THEN
        IER = -3
        WRITE(LUOUT, 1) 'Nonblank Variable name must be provided'
        RETURN
      ENDIF

      TMPCHAR = NAME(J:K)//CHAR(0)
C     CALL cidl_upcase(TMPCHAR, I)

      VAR_PTR =
     &   IDL_FindNamedVariable(%REF(TMPCHAR), %VAL(0))

      CALL VAR_PTR_2_IDL_STR(%VAL(VAR_PTR), ITYPE,VARIABLE,NPASS,IER)
c **********************************************************************

      IF (ITYPE .NE. IDL_TYP_STRING) THEN
        WRITE (LUOUT, 2)
     & '%GET_STR_VAR: String variable not returned', ITYPE
        IF (ITYPE .EQ. 0) THEN
          IER = -2
        ELSE
          IER = ITYPE
        ENDIF
        RETURN
      ENDIF

      IF (NPASS .EQ. 0 .AND. IER .NE. 0) RETURN

      I = LEN(VARIABLE)
      IF (NPASS .GT. I) THEN
        WRITE (LUOUT,2)
     & '%GET_STR_VAR: Complete STRING not returned:', NPASS, I
        IER = 100+NPASS
      ENDIF
      RETURN
      END

*deck get_real_var
      SUBROUTINE get_real_var (NAME, VARIABLE, NPASS, IER)
C **********************************************************************

C     Return a real Variable
C
C     NAME     Name of variable in IDL
C     VARIABLE Fortran variable to receive data
C     NPASS    Number of elements returned. Should be 1.
C
C **********************************************************************
C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_FindNamedVariable, '_IDL_FindNamedVariable'
CDEC$ ATTRIBUTES C :: IDL_FindNamedVariable

      EXTERNAL IDL_FindNamedVariable !$pragma C(IDL_FindNamedVariable)

C   Flag for initialization
      INTEGER*4 STARTIDL, LUOUT

C   Define Callable IDL common block
      COMMON / CALLABLE_IDL / STARTIDL, LUOUT

C   Define IDL Definitions  for IDL_ImportNamedArray

      INTEGER I, J, K
      CHARACTER *136 TMPCHAR

      INTEGER VAR_PTR
      INTEGER IDL_TYP_FLOAT
      PARAMETER (IDL_TYP_FLOAT = 4)
C
C   Passed parameters
      INTEGER NDIM, IDIM(8), NARRAY, NPASS, ITYPE, IER
      CHARACTER*(*) NAME
      REAL VARIABLE

      NARRAY = 1
      IF (STARTIDL .NE. 1) THEN
        WRITE(LUOUT,1) 'Use START_CALL_IDL before sending commands'
        RETURN
      ENDIF
1       FORMAT(A)
2     FORMAT(A, I5, I5)
      CALL cidl_strtrim(NAME, I, J, K)
      IF (I .EQ. 0) THEN
        IER = -3
        WRITE(LUOUT, 1) 'Nonblank Variable name must be provided'
        RETURN
      ENDIF

      TMPCHAR = NAME(J:K)//CHAR(0)
C     CALL cidl_upcase(TMPCHAR, I)

      VAR_PTR =
     &   IDL_FindNamedVariable(%REF(TMPCHAR), %VAL(0))

      CALL VAR_PTR_2_VALUE(%VAL(VAR_PTR), ITYPE,
     &   VARIABLE, NDIM, IDIM, NARRAY, NPASS)

      IF (ITYPE .NE. IDL_TYP_FLOAT) THEN
        WRITE (LUOUT, 2)
     & '%GET_REAL_VAR: Float variable not returned', ITYPE
        IF (ITYPE .EQ. 0) THEN
          IER = -2
        ELSE
          IER = ITYPE
        ENDIF
        RETURN
      ENDIF

      IF (NPASS .GT. NARRAY) THEN
        WRITE (LUOUT,2)
     & '%GET_REAL_VAR: Complete array not returned:', NPASS, NARRAY
        IER = -4
      ENDIF

      RETURN
      END

*deck get_integer_var
      SUBROUTINE get_integer_var (NAME, VARIABLE, NPASS, IER)
C **********************************************************************

C     Return a Integer Variable
C
C     NAME     Name of variable in IDL
C     VARIABLE Fortran variable to receive data
C     NPASS    Number of elements returned. Should be 1.
C
C **********************************************************************
C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_FindNamedVariable, '_IDL_FindNamedVariable'
CDEC$ ATTRIBUTES C :: IDL_FindNamedVariable

      EXTERNAL IDL_FindNamedVariable !$pragma C(IDL_FindNamedVariable)

C   Flag for initialization
      INTEGER*4 STARTIDL, LUOUT

C   Define Callable IDL common block
      COMMON / CALLABLE_IDL / STARTIDL, LUOUT

C   Define IDL Definitions  for IDL_ImportNamedArray

      INTEGER I, J, K
      CHARACTER *136 TMPCHAR

      INTEGER VAR_PTR
      INTEGER IDL_TYP_LONG
      PARAMETER (IDL_TYP_LONG = 3)
C
C   Passed parameters
      INTEGER NDIM, IDIM(8), NARRAY, NPASS, ITYPE, IER
      CHARACTER*(*) NAME
      INTEGER VARIABLE

      NARRAY = 1
      IF (STARTIDL .NE. 1) THEN
        WRITE(LUOUT,1) 'Use START_CALL_IDL before sending commands'
        RETURN
      ENDIF
1       FORMAT(A)
2     FORMAT(A, I5, I5)
      CALL cidl_strtrim(NAME, I, J, K)
      IF (I .EQ. 0) THEN
        IER = -3
        WRITE(LUOUT, 1) 'Nonblank Variable name must be provided'
        RETURN
      ENDIF
      TMPCHAR = NAME(J:K)//CHAR(0)
      VAR_PTR =
     &   IDL_FindNamedVariable(%REF(TMPCHAR), %VAL(0))

      CALL VAR_PTR_2_VALUE(%VAL(VAR_PTR), ITYPE,
     &   VARIABLE, NDIM, IDIM, NARRAY, NPASS)

      IF (ITYPE .NE. IDL_TYP_LONG) THEN
        WRITE (LUOUT, 2)
     & '%GET_INTEGER_VAR: Integer variable not returned', ITYPE
        IF (ITYPE .EQ. 0) THEN
          IER = -2
        ELSE
          IER = ITYPE
        ENDIF
        RETURN
      ENDIF

      IF (NPASS .GT. NARRAY) THEN
        WRITE (LUOUT,2)
     & '%GET_INTEGER_VAR: Complete array not returned:', NPASS, NARRAY
        IER = -4
      ENDIF

      RETURN
      END


*deck get_integer_array
      SUBROUTINE get_integer_array 
     &   (NAME, ARRAY, NDIM, IDIM, NARRAY, NPASS, IER)
C **********************************************************************

C     Return a real array of NDIM dimensions.
C
C     NAME  Name of variable in IDL
C     ARRAY Fortran array to receive data
C           Data will be packed into ARRAY
C     NDIM  Number of dimensions for "NAME"
C     IDIM  Array of NDIM elements with number of elements per dimension
C           IDIM(8) is always save.
C     NARRAY Maximum size of ARRAY
C            NOTE: NARRAY can be of size=1
C                  See also GET_INTEGER_VAR
C     NPASS Maximum size of "NAME"
C
C **********************************************************************
C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_FindNamedVariable, '_IDL_FindNamedVariable'
CDEC$ ATTRIBUTES C :: IDL_FindNamedVariable

      EXTERNAL IDL_FindNamedVariable !$pragma C(IDL_FindNamedVariable)

C   Flag for initialization
      INTEGER*4 STARTIDL, LUOUT

C   Define Callable IDL common block
      COMMON / CALLABLE_IDL / STARTIDL, LUOUT

C   Define IDL Definitions  for IDL_ImportNamedArray

      INTEGER I, J, K
      CHARACTER *136 TMPCHAR

      INTEGER VAR_PTR
      INTEGER IDL_TYP_LONG
      PARAMETER (IDL_TYP_LONG = 3)
C
C   Passed parameters
      INTEGER NDIM, IDIM(*), NARRAY, NPASS, ITYPE
      CHARACTER*(*) NAME
      INTEGER ARRAY(*)

      IF (STARTIDL .NE. 1) THEN
        WRITE(LUOUT,1) 'Use START_CALL_IDL before sending commands'
        RETURN
      ENDIF
1       FORMAT(A)
2     FORMAT(A, I5, I5)

      CALL cidl_strtrim(NAME, I, J, K)
      IF (I .EQ. 0) THEN
        IER = -3
        WRITE(LUOUT, 1) 'Nonblank Variable name must be provided'
        RETURN
      ENDIF
      TMPCHAR = NAME(J:K)//CHAR(0)

      VAR_PTR =
     &   IDL_FindNamedVariable(%REF(TMPCHAR), %VAL(0))

      CALL VAR_PTR_2_VALUE(%VAL(VAR_PTR), ITYPE,
     &   ARRAY, NDIM, IDIM, NARRAY, NPASS)

      IF (ITYPE .NE. IDL_TYP_LONG) THEN
        WRITE (LUOUT, 2)
     & '%GET_INTEGER_ARRAY: Integer array not returned', ITYPE
        IF (ITYPE .EQ. 0) THEN
          IER = -2
        ELSE
          IER = ITYPE
        ENDIF
        RETURN
      ENDIF

      IF (NPASS .GT. NARRAY) THEN
        WRITE (LUOUT,2)
     & '%GET_INTEGER_ARRAY: Complete array not returned:', NPASS, NARRAY
        IER = -4
      ENDIF

      RETURN
      END

*deck var_ptr_2_idl_str
      SUBROUTINE VAR_PTR_2_IDL_STR(VPTR, ITYPE, VAR, NPASS, IER)
C
C       Declare a Fortran Record type that has a compatible form with
C       the IDL C struct IDL_VARIABLE for a floating point value.
C       Note this structure contains a union which is the size of
C       the largest data type.  This structure has been padded to
C       support the union.   Fortran records are not part of
C       F77, but most compilers have this option.

      STRUCTURE /IDL_VARIABLE/
          CHARACTER*1 TYPE
          CHARACTER*1 FLAGS
          INTEGER*4 PAD        !Pad for largest data type
          INTEGER*4 VALUE
      END STRUCTURE

      RECORD /IDL_VARIABLE/ VPTR

      CHARACTER *(*) VAR
      INTEGER ITYPE, NPASS, IER
      INTEGER FLAG

      VAR = ' '
      ITYPE = ICHAR(VPTR.TYPE)
      IF (ITYPE .NE. 7) THEN
        NPASS = 0
        RETURN
      ENDIF

      FLAG = IAND(ICHAR(VPTR.FLAGS), 4)
      IF (FLAG .EQ. 4) THEN
C       ARRAY
        NPASS = 0
        IER = -4
        RETURN
      ELSE
        IER = 0
        CALL IDL_STRING_2_STR(VPTR.VALUE, VAR, NPASS)
      ENDIF
      RETURN
      END

*deck idl_string_2_str
      SUBROUTINE IDL_STRING_2_STR(STR_STR, VAR, NPASS)
cWINDOWS
c     EXTERNAL strncpy !$pragma C(strncpy)
      INTEGER NPASS, L
      CHARACTER *(*) VAR
      STRUCTURE /IDL_STRING/
         INTEGER*4 SLENGTH
         INTEGER*2 FLAG
         INTEGER*4 VALUE
      END STRUCTURE
      RECORD /IDL_STRING/ STR_STR
      NPASS = STR_STR.SLENGTH
      L = MIN(LEN(VAR), NPASS)
      VAR=' '
c     IF(L .GT. 0) CALL strncpy(%REF(VAR),%VAL(STR_STR.VALUE),%VAL(L))
cWINDOWS
      IF(L .GT. 0) CALL XSTRNCPY(VAR,%VAL(STR_STR.VALUE),%VAL(L))
      RETURN
      END
      subroutine XSTRNCPY(VAR,STR)
      CHARACTER *(*) VAR, STR
      INTEGER LV, LS, I, J
      INTEGER ICHAR, LEN
C     Depending on how the computer passes strings these lengths could
C       be switched. Use the MINIMUM only.
      LV = LEN(VAR)
      LS = LEN(STR)
      PRINT *, LV, LS
      M= MIN (LV, LS)
      DO  I = 1, M
        J = ICHAR(STR(I:I))
        IF (J .EQ. 0) GOTO 2
        VAR(I:I) = CHAR(J)
      ENDDO
2     CONTINUE
      RETURN
      END
*deck var_ptr_2_value
      SUBROUTINE VAR_PTR_2_VALUE(VPTR, ITYPE, 
     &   ARRAY, NDIM, IDIM, NARRAY, NPASS)
C
C       Declare a Fortran Record type that has a compatible form with
C       the IDL C struct IDL_VARIABLE for a floating point value.
C       Note this structure contains a union which is the size of
C       the largest data type.  This structure has been padded to
C       support the union.   Fortran records are not part of
C       F77, but most compilers have this option.

      STRUCTURE /IDL_VARIABLE/
          CHARACTER*1 TYPE
          CHARACTER*1 FLAGS
          INTEGER*4 PAD        !Pad for largest data type
          INTEGER*4 VALUE
      END STRUCTURE

      RECORD /IDL_VARIABLE/ VPTR

      INTEGER ARRAY(*)
      INTEGER ITYPE, NDIM, IDIM(*), NARRAY, NPASS
      INTEGER FLAG

      ITYPE = ICHAR(VPTR.TYPE)
      IF (ITYPE .NE. 3  .AND. ITYPE .NE. 4 .and. 
     &   ITYPE .NE. 1) THEN
        NPASS = 0
        RETURN
      ENDIF
      
      FLAG = IAND(ICHAR(VPTR.FLAGS), 4)
      IF (FLAG .EQ. 4) THEN 
C       ARRAY
        CALL VAR_PTR_2_ARRAY(%VAL(VPTR.VALUE), 
     &    ARRAY, NDIM, IDIM, NARRAY, NPASS)
      ELSE 
        NPASS = 1
        NDIM = 1
        IDIM(1) = 1
        IF (NARRAY .LT. 1) NARRAY = 1
        ARRAY(1)=VPTR.VALUE
      ENDIF
      RETURN
      END

*deck var_ptr_2_array
      SUBROUTINE VAR_PTR_2_ARRAY(VALUE, 
     &    ARRAY, NDIM, IDIM, NARRAY, NPASS)
C
C     Convert an IDL_ARRAY to Fortran variables
C
      INTEGER VALUE(*), ARRAY(*), NDIM, IDIM(*), NARRAY, NPASS
      INTEGER IVAL, I
      
      NPASS = VALUE(3)
      IVAL = MIN(NPASS, NARRAY)
      NDIM = ISHFT(VALUE(5), -24)
      DO I = 1, NDIM
        IDIM(I) = VALUE(5+I)
      ENDDO
      CALL MOVE_VAR_PTR_2_ARRAY(%VAL(VALUE(4)), ARRAY, IVAL)
      RETURN
      END

*deck move_var_ptr_2_array
      SUBROUTINE MOVE_VAR_PTR_2_ARRAY(IA, IB, NP)
      INTEGER IA(*), IB(*), NP, I
      DO I = 1, NP
        IB(I)= IA(I)
      ENDDO
      RETURN
      END

*deck idl_write
      subroutine idl_write(INPUT, FLAG)
c
c     This routine writes a string to an IDL display 
c
c     If flag is zero, no leading characters will be printed.
c       If flag is not zero, then the value of the IDL system variable
c          !MSG_PREFIX will be printed. (Default value = '% ')
c
      CHARACTER *(*) INPUT
      CHARACTER *1 CHAR
      INTEGER FLAG
      INTEGER I, LEN, DONE
      INTEGER MAXLEN
      PARAMETER (MAXLEN=1024)
      CHARACTER*(MAXLEN) TEMP
C   Some Fortran compilers require external definitions for IDL routines
CDEC$ ALIAS IDL_Message, '_IDL_Message'
CDEC$ ATTRIBUTES C :: IDL_Message

      EXTERNAL IDL_Message !$pragma C(IDL_Message)
C     check the length and set the last character to a char(0)
      I = LEN(INPUT)
      DONE = 0
      DO WHILE (I .GT. 0 .AND. DONE .EQ. 0)
        IF (ICHAR(INPUT(I:I)) .GE. 33 .AND.
     &    ICHAR(INPUT(I:I)) .LE. 126) THEN
          DONE = 1
        ELSE 
          I = I-1
        ENDIF
      ENDDO

      IF (I .GT. 0) THEN
        IF (I .GE. MAXLEN) I = MAXLEN-1
        TEMP = INPUT(1:I)//CHAR(0)
      ELSE
        TEMP = ' '//CHAR(0)
      ENDIF
      IF (FLAG .EQ. 0) THEN
        CALL IDL_Message(%VAL(-1), %VAL(262144), %REF(TEMP))
      ELSE
        CALL IDL_Message(%VAL(-1), %VAL(0), %REF(TEMP))
      ENDIF
c **********************************************************************
      RETURN
      END

*deck cidl_strtrim
      SUBROUTINE cidl_strtrim(INPUT, LENGTH, J, I)
      CHARACTER INPUT*(*)
      INTEGER LEN, I, J, K, LENGTH, ICHAR
C
C     FIND THE MINIMUM LENGTH
C
      K = LEN(INPUT)
C
C     FIND THE FIRST NONBLANK CHARACTER
C
      DO I = K, 1, -1
        IF(ICHAR(INPUT(I:I)) .GE. 33 .AND. 
     &    ICHAR(INPUT(I:I)) .LE. 126) GOTO 2
      ENDDO
      LENGTH = 0
      RETURN
C
C     CHECK FOR INITIAL BLANK CHARACTERS
C
2     J = 1
      IF (I .GT. 1) THEN
        DO J = 1, I-1
          IF(ICHAR(INPUT(J:J)) .GE. 33 .AND. 
     &      ICHAR(INPUT(J:J)) .LE. 126)  GOTO 22
        ENDDO
        J=I
      ENDIF
C
C     RETURN THE LENGTH AND THE VALUES
C
22    LENGTH = I+1-J
C     INPUT = INPUT(J:I)
       
      RETURN
      END

*deck cidl_upcase
      subroutine cidl_upcase(WORD, LENGTH)
c
c converts word to upper case
c
      CHARACTER*(*) WORD
      CHARACTER*1 CTMP
      INTEGER LENGTH, I
c
      LENGTH = MIN(LEN(WORD), LENGTH)
c
      DO 1 I=1,LENGTH
c
c make sure character is alphabetic
c
        if( ICHAR(WORD(I:I)) .GE. 97  .AND.
     &      ICHAR(WORD(I:I)) .LE. 122      )THEN
          CTMP = CHAR(ICHAR(WORD(I:I))-32)
          WORD(I:I) = CTMP
        ENDIF
    1 CONTINUE
c
      RETURN
      END
