PRO exray_batchcalc,batchstr

;whoops=dialog_message('Batch processing not yet implemented',/Error)

;save the active data set to be restored at the end
active=batchstr.exraystr.activedata
xfr,batchstr.exraystr.datawdf(active),get_maxwdf()
xfr,batchstr.exraystr.scaledwdf(active),get_maxwdf()-1

;open the batch file
openr,u,batchstr.batchfile,/get

line=''
while (not eof(u)) do begin
  ;read the next file in the list and add on the pathname
  readf,u,line
  file=batchstr.path+line

  ;read in the data from this file and store it in the active wdf array
  rufo,xdat,ydat,file=file
  i2w,xdat,ydat,60,/xy
  index=where(get_wdf() eq 60)
  delwdf,60
  if (index(0) lt 0) then begin
     err=dialog_message(['There was an error opening the data file:',$
              file,'Please verify that the file contains data in format.'],/error)
     goto, exitjump
  endif
  if (batchstr.waveflag eq 1) then $
     i2w,xdat,ydat,batchstr.exraystr.datawdf(active),/xy $
  else $
     i2w,xdat,ydat,batchstr.exraystr.scaledwdf(active),/xy

  ;set the filename in the main widget
  widget_control,batchstr.exraystr.widget.DataFile,SET_VALUE=line

  ;******************************************
  ;apply the wavelength scale (if desired)
  ;******************************************
  if (batchstr.waveflag eq 1) then begin
     if (batchstr.exraystr.convexflag eq 0) then $
        exray_autoscale,batchstr.exraystr,/noplot $
     else $
        exray_convex_autoscale,batchstr.exraystr,/noplot

     ;plot the scaled data
        w2i,x,y,batchstr.exraystr.scaledwdf(active)
        plo,batchstr.exraystr.scaledwdf(active),col=0,line=0,xrange=[min(x),max(x)],yrange=[min(y),max(y)] $
          ,leg=-1,xtitle='Wavelength (Angstroms)',pos=[0.15,0.1,0.95,0.957],xstyle=1,ystyle=1 $
          ,psym=0

       ;if the user has requested known transitions, then overplot those selected
       index=where(batchstr.exraystr.whichelements gt 0)
       if (index(0) ge 0) then $
          exray_plotrans,batchstr.exraystr
       oplot,[batchstr.exraystr.lamref,batchstr.exraystr.lamref],[min(y),max(y)],line=1,col=3
       legendp,['Reference Wavelength = '+string(batchstr.exraystr.lamref,format='(F6.3)')+' Angstroms'],$
          col=3,line=1,psym=0,pos=[0.15,0.98],/normal

     ;save the scaled data
       split=strsplit(line,'.',/extract)
       root=split(0)
       w2i,xdat,ydat,batchstr.exraystr.scaledwdf(active)
       wufo,xdat,ydat,file=batchstr.path+root+'_wave.ufo'
  endif

  wait,1.0

  ;******************************************
  ;apply the density to intensity conversion
  ;******************************************
  if (batchstr.d2iflag eq 1) then begin
     exray_d2i,batchstr.MainWidget,/nosave,/nocheck
     xfr,60,batchstr.exraystr.scaledwdf(active)

     ;plot the scaled data
;        w2i,x,y,batchstr.exraystr.scaledwdf(active)
;        plo,batchstr.exraystr.scaledwdf(active),col=0,line=0,xrange=[min(x),max(x)],yrange=[min(y),max(y)] $
;          ,leg=-1,xtitle='Wavelength (Angstroms)',pos=[0.15,0.1,0.95,0.957],xstyle=1,ystyle=1 $
;          ,psym=0

     ;save the scaled data
       split=strsplit(line,'.',/extract)
       root=split(0)
       w2i,xdat,ydat,batchstr.exraystr.scaledwdf(active)
       wufo,xdat,ydat,file=batchstr.path+root+'_i.ufo'
  endif

  wait,1.0

  ;******************************************
  ;apply the efficiency corrrection (if desired)
  ;******************************************
  if (batchstr.effcorflag eq 1) then begin
      xfr,batchstr.exraystr.scaledwdf(active),60
      exray_eff,batchstr.MainWidget,save=0,/nocheck,/noplot,/noextract
      xfr,60,batchstr.exraystr.scaledwdf(active)

     ;plot the scaled data
        w2i,x,y,batchstr.exraystr.scaledwdf(active)
        plo,batchstr.exraystr.scaledwdf(active),col=0,line=0,xrange=[min(x),max(x)],yrange=[min(y),max(y)] $
          ,leg=-1,xtitle='Wavelength (Angstroms)',pos=[0.15,0.1,0.95,0.957],xstyle=1,ystyle=1 $
          ,psym=0

       ;if the user has requested known transitions, then overplot those selected
       index=where(batchstr.exraystr.whichelements gt 0)
       if (index(0) ge 0) then $
          exray_plotrans,batchstr.exraystr
       oplot,[batchstr.exraystr.lamref,batchstr.exraystr.lamref],[min(y),max(y)],line=1,col=3
       legendp,['Reference Wavelength = '+string(batchstr.exraystr.lamref,format='(F6.3)')+' Angstroms'],$
          col=3,line=1,psym=0,pos=[0.15,0.98],/normal

       ;save the scaled data
       split=strsplit(line,'_',/extract)
       split2=strsplit(split(0),'.',/extract)
       root=split2(0)
       w2i,xdat,ydat,batchstr.exraystr.scaledwdf(active)
       wufo,xdat,ydat,file=batchstr.path+root+'_eff_cor.ufo'
endif

  wait,1.0

endwhile

exitjump:
close,u
free_lun,u

;restore the data array
xfr,get_maxwdf(),batchstr.exraystr.datawdf(active)
xfr,get_maxwdf()-1,batchstr.exraystr.scaledwdf(active)
widget_control,batchstr.exraystr.widget.DataFile,SET_VALUE=batchstr.exraystr.datafile(active)
widget_control,batchstr.exraystr.widget.plotlist,send_event=$
          { WIDGET_DROPLIST, ID:batchstr.exraystr.widget.plotlist, TOP:batchstr.MainWidget, $
            HANDLER:batchstr.MainWidget, INDEX:3 }
return
end
