

pro Exray_D2IWidget_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = d2istr

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='Film_DROPLIST'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_DROPLIST' )then begin
         if (Event.index gt 5) then begin
            widget_control,d2istr.tension,sensitive=0
            widget_control,d2istr.interpolbase,sensitive=0
         endif else begin
            widget_control,d2istr.tension,sensitive=1
            widget_control,d2istr.interpolbase,sensitive=1
         endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='FogFile_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           d2istr.fogflag = 0
           widget_control,d2istr.fog,sensitive=1
           widget_control,d2istr.openfog,sensitive = 0
           widget_control,d2istr.fogfilename,sensitive=0
        endif else begin
           d2istr.fogflag = 1
           widget_control,d2istr.fog,sensitive=0
           widget_control,d2istr.openfog,sensitive = 1
           widget_control,d2istr.fogfilename,sensitive=1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Open_FogFile_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
         fogfile=d2istr.fogfile
         exray_opendata,d2istr.exraystr,wdf=d2istr.fogwdf,file=fogfile
         d2istr.fogfile=fogfile
         widget_control,d2istr.fogfilename,set_value=d2istr.fogfile
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Spline_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           d2istr.interpolflag = 0
        endif else begin
           d2istr.interpolflag = 1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Linear_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           d2istr.interpolflag = 1
        endif else begin
           d2istr.interpolflag = 0
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Angle_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           d2istr.angleflag = 0
        endif else begin
           d2istr.angleflag = 1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='NoAngle_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           d2istr.angleflag = 1
        endif else begin
           d2istr.angleflag = 0
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Go_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
       ;save the values in 'global' variables and calculate the result
       filmtype=widget_info(d2istr.film,/Droplist_Select)
       d2istr.exraystr.wfilm.filmtype=filmtype
       fog=0.0
       widget_control,d2istr.fog,get_value=fog
       d2istr.exraystr.wfilm.fog=fog
       fogfile=''
       widget_control,d2istr.fogfilename,get_value=fogfile
       d2istr.exraystr.wfilm.fogfile=fogfile
       if (d2istr.fogflag eq 1) and (d2istr.fogfile eq 'none') then begin
          whoops=dialog_message('You need to specify a filename containing the fog data',/Error)
          return
       endif
       tension=1.0
       widget_control,d2istr.tension,get_value=tension
       d2istr.exraystr.wfilm.tension=tension
       d2istr.exraystr.wfilm.fogflag=d2istr.fogflag
       d2istr.exraystr.wfilm.interpolflag=d2istr.interpolflag
       d2istr.exraystr.wfilm.d2iangflag=d2istr.angleflag
       widget_control,d2istr.MainWidget,set_uvalue=d2istr.exraystr
       widget_control, Event.top, /DESTROY
       if (filmtype gt 5) then $
          exray_ip,d2istr.MainWidget,angcor=d2istr.angleflag $
       else $
          exray_d2i,d2istr.MainWidget,angcor=d2istr.angleflag
       return
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;quit without saving anything
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = d2istr


end

pro Exray_D2IWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control, MainWidget, get_uvalue = exraystr
  mxy=exraystr.mxy

  Exray_D2IWidget_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_D2IWidget_BASE', Column = 1, $
      TITLE='Density -> Intensity Options' ,SPACE=3 ,XPAD=3 ,YPAD=3)

  Film_DROPLIST = Widget_Droplist(Exray_D2IWidget_BASE,  $
      UNAME='Film_DROPLIST' ,SENSITIVE=1,TITLE='Film Type' , $
      VALUE=['101-07','DEF','SB-5','RAR 2492','RAR 2495','RAR 2497','TR Image Plate'])


  Fog_BASE = Widget_Base(Exray_D2IWidget_BASE, UNAME='Fog_BASE', $
      COLUMN=1)

  Fog_Field = CW_Field(Fog_BASE,UNAME='Fog_FIELD' $
                        ,Title='Film Fog',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.wfilm.fog)

  FogFile_BASE = Widget_Base(Fog_BASE, UNAME='FogFile_BASE', $
      COLUMN=1 ,/NonEXCLUSIVE)

  FogFile_Button = Widget_Button(FogFile_BASE, UNAME='FogFile_Button'  $
      ,/ALIGN_Right,SENSITIVE=1 ,VALUE='Read Fog From File')

  FogFilename_BASE = Widget_Base(Fog_BASE, UNAME='Fog_BASE', $
      COLUMN=3)

  dummy=widget_label(FogFilename_BASE,Value='   ')

  FogFilename_Field = CW_Field(FogFilename_BASE,UNAME='FogFilename_FIELD' $
                        ,Title='Fog File:',/Return_Events,/string,xsize=20 $
                        ,Value=exraystr.wfilm.fogfile)

  Open_FogFile_BUTTON = Widget_Button(FogFilename_BASE,  $
      UNAME='Open_FogFile_BUTTON',SCR_XSIZE=30*mxy,SCR_YSIZE=30*mxy  $
      ,/ALIGN_Left ,VALUE=exraystr.images.open,/BITMAP)

  Tension_Field = CW_Field(Exray_D2IWidget_BASE,UNAME='Tension_FIELD' $
                        ,Title='Tension Value',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.wfilm.tension)

  InterpolButton_BASE = Widget_Base(Exray_D2IWidget_BASE, UNAME='InterpolButton_BASE', $
      COLUMN=1 ,/EXCLUSIVE,Frame=1)

  Spline_Button = Widget_Button(InterpolButton_BASE, UNAME='Spline_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Linear Interpolation Across Edges')

  Linear_Button = Widget_Button(InterpolButton_BASE, UNAME='Linear_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Cubic Spline Across Edges')

  AngleButton_BASE = Widget_Base(Exray_D2IWidget_BASE, UNAME='AngleButton_BASE', $
      COLUMN=1 ,/Exclusive,Frame=1)

  NoAngle_Button = Widget_Button(AngleButton_BASE, UNAME='NoAngle_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Angle of Incidence = 90 deg.')

  Angle_Button = Widget_Button(AngleButton_BASE, UNAME='Angle_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Calculate Angle of Incidence')

  Quit_BASE = Widget_Base(Exray_D2IWidget_BASE, UNAME='Quit_BASE' $
      ,COLUMN=2,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Cancel')


  Go_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Go_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Calculate')


;************************************************************************************
;Define the structure to be passed around
;************************************************************************************

  d2istr = {NAME: 'Options_Structure',$
              film:Film_DROPLIST,$
              tension:Tension_FIELD,$
              fogbase:Fog_BASE,$
              fog:Fog_FIELD,$
              openfog:Open_FogFile_BUTTON,$
              fogfile:exraystr.wfilm.fogfile,$
              fogfilename:FogFilename_FIELD,$
              filmtype:long(0),$
              fogflag:exraystr.wfilm.fogflag,$
              fogwdf:exraystr.wfilm.fogwdf,$
              interpolbase:InterpolButton_BASE,$
              interpolflag:long(0),$
              angleflag:long(0),$
              exraystr:exraystr,$
              MainWidget:MainWidget}

  d2istr.filmtype=exraystr.wfilm.filmtype
  widget_control,Film_DROPLIST, set_droplist_select=d2istr.filmtype

  if (exraystr.wfilm.d2iangflag eq 0) then begin
     widget_control,NoAngle_Button,set_button = 1
     widget_control,Angle_Button,set_button = 0
     d2istr.angleflag=0
  endif else begin
     widget_control,NoAngle_Button,set_button = 0
     widget_control,Angle_Button,set_button = 1
     d2istr.angleflag=1
  endelse
  if (exraystr.wfilm.interpolflag eq 0) then begin
     widget_control,Linear_Button,set_button = 1
  endif else begin
     widget_control,Spline_Button,set_button = 1
     d2istr.interpolflag = 1
  endelse
  if (exraystr.wfilm.fogflag eq 1) then begin
     widget_control,Fog_Field,sensitive=0
     widget_control,FogFile_Button,set_button = 1
  endif else begin
     widget_control,Open_FogFile_Button,sensitive = 0
     widget_control,FogFilename_Field,sensitive=0
  endelse
  if (exraystr.convexflag ne 0 or $ ;exraystr.wfilm.JFlag ne 0 or $
      exraystr.plotOK ne 1) then begin
     widget_control,NoAngle_Button,set_button = 1
     widget_control,Angle_Button,set_button = 0
     widget_control,Angle_Button,sensitive = 0
     d2istr.angleflag=0
  endif
  if (d2istr.filmtype gt 5) then begin
     widget_control,d2istr.tension,sensitive=0
     widget_control,d2istr.interpolbase,sensitive=0
  endif


 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  Widget_Control, /REALIZE, Exray_D2IWidget_BASE

  Widget_Control, Exray_D2IWidget_BASE, set_uvalue = d2istr


  XManager, 'Exray_D2IWidget_BASE', Exray_D2IWidget_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro Exray_D2IWidget, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_D2IWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end