

pro Exray_Group1Widget_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = groupstr

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='Lambda1_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           groupstr.lamset=0
        endif else begin
           Widget_Control,groupstr.bet1,SET_BUTTON = 0
           groupstr.lamset=1
           if (groupstr.exraystr.serset(0) eq 0) then begin
              Widget_Control,groupstr.val1,Column_Labels=['Wavelength']
           endif
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Beta1_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           groupstr.lamset=1
        endif else begin
           Widget_Control,groupstr.lam1,SET_BUTTON = 0
           groupstr.lamset=0
           if (groupstr.exraystr.serset(0) eq 0) then begin
              Widget_Control,groupstr.val1,Column_Labels=['Beta']
           endif
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Quit_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
         whoops = ''

         ;if series information, get the values (lambda or beta)
         if (groupstr.exraystr.serset(0) eq 1) then begin
           tmp1=double(0.)
           tmp2=double(0.)
           tmp3=double(0.)
           tmp=dblarr(3)
           widget_control,groupstr.init1,get_value=tmp1
           widget_control,groupstr.final1,get_value=tmp2
           widget_control,groupstr.inter1,get_value=tmp3
           tmp(0)=tmp1
           tmp(1)=tmp2
           tmp(2)=tmp3
           if ((tmp3 gt abs(tmp2-tmp1)) or (tmp2 lt tmp1)) then begin
              whoops=dialog_message('Not a valid series definition.',/Error)
              return
           endif
           for i=0,2 do $
              if (tmp(i) gt 0) then begin
                 if (groupstr.lamset eq 1) then begin
                    groupstr.exraystr.lamset(0)=1
                    groupstr.exraystr.wxstal(*).beta(0,*)=0.
                    groupstr.exraystr.wsource(*).lambda(0,i)=tmp(i)
                 endif else begin
                    groupstr.exraystr.lamset(0)=0
                    groupstr.exraystr.wsource(*).lambda(0,*)=0.
                    groupstr.exraystr.wxstal(*).beta(0,i)=tmp(i)*!pi/180.
                 endelse
              endif else $
                whoops=dialog_message('Each field must be greater than 0!',/Error)
         endif else begin
         ;now if specific information, get the values
            tmp=dblarr(groupstr.exraystr.wnumlambda)
            widget_control,groupstr.val1,GET_VALUE=tmp
            groupstr.tmp(*)=tmp(*)
            index=where(groupstr.tmp lt 0.)
            if (groupstr.tmp(0) le 0.) then $
              whoops=dialog_message('At least the first field must be greater than 0!',/Error) $
            else if (index(0) ne -1) then $
              whoops=dialog_message('All values must be greater than 0!',/Error) $
            else begin
              if groupstr.lamset eq 0 then begin
                 groupstr.exraystr.lamset(0)=0
                 groupstr.exraystr.wsource(*).lambda(0,*)=0.
                 groupstr.exraystr.wxstal(*).beta(0,*)=groupstr.tmp(*)*!pi/180.
              endif else begin
                 groupstr.exraystr.lamset(0)=1
                 groupstr.exraystr.wxstal(*).beta(0,*)=0.
                 groupstr.exraystr.wsource(*).lambda(0,*)=groupstr.tmp(*)
              endelse
            endelse
          endelse

        ;now get the order information
         tmp=long(0)
         widget_control,groupstr.order1,get_value=tmp
         if (tmp gt 0) then $
            groupstr.exraystr.wsource(*).n(0)=tmp $
         else $
             whoops=dialog_message('Order number must be greater than 0!',/Error)
        if (whoops ne 'OK') then begin
          ;go ahead and save the stuff, set the main widget button, and quit this widget
           groupstr.exraystr.groupOK = 1
           if (groupstr.lamset eq 1) then begin
              widget_control, groupstr.exraystr.widget.Lambda1,SET_BUTTON = 1
              widget_control, groupstr.exraystr.widget.Beta1,SET_BUTTON = 0
           endif else begin
              widget_control, groupstr.exraystr.widget.Lambda1,SET_BUTTON = 0
              widget_control, groupstr.exraystr.widget.Beta1,SET_BUTTON = 1
           endelse
           widget_control, groupstr.exraystr.widget.Order1,$
               SET_VALUE = groupstr.exraystr.wsource(*).n(0)
           Widget_Control, groupstr.MainWidget, set_uvalue = groupstr.exraystr
           widget_control, Event.top, /DESTROY
           return
        endif
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;quit without saving anything
        widget_control, groupstr.exraystr.widget.Series1,SET_BUTTON = 0
        widget_control, groupstr.exraystr.widget.Specific1,SET_BUTTON = 0
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = groupstr


end

pro Exray_Group1Widget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control, MainWidget, get_uvalue = exraystr
  mxy=exraystr.mxy

  numlambda=exraystr.wnumlambda
  spcarray=strarr(numlambda) ;an array for the row headers if specific is set
  for i=0,numlambda-1 do spcarray(i)=strtrim(string(i+1),1)

  Exray_Group1Widget_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_Group1Widget_BASE' ,XOFFSET=5 ,YOFFSET=5 $
      ,TITLE='Wavelength/Beta Groups' ,SPACE=3 ,XPAD=3 ,YPAD=3 $
      ,COLUMN = 1)


;***********************************************************************************
;GROUP 1

  Group1_LABEL = Widget_Label(Exray_Group1Widget_BASE,  $
      UNAME='Group1_LABEL' ,XOFFSET=10 ,YOFFSET=10 ,/ALIGN_LEFT  $
      ,VALUE='GROUP 1')


  Order1_Field = CW_Field(Exray_Group1Widget_BASE,UNAME='Order1_FIELD' $
                        ,Title='Order #',/Return_Events,/long,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wsource(0).n(0)])

  Group1_BASE = Widget_Base(Exray_Group1Widget_BASE, UNAME='Group1_BASE'  $
      ,XOFFSET=10 ,YOFFSET=56 ,COLUMN=1 ,/NONEXCLUSIVE $
      ,/FRAME)


  Lambda1_Button = Widget_Button(Group1_BASE, UNAME='Lambda1_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Wavelengths')


  Beta1_Button = Widget_Button(Group1_BASE, UNAME='Beta1_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Betas')

  Value1_BASE = Widget_Base(Exray_Group1Widget_BASE, UNAME='Value1_BASE'  $
      ,COLUMN=1,/FRAME,/BASE_ALIGN_RIGHT)

if (exraystr.serset(0) eq 0) then begin

     Value1_TABLE = Widget_TABLE(Value1_BASE,UNAME='Value1_TABLE' $
                        ,xsize=1,ysize=exraystr.wnumlambda ,y_scroll_size=10 $
                        ,x_scroll_size=1 $
                        ,Value=[exraystr.wsource(0).lambda(0,*)],FORMAT='(F7.3)' $
                        ,/Editable,ROW_LABELS=spcarray)

     groupstr = {NAME: 'Group_Structure',$
              Order1:Order1_FIELD,$
              Val1:Value1_TABLE,$
              Lam1:Lambda1_BUTTON,$
              Bet1:Beta1_BUTTON,$
              Ord:long(0),$ ;temporary holder of order information
              Tmp:dblarr(numlambda),$ ;temporary holder of inserted information
              LamSet:long(0),$ ;flag to say if lambda or beta info inserted
              exraystr:exraystr,$
              MainWidget:MainWidget}

      if exraystr.lamset(0) eq 0 then begin
         Widget_Control,Value1_TABLE,Column_Labels=['Beta']
         Widget_Control,Value1_TABLE,SET_VALUE=exraystr.wxstal(0).beta(0,*)*180./!pi
      endif else begin
         Widget_Control,Value1_TABLE,Column_Labels=['Wavelength']
      endelse

endif else begin

     Init1_Field = CW_Field(Value1_BASE,UNAME='Init1_FIELD' $
                        ,Title='Initial Value = ',/All_Events $
                        ,/float,xsize=12,ysize=1 $
                        ,Value=[exraystr.wsource(0).lambda(0,0)])
     Final1_Field = CW_Field(Value1_BASE,UNAME='Final1_FIELD' $
                        ,Title='Final Value = ',/All_Events $
                        ,/float,xsize=12,ysize=1 $
                        ,Value=[exraystr.wsource(0).lambda(0,1)])
     Inter1_Field = CW_Field(Value1_BASE,UNAME='Inter1_FIELD' $
                        ,Title='Interval = ',/All_Events $
                        ,/float,xsize=12,ysize=1 $
                        ,Value=[exraystr.wsource(0).lambda(0,2)])

     groupstr = {NAME: 'Group_Structure',$
              Lam1:Lambda1_BUTTON,$
              Bet1:Beta1_BUTTON,$
              Order1:Order1_FIELD,$
              Init1:Init1_FIELD,$
              Final1:Final1_FIELD,$
              Inter1:Inter1_FIELD,$
              Ord:long(0),$ ;temporary holder of order information
              Tmp:dblarr(numlambda),$ ;temporary holder of inserted information
              LamSet:long(0),$ ;flag to say if lambda or beta info inserted
              exraystr:exraystr,$
              MainWidget:MainWidget}

      if exraystr.lamset(0) eq 0 then begin
         Widget_Control,Init1_FIELD,SET_VALUE=exraystr.wxstal(0).beta(0,0)*180./!pi
         Widget_Control,Final1_FIELD,SET_VALUE=exraystr.wxstal(0).beta(0,1)*180./!pi
         Widget_Control,Inter1_FIELD,SET_VALUE=exraystr.wxstal(0).beta(0,2)*180./!pi
      endif
endelse

  Quit_BASE = Widget_Base(Exray_Group1Widget_BASE, UNAME='Quit_BASE' $
      ,COLUMN=2,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Cancel')


  Quit_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Quit_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Done')


;***********************************************************************************
;Set the appropriate buttons and values
;***********************************************************************************

  if exraystr.lamset(0) eq 0 then begin
     Widget_Control,Beta1_BUTTON,SET_BUTTON=1
  endif else begin
     Widget_Control,Lambda1_BUTTON,SET_BUTTON=1
  endelse

;************************************************************************************
;Define the structure to be passed around
;************************************************************************************

  numorders=exraystr.wnumorders


   groupstr.LamSet=exraystr.lamset(0)

 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  Widget_Control, /REALIZE, Exray_Group1Widget_BASE

  Widget_Control, Exray_Group1Widget_BASE, set_uvalue = groupstr


  XManager, 'Exray_Group1Widget_BASE', Exray_Group1Widget_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro exray_group1widget, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_Group1Widget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end