

pro Exray_horderWidget_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = hostr

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='HFile_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           hostr.hoflag = 0
           widget_control,hostr.input,sensitive=1
           widget_control,hostr.openfile,sensitive = 0
           widget_control,hostr.hfilename,sensitive=0
        endif else begin
           hostr.hoflag = 1
           widget_control,hostr.input,sensitive=0
           widget_control,hostr.openfile,sensitive = 1
           widget_control,hostr.hfilename,sensitive=1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Open_HFile_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
         hofile=hostr.hofile
         exray_opendata,hostr.exraystr,wdf=hostr.exraystr.wfilm.howdf,file=hofile
         hostr.hofile=hofile
         widget_control,hostr.Hfilename,set_value=hostr.hofile
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Go_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
       ;save the values in 'global' variables and calculate the result
       widget_control,hostr.ncor,get_value=ncor
       if (hostr.hoflag eq 0) then begin
          widget_control,hostr.lam1,get_value=lam1
          widget_control,hostr.lam2,get_value=lam2
       endif else begin
          widget_control,hostr.hfilename,get_value=hofile
          hostr.exraystr.wfilm.hofile=hofile
          w2i,x,y,hostr.exraystr.wfilm.howdf
          lam1=min(x)
          lam2=max(x)
       endelse
       ;check that the input wavelengths are acceptable
       if (hostr.exraystr.plotflag eq 4) then $
          w2i,xorig,yorig,hostr.exraystr.scaledwdf(hostr.exraystr.activedata) $
       else $
          w2i,xorig,yorig,hostr.exraystr.datawdf(hostr.exraystr.activedata)
       if ((lam1*ncor gt max(xorig)) or (lam2*ncor lt min(xorig))) then begin
          whoops=dialog_message('Given wavelength range is outside data domain.',/Error)
       endif else begin
          hostr.exraystr.wfilm.hoflag=hostr.hoflag
          hostr.exraystr.wfilm.ncor=ncor
          hostr.exraystr.wfilm.hocrange=[lam1,lam2]
          widget_control,hostr.MainWidget,set_uvalue=hostr.exraystr
          widget_control, Event.top, /DESTROY
          exray_horder,hostr.MainWidget
          return
       endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;quit without saving anything
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = hostr


end

pro Exray_horderWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control, MainWidget, get_uvalue = exraystr
  mxy=exraystr.mxy

  Exray_horderWidget_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_horderWidget_BASE', Column = 1,/align_left, $
      TITLE='Higher Order Correction' ,SPACE=3 ,XPAD=3 ,YPAD=3)

  Message_LABEL = Widget_Label(Exray_horderWidget_BASE,/align_left,Value='Before running this correction:')
  Message_LABEL = Widget_Label(Exray_horderWidget_BASE,/align_left,Value='   - Have the wavelength corrected data (OD units) open in the window.')
  Message_LABEL = Widget_Label(Exray_horderWidget_BASE,/align_left,Value='   - Make sure the d2i calculation is set up correctly.')
  Message_LABEL = Widget_Label(Exray_horderWidget_BASE,/align_left,Value='   - Make sure the efficiency correction is set up correctly.')

  Message_LABEL = Widget_Label(Exray_horderWidget_BASE,Value='')

  Control_Base=Widget_Base(Exray_horderWidget_BASE,column=1)

  Ncor_Field = CW_Field(Control_BASE,UNAME='Ncor_FIELD' $
                        ,Title='Order to Correct',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.wfilm.ncor)

  dummy_LABEL = Widget_Label(Control_BASE,Value='')


  Input_Base = Widget_Base(Control_BASE,column=2,frame=1)

  Lam1_Field = CW_Field(Input_Base,UNAME='Lam1_FIELD' $
                        ,Title='Starting Wavelength',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.wfilm.hocrange(0))
;  dummy_LABEL = Widget_Label(Input_BASE,Value='')

  Lam2_Field = CW_Field(Input_BASE,UNAME='Lam2_FIELD' $
                        ,Title='Ending Wavelength ',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.wfilm.hocrange(1))

  dummy_LABEL = Widget_Label(Control_BASE,Value='')

  HFile_BASE = Widget_Base(Control_BASE, UNAME='HFile_BASE', $
      COLUMN=1 ,/NonEXCLUSIVE)

  HFile_Button = Widget_Button(HFile_BASE, UNAME='HFile_Button'  $
      ,/ALIGN_Right,SENSITIVE=1 ,VALUE='Read 1st order  from File')

  HFilename_BASE = Widget_Base(Control_BASE, UNAME='HFile_BASE', $
      COLUMN=3)

  dummy=widget_label(HFilename_BASE,Value='   ')

  HFilename_Field = CW_Field(HFilename_BASE,UNAME='HFilename_FIELD' $
                        ,Title='File:',/Return_Events,/string,xsize=50 $
                        ,Value=exraystr.wfilm.hofile)

  Open_HFile_BUTTON = Widget_Button(HFilename_BASE,  $
      UNAME='Open_HFile_BUTTON',SCR_XSIZE=20*mxy,SCR_YSIZE=20*mxy  $
      ,/ALIGN_Left ,VALUE=exraystr.images.open,/BITMAP)


  Quit_BASE = Widget_Base(Exray_horderWidget_BASE, UNAME='Quit_BASE' $
      ,COLUMN=2,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Cancel')


  Go_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Go_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Calculate')


;************************************************************************************
;Define the structure to be passed around
;************************************************************************************

  hostr = {NAME: 'Options_Structure',$
              input:Input_BASE,$
              lam1:Lam1_FIELD,$
              lam2:Lam2_FIELD,$
              ncor:Ncor_FIELD,$
              hfilename:HFilename_FIELD,$
              filebutton:HFile_BUTTON,$
              openfile:Open_HFile_BUTTON,$
              hoflag:exraystr.wfilm.hoflag,$
              hofile:exraystr.wfilm.hofile,$
              exraystr:exraystr,$
              MainWidget:MainWidget}


 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  Widget_Control, /REALIZE, Exray_horderWidget_BASE

  Widget_Control, Exray_horderWidget_BASE, set_uvalue = hostr

  if (hostr.hoflag eq 0) then begin
     widget_control,hostr.input,sensitive=1
     widget_control,hostr.openfile,sensitive = 0
     widget_control,hostr.hfilename,sensitive=0
  endif else begin
     widget_control,hostr.filebutton,set_button=1
     widget_control,hostr.input,sensitive=0
     widget_control,hostr.openfile,sensitive = 1
     widget_control,hostr.hfilename,sensitive=1
  endelse

  XManager, 'Exray_horderWidget_BASE', Exray_horderWidget_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro Exray_horderWidget, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_horderWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end