

pro Exray_RebinWidget_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = restr

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='Man_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           widget_control,restr.manbase,sensitive=0
           widget_control,restr.auto,set_button=1
           widget_control,restr.autobase,sensitive=1
        endif else begin
           widget_control,restr.autobase,sensitive=0
           widget_control,restr.manbase,sensitive=1
           widget_control,restr.auto,set_button=0
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Auto_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           widget_control,restr.autobase,sensitive=0
           widget_control,restr.man,set_button=1
           widget_control,restr.manbase,sensitive=1
        endif else begin
           widget_control,restr.autobase,sensitive=1
           widget_control,restr.manbase,sensitive=0
           widget_control,restr.man,set_button=0
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Go_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
       ;save the values in 'global' variables and calculate the result
       widget_control,restr.slope,get_value=slope
       widget_control,restr.dres,get_value=dres
       auto = WIDGET_INFO(restr.auto,/button_set )
       restr.exraystr.wfilm.rebinslope = slope
       restr.exraystr.wfilm.dres = dres
       restr.exraystr.wfilm.rebinflag = auto
       widget_control,restr.MainWidget,set_uvalue=restr.exraystr
       widget_control, Event.top, /DESTROY
       exray_rebin,restr.MainWidget
       return
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;quit without saving anything
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = restr


end

pro Exray_RebinWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control, MainWidget, get_uvalue = exraystr
  mxy=exraystr.mxy

  Exray_RebinWidget_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_RebinWidget_BASE', Column = 1,/align_left, $
      TITLE='Rebin Data Correction' ,SPACE=3 ,XPAD=3 ,YPAD=3)

  ;Message_LABEL = Widget_Label(Exray_RebinWidget_BASE,/align_left,Value='Before running this correction:')
  ;Message_LABEL = Widget_Label(Exray_RebinWidget_BASE,/align_left,Value='   - Have the noise-range zoomed in the window.')
  ;Message_LABEL = Widget_Label(Exray_RebinWidget_BASE,/align_left,Value='   - ')
  ;Message_LABEL = Widget_Label(Exray_RebinWidget_BASE,/align_left,Value='   - ')

;  Input_Base = Widget_Base(Exray_RebinWidget_BASE,column=1)

  ManBUTTON_BASE = Widget_Base(Exray_RebinWidget_BASE, UNAME='ManBUTTON_BASE', $
      COLUMN=1,/Exclusive)

  Man_Button = Widget_Button(ManBUTTON_BASE, UNAME='Man_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Manual Input')

  Man_BASE = Widget_Base(Exray_RebinWidget_BASE, UNAME='Man_BASE', $
      COLUMN=1)

  Slope_Field = CW_Field(Man_Base,UNAME='Slope_FIELD' $
                        ,Title='Point Spacing (mA/px) ',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.wfilm.rebinslope)
;  dummy_LABEL = Widget_Label(Input_BASE,Value='')

  AutoBUTTON_BASE = Widget_Base(Exray_RebinWidget_BASE, UNAME='AutoBUTTON_BASE', $
      COLUMN=1,/Exclusive)

  Auto_Button = Widget_Button(AutoBUTTON_BASE, UNAME='Auto_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Determine From Dispersion ')

  Auto_BASE = Widget_Base(Exray_RebinWidget_BASE, UNAME='Auto_BASE', $
      COLUMN=1)

  Dres_Field = CW_Field(Auto_Base,UNAME='Dres_FIELD' $
                        ,Title='Detector Resolution (um) ',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.wfilm.dres)

  Quit_BASE = Widget_Base(Exray_RebinWidget_BASE, UNAME='Quit_BASE' $
      ,COLUMN=2,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Cancel')


  Go_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Go_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Calculate')


;************************************************************************************
;Define the structure to be passed around
;************************************************************************************

  restr = {NAME: 'Options_Structure',$
              slope:Slope_FIELD,$
              dres:Dres_FIELD,$
              man:Man_BUTTON,$
              auto:Auto_BUTTON,$
              manbase:Man_Base,$
              autobase:Auto_Base,$
              exraystr:exraystr,$
              MainWidget:MainWidget}


 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  if (exraystr.wfilm.rebinflag eq 0) then begin
     Widget_Control,Man_Button,set_button=1
     Widget_Control,Auto_Base,sensitive = 0
  endif else begin
     Widget_Control,Auto_Button,set_button=1
     Widget_Control,Man_Base,sensitive = 0
  endelse

  Widget_Control, /REALIZE, Exray_RebinWidget_BASE

  Widget_Control, Exray_RebinWidget_BASE, set_uvalue = restr


  XManager, 'Exray_RebinWidget_BASE', Exray_RebinWidget_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro Exray_RebinWidget, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_RebinWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end