

pro Exray_ScalerMath_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = scalestr

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='Calculate_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;wdf array 105 contains the scaled data
        widget_control,scalestr.scale,get_value=scaler
        operand=widget_info(scalestr.operation,/DROPLIST_SELECT)
        case operand of
        0: add,105,0,scaler,103
        1: add,105,0,-1.*scaler,103
        2: mul,105,0,scaler,103
        3: mul,105,0,1./scaler,103
        else:
        endcase
        if (scalestr.exraystr.plotflag eq 3) then $
           xfr,103,scalestr.exraystr.datawdf(scalestr.exraystr.activedata) $
        else if (scalestr.exraystr.plotflag eq 4) then $
           xfr,103,scalestr.exraystr.scaledwdf(scalestr.exraystr.activedata)

        ;plot the result in the GUI window
        scalestr.exraystr.yrange=[mn(103,/quiet),mx(103,/quiet)]
        Widget_Control,scalestr.MainWidget,set_uvalue=scalestr.exraystr
        widget_control,scalestr.exraystr.widget.plotlist,send_event=$
           { WIDGET_DROPLIST, ID:scalestr.exraystr.widget.plotlist, TOP:scalestr.MainWidget, $
             HANDLER:scalestr.MainWidget, INDEX:scalestr.exraystr.plotflag}
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Quit_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;restore the original curve from wdf 104 and quit
        ;save the values in 'global' variables
        if (scalestr.exraystr.plotflag eq 3) then $
           xfr,104,scalestr.exraystr.datawdf(scalestr.exraystr.activedata) $
        else if (scalestr.exraystr.plotflag eq 4) then $
           xfr,104,scalestr.exraystr.scaledwdf(scalestr.exraystr.activedata)

        ;plot the result in the GUI window
        scalestr.exraystr.plotflag=scalestr.exraystr.plotflag-1
        Widget_Control,scalestr.MainWidget,set_uvalue=scalestr.exraystr
        widget_control,scalestr.exraystr.widget.plotlist,send_event=$
           { WIDGET_DROPLIST, ID:scalestr.exraystr.widget.plotlist, TOP:scalestr.MainWidget, $
             HANDLER:scalestr.MainWidget, INDEX:scalestr.exraystr.plotflag + 1 }
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = scalestr


end

pro Exray_ScalerMath_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control, MainWidget, get_uvalue = exraystr
  mxy=exraystr.mxy

  Exray_ScalerMath_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_ScalerMath_BASE' ,XOFFSET=5 ,YOFFSET=5, Column = 1, $
      TITLE='Scaler Math' ,SPACE=3 ,XPAD=3 ,YPAD=3)

  Scaler_BASE = Widget_Base(Exray_ScalerMath_BASE, UNAME='Scale_BASE' $
      ,COLUMN=2,/ALIGN_Center)

  Scaler_DROPLIST = Widget_Droplist(Scaler_BASE,  $
      UNAME='Scaler_DROPLIST' ,XOFFSET=10 ,YOFFSET=89 ,SENSITIVE=1  $
      ,TITLE='' ,VALUE=[ 'Add','Subtract','Multiply by','Divide by'])

  Scaler_Field = CW_Field(Scaler_BASE,UNAME='Scale_FIELD' $
                        ,Title='  ',/Return_Events,/float,xsize=8 $
                        ,Value=0.0)

  Quit_BASE = Widget_Base(Exray_ScalerMath_BASE, UNAME='Quit_BASE' $
      ,COLUMN=3,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Cancel')

  Calculate_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Calculate_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Calculate')

  Quit_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Quit_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Done')


;************************************************************************************
;Define the structure to be passed around
;************************************************************************************

  scalestr = {NAME: 'Options_Structure',$
              scale:scaler_FIELD,$
              operation:scaler_DROPLIST,$
              exraystr:exraystr,$
              MainWidget:MainWidget}


 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  Widget_Control, /REALIZE, Exray_ScalerMath_BASE

  Widget_Control, Exray_ScalerMath_BASE, set_uvalue = scalestr


  XManager, 'Exray_ScalerMath_BASE', Exray_ScalerMath_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro Exray_ScalerMath, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_ScalerMath_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end
