PRO exray_spectrotrans,MainWidget

;***************************************************************************
;* This program is used to determine the absolute transmission absorption  *
;* spectrum over a specified wavelength range from opacity data given in   *
;* wdfin.                                                                  *
;***************************************************************************

widget_control,MainWidget,get_uvalue=exraystr

w2i,xconv,yconv,exraystr.scaledwdf(exraystr.activedata)
ymin=min(yconv)
ymax=max(yconv)

ans='No'
while ans ne 'Yes' do begin

   i2w,xconv,yconv,103,/xy

   ;now, allow the user to pick 4 points on the maximum
   ;strucuture curve which will be used to calculate the
   ;background transmission.
   pickx=dblarr(1)
   while n_elements(pickx) ne 4 do begin
     info=dialog_message(['Please select four points (in any order):',$
                          '1: The left edge of the data',$
                          '2: The right edge of the data',$
                          '3: The left edge of the spectral features',$
                          '4: The right edge of the spectral features'],/info,/cancel)
     if (info eq 'Cancel') then begin
          widget_control,exraystr.widget.plotlist,send_event=$
             { WIDGET_DROPLIST, ID:exraystr.widget.plotlist, TOP:MainWidget, $
              HANDLER:MainWidget, INDEX:4 }
          return
     endif
     xcur,xpick,ypick
     justify,xpick,xconv,pickx,yconv,picky
     if n_elements(pickx) ne 4 then $
        whoops=dialog_message('You must select 4 points!',/Error)
   endwhile
   pickx=pickx(sort(pickx))

   exray_spectroback,103, $
      pickx,degree=4,/plotz,yrange=[ymin,ymax],/fit3

   ans = dialog_message('Are you happy with this fit? (y/n)',/Question)

endwhile

w2i,xconv,yconv,103
i2w,xconv,yconv,exraystr.scaledwdf(exraystr.activedata),/xy

exraystr.plotflag = 0
widget_control,MainWidget,set_uvalue=exraystr
widget_control,exraystr.widget.plotlist,send_event=$
      { WIDGET_DROPLIST, ID:exraystr.widget.plotlist, TOP:MainWidget, $
         HANDLER:MainWidget, INDEX:4 }

return
end