PRO Exray_Transitions, element

maxtrans=50
numelements=1
Al = 0
;****************define the structures to be used**********************8
Ly = {NAME: 'Ly Series',$
      num:long(0),$ ;the number of defined transitions
      config:strarr(maxtrans),$ ;the transition configurations
      term:strarr(maxtrans),$ ;the transition terms
      jj:strarr(maxtrans),$ ;the j of the transition levels
      lambda:dblarr(maxtrans)} ;the wavelength of the transitions

He = {NAME: 'He Series',$
      num:long(0),$ ;the number of defined transitions
      config:strarr(maxtrans),$ ;the transition configurations
      term:strarr(maxtrans),$ ;the transition terms
      jj:strarr(maxtrans),$ ;the j of the transition levels
      lambda:dblarr(maxtrans)} ;the wavelength of the transitions

Li = {NAME: 'Li Series',$
      num:long(0),$ ;the number of defined transitions
      config:strarr(maxtrans),$ ;the transition configurations
      term:strarr(maxtrans),$ ;the transition terms
      jj:strarr(maxtrans),$ ;the j of the transition levels
      lambda:dblarr(maxtrans)} ;the wavelength of the transitions

Ka = {NAME: 'K-alpha Series',$
      num:long(0),$ ;the number of defined transitions
      config:strarr(maxtrans),$ ;the transition configurations
      term:strarr(maxtrans),$ ;the transition terms
      jj:strarr(maxtrans),$ ;the j of the transition levels
      lambda:dblarr(maxtrans)} ;the wavelength of the transitions

Kb = {NAME: 'K-beta Series',$
      num:long(0),$ ;the number of defined transitions
      config:strarr(maxtrans),$ ;the transition configurations
      term:strarr(maxtrans),$ ;the transition terms
      jj:strarr(maxtrans),$ ;the j of the transition levels
      lambda:dblarr(maxtrans)} ;the wavelength of the transitions

Kg = {NAME: 'K-gamma Series',$
      num:long(0),$ ;the number of defined transitions
      config:strarr(maxtrans),$ ;the transition configurations
      term:strarr(maxtrans),$ ;the transition terms
      jj:strarr(maxtrans),$ ;the j of the transition levels
      lambda:dblarr(maxtrans)} ;the wavelength of the transitions

element = {NAME: 'Known/Calculated Atomic Transitions',$
           numelements:numelements,$ ;the number of defined elements
           symbol:string(''),$ ;the atomic symbol of the element
           Ly:Ly,$ ;Lymann series
           He:He,$ ;Helium-like series
           Li:Li,$ ;Lithium-like series
           Ka:Ka,$ ;K-alpha lines for different charge states
           Kb:Kb,$ ;K-beta lines for different charge states
           Kg:Kg} ;K-gamma lines for different charge states

element=replicate(element,numelements)

;*********** Aluminum **************
element(Al).symbol='Al'

;First the Ly series
fname='atomic_data\Al_Ly.txt'
openr,u,fname,/get
line=''
count=0
readf,u,line
while(not eof(u)) do begin
  readf,u,line
  temp=strsplit(line,', ',/EXTRACT)
  element(Al).Ly.config(count)=temp(0)
  element(Al).Ly.term(count)=temp(1)
  element(Al).Ly.jj(count)=temp(2)
  element(Al).Ly.lambda(count)=double(temp(3))
  count=count+1
endwhile
element(Al).Ly.num=count
close,u
free_lun,u

;Second the He series
fname='atomic_data\Al_He.txt'
openr,u,fname,/get
line=''
count=0
readf,u,line
while(not eof(u)) do begin
  readf,u,line
  temp=strsplit(line,', ',/EXTRACT)
  element(Al).He.config(count)=temp(0)
  element(Al).He.term(count)=temp(1)
  element(Al).He.jj(count)=temp(2)
  element(Al).He.lambda(count)=double(temp(3))
  count=count+1
endwhile
element(Al).He.num=count
close,u

;Now, the Spect3D calculated K-alpha series
fname='atomic_data\Al_Kalpha.txt'
openr,u,fname,/get
line=''
count=0
readf,u,line
while(not eof(u)) do begin
  readf,u,line
  temp=strsplit(line,', ',/EXTRACT)
  element(Al).Ka.config(count)=temp(0)
  element(Al).Ka.term(count)=temp(1)
  element(Al).Ka.jj(count)=temp(2)
  element(Al).Ka.lambda(count)=double(temp(3))
  count=count+1
endwhile
element(Al).Ka.num=count
close,u

free_lun,u
return
end