

pro Exray_TransWidget_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = transtr

 ;Do this every time
  widget_control,transtr.atmcutoff,get_value=temp
  transtr.cutoff(transtr.index)=temp

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='Element_DROPLIST'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_DROPLIST' )then begin
         i=event.index
         ;if the transition file does not exist, then make the button insensitive
         ;also check to see if the user has already selected a transition
         whoops ='No' ;warn the user if they have changed the cut-off temperature since reading in the .atm file
         if (transtr.cutoff(transtr.index) ne transtr.element(transtr.index).atm.cutoff) then begin
            whoops=dialog_message(['You have changed the lower-level cutoff energy for '$
                                 +'transitions from file:',$
                                 transtr.element(transtr.index).atm.atmfile,$
                                 'You must re-open the .atm file for this change to take place.',$
                                 'Would you like to do that now?'],/Question)
            transtr.element(transtr.index).atm.cutoff=temp
         endif
         if (whoops eq 'No') then begin
            widget_control,transtr.Ly,set_button=0
            widget_control,transtr.He,set_button=0
            widget_control,transtr.Li,set_button=0
            widget_control,transtr.Ly,Sensitive=1
            widget_control,transtr.He,Sensitive=1
            widget_control,transtr.Li,Sensitive=1
            if (transtr.optstr.exraystr.element(i).Ly.lambda(0) eq 0.) then $
               widget_control,transtr.Ly,Sensitive=0 $
            else if (transtr.whichtrans(i,0) gt 0) then $
               widget_control,transtr.Ly,set_button=1
            if (transtr.optstr.exraystr.element(i).He.lambda(0) eq 0.) then $
               widget_control,transtr.He,Sensitive=0 $
            else if (transtr.whichtrans(i,1) gt 0) then  $
               widget_control,transtr.He,set_button=1
            if (transtr.optstr.exraystr.element(i).Li.lambda(0) eq 0.) then $
               widget_control,transtr.Li,Sensitive=0 $
            else if (transtr.whichtrans(i,2) gt 0) then  $
               widget_control,transtr.Li,set_button=1
            if (transtr.whichtrans(i,3) gt 0) then  $
               widget_control,transtr.atm,set_button=1 $
            else widget_control,transtr.atm,set_button=0
            if (transtr.optstr.exraystr.element(i).atm.LSFlag eq 1) then  $
               widget_control,transtr.atmls,set_button=1 $
            else widget_control,transtr.atmls,set_button=0

            widget_control,transtr.atmfile,$
                    set_value=transtr.element(i).atm.atmfile
            widget_control,transtr.atmcutoff,$
                    set_value=transtr.element(i).atm.cutoff
            ;if the user has already asked to include this element, then set the button
            if transtr.whichelements(i) gt 0 then widget_control,transtr.include,set_button=1 $
            else widget_control,transtr.include,set_button=0
            transtr.index=i
         endif else $
           widget_control,transtr.atmopen,send_event=$
            { WIDGET_BUTTON, ID:transtr.atmopen, TOP:wWidget, $
             HANDLER:wWidget, SELECT:1 }
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Include_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           transtr.whichelements(transtr.index) =0
        endif else begin
           transtr.whichelements(transtr.index) =1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='LySeries_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           transtr.whichtrans(transtr.index,0) =0
        endif else begin
           transtr.whichtrans(transtr.index,0) =1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='HeSeries_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           transtr.whichtrans(transtr.index,1) =0
        endif else begin
           transtr.whichtrans(transtr.index,1) =1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='LiSeries_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           transtr.whichtrans(transtr.index,2) =0
        endif else begin
           transtr.whichtrans(transtr.index,2) =1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='ATM_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           transtr.whichtrans(transtr.index,3) =0
        endif else begin
           if (transtr.element(transtr.index).atm.atmfile eq 'none') then begin
              index=where(transtr.element.symbol ne '') ;used in a little bit
              element=transtr.element(transtr.index);for some reason, you have to do this
              exray_readatm,element,cutoff=transtr.cutoff(transtr.index),$
                            error=flag
              if (flag eq 1) then begin ;an error occured
                 if (transtr.element(transtr.index).atm.atmfile eq 'none') then $
                    widget_control,transtr.atm,set_button=0
              endif else begin
                 transtr.element(transtr.index)=element
                 transtr.element(transtr.index).atm.cutoff=transtr.cutoff(transtr.index)
                 if (transtr.index gt index(n_elements(index)-1)) then begin
                    ;a new element
                    widget_control,transtr.elelist,$
                       set_value=[transtr.element(index).symbol,$
                            transtr.element(n_elements(index)).symbol,'new']
                    widget_control,transtr.elelist,$
                       set_droplist_select=transtr.index
                 endif
                 widget_control,transtr.atmfile,$
                    set_value=transtr.element(transtr.index).atm.atmfile
              endelse
           endif
           transtr.whichtrans(transtr.index,3) =1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='ATMOpen_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        index=where(transtr.element.symbol ne '') ;used in a little bit
        element=transtr.element(transtr.index) ;for some reason, you have to do this
       exray_readatm,element,cutoff=transtr.cutoff(transtr.index),$
                     error=flag
        if (flag eq 1) then begin ;an error occured
           if (transtr.element(transtr.index).atm.atmfile eq 'none') then $
              widget_control,transtr.atm,set_button=0
        endif else begin
              transtr.element(transtr.index)=element
              transtr.element(transtr.index).atm.cutoff=transtr.cutoff(transtr.index)
              widget_control,transtr.atmfile,$
                 set_value=transtr.element(transtr.index).atm.atmfile
              if (transtr.index gt index(n_elements(index)-1)) then begin
                 ;a new element
                 widget_control,transtr.elelist,$
                       set_value=[transtr.element(index).symbol,$
                            transtr.element(n_elements(index)).symbol,'new']
                 widget_control,transtr.elelist,$
                    set_droplist_select=transtr.index
              endif
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='ATMLS_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           transtr.element(transtr.index).atm.LSFlag =0
        endif else begin
           transtr.element(transtr.index).atm.LSFlag =1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Line_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           transtr.linetrans = 0
           widget_control,transtr.absemis,sensitive=1
        endif else begin
           transtr.linetrans = 1
           widget_control,transtr.absemis,sensitive=0
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Point_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           transtr.linetrans = 1
           widget_control,transtr.absemis,sensitive=0
        endif else begin
           transtr.linetrans = 0
           widget_control,transtr.absemis,sensitive=1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Abs_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           transtr.absflag = 1
        endif else begin
           transtr.absflag = 0
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Emis_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           transtr.absflag = 0
        endif else begin
           transtr.absflag = 1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Done_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
       ;save the values in 'global' variables and calculate the result
        whoops ='No'
        if (transtr.cutoff(transtr.index) ne transtr.element(transtr.index).atm.cutoff) then begin
           whoops=dialog_message(['You have changed the lower-level cutoff energy for '$
                                +'transitions from file:',$
                                transtr.element(transtr.index).atm.atmfile,$
                                'You must re-open the .atm file for this change to take place.',$
                                'Would you like to do that now?'],/Question)
           transtr.element(transtr.index).atm.cutoff=temp
        endif
        if (whoops eq 'No') then begin
           transtr.element(transtr.index).atm.cutoff=temp
           transtr.optstr.exraystr.whichelements=transtr.whichelements
           transtr.optstr.exraystr.whichtrans=transtr.whichtrans
           transtr.optstr.exraystr.element=transtr.element
           transtr.optstr.exraystr.linetrans=transtr.linetrans
           transtr.optstr.exraystr.absflag=transtr.absflag
           ;if no elements selected, then turn off button in scaleopt widget
           index=where(transtr.whichelements gt 0)
           if (index(0) lt 0) then widget_control,transtr.optstr.transitions,set_button=0 $
           else widget_control,transtr.optstr.transitions,set_button=1
           widget_control,transtr.MainWidget,set_uvalue=transtr.optstr
           widget_control, Event.top, /DESTROY
           return
        endif else $
           widget_control,transtr.atmopen,send_event=$
            { WIDGET_BUTTON, ID:transtr.atmopen, TOP:wWidget, $
             HANDLER:wWidget, SELECT:1 }

      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;quit without saving anything
        ;if no elements selected, then turn off button in scaleopt widget
        index=where(transtr.optstr.exraystr.whichelements gt 0)
        if (index(0) lt 0) then widget_control,transtr.optstr.transitions,set_button=0 $
        else widget_control,transtr.optstr.transitions,set_button=1
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = transtr


end

pro Exray_TransWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control,MainWidget,get_uvalue=optstr
  mxy=optstr.exraystr.mxy

  ;find out how what defined elements there are
  index=where(optstr.exraystr.element(*).symbol ne '')

  Exray_TransWidget_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_TransWidget_BASE',Column=1,$
      TITLE='Atomic Transitions' ,SPACE=3 ,XPAD=3 ,YPAD=3)

  Element_Base = Widget_Base(Exray_TransWidget_BASE, Column=2)

  Element_DROPLIST = Widget_Droplist(Element_Base,  $
      UNAME='Element_DROPLIST' ,SENSITIVE=1,TITLE='Element' , $
      VALUE=[optstr.exraystr.element(index).symbol,'new'])

  ElementButton_BASE = Widget_Base(Element_Base, UNAME='ElementButton_BASE', $
      COLUMN=1 ,/NonEXCLUSIVE,/Align_Right)

  Include_Button = Widget_Button(ElementButton_Base, UNAME='Include_Button'  $
      ,/ALIGN_Right,SENSITIVE=1 ,VALUE='Include')

  KP_LABEL = Widget_Label(Exray_TransWidget_BASE,  $
      UNAME='KP_LABEL',/ALIGN_Left,VALUE='Kelley/Pelumbo Known Transitions')

  KPTrans_Base = Widget_Base(Exray_TransWidget_BASE, UNAME='KPTrans_BASE' $
      ,frame=1,column=1)

  KPView_Button = Widget_Button(KPTrans_BASE, UNAME='KPView_Button'  $
      ,/ALIGN_Center,SENSITIVE=1 ,VALUE='View',XSIZE=80)

  KPSpec_Base = Widget_Base(KPTrans_BASE, UNAME='KPSpec_BASE' $
      ,/NonEXCLUSIVE,column=3)

  LySeries_Button = Widget_Button(KPSpec_BASE, UNAME='LySeries_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Ly Series')

  HeSeries_Button = Widget_Button(KPSpec_BASE, UNAME='HeSeries_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='He Series')

  LiSeries_Button = Widget_Button(KPSpec_BASE, UNAME='HeSeries_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Li Series')

  ATMSpec_Base = Widget_Base(Exray_TransWidget_BASE, UNAME='ATMSpec_BASE' $
      ,/NonEXCLUSIVE,column=1)

  ATM_Button = Widget_Button(ATMSpec_BASE, UNAME='ATM_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='ATBASE Calculated Transitions')

  ATMTrans_Base = Widget_Base(Exray_TransWidget_BASE, UNAME='ATMTrans_BASE' $
      ,frame=1,column=1)

  ATMFile_Base = Widget_Base(ATMTrans_Base, UNAME='ATMFile_BASE',column=3)

  ATMFile_LABEL = Widget_Label(ATMFile_Base,  $
      UNAME='ATMFile_LABEL',/ALIGN_Left,$
      VALUE='file: ')

  ATM_Filename = Widget_Text(ATMFile_BASE, UNAME='ATM_Filename'  $
      ,XSIZE=25,YSIZE=1,VALUE=[optstr.exraystr.element(0).atm.atmfile])


  ATMOpen_Button = Widget_Button(ATMFile_BASE, UNAME='ATMOpen_Button'  $
      ,/ALIGN_Right,SENSITIVE=1 ,VALUE='Open',XSIZE=35)

  ATMCutoff_Field = CW_Field(ATMTrans_BASE,UNAME='ATMCutoff_FIELD' $
                        ,Title='Lower-Level Energy Cut-Off =',/Return_Events,/float,xsize=8 $
                        ,Value=optstr.exraystr.element(0).atm.cutoff)

  ATMLS_Base = Widget_Base(ATMTrans_Base, UNAME='ATMLS_BASE' $
      ,/NonEXCLUSIVE,column=1,/Align_Center)

  ATMLS_Button = Widget_Button(ATMLS_BASE, UNAME='ATMLS_Button'  $
      ,/ALIGN_Center,SENSITIVE=1 ,VALUE='Use L-S Coupling Rules')

  ATMView_Button = Widget_Button(ATMTrans_BASE, UNAME='ATMView_Button'  $
      ,/ALIGN_Center,SENSITIVE=1 ,VALUE='View',XSIZE=80)

  Line_Base = Widget_Base(Exray_TransWidget_BASE, UNAME='Line_BASE' $
      ,column=1,Frame=1)

  Line_Button_Base = Widget_Base(Line_BASE, UNAME='Line_Button_BASE' $
      ,/Exclusive,column=1)

  Line_Button = Widget_Button(Line_Button_BASE, UNAME='Line_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Plot Lines')

  Point_Button = Widget_Button(Line_Button_BASE, UNAME='Point_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Plot Symbols')

  AbsEmis_Base = Widget_Base(Line_BASE, UNAME='AbsEmis_BASE' $
      ,/EXCLUSIVE,column=2)

  Abs_Button = Widget_Button(AbsEmis_BASE, UNAME='Abs_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Absorption')

  Emis_Button = Widget_Button(AbsEmis_BASE, UNAME='Emis_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Emission')

  Quit_BASE = Widget_Base(Exray_TransWidget_BASE, UNAME='Quit_BASE' $
      ,COLUMN=2,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Cancel')


  Done_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Done_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Done')


;************************************************************************************
;Define the structure to be passed around
;************************************************************************************

  transtr = {NAME: 'Transitions_Structure',$
              elelist:Element_Droplist,$
              include:Include_Button,$
              Ly:LySeries_Button,$
              He:HeSeries_Button,$
              Li:LiSeries_Button,$
              atm:ATM_Button,$
              atmopen:ATMOpen_Button,$
              atmls:ATMLS_Button,$
              atmfile:ATM_Filename,$
              atmcutoff:ATMCutoff_FIELD,$
              absemis:AbsEmis_BASE,$
              cutoff:optstr.exraystr.element.atm.cutoff,$
              absflag:optstr.exraystr.absflag,$
              linetrans:optstr.exraystr.linetrans,$
              index:long(0),$  ;the current droplist index
              whichelements:optstr.exraystr.whichelements,$ ;copy of the elements the user wants
              whichtrans:optstr.exraystr.whichtrans,$ ;copy of the transitions the user wants
              element:optstr.exraystr.element,$ ;copy of the element structure
              optstr:optstr,$
              MainWidget:MainWidget}

;************************************************************************************
;Initialize some buttons
;************************************************************************************
  widget_control,Abs_BUTTON,set_button=1
  widget_control,Point_BUTTON,set_button=1

  if (optstr.exraystr.whichelements(0) gt 0) then widget_control,Include_BUTTON,set_button=1

  if (optstr.exraystr.element(0).Ly.lambda(0) eq 0.) then $
     widget_control,LySeries_BUTTON,Sensitive=0 $
  else if (optstr.exraystr.whichtrans(0,0) gt 0) then $
     widget_control,LySeries_BUTTON,set_button=1
  if (optstr.exraystr.element(0).He.lambda(0) eq 0.) then $
     widget_control,HeSeries_BUTTON,Sensitive=0 $
  else if (optstr.exraystr.whichtrans(0,1) gt 0) then  $
     widget_control,HeSeries_BUTTON,set_button=1
  if (optstr.exraystr.element(0).Li.lambda(0) eq 0.) then $
     widget_control,LiSeries_BUTTON,Sensitive=0 $
  else if (optstr.exraystr.whichtrans(0,2) gt 0) then $
     widget_control,LiSeries_BUTTON,set_button=1
  if (optstr.exraystr.whichtrans(0,3) gt 0) then $
     widget_control,ATM_BUTTON,set_button=1
  if (optstr.exraystr.element(0).atm.LSFlag eq 1) then $
     widget_control,ATMLS_BUTTON,set_button=1
  if (optstr.exraystr.absflag eq 1) then begin
     widget_control,Emis_BUTTON,set_button=1
     widget_control,Abs_BUTTON,set_button=0
  endif
  if (optstr.exraystr.linetrans eq 1) then begin
     widget_control,Line_BUTTON,set_button=1
     widget_control,Point_BUTTON,set_button=0
     widget_control,AbsEmis_Base,Sensitive=0
  endif

 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  Widget_Control, /REALIZE, Exray_TransWidget_BASE

  Widget_Control, Exray_TransWidget_BASE, set_uvalue = transtr


  XManager, 'Exray_TransWidget_BASE', Exray_TransWidget_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro Exray_TransWidget, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_TransWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end
