PRO exray_writefile,MainWidget

Widget_Control,MainWidget,GET_UVALUE=exraystr

numxstals=exraystr.wnumxstals
numsource=exraystr.wnumsource
numorders=exraystr.wnumorders
numlambda=exraystr.wnumlambda

line=' '
type=' '
nametemp = ''
nametemp = dialog_pickfile(/Write,filter='*.exr',/fix_filter)
if (nametemp eq '') then return $
else begin
   if (strpos(nametemp,'.exr') eq -1) then nametemp=nametemp+'.exr'
   fname = nametemp
endelse

;**********************************************************************
; Write Headers and Data
;**********************************************************************

openw,u,fname,/get
  printf,u,'crystal geometry'
  if (exraystr.convexflag eq 1) then $
    printf,u,'convex'$
  else printf,u,'elliptical'
  printf,u,'*********** crystal definitions **************'
  printf,u,'number of crystals'
  ;number of crystals
  xstalcount=0
  for i=0,numxstals-1 do $
    if (exraystr.xstalset(i) eq 1) then xstalcount=xstalcount+1
  printf,u,xstalcount,format='(I2)'
  printf,u,''

  ;crystal plane spacing (2d)
  printf,u,'crystal plane spacings (2d in angstroms)'
  for i=0,xstalcount-1 do begin
     printf,u,exraystr.wxstal(i).twod,format='(F6.3)'
  endfor
  printf,u,''

if (exraystr.convexflag ne 1) then begin
  ;crystal h parameter (h)
  printf,u,'henke height parameters (h in cm)'
  for i=0,xstalcount-1 do begin
     printf,u,exraystr.wxstal(i).h,format='(F6.3)'
  endfor
  printf,u,''

  ;crystal focal length (R0)
  printf,u,'focal lengths (R0 in cm)'
  for i=0,xstalcount-1 do begin
     printf,u,exraystr.wxstal(i).R0,format='(F8.3)'
  endfor
  printf,u,''

  ;crystal boundaries (Beta_min and Beta_max)
  printf,u,'crystal boundary angles (betamin,betamax in degrees)'
  for i=0,xstalcount-1 do begin
     printf,u,exraystr.wxstal(i).betamin*180./!pi,',',$
              exraystr.wxstal(i).betamax*180./!pi,format='(F7.3,A1,F7.3)'
  endfor
  printf,u,''

endif else begin
;*****print convex crystal stuff******
  ;crystal radius
  printf,u,'crystal radius (Rc in inches)'
  for i=0,xstalcount-1 do begin
     printf,u,exraystr.wxstal(i).rc/2.54,format='(F8.4)'
  endfor
  printf,u,''

  printf,u,'crystal rotation (Chi in degrees ccw)'
  for i=0,xstalcount-1 do begin
     printf,u,exraystr.wxstal(i).chi*180./!pi,format='(F8.4)'
  endfor
  printf,u,''

  printf,u,'lattice rotation (p in degrees ccw)'
  for i=0,xstalcount-1 do begin
     printf,u,exraystr.wxstal(i).p*180./!pi,format='(F8.4)'
  endfor
  printf,u,''

endelse

  printf,u,'*********** source definitions **************'
  printf,u,'number of source points'
  ;number of sources
  sourcecount=0
  for i=0,numsource-1 do $
    if (abs(exraystr.wsource(i).a) gt 0.) then sourcecount=sourcecount+1
  printf,u,sourcecount,format='(I2)'
  printf,u,''

  ;source positions (a,b)
  printf,u,'source position from crystal focal point (a,b in cm)'
  sorindex=where(exraystr.sorset(*) gt 0)
  for i=0,sourcecount-1 do begin
     printf,u,exraystr.wsource(sorindex(i)).a,',',$
        exraystr.wsource(sorindex(i)).b,format='(F8.3,A1,F8.3)'
  endfor
  printf,u,''

  ;Wavelengths or Betas
  for i=0,numorders-1 do begin
     if ((exraystr.lamset(i) eq 1) and (exraystr.wsource(0).lambda(i,0) gt 0.)) then begin
        printf,u,'start wavelength data'
        printf,u,'source index(s)'
        printf,u,1,format='(I1)'
        printf,u,'diffraction order'
        printf,u,exraystr.wsource(0).n(i),format='(I2)'
        if (exraystr.serset(i) eq 1) then begin
           printf,u,'number of wavelengths(angstroms) = series'
           printf,u,exraystr.wsource(0).lambda(i,0),format='(F6.3)'
           printf,u,exraystr.wsource(0).lambda(i,1),format='(F6.3)'
           printf,u,exraystr.wsource(0).lambda(i,2),format='(F6.3)'
           printf,u,'end wavelength data'
           printf,u,''
        endif else begin
           lamcount=0
           for j=0,numlambda-1 do if (exraystr.wsource(0).lambda(i,j) gt 0.) then lamcount=lamcount+1
           printf,u,'number of wavelengths(angstroms) = ',lamcount,format='(A35,I3)'
           for j=0,lamcount-1 do printf,u,exraystr.wsource(0).lambda(i,j),format='(F6.3)'
           printf,u,'end wavelength data'
           printf,u,''
        endelse
     endif else if (exraystr.wxstal(0).beta(i,0) gt 0.) then begin
        printf,u,'start beta data'
        printf,u,'source index(s)'
        printf,u,1,format='(I1)'
        printf,u,'diffraction order'
        printf,u,exraystr.wsource(0).n(i),format='(I2)'
        if (exraystr.serset(i) eq 1) then begin
           printf,u,'number of betas(degrees) = series'
           printf,u,exraystr.wxstal(0).beta(i,0),format='(F6.3)'
           printf,u,exraystr.wxstal(0).beta(i,1),format='(F6.3)'
           printf,u,exraystr.wxstal(0).beta(i,2),format='(F6.3)'
           printf,u,'end beta data'
           printf,u,''
        endif else begin
           betacount=0
           for j=0,numlambda-1 do if (exraystr.wxstal(0).beta(i,j) gt 0.) then betacount=betacount+1
           printf,u,'number of betas(angstroms) = ',betacount,format='(A27,I3)'
           for j=0,betacount-1 do printf,u,exraystr.wxstal(0).beta(i,j),format='(F6.3)'
           printf,u,'end beta data'
           printf,u,''
        endelse
     endif
  endfor

  printf,u,'*********** detector definitions ************'
  ;detector length (L)
  printf,u,'length of detector (l in cm)'
  if (exraystr.wfilm.JFlag ne 2) then printf,u,exraystr.wfilm.L,format='(F6.3)' $
  else printf,u,0.0
  printf,u,''

  ;detector positioning (rf,phi)
  printf,u,'detector position (radius in cm , phi in degrees)'
  if (exraystr.convexflag eq 1) then begin
     if (exraystr.wfilm.circleflag eq 1) then $
        printf,u,'circle detector at rf = '+strtrim(string(exraystr.wfilm.rf),2) $
     else $
        printf,u,exraystr.wfilm.rf,',',(exraystr.wfilm.phi+exraystr.wxstal(0).chi)*180./!pi,$
           format='(F6.3,A2,F8.3)'
  endif else if (exraystr.wfilm.JFlag eq 1) then printf,u,'Johann line' $
  else if (exraystr.wfilm.JFlag eq 2) then printf,u,'Johann locus' $
  else printf,u,exraystr.wfilm.rf,',',exraystr.wfilm.phi*180./!pi,format='(F6.3,A2,F8.3)'
  printf,u,''

  ;detector rotation from normal (mu-phi+90)
  printf,u,'detector rotation about normal(mu in degrees)'
  if (exraystr.convexflag ne 1) then $
     printf,u,(exraystr.wfilm.mu-exraystr.wfilm.phi)*180./!pi+90., format='(F8.3)'$
  else $
     printf,u,(exraystr.wfilm.mu+exraystr.wfilm.phi)*180./!pi-90., format='(F8.3)'

  ;film type, tension, and fog
  printf,u,''
  printf,u,'film type index, tension, interpolation, and fog'
  if (exraystr.wfilm.fogflag eq 0) then $
    printf,u,exraystr.wfilm.filmtype,',',exraystr.wfilm.tension,',',$
             exraystr.wfilm.interpolflag,',',exraystr.wfilm.fog,format='(I2,A2,F8.3,A2,I2,A2,F8.3)' $
  else begin
    printf,u,exraystr.wfilm.filmtype,',',exraystr.wfilm.tension,',',$
             exraystr.wfilm.interpolflag,',',-1.0,format='(I2,A2,F8.3,A2,I2,A2,F4.1)'
    printf,u,exraystr.wfilm.fogfile
  endelse

  ;detector filtering
  if (exraystr.wfilm.filtflag eq 1) then begin
     printf,u,''
     printf,u,'detector filter index and thickness'
     for i=0,2 do begin
        printf,u,exraystr.wfilm.filter(i),',',exraystr.wfilm.filtwidth(i),format='(I2,A2,F8.3)'
     endfor
  endif

  ;MCP Photocathode
  if (exraystr.wfilm.mcpflag eq 1) then begin
    printf,u,''
    printf,u,'MCP photocathode index'
    printf,u,exraystr.wfilm.photocath,format='(I2)'
  endif

  ;Crystal reflectivity
  if (exraystr.wfilm.xstalflag eq 1) then begin
    printf,u,''
    printf,u,'crystal reflectivity index (0=Average,1=Prins,2=Mosaic) and data units index'
    printf,u,exraystr.wfilm.refflag,',',exraystr.wfilm.units,format='(I2,A2,I2)'
  endif

  ;Solid Angle Corrections
  if (exraystr.wfilm.geoflag eq 1) then begin
    printf,u,''
    printf,u,'spectrometer slit width, integration length, and magnification'
    printf,u,exraystr.wfilm.slit,',',exraystr.wfilm.lineout,$
             ',',exraystr.wfilm.mag,format='(F8.3,A2,F8.3,A2,F8.3)'
  endif

  printf,u,''
  printf,u,'*********** TREX design definitions ************'
  printf,u,'LOS flag (0=side-on, 1=end-on, 2=other)'
  printf,u,exraystr.LOSFlag,format='(I1)'
  printf,u,''
  printf,u,'origin location (cm)'
  printf,u,exraystr.wLOS,format='(F9.3)'
  printf,u,''
  printf,u,'rotation past average beta (degrees)'
  printf,u,exraystr.wrot*180./!pi,format='(F8.3)'

close,u
free_lun,u


;************************************************************
; Set the file widget
;************************************************************
widget_control,exraystr.widget.InFile,SET_VALUE=fname

RETURN
END
