

pro Exray_Convex_Film_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = filmstr

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='Quit_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        tmp=double(0.)
        widget_control,filmstr.rfwidget,get_value=tmp
        if tmp gt 0. then begin
           ;If the group actually contains data, then save the values
           filmstr.exraystr.wfilm.rf=tmp
        endif

        if (filmstr.exraystr.wfilm.circleFlag eq 0) then begin
           widget_control,filmstr.phiwidget,get_value=tmp
           filmstr.exraystr.wfilm.phi=tmp*!pi/180.
           widget_control,filmstr.muwidget,get_value=tmp
           filmstr.exraystr.wfilm.mu =tmp*!pi/180.
           widget_control,filmstr.Lwidget,get_value=tmp
           if tmp gt 0. then begin
              ;If the group actually contains data, then save the values
              filmstr.exraystr.wfilm.L = tmp
           endif
           ;run a check to see if valid film parameters are set
           if (filmstr.exraystr.wfilm.circleFlag ne 0) then begin
              if (filmstr.exraystr.wfilm.rf gt 0.) then filmstr.exraystr.filmOK = 1
           endif else begin
              if (filmstr.exraystr.wfilm.rf gt 0.) and (filmstr.exraystr.wfilm.phi ne 0.) $
                 and (filmstr.exraystr.wfilm.L gt 0.) then filmstr.exraystr.filmOK = 1
           endelse
        endif
        Widget_Control, filmstr.MainWidget, set_uvalue = filmstr.exraystr
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;quit without saving anything
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = filmstr


end

pro Exray_Convex_Film_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control, MainWidget, get_uvalue = exraystr
  mxy=exraystr.mxy

  Exray_Convex_Film_BASE = Widget_Base( GROUP_LEADER=wGroup, COLUMN=1, $
      UNAME='Exray_Convex_Film_BASE' ,XOFFSET=5 ,YOFFSET=5, /BASE_Align_Right $
      ,TITLE='Film Parameters' ,SPACE=3 ,XPAD=3 ,YPAD=3)

  Film_LABEL = Widget_Label(Exray_Convex_Film_BASE,  $
      UNAME='Film_LABEL',/ALIGN_LEFT,VALUE='')


;***********************************************************************************

if (exraystr.wfilm.circleFlag ne 0) then begin

     Rf_Field = CW_Field(Exray_Convex_Film_BASE,UNAME='Rf_FIELD' $
                        ,Title='Detector Radius (cm) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wfilm.rf])


     ;Define the structure to be passed around


      filmstr = {NAME: 'Film_Structure',$
                 rfwidget:rf_FIELD,$
                 exraystr:exraystr,$
                 MainWidget:MainWidget}

endif else begin
     Rf_Field = CW_Field(Exray_Convex_Film_BASE,UNAME='Rf_FIELD' $
                        ,Title='Detector Radius (cm) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wfilm.rf])


     Phi_Field = CW_Field(Exray_Convex_Film_BASE,UNAME='Phi_FIELD' $
                        ,Title='Detector Position (deg) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wfilm.phi*180./!pi])

     Mu_Field = CW_Field(Exray_Convex_Film_BASE,UNAME='Mu_FIELD' $
                        ,Title='Out of True (deg) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wfilm.mu*180./!pi])

     L_Field = CW_Field(Exray_Convex_Film_BASE,UNAME='L_FIELD' $
                        ,Title='Detector Length (cm) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wfilm.L])

     ;Define the structure to be passed around
      filmstr = {NAME: 'Film_Structure',$
                 rfwidget:rf_FIELD,$
                 phiwidget:Phi_FIELD,$
                 muwidget:Mu_FIELD,$
                 LWidget:L_FIELD,$
                 exraystr:exraystr,$
                 MainWidget:MainWidget}

endelse

  Quit_BASE = Widget_Base(Exray_Convex_Film_BASE, UNAME='Quit_BASE' $
      ,COLUMN=2,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Cancel')


  Quit_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Quit_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Done')





 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  Widget_Control, /REALIZE, Exray_Convex_Film_BASE

  Widget_Control, Exray_Convex_Film_BASE, set_uvalue = filmstr


  XManager, 'Exray_Convex_Film_BASE', Exray_Convex_Film_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro exray_convex_film, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_Convex_Film_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end