

pro Exray_Convex_XstalWidget_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = xstalstr

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='Xstal1_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           xstalstr.xstalset(0)=0
        endif else begin
           xstalstr.xstalset(0)=1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Xstal2_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           xstalstr.xstalset(1)=0
        endif else begin
           xstalstr.xstalset(1)=1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Xstal3_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           xstalstr.xstalset(2)=0
        endif else begin
           xstalstr.xstalset(2)=1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Quit_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        numxstals=3
        tmp=double(0.)
        whoops = ''
        for i=0,numxstals-1 do begin
          if xstalstr.xstalset(i) eq 1 then begin
             xstalstr.exraystr.xstalset(i) = 1
             widget_control,xstalstr.rc(i),get_value=tmp
             if (tmp gt 0) then $
                 xstalstr.exraystr.wxstal(i).rc=tmp*2.54 $
             else $
                whoops = dialog_message('Radius for xstal #'$
                +strtrim(string(i+1),2)+' must be > 0',/Error)

             widget_control,xstalstr.chi(i),get_value=tmp
             xstalstr.exraystr.wxstal(i).chi=tmp*!pi/180.

             widget_control,xstalstr.p(i),get_value=tmp
             xstalstr.exraystr.wxstal(i).p=tmp*!pi/180.

             widget_control,xstalstr.twod(i),get_value=tmp
             if (tmp gt 0) then $
                xstalstr.exraystr.wxstal(i).twod=tmp $
             else $
                whoops = dialog_message('2d for xstal #'$
                +strtrim(string(i+1),2)+' must be > 0',/Error)
          endif else begin
             xstalstr.exraystr.xstalset(i) = 0
             xstalstr.exraystr.wxstal(i).rc=0.
             xstalstr.exraystr.wxstal(i).chi=0.
             xstalstr.exraystr.wxstal(i).twod=0.
             xstalstr.exraystr.wxstal(i).p=0.
          endelse
        endfor

        if whoops eq 'OK' then return $
        else begin
          Widget_Control, xstalstr.MainWidget, set_uvalue = xstalstr.exraystr
          widget_control, Event.top, /DESTROY
          return
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = xstalstr


end

pro Exray_Convex_XstalWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control, MainWidget, get_uvalue = exraystr
  mxy=exraystr.mxy

  numxstals=exraystr.wnumxstals
  Initarr=dblarr(numxstals,5)
  for i=0,numxstals-1 do begin
    Initarr(i,0)=exraystr.wxstal(i).h
    Initarr(i,1)=exraystr.wxstal(i).R0
    Initarr(i,2)=exraystr.wxstal(i).betamin*180./!pi
    Initarr(i,3)=exraystr.wxstal(i).betamax*180./!pi
    Initarr(i,4)=exraystr.wxstal(i).twod
  endfor


  Exray_Convex_XstalWidget_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_Convex_XstalWidget_BASE' ,XOFFSET=5 ,YOFFSET=5,COLUMN=3 $
      ,TITLE='Crystals' ,SPACE=3 ,XPAD=3 ,YPAD=3)


;***********************************************************************************
;Xstal 1

  Xstal1_BASE = Widget_Base(Exray_Convex_XstalWidget_BASE, UNAME='Xstal1_BASE'  $
      ,XOFFSET=10 ,YOFFSET=10 ,COLUMN=1,/BASE_ALIGN_RIGHT)

  Xstal1Button_BASE = Widget_Base(Xstal1_BASE, UNAME='Xstal1Button_BASE'  $
      ,XOFFSET=10 ,YOFFSET=10 ,COLUMN=1 ,/NONEXCLUSIVE)


  Xstal1_Button = Widget_Button(Xstal1Button_BASE, UNAME='Xstal1_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Crystal 1')


  Value1_LABEL = Widget_Label(Xstal1_BASE,  $
      UNAME='Value1_LABEL' ,XOFFSET=10 ,YOFFSET=50 ,/ALIGN_Right  $
      ,VALUE='Crystal Parameters')


  Rc1_Field = CW_Field(Xstal1_BASE,UNAME='Rc1_FIELD' $
                        ,Title='Crystal Radius (in) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wxstal(0).rc/2.54])

  Chi1_Field = CW_Field(Xstal1_BASE,UNAME='Chi1_FIELD' $
                        ,Title='Crystal Rotation (deg) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wxstal(0).chi*180./!pi])


  Twod1_Field = CW_Field(Xstal1_BASE,UNAME='Twod1_FIELD' $
                        ,Title='2d (Ansgtroms) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wxstal(0).twod])

  P1_Field = CW_Field(Xstal1_BASE,UNAME='P1_FIELD' $
                        ,Title='Lattice Rotation (deg) = ',/Return_Events,/float $
                        ,xsize=exraystr.formats.fieldsize ,Value=[exraystr.wxstal(0).p*180./!pi])

;***********************************************************************************
;Xstal 2

  Xstal2_BASE = Widget_Base(Exray_Convex_XstalWidget_BASE, UNAME='Xstal2_BASE'  $
      ,XOFFSET=10 ,YOFFSET=10 ,COLUMN=1,/BASE_ALIGN_RIGHT)

  Xstal2Button_BASE = Widget_Base(Xstal2_BASE, UNAME='Xstal2Button_BASE'  $
      ,XOFFSET=10 ,YOFFSET=10 ,COLUMN=1 ,/NONEXCLUSIVE,XSIZE=80)


  Xstal2_Button = Widget_Button(Xstal2Button_BASE, UNAME='Xstal2_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=0 ,VALUE='Crystal 2')


  Value2_LABEL = Widget_Label(Xstal2_BASE,  $
      UNAME='Value2_LABEL' ,XOFFSET=10 ,YOFFSET=50 ,/ALIGN_Right  $
      ,VALUE='Crystal Parameters')


  Rc2_Field = CW_Field(Xstal2_BASE,UNAME='Rc2_FIELD' $
                        ,Title='Crystal Radius (in) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wxstal(1).rc/2.54])

  Chi2_Field = CW_Field(Xstal2_BASE,UNAME='Chi2_FIELD' $
                        ,Title='Crystal Rotation (deg) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wxstal(1).chi*180./!pi])


  Twod2_Field = CW_Field(Xstal2_BASE,UNAME='Twod2_FIELD' $
                        ,Title='2d (Ansgtroms) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wxstal(1).twod])

  P2_Field = CW_Field(Xstal2_BASE,UNAME='P2_FIELD' $
                        ,Title='Lattice Rotation (deg) = ',/Return_Events,/float $
                        ,xsize=exraystr.formats.fieldsize ,Value=[exraystr.wxstal(1).p*180./!pi])

;***********************************************************************************
;Xstal 3

  Xstal3_BASE = Widget_Base(Exray_Convex_XstalWidget_BASE, UNAME='Xstal3_BASE'  $
      ,XOFFSET=10 ,YOFFSET=10 ,COLUMN=1,/BASE_ALIGN_RIGHT)

  Xstal3Button_BASE = Widget_Base(Xstal3_BASE, UNAME='Xstal3Button_BASE'  $
      ,XOFFSET=10 ,YOFFSET=10 ,COLUMN=1 ,/NONEXCLUSIVE, XSIZE=80)


  Xstal3_Button = Widget_Button(Xstal3Button_BASE, UNAME='Xstal3_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=0 ,VALUE='Crystal 3')


  Value3_LABEL = Widget_Label(Xstal3_BASE,  $
      UNAME='Value3_LABEL' ,XOFFSET=10 ,YOFFSET=50 ,/ALIGN_Right  $
      ,VALUE='Crystal Parameters')


  Rc3_Field = CW_Field(Xstal3_BASE,UNAME='Rc3_FIELD' $
                        ,Title='Crystal Radius = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wxstal(2).rc/2.54])

  Chi3_Field = CW_Field(Xstal3_BASE,UNAME='Chi3_FIELD' $
                        ,Title='Crystal Rotation (deg) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wxstal(2).chi*180./!pi])


  Twod3_Field = CW_Field(Xstal3_BASE,UNAME='Twod3_FIELD' $
                        ,Title='2d (Ansgtroms) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wxstal(2).twod])

  P3_Field = CW_Field(Xstal3_BASE,UNAME='P3_FIELD' $
                        ,Title='Lattice Rotation (deg) = ',/Return_Events,/float $
                        ,xsize=exraystr.formats.fieldsize ,Value=[exraystr.wxstal(2).p*180./!pi])

  Quit_BASE = Widget_Base(Xstal3_BASE, UNAME='Quit_BASE' $
      ,COLUMN=2,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Cancel')


  Quit_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Quit_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Done')


;************************************************************************************
;Set the appropriate values and buttons
;************************************************************************************
if exraystr.xstalset(0) gt 0 then begin
   Widget_Control, Xstal1_Button,SET_BUTTON = 1
endif
if exraystr.xstalset(1) gt 0 then begin
   Widget_Control, Xstal2_Button,SET_BUTTON = 1
endif
if exraystr.xstalset(2) gt 0 then begin
   Widget_Control, Xstal3_Button,SET_BUTTON = 1
endif

;************************************************************************************
;Define the structure to be passed around
;************************************************************************************

  xstalstr = {NAME: 'Xstal_Structure',$
              rc:[rc1_FIELD,rc2_FIELD,rc3_FIELD],$
              chi:[chi1_FIELD,chi2_FIELD,chi3_FIELD],$
              Twod:[Twod1_FIELD,Twod2_FIELD,Twod3_FIELD],$
              p:[p1_FIELD,p2_FIELD,p3_FIELD],$
              xstalset:lonarr(numxstals),$ ;A flag to determine if the xstal is set
              exraystr:exraystr,$
              MainWidget:MainWidget}

  xstalstr.xstalset(*)=exraystr.xstalset(*)

 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  Widget_Control, /REALIZE, Exray_Convex_XstalWidget_BASE

  Widget_Control, Exray_Convex_XstalWidget_BASE, set_uvalue = xstalstr


  XManager, 'Exray_Convex_XstalWidget_BASE', Exray_Convex_XstalWidget_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro exray_convex_xstalwidget, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_Convex_XstalWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end