PRO EXRAY_PLOTRAYS,exrayptr,over,trex,LOS,alpham,R0m,noprint,windID=winID

if (over eq 0) then linelook=0 else linelook=1
if (n_elements(winID) ne 0) then wset,winID

numxstals=(*exrayptr).numxstals
numsource=(*exrayptr).numsource
numorders=(*exrayptr).numorders
numlambda=(*exrayptr).numlambda
for l=0,numxstals-1 do begin
   for i=0,numsource-1 do begin
      for j=0,numorders-1 do begin
          for k=0,numlambda-1 do begin
              a=(*exrayptr).source(i).a  ;will be called every time in case trex = 1
              b=(*exrayptr).source(i).b  ;will be called every time in case trex = 1
              theta=(*exrayptr).xstal(l).theta(i,j,k)
              if (theta gt 0.) then begin
                 xc=(*exrayptr).xstal(l).xc(i,j,k)
                 yc=(*exrayptr).xstal(l).yc(i,j,k)
                 xlambda=(*exrayptr).film.xlambda(l,i,j,k)
                 ylambda=(*exrayptr).film.ylambda(l,i,j,k)
                 lambda=(*exrayptr).source(i).lambda(j,k)
                 order=(*exrayptr).source(i).n(j)

                 if (trex ne 0) then begin
                    dist=sqrt((R0m+a)^2+b^2)*(R0m+a)/abs(R0m+a)
                    if (dist eq 0 or finite(dist) eq 0) then begin
                       ;the source is located at the source focus
                       ; which will cause -b/dist to be undefined
                       a = LOS
                       b = 0
                    endif else begin
                       a=LOS-dist*cos(alpham+asin(-b/dist))
                       b=dist*sin(alpham+asin(-b/dist))
                    endelse
                    dist=sqrt((R0m+xc)^2+yc^2)
                    xc=LOS-dist*cos(alpham+asin(-yc/dist))
                    yc=dist*sin(alpham+asin(-yc/dist))
                    dist=sqrt((R0m+xlambda)^2+ylambda^2)
                    xlambda=LOS-dist*cos(alpham+asin(-ylambda/dist))
                    ylambda=dist*sin(alpham+asin(-ylambda/dist))
                 endif

                 oplot,[a,xc],[b,yc],col=i,line=l
                 oplot,[xc,xlambda],[yc,ylambda],col=i,line=l

                 if (noprint eq 0) then begin
                    ;now print the wavelength label on the graph
                    label=strtrim(string(lambda,format='(D6.3)'),2) + ' A' $
                          +', order = '+strtrim(string(order,format='(I2)'),2)
                    if (xc gt xlambda) then $
                       orient= 180.+atan((yc-ylambda)/abs(xc-xlambda))*180./!pi $
                    else if (xlambda gt xc) then $
                       orient= 360.-atan((yc-ylambda)/abs(xc-xlambda))*180./!pi $
                    else orient = 270.
                    xyouts,xlambda,ylambda,label,orientation = orient,color=i
                 endif

              endif
          endfor
      endfor
   endfor
endfor

return
end