PRO Exray_PloTrans,exraystr

delta=0.01 ;the delta-lambda to use for finding maxima/minima
if (exraystr.plotflag eq 4) then $
   xfr,exraystr.scaledwdf(exraystr.activedata),105 $
else $
   xfr,exraystr.datawdf(exraystr.activedata),105

w2i,xdata,ydata,105
absflag=exraystr.absflag

;find the chosen elements
index=where(exraystr.whichelements gt 0)
for i=0,n_elements(index)-1 do begin
   ;find the chosen transitions
   index2=where(exraystr.whichtrans(index(i),*) gt 0)
   for j=0,n_elements(index2)-1 do begin

      case index2(j) of

      0: begin ;the Lymann series
         ;find how many Lymann transitions are defined
         index3=where(exraystr.element(index(i)).Ly.lambda gt 0.)
         for k=0,n_elements(index3)-1 do begin
            ;find the nearest maxima (emissions)/minima (absorptions)
            index4=where((xdata ge exraystr.element(index(i)).Ly.lambda(index3(k))-delta) $
                     and (xdata le exraystr.element(index(i)).Ly.lambda(index3(k))+delta))
            if (index4(0) gt 0) then begin
               ;the wavelength is in the range of the data
               if (absflag eq 1) then $
               mint=mx(105,left=xdata(index4(0)),$
                  right=xdata(index4(n_elements(index4)-1)),/quiet) $
               else $
               mint=mn(105,left=xdata(index4(0)), $
                       right=xdata(index4(n_elements(index4)-1)),/quiet)
               if (exraystr.linetrans eq 0) then $
                  plots,exraystr.element(index(i)).Ly.lambda(index3(k)),mint,line=0,psym=5,$
                     col=2 $
               else $
                  oplot,exraystr.element(index(i)).Ly.lambda(index3(k))*[1.,1.],!y.crange,line=0,col=2
            endif
         endfor
      end

      1: begin ;the Helium-Like series
         ;find how many He-like transitions are defined
         index3=where(exraystr.element(index(i)).He.lambda gt 0.)
         for k=0,n_elements(index3)-1 do begin
            ;find the nearest maxima (emissions)/minima (absorptions)
            index4=where((xdata ge exraystr.element(index(i)).He.lambda(index3(k))-delta) $
                     and (xdata le exraystr.element(index(i)).He.lambda(index3(k))+delta))
            if (index4(0) gt 0) then begin
               ;the wavelength is in the range of the data
               if (absflag eq 1) then $
               mint=mx(105,left=xdata(index4(0)), $
                       right=xdata(index4(n_elements(index4)-1)),/quiet) $
               else $
               mint=mn(105,left=xdata(index4(0)), $
                       right=xdata(index4(n_elements(index4)-1)),/quiet)
               if (exraystr.linetrans eq 0) then $
                  plots,exraystr.element(index(i)).He.lambda(index3(k)),mint,line=0,psym=5,$
                     col=4 $
               else $
                   oplot,exraystr.element(index(i)).He.lambda(index3(k))*[1.,1.],!y.crange,line=0,col=4
            endif
         endfor
      end

      2: begin ;the Lithium-Like series
         ;find how many Li-like transitions are defined
         index3=where(exraystr.element(index(i)).Li.lambda gt 0.)
         for k=0,n_elements(index3)-1 do begin
            ;find the nearest maxima (emissions)/minima (absorptions)
            index4=where((xdata ge exraystr.element(index(i)).Li.lambda(index3(k))-delta) $
                     and (xdata le exraystr.element(index(i)).Li.lambda(index3(k))+delta))
            if (index4(0) gt 0) then begin
               ;the wavelength is in the range of the data
               if (absflag eq 1) then $
               mint=mx(105,left=xdata(index4(0)), $
                       right=xdata(index4(n_elements(index4)-1)),/quiet) $
               else $
               mint=mn(105,left=xdata(index4(0)), $
                       right=xdata(index4(n_elements(index4)-1)),/quiet)
               if (exraystr.linetrans eq 0) then $
                  plots,exraystr.element(index(i)).Li.lambda(index3(k)),mint,line=0,psym=5,$
                     col=5 $
               else $
                  oplot,exraystr.element(index(i)).Li.lambda(index3(k))*[1.,1.],!y.crange,line=0,col=5
            endif
         endfor
      end

      3: begin ;the ATBASE calculated transitions from the user-defined .atm file
         ;find how many transitions are defined
         index3=where(exraystr.element(index(i)).atm.lambda gt 0.)
         if (exraystr.element(index(i)).atm.LSFlag eq 1) then $
            index3=where(exraystr.element(index(i)).atm.LS eq 1) $
         else $
            index3=where(exraystr.element(index(i)).atm.lambda gt 0.)
         if (index3(0) ge 0) then begin
         for k=0,n_elements(index3)-1 do begin
            ;find the nearest maxima (emissions)/minima (absorptions)
            index4=where((xdata ge exraystr.element(index(i)).atm.lambda(index3(k))-delta) $
                     and (xdata le exraystr.element(index(i)).atm.lambda(index3(k))+delta))
            if (index4(0) gt 0) then begin
               ;the wavelength is in the range of the data
               if (absflag eq 1) then $
               mint=mx(105,left=xdata(index4(0)), $
                       right=xdata(index4(n_elements(index4)-1)),/quiet) $
               else $
               mint=mn(105,left=xdata(index4(0)), $
                       right=xdata(index4(n_elements(index4)-1)),/quiet)
               if (exraystr.linetrans eq 0) then $
                  plots,exraystr.element(index(i)).atm.lambda(index3(k)),mint,line=0,psym=5,$
                     col=3 $
               else $
                  oplot,exraystr.element(index(i)).atm.lambda(index3(k))*[1.,1.],!y.crange,line=0,col=3
            endif
         endfor
         endif
      end
      else:
      endcase
   endfor
endfor

return
end