function revers_interp,xt,yt,zt,z,x,helps=helps

if keyword_set(helps) then begin
    sesame_help_options,'reverse_interp'
    return,-1.0e99
endif


    nx=n_elements(xt)
    ny=n_elements(yt)
    temp_y=dblarr(5)

    PERR = 1.0d-7
    P01 = 0.01 
    s10 = 0.0

    ;  Get x location
    ix = Isrch(x,xt)
    is1 = ix


    ;  Get approximate first guess y location
    s2 = z
    s3 = (x-xt(ix))/(xt(ix+1)-xt(ix))
    is1 = ix
    is2 = 0
    is3 = ny-1

    while(is3-is2 ne 1) do begin
        m = fix((0.5*(is2+is3)))
        iy = (m-1)
        if( s2 gt (1.0-s3)*zt(is1,iy)+s3*zt(is1+1,iy) ) then $
            is2 = m  $
          else $
            is3 = m 
    endwhile

    ix = is1 
    iy = is2

    s5 = Sesrt1(xt,zt,x,ix,iy) 
    s2 = yt(iy) 
    iy = iy+1
    s3 = yt(iy) 
    s6 = Sesrt1(xt,zt,x,ix,iy) 

;  Make sure J indices bracket variable Y

    iy=iy-1
    s1 = (s6-z)*(z-s5) 

    if( ((iy eq 0) and (z lt s5)) or $
        ((iy eq ny-2) and (z gt s6)) ) then s1 = 0.0 

    if(s1 lt 0.0) then begin
        if(z lt s5) then begin
            if(iy ne 0) then begin
                repeat begin
                    iy=iy-1
                    s6 = s5 
                    s5 = Sesrt1(xt,zt,x,ix,iy) 
                    s2 = yt(iy) 
                endrep until ( (z ge s5) or (iy eq 0)) 
            endif else begin
                while( (z ge s6) and (iy ne ny-2) ) do begin
                    iy=iy+2 
                    s5 = s6 
                    s6 = Sesrt1(xt,zt,x,ix,iy) 
                    iy=iy-1
                    s3 = yt(iy+1) 
                endwhile
            endelse
        endif
    endif

;  Make 2 sweeps over Y variable

    i = ix 
    s7 = (x-xt(i))/(xt(i+1)-xt(i)) 
    j = iy 
    s8 = yt(j+1)-yt(j)
    s6 = (s6-s5)/s8 
    y = 0.5*s8 
    if(j gt 0) then s2 = yt(j-1) 
    if(ny-j gt 2) then s3 = yt(j+2) 

    temp_y(1) = s1 
    temp_y(2) = s2 
    temp_y(3) = s3 
    temp_y(4) = 0.0  ; s4

    for k=1,2 do begin
        i = ix+k-1 
        j = iy 
        s12 = (zt(i,j+1) - zt(i,j))/s8 

        if(j gt 0) then begin
            s10 = yt(j)-yt(j-1) 
            temp_y(k) = (zt(i,j)-zt(i,j-1))/s10 
            temp_y(k+2) = (s12-temp_y(k))/(s8+s10) 
        endif else $
            temp_y(k) = 0.0 

        if( (j eq 1) and (temp_y(k)*(temp_y(k)-s10*temp_y[k+2]) le 0.0) ) then $
            temp_y(k+2) = (s12-2.0*temp_y(k))/s8 

        if(ny-j gt 2)  then begin
            s10 = yt(j+2)-yt(j+1) 
            temp_y(k) = ((zt(i,j+2) - zt(i,j+1))/s10-s12)/(s8+s10) 
        endif else $
          temp_y(k) = 0.0 

        if( (j le 0) and (s12*(s12-s8*temp_y(k)) le 0.0) ) then temp_y(k) = s12/s8 
    endfor
    s1 = temp_y(1) 
    s2 = temp_y(2) 
    s3 = temp_y(3) 
    s4 = temp_y(4) 

;  Begin iteration on variable Y (maximum number of iterations is 50)

    s14 = 1.0 

    for l=1,5 do begin
        smx = -1.0 
        if(s14 gt 0.0) then begin
            j = iy 
            s12 = abs(s1*(s8-y)) 
            s11 = s12 + abs(s3*y) 

            if(s11 gt 0.0) then s12 = s12/s11 

            if(j le 0) then  s12 = 0.0 
            if(ny-j le 2) then s12 = 1.0 

            s11 = s1+s12*(s3-s1) 
            s12 = (1.0-s12)*(s11-s1) 
            s9 = abs(s2*(s8-y)) 
            s10 = s9+abs(s4*y) 

            if(s10 gt 0.0) then s9 = s9/s10 
            if(j le 0) then s9 = 0.0 

            if(ny-j le 2) then s9 = 1.0 

            s10 = s2+s9*(s4-s2) 

            if( (z ge s5) and (z le s5+s6*s8) ) then begin
                s11 = s11 + (s10-s11)*s7 
                s12 = s12 + ((1.0-s9)*(s10-s2)-s12)*s7 
            endif else begin
                s11 = 0.0 
                s12 = 0.0 
            endelse

            dzy = s6+(2.0*y-s8)*s11+s8*s12 
            s11 = -y*(s8-y)*s11+s5+s6*y 

            if(dzy gt 0.0) then $
                s9 = (z-s11)/dzy $
              else $
                s9 = P01*Sign(s8,z-s11) 

            y = y+s9 
            s13 = abs(s9) - PERR*abs(s8) 
            s14 = abs(z-s11)-PERR*(abs(z)+PERR) 
            s14 = (s13<s14)
        endif
        smx = (smx>s14) 
        if(smx le 0.0) then l=51
    endfor

;  End iteration on variable Y

    j = iy 
    y = y+yt(j) 

    if(s14 le 0.0) then  $
        s1 = 1.0  $
      else $
        s1 = -1.0 

return,y 
end
