

pro Exray_BatchWidget_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = batchstr

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='Open_BatchFile_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        nametemp = ''
        path=''
        nametemp = dialog_pickfile(/must_exist,title='Select the batch file', $
                           path=batchstr.exraystr.path,get_path=path)
        if (nametemp ne '') then begin
           batchstr.path=path
           batchstr.batchfile=nametemp
           widget_control,batchstr.BatchFilename,SET_VALUE=batchstr.batchfile
        endif
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Batch_Filename'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_TEXT' )then begin
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Effcor_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
         if (batchstr.effcorflag eq 0) then batchstr.effcorflag = 1 $
         else batchstr.effcorflag = 0
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Wave_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
         if (batchstr.waveflag eq 0) then batchstr.waveflag = 1 $
         else batchstr.waveflag = 0
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='D2I_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
         if (batchstr.d2iflag eq 0) then batchstr.d2iflag = 1 $
         else batchstr.d2iflag = 0
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Quit_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
       ;save the values in 'global' variables and run the batch job
        if (batchstr.batchfile eq '') then begin
          whoops = dialog_message('No batch file selected.',/Error)
          return
        endif
        widget_control, Event.top, /DESTROY
        exray_batchcalc,batchstr
        batchstr.exraystr.path=batchstr.path
        batchstr.exraystr.batchfile=batchstr.batchfile
        Widget_Control, batchstr.MainWidget, set_uvalue = batchstr.exraystr
        return
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;quit without saving anything
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = batchstr


end

pro Exray_BatchWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control, MainWidget, get_uvalue = exraystr
  mxy=exraystr.mxy

  Exray_BatchWidget_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_BatchWidget_BASE' ,XOFFSET=5 ,YOFFSET=5, Column = 1, $
      TITLE='Batch Calculation' ,SPACE=3 ,XPAD=3 ,YPAD=3)

  BatchFile_LABEL = Widget_Label( Exray_BatchWidget_BASE,  $
      UNAME='BatchFile_LABEL',/ALIGN_LEFT,VALUE='Batch Filename')

  File_BASE = Widget_Base(Exray_BatchWidget_BASE, UNAME='File_BASE',COLUMN=2)

  Batch_Filename = Widget_Text(File_BASE, UNAME='Batch_Filename'  $
         ,FRAME=0.5 ,XOFFSET=11 ,YOFFSET=60 ,SCR_XSIZE=369*mxy,SCR_YSIZE=30*mxy $
         ,XSIZE=20 ,YSIZE=1, VALUE=exraystr.batchfile)

  CalcButton_BASE = Widget_Base(Exray_BatchWidget_BASE, UNAME='FilterButton_BASE', $
      COLUMN=1,/NonExclusive)

  Wave_BUTTON = Widget_Button(CalcButton_BASE, UNAME='Wave_BUTTON'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Apply Wavelength Scale')

  D2I_BUTTON = Widget_Button(CalcButton_BASE, UNAME='D2I_BUTTON'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Do Film Correction (D2I)')

  Effcor_BUTTON = Widget_Button(CalcButton_BASE, UNAME='Effcor_BUTTON'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Do Efficiency Correction')

  Open_BatchFile_BUTTON = Widget_Button(File_BASE,  $
      UNAME='Open_BatchFile_BUTTON' ,XOFFSET=389 ,YOFFSET=60,SCR_XSIZE=30*mxy,SCR_YSIZE=30*mxy $
      ,/ALIGN_CENTER ,VALUE='images/open.bmp',/BITMAP)

  Quit_BASE = Widget_Base(Exray_BatchWidget_BASE, UNAME='Quit_BASE' $
      ,COLUMN=2,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Cancel')


  Quit_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Quit_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Run')


;************************************************************************************
;Define the structure to be passed around
;************************************************************************************

  batchstr = {NAME: 'Batch_Structure',$
              BatchFilename:Batch_Filename,$
              batchfile:exraystr.batchfile,$
              path:exraystr.path,$
              waveflag:1,$
              effcorflag:1,$
              d2iflag:0,$
              exraystr:exraystr,$
              MainWidget:MainWidget}

  widget_control,Effcor_Button,set_button = 1
  widget_control,Wave_Button,set_button = 1
  widget_control,D2I_Button,set_button = 0

 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  Widget_Control, /REALIZE, Exray_BatchWidget_BASE

  Widget_Control, Exray_BatchWidget_BASE, set_uvalue = batchstr


  XManager, 'Exray_BatchWidget_BASE', Exray_BatchWidget_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro Exray_BatchWidget, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_BatchWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end
