PRO exray_d2i, MainWidget, nocheck=nocheck, noplot=noplot, nosave=nosave, angcor=angcor,$
               angle=ang, image = image

widget_control, MainWidget,get_uvalue=exraystr

pic=exraystr.wfilm.filmtype
ssiz = size(image)
lcimage = (ssiz[0] eq 2) ? 1 : 0

if (exraystr.plotflag eq 4) then $
   data=exraystr.scaledwdf(exraystr.activedata) $
else $
   data=exraystr.datawdf(exraystr.activedata)

Error_Status=0
CATCH,Error_Status
if Error_status NE 0 THEN begin
    whoops=dialog_message('There is a problem subtracting the fog.'$
             +' Please verify the settings',/ERROR)
    CATCH,/CANCEL
    return
endif
if (exraystr.wfilm.fogflag eq 1) then begin
   if lcimage then begin
     puty, getyf(data) * 0, data
     sub, data, exraystr.wfilm.fogwdf,103
     tmp = getyf(103)
     for j = 0, ssiz[2]-1 do image[*, j] += tmp
   endif else sub,data,exraystr.wfilm.fogwdf,103 
endif else  begin
   sub,data,0,exraystr.wfilm.fog,103
   if lcimage then image = image - exraystr.wfilm.fog
endelse
w2i,lamda,lineout_data,103
CATCH,/CANCEL

film = pic - 1

if keyword_set(angcor) then begin
    ;calculate the angle of incidence associated with each ray
    widget_control,exraystr.widget.Graphics,GET_VALUE=winID
    autoflag=exraystr.autoflag
    exraystr.autoflag=1
    exray_buildptr,exraystr,temptr
    (*temptr).numsource=1
    exray_go,50,temptr,windID=winID,noplot=noplot,angle=ang
    exraystr.autoflag=autoflag
    w2i,xf,yf,50
    ang=interpol(ang,yf,lamda)
endif else ang=!pi/2.0

if lcimage then $
  spect_data = henkep_film_resp( film, lamda, image, ang, $
  exraystr.wfilm.tension,exraystr.wfilm.interpolflag) else $
exray_henke_film_resp, film, lamda, lineout_data, ang, spect_data, $
    exraystr.wfilm.tension,exraystr.wfilm.interpolflag,0


; Plot it and ask if user is satisfied

if not keyword_set(noplot) then begin
   yrange=[min(spect_data),max(spect_data)]
   
   plot,lamda,spect_data,col=0,line=0,xrange=exraystr.xrange,yrange=yrange $
       ,xtitle='Wavelength (Angstroms)',pos=[0.15,0.1,0.95,0.957],xstyle=1,ystyle=1 $
       ,psym=0,ytitle='Intensity photons/um^2'

   wait,0.0
endif

if keyword_set(nosave) then begin
   ;store the result in the scratch wdf array 60
   if lcimage then i2w,lamda,spect_data[*, 0],60,/xy else $
     i2w,lamda,spect_data,60,/xy
endif else begin
   if keyword_set(nocheck) then $
      check='Yes'$
   else $
      check=dialog_message('Is this acceptable?',/Question)
   if (check eq 'Yes') then begin
      ;permanently overwrite the active scaledwdf
      if (exraystr.plotflag eq 4) then $
         i2w,lamda,spect_data,exraystr.scaledwdf(exraystr.activedata),/xy $
      else $
         i2w,lamda,spect_data,exraystr.datawdf(exraystr.activedata),/xy
   endif
   if not keyword_set(noplot) then begin
      plotflag=exraystr.plotflag
      exraystr.plotflag = 0
      widget_control,MainWidget,set_uvalue=exraystr
      widget_control,exraystr.widget.plotlist,send_event=$
        { WIDGET_DROPLIST, ID:exraystr.widget.plotlist, TOP:MainWidget, $
         HANDLER:MainWidget, INDEX:plotflag }
   endif
endelse

end
