

pro Exray_Filter_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = filtstr

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='Butterworth_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
         if (event.select eq 1) then filtstr.filtype=0
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Exponential_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
         if (event.select eq 1) then filtstr.filtype=1
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Ideal_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
         if (event.select eq 1) then filtstr.filtype=2
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Mode_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
         if (event.select eq 1) then begin
            filtstr.filparam=0
            widget_control,filtstr.mode,sensitive=1
            widget_control,filtstr.delta,sensitive=0
            widget_control,filtstr.freq,sensitive=0
         endif
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Delta_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
         if (event.select eq 1) then begin
            filtstr.filparam=1
            widget_control,filtstr.delta,sensitive=1
            widget_control,filtstr.mode,sensitive=0
            widget_control,filtstr.freq,sensitive=0
         endif
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Freq_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
         if (event.select eq 1) then begin
            filtstr.filparam=2
            widget_control,filtstr.freq,sensitive=1
            widget_control,filtstr.mode,sensitive=0
            widget_control,filtstr.delta,sensitive=0
         endif
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Go_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
       ;filter the data set
        case filtstr.filparam of
        0: begin
           widget_control,filtstr.mode,get_value=mode
        end
        1: begin
           widget_control,filtstr.delta,get_value=delta
           mode=filtstr.np*filtstr.dt/delta
        end
        2: begin
           widget_control,filtstr.freq,get_value=freq
           mode=filtstr.np*filtstr.dt*freq
        end
        endcase
        ;wdf array 103 will be the temporary holder of information
        case filtstr.filtype of
        0: filt,filtstr.data,103,type='but',mode=mode,plot=0
        1: filt,filtstr.data,103,type='exponential',mode=mode
        2: filt,filtstr.data,103,type='ide',mode=mode
        endcase
        plo,[filtstr.data,103],line=[0,0],col=[0,1],xran=filtstr.exraystr.xrange,/ov,$
            yran=filtstr.exraystr.yrange,psym=0,leg=-1,pos=[0.15,0.1,0.95,0.957],xstyle=1,ystyle=1
        legendp,['Filtered Data'],col=1,line=0,psym=0,pos=[0.6,0.92],/normal
        wait,0.0 ;plot needs time to update
        ok='No'
        ok=dialog_message('Is this acceptable?',/Question)
        if (ok eq 'No') then begin
           widget_control,filtstr.exraystr.widget.plotlist,send_event=$
            { WIDGET_DROPLIST, ID:filtstr.exraystr.widget.plotlist, TOP:filtstr.MainWidget, $
             HANDLER:filtstr.MainWidget, INDEX:filtstr.exraystr.plotflag }
           return
        endif else begin
           if (filtstr.exraystr.plotflag eq 3) then $
              xfr,103,filtstr.exraystr.datawdf(filtstr.exraystr.activedata) $
           else $
              xfr,103,filtstr.exraystr.scaledwdf(filtstr.exraystr.activedata)
           Widget_Control, filtstr.MainWidget, set_uvalue = filtstr.exraystr
           widget_control,filtstr.exraystr.widget.plotlist,send_event=$
            { WIDGET_DROPLIST, ID:filtstr.exraystr.widget.plotlist, TOP:filtstr.MainWidget, $
             HANDLER:filtstr.MainWidget, INDEX:filtstr.exraystr.plotflag }
           widget_control, Event.top, /DESTROY
           return
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;quit without saving anything
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = filtstr


end

pro Exray_Filter_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control, MainWidget, get_uvalue = exraystr
  mxy=exraystr.mxy

  if (exraystr.plotflag eq 3) then data=exraystr.datawdf(exraystr.activedata) $
  else data=exraystr.scaledwdf(exraystr.activedata)
  w2i,x,y,data
  np=n_elements(x)
  dt=0.
  for i=0,n_elements(x)-2 do dt=dt+x(i+1)-x(i)
  dt=dt/(1.*np-1.)

  Exray_Filter_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_Filter_BASE' ,XOFFSET=5 ,YOFFSET=5, Column = 1, $
      TITLE='Filter Options' ,SPACE=3 ,XPAD=3 ,YPAD=3)

  FilterType_LABEL = Widget_Label(Exray_Filter_BASE,  $
      UNAME='FilterType_LABEL',/ALIGN_LEFT,VALUE='Filtering Method')

  FilterType_BASE = Widget_Base(Exray_Filter_BASE,  $
      UNAME='Button_BASE', Column = 1,/Exclusive,Frame=1)

  Butterworth_BUTTON = Widget_Button(FilterType_BASE, UNAME='Butterworth_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Butterworth')

  Exponential_BUTTON = Widget_Button(FilterType_BASE, UNAME='Exponential_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Exponential')

  Ideal_BUTTON = Widget_Button(FilterType_BASE, UNAME='Ideal_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Ideal')

  FilterParam1_LABEL = Widget_Label(Exray_Filter_BASE,  $
      UNAME='FilterParam1_LABEL',/ALIGN_LEFT,VALUE='Filter Parameters')

  FilterParam2_LABEL = Widget_Label(Exray_Filter_BASE,  $
      UNAME='FilterParam1_LABEL',/ALIGN_LEFT,VALUE='(Mode=NP*DT/Delta=Freq*NP*DT)')

  FilterParam_BASE = Widget_Base(Exray_Filter_BASE,  $
      UNAME='Button_BASE', Column = 2,Frame=1)

  NP_LABEL = Widget_Label(FilterParam_BASE,  $
      UNAME='NP_LABEL',/ALIGN_LEFT,VALUE='NP='+strtrim(string(np),2) )

  ParamButton_BASE = Widget_Base(FilterParam_BASE,  $
      UNAME='Button_BASE', Column = 1,/Exclusive)

  Mode_BUTTON = Widget_Button(ParamButton_BASE, UNAME='Mode_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Mode')

  Delta_BUTTON = Widget_Button(ParamButton_BASE, UNAME='Delta_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Delta')

  Freq_BUTTON = Widget_Button(ParamButton_BASE, UNAME='Freq_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Freq')

  DT_LABEL = Widget_Label(FilterParam_BASE,  $
      UNAME='DT_LABEL',/ALIGN_LEFT,VALUE='DT='+strtrim(string(dt,format='(F10.3)'),2) )

  ParamValue_BASE=Widget_BASE(FilterParam_Base,column=1)

  Mode_Field = CW_Field(ParamValue_BASE,UNAME='Mode_FIELD' $
                        ,Title='= ',/All_Events,/float,xsize=8 $
                        ,Value=12.)

  Delta_Field = CW_Field(ParamValue_BASE,UNAME='Delta_FIELD' $
                        ,Title='= ',/All_Events,/float,xsize=8 $
                        ,Value=(np*dt)/12.)

  Freq_Field = CW_Field(ParamValue_BASE,UNAME='Freq_FIELD' $
                        ,Title='= ',/All_Events,/float,xsize=8 $
                        ,Value=12./(np*dt))


  Quit_BASE = Widget_Base(Exray_Filter_BASE, UNAME='Quit_BASE' $
      ,COLUMN=2,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Cancel')


  Go_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Go_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Calculate')


;************************************************************************************
;Define the structure to be passed around
;************************************************************************************

  filtstr = {NAME: 'Filter_Structure',$
              mode:Mode_Field,$
              delta:Delta_Field,$
              freq:Freq_Field,$
              data:data,$
              np:np,$
              dt:dt,$
              filtype:long(0),$ ;flag of which filter type to use
              filparam:long(0),$ ;flag of which filter parameter to use
              exraystr:exraystr,$
              MainWidget:MainWidget}

   widget_control,Butterworth_Button,set_button = 1
   widget_control,Mode_Button,set_button = 1
   widget_control,Delta_FIELD,sensitive = 0
   widget_control,Freq_FIELD,sensitive = 0

 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  Widget_Control, /REALIZE, Exray_Filter_BASE

  Widget_Control, Exray_Filter_BASE, set_uvalue = filtstr


  XManager, 'Exray_Filter_BASE', Exray_Filter_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro Exray_Filter, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_Filter_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end
