PRO exray_findi1,MainWidget,lamda,i2,dtot,i1,angcor=angcor,angle=ang2

widget_control, MainWidget,get_uvalue=exraystr

pic=exraystr.wfilm.filmtype

Error_Status=0
CATCH,Error_Status
if Error_status NE 0 THEN begin
    whoops=dialog_message('There is a problem subtracting the fog.'$
             +' Please verify the settings',/ERROR)
    CATCH,/CANCEL
    return
endif
if (exraystr.wfilm.fogflag eq 1) then begin
   w2i,xfog,yfog,exraystr.wfilm.fogwdf
   yfogi=interpol(yfog,xfog,lamda)
   dtot=dtot-yfogi
endif else $
   dtot=dtot-exraystr.wfilm.fog
CATCH,/CANCEL

film = pic - 1

if keyword_set(angcor) then begin
    ;calculate the angle of incidence associated with each ray
    widget_control,exraystr.widget.Graphics,GET_VALUE=winID
    autoflag=exraystr.autoflag
    exraystr.autoflag=1
    exray_buildptr,exraystr,temptr
    (*temptr).numsource=1
    exray_go,50,temptr,windID=winID,noplot=noplot,angle=ang
    exraystr.autoflag=autoflag
    w2i,xf,yf,50
    ang=interpol(ang,yf,lamda)
endif else ang=!pi/2.0

nl=n_elements(lamda)
i1=dblarr(nl)
for k=0,nl-1 do begin
   lam1=lamda(k)
   lam2=lam1/2.
   ;create d-logE curves for 1st and 2nd order wavelengths and store in WDF 51 and 52
   nd=10
   dens=findgen(nd)/(nd-1.)*(dtot(k)+0.5)+0.01

   intens1=dblarr(nd)
   intens2=dblarr(nd)
   for i=0,nd-1 do begin & $
      exray_henke_film_resp, film, [lam1,lam2], dens(i)*[1.,1.], ang, exposure, $
          exraystr.wfilm.tension,exraystr.wfilm.interpolflag,0
      intens1(i)=exposure(0)
      intens2(i)=exposure(1)
   endfor

   logd=alog(dens)
   log1=alog(intens1)
   log2=alog(intens2)
   i2w,intens1,dens,51,/xy,clab=strtrim(string(lam1,form='(F7.3)'),2)
   i2w,intens2,dens,52,/xy,clab=strtrim(string(lam2,form='(F7.3)'),2)

   ;first guess an I1 by assuming Densities add linearly (this will be a lower bound)
   Dtotal=dtot(k)
   logI2=alog(i2(k))
   logD2g=interpol(logd,log2,logI2)
   D2g=exp(logD2g)
   D1g=Dtotal-D2g
   logD1g=alog(D1g)
   logI1g=interpol(log1,logd,logD1g)
   I1g=exp(logI1g)

   ;search for the true answer
   ni=10
   I1min=intens1(0)
   I2i=I2(k)/float(ni)
   I1i=(I1g-I1min)/float(ni)
   delta=100.
   finc=0.1
   count=0
   direct=1.
   converged=1
   while abs(delta) gt Dtotal*1.e-5 do begin
      count=count+1
      I0i=I1min
      for i=0,ni-1 do begin
         I1pi=I0i+I1i
         logI1pi=alog(I1pi)
         logD1i=interpol(logd,log1,logI1pi)
         logI02i=interpol(log2,logd,logD1i)
         I2pi=exp(logI02i)+I2i
         logI2pi=alog(I2pi)
         logD2i=interpol(logd,log2,logI2pi)
         logI01i=interpol(log1,logd,logD2i)
         I0i=exp(logI01i)
      endfor
      Dt=exp(logD2i)
      delta=Dtotal-Dt
      I1gold=I1i*ni+I1min
      if (direct*delta lt 0) then begin
         if (count eq 1) then begin
            direct=-1.
            finc=-1.*finc
         endif
         I1gold=I1i*ni/(1.+finc)+I1min & $
         finc=finc/2.
      endif
      I1i=(I1gold-I1min)/float(ni)*(1.+finc)
      if (count gt 100) then begin
         delta=Dtotal*1.e-6
         converged=0
      endif
      ;print,count,I1i*ni+I1min,delta
   endwhile
   i1(k)=I1i*ni/(1.+finc)+I1min
   print,k,count,i1(k),converged
   plo,51,2,/xl,/yl,xtitle='Exposure',ytitle='Film Density',$
      title='k='+strtrim(string(k),2)+' out of '+strtrim(string(nl),2)
   wait,0.001
endfor

if (converged ne 1) then begin
   whoops=dialog_message('Not all points converged',/error)
endif

return
end