PRO exray_i2d, MainWidget, lambda, intens, dens, angcor=angcor, angle=angle

widget_control, MainWidget,get_uvalue=exraystr
pic=exraystr.wfilm.filmtype
film = pic - 1

;generate a 2D array of densities as a function of lambda and intensity
ni=n_elements(lambda)
nl=20 ;number of wavelengths in table
nd=200 ;number of densities in table
intab = dblarr(nl,nd)
lam=findgen(nl)/(nl-1.)*(lambda(ni-1)-lambda(0))+lambda(0)
if not(keyword_set(angcor)) then ang=lam/lam*!pi/2. else begin
   fit=poly_fit(lambda,angle,5)
   ang=poly (lam, fit)
endelse

den = findgen(nd)/(nd-1)*3.+0.001
for i=0,nl-1 do begin
  henke_film_resp, film, lam(i)*den/den, den, ang(i)*den/den, int, $
     exraystr.wfilm.tension,exraystr.wfilm.interpolflag,0
  intab(i,*)=int
endfor

;interpolate on the grid to get a good guess of the density
dens=dblarr(ni)
for i=0,ni-1 do begin
   dv = revers_interp(lam,den,intab,intens(i),lambda(i))
   dens(i)=dv
endfor

wait,0.0

return
end
