

pro Exray_LamRef_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = lamrefstr

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='Quit_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
       ;save the values in 'global' variables
        whoops = ''
        tmp=double(0.)
        Widget_Control,lamrefstr.lamref,get_value=tmp
        if tmp le 0. then $
           whoops=dialog_message('The reference wavelength must be greater than 0!' $
                                   ,/Error) $
        else $
           lamrefstr.exraystr.lamref=tmp

        tmp=long(0)
        Widget_Control,lamrefstr.orderef,get_value=tmp
        if tmp le 0 then $
           whoops=dialog_message('The reference order must be greater than 0!' $
                                   ,/Error) $
        else $
           lamrefstr.exraystr.orderef=tmp
        if whoops ne 'OK' then begin
           lamrefstr.exraystr.scaleOK=1
           Widget_Control, lamrefstr.MainWidget, set_uvalue = lamrefstr.exraystr
           if lamrefstr.exraystr.plotOK eq 1 then begin
              Widget_Control, lamrefstr.exraystr.widget.scaledata,SENSITIVE=1
              Widget_Control, lamrefstr.exraystr.widget.batch,SENSITIVE=1
              Widget_Control, lamrefstr.exraystr.widget.pff,SENSITIVE=1
           endif
           widget_control, Event.top, /DESTROY
           return
        endif
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;quit without saving anything
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = lamrefstr


end

pro Exray_LamRef_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control, MainWidget, get_uvalue = exraystr
  mxy=exraystr.mxy

  Exray_LamRef_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_LamRef_BASE' ,XOFFSET=5 ,YOFFSET=5, Column = 1 $
      ,TITLE='Wavelength' ,SPACE=3 ,XPAD=3 ,YPAD=3,/Base_Align_Right)



  LamRef_Field = CW_Field(Exray_LamRef_BASE,UNAME='LamRef_FIELD' $
                        ,Title='Corresponding Wavelength (A) =',/Return_Events $
                        ,/float,xsize=exraystr.formats.fieldsize,Value=[exraystr.lamref])


  OrderRef_Field = CW_Field(Exray_LamRef_BASE,UNAME='OrderRef_FIELD' $
                        ,Title='Diffraction Order =',/Return_Events $
                        ,/long,xsize=exraystr.formats.fieldsize,Value=[exraystr.orderef])


  Quit_BASE = Widget_Base(Exray_LamRef_BASE, UNAME='Quit_BASE' $
      ,COLUMN=2,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Cancel')


  Quit_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Quit_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Done')



  lamrefstr = {NAME: 'LamRef_Structure',$
              lamref:LamRef_FIELD,$
              orderef:OrderRef_FIELD,$
              exraystr:exraystr,$
              MainWidget:MainWidget}

 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  Widget_Control, /REALIZE, Exray_LamRef_BASE

  Widget_Control, Exray_LamRef_BASE, set_uvalue = lamrefstr


  XManager, 'Exray_LamRef_BASE', Exray_LamRef_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro exray_LamRef, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_LamRef_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end