

pro Exray_RayOpt_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = optstr

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='PrintWaves_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
         if (event.select eq 0) then optstr.printwaves = 0 $
         else optstr.printwaves = 1
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='LimitRays_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
         if (event.select eq 0) then optstr.limitrays = 0 $
         else optstr.limitrays = 1
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Quit_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
       ;save the values in 'global' variables
        optstr.exraystr.limitrays=optstr.limitrays
        optstr.exraystr.printwaves=optstr.printwaves
        Widget_Control, optstr.MainWidget, set_uvalue = optstr.exraystr
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;quit without saving anything
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = optstr


end

pro Exray_RayOpt_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control, MainWidget, get_uvalue = exraystr
  mxy=exraystr.mxy

  Exray_RayOpt_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_RayOpt_BASE' ,XOFFSET=5 ,YOFFSET=5, Column = 1, $
      TITLE='Ray-Tracing Options' ,SPACE=3 ,XPAD=3 ,YPAD=3)

  Button_BASE = Widget_Base(Exray_RayOpt_BASE,  $
      UNAME='Button_BASE', Column = 1,/NonExclusive)

  PrintWaves_BUTTON = Widget_Button(Button_BASE, UNAME='PrintWaves_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Print Wavelengths on Plot')

  LimitRays_BUTTON = Widget_Button(Button_BASE, UNAME='LimitRays_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Limit Diffraction to Crystal Dimensions')


  Quit_BASE = Widget_Base(Exray_RayOpt_BASE, UNAME='Quit_BASE' $
      ,COLUMN=2,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Cancel')


  Quit_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Quit_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Done')


;************************************************************************************
;Define the structure to be passed around
;************************************************************************************

  optstr = {NAME: 'Options_Structure',$
              printwaves:long(0),$
              limitrays:long(0),$
              exraystr:exraystr,$
              MainWidget:MainWidget}

  if (exraystr.printwaves eq 1) then begin
     widget_control, PrintWaves_button, set_button = 1
     optstr.printwaves=1
  endif
  if (exraystr.limitrays eq 1) then begin
     widget_control, LimitRays_button, set_button = 1
     optstr.limitrays=1
  endif

 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  Widget_Control, /REALIZE, Exray_RayOpt_BASE

  Widget_Control, Exray_RayOpt_BASE, set_uvalue = optstr


  XManager, 'Exray_RayOpt_BASE', Exray_RayOpt_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro exray_rayopt, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_RayOpt_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end
