PRO Exray_ReadATM,element,cutoff=cutoff,Error=errorflag 
 
errorflag=0 ;flag to say if there is an error (1 means an error) 
index=0 ;transition index 
ion=0 ;Atom charge state 
used=0 ;flag to say if a specific charge state is used 
energy=double(0.) ;energy of a level 
atnum='' ;the atomic number of the element 
term ='' ;the term symbol of a level 
termnum ='' ;the number of the term (2,3,4,...) 
config ='' ;the configuration of a level 
lastion=0 ;the current ion -> to tell if went to next charge state 
groundconfig='' ;the ground state configuration of an ion 
groundterm='' ;the ground state term of an ion 
groundenergy=double(0.) ;the ground state energy of a level 
lowenergies=dblarr(10) ;an array of possible lower levels 
lowconfigs=strarr(10) ;an array of possible lower level configurations 
lowterms=strarr(10) ;an array of possible lower level terms 
 
fname = '' 
fname = dialog_pickfile(/must_exist,title='Open the EXRAY session file', $ 
                           filter='*.atm') 
if (fname eq '') then begin 
  errorflag=1 
  return 
endif 
 
openr,u,fname,/get 
;check for a problem with the file 
Error_Status=0 
;CATCH,Error_Status 
if Error_status NE 0 THEN begin 
    whoops=dialog_message('There is a problem with the .atm file.',/ERROR) 
    errorflag=1 
    CATCH,/CANCEL 
    close,u 
    free_lun,u 
    return 
endif 
 
;re-initialize the values 
element.atm.num=0 
element.atm.config(*)='' 
element.atm.term(*)='' 
element.atm.jj(*)='' 
element.atm.lambda(*)=0.0 
 
line='' 
for i=0,4 do readf,u,line ;skip the header 
readf,u,format='(A17,A3)',line,atnum ;read the atomic number 
for i=0,7 do readf,u,line ;skip the header 
 
count=0 
while(not eof(u)) do begin 
  point_lun,-u,place 
  readf,u,format='(A1)',line 
  if (line ne '-') then begin 
     point_lun,u,place 
     readf,u,format='(2I5,I6,1F0,A4,A2,A0)',index,ion,used,energy,term,termnum,config 
     if (ion ne lastion) then begin 
        ;just read in the ground state values for this ion 
        lastion=ion 
        groundconfig=strtrim(config,2) 
        groundterm=strtrim(term,2) 
        groundenergy=energy 
        ;re-initiallize lower level arrays 
        lowenergies(*)=0. 
        lowconfigs(*)='' 
        lowterms(*)='' 
        lowcount=0 
     endif 
 
     if (used eq 1) then begin 
        ;the transition to this level is to be used 
        if (abs(energy-groundenergy) lt cutoff) and (energy ne groundenergy) then begin 
           ;this is a possible lower-level for transition 
           if (lowcount lt 10) then begin 
              lowenergies(lowcount)=energy 
              lowconfigs(lowcount)=strtrim(config,2) 
              lowterms(lowcount)=strtrim(term,2) 
              lowcount=lowcount+1 
           endif 
        endif else begin 
           ;this is a possible upper-level for transition 
           atm=element.atm ;again, you have to do this for some dumb reason 
           exray_transcalc,groundconfig,groundterm,groundenergy,$ 
                           lowconfigs,lowterms,lowenergies,$ 
                           strtrim(config,2),strtrim(term,2),energy,$ 
                           count,atm 
           element.atm=atm 
        endelse 
     endif 
  endif 
endwhile 
 
index=where(element.atm.lambda gt 0.) 
if (index(0) lt 0) then begin 
   whoops=dialog_message(['No levels in file:',fname,'satisfied the transition rules'],/error) 
   errorflag=1 
endif 
 
if (element.symbol eq '') then $ 
   element.symbol=strtrim(atnum,2) 
element.atm.atmfile=fname 
 
close,u 
free_lun,u 
 
CATCH,/CANCEL 
return 
end 
