PRO exray_readfile,MainWidget

Widget_Control,MainWidget,GET_UVALUE=exraystr
fname=exraystr.filename
openr,u,fname,/get

Error_Status=0
CATCH,Error_Status
if Error_status NE 0 THEN begin
    whoops=dialog_message('There is a problem with the input file.'$
             +' Please verify the contents.',/ERROR)
    CATCH,/CANCEL
    close,u
    free_lun,u
    return
endif

numsource=exraystr.wnumsource
numxstals=exraystr.wnumxstals
numorders=exraystr.wnumorders
numlambda=exraystr.wnumlambda

line=' '
type=' '

;**********************************************************************
; Initialize variables to remove residuals
;**********************************************************************
exraystr.wsource(*).a=0.
exraystr.wsource(*).b=0.
exraystr.wsource(*).lambda(*,*)=0.
exraystr.wsource(*).n(*)=1
exraystr.sorset(*)=0
exraystr.wxstal(*).h=0.
exraystr.wxstal(*).R0=0.
exraystr.wxstal(*).twod=0.
exraystr.wxstal(*).beta(*,*)=0.
exraystr.wxstal(*).ecc=0.
exraystr.wxstal(*).betamin=0.
exraystr.wxstal(*).betamax=0.
exraystr.wxstal(*).rc=0.
exraystr.wxstal(*).chi=0.
exraystr.wxstal(*).p=0.
exraystr.xstalset(*)=0
exraystr.wfilm.rf=0.
exraystr.wfilm.phi=0.
exraystr.wfilm.mu=0.
exraystr.wfilm.L=0.
exraystr.wfilm.JFlag=0.
exraystr.filmOK=0
exraystr.groupOK=0
exraystr.wfilm.circleflag=0
exraystr.convexflag=0
exraystr.plotflag=-1


;**********************************************************************
; Read in Data
;**********************************************************************
;exraystr.wxstal(*).beta(*,*)=-1.  ;initialize beta to -1 as a flag for later
JohannFlag=0
count=0

while(not eof(u)) do begin
  readf,u,line

  ;crystal geometry
  if strpos(line,'crystal geometry') ne -1 then begin
      readf,u,line
      if strpos(line,'convex') ne -1 then begin
         exraystr.convexflag=1
         Widget_Control, exraystr.widget.elliptical, MAP=0
         Widget_Control, exraystr.widget.convex, MAP=1
      endif else begin
         Widget_Control, exraystr.widget.convex, MAP=0
         Widget_Control, exraystr.widget.elliptical, MAP=1
         exraystr.convexflag=0
      endelse
  endif

  ;number of crystals
  if strpos(line,'number of crystals') ne -1 then begin
      readf,u,temp
      numxstals=long(temp)
  endif

  ;crystal plane spacing (2d)
  if strpos(line,'crystal plane') ne -1 then begin
     for i=0,numxstals-1 do begin
        readf,u,temp
        exraystr.wxstal(i).twod=double(temp)
     endfor
  endif

  ;crystal h parameter (h)
  if strpos(line,'henke') ne -1 then begin
     for i=0,numxstals-1 do begin
        readf,u,temp
        exraystr.wxstal(i).h=double(temp)
     endfor
  endif

  ;crystal focal length (R0)
  if strpos(line,'focal lengths') ne -1 then begin
     for i=0,numxstals-1 do begin
        readf,u,temp
        exraystr.wxstal(i).R0=double(temp)
     endfor
  endif

  ;crystal boundaries (Beta_min and Beta_max)
  if strpos(line,'crystal boundary') ne -1 then begin
     for i=0,numxstals-1 do begin
        readf,u,temp1,temp2
        exraystr.wxstal(i).betamin=double(temp1)*!pi/180.
        exraystr.wxstal(i).betamax=double(temp2)*!pi/180.
     endfor
  endif

  ;number of sources
  if strpos(line,'number of source') ne -1 then begin
      readf,u,temp
      numsource=long(temp)
  endif

  ;source positions (a,b)
  if strpos(line,'source position') ne -1 then begin
     for i=0,numsource-1 do begin
        readf,u,temp1,temp2
        if (exraystr.convexflag ne 1) then begin
           if (abs(temp1) eq exraystr.wxstal(0).R0) and (abs(temp2) eq 0.) then begin
              widget_control,exraystr.widget.AtFocus,SET_BUTTON=1
              exraystr.sorset(0)=1
              exraystr.wsource(0).a=double(temp1)
              exraystr.wsource(0).b=double(temp2)
           endif else begin
              widget_control,exraystr.widget.AtXY,SET_BUTTON=1
              exraystr.sorset(i+1)=1
              exraystr.wsource(i+1).a=double(temp1)
              exraystr.wsource(i+1).b=double(temp2)
           endelse
        endif else begin
           if ((temp1 eq -640.) and (temp2 eq 1.)) then begin
              widget_control,exraystr.widget.defaultc,SET_BUTTON=1
              exraystr.sorset(0)=1
              exraystr.wsource(0).a=double(temp1)
              exraystr.wsource(0).b=double(temp2)
           endif else begin
              widget_control,exraystr.widget.AtXYc,SET_BUTTON=1
              exraystr.sorset(i+1)=1
              exraystr.wsource(i+1).a=double(temp1)
              exraystr.wsource(i+1).b=double(temp2)
           endelse
        endelse
     endfor
  endif

  ;source wavelengths (lambda) and orders
  if strpos(line,'start wavelength') ne -1 then begin
    exraystr.lamset(count)=1
      if (count eq 0) then begin
        if (exraystr.convexflag ne 1) then begin
          widget_control,exraystr.widget.lambda1,SET_BUTTON=1
          widget_control,exraystr.widget.beta1,SET_BUTTON=0
        endif else begin
          widget_control,exraystr.widget.lambda1c,SET_BUTTON=1
          widget_control,exraystr.widget.beta1c,SET_BUTTON=0
        endelse
      endif
    readf,u,line
    point_lun,-u,place
    readf,u,line
    ;which sources contain these wavelengths
    i=0
    j=0
    while (i ne -1) do begin
        i=strpos(line,',',i)
        if (i ne -1) then begin
           j = j+1
           i = i+1
        endif
    endwhile
    sourcearr=lonarr(j+1)
    point_lun,u,place
    readf,u,sourcearr
    readf,u,line

    ;get the order numbers
    readf,u,temp
    for i=0,j do begin
      exraystr.wsource(*).n(count)=long(temp)
    endfor

    readf,u,line
    if strpos(line,'series') ne -1 then begin
      exraystr.serset(count)=1
      if (count eq 0) then begin
        if (exraystr.convexflag ne 1) then begin
          widget_control,exraystr.widget.series1,SET_BUTTON=1
          widget_control,exraystr.widget.specific1,SET_BUTTON=0
        endif else begin
          widget_control,exraystr.widget.series1c,SET_BUTTON=1
          widget_control,exraystr.widget.specific1c,SET_BUTTON=0
        endelse
      endif
      readf,u,v1
      readf,u,v2
      readf,u,v3
      exraystr.wsource(*).lambda(count,0)=double(v1)
      exraystr.wsource(*).lambda(count,1)=double(v2)
      exraystr.wsource(*).lambda(count,2)=double(v3)
    endif else begin
      exraystr.serset(count)=0
      if (count eq 0) then begin
        if (exraystr.convexflag ne 1) then begin
          widget_control,exraystr.widget.series1,SET_BUTTON=0
          widget_control,exraystr.widget.specific1,SET_BUTTON=1
        endif else begin
          widget_control,exraystr.widget.series1c,SET_BUTTON=0
          widget_control,exraystr.widget.specific1c,SET_BUTTON=1
        endelse
      endif
      d=strpos(line,'=')
      sized=float(strmid(line,d+1,strlen(line)-d))
      for i=0,sized-1 do begin
        readf,u,temp
        exraystr.wsource(*).lambda(count,i)=double(temp)
      endfor
    endelse

    count=count+1
    exraystr.groupOK = 1
  endif


  ;xstal betas and orders
  if strpos(line,'start beta') ne -1 then begin
    exraystr.lamset(count)=0
      if (count eq 0) then begin
        if (exraystr.convexflag ne 1) then begin
          widget_control,exraystr.widget.lambda1,SET_BUTTON=0
          widget_control,exraystr.widget.beta1,SET_BUTTON=1
        endif else begin
          widget_control,exraystr.widget.lambda1c,SET_BUTTON=0
          widget_control,exraystr.widget.beta1c,SET_BUTTON=1
        endelse
      endif
    readf,u,line
    point_lun,-u,place
    readf,u,line
    ;which xstals considered for these betas
    i=0
    j=0
    while (i ne -1) do begin
        i=strpos(line,',',i)
        if (i ne -1) then begin
           j = j+1
           i = i+1
        endif
    endwhile
    xstalarr=lonarr(j+1)
    point_lun,u,place
    readf,u,xstalarr
    readf,u,line

    ;get the order numbers
    readf,u,temp
    for i=0,numsource-1 do begin
      exraystr.wsource(i).n(count)=long(temp)
    endfor

    readf,u,line
    if strpos(line,'series') ne -1 then begin
      exraystr.serset(count)=1
      if (count eq 0) then begin
        if (exraystr.convexflag ne 1) then begin
          widget_control,exraystr.widget.series1,SET_BUTTON=1
          widget_control,exraystr.widget.specific1,SET_BUTTON=0
        endif else begin
          widget_control,exraystr.widget.series1c,SET_BUTTON=1
          widget_control,exraystr.widget.specific1c,SET_BUTTON=0
        endelse
      endif
      readf,u,v1
      readf,u,v2
      readf,u,v3
      exraystr.wxstal(*).beta(count,0)=double(v1)
      exraystr.wxstal(*).beta(count,1)=double(v2)
      exraystr.wxstal(*).beta(count,2)=double(v3)
    endif else begin
      exraystr.serset(count)=0
      if (count eq 0) then begin
        if (exraystr.convexflag ne 1) then begin
          widget_control,exraystr.widget.series1,SET_BUTTON=0
          widget_control,exraystr.widget.specific1,SET_BUTTON=1
        endif else begin
          widget_control,exraystr.widget.series1c,SET_BUTTON=0
          widget_control,exraystr.widget.specific1c,SET_BUTTON=1
        endelse
      endif
      d=strpos(line,'=')
      sized=float(strmid(line,d+1,strlen(line)-d))
      for i=0,sized-1 do begin
        readf,u,temp
        exraystr.wxstal(*).beta(count,i)=double(temp)*!pi/180.
      endfor
    endelse

    count=count+1
    exraystr.groupOK = 1
  endif


  ;detector length (L)
  if strpos(line,'length of detector') ne -1 then begin
     readf,u,temp
     exraystr.wfilm.L=double(temp)
  endif

  ;detector positioning (rf,phi)
  if strpos(line,'detector position') ne -1 then begin
        point_lun,-u,place
        readf,u,line
        if strpos(line,'Johann line') ne -1 then begin
           widget_control,exraystr.widget.JLine,SET_BUTTON=1
           widget_control,exraystr.widget.JLocus,SET_BUTTON=0
           widget_control,exraystr.widget.Fspecific,SET_BUTTON=0
           ;the user has asked for a line detector located at
           ; the Johann crossover at beta_avg
           exraystr.wfilm.JFlag=1 ;a flag to signal a Johann line detector is desired
           exraystr.filmOK = 1
           if strpos(line,'beta =') ne -1 then begin
             ;the user has specified a beta_avg to use as the film rotation angle
              hold=strpos(line,'=')
              beta_avg=double(strmid(line,hold+1,strlen(line)-hold))*!pi/180.
           endif else if strpos(line,'theta =') ne -1 then begin
             ;the user has specified a theta to use as the mean ray
              hold=strpos(line,'=')
              theta_avg=double(strmid(line,hold+1,strlen(line)-hold))*!pi/180.
           endif
        endif else if strpos(line,'Johann locus') ne -1 then begin
           widget_control,exraystr.widget.JLine,SET_BUTTON=0
           widget_control,exraystr.widget.JLocus,SET_BUTTON=1
           widget_control,exraystr.widget.Fspecific,SET_BUTTON=0
           ;the user has asked for the detector to be the locus of
           ; points at each lambda's johann crossover point.
           ; Set rf to be -1. as a flag for future consideration.
           exraystr.wfilm.JFlag=2 ;a flag to signal a Johann locus detector is desired
           exraystr.wfilm.rf=-1.
           ;set phi to the global average beta + pi
           exraystr.wfilm.phi=(max(exraystr.wxstal(*).betamax)+min(exraystr.wxstal(*).betamin))/2.+!pi
           exraystr.filmOK = 1
        endif else if strpos(line,'circle detector') ne -1 then begin
              exraystr.wfilm.circleflag=1
              widget_control,exraystr.widget.circlec,SET_BUTTON=1
              widget_control,exraystr.widget.linec,SET_BUTTON=0
              hold=strpos(line,'=')
              rf=double(strmid(line,hold+1,strlen(line)-hold))
              exraystr.wfilm.rf=rf
              if rf gt 0 then $
                 exraystr.filmOK = 1
        endif else begin
           if (exraystr.convexflag ne 1) then begin
              widget_control,exraystr.widget.JLine,SET_BUTTON=0
              widget_control,exraystr.widget.JLocus,SET_BUTTON=0
              widget_control,exraystr.widget.Fspecific,SET_BUTTON=1
              exraystr.wfilm.JFlag=0 ;a flag to signal a detector position is specified
              point_lun,u,place
              readf,u,temp1,temp2
              exraystr.wfilm.rf=double(temp1)
              exraystr.wfilm.phi=double(temp2)*!pi/180.
              exraystr.filmOK = 1
           endif else begin
              point_lun,u,place
              readf,u,temp1,temp2
              exraystr.wfilm.rf=double(temp1)
              exraystr.wfilm.phi=double(temp2)*!pi/180.-exraystr.wxstal(0).chi
              widget_control,exraystr.widget.linec,SET_BUTTON=1
              widget_control,exraystr.widget.circlec,SET_BUTTON=0
              exraystr.filmOK = 1
           endelse
        endelse
  endif


  ;detector rotation from normal (mu-phi+90)
  if strpos(line,'detector rotation') ne -1 then begin
        readf,u,temp
        if (exraystr.convexflag ne 1) then $
           exraystr.wfilm.mu=(temp+exraystr.wfilm.phi*180./!pi-90.)*!pi/180.$
        else $
           exraystr.wfilm.mu=!pi/2.-exraystr.wfilm.phi+double(temp)*!pi/180.
  endif

  ;film type, tension, and fogging
  if strpos(line,'film type') ne -1 then begin
        readf,u,temp1,temp2,temp3,temp4
        exraystr.wfilm.filmtype=temp1
        exraystr.wfilm.tension=temp2
        exraystr.wfilm.interpolflag=temp3
        exraystr.wfilm.fog=temp4
        if (exraystr.wfilm.fog lt 0) then begin
           ;fog is a vector read in from a file
           exraystr.wfilm.fog=0.
           exraystr.wfilm.fogflag=1
           temp=''
           readf,u,temp
           exraystr.wfilm.fogfile=temp
        endif
  endif

  ;detector filtering
  if strpos(line,'detector filter') ne -1 then begin
     exraystr.wfilm.filtflag = 1
     for i=0,2 do begin
        readf,u,temp1,temp2
        exraystr.wfilm.filter(i)=temp1
        exraystr.wfilm.filtwidth(i)=temp2
     endfor
  endif

  ;MCP photocathode
  if strpos(line,'photocathode') ne -1 then begin
     exraystr.wfilm.mcpflag = 1
     readf,u,temp1
     exraystr.wfilm.photocath=temp1
  endif

  ;crystal reflectivity
  if strpos(line,'reflectivity') ne -1 then begin
     exraystr.wfilm.xstalflag = 1
     readf,u,temp1,temp2
     exraystr.wfilm.refflag=temp1
     exraystr.wfilm.units=temp2
  endif

  ;spectrometer solid angle values
  if strpos(line,'slit width') ne -1 then begin
     exraystr.wfilm.geoflag = 1
     readf,u,temp1,temp2,temp3
     exraystr.wfilm.slit=temp1
     exraystr.wfilm.lineout=temp2
     exraystr.wfilm.mag=temp3
  endif

  ;TREX LOS flag
  if strpos(line,'LOS flag') ne -1 then begin
     readf,u,temp1
     exraystr.LOSflag=temp1
  endif

  ;TREX origin location
  if strpos(line,'origin location') ne -1 then begin
     readf,u,temp1
     exraystr.wLOS=temp1
  endif

  ;TREX crystal rotation past average beta
  if strpos(line,'past average beta') ne -1 then begin
     readf,u,temp1
     exraystr.wrot=temp1*!pi/180.
  endif

;************************************************************************
; Begin reading convex specific stuff...
;************************************************************************
  ;crystal radius (rc)
  if strpos(line,'crystal radius') ne -1 then begin
     for i=0,numxstals-1 do begin
        readf,u,temp
        exraystr.wxstal(i).rc=double(temp)*2.54
        widget_control,exraystr.widget.radiusc,set_value=temp
     endfor
  endif

  if strpos(line,'crystal rotation') ne -1 then begin
     for i=0,numxstals-1 do begin
        readf,u,temp
        exraystr.wxstal(i).chi=double(temp)*!pi/180.
        widget_control,exraystr.widget.rotationc,set_value=temp
     endfor
  endif

  if strpos(line,'lattice rotation') ne -1 then begin
     for i=0,numxstals-1 do begin
        readf,u,temp
        exraystr.wxstal(i).p=double(temp)*!pi/180.
     endfor
  endif

endwhile

close,u
free_lun,u


;************************************************************
; Save the values into the widget variables
;************************************************************
if (exraystr.convexflag ne 1) then begin
   for i=0,numxstals-1 do $
      if ((exraystr.wxstal(i).h le 0.) or (exraystr.wxstal(i).R0 le 0.) $
         or (exraystr.wxstal(i).twod le 0.)) then exraystr.xstalset(i) = 0 $
      else exraystr.xstalset(i) = 1
   ;determine the configuration and the xstal
   exray_getconfig,exraystr
   widget_control,exraystr.widget.order1,SET_VALUE=[exraystr.wsource(0).n(0)]
endif else begin
   for i=0,numxstals-1 do $
      if ((exraystr.wxstal(i).rc le 0.) $
         or (exraystr.wxstal(i).twod le 0.)) then exraystr.xstalset(i) = 0 $
      else exraystr.xstalset(i) = 1
   ;determine the wedge angle and the xstal
   exray_getconfig,exraystr
   widget_control,exraystr.widget.order1c,SET_VALUE=[exraystr.wsource(0).n(0)]
endelse
widget_control,MainWidget,SET_UVALUE=exraystr


CATCH,/CANCEL
RETURN
END
