PRO EXRAY_SPECTROBACK,wdf1,xpoints,degree=degr,plotz=plotz,noprint=noprint,$
                yrange=yrang,fit3=fit3

;*****************************************************************
;* This program takes the wdf1 array, cuts out the abscissa      *
;* values between xpoints(1) and xpoints(2), chops of the        *
;* abscissa values below xpoints(0) and above xpoints(3), then   *
;* does a linear fit to what is left, divides the ordinate       *
;* of wdf1 by the ordinate of the fit, and returns the result    *
;* back into wdf1.                                               *
;* This is valuable for determining the absolute transmission of *
;* of a spectrum with respect to the continuum background.       *
;*****************************************************************

w2i,x1,y1,wdf1

if n_elements(yrang) eq 0 then begin
   ymin = 0.
   ymax = 1.2
endif else begin
   ymin=yrang(0)
   ymax=yrang(1)
endelse

index=where(((x1 ge xpoints(0)) and (x1 le xpoints(1))) $
              or   ((x1 ge xpoints(2)) and (x1 le xpoints(3))))
xnew=dblarr(n_elements(index))
ynew=dblarr(n_elements(index))
xnew=x1(index)
ynew=y1(index)

;fit=poly_fit(xnew,ynew,1)
;yback=fit(0)+fit(1)*x1
;ytrans=y1/yback

i2w,xnew,ynew,50,/xy
if keyword_set(fit3) then begin
   exray_wdfit3,50,51,/Exact_Range
endif else $
   wdfit,50,51,degree=degr,quiet=noprint
lim,wdf1,xnew(1),xnew(n_elements(index)-1)
w2i,xback,yback,51
;w2i,x1,y1,wdf1
yback=interpol(yback,xback,x1)
ytrans=y1/yback
i2w,x1,ytrans,wdf1,/xy

if keyword_set(plotz) then begin
   plo,wdf1,line=0,psym=0,col=0,leg=-1,yran=[ymin,ymax]
   oplot,x1,yback,col=1
   oplot,x1,y1,col=3
   legendp,['Input','Fit','Result'],col=[3,1,0],line=[0,0,0],pos=[x1(0),0.2]
endif

;i2w,x1,ytrans,wdf1,/xy

return
end
