PRO Exray_TransCalc, groundconfig,groundterm,groundenergy, $ 
                 lowerconfigs, lowerterms, lowerenergy, $ 
                 upperconfig, upperterm, upperenergy,$ 
                 count,atm 
 
numtrans=count
;split up the config terms 
uppersplit=strsplit(upperconfig,'()',/Extract) 
;levels are in even indices, #electrons in a level are in odd indices 
 
;******************first the ground -> upper transition************************* 
parityOK=0 ;flag to say if the parity rule is satisified 
deOK=0 ;flag to say if only one electron has moved 
dsOK=0 ;under LS coupling, flag to say if delta-s rule is satisfied 
dlOK=1 ;under LS coupling, flag to say if delta-l rule is satisfied 
 
groundsplit=strsplit(groundconfig,'()',/Extract) 
 
;check to see if only one electron has moved (single electron transitions only) 
sum=0 
for i=0,n_elements(groundsplit)/2-1 do begin 
   index=where(uppersplit eq groundsplit(2*i)) 
   if (index(0) lt 0) then $ ;the upper level doesn't contain this nl 
      sum=sum+long(groundsplit(2*i+1)) $ 
   else $ ;the upper level does contain this nl 
      sum=sum+abs(long(uppersplit(index(0)+1))-long(groundsplit(2*i+1))) 
endfor 
for i=0,n_elements(uppersplit)/2-1 do begin 
   index=where(groundsplit eq uppersplit(2*i)) 
   if (index(0) lt 0) then $ ;the ground level doesn't contain this nl 
      sum=sum+long(uppersplit(2*i+1)) 
endfor 
if (sum eq 2) then begin 
   deOK = 1 ;only 1 electron has made a transition 
   ; check if parity rule is satisfied (parity must change) 
   index=where(strmatch(groundsplit,'*[sdgi]') eq 1) 
   if (index(0) ge 0) then $ 
      numevenlow=long(total(long(groundsplit(index+1)))) $ 
   else numevenlow=0 
   index=where(strmatch(groundsplit,'*[pfhj]') eq 1) 
   if (index(0) ge 0) then $ 
      numoddlow=long(total(long(groundsplit(index+1)))) $ 
   else numoddlow=0 
   index=where(strmatch(uppersplit,'*[sdgi]') eq 1) 
   if (index(0) ge 0) then $ 
      numevenup=long(total(long(uppersplit(index+1)))) $ 
   else numevenup=0 
   index=where(strmatch(uppersplit,'*[pfhj]') eq 1) 
   if (index(0) ge 0) then $ 
      numoddup=long(total(long(uppersplit(index+1)))) $ 
   else numoddup=0 
   if (abs(numevenlow-numevenup) eq 1) and (abs(numoddlow-numoddup) eq 1) then $ 
      parityOK = 1 
endif 
 
;calculate L-S coupling 
   ;calculate ds 
   slow=(long(groundterm)-1)/2. 
   sup=(long(upperterm)-1)/2. 
   if (abs(slow-sup) eq 0.0) then dsOK = 1 ;satisfies delta-s rule (ds=0) 
   ;calculate dl (dl=(+-1,0) but not 0->0) 
   lowl=strsplit(groundterm,strtrim(string(long(groundterm)),2),/extract) 
   upl=strsplit(upperterm,strtrim(string(long(upperterm)),2),/extract) 
   if (lowl eq 'S') then $ 
      if (upl eq 'P') then dlOK = 1 $ 
   else if (lowl eq 'P') then $ 
      if ((upl eq 'S')or(upl eq 'P')or(upl eq 'D')) then dlOK = 1 $ 
   else if (lowl eq 'D') then $ 
      if ((upl eq 'P')or(upl eq 'D')or(upl eq 'F')) then dlOK = 1 $ 
   else if (lowl eq 'F') then $ 
      if ((upl eq 'D')or(upl eq 'F')or(upl eq 'G')) then dlOK = 1 $ 
   else if (lowl eq 'G') then $ 
      if ((upl eq 'F')or(upl eq 'G')or(upl eq 'H')) then dlOK = 1 $ 
   else if (lowl eq 'H') then $ 
      if ((upl eq 'G')or(upl eq 'H')or(upl eq 'I')) then dlOK = 1 $ 
   else dlOK = 0 ;LS coupling won't work here anyway 
 
;if all rules check out, then return the transition 
if (deOK eq 1) and (parityOK eq 1)  then begin 
   atm.config(numtrans)=groundconfig+'-'+upperconfig
   atm.term(numtrans)=groundterm+'-'+upperterm
   atm.lambda(numtrans)=12398.53/abs(groundenergy-upperenergy) 
   atm.configE(numtrans)='(0.000 eV)-('+strtrim(string(abs(groundenergy-upperenergy),$ 
                                             format='(F8.3)'),2)+' eV) 
   if (dsOK eq 1) and (dlOK eq 1) then atm.LS(numtrans)=1 
   numtrans=numtrans+1 
endif 
 
;******************Now the exited lower -> upper transitions************************* 
 
index=where(lowerconfigs ne '') 
if (index(0) ge 0) then begin 
for j=0,n_elements(index)-1 do begin 
   parityOK=0 ;flag to say if the parity rule is satisified 
   deOK=0 ;flag to say if only one electron has moved 
   dsOK=0 ;under LS coupling, flag to say if delta-s rule is satisfied 
   dlOK=1 ;under LS coupling, flag to say if delta-l rule is satisfied 
 
   lowersplit=strsplit(lowerconfigs(j),'()',/Extract) 
 
   ;check to see if only one electron has moved (single electron transitions only) 
   sum=0 
   for i=0,n_elements(lowersplit)/2-1 do begin 
      index=where(uppersplit eq lowersplit(2*i)) 
      if (index(0) lt 0) then $ ;the upper level doesn't contain this nl 
         sum=sum+long(lowersplit(2*i+1)) $ 
      else $ ;the upper level does contain this nl 
         sum=sum+abs(long(uppersplit(index(0)+1))-long(lowersplit(2*i+1))) 
   endfor 
   for i=0,n_elements(uppersplit)/2-1 do begin 
      index=where(lowersplit eq uppersplit(2*i)) 
      if (index(0) lt 0) then $ ;the ground level doesn't contain this nl 
         sum=sum+long(uppersplit(2*i+1)) 
   endfor 
   if (sum eq 2) then begin 
      deOK = 1 ;only 1 electron has made a transition 
      ; check if parity rule is satisfied (parity must change) 
      index=where(strmatch(lowersplit,'*[sdgi]') eq 1) 
      if (index(0) ge 0) then $ 
         numevenlow=long(total(long(lowersplit(index+1)))) $ 
      else numevenlow=0 
      index=where(strmatch(lowersplit,'*[pfhj]') eq 1) 
      if (index(0) ge 0) then $ 
         numoddlow=long(total(long(lowersplit(index+1)))) $ 
      else numoddlow=0 
      index=where(strmatch(uppersplit,'*[sdgi]') eq 1) 
      if (index(0) ge 0) then $ 
         numevenup=long(total(long(uppersplit(index+1)))) $ 
      else numevenup=0 
      index=where(strmatch(uppersplit,'*[pfhj]') eq 1) 
      if (index(0) ge 0) then $ 
         numoddup=long(total(long(uppersplit(index+1)))) $ 
      else numoddup=0 
      if (abs(numevenlow-numevenup) eq 1) and (abs(numoddlow-numoddup) eq 1) then $ 
         parityOK = 1 
   endif 
 
   ;calculate L-S coupling 
      ;calculate ds 
      slow=(long(lowerterms(j))-1)/2. 
      sup=(long(upperterm)-1)/2. 
      if (abs(slow-sup) eq 0.0) then dsOK = 1 ;satisfies delta-s rule (ds=0) 
      ;calculate dl (dl=(+-1,0) but not 0->0) 
      lowl=strsplit(lowerterms(j),strtrim(string(long(lowerterms(j))),2),/extract) 
      upl=strsplit(upperterm,strtrim(string(long(upperterm)),2),/extract) 
      if (lowl eq 'S') then $ 
         if (upl eq 'P') then dlOK = 1 $ 
      else if (lowl eq 'P') then $ 
         if ((upl eq 'S')or(upl eq 'P')or(upl eq 'D')) then dlOK = 1 $ 
      else if (lowl eq 'D') then $ 
         if ((upl eq 'P')or(upl eq 'D')or(upl eq 'F')) then dlOK = 1 $ 
      else if (lowl eq 'F') then $ 
         if ((upl eq 'D')or(upl eq 'F')or(upl eq 'G')) then dlOK = 1 $ 
      else if (lowl eq 'G') then $ 
         if ((upl eq 'F')or(upl eq 'G')or(upl eq 'H')) then dlOK = 1 $ 
      else if (lowl eq 'H') then $ 
         if ((upl eq 'G')or(upl eq 'H')or(upl eq 'I')) then dlOK = 1 $ 
      else dlOK = 0 ;LS coupling won't work here anyway 
 
    ;if all rules check out, then return the transition 
   if (deOK eq 1) and (parityOK eq 1)  then begin 
      atm.config(numtrans)=lowerconfigs(j)+'-'+upperconfig 
      atm.term(numtrans)=lowerterms(j)+'-'+upperterm 
      atm.lambda(numtrans)=12398.53/abs(lowerenergy(j)-upperenergy) 
      atm.configE(numtrans)='('+ strtrim(string(abs(lowerenergy(j)-groundenergy),$ 
          format='(F8.3)'),2)+' eV)-('+strtrim(string(abs(lowerenergy(j)-upperenergy),$ 
          format='(F8.3)'),2)+' eV) 
      if (dsOK eq 1) and (dlOK eq 1) then atm.LS(numtrans)=1 
      numtrans=numtrans+1 
   endif 
endfor 
endif 
 

;**********************now, figure out the ion state of the atom*************************** 
if ((numtrans-count) ne 0) then begin
   index=where(strmatch(groundsplit,'*[sdgi]') eq 1) 
   if (index(0) ge 0) then $ 
      numevenlow=long(total(long(groundsplit(index+1)))) $ 
   else numevenlow=0 
   index=where(strmatch(groundsplit,'*[pfhj]') eq 1) 
   if (index(0) ge 0) then $ 
      numoddlow=long(total(long(groundsplit(index+1)))) $ 
   else numoddlow=0 


   case numevenlow+numoddlow of ;the total number of electrons 
     1: atm.ion(count:numtrans-1)='H-Like' 
     2: atm.ion(count:numtrans-1)='He-Like' 
     3: atm.ion(count:numtrans-1)='Li-Like' 
     4: atm.ion(count:numtrans-1)='Be-Like'
     5: atm.ion(count:numtrans-1)='B-Like' 
     6: atm.ion(count:numtrans-1)='C-Like' 
     7: atm.ion(count:numtrans-1)='N-Like' 
     8: atm.ion(count:numtrans-1)='O-Like' 
     9: atm.ion(count:numtrans-1)='F-Like' 
     10: atm.ion(count:numtrans-1)='Ne-Like' 
     11: atm.ion(count:numtrans-1)='Na-Like' 
     12: atm.ion(count:numtrans-1)='Mg-Like' 
     13: atm.ion(count:numtrans-1)='Al-Like' 
     14: atm.ion(count:numtrans-1)='Si-Like' 
     15: atm.ion(count:numtrans-1)='P-Like' 
     16: atm.ion(count:numtrans-1)='S-Like' 
     17: atm.ion(count:numtrans-1)='Cl-Like' 
     18: atm.ion(count:numtrans-1)='Ar-Like' 
   else: atm.ion(count:numtrans-1)='Z* = '+strtrim(string(numevenlow+numoddlow),2) 
   endcase 
endif
  
;return the index of the next transition
count=numtrans

return 
end