PRO Exray_Transitions, element, projpath

if (!Version.OS_FAMILY eq 'MacOS') then begin
   ;the Mac has a different way of defining paths... so set some values
   sepchar=':'
endif else begin
   sepchar='/'
endelse

maxtrans=100
numelements=5
Al = 0
Si = 1
Ar = 2
;****************define the structures to be used**********************8
Ly = {NAME: 'Ly Series',$
      num:long(0),$ ;the number of defined transitions
      config:strarr(maxtrans),$ ;the transition configurations
      term:strarr(maxtrans),$ ;the transition terms
      jj:strarr(maxtrans),$ ;the j of the transition levels
      lambda:dblarr(maxtrans)} ;the wavelength of the transitions

He = {NAME: 'He Series',$
      num:long(0),$ ;the number of defined transitions
      config:strarr(maxtrans),$ ;the transition configurations
      term:strarr(maxtrans),$ ;the transition terms
      jj:strarr(maxtrans),$ ;the j of the transition levels
      lambda:dblarr(maxtrans)} ;the wavelength of the transitions

Li = {NAME: 'Li Series',$
      num:long(0),$ ;the number of defined transitions
      config:strarr(maxtrans),$ ;the transition configurations
      term:strarr(maxtrans),$ ;the transition terms
      jj:strarr(maxtrans),$ ;the j of the transition levels
      lambda:dblarr(maxtrans)} ;the wavelength of the transitions

ATM = {NAME: 'SPECT3D Calculated Transitions',$
      num:long(0),$ ;the number of defined transitions
      atmfile:'none',$ ;the filename for the ATM file
      config:strarr(maxtrans),$ ;the transition configurations
      configE:strarr(maxtrans),$ ;the energies of the configurations (w/ respect to ground)
      term:strarr(maxtrans),$ ;the transition terms
      jj:strarr(maxtrans),$ ;the j of the transition levels
      lambda:dblarr(maxtrans),$ ;the wavelength of the transitions
      ion:strarr(maxtrans),$ ;the ion-state of the atom
      LSFlag:long(0),$ ;flag to say if L-S transition rules apply
      LS:lonarr(maxtrans),$ ;flags which say where L-S coupling is satisfied
      cutoff:double(300.)} ;the lower-level cut-off energy for transitions


element = {NAME: 'Known/Calculated Atomic Transitions',$
           numelements:numelements,$ ;the number of defined elements
           symbol:string(''),$ ;the atomic symbol of the element
           Ly:Ly,$ ;Lymann series
           He:He,$ ;Helium-like series
           Li:Li,$ ;Lithium-like series
           ATM:ATM} ;ATBASE Calculated enegy levels from a .atm file

element=replicate(element,numelements)

;*********** Aluminum **************
element(Al).symbol='Al'

;First the Ly series
fname=projpath+'atomic_data'+sepchar+'Al_Ly.txt'
openr,u,fname,/get
line=''
count=0
readf,u,line
while(not eof(u)) do begin
  readf,u,line
  temp=strsplit(line,', ',/EXTRACT)
  element(Al).Ly.config(count)=temp(0)
  element(Al).Ly.term(count)=temp(1)
  element(Al).Ly.jj(count)=temp(2)
  element(Al).Ly.lambda(count)=double(temp(3))
  count=count+1
endwhile
element(Al).Ly.num=count
close,u
free_lun,u

;Second the He series
fname=projpath+'atomic_data'+sepchar+'Al_He.txt'
openr,u,fname,/get
line=''
count=0
readf,u,line
while(not eof(u)) do begin
  readf,u,line
  temp=strsplit(line,', ',/EXTRACT)
  element(Al).He.config(count)=temp(0)
  element(Al).He.term(count)=temp(1)
  element(Al).He.jj(count)=temp(2)
  element(Al).He.lambda(count)=double(temp(3))
  count=count+1
endwhile
element(Al).He.num=count
close,u

free_lun,u

;*********** Silicon **************
element(Si).symbol='Si'

;First the Ly series
fname=projpath+'atomic_data'+sepchar+'Si_Ly.txt'
openr,u,fname,/get
line=''
count=0
readf,u,line
while(not eof(u)) do begin
  readf,u,line
  temp=strsplit(line,', ',/EXTRACT)
  element(Si).Ly.config(count)=temp(0)
  element(Si).Ly.term(count)=temp(1)
  element(Si).Ly.jj(count)=temp(2)
  element(Si).Ly.lambda(count)=double(temp(3))
  count=count+1
endwhile
element(Si).Ly.num=count
close,u
free_lun,u

;Second the He series
fname=projpath+'atomic_data'+sepchar+'Si_He.txt'
openr,u,fname,/get
line=''
count=0
readf,u,line
while(not eof(u)) do begin
  readf,u,line
  temp=strsplit(line,', ',/EXTRACT)
  element(Si).He.config(count)=temp(0)
  element(Si).He.term(count)=temp(1)
  element(Si).He.jj(count)=temp(2)
  element(Si).He.lambda(count)=double(temp(3))
  count=count+1
endwhile
element(Si).He.num=count
close,u

free_lun,u

;*********** Argon **************
element(Ar).symbol='Ar'

;First the Ly series
fname=projpath+'atomic_data'+sepchar+'Ar_Ly.txt'
openr,u,fname,/get
line=''
count=0
readf,u,line
while(not eof(u)) do begin
  readf,u,line
  temp=strsplit(line,', ',/EXTRACT)
  element(Ar).Ly.config(count)=temp(0)
  element(Ar).Ly.term(count)=temp(1)
  element(Ar).Ly.jj(count)=temp(2)
  element(Ar).Ly.lambda(count)=double(temp(3))
  count=count+1
endwhile
element(Ar).Ly.num=count
close,u
free_lun,u

;Second the He series
fname=projpath+'atomic_data'+sepchar+'Ar_He.txt'
openr,u,fname,/get
line=''
count=0
readf,u,line
while(not eof(u)) do begin
  readf,u,line
  temp=strsplit(line,', ',/EXTRACT)
  element(Ar).He.config(count)=temp(0)
  element(Ar).He.term(count)=temp(1)
  element(Ar).He.jj(count)=temp(2)
  element(Ar).He.lambda(count)=double(temp(3))
  count=count+1
endwhile
element(Ar).He.num=count
close,u

free_lun,u

return
end