

pro Exray_Film_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = filmstr

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='Calc_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           filmstr.jsflag = 1
           widget_control,filmstr.filelabel,sensitive=1
           widget_control,filmstr.filebase,sensitive=1
        endif else begin
           filmstr.jsflag = 0
           widget_control,filmstr.filelabel,sensitive=0
           widget_control,filmstr.filebase,sensitive=0
        endelse
     endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='File_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           filmstr.jsflag = 0
           widget_control,filmstr.filelabel,sensitive=0
           widget_control,filmstr.filebase,sensitive=0
        endif else begin
           filmstr.jsflag = 1
           widget_control,filmstr.filelabel,sensitive=1
           widget_control,filmstr.filebase,sensitive=1
        endelse
     endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Open_FilmFile_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        nametemp = ''
        path=''
        nametemp = dialog_pickfile(/must_exist,title='Select the Johann Filmplane File', $
                           path=filmstr.exraystr.path,get_path=path,filter='*.ufo')
        if (nametemp ne '') then begin
           filmstr.filmfile=nametemp
           widget_control,filmstr.filename,SET_VALUE=filmstr.filmfile
        endif
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Quit_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
      if (filmstr.exraystr.wfilm.JFlag lt 2) then begin
        tmp=double(0.)
           widget_control,filmstr.rfwidget,get_value=tmp
           if tmp gt 0. then begin
              ;If the group actually contains data, then save the values
              filmstr.exraystr.wfilm.rf=tmp
           endif
           widget_control,filmstr.phiwidget,get_value=tmp
           filmstr.exraystr.wfilm.phi=tmp*!pi/180.
           widget_control,filmstr.muwidget,get_value=tmp
           filmstr.exraystr.wfilm.mu = tmp*!pi/180.+filmstr.exraystr.wfilm.phi-!pi/2.
           widget_control,filmstr.Lwidget,get_value=tmp
           if tmp gt 0. then begin
              ;If the group actually contains data, then save the values
              filmstr.exraystr.wfilm.L = tmp
           endif
           ;run a check to see if valid film parameters are set
           if (filmstr.exraystr.wfilm.JFlag eq 2) then filmstr.exraystr.filmOK = 1 $
           else if (filmstr.exraystr.wfilm.JFlag eq 1) then begin
              if (filmstr.exraystr.wfilm.L ne 0.) then filmstr.exraystr.filmOK = 1
           endif else begin
              if (filmstr.exraystr.wfilm.rf ne 0.) and (filmstr.exraystr.wfilm.phi ne 0.) $
                 and (filmstr.exraystr.wfilm.L ne 0.) then filmstr.exraystr.filmOK = 1
           endelse
      endif else if (filmstr.exraystr.wfilm.JFlag eq 3) then begin
           widget_control,filmstr.rfwidget,get_value=tmp
           if tmp gt 0. then begin
              ;If the group actually contains data, then save the values
              filmstr.exraystr.wfilm.rf=tmp
           endif
      endif else begin
           filmstr.exraystr.wfilm.jsflag=filmstr.jsflag
           filmstr.exraystr.wfilm.filmfile=filmstr.filmfile
      endelse
        Widget_Control, filmstr.MainWidget, set_uvalue = filmstr.exraystr
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;quit without saving anything
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = filmstr


end

pro Exray_Film_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control, MainWidget, get_uvalue = exraystr
  mxy=exraystr.mxy

  numlambda=exraystr.wnumlambda

  Exray_Film_BASE = Widget_Base( GROUP_LEADER=wGroup, COLUMN=1, $
      UNAME='Exray_Film_BASE' ,XOFFSET=5 ,YOFFSET=5, /BASE_Align_Right $
      ,TITLE='Film Parameters' ,SPACE=3 ,XPAD=3 ,YPAD=3)

  Film_LABEL = Widget_Label(Exray_Film_BASE,  $
      UNAME='Film_LABEL',/ALIGN_LEFT,VALUE='')


;***********************************************************************************


if (exraystr.wfilm.JFlag lt 2) then begin

  if (exraystr.wfilm.JFlag eq 1) then begin

     Rf_Field = CW_Field(Exray_Film_BASE,UNAME='Rf_FIELD' $
                        ,Title='Detector Radius (cm) = ',/Return_Events,/float $
                        ,xsize=exraystr.formats.fieldsize,Value=[exraystr.wfilm.rf])

     Phi_Field = CW_Field(Exray_Film_BASE,UNAME='Phi_FIELD' $
                        ,Title='Detector Position (deg) = ',/Return_Events,/float $
                        ,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wfilm.phi*180./!pi])

  endif else begin
     Rf_Field = CW_Field(Exray_Film_BASE,UNAME='Rf_FIELD' $
                        ,Title='Detector Radius (cm) = ',/Return_Events,/float $
                        ,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wfilm.rf])


     Phi_Field = CW_Field(Exray_Film_BASE,UNAME='Phi_FIELD' $
                        ,Title='Detector Position (deg) = ',/Return_Events,/float $
                        ,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wfilm.phi*180./!pi])
  endelse

  Mu_Field = CW_Field(Exray_Film_BASE,UNAME='Mu_FIELD' $
                        ,Title='Out of True (deg) = ',/Return_Events,/float $
                        ,xsize=exraystr.formats.fieldsize $
                        ,Value=[(exraystr.wfilm.mu-exraystr.wfilm.phi)*180./!pi+90.])

  L_Field = CW_Field(Exray_Film_BASE,UNAME='L_FIELD' $
                        ,Title='Detector Length (cm) = ',/Return_Events,/float $
                        ,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wfilm.L])

endif else if (exraystr.wfilm.JFlag eq 3) then begin
   ;circular film plane
     Rf_Field = CW_Field(Exray_Film_BASE,UNAME='Rf_FIELD' $
                        ,Title='Detector Radius (cm) = ',/Return_Events,/float $
                        ,xsize=exraystr.formats.fieldsize,Value=[exraystr.wfilm.rf])

endif else begin

  Johann_Button_Base = Widget_Base(Exray_Film_BASE, UNAME='Johann_Button_BASE' $
      ,/Exclusive,column=1,/Align_Left)

  Calc_Button = Widget_Button(Johann_Button_BASE, UNAME='Calc_BUTTON'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Calculate Johann locus from crystal specs')

  File_Button = Widget_Button(Johann_Button_BASE, UNAME='File_BUTTON'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Read Johann locus points from file:')

  FilmFile_LABEL = Widget_Label( Exray_Film_BASE,  $
      UNAME='FilmFile_LABEL',/ALIGN_LEFT,VALUE='Filename Describing Johann Filmplane')

  File_BASE = Widget_Base(Exray_Film_BASE, UNAME='File_BASE',COLUMN=2)

  FilmFile_Filename = Widget_Text(File_BASE, UNAME='FilmFile_Filename'  $
         ,FRAME=0.5 ,XOFFSET=11 ,YOFFSET=60 ,SCR_XSIZE=369*mxy,SCR_YSIZE=30*mxy $
         ,XSIZE=20 ,YSIZE=1, VALUE=exraystr.wfilm.filmfile)

  Open_FilmFile_BUTTON = Widget_Button(File_BASE,  $
      UNAME='Open_FilmFile_BUTTON' ,XOFFSET=389 ,YOFFSET=60,SCR_XSIZE=30*mxy,SCR_YSIZE=30*mxy $
      ,/ALIGN_CENTER ,VALUE='images/open.bmp',/BITMAP)

endelse

  Quit_BASE = Widget_Base(Exray_Film_BASE, UNAME='Quit_BASE' $
      ,COLUMN=2,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Cancel')


  Quit_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Quit_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Done')


if (exraystr.wfilm.JFlag eq 1) then begin
  ;calculate the radius and position of the film
   h=exraystr.wxstal(0).h
   R0=exraystr.wxstal(0).R0
   ecc = sqrt(1+(h/R0)^2)-h/R0
   betamin=exraystr.wxstal(0).betamin
   betamax=exraystr.wxstal(0).betamax
   thetamin=atan((1.-ecc*cos(betamin))/(ecc*sin(betamin)))
   thetamax=atan((1.-ecc*cos(betamax))/(ecc*sin(betamax)))
   thetaJ= (thetamin+thetamax)/2.
   beta_avg=thetaJ+acos(cos(thetaJ)/ecc)
   rcurve=h*(1.-2.*ecc*cos(beta_avg)+ecc^2.)^(3./2.)/(1.-ecc*cos(beta_avg))^3.
   rho=h/(1.-ecc*cos(beta_avg))
   rf=rcurve*sin(thetaJ)-rho
   xc_Bavg=-rho*cos(beta_avg)
   yc_Bavg=rho*sin(beta_avg)
   alpha=atan(yc_Bavg/(xc_Bavg+R0))
   phi=(2.*thetaJ-alpha+!pi)*180./!pi

  Widget_Control,Film_LABEL, SET_VALUE='Line Detector at Central Johann Crossover'
  Widget_Control,Rf_FIELD,Set_Value=[rf]
  Widget_Control,Phi_FIELD,Set_Value=[phi]
endif else if (exraystr.wfilm.JFlag eq 2) then begin
  Widget_Control,Film_LABEL, SET_VALUE='Johann Locus Detector'
endif else if (exraystr.wfilm.JFlag eq 3) then begin
  Widget_Control,Film_LABEL, SET_VALUE='Circular Detector'
endif else begin
  Widget_Control,Film_LABEL, SET_VALUE='Line Detector'
endelse

;************************************************************************************
;Define the structure to be passed around
;************************************************************************************

if (exraystr.wfilm.JFlag ne 2) then begin
  if (exraystr.wfilm.Jflag eq 3) then $
     filmstr = {NAME: 'Film_Structure',$
                 rfwidget:rf_FIELD,$
                 exraystr:exraystr,$
                 MainWidget:MainWidget} $
  else $
     filmstr = {NAME: 'Film_Structure',$
                 rfwidget:rf_FIELD,$
                 phiwidget:Phi_FIELD,$
                 muwidget:Mu_FIELD,$
                 LWidget:L_FIELD,$
                 exraystr:exraystr,$
                 MainWidget:MainWidget}
endif else begin
  filmstr = {NAME: 'Film_Structure',$
              filebase:File_BASE,$
              filelabel:FilmFile_Label,$
              filename:filmfile_Filename,$
              jsflag:exraystr.wfilm.jsflag,$
              filmfile:exraystr.wfilm.filmfile,$
              exraystr:exraystr,$
              MainWidget:MainWidget}

  if (exraystr.wfilm.jsflag eq 0) then begin
     Widget_Control,Calc_BUTTON,Set_Button=1
     Widget_Control,File_BASE,Sensitive=0
     Widget_Control,FilmFile_LABEL,Sensitive=0
  endif else begin
     Widget_Control,File_BUTTON,Set_Button=1
  endelse

endelse


 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  Widget_Control, /REALIZE, Exray_Film_BASE

  Widget_Control, Exray_Film_BASE, set_uvalue = filmstr


  XManager, 'Exray_Film_BASE', Exray_Film_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro exray_film, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_Film_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end