PRO Exray_PlotList,MainWidget,Event


;*********************************************************************************************
;Ray-Tracing Calculations and Window Plotting
;  -The actual calculations of the ray-tracing are called in this procedure
;*********************************************************************************************

widget_control,/hourglass
widget_control,MainWidget,get_uvalue=exraystr

widget_control,exraystr.widget.Graphics,GET_VALUE=winID
wset,winID

widget_control,exraystr.widget.PlotList,Get_Value=plotname
ip=Event.index
;if ((exraystr.plotflag eq 5) or (exraystr.plotflag eq 15)) then pname='Locus Points' else $
if (ip ge 0 and ip lt n_elements(plotname)) then $
   pname=plotname(ip) $
else begin
   whoops=dialog_message('Please select a plotting option from the drop-down menu.',/Error)
   return
endelse

if ((pname eq 'Locus Points') and (exraystr.wfilm.Jflag ne 2)) then begin
   whoops=dialog_message('Option only available for Johann film planes.',/Error)
   return
endif

;********************** make some buttons insensitive **********************
widget_control,exraystr.widget.savedata,SENSITIVE=0
widget_control,exraystr.widget.pickref,SENSITIVE=0
widget_control,exraystr.widget.scaledata,SENSITIVE=0
widget_control,exraystr.widget.d2i,SENSITIVE=0
widget_control,exraystr.widget.eff,SENSITIVE=0
widget_control,exraystr.widget.scalecalc,SENSITIVE=0
widget_control,exraystr.widget.polynomial,SENSITIVE=0
widget_control,exraystr.widget.backcurve,SENSITIVE=0
widget_control,exraystr.widget.filter,SENSITIVE=0
widget_control,exraystr.widget.rebin,SENSITIVE=0
widget_control,exraystr.widget.rescale,SENSITIVE=0
widget_control,exraystr.widget.overplot,$
                         set_value=exraystr.images.overplot,/bitmap

;Do common calculations/procedures
if ((pname ne 'Data') and (pname ne 'Scaled Data')) then begin
   if (exraystr.plotOK eq 0) then begin
      whoops = dialog_message('There are not enough parameters set to ' $
           +'complete that action',/Error)
      return
   endif
   if (pname eq 'Ray-Tracing') then begin
      if (exraystr.convexflag ne 1) then $
         exray_buildptr,exraystr,exrayptr $
      else $
         exray_convex_buildptr,exraystr,exrayptr
   endif
   xstalnum=0
   for i=0,exraystr.wnumxstals-1 do $
   if (exraystr.xstalset(i) eq 1) then $
      xstalnum=xstalnum+1
   wdfa=findgen(xstalnum)+50
   if (exraystr.ellipset eq 0) then begin
      if ((exraystr.LOSFlag eq 0) or (exraystr.LOSFlag eq 1)) then $
         TREXval=1 $
      else if (exraystr.LOSFlag eq 3) then $
         TREXval=2 $
      else $
         TREXval=3
   endif else $
      TREXval=0
   ;set the flag for plotting in the convex crystal coordinate system or the LOS coordinate system
   coord=-1
   if (exraystr.crystalset eq 0) then $
      coord=0 $ ;plot in the crystal coordinate system
   else begin
      if (exraystr.LOSCFlag eq 0) then $
         coord=1 $ ;plot in the TIXTL LOS coordinate system
      else if (exraystr.LOSCFlag eq 1) then $
         coord=2 $ ;plot in the PODD LOS coordinate system
      else if (exraystr.LOSCFlag eq 2) then $
         coord=3  ;plot in the CRITR LOS coordinate system
   endelse
endif else active=exraystr.activedata

;determine if calculating convex ray-trace in Cauchois geometry
if (exraystr.LOSCFlag eq 2) then $
   trans=1 $
else $
   trans=0


if (pname eq 'Ray-Tracing') then begin
;*********************** plot the ray-tracing *******************************
   if (exraystr.plotflag ne 0) then begin
     ;readjust the plot ranges for ray-tracing
     if (exraystr.ellipset eq 1) then begin
        exraystr.xrange=[-10,10]
        exraystr.yrange=[-10,10]
     endif else begin
      if (exraystr.LOSFlag ne 3) then begin
        exraystr.xrange=[-37,7]
        exraystr.yrange=[-6,36]
      endif else begin
        exraystr.xrange=[-35,10]
        exraystr.yrange=[-15,30]
      endelse
     endelse
     if (exraystr.convexflag eq 1) then begin
        rc0=exraystr.wxstal(0).rc
        if (n_elements(xrange) eq 0) then begin
           if (coord eq 0) then $
              exraystr.xrange=[-5.-rc0,5.+rc0] $
           else $
              exraystr.xrange=[-12.,10.]  
        endif
        if (n_elements(yrange) eq 0) then begin
           if (coord eq 0) then $
              exraystr.yrange=[-5.,5.+2.*rc0] $
           else $
              exraystr.yrange=[-7.,15.]  
        endif
     endif
   endif
    exraystr.plotflag=0
    if (exraystr.convexflag ne 1) then $
       exray_go,wdfa,exrayptr,xrange=exraystr.xrange,yrange=exraystr.yrange, $
          noprint=1-exraystr.printwaves, limit=exraystr.limitrays, /nodisp, $
          TREX = TREXval,origin=exraystr.wLOS,windID=winID,rotation=exraystr.wrot, $
          config=exraystr.configflag $
    else $
       exray_convex_go,wdfa,exrayptr,xrange=exraystr.xrange,yrange=exraystr.yrange,$
          noprint=1-exraystr.printwaves, coord=coord, trans=trans, limit=exraystr.limitrays,windID=winID 
    delwdf,wdfa
    ptr_free,exrayptr
    exraystr.image=tvrd(TRUE=1) ;save the background image
    if (exraystr.configflag eq 1) then exraystr.configflag=0


 endif else if (pname eq 'Dispersion') then begin
 ;********************** plot the dispersion *********************************
   widget_control,exraystr.widget.savedata,SENSITIVE=1
   tempstr=replicate(exraystr,1)
   tempstr.autoflag = 1
   if (exraystr.convexflag ne 1) then begin
      exray_buildptr,tempstr,temptr
      exray_go,wdfa,temptr,xrange=exraystr.xrange,yrange=exraystr.yrange,$
          windID=winID
   endif else begin
      exray_convex_buildptr,tempstr,temptr
      exray_convex_go,wdfa,temptr,xrange=exraystr.xrange,yrange=exraystr.yrange,$
          windID=winID, trans=trans
   endelse
    if (exraystr.plotflag ne 1) then begin
        ;find the max and min of the data
        w2i,x,y,wdfa(0)
        exraystr.xrange=[min(x),max(x)]
        exraystr.yrange=[min(y),max(y)]
        for i=1,n_elements(wdfa)-1 do begin
           w2i,x,y,wdfa(i)
           if (min(x) lt exraystr.xrange(0)) then exraystr.xrange(0)=min(x)
           if (max(x) gt exraystr.xrange(1)) then exraystr.xrange(1)=max(x)
           if (min(y) lt exraystr.yrange(0)) then exraystr.yrange(0)=min(y)
           if (max(y) gt exraystr.yrange(1)) then exraystr.yrange(1)=max(y)
        endfor
    endif
    exraystr.plotflag=1
    ylabel='Wavelength (A)'
    xlabel='Film Position (cm)'
    plo,wdfa,col=[0,1,2],line=[0,0,0],xtitle=xlabel,psym=0,$
       ytitle=ylabel,leg=-1,charsize=1.2,pos=[0.15,0.1,0.95,0.957], $
       xrange=exraystr.xrange,yrange=exraystr.yrange,xstyle=1,ystyle=1
    for i=0,xstalnum-1 do begin
       xstalstring='crystal #'+string(i+1)
       xstalstring=strcompress(xstalstring)
       legend2,xstalstring,col=i,line=0,pos=[0.69,0.9-i*0.05],/normal,charsize=0.8
    endfor
    ptr_free,temptr
    exraystr.image=tvrd(TRUE=1) ;save the background image

 endif else if (pname eq 'Resolution') then begin
 ;************************ plot the resolution **********************************
       if (exraystr.wfilm.JFlag eq 2) then $
          exray_johann_rescalc,exraystr,windID=winID $
       else $
          exray_rescalc,exraystr,windID=winID
       delwdf,wdfa
;       ptr_free,exrayptr
       exraystr.plotflag=2
       exraystr.image=tvrd(TRUE=1) ;save the background image

 endif else if (pname eq 'Data') then begin
 ;************************ plot the data ****************************************
    if (exraystr.plotflag ne 3) then begin
       ;find the max and min of the data
       w2i,x,y,exraystr.datawdf(active)
       exraystr.xrange=[min(x),max(x)]
       exraystr.yrange=[min(y),max(y)]
    endif
    exraystr.plotflag=3
    widget_control,exraystr.widget.pickref,SENSITIVE=1
    widget_control,exraystr.widget.savedata,SENSITIVE=1
    widget_control,exraystr.widget.backcurve,SENSITIVE=1
    widget_control,exraystr.widget.filter,SENSITIVE=1
    widget_control,exraystr.widget.scalecalc,SENSITIVE=1
    widget_control,exraystr.widget.rebin,SENSITIVE=1
    widget_control,exraystr.widget.rescale,SENSITIVE=1
    if ((exraystr.scaleOK eq 1) and (exraystr.plotOK eq 1)) then $
       widget_control,exraystr.widget.scaledata,SENSITIVE=1
    if (exraystr.xrange(1) gt 100.) then begin
       xtitle='Film Position (microns)'
    endif else begin
       xtitle='Wavelength (Angstroms)'
       widget_control,exraystr.widget.d2i,SENSITIVE=1
       widget_control,exraystr.widget.eff,SENSITIVE=1
       widget_control,exraystr.widget.polynomial,SENSITIVE=1
       widget_control,exraystr.widget.backcurve,SENSITIVE=1
       widget_control,exraystr.widget.ordercor,SENSITIVE=1
    endelse

    if (exraystr.overflag eq 1) then begin
       widget_control,exraystr.widget.overplot,$
                         set_value=exraystr.images.overplot_active,/bitmap
       plo,[exraystr.datawdf(active),exraystr.overwdf],col=[0,1],line=[0,0],/over $
          ,leg=-1,xtitle=xtitle,pos=[0.15,0.1,0.95,0.957],xstyle=1,ystyle=1 $
          ,psym=0, xrange=exraystr.xrange,yrange=exraystr.yrange
       datafile=strsplit(exraystr.datafile(active),'/\',/EXTRACT)
       whichfile=where(exraystr.datawdf eq exraystr.overwdf)
       if (whichfile(0) ge 0) then $
          overfile=strsplit(exraystr.datafile(whichfile(0)),'/\',/EXTRACT)
       legend2,[datafile(n_elements(datafile)-1),overfile(n_elements(overfile)-1)],$
          col=[0,1],line=0,psym=0,pos=[0.5,0.92],/normal
    endif else $
       plo,exraystr.datawdf(active),col=0,line=0,xrange=exraystr.xrange,yrange=exraystr.yrange $
          ,leg=-1,xtitle=xtitle,pos=[0.15,0.1,0.95,0.957],xstyle=1,ystyle=1 $
          ,psym=0

    if (exraystr.xrange(1) lt 100.) then begin
       ;if the user has requested known transitions, then overplot those selected
       index=where(exraystr.whichelements gt 0)
       if (index(0) ge 0) then $
          exray_plotrans,exraystr
    endif

    exraystr.image=tvrd(TRUE=1) ;save the background image

 endif else if (pname eq 'Scaled Data') then begin
 ;*********************** plot the scaled data ***********************************
    if (exraystr.scaleflag(exraystr.activedata) ne 1) then begin
       whoops=dialog_message('This data has not been scaled.',/Error)
       widget_control,exraystr.widget.plotlist,set_droplist_select=exraystr.plotflag
       return
    endif

    if (exraystr.plotflag ne 4) then begin
       ;find the max and min of the data
       w2i,x,y,exraystr.scaledwdf(active)
       exraystr.xrange=[min(x),max(x)]
       exraystr.yrange=[min(y),max(y)]
    endif
    exraystr.plotflag=4
    ;make some buttons sensitive
    widget_control,exraystr.widget.savedata,SENSITIVE=1
    widget_control,exraystr.widget.polynomial,SENSITIVE=1
    widget_control,exraystr.widget.backcurve,SENSITIVE=1
    widget_control,exraystr.widget.filter,SENSITIVE=1
    widget_control,exraystr.widget.scalecalc,SENSITIVE=1
    widget_control,exraystr.widget.rescale,SENSITIVE=0
    widget_control,exraystr.widget.d2i,SENSITIVE=1
    widget_control,exraystr.widget.eff,SENSITIVE=1
    ;if overplotting, then overplot
    if (exraystr.overflag eq 2) then begin
       widget_control,exraystr.widget.overplot,$
                         set_value=exraystr.images.overplot_active,/bitmap
       plo,[exraystr.scaledwdf(active),exraystr.overwdf],col=[0,1],line=[0,0],/over $
          ,leg=-1,xtitle=xtitle,pos=[0.15,0.1,0.95,0.957],xstyle=1,ystyle=1 $
          ,psym=0, xrange=exraystr.xrange,yrange=exraystr.yrange
       datafile=strsplit(exraystr.datafile(active),'/\',/EXTRACT)
       whichfile=where(exraystr.datawdf eq exraystr.overwdf)
       if (whichfile(0) ge 0) then $
          overfile=strsplit(exraystr.datafile(whichfile(0)),'/\',/EXTRACT)
       legend2,[datafile(n_elements(datafile)-1),overfile(n_elements(overfile)-1)],$
          col=[0,1],line=0,psym=0,pos=[0.5,0.92],/normal
    endif else $ ;plot the scaled data
       plo,exraystr.scaledwdf(active),col=0,line=0,xrange=exraystr.xrange,yrange=exraystr.yrange $
          ,leg=-1,xtitle='Wavelength (Angstroms)',pos=[0.15,0.1,0.95,0.957],xstyle=1,ystyle=1 $
          ,psym=0

    ;if the user has requested known transitions, then overplot those selected
    index=where(exraystr.whichelements gt 0)
    if (index(0) ge 0) then $
       exray_plotrans,exraystr
    exraystr.image=tvrd(TRUE=1) ;save the background image
    oplot,[exraystr.lamref,exraystr.lamref],exraystr.yrange,line=1,col=3
    legend2,['Reference Wavelength = '+string(exraystr.lamref,format='(F6.3)')+' Angstroms'],$
          col=3,line=1,psym=0,pos=[0.15,0.98],/normal
    ;if analyzing TIXTL data, allow density -> intensity scaling
    if (exraystr.wfilm.circleflag eq 1) then $
       widget_control,exraystr.widget.d2i,SENSITIVE=1

 endif else if (pname eq 'Locus Points') then begin
 ;********************** plot the Johann Locus Points *********************************
   widget_control,exraystr.widget.savedata,SENSITIVE=1
   tempstr=replicate(exraystr,1)
   tempstr.autoflag = 1
   exray_buildptr,tempstr,temptr
   exray_go,wdfa,temptr,xrange=exraystr.xrange,yrange=exraystr.yrange,$
          windID=winID, /nodisp
    if (exraystr.plotflag ne 5) then begin
        ;find the max and min of the data
        w2i,x,y,wdfa(0)
        exraystr.xrange=[min(x),max(x)]
        exraystr.yrange=[min(y),max(y)]
        for i=1,n_elements(wdfa)-1 do begin
           w2i,x,y,wdfa(i)
           if (min(x) lt exraystr.xrange(0)) then exraystr.xrange(0)=min(x)
           if (max(x) gt exraystr.xrange(1)) then exraystr.xrange(1)=max(x)
           if (min(y) lt exraystr.yrange(0)) then exraystr.yrange(0)=min(y)
           if (max(y) gt exraystr.yrange(1)) then exraystr.yrange(1)=max(y)
        endfor
    endif
    exraystr.plotflag=5
    ylabel='Y (cm)'
    xlabel='X (cm)'
    plo,wdfa,col=[0,1,2],line=[0,0,0],xtitle=xlabel,psym=0,$
       ytitle=ylabel,leg=-1,charsize=1.2,pos=[0.15,0.1,0.95,0.957], $
       xrange=exraystr.xrange,yrange=exraystr.yrange,xstyle=1,ystyle=1
    for i=0,xstalnum-1 do begin
       xstalstring='crystal #'+string(i+1)
       xstalstring=strcompress(xstalstring)
       legend2,xstalstring,col=i,line=0,pos=[0.69,0.9-i*0.05],/normal,charsize=0.8
    endfor
    ptr_free,temptr

    exraystr.image=tvrd(TRUE=1) ;save the background image

 endif


widget_control,MainWidget,set_uvalue=exraystr

return
end
