PRO EXRAY_PLOTPREP,exrayptr,xrange,yrange,over,trex,LOS,alpham,R0m,parabolic,$
                   windID=winID,xjohann,yjohann

;*************************************************
; Intialize the plot window
;*************************************************
if (over eq 0) then begin
   if (n_elements(winID) eq 0) then begin
      window,0,xsize=650,ysize=450,title='Elliptical Crystal Ray Tracing'
      plot,[0,0],[-100,100],line=1,xran=xrange,yran=yrange,xtitle='X (cm)',ytitle='Y (cm)',$
                         xstyle=1,ystyle=1,position=[0.1,0.1,0.7,0.9667],charsize=1.2
   endif else begin
      wset,winID
      plot,[0,0],[-100,100],line=1,xran=xrange,yran=yrange,xtitle='X (cm)',ytitle='Y (cm)',$
                         xstyle=1,ystyle=1,position=[0.15,0.1,0.95,0.957],charsize=1.2
   endelse
   oplot,[-1000,1000],[0,0],line=1
   if (trex eq 1) then begin
      ;plot the TREX instrument housing
      oplot,[3.7,3.7],[-4,4.5]
      oplot,[4.7,4.7],[-5,5.5]
      oplot,[-29,-29],[-4,4.5]
      oplot,[-30,-30],[-5,5.5]
      oplot,[-29,3.7],[-4,-4]
      oplot,[-30,4.7],[-5,-5]
      oplot,[-29,3.7],[4.5,4.5]
      oplot,[-30,4.7],[5.5,5.5]

   endif else if (trex eq 2) then begin
      ;plot the PODD instrument housing

      ;LOS pipe
      ptop=2.5/2.*2.54 ;*
      pbottom=-1.*ptop ;*

      ;crystal housing (in cm)
      xtop=4.53/2.*2.54     ;*inside top surface
      xbottom=-xtop ;*inside bottom surface
      xright=1.8473*2.54    ;*inside right surface
      xleft=xright-15.*2.54     ;*inside left surface
      xwidth=1.8288      ;*wall thickness of top surface
      xoright=xright-3.942*2.54    ;*right position of top opening
      xoleft=xoright-7.81*2.54    ;*left position of top opening
      ;xl2=-17.0         ;position of bump-in for H2 MCP compatability
      ;xt2=xtop-xwidth   ;top lid position of bump-in for H2 MCP compatability
      ;xl2=xoleft         ;position of bump-in for H2 MCP compatability
      ;xt2=xtop   ;top lid position of bump-in for H2 MCP compatability

      oplot,[xright,!x.crange(1)],[ptop,ptop],thick=2.
      oplot,[xright,!x.crange(1)],[pbottom,pbottom],thick=2.

      oplot,[xright,xright],[ptop,xtop]
      oplot,[xright,xright],[pbottom,xbottom]
      oplot,[xright,xleft],[xbottom,xbottom]
      oplot,[xright,xoright],[xtop,xtop]
      oplot,[xoleft,xleft],[xtop,xtop]
      oplot,[xleft,xleft],[xbottom,xtop]
      oplot,[xright,xoright],[xtop,xtop]+xwidth
      oplot,[xoleft,xleft],[xtop,xtop]+xwidth
      oplot,[xoleft,xoleft],[xtop,xtop+xwidth]
      oplot,[xoright,xoright],[xtop,xtop+xwidth]
      oplot,[xleft,xleft],[xtop,xtop+xwidth]
      oplot,[xright,xright],[xtop,xtop+xwidth]
   endif
   if (trex gt 0) then begin
      if ((*exrayptr).film.JFlag gt 1) then begin
      ;Plot the film housing
         fbottom=3.75
         ftop=17.
         fleft=-23.
         fright=-6.5
         ;oplot,[fright,fright],[xtop,ftop]
         ;oplot,[fright-1.,fright-1.],[xtop-1.,ftop-1.]
         ;oplot,[fleft,fleft],[fbottom,ftop]
         ;oplot,[fleft+1.,fleft+1.],[fbottom+1.,ftop-1.]
         ;oplot,[xleft+1.,fleft+1.],[fbottom+1.,fbottom+1.]
         ;oplot,[fright-1.,fleft+1.],[ftop-1.,ftop-1.]
         ;oplot,[fleft,xleft],[fbottom,fbottom]
         ;oplot,[fright,fleft],[ftop,ftop]
      endif else begin
      ;Plot the MCP camera body
         rf=(*exrayptr).film.rf
         phi=(*exrayptr).film.phi
         mu=(*exrayptr).film.mu
         L=(*exrayptr).film.L
         xf0=-rf*cos(phi)
         yf0=rf*sin(phi)

         m1x=2.383
         m1y=0.
         m2y=1.163
         m3x=7.938
         m4y=-8.680
         m5x=4.128
         m6y=-1.060

         r1=sqrt(m1x^2.+m1y^2.)
         theta1=atan(m1y/m1x)*[-1.,1.]+[0.,!pi]
         r2=sqrt(m1x^2.+m2y^2.)
         theta2=atan(m2y/m1x)*[-1.,1.]+[0.,!pi]
         r3=sqrt(m3x^2.+m2y^2.)
         theta3=atan(m2y/m3x)*[-1.,1.]+[0.,!pi]
         r4=sqrt(m3x^2.+m4y^2.)
         theta4=atan(m4y/m3x)*[-1.,1.]+[0.,!pi]
         r5=sqrt(m5x^2.+m4y^2.)
         theta5=atan(m4y/m5x)*[-1.,1.]+[0.,!pi]
         r6=sqrt(m5x^2.+m6y^2.)
         theta6=atan(m6y/m5x)*[-1.,1.]+[0.,!pi]

         px1=r1*cos(theta1-!pi+mu)+xf0
         px2=r2*cos(theta2-!pi+mu)+xf0
         px3=r3*cos(theta3-!pi+mu)+xf0
         px4=r4*cos(theta4-!pi+mu)+xf0
         px5=r5*cos(theta5-!pi+mu)+xf0
         px6=r6*cos(theta6-!pi+mu)+xf0
         py1=-r1*sin(theta1-!pi+mu)+yf0
         py2=-r2*sin(theta2-!pi+mu)+yf0
         py3=-r3*sin(theta3-!pi+mu)+yf0
         py4=-r4*sin(theta4-!pi+mu)+yf0
         py5=-r5*sin(theta5-!pi+mu)+yf0
         py6=-r6*sin(theta6-!pi+mu)+yf0

         dist=sqrt((R0m+px1)^2+py1^2)
         px1=LOS-dist*cos(alpham+asin(-py1/dist))
         py1=dist*sin(alpham+asin(-py1/dist))
         dist=sqrt((R0m+px2)^2+py2^2)
         px2=LOS-dist*cos(alpham+asin(-py2/dist))
         py2=dist*sin(alpham+asin(-py2/dist))
         dist=sqrt((R0m+px3)^2+py3^2)
         px3=LOS-dist*cos(alpham+asin(-py3/dist))
         py3=dist*sin(alpham+asin(-py3/dist))
         dist=sqrt((R0m+px4)^2+py4^2)
         px4=LOS-dist*cos(alpham+asin(-py4/dist))
         py4=dist*sin(alpham+asin(-py4/dist))
         dist=sqrt((R0m+px5)^2+py5^2)
         px5=LOS-dist*cos(alpham+asin(-py5/dist))
         py5=dist*sin(alpham+asin(-py5/dist))
         dist=sqrt((R0m+px6)^2+py6^2)
         px6=LOS-dist*cos(alpham+asin(-py6/dist))
         py6=dist*sin(alpham+asin(-py6/dist))

         for i=0,1 do begin
             oplot,[px1(i),px2(i)],[py1(i),py2(i)],col=3
             oplot,[px2(i),px3(i)],[py2(i),py3(i)],col=3
             oplot,[px3(i),px4(i)],[py3(i),py4(i)],col=3
             oplot,[px4(i),px5(i)],[py4(i),py5(i)],col=3
             oplot,[px5(i),px6(i)],[py5(i),py6(i)],col=3
         endfor
         oplot,px6,py6,col=3

      endelse

   endif
   linelook=0
endif else linelook=1

if (trex ne 0) then begin
      ;plot the origin and the x-over focus
      xshift=-R0m*cos(alpham)+LOS  ;the x and y positions of the new ellipse focus
      yshift=R0m*sin(alpham)
      oplot,[0,xshift],[0,yshift],line=0,psym=2,col=1
endif

;*************************************************
; Plot the xstals
;*************************************************
numxstals=(*exrayptr).numxstals
for l=0,numxstals-1 do begin
   betamin=(*exrayptr).xstal(l).betamin
   betamax=(*exrayptr).xstal(l).betamax
   h=(*exrayptr).xstal(l).h
   R0=(*exrayptr).xstal(l).R0
   ecc=(*exrayptr).xstal(l).ecc
   xmin=-h*cos(betamin)/(1.-ecc*cos(betamin))
   ymin= h*sin(betamin)/(1.-ecc*cos(betamin))
   xmax=-h*cos(betamax)/(1.-ecc*cos(betamax))
   ymax= h*sin(betamax)/(1.-ecc*cos(betamax))
   xxstal=(xmax-xmin)*(findgen(1000)*.001)+xmin
   if (parabolic eq 0) then $ ; an elliptical crystal
      yxstal=sqrt(h^2/(1.-ecc^2)-(xxstal+R0/2.)^2*(1.-ecc^2)) $
   else $ ; a parabolic crystal
      yxstal = sqrt(h^2-2.*h*xxstal)
   if (trex ne 0) then begin
      dist=sqrt((R0m+xxstal)^2+yxstal^2)
      xxstal=LOS-dist*cos(alpham+asin(-yxstal/dist))
      yxstal=dist*sin(alpham+asin(-yxstal/dist))
   endif
   oplot,xxstal,yxstal,col=l,thick=2,line=linelook

   ;calculate the length of the substrate
   dl=sqrt((xxstal(1:999)-xxstal(0:998))^2.+(yxstal(1:999)-yxstal(0:998))^2.)
   length=total(dl)
   ;xyouts,0.15,0.97,/normal,'Substrate Length = '$
   ;       +strtrim(string(length,format='(F9.2)'),2)+'cm'
endfor

;*************************************************
; Plot the film plane
;*************************************************
rf=(*exrayptr).film.rf
if (rf ge 0.) then begin
   if ((*exrayptr).film.Jflag eq 3) then begin
   ;Circular Film Plane
      xfmax=rf*cos(betamin)
      xfmin=rf*cos(betamax)
      xf=findgen(100)/99.*(xfmax-xfmin)+xfmin
      yf=-1.*sqrt(rf^2.-xf^2.)
      if (trex ne 0) then begin
         dist=sqrt((R0m+xf)^2+yf^2)
         xf=LOS-dist*cos(alpham+asin(-yf/dist))
         yf=dist*sin(alpham+asin(-yf/dist))
      endif
      oplot,xf,yf,thick=2,line=linelook
   endif else begin
   ;Linear Film Plane
      phi=(*exrayptr).film.phi
      mu=(*exrayptr).film.mu
      L=(*exrayptr).film.L
      xf0=-rf*cos(phi)
      yf0=rf*sin(phi)
      xfminus=xf0+L/2.*cos(mu)
      xfplus=xf0-L/2.*cos(mu)
      yfminus=yf0-L/2.*sin(mu)
      yfplus=yf0+L/2.*sin(mu)
      if (trex ne 0) then begin
         dist=sqrt((R0m+xfplus)^2+yfplus^2)
         xfplus=LOS-dist*cos(alpham+asin(-yfplus/dist))
         yfplus=dist*sin(alpham+asin(-yfplus/dist))
         dist=sqrt((R0m+xfminus)^2+yfminus^2)
         xfminus=LOS-dist*cos(alpham+asin(-yfminus/dist))
         yfminus=dist*sin(alpham+asin(-yfminus/dist))
      endif
      oplot,[xfminus,xfplus],[yfminus,yfplus],thick=2,line=linelook
   endelse
   xjohann=0.
   yjohann=0.
endif else begin
;Johann Film Plane
   betamin=(*exrayptr).xstal(0).betamin
   betamax=(*exrayptr).xstal(0).betamax
   ecc=(*exrayptr).xstal(0).ecc
   h=(*exrayptr).xstal(0).h
   R0=(*exrayptr).xstal(0).R0
   a=-R0
   b=0.
   nb=1000.
   betas=findgen(nb)/(1.*nb-1.)*(betamax-betamin)+betamin
     ;calculate theta for each beta
     xc =-h*cos(betas)/(1.0-ecc*cos(betas))
     yc = h*sin(betas)/(1.0-ecc*cos(betas))
     dydx=-(ecc-cos(betas))/sin(betas)
     numerator=(xc-a) + (yc-b)*dydx
     denominator=sqrt((xc-a)^2+(yc-b)^2)*sqrt(1+dydx^2)
     costheta=numerator/denominator
     theta=acos(costheta)
   rcurve=h*(1.-2.*ecc*cos(betas)+ecc^2.)^(3./2.)/(1.-ecc*cos(betas))^3.
   rho=h/(1.-ecc*cos(betas))
   rlambda=rcurve*sin(theta)-rho
   xjohann=rlambda*cos(betas)
   yjohann=-rlambda*sin(betas)
   if (trex ne 0) then begin
      dist=sqrt((R0m+xjohann)^2+yjohann^2)
      xjohann=LOS-dist*cos(alpham+asin(-yjohann/dist))
      yjohann=dist*sin(alpham+asin(-yjohann/dist))
   endif
   oplot,xjohann,yjohann,thick=2,line=linelook
endelse

return
end