pro exray_thetacalc,exrayptr,whichxstal,whichsource,whichorder,whichlambda,limit,parabolic

  betamin=(*exrayptr).xstal(whichxstal).betamin
  betamax=(*exrayptr).xstal(whichxstal).betamax
  h=(*exrayptr).xstal(whichxstal).h
  ecc=(*exrayptr).xstal(whichxstal).ecc
  twod=(*exrayptr).xstal(whichxstal).twod
  a=(*exrayptr).source(whichsource).a
  b=(*exrayptr).source(whichsource).b
  n=(*exrayptr).source(whichsource).n(whichorder)
  beta=(*exrayptr).xstal(whichxstal).beta(whichorder,whichlambda)


  ;***************************************************************
  ; Calculate and save the values of xc and yc
  ;***************************************************************

  if (((beta ge betamin) and (beta le betamax)) or limit eq 0) then begin
    ;if beta falls between betamin and betamax, or the user has not
    ; requested that xrays diffract between the crystal limits then
    ; calculate xc anc yc
     xc =-h*cos(beta)/(1.0-ecc*cos(beta))
     yc = h*sin(beta)/(1.0-ecc*cos(beta))
  endif else begin
    ;otherwise set this theta = 0. as a flag that the x-ray will not
    ; diffract off this crystal and return
     xc = 0.
     yc = 0.
     (*exrayptr).xstal(whichxstal).theta(whichsource,whichorder,whichlambda)=0.
     (*exrayptr).xstal(whichxstal).xc(whichsource,whichorder,whichlambda)=xc
     (*exrayptr).xstal(whichxstal).yc(whichsource,whichorder,whichlambda)=yc
     return
  endelse

  ;***************************************************************
  ; Calculate cos(theta)
  ;***************************************************************

  if (parabolic eq 0) then $ ;an elliptical crystal
     dydx=-(ecc-cos(beta))/sin(beta) $
  else $ ; a parabolic crystal
     dydx=-h/yc
  numerator=(xc-a) + (yc-b)*dydx
  denominator=sqrt((xc-a)^2+(yc-b)^2)*sqrt(1+dydx^2)
  costheta=numerator/denominator
  theta=acos(costheta)
  lambda=twod/n*sqrt(1.-costheta^2)

  (*exrayptr).xstal(whichxstal).xc(whichsource,whichorder,whichlambda)=xc
  (*exrayptr).xstal(whichxstal).yc(whichsource,whichorder,whichlambda)=yc
  (*exrayptr).xstal(whichxstal).theta(whichsource,whichorder,whichlambda)=theta
  (*exrayptr).source(whichsource).lambda(whichorder,whichlambda)=lambda


return
end
