

pro Exray_GraphOpt_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = optstr

  case Event.id of

   Widget_Info(wWidget, FIND_BY_UNAME='SquareZoom_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           optstr.square = 0
        endif else begin
           optstr.square = 1
           tmp=double(0.)
           widget_control,optstr.xzoom,get_value=tmp
           widget_control,optstr.yzoom,set_value=tmp
        endelse
      endif
    end
   Widget_Info(wWidget, FIND_BY_UNAME='ShowTrans_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           optstr.showtrans = 0
        endif else begin
           optstr.showtrans = 1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Quit_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
       ;save the values in 'global' variables
        tmp = double(0.)
        Widget_Control, optstr.xzoom, get_value = tmp
        optstr.exraystr.xzoomfac=tmp
        if optstr.square eq 1 then optstr.exraystr.yzoomfac = optstr.exraystr.xzoomfac $
        else begin
           Widget_Control, optstr.yzoom, get_value = tmp
           optstr.exraystr.yzoomfac=tmp
        endelse
        optstr.exraystr.zoomsquare=optstr.square
        optstr.exraystr.showtrans=optstr.showtrans
        Widget_Control, optstr.MainWidget, set_uvalue = optstr.exraystr
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;quit without saving anything
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = optstr


end

pro Exray_GraphOpt_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control, MainWidget, get_uvalue = exraystr
  mxy=exraystr.mxy

  Exray_GraphOpt_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_GraphOpt_BASE' ,XOFFSET=5 ,YOFFSET=5, Column = 1, $
      TITLE='GUI Options' ,SPACE=3 ,XPAD=3 ,YPAD=3)

  XZoom_Field = CW_Field(Exray_GraphOpt_BASE,UNAME='XZoom_FIELD' $
                        ,Title='X Zoom Factor',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.xzoomfac)
  YZoom_Field = CW_Field(Exray_GraphOpt_BASE,UNAME='YZoom_FIELD' $
                        ,Title='Y Zoom Factor',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.yzoomfac)

  SquareZoom_BASE = Widget_Base(Exray_GraphOpt_BASE,  $
      UNAME='SquareZoom_BASE', Column = 1,/NonExclusive)

  SquareZoom_BUTTON = Widget_Button(SquareZoom_BASE, UNAME='SquareZoom_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Keep Zoom Area Square')

  ShowTrans_BASE = Widget_Base(Exray_GraphOpt_BASE,  $
      UNAME='ShowTrans_BASE', Column = 1,/NonExclusive)

  ShowTrans_BUTTON = Widget_Button(SquareZoom_BASE, UNAME='ShowTrans_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Cursor On Known Transitions')


  Quit_BASE = Widget_Base(Exray_GraphOpt_BASE, UNAME='Quit_BASE' $
      ,COLUMN=2,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Cancel')


  Quit_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Quit_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Done')


;************************************************************************************
;Define the structure to be passed around
;************************************************************************************

  optstr = {NAME: 'Options_Structure',$
              xzoom:XZoom_FIELD,$
              yzoom:YZoom_FIELD,$
              square:exraystr.zoomsquare,$
              showtrans:exraystr.showtrans,$
              exraystr:exraystr,$
              MainWidget:MainWidget}

  if (exraystr.zoomsquare eq 1) then begin
     widget_control, squarezoom_button, set_button = 1
  endif

  ;check to see if the user is overplotting known transitions
  index=where(exraystr.whichelements gt 0)
  if (index(0) lt 0) then widget_control,showtrans_button,sensitive=0 $
  else if (exraystr.showtrans eq 1) then begin
     widget_control, showtrans_button, set_button = 1
  endif


 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  Widget_Control, /REALIZE, Exray_GraphOpt_BASE

  Widget_Control, Exray_GraphOpt_BASE, set_uvalue = optstr


  XManager, 'Exray_GraphOpt_BASE', Exray_GraphOpt_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro exray_graphopt, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_GraphOpt_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end
