

pro Exray_XYrange_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = xystr

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='Quit_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
       ;save the values in 'global' variables
        whoops = ''
        tmp1 = double(0.)
        tmp2 = double(0.)
        Widget_Control, xystr.Xmin, get_value = tmp1
        Widget_Control, xystr.Xmax, get_value = tmp2
        if (tmp2 le tmp1) then $
            whoops=dialog_message('Invalid Plot Range (Xmax <= Xmin)',/Error) $
        else $
            xystr.exraystr.xrange(0)=tmp1
            xystr.exraystr.xrange(1)=tmp2
        Widget_Control, xystr.Ymin, get_value = tmp1
        Widget_Control, xystr.Ymax, get_value = tmp2
        if (tmp2 le tmp1) then $
            whoops=dialog_message('Invalid Plot Range (Ymax <= Ymin)',/Error) $
        else $
           xystr.exraystr.yrange(0)=tmp1
           xystr.exraystr.yrange(1)=tmp2
        if whoops ne 'OK' then begin
           Widget_Control, xystr.MainWidget, set_uvalue = xystr.exraystr
           if (xystr.exraystr.plotOK eq 1) then begin
              widget_control,xystr.exraystr.widget.plotlist,send_event=$
                   { WIDGET_DROPLIST, ID:xystr.exraystr.widget.plotlist, TOP:wWidget, $
                   HANDLER:wWidget, INDEX:xystr.exraystr.plotflag }
           endif
           widget_control, Event.top, /DESTROY
           return
        endif
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;quit without saving anything
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = xystr


end

pro Exray_XYrange_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control, MainWidget, get_uvalue = exraystr
  mxy=exraystr.mxy

  Exray_XYrange_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_XYrange_BASE' ,XOFFSET=5 ,YOFFSET=5, Column = 1, $
      TITLE='Plot Range' ,SPACE=3 ,XPAD=3 ,YPAD=3)

  Xrange_BASE = Widget_Base(Exray_XYrange_BASE,  $
      UNAME='Xrange_BASE', Column = 2,TITLE='Plot Range')

  XMin_Field = CW_Field(Xrange_BASE,UNAME='XMin_FIELD' $
                        ,Title='X range =',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.xrange(0))
  XMax_Field = CW_Field(Xrange_BASE,UNAME='XMax_FIELD' $
                        ,Title='',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.xrange(1))

  Yrange_BASE = Widget_Base(Exray_XYrange_BASE,  $
      UNAME='Yrange_BASE', Column = 2,TITLE='Plot Range')

  YMin_Field = CW_Field(Yrange_BASE,UNAME='YMin_FIELD' $
                        ,Title='Y range =',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.yrange(0))
  YMax_Field = CW_Field(Yrange_BASE,UNAME='YMax_FIELD' $
                        ,Title='',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.yrange(1))

  Quit_BASE = Widget_Base(Exray_XYrange_BASE, UNAME='Quit_BASE' $
      ,COLUMN=2,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Cancel')


  Quit_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Quit_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Done')


;************************************************************************************
;Define the structure to be passed around
;************************************************************************************

  xystr = {NAME: 'XY_Structure',$
              Xmin:XMin_FIELD,$
              Xmax:XMax_FIELD,$
              Ymin:YMin_FIELD,$
              Ymax:YMax_FIELD,$
              exraystr:exraystr,$
              MainWidget:MainWidget}

 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  Widget_Control, /REALIZE, Exray_XYrange_BASE

  Widget_Control, Exray_XYrange_BASE, set_uvalue = xystr


  XManager, 'Exray_XYrange_BASE', Exray_XYrange_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro exray_XYrange, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_XYrange_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end
