PRO exray_makehist,xd,yd,bins,hist,file=infile,rescale=rf,numbins=nb,$
             findrf=findrf,poisson=poisson,fitcurve=yg,$
             shift=ys,chi=chisq,seed=rfin,error=rferr,$
             limit=nobins,fitrange=frange

if (n_elements(infile) ne 0) then rufo,xd,yd,file=infile
if (n_elements(nb) eq 0) then nb=50
if (n_elements(rf) eq 0) then rf=1.
if (n_elements(ys) eq 0) then ys=0.
if (n_elements(rfin) ne 0) then rf=rfin

bins=findgen(nb)/(nb-1.)*(max(yd)-min(yd))+min(yd)
bsz=bins(2)-bins(1)
hist=histogram(yd,binsize=bsz)
bins=bins+ys
bins=bins(where(bins ge 0))
hist=hist(where(bins ge 0))
if (n_elements(nobins) ne 0) then begin
   index=where(indgen(nb) ne nobins)
   bins=bins(index)
   hist=hist(index)
endif
sigs=sqrt(hist)
;hist=hist/total(bsz*hist)
;sigs=sqrt(hist)/total(bsz*hist)
xav=total(bins*hist)/total(hist)

if keyword_set(findrf) then begin
  ;window,2
  ns=100 ;the number of search iterations
  if (n_elements(frange) eq 0) then begin
     frange=rf*[0.5,1.5]
  endif
  count=0
  chisq=dblarr(ns)
  rfs=findgen(ns)/(ns-1.)*(frange(1)-frange(0))+frange(0)
  jump: count=count+1
  for j=0,ns-1 do begin
     i=(count-1)*100+j
     xav2=xav*rfs(i)
     xg=bins*rfs(i)
     if keyword_set(poisson) then begin
       yg=xav2^xg*exp(-xav2)/factorial(xg)
     endif else begin
       yg=1./sqrt(2.*!pi*xav2)*exp(-(xg-xav2)^2/(2.*xav2))
     endelse
     yg=yg*total(bsz*hist)
     index=where(sigs ne 0. and finite(yg) ne 0)
     tempchi=total((hist(index)-yg(index)*rfs(i))^2*1./sigs(index)^2)$
             /(n_elements(index)-1)
     chisq(i)=tempchi
     plot,bins*rfs(i),hist+sigs,line=1,psym=10,xtitle='Rescaled Counts'$
         ,ytitle='Frequency'
     oplot,bins*rfs(i),hist,psym=10
     oplot,bins*rfs(i),hist-sigs,psym=10,line=1
     oplot,[xav,xav]*rfs(i),[0.,1.e6],line=2
     oplot,bins*rfs(i),yg*rfs(i),col=1
     wait,0.01
  endfor
  ;find the minimum
  deg=5
  ;fit=poly_fit(rfs,chisq,deg)
  xfit=findgen(1000)/999.*(max(rfs)-min(rfs))+min(rfs)
  ;yfit=dblarr(n_elements(xfit))
  ;for i=0,5 do yfit=yfit+fit(i)*xfit^i
  yfit=interpol(chisq,rfs,xfit)
  plot,xfit,yfit,xtitle='Rescale Factor',ytitle='Chi-Squared'
  oplot,rfs,chisq,psym=2
  wait,1.0
  ;hak
  best=xfit(where(yfit eq min(yfit)))
  rf=best(0)
  ;find the 1 sigma levels
  i2w,xfit,yfit,60,/xy
  p1sigs=get_time(60,min(yfit)+1.,np=np)
  if (np ne 2) then begin
     if (count gt 15) then begin
        print,'1 sigma levels not found - try a different seed'
     endif else begin
        ;ans='Y'
        ;print,'1 sigma level not found - increase range? (Y,n)'
        ;read,ans
        ;if (ans eq 'n') then return
        ;frange2=[1.,100.]*rfs(1)-rfs(0)+rfs(ns-1)
        frange2=[rfs(ns*count-1)+rfs(1)-rfs(0),rfs(ns*count-1)+rfs(ns-1)*10.]
        print,frange2
        chisq2=chisq
        rfs2=rfs
        chisq=dblarr(n_elements(chisq2)+ns)
        chisq(0:n_elements(chisq2)-1)=chisq2
        rfs=[rfs2,findgen(ns)/(ns-1.)*(frange2(1)-frange2(0))+frange2(0)]
        goto,jump
     endelse
  endif else begin
     rferr=p1sigs
  endelse
  if (n_elements(p1sigs) eq 2) then $
     print,rf,' + ',p1sigs(1),' - ',p1sigs(0) $
  else $
     print,rf

endif

;window,0
if keyword_set(poisson) then begin
   xg=bins*rf
   xav=xav*rf
   yg=xav^xg*exp(-xav)/factorial(xg)
   yg=yg*total(bsz*hist)
endif else begin
   xg=bins*rf
   xav=xav*rf
   yg=1./sqrt(2.*!pi*xav)*exp(-(xg-xav)^2/(2.*xav))
   yg=yg*total(bsz*hist)
;   oplot,bins*rf,yg*rf,col=1
;   index=where(sigs ne 0.)
;   chisq=total((hist(index)-yg(index)*rf)^2*1./sigs(index)^2)$
;              /(n_elements(index)-1)
;   print,chisq
endelse

index=where(sigs ne 0.)
chisq=total((hist(index)-yg(index)*rf)^2*1./sigs(index)^2)$
              /(n_elements(index)-1)
print,chisq

title='R = '+strtrim(string(rf,format='(F10.0)'),2)+',  Chi!E2!N = '$
            +strtrim(string(chisq,format='(F5.2)'),2)
plot,bins*rf,hist+sigs,line=1,psym=10,xtitle='Rescaled Counts'$
    ,ytitle='Frequency',title=title
oplot,bins*rf,hist,psym=10
oplot,bins*rf,hist-sigs,psym=10,line=1
oplot,[xav,xav],!y.crange,line=2

oplot,bins*rf,yg*rf,col=1

wait,1.0

return
end
