

pro Exray_PffWidget_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = pffstr

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='Open_PffFile_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        nametemp = ''
        path=''
        nametemp = dialog_pickfile(/must_exist,title='Select the pff file', $
                           path=pffstr.exraystr.path,get_path=path,filter='*.pff')
        if (nametemp ne '') then begin
           pffstr.path=path
           pffstr.Pfffile=nametemp
           widget_control,pffstr.PffFilename,SET_VALUE=pffstr.Pfffile
        endif
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Pff_Filename'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_TEXT' )then begin
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Effcor_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
         if (pffstr.effcorflag eq 0) then pffstr.effcorflag = 1 $
         else pffstr.effcorflag = 0
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Wave_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
         if (pffstr.waveflag eq 0) then pffstr.waveflag = 1 $
         else pffstr.waveflag = 0
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='D2I_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
         if (pffstr.d2iflag eq 0) then pffstr.d2iflag = 1 $
         else pffstr.d2iflag = 0
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Backsub_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
         if (pffstr.backflag eq 0) then begin
            pffstr.backflag = 1
            Widget_Control, pffstr.backbase, Sensitive=1
         endif else begin
            pffstr.backflag = 0
            Widget_Control, pffstr.backbase, Sensitive=0
         endelse
     endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Open_Backsub_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        nametemp = ''
        path=''
        nametemp = dialog_pickfile(/must_exist,title='Select the background file', $
                           path=pffstr.exraystr.path,get_path=path,filter='*.ufo')
        if (nametemp ne '') then begin
           pffstr.backfile=nametemp
           widget_control,pffstr.backname,SET_VALUE=pffstr.backfile
        endif
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Quit_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
       ;save the values in 'global' variables and run the Pff job
        if (pffstr.Pfffile eq '') then begin
          whoops = dialog_message('No pff file selected.',/Error)
          return
        endif
        widget_control, Event.top, /DESTROY
        exray_Pffcalc,pffstr
        pffstr.exraystr.path=pffstr.path
        pffstr.exraystr.Pfffile=pffstr.Pfffile
        Widget_Control, pffstr.MainWidget, set_uvalue = pffstr.exraystr
        return
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;quit without saving anything
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = pffstr


end

pro Exray_PffWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control, MainWidget, get_uvalue = exraystr
  mxy=exraystr.mxy

  Exray_PffWidget_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_PffWidget_BASE' ,XOFFSET=5 ,YOFFSET=5, Column = 1, $
      TITLE='Pff Calculation' ,SPACE=3 ,XPAD=3 ,YPAD=3)

  PffFile_LABEL = Widget_Label( Exray_PffWidget_BASE,  $
      UNAME='PffFile_LABEL',/ALIGN_LEFT,VALUE='Pff Filename')

  File_BASE = Widget_Base(Exray_PffWidget_BASE, UNAME='File_BASE',COLUMN=2)

  Pff_Filename = Widget_Text(File_BASE, UNAME='Pff_Filename'  $
         ,FRAME=0.5 ,XOFFSET=11 ,YOFFSET=60 ,SCR_XSIZE=369*mxy,SCR_YSIZE=30*mxy $
         ,XSIZE=20 ,YSIZE=1, VALUE=exraystr.Pfffile)

  CalcButton_BASE = Widget_Base(Exray_PffWidget_BASE, UNAME='FilterButton_BASE', $
      COLUMN=1,/NonExclusive)

  Wave_BUTTON = Widget_Button(CalcButton_BASE, UNAME='Wave_BUTTON'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Apply Wavelength Scale')

  D2I_BUTTON = Widget_Button(CalcButton_BASE, UNAME='D2I_BUTTON'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Do Film Correction (D2I)')

  Effcor_BUTTON = Widget_Button(CalcButton_BASE, UNAME='Effcor_BUTTON'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Do Efficiency Correction')

  Backsub_BUTTON = Widget_Button(CalcButton_BASE, UNAME='Backsub_BUTTON'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Do Background Subtraction')

  Backsub_BASE = Widget_Base(Exray_PffWidget_BASE, UNAME='Backsub_BASE',COLUMN=2 $
      ,/align_right,Sensitive=0)

  Backsub_LABEL = Widget_Label( Backsub_BASE,  $
      UNAME='Backsub_LABEL',/ALIGN_LEFT,VALUE='Background Filename')

  Backsub_Filename = Widget_Text(Backsub_BASE, UNAME='Backsub_Filename'  $
         ,FRAME=0.5 ,XOFFSET=11 ,YOFFSET=60 ,SCR_XSIZE=300*mxy,SCR_YSIZE=30*mxy $
         ,XSIZE=20 ,YSIZE=1, VALUE=exraystr.backfile)

  dummy_LABEL = Widget_Label( Backsub_BASE,/ALIGN_LEFT,VALUE='')

  Open_Backsub_BUTTON = Widget_Button(Backsub_BASE,  $
      UNAME='Open_Backsub_BUTTON' ,XOFFSET=389 ,YOFFSET=60,SCR_XSIZE=30*mxy,SCR_YSIZE=30*mxy $
      ,/ALIGN_CENTER ,VALUE='images/open.bmp',/BITMAP)

  Open_PffFile_BUTTON = Widget_Button(File_BASE,  $
      UNAME='Open_PffFile_BUTTON' ,XOFFSET=389 ,YOFFSET=60,SCR_XSIZE=30*mxy,SCR_YSIZE=30*mxy $
      ,/ALIGN_CENTER ,VALUE='images/open.bmp',/BITMAP)

  Quit_BASE = Widget_Base(Exray_PffWidget_BASE, UNAME='Quit_BASE' $
      ,COLUMN=2,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Cancel')


  Quit_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Quit_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Run')


;************************************************************************************
;Define the structure to be passed around
;************************************************************************************

  pffstr = {NAME: 'Pff_Structure',$
              PffFilename:Pff_Filename,$
              Pfffile:exraystr.Pfffile,$
              backname:Backsub_Filename,$
              backfile:exraystr.backfile,$
              path:exraystr.path,$
              backbase:Backsub_Base,$
              waveflag:1,$
              effcorflag:1,$
              d2iflag:0,$
              backflag:0,$
              exraystr:exraystr,$
              MainWidget:MainWidget}

  widget_control,Effcor_Button,set_button = 1
  widget_control,Wave_Button,set_button = 1
  widget_control,D2I_Button,set_button = 0
  widget_control,Backsub_Button,set_button = 0

 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  Widget_Control, /REALIZE, Exray_PffWidget_BASE

  Widget_Control, Exray_PffWidget_BASE, set_uvalue = pffstr


  XManager, 'Exray_PffWidget_BASE', Exray_PffWidget_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro Exray_PffWidget, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_PffWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end
