PRO exray_plotfilters,effstr,save=save

   ;get the filter materials and thicknesses
       filtindex=lonarr(3)
       filter=0
       filter=widget_info(effstr.filt1,/Droplist_Select)
       filtindex(0)=filter
       filter=widget_info(effstr.filt2,/Droplist_Select)
       filtindex(1)=filter
       filter=widget_info(effstr.filt3,/Droplist_Select)
       filtindex(2)=filter

       filtwidth=dblarr(3)
       widget_control,effstr.thick1,get_value=filter
       filtwidth(0)=filter
       widget_control,effstr.thick2,get_value=filter
       filtwidth(1)=filter
       widget_control,effstr.thick3,get_value=filter
       filtwidth(2)=filter


   pff=effstr.exraystr.projpath+'atomic_data'+effstr.exraystr.sepchar+'filter_material.pff'
   openpff,pff,fileid=fid

   firstflag=0
   for i=0,2 do begin
      ;retrieve the filter choices (as in the order given in effwidget)
      if (filtindex(i) ne 0) then begin
         ;determine the index of the selected filter in the pff file
         case filtindex(i) of
            1: begin  ;Aluminum
                index=2
                rho=2.6989
               end
            2: begin  ;Beryllium
                index=10
                rho=1.848
               end
            3: begin  ;Kapton
                index=115
                rho=1.42
               end
            4: begin  ;Kimfol
                index=117
                rho=1.20
               end
            5: begin  ;Mylar
                index=122
                rho=1.397
               end
            6: begin  ;Parylene N
                index=126
                rho=1.11
               end
            7: begin  ;Polystyrene
                index=131
                rho=1.056
               end
            8: begin   ;Tantalum
                index=83
                rho=16.654
               end
            9: begin   ;Titanium
                index=91
                rho=4.54
               end
           10: begin   ;Tungsten
                index=92
                rho=19.3
               end
         endcase

         ;get the absorption curve from the pff file (use wdf array 61 as work array)
         re,61,index,fileid=fid
         w2i,energy,sigma,61
         lambda=12398.53/energy ;angstroms
         mu=sigma*rho ;cm^-1
         thickness=filtwidth(i)*1.e-4 ;cm
         ftrans=exp(-1.0*mu*thickness)
         i2w,lambda,ftrans,62

         ;wdf array 63 holds the total filter transmission for all filters
         if (firstflag eq 0) then begin
            if (not keyword_set(save)) then begin
              ;open up a new plot window
               window,30,xsize=500,ysize=400,$
                    xpos=effstr.geo.scr_xsize+(2.*effstr.geo.margin),ypos=0.
               plot,lambda,ftrans,yran=[0,1.0],/ys,xtitle='Wavelength (Angstroms)',$
                    ytitle='Transmission',xrange=[0,40]
            endif
            xfr,62,63
            firstflag=1
         endif else begin
            if (not keyword_set(save)) then $
               oplot,lambda,ftrans,col=firstflag
            mul,63,62
            firstflag=firstflag+1
         endelse

      endif
   endfor

    closepff,fid

    w2i,lambda,ftrans,63

    if keyword_set(save) then begin
      ;save the total transmission
      nametemp=''
      nametemp = dialog_pickfile(title='Save As:', /WRITE,$
                           filter='*.ufo',path=effstr.exraystr.path)
      if (nametemp eq '') then return $
      else if (strpos(nametemp,'.ufo') eq -1) then nametemp=nametemp+'.ufo'
      wufo,lambda,ftrans,file=nametemp
    endif else begin
       oplot,lambda,ftrans,col=firstflag
       legstring=strarr(firstflag+1)
       for i=0,firstflag-1 do legstring(i)='filter #'+strtrim(string(i+1),2)
       legstring(firstflag)='Total'
       legend,legstring,col=[0,1,2,3,4],line=[0,0,0,0],psym=0,pos=[0.7,0.9],/normal

       ;return plotting window to EXRAY GUI
       widget_control,effstr.exraystr.widget.Graphics,GET_VALUE=winID
       wset,winID
    endelse

return
end