PRO exray_plotref, effstr, save=save

   ;get the diffraction order
   n=effstr.exraystr.wsource(0).n(0)

   if (effstr.exraystr.convexflag eq 0) then $ ;elliptical geometry
      whichXstal=widget_info(effstr.exraystr.widget.Xstals,/Droplist_Select) $
   else $ ;convex geometry
      whichXstal=widget_info(effstr.exraystr.widget.XstalC,/Droplist_Select)
   case whichXstal of
      1: begin   ;KAP
         refile=effstr.exraystr.projpath+'crystal_data'+effstr.exraystr.sepchar+$
                  'KAP_'+strtrim(string(n),2)+'.txt'
         xstal='KAP (n='+strtrim(string(n),2)+')'
      end
      2: begin   ;Mica
         refile=effstr.exraystr.projpath+'crystal_data'+effstr.exraystr.sepchar+$
                  'Mica_'+strtrim(string(n),2)+'.txt'
         xstal='Mica (n='+strtrim(string(n),2)+')'
      end
      3: begin   ;PET
         refile=effstr.exraystr.projpath+'crystal_data'+effstr.exraystr.sepchar+$
                  'PET_'+strtrim(string(n),2)+'.txt'
         xstal='PET (n='+strtrim(string(n),2)+')'
      end
      6: begin   ;LiF(220)
         refile=effstr.exraystr.projpath+'crystal_data'+effstr.exraystr.sepchar+$
                  'LiF220_'+strtrim(string(n),2)+'.txt'
         xstal='LiF (220) (n='+strtrim(string(n),2)+')'
      end
      7: begin   ;LiF(200)
         refile=effstr.exraystr.projpath+'crystal_data'+effstr.exraystr.sepchar+$
                  'LiF200_'+strtrim(string(n),2)+'.txt'
         xstal='LiF (200) (n='+strtrim(string(n),2)+')'
      end
   endcase

   readasc,refile,10,xt,yt
   lambda=yt(*,8)            ;Angstroms

   if keyword_set(save) then begin
      ;save the selected reflectivity
      case effstr.refflag of
         0:  ref=((yt(*,2)+yt(*,3))*1.e-3)/2.  ;average
         1:  ref=yt(*,2)*1.e-3                 ;Prins
         2:  ref=yt(*,3)*1.e-3                 ;Mosaic
      endcase
      nametemp=''
      nametemp = dialog_pickfile(title='Save As:', /WRITE,$
                           filter='*.ufo',path=effstr.exraystr.path)
      if (nametemp eq '') then return $
      else if (strpos(nametemp,'.ufo') eq -1) then nametemp=nametemp+'.ufo'
      wufo,lambda,ref,file=nametemp

   endif else begin
      ;open up a new plot window
      window,30,xsize=500,ysize=400,$
          xpos=effstr.geo.scr_xsize+(2.*effstr.geo.margin),ypos=0.

      ymax=max([yt(*,2),yt(*,3)])*1.e-3
      ymin=min([yt(*,2),yt(*,3)])*1.e-3
      plot,lambda,yt(*,2)*1.e-3,/xl,/yl,xtitle='Wavelength (Angstroms)',yran=[ymin,ymax],$
           ytitle='Reflectivity (Radians)',title='Henke Tabulated Values for '+xstal
      oplot,lambda,yt(*,3)*1.e-3,col=1
      oplot,lambda,((yt(*,2)+yt(*,3))*1.e-3)/2.,col=3
      legend,['Prins','Mosaic','Average'],line=[0,0,0],col=[0,1,3],psym=0,pos=[0.7,0.9],/normal

     ;return plotting window to EXRAY GUI
      widget_control,effstr.exraystr.widget.Graphics,GET_VALUE=winID
      wset,winID
   endelse

return
end