

pro Exray_PrintWhere_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = printstr

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='Printers_DROPLIST'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_DROPLIST' )then begin
          printstr.theprinter=Event.Index
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='ToPrinter_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
         if (event.select eq 0) then begin
            printstr.towhere = 1
            widget_control,printstr.printerlist,sensitive=0
         endif else begin
            printstr.towhere = 0
            widget_control,printstr.printerlist,sensitive=01
         endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='ToFile_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
         if (event.select eq 0) then begin
            printstr.towhere = 0
            widget_control,printstr.printerlist,sensitive=1
         endif else begin
            printstr.towhere = 1
            widget_control,printstr.printerlist,sensitive=0
         endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Quit_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
       ;print to the appropriate place
        if (printstr.towhere eq 0) then begin
           widget_control,printstr.control,MAP=0
           widget_control,printstr.printing,MAP=1
           set_printer,dest=printstr.printers(printstr.theprinter)
           printstr.exraystr.activeprinter=printstr.theprinter
           currentdevice=!D.NAME
           printpic=tvrd(TRUE=1)
           set_plot,'ps'
           device,file='exrayplot.ps',/color
           tv,printpic,TRUE=1
           Device,/Close
           lprint,file='exrayplot.ps'
           spawn,'rm -f exrayplot.ps'
           set_plot,currentdevice
           if (!p.background eq 0) then swap
        endif else begin
           nametemp = ''
           nametemp = dialog_pickfile(title='Save As:', /WRITE,$
                           filter=['*.ps'],/FIX_FILTER)
           if (nametemp eq '') then return $
           else if (strpos(nametemp,'.ps') eq -1) then nametemp=nametemp+'.ps'
           widget_control,printstr.control,MAP=0
           widget_control,printstr.printing,MAP=1
           currentdevice=!D.NAME
           printpic=tvrd(TRUE=1)
           set_plot,'ps'
           device,file=nametemp,/color
           tv,printpic,TRUE=1
           Device,/Close
           set_plot,currentdevice
           if (!p.background eq 0) then swap
        endelse
        Widget_Control, printstr.MainWidget, set_uvalue = printstr.exraystr
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;quit without saving anything
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = printstr


end

pro Exray_PrintWhere_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control, MainWidget, get_uvalue = exraystr

  Exray_PrintWhere_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_PrintWhere_BASE' ,XOFFSET=5 ,YOFFSET=5, $
      TITLE='Print' ,SPACE=3 ,XPAD=3 ,YPAD=3)

  Printing_BASE = Widget_Base( Exray_PrintWhere_BASE,UNAME='Printing_BASE' $
      ,COLUMN=1,MAP=0)

  Printing_LABEL = Widget_Label(Printing_BASE,  $
      UNAME='Printing_LABEL',/ALIGN_LEFT ,VALUE='Printing...')


  Control_BASE = Widget_Base( Exray_PrintWhere_BASE,UNAME='Control_BASE' $
      ,COLUMN=1,MAP=1)

  Info_Base = Widget_BASE(Control_BASE,UNAME='Info_BASE',Column=2)

  Button_BASE = Widget_Base(Info_Base,  $
      UNAME='Button_BASE', Column = 1,/Exclusive)

  ToPrinter_BUTTON = Widget_Button(Button_BASE, UNAME='ToPrinter_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Print to printer')

  ToFile_BUTTON = Widget_Button(Button_BASE, UNAME='ToFile_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Print to post-script file')


  Printers_DROPLIST = Widget_DROPLIST(Info_Base,  $
        UNAME='Printers_DROPLIST' ,VALUE=exraystr.printers,TITLE='Destination:')

  Quit_BASE = Widget_Base(Control_BASE, UNAME='Quit_BASE' $
      ,COLUMN=2,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60 ,SCR_YSIZE=36 ,/ALIGN_CENTER  $
      ,VALUE='Cancel')


  Quit_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Quit_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60 ,SCR_YSIZE=36 ,/ALIGN_CENTER  $
      ,VALUE='OK')


;************************************************************************************
;Define the structure to be passed around
;************************************************************************************

  widget_control,ToPrinter_Button,Set_Button = 1
  widget_control,Printers_DROPLIST,Set_Droplist_Select = exraystr.activeprinter

  printstr = {NAME: 'PrintWhere_Structure',$
              printing:Printing_BASE,$
              Control:Control_BASE,$
              printerlist:Printers_DROPLIST,$
              printers:exraystr.printers,$
              towhere:long(0),$
              theprinter:long(exraystr.activeprinter),$
              exraystr:exraystr,$
              MainWidget:MainWidget}


 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  Widget_Control, /REALIZE, Exray_PrintWhere_BASE

  Widget_Control, Exray_PrintWhere_BASE, set_uvalue = printstr


  XManager, 'Exray_PrintWhere_BASE', Exray_PrintWhere_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro exray_printwhere, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_PrintWhere_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end
