PRO exray_rebin, MainWidget

Widget_Control, MainWidget, get_uvalue = exraystr
widget_control,exraystr.widget.Graphics,GET_VALUE=winID
wset,winID

if (exraystr.plotflag eq 4) then begin
   w2i,xorig,yorig,exraystr.scaledwdf(exraystr.activedata)
endif else begin
   w2i,xorig,yorig,exraystr.datawdf(exraystr.activedata)
endelse

ndp=n_elements(xorig)

if (exraystr.wfilm.rebinflag eq 0) then begin
   ;Manual slope input (mA/px)
   nslope=exraystr.wfilm.rebinslope
endif else begin
   ;Determine spacing from dispersion
   tempstr=replicate(exraystr,1)
   tempstr.autoflag = 1
   if (exraystr.convexflag ne 1) then $
      exray_buildptr,tempstr,temptr $
   else $
      exray_convex_buildptr,tempstr,temptr

   numsource=(*temptr).numsource
   ahold=dblarr(numsource)
   bhold=dblarr(numsource)
   if (exraystr.convexflag ne 1) then begin
      ahold(*)=(*temptr).source(*).a
      bhold(*)=(*temptr).source(*).b
   endif else begin
      ahold(*)=(*temptr).source(*).a(0)
      bhold(*)=(*temptr).source(*).b(0)
   endelse

   (*temptr).numsource=1
   if (exraystr.convexflag ne 1) then begin
      (*temptr).source(0).a=-(*temptr).xstal(0).R0
      (*temptr).source(0).b=0.
      exray_go,50,temptr,windID=winID,/noprint
      for i=0,numsource-1 do begin
         (*temptr).source(0).a=ahold(i)
         (*temptr).source(0).b=bhold(i)
         exray_go,51+i,temptr,windID=winID,/noprint
      endfor
   endif else begin
      exray_convex_go,50,temptr,windID=winID,/noprint
      for i=0,numsource-1 do begin
         (*temptr).source(0).a(0)=ahold(i)
         (*temptr).source(0).b(0)=bhold(i)
         exray_convex_go,51+i,temptr,windID=winID,/noprint
      endfor
   endelse

   w2i,xlam,ylam,50 ;ylam is the lambda values
   if (n_elements(xlam) le 2) then begin
      whoops=dialog_message($
    'An Error Occured During the Dispersion Calculation...Please Check All Parameters',/ERROR)
   return
   endif
   dif,50,60        ;60 contains the ideal dispersion (dlambda/dx) in A/cm
   w2i,xdisp,ydisp,60
   ndisp=n_elements(ydisp)
   avgdisp=total(ydisp)/ndisp
   dres=exraystr.wfilm.dres
   nslope=avgdisp*dres*1.e-4*1000.  ;slope is in mA/px
endelse

cslope=total(xorig(1:ndp-1)-xorig(0:ndp-2))/(ndp-1.)*1000.
rfac=long(nslope/cslope)
numpoints=ndp/rfac
xnew=rebin(xorig(0:long(rfac*numpoints)-1),numpoints)
ynew=rebin(yorig(0:long(rfac*numpoints)-1),numpoints)

plot,xorig,yorig,xran=exraystr.xrange,yran=exraystr.yrange,/xs,/ys,$
   Title='Rebin Factor = '+strtrim(string(rfac),2)
oplot,xnew,ynew,col=1
wait,1.0
legend,['Orignial','Re-binned'],col=[0,1],line=[0,0]

ans=dialog_message('Would you like to continue with the re-bin?',/question)

if (ans eq 'Yes') then begin
   if (exraystr.plotflag eq 4) then begin
      i2w,xnew,ynew,exraystr.scaledwdf(exraystr.activedata)
   endif else begin
      i2w,xnew,ynew,exraystr.datawdf(exraystr.activedata)
   endelse
endif

   plotflag=exraystr.plotflag
   ;exraystr.plotflag = 0
   widget_control,MainWidget,set_uvalue=exraystr
   widget_control,exraystr.widget.plotlist,send_event=$
      { WIDGET_DROPLIST, ID:exraystr.widget.plotlist, TOP:MainWidget, $
         HANDLER:MainWidget, INDEX:plotflag }

Widget_Control, MainWidget, set_uvalue = exraystr

return
end