

pro Exray_RelTransWidget_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = reltranstr

case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='Reset_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;reset all values
        reltranstr.xpick(*) = 0.
        reltranstr.numpick = 0
        tv,reltranstr.exraystr.image,TRUE=1 ;redraw the background image
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Done_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin

       if (reltranstr.numpick lt 3) then begin
         ;not enough points selected
         whoops=dialog_message('You must select 4 points!',/Error)
         return
       endif

       data=104
       w2i,x1,y1,data
       pickx=reltranstr.xpick
       pickx=pickx(sort(pickx))
       index=where(((x1 ge pickx(0)) and (x1 le pickx(1))) $
              or   ((x1 ge pickx(2)) and (x1 le pickx(3))))
       xnew=dblarr(n_elements(index))
       ynew=dblarr(n_elements(index))
       xnew=x1(index)
       ynew=y1(index)

       if (reltranstr.adjustflag eq 0) then begin
          ;Calculate and adjust the background curve
          widget_control,reltranstr.reset,sensitive = 0
          ;wdf array 103 will be the temporary data holder
;          exray_spectroback,103, $
;             pickx,degree=4,/plotz,yrange=[mn(103),mx(103)],/fit3
          i2w,xnew,ynew,105,/xy
          wdfit3,105,103,/Exact_Range
          reltranstr.adjustflag = 1
          widget_control,reltranstr.text,set_value='Click "Done" when finished'
       endif else if (reltranstr.adjustflag eq 1) then begin
          reltranstr.adjustflag = 0
          w2i,xback,yback,103
          yback=interpol(yback,xback,x1)
          ytrans=y1/yback
          i2w,x1,ytrans,103,/xy
          plo,103,line=0,psym=0,col=0,leg=-1,yran=[0,mx(104)]
          oplot,x1,yback,col=1
          oplot,x1,y1,col=3
          legend,['Input','Fit','Result'],col=[3,1,0],line=[0,0,0],pos=[x1(0),0.2]
          ans = dialog_message('Are you happy with this fit? (y/n)',/Question)
          if (ans eq 'Yes') then begin
             ;save the relative transmission spectrum and quit
             xfr,103,reltranstr.exraystr.scaledwdf(reltranstr.exraystr.activedata)
             widget_control,reltranstr.exraystr.widget.Graphics,GET_VALUE=winID
             wset,winID
             reltranstr.exraystr.plotflag = 0
             widget_control,reltranstr.MainWidget,set_uvalue=reltranstr.exraystr
             widget_control,reltranstr.exraystr.widget.plotlist,send_event=$
                { WIDGET_DROPLIST, ID:reltranstr.exraystr.widget.plotlist, $
                 TOP:reltranstr.MainWidget,HANDLER:reltranstr.MainWidget, INDEX:4 }
             widget_control, Event.top, /DESTROY
             return
          endif else begin
             reltranstr.adjustflag = 0
             reltranstr.xpick(*) = 0.
             reltranstr.numpick = 0
             widget_control,reltranstr.reset,sensitive = 1
             widget_control,reltranstr.done,sensitive = 1
             widget_control,reltranstr.graph,draw_motion_events=1
             widget_control,reltranstr.graph,draw_button_events=1
             widget_control,reltranstr.text,set_value= $
                         ['Please select four points (in any order):',$
                          '1: The left edge of the background data',$
                          '2: The right edge of the background data',$
                          '3: The left edge of the spectral features',$
                          '4: The right edge of the spectral features']
             plo,104,col=0,line=0,xrange=reltranstr.exraystr.xrange,$
                 yrange=reltranstr.exraystr.yrange,leg=-1,xtitle='Wavelength (Angstroms)',$
                 pos=[0.15,0.1,0.95,0.957],xstyle=1,ystyle=1,psym=0
             reltranstr.exraystr.image=tvrd(TRUE=1) ;save the background image
          endelse
        endif
      endif
    end
     Widget_Info(wWidget, FIND_BY_UNAME='GRAPHICS_DRAW'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_DRAW' )then begin
        ;picking the required points
        pxmin = 0.15 ;the x position of the plot lower left corner (in fraction of window height)
        wdx=404.     ;the window width
        pdx = 0.8    ;the plot width (in fraction of window height)
        dxdp=(reltranstr.exraystr.xrange(1)-reltranstr.exraystr.xrange(0))/(pdx*wdx)
        xnow=(event.x-(pxmin*wdx))*dxdp+reltranstr.exraystr.xrange(0)

        if (Event.type eq 1) then begin
           w2i,xtemp,ytemp,reltranstr.exraystr.scaledwdf(reltranstr.exraystr.activedata)
           index = where(xtemp ge xnow)
           if (index(0) ge 0) then $
             reltranstr.xpick(reltranstr.numpick)=xtemp(index(0)) $
           else $
             reltranstr.xpick(reltranstr.numpick)=xtemp(0)
           for i=0,reltranstr.numpick do $
             plots,[reltranstr.xpick(i),reltranstr.xpick(i)],$
                reltranstr.exraystr.yrange,line=0,col=i
           reltranstr.numpick = reltranstr.numpick+1
;           reltranstr.exraystr.image=tvrd(TRUE=1) ;save the background image
           if (reltranstr.numpick gt 3) then begin
              ;done picking points...
              widget_control,reltranstr.graph,draw_motion_events=0
              widget_control,reltranstr.graph,draw_button_events=0
           endif
        endif else if (Event.type eq 2) then begin
          ;plot the ruler line
          tv,reltranstr.exraystr.image,TRUE=1 ;redraw the background image
          for i=0,reltranstr.numpick-1 do $
             plots,[reltranstr.xpick(i),reltranstr.xpick(i)],$
                reltranstr.exraystr.yrange,line=0,col=i
          plots,[xnow,xnow],$
                [reltranstr.exraystr.yrange(1),reltranstr.exraystr.yrange(0)],line=0,$
                col=reltranstr.numpick
        endif
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;quit without saving anything
        widget_control,reltranstr.exraystr.widget.Graphics,GET_VALUE=winID
        wset,winID
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = reltranstr


end

pro Exray_RelTransWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control, MainWidget, get_uvalue = exraystr
  mxy=exraystr.mxy

  Exray_RelTransWidget_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_RelTransWidget_BASE', Column = 1, $
      TITLE='Absolute Transmission' ,SPACE=3 ,XPAD=3 ,YPAD=3)

  Control_BASE = Widget_Base(Exray_RelTransWidget_BASE,Column=3)

  Graphics_TEXT = Widget_TEXT(Control_BASE,  $
      UNAME='Graphics_TEXT' ,YSIZE = 5 ,XSIZE = 42, Frame = 0$
      ,/ALIGN_CENTER,VALUE=['Please select four points (in any order):',$
                          '1: The left edge of the background data',$
                          '2: The right edge of the background data',$
                          '3: The left edge of the spectral features',$
                          '4: The right edge of the spectral features'])

  Reset_BUTTON = Widget_Button(Control_BASE,  $
      UNAME='Reset_BUTTON' ,FRAME=1, VALUE='Reset')
  Done_BUTTON = Widget_Button(Control_BASE,  $
      UNAME='Done_BUTTON' ,FRAME=1, VALUE='Done')

  Graphics_DRAW = Widget_Draw(Exray_RelTransWidget_BASE, UNAME='GRAPHICS_DRAW'  $
      ,XOFFSET=12 ,YOFFSET=117 ,SCR_XSIZE=404*mxy ,SCR_YSIZE=377*mxy $
      ,XSIZE=404,YSIZE=377,FRAME=0.5,/BUTTON_EVENTS,/MOTION_EVENTS)

  Quit_BASE = Widget_Base(Exray_RelTransWidget_BASE, UNAME='Quit_BASE' $
      ,COLUMN=2,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Cancel')

;************************************************************************************
;Define the structure to be passed around
;************************************************************************************

  widget_control,Graphics_DRAW,GET_VALUE=winID
  wset,winID


  reltranstr = {NAME: 'RelTrans_Structure',$
              Graph:Graphics_DRAW,$
              text:Graphics_TEXT,$
              reset:Reset_BUTTON,$
              done:Done_BUTTON,$
              adjustflag:long(0),$
              xpick:dblarr(4),$
              numpick:long(0),$
              exraystr:exraystr,$
              MainWidget:MainWidget}

 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  Widget_Control, /REALIZE, Exray_RelTransWidget_BASE

  plo,exraystr.scaledwdf(exraystr.activedata),col=0,line=0,xrange=exraystr.xrange,yrange=exraystr.yrange $
       ,leg=-1,xtitle='Wavelength (Angstroms)',pos=[0.15,0.1,0.95,0.957],xstyle=1,ystyle=1 $
       ,psym=0
  reltranstr.exraystr.image=tvrd(TRUE=1) ;save the background image

  xfr,exraystr.scaledwdf(exraystr.activedata),104

  Widget_Control, Exray_RelTransWidget_BASE, set_uvalue = reltranstr


  XManager, 'Exray_RelTransWidget_BASE', Exray_RelTransWidget_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro Exray_RelTransWidget, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_RelTransWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end
