PRO Exray_ResCalc,exraystr,windID=winID

wset,winID

tempstr=replicate(exraystr,1)
tempstr.autoflag = 1
if (exraystr.convexflag ne 1) then $
   exray_buildptr,tempstr,temptr $
else $
   exray_convex_buildptr,tempstr,temptr

numsource=(*temptr).numsource
ahold=dblarr(numsource)
bhold=dblarr(numsource)
if (exraystr.convexflag ne 1) then begin
   ahold(*)=(*temptr).source(*).a
   bhold(*)=(*temptr).source(*).b
endif else begin
   ahold(*)=(*temptr).source(*).a(0)
   bhold(*)=(*temptr).source(*).b(0)
endelse

(*temptr).numsource=1
if (exraystr.convexflag ne 1) then begin
   (*temptr).source(0).a=-(*temptr).xstal(0).R0
   (*temptr).source(0).b=0.
   exray_go,50,temptr,windID=winID,/noprint
   for i=0,numsource-1 do begin
      (*temptr).source(0).a=ahold(i)
      (*temptr).source(0).b=bhold(i)
      exray_go,51+i,temptr,windID=winID,/noprint
   endfor
endif else begin
   exray_convex_go,50,temptr,windID=winID,/noprint
   for i=0,numsource-1 do begin
      (*temptr).source(0).a(0)=ahold(i)
      (*temptr).source(0).b(0)=bhold(i)
      exray_convex_go,51+i,temptr,windID=winID,/noprint
   endfor
endelse

w2i,xlam,ylam,50 ;ylam is the lambda values
if (n_elements(xlam) le 2) then begin
   whoops=dialog_message($
    'An Error Occured During the Resolution Calculation...Please Check All Parameters',/ERROR)
   return
endif
dif,50,60        ;60 contains the ideal dispersion (dlambda/dx)
mul,60,0,1.e-4*100.,61  ;61 contains delta lambda assuming a 100 micron resolution element
div,50,61,70     ;70 contains the ideal resolution
w2i,xideal,yideal,70

if (exraystr.wfilm.circleflag eq 0) then $
   xcommon=findgen(1000)*(*temptr).film.L/1000.$
else $
   xcommon=findgen(10000)*(*temptr).film.rf*!pi/2./10000. ;the film is big
ylam=interpol(ylam,xlam,xcommon)
yideal=interpol(yideal,xideal,xcommon)
if (numsource eq 1) then begin
   if (exraystr.plotflag ne 2) then begin
      exraystr.xrange=[min(ylam),max(ylam)]
      exraystr.yrange=[min(yideal),max(yideal)]
   endif
   plot,ylam,yideal,col=0,xtitle='Wavelength (A)',ytitle='Resolution' $
       ,charsize=1.2, pos=[0.15,0.1,0.95,0.957],xstyle=1,ystyle=1,psym=0 $
       ,xrange=exraystr.xrange,yrange=exraystr.yrange
   delwdf,[50,60,61,70]
   return
endif

;ysdisp=dblarr(1000)
;for i=51,51+numsource-1 do begin
;   sub,50,i,i+10  ;i+10 contains the difference in film position
;   w2i,xtemp,ytemp,i+10
;   if (n_elements(xtemp) gt 2) then begin
;      ytemp=abs(ytemp)
;      ytemp=interpol(ytemp,xtemp,xcommon)
;      for j=0,999 do begin
;        if (ytemp(j) gt ysdisp(j)) then begin
;           ysdisp(j) = ytemp(j)
;        endif
;      endfor
;      i2w,xcommon,ysdisp,70 ;70 contains the maximum difference in film position
;   endif
;   delwdf,[i,i+10]
;endfor

;add,70,0,1.e-4*100.,62 ;62 contains the convolved delta x assuming 100 micron res element
;mul,60,62,63 ;63 contains the total delta lambda
;div,50,63,64 ;64 contains the worst-case source-broadened resolution

;w2i,xsb,ysb,64
;ysb=interpol(ysb,xsb,xcommon)

xmax=dblarr(1000)
xmin=dblarr(1000)
xmax(*)=xcommon(*)
xmin(*)=xcommon(*)
maxdisp=60
mindisp=60
for i=51,51+numsource-1 do begin
   w2i,xtemp,ytemp,i
   if (n_elements(xtemp) gt 2) then begin
      xtemp=interpol(xtemp,ytemp,ylam)
      dif,i,i+10 ;i+10 contains the dispersion for this source
      for j=0,999 do begin
         if (xtemp(j) gt xmax(j)) then begin
            xmax(j)=xtemp(j) ;the maximum film position for this wavelength
            maxdisp=i+10 ;the dispersion for this source point
         endif
         if (xtemp(j) lt xmin(j)) then begin
            xmin(j)=xtemp(j) ;the minimum film position for this wavelength
            mindisp=i+10 ;the dispersion for this source point
         endif
      endfor
      delwdf,i
   endif
endfor

fwhm=1.0e-4*100 ;assuming a 100 micron channel-plate induced broadening
w2i,xmaxdisp,ymaxdisp,maxdisp ;the dispersion at the maximum film position
ymaxdisp=interpol(ymaxdisp,xmaxdisp,xcommon)
w2i,xmindisp,ymindisp,mindisp ;the dispersion at the minimum film position
ymindisp=interpol(ymindisp,xmindisp,xcommon)
deltalam=ymaxdisp*(fwhm/2.+xmax)+ymindisp*(fwhm/2.-xmin)
ysb=ylam/deltalam

if (exraystr.plotflag ne 2) then begin
    exraystr.xrange=[min(ylam),max(ylam)]
    exraystr.yrange=[min(ysb),max(yideal)]
endif
plot,ylam,yideal,col=0,xtitle='Wavelength (A)',ytitle='Resolution',charsize=1.2,psym=0 $
    ,xstyle=1,ystyle=1,xrange=exraystr.xrange,yrange=exraystr.yrange, pos=[0.15,0.1,0.95,0.957]
oplot,ylam,ysb,col=1
legend,['Ideal Resolution','Source-Broadened'],col=[0,1],line=[0,0]

delwdf,[50,60,70]

ptr_free,temptr
return
end