

pro Exray_RescaleWidget_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = restr

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='Go_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
       ;save the values in 'global' variables and calculate the result
       widget_control,restr.degree,get_value=deg
       widget_control,restr.guess,get_value=res1
       widget_control,restr.bins,get_value=bin
       poisson = WIDGET_INFO(restr.poiss,/button_set )
       restr.exraystr.wfilm.redeg = deg
       restr.exraystr.wfilm.reguess = res1
       restr.exraystr.wfilm.numbins = bin
       restr.exraystr.wfilm.distflag = poisson
       widget_control,restr.MainWidget,set_uvalue=restr.exraystr
       widget_control, Event.top, /DESTROY
       exray_rescale,restr.MainWidget,degree=deg,rescale=res1,bins=bin,poisson=poisson
       return
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;quit without saving anything
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = restr


end

pro Exray_RescaleWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control, MainWidget, get_uvalue = exraystr
  mxy=exraystr.mxy

  Exray_RescaleWidget_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_RescaleWidget_BASE', Column = 1,/align_left, $
      TITLE='Rescale to Counts Correction' ,SPACE=3 ,XPAD=3 ,YPAD=3)

  Message_LABEL = Widget_Label(Exray_RescaleWidget_BASE,/align_left,Value='Before running this correction:')
  Message_LABEL = Widget_Label(Exray_RescaleWidget_BASE,/align_left,Value='   - Have the noise-range zoomed in the window.')
  ;Message_LABEL = Widget_Label(Exray_RescaleWidget_BASE,/align_left,Value='   - ')
  ;Message_LABEL = Widget_Label(Exray_RescaleWidget_BASE,/align_left,Value='   - ')

  Message_LABEL = Widget_Label(Exray_RescaleWidget_BASE,Value='')

  Input_Base = Widget_Base(Exray_RescaleWidget_BASE,column=1)

  Order_Field = CW_Field(Input_Base,UNAME='Order_FIELD' $
                        ,Title='Degree of Background Fit ',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.wfilm.redeg)
;  dummy_LABEL = Widget_Label(Input_BASE,Value='')

  Guess_Field = CW_Field(Input_BASE,UNAME='Guess_FIELD' $
                        ,Title='Starting Guess for Rescale ',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.wfilm.reguess)

  Bins_Field = CW_Field(Input_BASE,UNAME='Bins_FIELD' $
                        ,Title='Number of Bins in Histogram ',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.wfilm.numbins)

  Dist_LABEL = Widget_Label(Input_BASE,Value='Distribution for Fit')

  Dist_BASE = Widget_Base(Input_BASE, UNAME='Dist_BASE', $
      COLUMN=1,/Exclusive,Frame=1)

  Gauss_Button = Widget_Button(Dist_BASE, UNAME='Gauss_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Gaussian')

  Poisson_Button = Widget_Button(Dist_BASE, UNAME='Poisson_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Poisson')

  Quit_BASE = Widget_Base(Exray_RescaleWidget_BASE, UNAME='Quit_BASE' $
      ,COLUMN=2,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Cancel')


  Go_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Go_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Calculate')


;************************************************************************************
;Define the structure to be passed around
;************************************************************************************

  restr = {NAME: 'Options_Structure',$
              degree:Order_FIELD,$
              guess:Guess_FIELD,$
              bins:Bins_Field,$
              gauss:Gauss_BUTTON,$
              poiss:Poisson_BUTTON,$
              exraystr:exraystr,$
              MainWidget:MainWidget}


 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  if (exraystr.wfilm.distflag eq 0) then $
     Widget_Control,Gauss_Button,set_button=1  $
  else $
     Widget_Control,Poisson_Button,set_button=1

  Widget_Control, /REALIZE, Exray_RescaleWidget_BASE

  Widget_Control, Exray_RescaleWidget_BASE, set_uvalue = restr


  XManager, 'Exray_RescaleWidget_BASE', Exray_RescaleWidget_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro Exray_RescaleWidget, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_RescaleWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end