

pro Exray_ScaleOpt_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = optstr

  case Event.id of

   Widget_Info(wWidget, FIND_BY_UNAME='Auto_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 1) then begin
           optstr.fitflag = 0
        endif
      endif
    end
   Widget_Info(wWidget, FIND_BY_UNAME='Group1_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 1) then begin
           optstr.fitflag = 2
        endif
      endif
    end
   Widget_Info(wWidget, FIND_BY_UNAME='Specify_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 1) then begin
           optstr.fitflag = 1
        endif
      endif
    end
   Widget_Info(wWidget, FIND_BY_UNAME='Transitions_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 1) then begin
           exray_transwidget,wWidget
           Widget_Control,wWidget,get_uvalue=optstr
        endif else optstr.exraystr.whichelements(*)=0
      endif
    end
   Widget_Info(wWidget, FIND_BY_UNAME='SelectTransitions_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
           exray_transwidget,wWidget
           Widget_Control,wWidget,get_uvalue=optstr
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Quit_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
       ;save the values in 'global' variables
       whoops = ''
       if (optstr.fitflag eq 1) then begin
          tmp1 = double(0.)
          tmp2 = double(0.)
          tmp3 = double(0.)
          Widget_Control, optstr.minwave, get_value = tmp1
          Widget_Control, optstr.maxwave, get_value = tmp2
          Widget_Control, optstr.intwave, get_value = tmp3
          if ((tmp2 le tmp1) or (tmp1 le 0.)) or (tmp3 gt tmp2-tmp1) then $
             whoops=dialog_message('You have entered an invalid wavelength range.',/Error)
       endif
       tmp=long(0)
       Widget_Control, optstr.fit,get_value=tmp
       if (tmp lt 0) or (tmp gt 10) then $
          whoops=dialog_message('You have entered an invalid polynomial order.',/Error)
       if (whoops eq '') then begin
          if (optstr.fitflag eq 1) then begin
             optstr.exraystr.minwave=tmp1
             optstr.exraystr.maxwave=tmp2
             optstr.exraystr.intwave=tmp3
          endif else begin
             optstr.exraystr.minwave=0.0
             optstr.exraystr.maxwave=0.0
             optstr.exraystr.intwave=0.0
          endelse
          optstr.exraystr.fitorder=tmp
          optstr.exraystr.fitflag=optstr.fitflag
          Widget_Control, optstr.MainWidget, set_uvalue = optstr.exraystr
          widget_control, Event.top, /DESTROY
          return
       endif
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;quit without saving anything
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = optstr


end

pro Exray_ScaleOpt_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control, MainWidget, get_uvalue = exraystr
  mxy=exraystr.mxy

  Exray_ScaleOpt_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_ScaleOpt_BASE' ,XOFFSET=5 ,YOFFSET=5, Column = 1, $
      TITLE='Scaling Options' ,SPACE=3 ,XPAD=3 ,YPAD=3,/Base_Align_Right)

  FitOrder_Field = CW_Field(Exray_ScaleOpt_BASE,UNAME='FitOrder_FIELD' $
                        ,Title='Degree of Polynomial Fit',/Return_Events,/long,xsize=5 $
                        ,Value=exraystr.fitorder)

  ScaleRange_LABEL = Widget_Label(Exray_ScaleOpt_BASE,  $
      UNAME='ScaleRange_LABEL' ,/ALIGN_CENTER,VALUE='Wavelength Range for Scaling Fit')

  ScaleRange_BASE = Widget_Base(Exray_ScaleOpt_BASE,  $
      UNAME='ScaleRange_BASE', Column = 1, Frame=1,/Align_center,/Base_Align_Right)

  Autoscale_BASE = Widget_Base(ScaleRange_BASE,  $
      UNAME='Autoscale_BASE', Column = 1, /Exclusive,/Align_center)

  Auto_Button = Widget_Button(Autoscale_BASE, UNAME='Auto_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Automatic')

  Group1_Button = Widget_Button(Autoscale_BASE, UNAME='Group1_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Use Group 1')

  Specify_Button = Widget_Button(Autoscale_BASE, UNAME='Specify_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Specify Range')

  Min_Field = CW_Field(ScaleRange_BASE,UNAME='Min_FIELD' $
                        ,Title='minimum (A)',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.minwave)

  Max_Field = CW_Field(ScaleRange_BASE,UNAME='Max_FIELD' $
                        ,Title='maximum (A)',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.maxwave)

  Int_Field = CW_Field(ScaleRange_BASE,UNAME='Int_FIELD' $
                        ,Title='interval (A)',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.intwave)

  Transitions_LABEL = Widget_Label(Exray_ScaleOpt_BASE,  $
      UNAME='Transitions_LABEL' ,/ALIGN_CENTER,VALUE='Known Atomic Transitions')

  Transitions_BASE = Widget_Base(Exray_ScaleOpt_BASE,  $
      UNAME='Transitions_BASE', Column = 2, Frame=1,/Align_center)

  TransitionsButton_BASE = Widget_Base(Transitions_BASE,  $
      UNAME='TransitionsButton_BASE', Column = 1, /NonExclusive,/Align_center)

  Transitions_Button = Widget_Button(TransitionsButton_BASE, UNAME='Transitions_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Overlay Transitions')

  SelectTransitions_Button = Widget_Button(Transitions_BASE, UNAME='SelectTransitions_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Select',SCR_XSIZE=60*mxy ,SCR_YSIZE=26*mxy)

  Quit_BASE = Widget_Base(Exray_ScaleOpt_BASE, UNAME='Quit_BASE' $
      ,COLUMN=2,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Cancel')


  Quit_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Quit_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Done')


;************************************************************************************
;Define the structure to be passed around
;************************************************************************************

  optstr = {NAME: 'Options_Structure',$
              fit:FitOrder_FIELD,$
              minwave:Min_FIELD,$
              maxwave:Max_FIELD,$
              auto:Auto_BUTTON,$
              group1:Group1_BUTTON,$
              specify:Specify_BUTTON,$
              intwave:Int_FIELD,$
              transitions:Transitions_BUTTON,$
              fitflag:long(0),$
              exraystr:exraystr,$
              MainWidget:MainWidget}
  if (exraystr.fitflag eq 0) then begin
     widget_control,auto_Button,set_button = 1
     optstr.fitflag = 0
  endif else if (exraystr.fitflag eq 1) then begin
     widget_control,Specify_Button,set_button = 1
     optstr.fitflag = 1
  endif else begin
     widget_control,Group1_Button,set_button = 1
     optstr.fitflag = 2
  endelse

  index=where(exraystr.whichelements gt 0)
  if (index(0) ge 0) then widget_control,Transitions_BUTTON,set_button=1

 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  Widget_Control, /REALIZE, Exray_ScaleOpt_BASE

  Widget_Control, Exray_ScaleOpt_BASE, set_uvalue = optstr


  XManager, 'Exray_ScaleOpt_BASE', Exray_ScaleOpt_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro Exray_ScaleOpt, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_ScaleOpt_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end
