PRO EXRAY_CONVEX_FILMPOSITION,convexptr,whichxstal,whichsource,whichorder,whichlambda

rf=(*convexptr).film.rf
phi=(*convexptr).film.phi
mu=(*convexptr).film.mu
L=(*convexptr).film.L
beta=(*convexptr).xstal(whichxstal).beta(whichorder,whichlambda)
xc=(*convexptr).xstal(whichxstal).xc(whichsource,whichorder,whichlambda)
yc=(*convexptr).xstal(whichxstal).yc(whichsource,whichorder,whichlambda)
rc0=(*convexptr).xstal(0).rc
chi=(*convexptr).xstal(0).chi
circleflag=(*convexptr).film.circleflag

if ((xc eq 0) and (yc eq 0)) then return ;the x-ray won't diffract off this crystal

if (circleflag ne 1) then begin
   ;calculate the film position for linear film
   xf0=rf*cos(phi) ;-rc0*sin(chi)
   yf0=rf*sin(phi)+rc0 ;+rc0*cos(chi)
   yfminus=yf0-L/2.*sin(mu)

   xlambda=((yc-yf0)-xf0*tan(mu)+xc*tan(beta))/(tan(beta)-tan(mu))
   ylambda=yf0+tan(mu)*(xf0-xlambda)
   dlambda=(ylambda-yfminus)/sin(mu)
endif else begin
   ;calculate the film position for circular film
;   a=1.+(tan(beta))^2
;   b=2.*tan(beta)*(rc0-yc-xc*tan(beta))
;   c=rc0^2+yc^2-2.*rc0*yc-rf^2+tan(beta)*(tan(beta)*xc^2+2.*xc*yc-2.*rc0*xc)
;   xlambda=(-b+sqrt(b^2-4.*a*c))/(2.*a)
;   ylambda=tan(beta)*(xc-xlambda)+yc
;   dlambda=rf*atan((ylambda-rc0)/(xlambda)) $
;        +(abs(xlambda)-xlambda)/abs(xlambda)*rf*!pi/2.

   mb=(tan(!pi-beta))
   bb=yc-mb*xc
   a=1.+(mb)^2.
   b=2.*mb*(bb-rc0)
   c=bb^2.+rc0^2.-2.*bb*rc0-rf^2.
   if (beta gt !pi/2.) then $
      xlambda=(-b+sqrt(b^2-4.*a*c))/(2.*a) $
   else $
      xlambda=(-b-sqrt(b^2-4.*a*c))/(2.*a)
   ylambda=mb*(xlambda)+bb
   dlambda=rf*atan((ylambda-rc0)/(xlambda)) $
        +(abs(xlambda)-xlambda)/abs(xlambda)*rf*!pi/2.
endelse

(*convexptr).film.d(whichxstal,whichsource,whichorder,whichlambda)=dlambda

(*convexptr).film.xlambda(whichxstal,whichsource,whichorder,whichlambda)=xlambda
(*convexptr).film.ylambda(whichxstal,whichsource,whichorder,whichlambda)=ylambda

return
end