PRO EXRAY_CONVEX_PLOTPREP,convexptr,xrange,yrange,over,windID=winID

;*************************************************
; Intialize the plot window
;*************************************************
if (over eq 0) then begin
   if (n_elements(winID) eq 0) then begin
      window,0,xsize=650,ysize=450,title='Convex Crystal Ray Tracing'
      plot,[0,0],[-100,100],line=1,xran=xrange,yran=yrange,xtitle='X (cm)',ytitle='Y (cm)',$
                         xstyle=1,ystyle=1,position=[0.1,0.1,0.7,0.9667],charsize=1.2
   endif else begin
      wset,winID
      plot,[0,0],[-1000,1000],line=1,xran=xrange,yran=yrange,xtitle='X (cm)',ytitle='Y (cm)',$
                         xstyle=1,ystyle=1,position=[0.15,0.1,0.95,0.957],charsize=1.2
   endelse
   oplot,[-1000,1000],[0,0],line=1
   linelook=0
endif else linelook=1

;*************************************************
; Plot the xstals
;*************************************************
numxstals=(*convexptr).numxstals
rc0=(*convexptr).xstal(0).rc
chi0=(*convexptr).xstal(0).chi
for l=0,numxstals-1 do begin
   rc=(*convexptr).xstal(l).rc
   chi=(*convexptr).xstal(l).chi
   delta_r=rc-rc0
   delta_chi=chi-chi0
   xxstal=(findgen(1000)*2.*rc/1000)-rc
   yxstal = sqrt(rc^2-xxstal^2)
   oplot,xxstal,yxstal,col=l,thick=2,line=linelook
endfor

rf=(*convexptr).film.rf
chi=(*convexptr).xstal(0).chi
circleflag=(*convexptr).film.circleflag
;*************************************************
; Plot the film plane (if linear film)
;*************************************************
if (rf ge 0.) and (circleflag ne 1) then begin
   phi=(*convexptr).film.phi
   mu=(*convexptr).film.mu
   L=(*convexptr).film.L
   xf0=rf*cos(phi)
   yf0=rf*sin(phi) + rc0
   xfminus=xf0-L/2.*cos(mu)
   xfplus=xf0+L/2.*cos(mu)
   yfminus=yf0+L/2.*sin(mu)
   yfplus=yf0-L/2.*sin(mu)
   oplot,[xfminus,xfplus],[yfminus,yfplus],thick=2,line=linelook
endif else begin
;*************************************************
; Plot the film plane (if circular film)
;*************************************************
   xfilm=(findgen(1000)*2.*rf/1000)-rf
   yfilm = sqrt(rf^2-xfilm^2)+rc0
   oplot,xfilm,yfilm,col=0,thick=2,line=linelook
endelse


return
end