PRO EXRAY_CONVEX_PLOTRAYS,convexptr,over,noprint,windID=winID

if (over eq 0) then linelook=0 else linelook=1
if (n_elements(winID) ne 0) then wset,winID

numxstals=(*convexptr).numxstals
numsource=(*convexptr).numsource
numorders=(*convexptr).numorders
numlambda=(*convexptr).numlambda
for l=0,numxstals-1 do begin
   for i=0,numsource-1 do begin
      a=(*convexptr).source(i).a(l)
      b=(*convexptr).source(i).b(l)
      for j=0,numorders-1 do begin
          for k=0,numlambda-1 do begin
              theta=(*convexptr).xstal(l).theta(i,j,k)
              if (theta gt 0.) then begin
                 xc=(*convexptr).xstal(l).xc(i,j,k)
                 yc=(*convexptr).xstal(l).yc(i,j,k)
                 xlambda=(*convexptr).film.xlambda(l,i,j,k)
                 ylambda=(*convexptr).film.ylambda(l,i,j,k)
                 twod=(*convexptr).xstal(l).twod
                 p=(*convexptr).xstal(l).p
                 order=(*convexptr).source(i).n(j)
                 ;lambda=twod/order*sin(theta-p) ;calculate lambda in case betas given
                 lambda=twod/order*sin(theta) ;calculate lambda in case betas given

                 oplot,[a,xc],[b,yc],col=i,line=l
                 oplot,[xc,xlambda],[yc,ylambda],col=i,line=l

                 if (noprint eq 0) then begin
                    ;now print the wavelength label on the graph
                    label=strtrim(string(lambda,format='(D6.3)'),2) + ' A' $
                          +', order = '+strtrim(string(order,format='(I2)'),2)
                    if (xc gt xlambda) then $
                       orient= 180.+atan((yc-ylambda)/abs(xc-xlambda))*180./!pi $
                    else if (xlambda gt xc) then $
                       orient= 360.-atan((yc-ylambda)/abs(xc-xlambda))*180./!pi $
                    else orient = 270.
                    xyouts,xlambda,ylambda,label,orientation = orient,color=i
                 endif

              endif
          endfor
      endfor
   endfor
endfor

return
end
