

pro Spectrofit_BASE_event, Event

  @spectrofit.cmn

  wWidget =  Event.top

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='Open_DataFile_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        spectrofit_opendata, Event
        widget_control,Data_Filename,SET_VALUE=[datafile]
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Open_CalcFile_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        spectrofit_opencalc, Event
        widget_control,Calc_Filename,SET_VALUE=[calcfile]
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Open_SigmaFile_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        dummy2, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='TRange_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
            widget_control,minTemp_Value_TABLE,/Editable
            widget_control,maxTemp_Value_TABLE,/Editable
        endif else begin
            widget_control,minTemp_Value_TABLE,Editable=0
            widget_control,maxTemp_Value_TABLE,Editable=0
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='DRange_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
            widget_control,minDens_Value_TABLE,/Editable
            widget_control,maxDens_Value_TABLE,/Editable
        endif else begin
            widget_control,minDens_Value_TABLE,Editable=0
            widget_control,maxDens_Value_TABLE,Editable=0
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Others_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        spectrofit_others
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Plot_DROPLIST'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_DROPLIST' )then begin
        widget_control,Graphics_DRAW,GET_VALUE=winID
        if (Event.index eq 0) then spectrofit_makeplots,/best_fit,windID=winid $
        else if (Event.index eq 1) then spectrofit_makeplots,/var_surface,windID=winid $
        else if (Event.index eq 2) then spectrofit_makeplots,/chi_vs_t,windID=winid $
        else if (Event.index eq 3) then spectrofit_makeplots,/chi_vs_n,windID=winid $
        else if (Event.index eq 4) then spectrofit_contours,chisq,temps,dens,windID=winid
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='SpectRes_Value_TABLE'): begin
        widget_control,SpectRes_Value_TABLE,GET_VALUE=SpectRes
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Sigma_Value_TABLE'): begin
        widget_control,Sigma_Value_TABLE,GET_VALUE=Sigma
    end
    Widget_Info(wWidget, FIND_BY_UNAME='MinDepth_Value_TABLE'): begin
        widget_control,MinDepth_Value_TABLE,GET_VALUE=MinDepth
    end
    Widget_Info(wWidget, FIND_BY_UNAME='MaxDepth_Value_TABLE'): begin
        widget_control,MaxDepth_Value_TABLE,GET_VALUE=MaxDepth
    end
    Widget_Info(wWidget, FIND_BY_UNAME='NumDepths_Value_TABLE'): begin
        widget_control,NumDepths_Value_TABLE,GET_VALUE=NumDepths
    end
    Widget_Info(wWidget, FIND_BY_UNAME='minTemp_Value_TABLE'): begin
        widget_control,minTemp_Value_TABLE,GET_VALUE=Tmin
    end
    Widget_Info(wWidget, FIND_BY_UNAME='maxTemp_Value_TABLE'): begin
        widget_control,maxTemp_Value_TABLE,GET_VALUE=Tmax
    end
    Widget_Info(wWidget, FIND_BY_UNAME='minDens_Value_TABLE'): begin
        widget_control,minDens_Value_TABLE,GET_VALUE=Dmin
    end
    Widget_Info(wWidget, FIND_BY_UNAME='maxDens_Value_TABLE'): begin
        widget_control,maxDens_Value_TABLE,GET_VALUE=Dmax
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Save_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        spectrofit_save, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='OpenData_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        spectrofit_openold, Event
        if (oldfile ne '') then begin
           widget_control,Plot_DROPLIST,/Sensitive
           widget_control,Graphics_DRAW,GET_VALUE=winID
           spectrofit_makeplots,/var_surface,windID=winid
           openflag = 1
        endif
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Quit_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
         widget_control, Event.top, /DESTROY
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Execute_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;check to make sure that files are selected and variables initialized
        if (datafile eq '') then widget_control,Output_Window, $
                                 SET_VALUE='You must select a datafile' $
        else if (calcfile eq '') then widget_control,Output_Window, $
                                 SET_VALUE='You must select a calculation file' $
        else begin
           if (openflag eq 1) then begin
              spectrofit_reset
              widget_control,Plot_DROPLIST,Sensitive=0
           endif
           openw,10,'c:\Work Files\Spectroscopy\Spectrofit\spectrofit.inp'
           printf,10,"'"+calcfile+"'"
           close,10
           widget_control,Graphics_DRAW,GET_VALUE=winID
           spectrofit_go,MinDepth(0),MaxDepth(0),NumDepths(0), $
                         resolution=SpectRes(0),windID=winID
           widget_control,Plot_DROPLIST,/Sensitive
           openflag=1
        endelse
      endif
    end
    else:
  endcase

end

pro Spectrofit_BASE, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  @spectrofit.cmn

  spectrofit_initialize

  Resolve_Routine, 'spectrofit_eventcb',/COMPILE_FULL_FILE  ; Load event callback routines

  Spectrofit_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Spectrofit_BASE' ,XOFFSET=5 ,YOFFSET=5 ,SCR_XSIZE=623  $
      ,SCR_YSIZE=591 ,TITLE='Spectrofit' ,SPACE=3 ,XPAD=3 ,YPAD=3)


  Graphics_DRAW = Widget_Draw(Spectrofit_BASE, UNAME='GRAPHICS_DRAW'  $
      ,XOFFSET=12 ,YOFFSET=113 ,SCR_XSIZE=404 ,SCR_YSIZE=377 $
      ,XSIZE=404,YSIZE=377,Frame=1)


  Data_Filename = Widget_Text(Spectrofit_BASE, UNAME='Data_Filename'  $
      ,FRAME=1 ,XOFFSET=11 ,YOFFSET=19 ,SCR_XSIZE=365 ,SCR_YSIZE=21  $
      ,/ALL_EVENTS ,XSIZE=20 ,YSIZE=1, VALUE=[datafile])


  Calc_Filename = Widget_Text(Spectrofit_BASE, UNAME='Calc_Filename'  $
      ,FRAME=1 ,XOFFSET=11 ,YOFFSET=65 ,SCR_XSIZE=365 ,SCR_YSIZE=21  $
      ,XSIZE=20 ,YSIZE=1, VALUE=[calcfile])


  Open_DataFile_BUTTON = Widget_Button(Spectrofit_BASE,  $
      UNAME='Open_DataFile_BUTTON' ,FRAME=1 ,XOFFSET=375 ,YOFFSET=19  $
      ,SCR_XSIZE=39 ,SCR_YSIZE=21 ,/ALIGN_CENTER ,VALUE='Open')


  Open_CalcFile_BUTTON = Widget_Button(Spectrofit_BASE,  $
      UNAME='Open_CalcFile_BUTTON' ,FRAME=1 ,XOFFSET=375 ,YOFFSET=65  $
      ,SCR_XSIZE=39 ,SCR_YSIZE=21 ,/ALIGN_CENTER ,VALUE='Open')


  DataFile_LABEL = Widget_Label(Spectrofit_BASE,  $
      UNAME='DataFile_LABEL' ,XOFFSET=13 ,SCR_XSIZE=237 ,SCR_YSIZE=13  $
      ,/ALIGN_LEFT ,VALUE='Relative Transmission Data File')


  CalcFile_LABEL = Widget_Label(Spectrofit_BASE,  $
      UNAME='CalcFile_LABEL' ,XOFFSET=11 ,YOFFSET=44 ,/ALIGN_LEFT  $
      ,VALUE='JATBASE Detailed Opacity Calculation File')


  SpectRes_LABEL = Widget_Label(Spectrofit_BASE,  $
      UNAME='SpectRes_LABEL' ,XOFFSET=437 ,YOFFSET=90 ,SCR_XSIZE=121  $
      ,SCR_YSIZE=18 ,/ALIGN_CENTER ,VALUE='Data Spectral Resolution')


  Sigma_LABEL = Widget_Label(Spectrofit_BASE, UNAME='Sigma_LABEL'  $
      ,XOFFSET=437 ,YOFFSET=139 ,SCR_XSIZE=126 ,SCR_YSIZE=18  $
      ,/ALIGN_CENTER ,VALUE='Data Uncertainty (1 sigma)')


  MinDepth_LABEL = Widget_Label(Spectrofit_BASE,  $
      UNAME='MinDepth_LABEL' ,XOFFSET=426 ,YOFFSET=191 ,SCR_XSIZE=146  $
      ,SCR_YSIZE=19 ,/ALIGN_CENTER ,VALUE='Minimum Plasma'+ $
      ' Mass-Depth')


  MaxDepth_LABEL = Widget_Label(Spectrofit_BASE,  $
      UNAME='MaxDepth_LABEL' ,XOFFSET=426 ,YOFFSET=243 ,SCR_XSIZE=147  $
      ,SCR_YSIZE=18 ,/ALIGN_CENTER ,VALUE='Maximum Plasma'+ $
      ' Mass-Depth')


  NumDepths_LABEL = Widget_Label(Spectrofit_BASE,  $
      UNAME='NumDepths_LABEL' ,XOFFSET=427 ,YOFFSET=293  $
      ,SCR_XSIZE=140 ,SCR_YSIZE=18 ,/ALIGN_CENTER ,VALUE='Number of'+ $
      ' Mass-Depths')


  Output_Window = Widget_Text(Spectrofit_BASE, UNAME='Output_Window'  $
      ,FRAME=1 ,XOFFSET=10 ,YOFFSET=493 ,SCR_XSIZE=406 ,SCR_YSIZE=18  $
      ,XSIZE=20 ,YSIZE=1)

  Save_BUTTON = Widget_Button(Spectrofit_BASE,  $
      UNAME='Save_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=515 ,SCR_XSIZE=130 ,SCR_YSIZE=30 ,/ALIGN_CENTER  $
      ,VALUE='Save Data')

  OpenData_BUTTON = Widget_Button(Spectrofit_BASE,  $
      UNAME='OpenData_BUTTON' ,FRAME=1 ,XOFFSET=148  $
      ,YOFFSET=515 ,SCR_XSIZE=130 ,SCR_YSIZE=30 ,/ALIGN_CENTER  $
      ,VALUE='Open Data')

  Quit_BUTTON = Widget_Button(Spectrofit_BASE,  $
      UNAME='Quit_BUTTON' ,FRAME=1 ,XOFFSET=286  $
      ,YOFFSET=515 ,SCR_XSIZE=130 ,SCR_YSIZE=30 ,/ALIGN_CENTER  $
      ,VALUE='Exit')

  Open_SigmaFile_BUTTON = Widget_Button(Spectrofit_BASE,  $
      UNAME='Open_SigmaFile_BUTTON' ,FRAME=1 ,XOFFSET=532  $
      ,YOFFSET=162 ,SCR_XSIZE=33 ,SCR_YSIZE=20 ,/ALIGN_CENTER  $
      ,VALUE='Open')


  MinDepth_Units_LABEL = Widget_Label(Spectrofit_BASE,  $
      UNAME='MinDepth_Units_LABEL' ,XOFFSET=569 ,YOFFSET=217  $
      ,SCR_XSIZE=39 ,SCR_YSIZE=23 ,/ALIGN_LEFT ,VALUE='g/cm^2')


  MaxDepth_Units_LABEL = Widget_Label(Spectrofit_BASE,  $
      UNAME='MaxDepth_Units_LABEL' ,XOFFSET=569 ,YOFFSET=270  $
      ,SCR_XSIZE=40 ,SCR_YSIZE=18 ,/ALIGN_LEFT ,VALUE='g/cm^2')


  TButton_BASE = Widget_Base(Spectrofit_BASE, UNAME='TButton_BASE'  $
      ,XOFFSET=439 ,YOFFSET=344 ,COLUMN=1 ,/NONEXCLUSIVE)


  TRange_Button = Widget_Button(TButton_BASE, UNAME='TRange_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Compute All Temperatures')

  widget_control,TRange_Button,/SET_BUTTON

  Tmin_LABEL = Widget_Label(Spectrofit_BASE, UNAME='Tmin_LABEL'  $
      ,XOFFSET=441 ,YOFFSET=370 ,/ALIGN_LEFT ,VALUE='Tmin')


  Tmax_LABEL = Widget_Label(Spectrofit_BASE, UNAME='Tmax_LABEL'  $
      ,XOFFSET=538 ,YOFFSET=370 ,/ALIGN_LEFT ,VALUE='Tmax')


  Tmin_Units_LABEL = Widget_Label(Spectrofit_BASE,  $
      UNAME='Tmin_Units_LABEL' ,XOFFSET=484 ,YOFFSET=392  $
      ,SCR_XSIZE=18 ,SCR_YSIZE=18 ,/ALIGN_LEFT ,VALUE='eV')


  Tmax_Units_LABEL = Widget_Label(Spectrofit_BASE,  $
      UNAME='Tmax_Units_LABEL' ,XOFFSET=580 ,YOFFSET=393  $
      ,SCR_XSIZE=18 ,SCR_YSIZE=18 ,/ALIGN_LEFT ,VALUE='eV')


  DButton_BASE = Widget_Base(Spectrofit_BASE, UNAME='WID_BASE_1'  $
      ,XOFFSET=441 ,YOFFSET=422 ,COLUMN=1 ,/NONEXCLUSIVE)


  DRange_Button = Widget_Button(DButton_BASE, UNAME='DRange_Button'  $
      ,/ALIGN_LEFT ,VALUE='Compute All Densities')

  widget_control,DRange_Button,/SET_BUTTON

  Dmax_Units_LABEL = Widget_Label(Spectrofit_BASE,  $
      UNAME='Dmax_Units_LABEL' ,XOFFSET=580 ,YOFFSET=475  $
      ,SCR_XSIZE=31 ,SCR_YSIZE=18 ,/ALIGN_LEFT ,VALUE='cm^-3')


  Dmin_Units_LABEL = Widget_Label(Spectrofit_BASE,  $
      UNAME='Dmin_Units_LABEL' ,XOFFSET=486 ,YOFFSET=474  $
      ,SCR_XSIZE=31 ,SCR_YSIZE=18 ,/ALIGN_LEFT ,VALUE='cm^-3')


  Dmax_LABEL = Widget_Label(Spectrofit_BASE, UNAME='Dmax_LABEL'  $
      ,XOFFSET=535 ,YOFFSET=449 ,/ALIGN_LEFT ,VALUE='n_max')


  Dmin_LABEL = Widget_Label(Spectrofit_BASE, UNAME='Dmin_LABEL'  $
      ,XOFFSET=441 ,YOFFSET=449 ,/ALIGN_LEFT ,VALUE='n_min')


  Execute_BUTTON = Widget_Button(Spectrofit_BASE,  $
      UNAME='Execute_BUTTON' ,FRAME=1 ,XOFFSET=435 ,YOFFSET=20  $
      ,SCR_XSIZE=128 ,SCR_YSIZE=62 ,/ALIGN_CENTER ,VALUE='Execute')


  Others_BUTTON = Widget_Button(Spectrofit_BASE,  $
      UNAME='Others_BUTTON' ,XOFFSET=447 ,YOFFSET=515 ,SCR_XSIZE=117  $
      ,SCR_YSIZE=31 ,/ALIGN_CENTER ,VALUE='Other Parameters')


  Plot_DROPLIST = Widget_Droplist(Spectrofit_BASE,  $
      UNAME='Plot_DROPLIST' ,XOFFSET=10 ,YOFFSET=91 ,SENSITIVE=0  $
      ,TITLE='Plot' ,VALUE=[ 'Best-Fit','Variance Surface', 'Chi-Squared vs.'+ $
      ' Temp', 'Chi-Squared vs. Dens', 'Best-Fit Contours' ])


  SpectRes_Value_TABLE = Widget_Table(Spectrofit_BASE,  $
      UNAME='SpectRes_Value_TABLE' ,FRAME=1 ,XOFFSET=437 ,YOFFSET=112  $
      ,SCR_XSIZE=127 ,SCR_YSIZE=20 ,/EDITABLE ,/NO_HEADERS,/KBRD_FOCUS_EVENTS  $
      ,COLUMN_WIDTHS=[127],XSIZE=1 ,YSIZE=1, VALUE=[SpectRes], FORMAT='(F4.0)')


  Sigma_Value_TABLE = Widget_Table(Spectrofit_BASE,  $
      UNAME='Sigma_Value_TABLE' ,FRAME=1 ,XOFFSET=438 ,YOFFSET=162  $
      ,SCR_XSIZE=94 ,SCR_YSIZE=20 ,/EDITABLE ,/NO_HEADERS,/KBRD_FOCUS_EVENTS  $
      ,COLUMN_WIDTHS=[94] ,XSIZE=1 ,YSIZE=1, VALUE=[Sigma], FORMAT='(F5.3)')


  MinDepth_Value_TABLE = Widget_Table(Spectrofit_BASE,  $
      UNAME='MinDepth_Value_TABLE' ,FRAME=1 ,XOFFSET=438 ,YOFFSET=214  $
      ,SCR_XSIZE=127 ,SCR_YSIZE=20 ,/EDITABLE ,/NO_HEADERS,/KBRD_FOCUS_EVENTS  $
      ,COLUMN_WIDTHS=[127],XSIZE=1 ,YSIZE=1, VALUE=[MinDepth], FORMAT='(E10.3e2)')


  MaxDepth_Value_TABLE = Widget_Table(Spectrofit_BASE,  $
      UNAME='MaxDepth_Value_TABLE' ,FRAME=1 ,XOFFSET=438 ,YOFFSET=266  $
      ,SCR_XSIZE=127 ,SCR_YSIZE=20 ,/EDITABLE ,/NO_HEADERS,/KBRD_FOCUS_EVENTS  $
      ,COLUMN_WIDTHS=[127],XSIZE=1 ,YSIZE=1, VALUE=[MaxDepth], FORMAT='(E10.3e2)')


  NumDepths_Value_TABLE = Widget_Table(Spectrofit_BASE,  $
      UNAME='NumDepths_Value_TABLE' ,FRAME=1 ,XOFFSET=438,/KBRD_FOCUS_EVENTS  $
      ,YOFFSET=315,SCR_XSIZE=127 ,SCR_YSIZE=20 ,/EDITABLE ,/NO_HEADERS  $
      ,COLUMN_WIDTHS=[127],XSIZE=1 ,YSIZE=1, VALUE=[NumDepths], FORMAT='(I3)')



  MinTemp_Value_TABLE = Widget_Table(Spectrofit_BASE,  $
      UNAME='MinTemp_Value_TABLE' ,FRAME=1 ,XOFFSET=430 ,YOFFSET=389  $
      ,SCR_XSIZE=49 ,SCR_YSIZE=20  ,/NO_HEADERS,/KBRD_FOCUS_EVENTS  $
      ,COLUMN_WIDTHS=[49] ,XSIZE=1 ,YSIZE=1, VALUE=[Tmin], FORMAT='(F6.2)')


  MaxTemp_Value_TABLE = Widget_Table(Spectrofit_BASE,  $
      UNAME='MaxTemp_Value_TABLE' ,FRAME=1 ,XOFFSET=526 ,YOFFSET=389  $
      ,SCR_XSIZE=49 ,SCR_YSIZE=20  ,/NO_HEADERS,/KBRD_FOCUS_EVENTS  $
      ,COLUMN_WIDTHS=[49] ,XSIZE=1 ,YSIZE=1, VALUE=[Tmax], FORMAT='(F6.2)')


  MinDens_Value_TABLE = Widget_Table(Spectrofit_BASE,  $
      UNAME='MinDens_Value_TABLE' ,FRAME=1 ,XOFFSET=432 ,YOFFSET=472  $
      ,SCR_XSIZE=52 ,SCR_YSIZE=20  ,/NO_HEADERS,/KBRD_FOCUS_EVENTS  $
      ,COLUMN_WIDTHS=[52] ,XSIZE=1 ,YSIZE=1, VALUE=[Dmin],FORMAT='(E8.1e2)')


  MaxDens_Value_TABLE = Widget_Table(Spectrofit_BASE,  $
      UNAME='MaxDens_Value_TABLE' ,FRAME=1 ,XOFFSET=526 ,YOFFSET=472  $
      ,SCR_XSIZE=52 ,SCR_YSIZE=20 ,/NO_HEADERS,/KBRD_FOCUS_EVENTS  $
      ,COLUMN_WIDTHS=[52] ,XSIZE=1 ,YSIZE=1, VALUE=[Dmax],FORMAT='(E8.1e2)')

  Widget_Control, /REALIZE, Spectrofit_BASE

  XManager, 'Spectrofit_BASE', Spectrofit_BASE,/No_Block

end
;
; Empty stub procedure used for autoloading.
;
pro spectrofit, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Spectrofit_BASE, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end
