

pro Exray_XstalWidget_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = xstalstr

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='Xstal1_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           xstalstr.xstalset(0)=0
        endif else begin
           xstalstr.xstalset(0)=1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Xstal2_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           xstalstr.xstalset(1)=0
        endif else begin
           xstalstr.xstalset(1)=1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Xstal3_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           xstalstr.xstalset(2)=0
        endif else begin
           xstalstr.xstalset(2)=1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Quit_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        numxstals=3
        tmp=double(0.)
        whoops = ''
        for i=0,numxstals-1 do begin
          if xstalstr.xstalset(i) eq 1 then begin
             xstalstr.exraystr.xstalset(i) = 1
             widget_control,xstalstr.h(i),get_value=h
             if (h gt 0) then $
                 xstalstr.exraystr.wxstal(i).h=h $
             else $
                whoops = dialog_message('h value for xstal #'$
                +strtrim(string(i+1))+' must be > 0',/Error)
             widget_control,xstalstr.R0(i),get_value=R0
             if (R0 gt 0) then $
                 xstalstr.exraystr.wxstal(i).R0=R0 $
             else $
                whoops = dialog_message('Focal length for xstal #'$
                +strtrim(string(i+1))+' must be > 0',/Error)
             widget_control,xstalstr.BMin(i),get_value=betamin
             betamin=betamin*!pi/180.
             if (betamin gt 0) then $
                xstalstr.exraystr.wxstal(i).betamin=betamin $
             else $
                whoops = dialog_message('Minimum Beta for xstal #'$
                +strtrim(string(i+1))+' must be > 0',/Error)
             widget_control,xstalstr.BMax(i),get_value=betamax
             betamax=betamax*!pi/180.
             if (betamax gt 0) then $
                xstalstr.exraystr.wxstal(i).betamax=betamax $
             else $
                whoops = dialog_message('Maximum Beta for xstal #'$
                +strtrim(string(i+1))+' must be > 0',/Error)
             widget_control,xstalstr.twod(i),get_value=tmp
             if (tmp gt 0) then $
                xstalstr.exraystr.wxstal(i).twod=tmp $
             else $
                whoops = dialog_message('2d for xstal #'$
                +strtrim(string(i+1))+' must be > 0',/Error)
             if (whoops = '') then begin
                xmin=-h*cos(betamin)/(1.-ecc*cos(betamin))
                xmax=-h*cos(betamax)/(1.-ecc*cos(betamax))
                xxstal=(xmax-xmin)*(findgen(1000)*.001)+xmin
                yxstal=sqrt(h^2/(1.-ecc^2)-(xxstal+R0/2.)^2*(1.-ecc^2))
                dl=sqrt((xxstal(1:999)-xxstal(0:998))^2.+(yxstal(1:999)-yxstal(0:998))^2.)
                length=total(dl)
                xstalstr.exraystr.wxstal(i).length=length
             endif
          endif else begin
             xstalstr.exraystr.xstalset(i) = 0
             xstalstr.exraystr.wxstal(i).h=0.
             xstalstr.exraystr.wxstal(i).R0=0.
             xstalstr.exraystr.wxstal(i).betamin=0.
             xstalstr.exraystr.wxstal(i).betamax=0.
             xstalstr.exraystr.wxstal(i).twod=0.
             xstalstr.exraystr.wxstal(i).length=0.
          endelse
        endfor

        if whoops eq 'OK' then return $
        else begin
          Widget_Control, xstalstr.MainWidget, set_uvalue = xstalstr.exraystr
          widget_control, Event.top, /DESTROY
          return
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  ;calculate and update the substrate length
   widget_control,xstalstr.h(0),get_value=h
   widget_control,xstalstr.R0(0),get_value=R0
   ecc=sqrt(1+(h/R0)^2)-h/R0
   widget_control,xstalstr.BMin(0),get_value=betamin
   widget_control,xstalstr.BMax(0),get_value=betamax
   betamin=betamin*!pi/180.
   betamax=betamax*!pi/180.
   xmin=-h*cos(betamin)/(1.-ecc*cos(betamin))
   xmax=-h*cos(betamax)/(1.-ecc*cos(betamax))
   xxstal=(xmax-xmin)*(findgen(1000)*.001)+xmin
   yxstal=sqrt(h^2/(1.-ecc^2)-(xxstal+R0/2.)^2*(1.-ecc^2))
   dl=sqrt((xxstal(1:999)-xxstal(0:998))^2.+(yxstal(1:999)-yxstal(0:998))^2.)
   length=total(dl)
   widget_control,xstalstr.length,set_value=length

  ;calculate the radius of curvature
  jbeta=findgen(10000)/9999.*(betamax-betamin)+betamin
  jtheta=atan((1-ecc*cos(jbeta))/(ecc*sin(jbeta)))
  rcurve=h*(1.-2.*ecc*cos(jbeta)+ecc^2.)^(3./2.)/(1.-ecc*cos(jbeta))^3.
  minrc=min(rcurve)
  maxrc=max(rcurve)
  xstalstr.exraystr.wxstal(0).rcurve=[minrc,maxrc]
  widget_control,xstalstr.Rcurve,set_value='radius of curvature = ' $
     +strtrim(string(minrc,form='(F5.1)'),2)+' - ' $
     +strtrim(string(maxrc,form='(F5.1)'),2)+' cm'

  Widget_Control, wWidget, set_uvalue = xstalstr


end

pro Exray_XstalWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control, MainWidget, get_uvalue = exraystr
  mxy=exraystr.mxy

  numxstals=exraystr.wnumxstals
  Initarr=dblarr(numxstals,5)
  for i=0,numxstals-1 do begin
    Initarr(i,0)=exraystr.wxstal(i).h
    Initarr(i,1)=exraystr.wxstal(i).R0
    Initarr(i,2)=exraystr.wxstal(i).betamin*180./!pi
    Initarr(i,3)=exraystr.wxstal(i).betamax*180./!pi
    Initarr(i,4)=exraystr.wxstal(i).twod
  endfor


  Exray_XstalWidget_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_XstalWidget_BASE' ,XOFFSET=5 ,YOFFSET=5,COLUMN=3 $
      ,TITLE='Crystals' ,SPACE=3 ,XPAD=3 ,YPAD=3)


;***********************************************************************************
;Xstal 1

  Xstal1_BASE = Widget_Base(Exray_XstalWidget_BASE, UNAME='Xstal1_BASE'  $
      ,XOFFSET=10 ,YOFFSET=10 ,COLUMN=1,/BASE_ALIGN_RIGHT)

;  Xstal1Button_BASE = Widget_Base(Xstal1_BASE, UNAME='Xstal1Button_BASE'  $
;      ,XOFFSET=10 ,YOFFSET=10 ,COLUMN=1 ,/NONEXCLUSIVE)


;  Xstal1_Button = Widget_Button(Xstal1Button_BASE, UNAME='Xstal1_Button'  $
;      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Crystal 1')


  Value1_LABEL = Widget_Label(Xstal1_BASE,  $
      UNAME='Value1_LABEL' ,XOFFSET=10 ,YOFFSET=50 ,/ALIGN_Right  $
      ,VALUE='Crystal Parameters')


  H1_Field = CW_Field(Xstal1_BASE,UNAME='H1_FIELD' $
                        ,Title='Henke h (cm) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wxstal(0).h])

  R01_Field = CW_Field(Xstal1_BASE,UNAME='R01_FIELD' $
                        ,Title='Focal Length (cm) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wxstal(0).R0])

  BMin1_Field = CW_Field(Xstal1_BASE,UNAME='BMin1_FIELD' $
                        ,Title='Minimum Beta (deg) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wxstal(0).betamin*180./!pi])

  BMax1_Field = CW_Field(Xstal1_BASE,UNAME='BMax1_FIELD' $
                        ,Title='Maximum Beta (deg) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wxstal(0).betamax*180./!pi])

  Size1_Field = CW_Field(Xstal1_BASE,UNAME='Size1_FIELD' $
                        ,Title='Substrate Length (cm) = ',/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wxstal(0).length])


  Twod1_Field = CW_Field(Xstal1_BASE,UNAME='Twod1_FIELD' $
                        ,Title='2d (Ansgtroms) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wxstal(0).twod])

  Rcurve_LABEL = Widget_Label(Xstal1_BASE,  $
      UNAME='Rcurve_LABEL' ,XOFFSET=10 ,YOFFSET=50 ,/ALIGN_Right  $
      ,VALUE='radius of curvature = ')

;***********************************************************************************
;Xstal 2

;  Xstal2_BASE = Widget_Base(Exray_XstalWidget_BASE, UNAME='Xstal2_BASE'  $
;      ,XOFFSET=10 ,YOFFSET=10 ,COLUMN=1,/BASE_ALIGN_RIGHT)

;  Xstal2Button_BASE = Widget_Base(Xstal2_BASE, UNAME='Xstal2Button_BASE'  $
;      ,XOFFSET=10 ,YOFFSET=10 ,COLUMN=1 ,/NONEXCLUSIVE,XSIZE=80)


;  Xstal2_Button = Widget_Button(Xstal2Button_BASE, UNAME='Xstal2_Button'  $
;      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Crystal 2')


;  Value2_LABEL = Widget_Label(Xstal2_BASE,  $
;      UNAME='Value2_LABEL' ,XOFFSET=10 ,YOFFSET=50 ,/ALIGN_Right  $
;      ,VALUE='Crystal Parameters')


;  H2_Field = CW_Field(Xstal2_BASE,UNAME='H2_FIELD' $
;                        ,Title='Henke h (cm) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
;                        ,Value=[exraystr.wxstal(1).h])

;  R02_Field = CW_Field(Xstal2_BASE,UNAME='R02_FIELD' $
;                        ,Title='Focal Length (cm) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
;                        ,Value=[exraystr.wxstal(1).R0])

;  BMin2_Field = CW_Field(Xstal2_BASE,UNAME='BMin2_FIELD' $
;                        ,Title='Minimum Beta (deg) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
;                        ,Value=[exraystr.wxstal(1).betamin*180./!pi])

;  BMax2_Field = CW_Field(Xstal2_BASE,UNAME='BMax2_FIELD' $
;                        ,Title='Maximum Beta (deg) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
;                        ,Value=[exraystr.wxstal(1).betamax*180./!pi])

;  Twod2_Field = CW_Field(Xstal2_BASE,UNAME='Twod2_FIELD' $
;                        ,Title='2d (Ansgtroms) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
;                        ,Value=[exraystr.wxstal(1).twod])


;***********************************************************************************
;Xstal 3

;  Xstal3_BASE = Widget_Base(Exray_XstalWidget_BASE, UNAME='Xstal3_BASE'  $
;      ,XOFFSET=10 ,YOFFSET=10 ,COLUMN=1,/BASE_ALIGN_RIGHT)

;  Xstal3Button_BASE = Widget_Base(Xstal3_BASE, UNAME='Xstal3Button_BASE'  $
;      ,XOFFSET=10 ,YOFFSET=10 ,COLUMN=1 ,/NONEXCLUSIVE, XSIZE=80)


;  Xstal3_Button = Widget_Button(Xstal3Button_BASE, UNAME='Xstal3_Button'  $
;      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Crystal 3')


;  Value3_LABEL = Widget_Label(Xstal3_BASE,  $
;      UNAME='Value3_LABEL' ,XOFFSET=10 ,YOFFSET=50 ,/ALIGN_Right  $
;      ,VALUE='Crystal Parameters')


;  H3_Field = CW_Field(Xstal3_BASE,UNAME='H3_FIELD' $
;                        ,Title='Henke h (cm) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
;                        ,Value=[exraystr.wxstal(2).h])

;  R03_Field = CW_Field(Xstal3_BASE,UNAME='R03_FIELD' $
;                        ,Title='Focal Length (cm) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
;                        ,Value=[exraystr.wxstal(2).R0])

;  BMin3_Field = CW_Field(Xstal3_BASE,UNAME='BMin3_FIELD' $
;                        ,Title='Minimum Beta (deg) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
;                        ,Value=[exraystr.wxstal(2).betamin*180./!pi])

;  BMax3_Field = CW_Field(Xstal3_BASE,UNAME='BMax3_FIELD' $
;                        ,Title='Maximum Beta (deg) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
;                        ,Value=[exraystr.wxstal(2).betamax*180./!pi])

;  Twod3_Field = CW_Field(Xstal3_BASE,UNAME='Twod3_FIELD' $
;                        ,Title='2d (Ansgtroms) = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
;                        ,Value=[exraystr.wxstal(2).twod])


  Quit_BASE = Widget_Base(Xstal1_BASE, UNAME='Quit_BASE' $
      ,COLUMN=2,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Cancel')


  Quit_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Quit_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Done')


;************************************************************************************
;Set the appropriate values and buttons
;************************************************************************************
;if exraystr.xstalset(0) gt 0 then begin
;   Widget_Control, Xstal1_Button,SET_BUTTON = 1
;endif
;if exraystr.xstalset(1) gt 0 then begin
;   Widget_Control, Xstal2_Button,SET_BUTTON = 1
;endif
;if exraystr.xstalset(2) gt 0 then begin
;   Widget_Control, Xstal3_Button,SET_BUTTON = 1
;endif

;************************************************************************************
;Define the structure to be passed around
;************************************************************************************

  xstalstr = {NAME: 'Xstal_Structure',$
;              h:[H1_FIELD,H2_FIELD,H3_FIELD],$
;              R0:[R01_FIELD,R02_FIELD,R03_FIELD],$
;              Bmin:[BMin1_FIELD,BMin2_FIELD,BMin3_FIELD],$
;              Bmax:[BMax1_FIELD,BMax2_FIELD,BMax3_FIELD],$
;              Twod:[Twod1_FIELD,Twod2_FIELD,Twod3_FIELD],$
              h:H1_FIELD,$
              R0:R01_FIELD,$
              Bmin:BMin1_FIELD,$
              Bmax:BMax1_FIELD,$
              Twod:Twod1_FIELD,$
              Length:Size1_FIELD,$
              Rcurve:Rcurve_LABEL,$
              xstalset:lonarr(numxstals),$ ;A flag to determine if the xstal is set
              exraystr:exraystr,$
              MainWidget:MainWidget}

  xstalstr.xstalset(*)=exraystr.xstalset(*)

  ;calculate and set the crystal substrate length
   h=exraystr.wxstal(0).h
   R0=exraystr.wxstal(0).R0
   ecc=sqrt(1+(h/R0)^2)-h/R0
   betamin=exraystr.wxstal(0).betamin
   betamax=exraystr.wxstal(0).betamax
   xmin=-h*cos(betamin)/(1.-ecc*cos(betamin))
   xmax=-h*cos(betamax)/(1.-ecc*cos(betamax))
   xxstal=(xmax-xmin)*(findgen(1000)*.001)+xmin
   yxstal=sqrt(h^2/(1.-ecc^2)-(xxstal+R0/2.)^2*(1.-ecc^2))
   dl=sqrt((xxstal(1:999)-xxstal(0:998))^2.+(yxstal(1:999)-yxstal(0:998))^2.)
   length=total(dl)
   widget_control,xstalstr.length,set_value=length
   exraystr.wxstal(0).length=length

  ;calculate the radius of curvature
  jbeta=findgen(10000)/9999.*(betamax-betamin)+betamin
  jtheta=atan((1-ecc*cos(jbeta))/(ecc*sin(jbeta)))
  rcurve=h*(1.-2.*ecc*cos(jbeta)+ecc^2.)^(3./2.)/(1.-ecc*cos(jbeta))^3.
  minrc=min(rcurve)
  maxrc=max(rcurve)
  exraystr.wxstal(0).rcurve=[minrc,maxrc]
  widget_control,xstalstr.Rcurve,set_value='    radius of curvature = ' $
     +strtrim(string(minrc,form='(F5.1)'),2)+' - ' $
     +strtrim(string(maxrc,form='(F5.1)'),2)+' cm'
 

  Widget_Control, MainWidget, set_uvalue = exraystr

 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  Widget_Control, /REALIZE, Exray_XstalWidget_BASE

  Widget_Control, Exray_XstalWidget_BASE, set_uvalue = xstalstr


  XManager, 'Exray_XstalWidget_BASE', Exray_XstalWidget_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro exray_xstalwidget, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_XstalWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end