

pro Exray_OverplotWidget_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = overstr

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='Open_DataFile_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        holdactive=overstr.exraystr.activedata
        exraystr=overstr.exraystr
        exray_opendata, exraystr
        overstr.exraystr=exraystr
        if (overstr.exraystr.datafile(overstr.exraystr.activedata) ne 'none') then begin
           index = where(overstr.exraystr.datafile ne 'none')
           widget_control,overstr.DataFile,SET_VALUE=overstr.exraystr.datafile(index)
           widget_control,overstr.DataFile,SET_DROPLIST_SELECT=overstr.exraystr.activedata
           overstr.exraystr.overwdf=overstr.exraystr.datawdf(overstr.exraystr.activedata)
           overstr.exraystr.activedata=holdactive
           overstr.dataOK = 1
        endif else overstr.dataOK=0
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Data_Filename'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_DROPLIST' )then begin
         overstr.dataOK=0
         for i=0,9 do begin
            if (Event.index eq i) then begin
               overstr.exraystr.overwdf=overstr.exraystr.datawdf(i)
               overstr.dataOK = 1
            endif
         endfor
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Quit_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
       ;save the values in 'global' variables
        if (overstr.dataOK eq 0) then begin
           whoops = dialog_message('You have not selected a data set for overplotting!',/Error)
           return
        endif
        if (overstr.exraystr.plotflag eq 3) then $
           overstr.exraystr.overflag=1 $
        else if (overstr.exraystr.plotflag eq 4) then $
           overstr.exraystr.overflag=2
        Widget_Control, overstr.MainWidget, set_uvalue = overstr.exraystr
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;quit without saving anything
        Widget_Control, overstr.MainWidget, get_uvalue = exraystr
        if (exraystr.overflag eq 0) then $
           Widget_Control, overstr.exraystr.widget.overplot, $
                           set_value='images/overplot.bmp',/bitmap
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = overstr


end

pro Exray_OverplotWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control, MainWidget, get_uvalue = exraystr
  mxy=exraystr.mxy

  index=where(exraystr.datafile ne 'none')
  if (index(0) lt 0) then datafiles='none' else datafiles=exraystr.datafile(index)

  Exray_OverplotWidget_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_OverplotWidget_BASE' ,XOFFSET=5 ,YOFFSET=5, Column = 1, $
      TITLE='Overplot' ,SPACE=3 ,XPAD=3 ,YPAD=3)

  DataFile_LABEL = Widget_Label( Exray_OverplotWidget_BASE,  $
      UNAME='DataFile_LABEL',/ALIGN_LEFT,VALUE='Select a dataset for overplotting')

  File_BASE = Widget_Base(Exray_OverplotWidget_BASE, UNAME='File_BASE',COLUMN=2)

  Data_Filename = Widget_DropList(File_BASE, UNAME='Data_Filename'  $
         ,FRAME=0.5 ,XOFFSET=11 ,YOFFSET=60 ,SCR_XSIZE=369,SCR_YSIZE=30 $
         ,XSIZE=20 ,YSIZE=1, VALUE=datafiles)

  Open_DataFile_BUTTON = Widget_Button(File_BASE,  $
      UNAME='Open_DataFile_BUTTON' ,XOFFSET=389 ,YOFFSET=60,SCR_XSIZE=30,SCR_YSIZE=30 $
      ,/ALIGN_CENTER ,VALUE='images/open.bmp',/BITMAP)

  Quit_BASE = Widget_Base(Exray_OverplotWidget_BASE, UNAME='Quit_BASE' $
      ,COLUMN=2,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Cancel')


  Quit_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Quit_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Done')


;************************************************************************************
;Define the structure to be passed around
;************************************************************************************

  overstr = {NAME: 'Options_Structure',$
              DataFile:Data_Filename,$
              dataOK:long(0),$
              exraystr:exraystr,$
              MainWidget:MainWidget}


 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  Widget_Control, /REALIZE, Exray_OverplotWidget_BASE

  Widget_Control, Exray_OverplotWidget_BASE, set_uvalue = overstr


  XManager, 'Exray_OverplotWidget_BASE', Exray_OverplotWidget_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro Exray_OverplotWidget, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_OverplotWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end
