FUNCTION interpolate_map,x_one,x_two
;
;This allows interpolate.pro to do what I wish it could do.
;This returns an array of indices that describes how 'x_one' maps onto 'x_two'.
;In other words, after using this and interpolate.pro, one can plot an interpolated 
;form of y_one against x_two
;These arrays are meant to be dependent variable arrays.
;
;Does not provide systematic uncertainty inherent in this interpolation.
;
;One should overplot interpolated result over original to check for consistency.

map_index=fltarr(N_ELEMENTS(x_two))

for i=0,N_ELEMENTS(x_two)-1 do begin

  index=max(where(x_one lt x_two[i]))
  if index lt 0 then begin
    map_index[i]=0
    continue
  endif
  if index eq N_ELEMENTS(x_one)-1 then begin
    map_index[i]=index
    continue
  endif else map_index[i]=(x_two[i]-x_one[index])/(x_one[index+1]-x_one[index])+index
  
endfor


return, map_index

end