; ------------------------------------------------------------------------ 
; $Id: atbackground.pro,v 1.2 2005/03/09 22:21:17 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2005 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
;+
; NAME:
;	ATBACKGROUND
;
; PURPOSE:
;	This procedure sets the background for ATHETA plots to black
;	(the default) or white.  The default drawing color switches
;       to the opposite color.
;
; CATEGORY:
;	ATHETA
;
; CALLING SEQUENCE:
;	ATBACKGROUND [, /BLACK] [, /WHITE]
;
; KEYWORD PARAMETERS:
;	BLACK:	Set background color to black and default drawing
;               color to white (Default).
;	WHITE:	Set background color to white and default drawing
;               color to black.
;
; MODIFICATION HISTORY:
; 	Written by:	Rebecca Coats, 5/97.
;-
pro atbackground, black=black, white=white
;
if keyword_set(black) then begin
  !P.BACKGROUND = 0
  !P.COLOR = 8
endif else if keyword_set(white) then begin
  !P.BACKGROUND = 8
  !P.COLOR = 0
endif
;
return
end
