; ------------------------------------------------------------------------ 
; $Id: atcell.pro,v 1.2 2005/03/09 22:21:38 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2005 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
pro atcell, colr, flip=flip, _extra=extra
;
; plot filled cells
;
common at_colr
common at_grid
common at_cell
;
nz = grid_nx
nr = grid_ny
z = grid_x
r = grid_y
dz = cell_dz
dr = cell_dr
cell = cell_index
;
mxcolr = n_elements(colr)
;
if not keyword_set(flip) then flip = 0
;
for m=1, nz-2 do begin
  for l=1, nr-2 do begin
    if cell(l,m) gt 0 then begin
      im = cell(l,m)
      zp = 0.5*dz(m) + .01*dz(m)
      zm = 0.5*dz(m-1) - .01*dz(m-1)
      rp = 0.5*dr(l) + .01*dr(l)
      rm = 0.5*dr(l-1) - .01*dr(l-1)
      if m eq 1 then begin
        zm = 0.0
        im = cell(l,2)
      endif else begin
      if m eq nz-2 then begin
        zp = 0.0
        im = cell(l,nz-3)
      endif
      endelse
      if l eq 1 then begin
        rm = 0.0
        im = cell(2,m)
      endif else begin
      if l eq nr-2 then begin
        rp = 0.0
        im = cell(nr-3,m)
      endif
      endelse
      bz = [z(m)-zm,z(m)+zp,z(m)+zp,z(m)-zm,z(m)-zm]
      br = [r(l)-rm,r(l)-rm,r(l)+rp,r(l)+rp,r(l)-rm]
      if im lt 0 or im gt mxcolr-1 then im=0
      cl = colr(im)
      if cl eq at_bgc then cl = !P.BACKGROUND $
      else if cl eq at_fgc then cl = !P.COLOR
      if flip then $
        polyfill, br, bz, color=cl, noclip=0, _extra=extra $
      else $
        polyfill, bz, br, color=cl, noclip=0, _extra=extra
    endif
  endfor
endfor
return
end
