 function  str2string, str, row
on_error, 1

;
; STR is csv structure
; Row is row index, 0 to nrow-1
; 
@csvcommon.dat

ier =1
if n_elements(initcsv) eq 0 then init_csv

if size(str, /type) ne 8 then begin
  print, '% STR2STRING: CSV structure must be defined.'
  return, ''
endif

tags = tag_names(str)

ok = get_match('CVS_TYPE', tags, nel = nel)
if nel ne 1 then begin
  print, '% STR2STRING: This structure is not a CVS_STRUCTURE'
  return, ''
endif

ncol = str.ncol
nrow = str.nrow

if (row lt 0) or (row ge nrow) then begin
  print, '% STR2STRING: Row must be in the range of 0 to '+strtrim(nrow-1, 2)
  return, ''
endif
ss = ''
for i = 0, ncol-1 do begin
  if i gt 0 then ss = ss+','
  var = (str.(i))[row]
  svar = size(var, /type)
  if svar eq 2 then begin
    if var ne integer_def then ss = ss+ strtrim(var, 2)
  endif else if svar eq 3 then begin
    if var ne long_def then ss = ss+ strtrim(var, 2)
  endif else if svar eq 4 then begin
    if var ne float_def then ss = ss+ strtrim(var, 2)
  endif else if svar eq 5 then begin
    if var ne double_def then ss = ss+ $
      strtrim(string(var,format ='(g22.12)'), 2)
  endif else begin
     if var ne string_def then begin
        var = strtrim(var, 2)
        if  (strpos(var, ',') ge 0) then var = '"'+var+'"'
        ss = ss + var
     endif
  endelse
endfor
return, ss
end
