; ------------------------------------------------------------------------ 
; $Id: setexo.pro,v 1.2 2007/06/06 19:40:42 lpmix Exp $
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro  setexo, p1, ierror = ierror, verbose = verbose
;+
;   Set the current file pointer to indicated file.
;   Format: SETEXO,  fileid [, /VERBOSE] [, IERROR = ierror]
;   where:
;      fileid - file id of desired file
;      VERBOSE- Keyword, if set, information about data will be printed.
;   Note:  If fileid is undefined or is zero, nothing is done.
;
;    Example:
;   Set the current file pointer to the file with a file id (fid) of 3
;      SETEXO, 3
;
;   Written by:     L. P. Mix, October 10, 2005
;
;-
;
on_error, 1
;
@exoduscom.dat
;
      ierror = 1
      if n_elements(init_exo) eq 0 then begin
         print, '% SETEXO: No Exodus files have been opened.'
         return
      end
;
;     check on the number of parameters
;
;     if no fid is entered then return
      if (n_elements(p1) eq 0) then begin
        print,'% Format: SETEXO,  File_Id,  [, /VERBOSE] [, IERROR = ierror] '
        return
      endif
;     if p1 is zero then quit
      if p1 eq 0 then begin
        print ,'% SETEXO: File Id is zero - nothing changed'
        ierror = 0
        return
      endif
;
;     get integers for the write
;
      ok = where (array_exoid(*, 0) eq p1, nok)
      if nok eq 0 then begin
        Print, '% SETEXO: ', strtrim(p1, 2), ' is not a valid file id.'
        ierror = 1
        return 
      endif
      exo_id = ok(0)
      load_exo_data, verbose = verbose
      ierror = 0
      end
