; ------------------------------------------------------------------------ 
; $Id: get_exo_string.pro,v 1.2 2007/06/06 19:40:52 lpmix Exp $
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro get_exo_string, dataset, strarray, map, nmap, nmax, ier, lcstring
;
;+
;
;  Gets a dataset from a string
;
;  dataset      the dataset specifier and may be a string or a number
;  Strarray     string array
;  map is the dataset list 
;  nmap is the number in map
;  nmax is the maximum number desired
;  lcstring is 0 if dataset is not a string
;           is +/- 1 if dataset is a string
;           (-1 if * or '' is passed as the dataset)
;  ier          1 if not successful
;               0 if successful
;  
;-
;
      on_error, 1
      ier = 1
      nmap = 0
      if n_elements (dataset) eq 0 then return
      b = size (dataset)
      if n_elements(dataset) eq 1 then begin
; scalar
        if b(b[0]+1)  eq 7 then begin
; string for dataset
          dataset = strtrim(dataset, 2)
          slen = strlen (dataset)
          lcstring = 1
          if slen le 1 then begin
            if dataset eq '*' or dataset eq '' then begin
              nmap = n_elements(strarray)
              map = 1+indgen(nmap)
              lcstring = -1
              slen = 0
            endif
          endif
          if slen gt 0 then begin
            map = get_match(dataset, strarray, nel = nmap)+1
            if nmap eq 0 then begin
              print, ' No match for string ', dataset
              return
            endif
;           if we have more try to find an exact match
            if nmap gt nmax then begin
              if (strmid(dataset, 0, 1) ne '^' ) then newdata = '^'+dataset $
                else newdata = dataset
              if (strmid(dataset, slen-1, 1) ne '$') then $
                newdata = newdata+'$'
              slen2 = strlen(newdata)
              if slen2 gt slen then $
                map = get_match(newdata, strarray, nel = nmap)+1
              if nmap eq 0 or nmap gt nmax then begin
                print, ' A unique dataset was not found with the string '
                print, '             ' , dataset, ' -- Current datasets are'
                direxo, dataset, /print
                return
              endif
            endif
          endif
        endif else begin
;         a number 
          nmap = n_elements(dataset)
          map = dataset
          lcstring = 0
        endelse
        if nmap gt 0 then map = map(0:nmap-1) else map = 0
      endif else begin
        lcstring = 0
        map = reform(dataset)
        nmap = n_elements(map)
      endelse
      if nmap gt 0 then ier = 0L
      end
