;charsets.pro
pro charsets, fontnum
if n_elements(fontnum) eq 0 then fontnum =3

; This MAIN_PROGRAM creates a printed Character Set list for a Postscript
; printer.  
;
; Simply run with:
;    IDL> startpost, font = 10, /port
;    IDL> charsets, 3
;    IDL> charsets, 9
;    IDL> endpost & lprint


  if (fontnum eq 3) then title='Helvetica' 
  if (fontnum eq 9) then title='Symbol (bang9)'


  plot,[0,60],[0,60],/nodata,xsty=7,ysty=7,$
    position=[0,0,1,1]				; set up coordinates
  xyouts,30,58,/data,align=.5,title			; print title
  startit = (fontnum eq 9) ? '!9':'!3'
  col=0
  row=0
  for i=1,255 do begin				; loop over all characters
    xyouts,col+5,55-row,'!3'+string(i)+'= '+startit+string(byte(i)),/data
    row=row+1
    if (row eq 52) then begin
      col=col+11
      row=0
    endif
  endfor
end


