PRO chk_m1,filename=filename
;
; This script will be used to compare two wedges,
; a test wedge named test_wedge.pff and a new wedge  
; to be input by the user. Plots of the output from 
; the pe_cal routine will be compared to determine 
; that the scanning is providing equivalent results.
; Also, background levels taken from the step will
; be compared to ensure proper scanning levels.
;

  on_error, 1
; close any open pff files 
  closepff,0

; delete wdf and str arrays
  delstr

; test file paramters
  test_fog=0.39
; open test curve pff file and extract test curve
  sep =  path_sep()
  fil = get_pfidl_directory()+'pfidl'+sep+'local'+sep+'data'+sep+'m1_m2_measurements.pff'
  openpff, fil
; Datasets 1, 2, & 3 are for M1
  re,10,1
  re,11,2
  re,12,3

  print,'Open the step wedge file you wish to fit'
  openpff,fname,path='~'+getenv('USER')+'/calibrations'
  readstr,1
  plotstr,1,cn=2
  xfr
  check_orient, orient
  if orient lt 0 then return else $
    if orient gt 0 then flipstr, 1, 2, rotat = orient else xfrstr, 1, 2
      
  plotstr,2,cn=2
  ans=' '
  xfrstr, 2, 3
  read, ans, prompt = 'Does image need to be croped? (y/n)'
  if(ans eq 'y') then winstr,2, save = 3

  print,'We will use the winstr command to get an average background level in the film'
  hak, /message
  winstr,3,ave=fog
  ;remove background fog level from image
  substr,3,0,fog ; reduce to net fog level
  str1=string(format='("Fog level on test film was: ",f5.3)',test_fog)
  print,str1
  str2=string(format='("Fog level on this film was: ",f5.3)',fog)
  print,str2
  d=(test_fog-fog)/test_fog * 100.0
  str3=string(format='("Difference of ",f6.2," %")',d)
  print,str3

  
  pe_cal,str=3,out=4
  hak, /messag
  barefname = get_bare_filename(fname, extension = extension)
  
  new_curve_date= barefname+extension
  new_name='Test Wedge: '+new_curve_date
  lab,4,new_name
  plo,[10,4,11,12],col=[1,2,7,7],line=[0,0,3,3],/ov
  xyouts,0.5,0.91,/norm,str1
  xyouts,0.5,0.88,/norm,str2
  xyouts,0.5,0.85,/norm,str3

  oname=barefname+'_test_wedge.ps'
  oname=strtrim(oname,2)
  ;startpost,file=oname,/color,/data
  ;plo,[10,4],/col,/ov,thick=4
  ;xyouts,0.5,0.91,/norm,str1
  ;xyouts,0.5,0.88,/norm,str2
  ;xyouts,0.5,0.85,/norm,str3
  ;endpost
end
