 pro clip_poly, poly, xx, yy, zz, x1 = x1, x2 = x2, x3 = x3, flag = flag

; Poly is the polygon vertex list of the form, n, v1, v2, ... vn, 
; XX, yy, zz are the coordinates
; Flag is a vector of values for each coordinate.
; Value of 0 indicates no filtering
; Value gt 0 indicates xvalue is a maximum
; Value lt 0 indicates xvalue is a minimum
; X1, x2, x3 are the xvalues corresponding to flag[0, 1, 2] respectively
;
 on_error, 1
 npoly = n_elements (poly)
 if npoly eq 0 then begin
   print, '% CLIP_POLY: Poly must have values
   return
 endif
 if n_elements(flag) lt  3 then begin
   print, '% CLIP_POLY: Flag must have 3 elements
   return
 endif
 i = 0L & j = 0L
 ok = where (flag[0:2] ne 0, nflag)
 if nflag eq 0 then return

 while i lt npoly do begin
   n= poly[i]
;  
   nokeep = 0
   if flag[0] ne 0 then begin
     x =xx[poly[i+1: i+n]]
     if flag[0] lt 0 then ok = where (x gt x1, nok) else $
       ok = where (x lt x1, nok)
     if nok gt 0 then nokeep = 1
   endif
   if flag[1] ne 0 then begin
     x =yy[poly[i+1: i+n]]
     if flag[1] lt 0 then ok = where (x gt x2, nok) else $
       ok = where (x lt x2, nok)
     if nok gt 0 then nokeep = nokeep+1 
   endif

   if flag[2] ne 0 then begin
     x =zz[poly[i+1: i+n]]
     if flag[2] lt 0 then ok = where (x gt x3, nok) else $
       ok = where (x lt x3, nok)
     if nok gt 0 then nokeep = nokeep+1 
   endif
   if nokeep lt nflag then begin
     poly[j:j+n] = poly [i:i+n]
     j = j+n+1
   endif 
   i = i+n+1
 endwhile
 help, i, j
 if j gt 0 then poly = poly[0:j-1] else poly = -1
 end
