; ------------------------------------------------------------------------
; $Id$
; ------------------------------------------------------------------------
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
;+
; NAME:
;       MAKE_EXO_FIELD
;
; PURPOSE:
;       Tell what your routine does here.  I like to start with the words:
;	"This function (or procedure) ..."
;	Try to use the active, present tense.
;
; CATEGORY:
;       Put a category (or categories) here.  For example:
;	Widgets.
;
; CALLING SEQUENCE:
;       Write the calling sequence here. Include only positional parameters
;	(i.e., NO KEYWORDS). For procedures, use the form:
;
;       ROUTINE_NAME, Parameter1, Parameter2, Foobar
;
;	Note that the routine name is ALL CAPS and arguments have Initial
;	Caps.  For functions, use the form:
; 
;       Result = FUNCTION_NAME(Parameter1, Parameter2, Foobar)
;
;	Always use the "Result = " part to begin. This makes it super-obvious
;	to the user that this routine is a function!
;
; INPUTS:
;       Parm1:	Describe the positional input parameters here. Note again
;		that positional parameters are shown with Initial Caps.
;
; OPTIONAL INPUTS:
;       Parm2:	Describe optional inputs here. If you don't have any, just
;		delete this section.
;	
; KEYWORD PARAMETERS:
;       KEY1:	Document keyword parameters like this. Note that the keyword
;		is shown in ALL CAPS!
;
;       KEY2:	Yet another keyword. Try to use the active, present tense
;		when describing your keywords.  For example, if this keyword
;		is just a set or unset flag, say something like:
;		"Set this keyword to use foobar subfloatation. The default
;		 is foobar superfloatation."
;
; OUTPUTS:
;       Describe any outputs here.  For example, "This function returns the
;	foobar superflimpt version of the input array."  This is where you
;	should also document the return value for functions.
;
; OPTIONAL OUTPUTS:
;       Describe optional outputs here.  If the routine doesn't have any, 
;	just delete this section.
;
; COMMON BLOCKS:
;       BLOCK1:	Describe any common blocks here. If there are no COMMON
;		blocks, just delete this entry.
;
; SIDE EFFECTS:
;	this entry.
;
; RESTRICTIONS:
;	Describe any "restrictions" here.  Delete this section if there are
;	no important restrictions.
;
; PROCEDURE:
;	You can describe the foobar superfloatation method being used here.
;	You might not need this section for your routine.
;
; EXAMPLE:
;	Please provide a simple example here. An example from the PICKFILE
;	documentation is shown below. Please try to include examples that
;       do not rely on variables or data files that are not defined in
;       the example code. Your example should execute properly if typed
;       in at the IDL command line with no other preparation.
;
;	Create a PICKFILE widget that lets users select only files with 
;	the extensions 'pro' and 'dat'.  Use the 'Select File to Read' title 
;	and store the name of the selected file in the variable F.  Enter:
;
;		F = PICKFILE(/READ, FILTER = ['pro', 'dat'])
;
; MODIFICATION HISTORY:
; 	Written by:	L. P. Mix, Jr., March 30, 2005
;	July, 1994	Any additional mods get described here.  Remember to
;			change the stuff above if you add a new keyword or
;			something!
;-

 pro make_exo_field, fileout, filein, strarray = strarray

on_error,1
@write_exo_header_com.dat
  
  if n_elements (fileout) eq 0 then fileout = 'qsfld.exo'
  lcopenpff =0
  if n_elements (strarray) gt 0 then str = strarray[0] else begin
    if n_elements (filein) eq 0 then fname = 'fldsnp.pff' else fname = filein
    info = file_info(fname)
    if (info.exists + info.read) ne 2b then begin
      print, '% MAKE_EXO_CONDUCTOR: File does not exist with read permission'
      print, '           File Name = ', fname
      print, '           File Exists =', info.exists
      print, '           Read Permission =', info.read
      return
    endif
    openpff, fname, ndset = ndset
    lcopenpff = 1
    str =1
    readstr, str, 2
  endelse
  get_dir, 0, 2,2,comm= comm, /no_trim
  variable_name = strtrim(strmid(comm[0], 0, 32), 2)
  if n_elements (str) ne 0 then s2i, s, str
  if size (s, /type) lt 8 then begin
    print, '% MAKE_EXO_FIELD: Structure must be defined'
    return
  endif

  fileout = find_newfile(fileout, /quiet)
  if s.ndim ne 3 then begin
    print, '% MAKE_EXO_CONDUCTOR: This version requires 3D data'
    return
  endif
; get the names of the conductors
  nblock = s.block
  loc_nodes = make_array(nblock+1, value =0L)
  loc_elem = loc_nodes
;
  nvect = s.nvect
  ss = s.size

  for i = 1L, nblock do loc_nodes[i]=ss[0,i-1]*ss[1,i-1]*ss[2,i-1]+loc_nodes[i-1]
  for i = 1L, nblock do loc_elem[i]= $
    ((ss[0,i-1]-1) > 1L)*((ss[1,i-1]-1) > 1L)*((ss[2,i-1]-1) > 1L)+loc_elem[i-1]
  nodes = make_array(3, loc_nodes[nblock])
  if s.two eq 0 then begin
    lcshape = 'HEX'
    nconnect = 8L
  endif else begin
    lcshape = 'SHELL'
    nconnect = 4L
  endelse
  blo_type =make_array(nblock, value = lcshape)
  connect = make_array(nconnect, loc_elem[nblock], /long)
  for nb = 1L, nblock do begin
    x= get_array(s, 1, nb)
    y= get_array(s, 2, nb)
    z= get_array(s, 3, nb)
    inode = loc_nodes[nb-1]
    nx = ss[0, nb-1]
    ny = ss[1, nb-1]
    nz = ss[2, nb-1]
    nxy = nx*ny
    for iz = 0, nz-1 do for iy = 0, ny-1 do for ix = 0, nx-1 do begin
      nodes[0, inode] =[x[ix], y[iy], z[iz]]
      inode += 1
    endfor
    inode = loc_elem[nb-1]
    if s.two eq 0 then begin
      xcon = [0, 1, 1, 0, 0, 1, 1, 0]
      for iz = 0, nz - 2 do begin
        zcon = iz*nxy + loc_nodes[nb-1] + [0, 0, 0, 0, nxy, nxy, nxy, nxy]
        for iy = 0, ny - 2 do begin
          ycon = iy*nx + [0, 0, nx, nx, 0, 0, nx, nx] +zcon
          for ix = 0, nx - 2 do begin
            connect[0, inode] = ix + xcon + ycon
            inode += 1
          endfor
        endfor
      endfor
    endif else begin
      if s.two eq 1 then begin
        xcon = [0, 1, 1, 0]
        for iz = 0, nz-2 do begin
          zcon = iz*ny +loc_nodes[nb-1] +xcon +[0, 0, nxy, nxy]
          for iy = 0, ny-2 do begin
            connect[0, inode]= zcon + iy
            inode += 1
          endfor
        endfor
      endif else if s.two eq 2 then begin
        xcon = [0, 1, 1, 0]
        for iz = 0, nz-2 do begin
          zcon = iz*nxy +loc_nodes[nb-1] +[0, 0, nxy, nxy] +xcon
          for ix = 0, nx-2 do begin
            connect[0, inode]= zcon + ix
            inode += 1
          endfor
        endfor
      endif else begin
        xcon = [0, 1, 1, 0]
        for iy = 0, ny-2 do begin
          zcon = iy*nx +loc_nodes[nb-1] +xcon +[0, 0, nx, nx]
          for ix = 0, nx-2 do begin
            connect[0, inode]= zcon + ix
            inode += 1
          endfor
        endfor
      endelse
    endelse
  endfor
  get_uniq_nodes, nodes, newcoord, ind

  if s.spare[0] eq 2 then begin
    ctheta = reform(cos(newcoord[1, *]))
    stheta = reform(sin(newcoord[1, *]))
    newcoord[1, *] = newcoord[0, *]*stheta
    newcoord[0, *] = newcoord[0, *]*ctheta
    ctheta =0
    stheta =0
  endif

  newcoord = transpose(newcoord)
  ss = size(newcoord)
  num_nodes = ss[1]
  help, num_nodes, newcoord
;  dlconnect = reform (ind, 4, nplanes, /overwrite) +1L

  cdfid = ncdf_create(fileout, clobber = clobber)
  help, cdfid
  title = 'IDL/ExodusII: '+systime(0)
  help, fileout, cdfid
  
  num_elem= loc_elem[1:nblock]-loc_elem[0:nblock-1]
  nvar = nvect

  write_exo_header, cdfid, nblock = nblock, nnode = num_nodes, nelem= num_elem, $
    blo_type = blo_type, title = title, numnodevar = nvar, numelemvar=0

  farray = make_array(num_nodes, nvar )
  if nvar eq 1 then farray [ind, nvar-1] = get_array(s, -1, /all) else begin
    farray[ind, 0] = get_array(s, -1, /all)
    farray[ind, 1] = get_array(s, -2, /all)
    if nvar eq 3 then farray[ind, 2] = get_array(s, -3, /all)
  endelse
  ncdf_varput, cdfid, coordxid, newcoord[*, 0]
  ncdf_varput, cdfid, coordyid, newcoord[*, 1]
  ncdf_varput, cdfid, coordzid, newcoord[*, 2]
  coord_names = make_array(3, /string)

  coord_names[0] = 'X axis'
  coord_names[1] = 'Y axis'
  coord_names[2] = 'Z axis'
;  ind += 1
  print, ' IND range: ',  min(ind, max = m), m
  ncdf_varput, cdfid, coordnamid, coord_names
  varname = make_array(nvar, /string)
  if nvar eq 1 then varname [0] = variable_name else begin
    varname[0] = variable_name+'_x'
    varname[1] = variable_name+'_y'
    if nvar eq 3 then varname[2] = variable_name+'_z'
  endelse
  ncdf_varput, cdfid, nodenamid, varname

  for i = 1L, nblock do $
    ncdf_varput, cdfid, connectid[i-1], ind[connect[*, loc_elem[i-1]:loc_elem[i]-1]]+1L
  ntimes = (lcopenpff eq 0) ? n_elements(strarray) : ndset-1
  times = make_array(ntimes)
  if lcopenpff eq 1 then str_range = indgen(ntimes)+2
  for nts = 1, ntimes  do begin
    if lcopenpff gt 0 then readstr, str, str_range[nts-1] $
      else str = strarray[nts-1]
    c = strcomment(str)
    jj = strpos(c, 't=')
    reads, strmid(c, jj+2), time
    times[nts-1] = time
    if nvar eq 1 then farray [ind, nvar-1] = get_array(str, -1, /all) else begin
      farray[ind, 0] = get_array(str, -1, /all)
      farray[ind, 1] = get_array(str, -2, /all)
      if nvar eq 3 then farray[ind, 2] = get_array(str, -3, /all)
    endelse
    ncdf_varput, cdfid, timewholeid, time, offset = (nts-1)
    for i = 0, nvar-1 do ncdf_varput, cdfid, nodevarid[i], farray[*, i], offset = [0, nts-1]
  endfor
  print, times
  if lcopenpff eq 1 then closepff, 0
  ncdf_close, cdfid
  end
