pro ntof_doit, shot, verbose = verbose, scan = scan
;
@ntof_common.dat
on_error, 2

if n_elements(shot) gt 0 then ntof, shot[0], /read

mag = 30
numb_losm = numb_los-1
for i = 0, numb_losm do begin
  wtot = detect_wdf[*,*, i]
  ok = where (wtot gt 0, nok)
  if nok gt 0 then begin
    wtot = wtot[ok]
    zoomw, wtot, zoomrange = totzoom,  instructions = 'Center the DD peaks in the right window'
print, 'totzoom ', totzoom
    plo, wtot, xrange= totzoom
    for j = 0, numb_detect[i]-1 do begin
      wdf = detect_wdf[*, j, i]
      ok = where(wdf gt 0, nok) 
      ddzoom = totzoom
      if nok gt 0 then begin
        wdf = wdf[ok]
        lcquit = 1
        while lcquit gt 0 do begin
          zoomw, wdf, zoomrange = ddzoom, xcur = xcur, instructions = 'Pick the DD peak beginning/end.'
          if nok gt 1 then begin
            plo, wdf, xr = xcur
            for k = 1, n_elements(wdf) do print, k, ' ', wdcomment(wdf[k-1])
            read, ia, prompt= ' Pick the desired waveform.  Enter 1, ... : '
            ia = (ia > 1) <  nok
          endif else ia = 1
          st = min(xcur, max = en)
          bl = ave(wdf[ia-1], left = st-1.5e-9, right = st+1.5e-9, /quiet)
          w = 10.
          m = mn(wdf[ia-1], lef= st, right = en , time= t, /quiet)
          estimate = [m - bl,(t-st)*1e9, w, bl]
          temp = ion_temp(wdf[ia-1], window= xcur, /deut, /plot, lcquit = lcquit, $
            est = estimate, coeff = coeff)
          if keyword_set(verbose) then print, coeff
        endwhile
        lcquit = 1
        dtzoom = ddzoom- 26.6*detect_dist[j,i]*1e-9
        while lcquit gt 0 do begin
          zoomw, wdf, zoomrange = dtZoom, xcur = xcur, instructions = 'Pick the DT peak beginning/end.'
          if nok gt 1 then begin
            for k = 1, n_elements(wdf) do print, k, ' ', wdcomment(wdf[k-1])
           plo, wdf, xr = xcur
            read, ia, prompt= ' Pick the desired waveform.  Enter 1, ... : '
            ia = (ia > 1) <  nok
          endif else ia = 1
          st = min(xcur, max = en)
          bl = ave(wdf[ia-1], left = st-1.5e-9, right = st+1.5e-9, /quiet)
          w = 10.
          m = mn(wdf[ia-1], lef= st, right = en , time= t, /quiet)
          
          estimate = [m - bl,(t-st)*1e9, w, bl]
          temp = ion_temp(wdf[ia-1], window= xcur, /tritium, /plot, lcquit = lcquit, $
            est = estimate, coeff = coeff)
          if keyword_set(verbose) then print, coeff
        endwhile
      endif
    endfor
  endif
  if i lt (numb_losm) then begin
    ans = ''
    read, ans, prompt='Do you wish to continue? (Y or N)'
    if strupcase(strmid (strtrim(ans, 2), 0,1)) eq 'N' then return
  endif
endfor
ntof_fit, /plotit
end
