; ------------------------------------------------------------------------ 
; $Id: scan.pro,v 1.2 2005/03/09 22:46:52 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2005 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
; /remote/lpmix/consult/jebaile/scan.pro
pro scan, wdf, temperature = temp, emission = emission, out = out, $
         chi = chi, error =error

on_error, 1

if n_elements (error) eq 0 then error = 0.05

nele = n_elements (emission)
  if n_elements (out) eq 0 then out = get_maxwdf()-3
if nele gt 1 then begin
  temp = make_array(nele) 
  chi = temp

  for i = 0, nele-1 do begin
    fit_spec, wdf, temp= tmp, emis = emission[i],chi= tchi, /tonly, verb =0, $
      error = error
    temp[i] = tmp
    chi[i] = tchi
  endfor
  i2w, emission, temp, out, /xydata, clab = 'Temperature vs Emissivity', $
    xlab = 'Emissivity', ylab = 'Temperature(eV)'
  i2w, emission, chi, out+1, /xydata, clab = 'Chi-sq vs Emissivity'
    xlab = 'Emissivity', ylab = 'Chi-sq'
  i2w, temp, chi, out+2,  /xydata, clab = 'Chi-sq vs Temperature'
    ylab = 'Chi-sq', xlab = 'Temperature(eV)'
  return
endif

nele = n_elements (temp)
if nele gt 1 then begin
  emission = make_array(nele) 
  chi = emission
  for i = 0, nele-1 do begin
    fit_spec, wdf, temp= temp[i], emis = tmp, chi= tchi,/eonly, verb =0, $
      error = error
    emission[i] = tmp
    chi[i]= tchi
  endfor
  i2w, temp, emission, out, /xydata, clab = 'Emissivity vs Temperature'
    ylab = 'Emissivity', xlab = 'Temperature(eV)'
  i2w, emission, chi, out+1, /xydata, clab = 'Chisq vs Emissivity'
    xlab = 'Emissivity', ylab = 'Chi-sq'
  i2w, temp, chi, out+2, /xydata, clab = 'Chisq vs Temperature'
    ylab = 'Chi-sq', xlab = 'Temperature(eV)'
  return
endif
print, '% SCAN: Either Emission or Temperature must be provided.'
return
end
