;+
;   Widget to interactively draw a multi-block 3D grid
;   format: qs_plotter, c_normin, x_normin, XSIZE=x_size, YSIZE=y_size, $
;        reset = reset, GROUP=GROUP, noload = noload
;
;-
;
 PRO qs_plotter_event, event
;
;  Common Blocks
;
@qsplotpars.com
;
;  When a widget is manipulated,
;   put its User Value into the variable 'eventval':
;
      col_offset = 2
      WIDGET_CONTROL, event.id, GET_UVALUE = eventval
; Perform actions based on the User Value of the event:
;
  CASE eventval OF
   'DRAW_WIN_EVENT': BEGIN

     coord = convert_coord(event.x, event.y, /device, /to_data)
     if lcurse then begin
       widget_control, xcurse, set_value = coord[0]
       widget_control, ycurse, set_value = coord[1]
     endif

      CASE curoper of

      'ZOOM': BEGIN
             if event.press EQ 1 then begin
;            a point has been designated
                if narray lt 0 then begin
                   narray = 0
                   arr = coord
                  if n_elements (arr) gt 1 then begin
                    oplot, [arr[0], arr[0]], !y.crange, color= 0, lines = 2
                    oplot, !x.crange, [arr[1], arr[1]], color= 0, lines = 2 
                  endif
                   widget_control, qsinstr,set_value = $
                   'Indicate opposite corner of the ZOOM region'
                 endif else begin
                   tempx = [min([arr[0], coord[0]], max = maxx) , maxx]
                   tempy = [min([arr[1], coord[1]], max = maxx) , maxx]
                   qsplot, xrange=tempx, yrange=tempy
;
                   curoper = 'WAIT'
                   tempx = 0
                   widget_control, qsinstr,set_value = $
                   'Pick an Activity or press DONE '
;                  Clear events and make the draw widget insensitive 
;;                   widget_control, draw, /clear_events, draw_motion_events=0
                 endelse
             endif else begin
;               we are moving the cursor over the plot
                if narray lt 0 then begin
;                 indicate the current point
                  if n_elements (arr) gt 1 then begin
                    oplot, [arr[0], arr[0]], !y.crange, color= 0, lines = 2
                    oplot, !x.crange, [arr[1], arr[1]], color= 0, lines = 2 
                  endif
                  arr = coord
                  oplot, [arr[0], arr[0]], !y.crange, color=7, lines = 2
                  oplot, !x.crange, [arr[1], arr[1]], color=7, lines = 2
                endif else begin
                  if (n_elements(tempx) gt 1) then $
                  oplot, [tempx[0], tempx[1], tempx[1], tempx[0], tempx[0]], $
                    [tempy[0], tempy[0], tempy[1], tempy[1], tempy[0]], $
                    color = 0, lines = 2  else begin
                    oplot, [arr[0], arr[0]], !y.crange, color= 0, lines = 2
                    oplot, !x.crange, [arr[1], arr[1]], color= 0, lines = 2 
                  endelse  
                  tempx = [min([arr[0], coord[0]], max = maxx) , maxx]
                  tempy = [min([arr[1], coord[1]], max = maxx) , maxx]
                  oplot, [tempx[0], tempx[1], tempx[1], tempx[0], tempx[0]], $
                    [tempy[0], tempy[0], tempy[1], tempy[1], tempy[0]], $
                    color = 7, lines = 2
                endelse
              endelse
           END

           ELSE: begin
             if event.press EQ 1 then begin
;;               point_locate, coord, b_select, gsel, float=lcfloat
             endif
           END

        ENDCASE
        END

   'CONTROLS': BEGIN
              buttn = event.value
     CASE buttn of

      'ZOOM': BEGIN
              if curoper eq 'WAIT' then begin
		; Set the window number - important for multiple windows
		WSET, cur_win
;;                widget_control, draw, /clear_events, sensitive = 1, $
;;                  draw_motion_events = 1
                widget_control, qsinstr,set_value = $
                  'Indicate one corner of the ZOOM region'
                arr = -1
                narray = -1
                curoper = 'ZOOM'
              endif
             END

     'RESET': BEGIN
              if curoper eq 'WAIT' then begin
		; Set the window number - important for multiple windows
		WSET, cur_win
                ; Redraw the full image
                qsplot
              endif
             END

      ENDCASE
           END
  
  'PLOT_PLANE': BEGIN
      value = Event.Value
      if value le 2 then begin
        c_norm = abs(value-3)
        flip = 0
      endif else begin
        c_norm = abs(value-6)
        flip = 1
      endelse
      x_norm = zslice[c_norm-1]
      qs_plotsetup
      widget_control, slice, set_value=[x_norm,zrange[*,c_norm-1]]
      qsplot
      END

  'SLICE': BEGIN
      if event.drag eq 0 then begin
        widget_control, event.id, get_value = x_norm
        zslice[c_norm-1] = x_norm
        qsplot
      endif
      END

   'PLOT_SETTINGS': BEGIN
      IF Event.Select THEN Sel = 1 ELSE Sel = 0
      CASE Event.Value OF
      0: begin
           lc1to1 = Sel
           qsplot, xrange=!x.crange, yrange=!y.crange
         endcase
      1: begin
           lcurse = Sel
           if Sel then begin
             widget_control, xcurse, sensitive = 1
             widget_control, ycurse, sensitive = 1
           endif else begin
             widget_control, xcurse, sensitive = 0
             widget_control, ycurse, sensitive = 0
           endelse
         endcase
      ELSE: Message,'Unknown button pressed'
      ENDCASE
      END

   'PLOT_FLAGS': BEGIN
      IF Event.Select THEN Sel = 1 ELSE Sel = 0
      CASE Event.Value OF
      0: lcgrid = Sel
      1: lccond = Sel
      2: lcdiel = Sel
      3: lcbcnd = Sel
      4: lcdiag = Sel
      5: lcslic = Sel
      ELSE: Message,'Unknown button pressed'
      ENDCASE
      qsplot, xrange=!x.crange, yrange=!y.crange
      END

   'ALL_DONE': BEGIN
              buttn = event.value
      CASE buttn of

     'DONE': BEGIN
            if old_win ge 0 then wset, old_win
            WIDGET_CONTROL, event.top, /DESTROY
           END

      ENDCASE
      END

    ELSE: Print, eventval,' is not supported at this time.'
    ENDCASE

      END
;
 PRO   qs_plotter, c_normin, x_normin, XSIZE=x_size, YSIZE=y_size, $
        flip=flipin, reset=reset, GROUP=GROUP, noload=noload
;
;+ 
;       QSEDIT
;-
;
@qs_data.com
@qsplotpars.com
@draw_defaults.com
;
      on_error, 1
;
      if n_elements(c_normin) ne 0 then c_norm = c_normin $
      else if n_elements(c_norm) eq 0 then c_norm = 3
      if n_elements(zslice) eq 0 then begin
        zslice = make_array(3,/float)
        zslice[*] = qs_grid.range[0,*,0]
      endif
      if n_elements(x_normin) ne 0 then zslice[c_norm-1] = x_normin
      if n_elements(flipin) ne 0 then flip = flipin $ 
      else if n_elements(flip) eq 0 then flip = 0 

      if n_elements(lcgrid) eq 0 then lcgrid = 1
      if n_elements(lccond) eq 0 then lccond = 1
      if n_elements(lcdiel) eq 0 then lcdiel = 1
      if n_elements(lcbcnd) eq 0 then lcbcnd = 1
      if n_elements(lcdiag) eq 0 then lcdiag = 1
      if n_elements(lcslic) eq 0 then lcslic = 1
      if n_elements(lc1to1) eq 0 then lc1to1 = 0
      if n_elements(lcurse) eq 0 then lcurse = 0
      if n_elements(rrratio) eq 0 then set_drawsize, /init
;
      if n_elements(zrange) eq 0 then begin
        zrange = make_array(2,3,/float)
        zrange[*,*] = qs_grid.range[*,*,0]
      endif
      qs_plotsetup
;
;  do the color table
      if (not keyword_set(noload)) then loadxyct
      device, set_graphics = 3
      cerase = !d.n_colors -1
;
      old_win = !d.window
; The size of the draw area is one of the more important parameters
; for a draw widget.  This example uses keywords to define the size
; of the draw area.  An alternative would be to use a fixed size draw area. 
;
      if (NOT keyword_set(x_size)) THEN x_size = bigsize[0]
      if (NOT keyword_set(y_size)) THEN y_size = 0.7*bigsize[1]
;
;  Set the base widget
      base = WIDGET_BASE(/COLUMN, /FRAME)
;
;  the Instructional widget base
;
      insbase =  WIDGET_BASE(base, /ROW, /FRAME)
;
;  Now a base for the draw widget and another for plot controls
;
  dbase = WIDGET_BASE(base, $
      /ROW, $
      MAP=1)

  pbase = WIDGET_BASE(base, $
      COLUMN=1, $
      MAP=1)
;
; A widget for instructional text is created
;
      qsinstr = WIDGET_LABEL(insbase,  VALUE = 'Instructions:')
      qsinstr = WIDGET_Text(insbase, xsize = 40, edit= 0, $
      value = 'Pick an Activity or press DONE ')

;  A widget called 'draw' is created.
      draw = WIDGET_DRAW(dbase, $
	/BUTTON_EVENTS, $	;generate events when buttons pressed
        /MOTION_EVENTS, $	;generate events when cursor moves over window
	/FRAME, $
	UVALUE = 'DRAW_WIN_EVENT', $
	RETAIN = 2, $		;make sure draw is redrawn when covered
	XSIZE = x_size, $
	YSIZE = y_size)

  Btns105 = [ $
    'grid  ', $
    'conductors  ', $
    'dielectric  ', $
    'BCs  ', $
    'histories  ', $
    'slice locations']
  pflags = CW_BGROUP( pbase, Btns105, $
      /ROW, $
      LABEL_LEFT='Show:', $
      NONEXCLUSIVE=1, $
      set_value = [lcgrid, lccond, lcdiel, lcbcnd, lcdiag, lcslic], $
      UVALUE='PLOT_FLAGS')

  sbase = WIDGET_BASE(pbase, $
      BASE_ALIGN_CENTER=1, $
      SPACE=40, $
      ROW=1, $
      MAP=1)

  Btns102 = [ $
    'ij', $
    'ki', $
    'jk', $
    'ji', $
    'ik', $
    'kj']
  pplane = CW_BGROUP( sbase, Btns102, $
      ROW=2, $
      EXCLUSIVE=1, /NO_RELEASE, $
      FRAME=1, $
      LABEL_LEFT='Plot plane:', $
      set_value = (3*flip) + (3-c_norm), $
      UVALUE='PLOT_PLANE')

  slice = CW_FSLIDER( sbase, $
      DRAG=1, $
      FRAME=1, $
      MAXIMUM=zrange[1,c_norm-1], $
      MINIMUM=zrange[0,c_norm-1], $
      EDIT=1, $
      TITLE='   Current slice  ', $
      UVALUE='SLICE', $
      VALUE=zslice[c_norm-1])

  bbase = WIDGET_BASE(sbase, $
      ROW=1, $
      MAP=1)

  Btns107 = [ $
    '    Zoom    ', $
    '    Reset   ']
  Uval107 = [ $
    'ZOOM', $
    'RESET'] 
  pcontrol = CW_BGROUP( bbase, Btns107, $
      ROW=1, /NO_RELEASE, $
      SPACE=10, $
      BUTTON_UVALUE=Uval107, $
      UVALUE='CONTROLS')

  BASE171 = WIDGET_BASE(pbase, $
      ROW=1, $
      MAP=1)

  Btns101 = [ 'Aspect 1:1  ', 'Cursor Active' ]
  curse = CW_BGROUP( BASE171, Btns101, $
      /ROW, $
      NONEXCLUSIVE=1, $
      set_value = [lc1to1, lcurse], $
      UVALUE='PLOT_SETTINGS')

   xcurse = CW_FIELD( BASE171,VALUE=0.0, $
      ROW=1, $
      FLOAT=1, $
      TITLE='x:', $
      UVALUE='XCURSE', $
      XSIZE=10, $
      /NOEDIT)

   ycurse = CW_FIELD( BASE171,VALUE=0.0, $
      ROW=1, $
      FLOAT=1, $
      TITLE='y:', $
      UVALUE='YCURSE', $
      XSIZE=10, $
      /NOEDIT)

  donebase = WIDGET_BASE(base, $
      ALIGN_RIGHT=1, $
      COLUMN=1, $
      XPAD=10, $
      MAP=1)

  Btns108 = [ '     Done     ' ]
  Uval108 = [ 'DONE' ]
  pdone = CW_BGROUP( donebase, Btns108, $
      ROW=1, /NO_RELEASE, $
      BUTTON_UVALUE=Uval108, $
      UVALUE='ALL_DONE')
;
;  Realize the widgets:
;
      WIDGET_CONTROL, base, /REALIZE
;
;  Get the window number from the draw widget.  This can only be done
;  after the widget has been realized.
;
      WIDGET_CONTROL, draw, GET_VALUE=cur_win
      WSET, cur_win
;
; Clear events and make the draw widget insensitive 
;
         widget_control, xcurse, sensitive = 0
         widget_control, ycurse, sensitive = 0
;;         widget_control, draw, /clear_events, draw_motion_events=0
;
        curoper = 'WAIT'
;
        qsplot
;
;  Hand off control of the widget to the XMANAGER:
;
      XMANAGER, "qs_plotter", base, GROUP_LEADER=GROUP
;
      END
