; ------------------------------------------------------------------------ 
; $Id: setpdb.pro,v 1.3 2007/06/06 19:44:56 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
  pro setpdb, fileid, ierror = ier
;
;+
;   Set the current file pointer to file with specified pdb file id
;   Format: SETPDB,  fileid, ierrror = ierror
;   where:
;      fileid - file id of desired file
;      ierror - error parameter
;               returns zero if no error
;   Note:  If fileid is undefined or is zero, nothing is done.
;    Example:
;   Set the current file pointer to the file with a file id (fid) of 3
;      setpff, 3
;-

;
@pdbcom.dat

; PDB common block
; 
;
; common pdbcommon, initpdb, pdb_exe, ufid, pdbfid, maxfid, curfid, file_info
;
;     start the process
;
      on_error, 1
      ier = 1
      if n_elements(initpdb) eq 0 then initpdb =0
      if initpdb eq 0 then begin
        PRINT, '% SETPDB: Cannot set file pointer. No files are open.'
        return
      endif
      if curfid lt 0 then begin
        PRINT, '% SETPDB: Cannot set file pointer. No files are open.'
        return
      endif
      ier =0
      if n_elements (fileid ) eq 0 then return
      ok = where (fileid(0) eq ufid, nok)
      if nok gt 0 then curfid = ok(0) else begin
        PRINT, '% SETPDB: Cannot set file pointer. ', strtrim (fileid(0), 2), $
         ' is not a valid file id.'
        ier = 1
      endelse
      end


