; ------------------------------------------------------------------------ 
; $Id: cell2node_3d.pro,v 1.4 2007/06/06 19:45:14 lpmix Exp $
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro cell2node_3d, values, imat, nodes

; 
; put cell values on nodes.
;
 nodes = 0
 ss = size(values)
 sss = size (imat)
 if ( (ss[1] ne sss[1])or (ss[2] ne sss[2]) ) then begin
   print, '% CELL2NODE_3D:  Material and values matric must be the same size.
   print, 'Values:', ss[1], ss[2]
   print, 'Region:', sss[1], sss[2]
   return
 endif
 if ss[0] eq sss[0] +1 then begin
   temp = intarr(ss[1], ss[2], ss[3])
   for i = 0, ss[3]-1 do temp[*,*,i] = imat
   imat = temporary(temp)
 endif else if ss[0] ne sss[0] then begin
   print, '% CELL2NODE_3D: Dimensions of material and values must be the same'
   print, ss[0], sss[0]
   return
 endif

 bad = where (imat(1:*, 1:*, *) eq 0, nbad)
 nx = ss(1)
 nxm = nx-1
 ny = ss(2)
 nym = ny-1
 if ss(0) eq 3 then nz = ss(3) else nz = 1
 nvalr = make_array(nxm, nym, nz , value = 1, /int)
 valr = values(1:nxm, 1:nym, * )
 if nbad gt 0 then begin
   nvalr[bad]= 0
   valr[bad]=0.0
 endif
 nval = intarr(nx, ny, nz)
 if size(values, /type) eq 5 then $ 
   nodes = make_array(nx, ny, nz, /double, value = 0.0d0) $
   else nodes = make_array(nx, ny, nz, value = 0.0)
 nodes(0:nxm-1, 0:nym-1, *)= valr
 nval(0:nxm-1, 0:nym-1, *)= nvalr

 nodes(1:nxm, 0:nym-1, *)= nodes(1:nxm, 0:nym-1, *)+ valr
 nval(1:nxm, 0:nym-1, *) = nval(1:nxm, 0:nym-1, *) + nvalr

 nodes(1:nxm, 1:nym, *)= nodes(1:nxm, 1:nym, *)+ valr
 nval(1:nxm, 1:nym, *) = nval(1:nxm, 1:nym, *) + nvalr

 nodes(0:nxm-1, 1:nym, *)= nodes(0:nxm-1, 1:nym, *)+ valr
 nval(0:nxm-1, 1:nym, *) = nval(0:nxm-1, 1:nym, *) + nvalr

 nodes = nodes/(nval > 1)
 arr2str, 70, values
 arr2str, 71, imat
 arr2str, 72, nodes
 end
