; ------------------------------------------------------------------------ 
; $Id: con2tri.pro,v 1.3 2007/06/06 19:45:14 lpmix Exp $
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro con2tri, locx, connect, tri
; make triangles from connection data.
;
nloc = n_elements(locx)
nreg = nloc -1
regsiz = locx[1:nreg]-locx[0: nreg-1]
if max(regsiz) gt 5 then begin
  tri =0
  print, '% CON2TRI: Maximum region size is 5 nodes.
  return
endif

ok5 = where(regsiz eq 5, nok5)
ok4 = where(regsiz eq 4, nok4)
ok3 = where(regsiz eq 3, nok3)

ntri = 3*nok5+2*nok4+ nok3
tri = make_array(3, ntri, /long)
j = 0L
if nok3 gt 0 then begin
  for i = 0L, nok3-1 do $
    tri (*, j+i) = connect[locx[ok3[i]]:locx[ok3[i]+1]-1]
  j = j+nok3
endif
if nok4 gt 0 then begin
  val = [0L, 1L, 2L, 0, 2, 3]
  for i = 0L, nok4-1 do begin
    nodes = connect[locx[ok4[i]]:locx[ok4[i]+1]-1]
    tri [*, j+i+i:j+i+i+1]= nodes[val]
  endfor
  j = j+nok4+nok4
endif
if nok5 gt 0 then begin
  val = [0L, 1L, 2, 0, 2, 3, 0, 3, 4]
  for i = 0L, nok5-1 do begin
    nodes = connect[locx[ok5[i]]:locx[ok5[i]+1]-1]
    tri [*, j+3*i:j+3*i+2]= nodes[val] 
  endfor
  j = j+nok5+nok5+nok5
endif
end
 
