; ------------------------------------------------------------------------ 
; $Id: make_pact_triangles.pro,v 1.3 2007/06/06 19:45:14 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro make_pact_triangles, imat, tri, bad = bad
; Upper right hand corner material matrix has the material number 
; for a cell.  Eliminate cells without material.
; Bad are cells without material

on_error, 1
 ss = size(imat)
 nx = ss(1)
 ny = ss(2)
 tri = 0
 tri = make_triangles (imat, nx, ny)
 if (n_elements(tri) lt 2) then begin
   print, '% MAKE_PACT_TRIANGLES: Error in Make_triangles'
   return
 endif
 bad = where (imat(1:*,1:*) eq 0, nok) 
 if nok eq 0 then return
 ind = lindgen(2L*(nx-1)*(ny-1))
 ok = bad+bad
 ind[ok] =-1
 ind[ok+1] = -1
 ok = where (ind ge 0)
 tri = tri[*, ind[ok]]
 end

