; ------------------------------------------------------------------------ 
; $Id: wdf2str.pro,v 1.3 2007/06/06 19:44:56 lpmix Exp $
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
pro wdf2str, wdstart, nwdf, str
;+
; Name: wdf2str, wdstart, nwdf, str
;
; combine wdfarrays into a structure.
; This is a temporary procedure.
; wdstart  - first wdf array
; nwdf     - number of wdf arrays
; str      - structure to receive the data.
; 
; example:
;  combine the first 21 wdfarrays into structure #3
;
;    wdf2str, 1, 21, 3
;
;  Writen by: L. P. Mix, 1/29/04
;-
on_error, 1

if n_params() ne 3 then begin
  print, '% WDF2STR:  Must have 3 parameters.
  return
endif

if ((n_elements(wdstart) eq 0) or $
  (n_elements(wdstart) eq 0)  or $
  (n_elements(str) eq 0)) then begin
  print, '% WDF2STR:  All 3 parameters must be defined.
  return
endif
x = 1 
z = getxf(wdstart)
y = 1+indgen(nwdf)
arr = make_array(1, nwdf, n_elements(z))
for i =0, nwdf-1 do arr[0, i, *] = getyf(i+wdstart)
arr2str, str, arr, x, y, z, clabel = wdcomment(wdstart), $
  zlabel = 'Time', ylabel = 'Groups', $
  xlab = 'Flux surface'
arr=0
end
