; ------------------------------------------------------------------------ 
; $Id: openpds.pro,v 1.3 2007/06/06 19:50:17 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro openpds, file, full = full
;
;     this routine opens the pds procedures
;
@pds_datacom.dat
      on_error, 1

      if n_elements(initpds) eq 0 then initpds = 0
      if initpds eq 0 then init_pds
      if initpds lt 0 then begin
        print, '% PDS_OPEN: This installation does not support PDS'
        return
      endif
      if n_elements(file) eq 0 then file = dialog_pickfile(/read)
      file = strtrim(file, 2)
      strl = strlen(file)
      if strl eq 0 then begin
        print, '% PDS_OPEN: File name must be specified'
        return
      endif
      if n_elements (full) eq 0 then full = 1

      ier = 1L
      file = file + ' ' 
      bfile = byte(file)
      bfile(strl)=0
;     strl = strl+1
;     help, file, strl, pds_id
      junk = call_external(PDS_EXE, 'pdsp_open_', bfile, strl, pds_id, ier)
      if ier ne 0 then print, $
        '% PDS_OPEN: Unable to open file: ', file else begin
        print, '% PDS_OPEN: File opened with file handle = ', strtrim(pds_id,2)
        print, '  File: ', file
        if n_elements(file_handle) eq 0 then begin
          file_handle = make_array(20, value = -1L, /long)
          file_name = make_array(20, value = '', /string)
        endif
        i = 0
        while(file_handle(i) ge 0) do i = i+1
        if i lt n_elements(file_name) then begin
          file_handle(i) = pds_id 
          file_name(i) = file
        endif
        var_name = get_pds_names(/variables) 
        num_var = n_elements(var_name)
        seg_ids = get_pds_ids(/segment)
        num_seg = n_elements(seg_ids)
        if not keyword_set(full) then return

print, ' Number of variables: ', strtrim (num_var, 2)
for i = 0, num_var-1 do print, i, '  ', var_name(i)
print, ' Number of segments: ', strtrim (num_seg, 2)
for i = 0, num_seg-1 do print, i, '  ', seg_ids(i)
      endelse
      end
