; ------------------------------------------------------------------------ 
; $Id: set_pds_debug.pro,v 1.3 2007/06/06 19:50:17 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro SET_PDS_DEBUG, LEVEL, show_level = show_level
;+
; This routine sets the PDS Debug Level for PDS messages.
; 
; A level of -10 eliminates all error and warning messages.
; A level of  0 is the default.
; A level of  10 increases output to almost all PDS function calls.
; 
; Format:
;  PDS_Debug, level [, SHOW = show]
; 
;    where:
;        Level The debug level (DEFAULT = 0)
;              If level is not set, then nothing will be changed.
;        SHOW  If set, Show current level
;        
;-

@pds_datacom.dat

      on_error, 1

      if n_elements(initpds) eq 0 then pds_init
      if initpds eq 0 then pds_init    
      ier = 0L

      if initpds lt 0 then begin
        print, '% PDS_INIT: This installation does not support PDS'
        IER = 1
        return
      endif
      
      if n_elements(level) ne 0 then begin
        level = long(level)
        ier = 0L
        junk = call_external(PDS_EXE, 'pdsp_debug_', level, ier)
        if ier eq 0 then pds_debug_level = level else $
          print, '% PDS_DEBUG: Error setting PDS debug level' , level
      endif
      if keyword_set (show_level) then print, $
        '% PDS_DEBUG: Current PDS DEBUG level is ', strtrim(pds_debug_level,2)
        
      end
