; ------------------------------------------------------------------------ 
; $Id: init_pff.pro,v 1.18 2009/06/08 16:17:56 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
  pro init_pff, pffexe = a
;
;     this routine initializes the pff procedures
;
      common pffcom, initpff, pff_exe
;     we will initialize the qs structures and the wdf arrays here.
@qsstrcom.dat
@com.dat
;
;     start the process
;
common copyright_common, copyright_init
;
      on_error, 1
      common getdircom, junkfilename

      if n_elements(initpff) eq 0 then initpff =0
      if initpff gt 0 then return
;
      if n_elements (copyright_init) eq 0 then copyright_notice
      p1 = 0L
      if n_elements(a) eq 0 then a = getenv('PFF_EXE') 
      b = get_pfidl_directory()
      if strlen(b) eq 0 then b = path_sep()
      name = strupcase(strmid(!version.os, 0, 3))
      list= tag_names(!version)
      if (name  eq 'HP-') then begin
        if strlen(a) lt 1 then begin
            pff_exe = b+'lib/hp/hp_pfidl.sl'
        endif else begin
          pff_exe = a
          print, ' PFF_EXE=',pff_exe
        endelse
        junk = call_external(PFF_EXE,'pff_init', p1)
        initpff = 1
;        spawn,  'echo ',ans, pid =  pid
        pid = long(64*systime(1) mod 1048576)
        junkfilename=  '/tmp/IDLdir'+strtrim (pid(0), 2)+'.tmp'
      endif else if (name eq 'SUN') then begin
; use this for sun
        i = get_match('MEMORY_BITS', list, nel= nel)
        name = (((nel gt 0) && (!version.memory_bits eq 64))) ? $
          'solaris8/sun8_pfidl' : 'solaris/sun_pfidl'
        if strlen(a) lt 1 then begin
            spawn,  'uname -r', ans
            name = (ans[0] eq '5.9') ? name+'9.so' : name + '.so'
            pff_exe = b+'lib/'+name 
        endif else begin
          pff_exe = a
          print, ' PFF_EXE=',pff_exe
        endelse
        junk = call_external(PFF_EXE,'pff_init_', p1)
        initpff = 2
;        spawn,  'echo ',ans, pid=pid
        pid = long(64*systime(1) mod 1048576)
        junkfilename=  '/tmp/IDLdir'+strtrim (pid(0), 2)+'.tmp'

      endif else if (name eq 'IRI') then begin
; use this for sgi
        i = get_match('MEMORY_BITS', list, nel= nel) 
        name = 'sgi_pfidl.so'
        if strlen(a) lt 1 then begin
          pff_exe = b+'lib/'+name
        endif else begin
          pff_exe = a
          print, ' PFF_EXE=',pff_exe
        endelse 
        junk = call_external(PFF_EXE,'pff_init_', p1)
        initpff = 2
;        spawn,  'echo ',ans, pid=pid
        pid = long(64*systime(1) mod 1048576)
        junkfilename=  '/tmp/IDLdir'+strtrim (pid(0), 2)+'.tmp'
      endif else if (name eq 'LIN') then begin
; use this for linux
        i = get_match('MEMORY_BITS', list, nel= nel)
        fname = (((nel gt 0) && (!version.memory_bits eq 64))) ? $
          'lib/lin64/lin64_pfidl.so' : 'lib/linux/lin_pfidl.so'
        pff_exe = (strlen(a) lt 1) ? b+fname : a
        if strlen(a) gt 1 then  print, ' PFF_EXE=',pff_exe
        junk = call_external(PFF_EXE,'pff_init_', p1)
        initpff = 2
;        spawn,  'echo ',ans, pid=pid
        pid = long(64*systime(1) mod 1048576)
        junkfilename=  '/tmp/IDLdir'+strtrim (pid(0), 2)+'.tmp'
      endif else if name eq 'WIN' then begin
; use this for Windows
;       Version 6.3 went to idl from idl32 for the program name
        vr = (float(!version.release) lt 6.29) ? '62' : ''
        if strlen(a) lt 1 then  pff_exe = b+'lib\windows\win_pfidl'+vr $
           else  pff_exe = a
;       Change from the DEC/Compaq Visual Fortran calling 
;       to standard calling convention.
;       Intel Fortran w/ ifac:iref
;       Only a version for IDL 6.3 and later
        if strlen(vr) gt 0 then begin
          junk = call_external(PFF_EXE,'_PFF_INIT@8' , p1)
          initpff = 4
        endif else begin
;         New calling convention  is the same as HP.
          junk = call_external(PFF_EXE,'pff_init' , p1)
          initpff = 1
        endelse
        junkfilename= 'c:\temp\IDLdir'+ $
           strtrim(string(long(randomu(iseed)*1e7)),2)+'.tmp'
      endif else if (name eq 'DAR') then begin
; use this for Mac OS X
        if  (!version.arch ne 'i386') && (!version.arch ne 'x86_64') then begin
          Print, '% INIT_PFF:  This architecture of IDL not supported in PFIDL'   
          print, '             Only X86 versions are supported.'
          print, '             (!version.arch = i386 or x86_64)'
        endif else begin
          i = get_match('MEMORY_BITS', list, nel= nel)
          fname = (((nel gt 0) && (!version.memory_bits eq 64))) ? $
            ;'lib/darwin64/mac64_pfidl.dylib' : 'lib/darwin/mac_pfidl.dylib'
            ;'/Network/Servers/copland.as.utexas.edu/Volumes/HD2/UGrads/nam263/pfidl/lib/darwin64/mac64_pfidl.dylib' : 'lib/darwin/mac_pfidl.dylib'
            '/Users/mikemon/idl_sandia/Z_Project/lib/darwin64/mac64_pfidl.dylib' : '/Users/mikemon/idl_sandia/Z_Project/lib/darwin/mac_pfidl.dylib'
          pff_exe = (strlen(a) lt 1) ? b+fname : a
          ;pff_exe = fname
 
          if strlen(a) gt 1 then  print, ' PFF_EXE=',pff_exe
          junk = call_external(PFF_EXE,'pff_init_', p1)
          initpff = 2
          pid = long(64*systime(1) mod 1048576)
          junkfilename=  '/tmp/IDLdir'+strtrim (pid(0), 2)+'.tmp'
        endelse
      endif else begin
        print, 'This operating system is not supported by PFIDL'
      endelse
      if n_elements (structinit) eq 0 then qsstruct_init
      if n_elements(initwdf) eq 0 then wdfinit
   end

