; ------------------------------------------------------------------------ 
; $Id: add_tools.pro,v 1.4 2008/04/09 14:23:51 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro add_tools
;
;+
; Name: ADD_TOOLS
; 
; Description:
;       Add the tools directory, written by Greg Dunham, to a IDL session path.
;       and 
;       Add the help files for these directories to the !help_path
;
; Format: add_tools
;
;-
 common tools_directory_common, tools_dir

 on_error, 1
 
 if n_elements(tools_dir) eq 0 then begin
;  only add if not added before
   if (!version.os_family eq 'unix') then $
     tools_dir = '/usr/local/apps/Tools/gsdunha' else begin
     print, '% ADD_TOOLS: This is only supported on Unix'
     print, '  Contact Paul Mix, (505) 845-7493, lpmix@sandia.gov'
     return
   endelse
   sep = path_sep(/search_path)
   !path = expand_path('+'+tools_dir)+sep+!path 
; !help_path = tools_dir+'/tools_help'+sep+!help_path
   tools_dir = tools_dir+path_sep()
 endif else print, '% ADD_TOOLS: Tools have already been added'
end
