; ------------------------------------------------------------------------ 
; $Id: endjpeg.pro,v 1.3 2007/06/06 20:03:46 lpmix Exp $
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro endjpeg
;+
;  Close the MJPEG2000 file and destroy the object.
;  Format: EndJPEG
;
;  Examples:
;  Send the nframe images to a motion JPEG2000 file called: target.mj2
;; Initialize JPEG2000
;    startJPEG, 'target.mj2'
;; Generate frames
;    for i = 1L, nframe do begin
;      <Make a plot>
;      sjpeg
;    endfor
;; Close the file
;    endjpeg
;; View the Movie
;    MJ2_Player
;
;  MODIFICATION HISTORY:
;      Original version, L. P. Mix, April 14, 2006
;-
 
;-
on_error,1 
   common switchjpeg, omj2_write, file_name, current_file, initial

   if obj_valid(omj2_write) then begin
     result = omj2_write -> commit(10000)
     if result ne 1 $
       then print, '% EndJPEG: Commit returned a value of ', strtrim (result, 2)
     obj_destroy, omj2_write 
   endif else print, '% EndJPEG: No valid JPEG object'
     
   end
