; ------------------------------------------------------------------------ 
; $Id: getx.pro,v 1.3 2007/06/06 20:03:48 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro  Getx, x, wdf, maximum = maximum, minimum = minimum
;+
;     this procedure returns the abscissa values of an wdf array
;       format: getx, xarray, wdf, maximum = maximum, minimum = minimum
;       where xarray is an IDL array of the x values 
;             wdf is the wdf array number
;           minimum - minimum X value
;           maximum - maximum X value
;-
@com.dat
;
      if n_elements(initwdf) eq 0 then wdfinit
      nparams = n_params()
      if nparams lt 2 then begin
        print,' GETX must have at least 2 parameters'
        return
      endif
;
      if n_elements(wdf) eq 0 then begin
        print, 'Parameters to GETX must be defined'
        return
      endif
      if wdf lt 1 or wdf gt maxwdfarray then begin
        print, 'wdf array must be greater than 0 and </=', maxwdfarray
        return
      endif
;
      nel = wdfnp(wdf-1)
      if nel eq 0 then begin
        print, 'No valid data in the wdf array'
        return
      endif
      get_wdfarray, array, wdf, /xy
      if n_elements(array) eq nel+nel then begin
        x = array(0:nel-1)
      endif else begin
        x = findgen(nel)*array(1)+array(0)
      endelse
      maximum = wdfmaxx(wdf-1)
      minimum = wdfminx(wdf-1)
      array=0
      return
      end
