; ------------------------------------------------------------------------ 
; $Id: getxf.pro,v 1.3 2007/06/06 20:03:48 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Function  Getxf, wdf, maximum = maximum, minimum = minimum
;+
;     this function returns the abscissa values of an wdf array
;       format: x = getxf( wdf, maximum = maximum, minimum = minimum)
;       where xarray is an IDL array of the x values 
;             wdf is the wdf array number
;           minimum - minimum X value
;           maximum - maximum X value
;-
@com.dat
;
      if n_elements(initwdf) eq 0 then wdfinit
      nparams = n_params()
      if nparams lt 1 then begin
        message, /info,' WDF array number must be provided'
        return, 0
      endif
;
      if n_elements(wdf) eq 0 then begin
        message, /info, 'WDF array number must be defined'
        return, 0
      endif
      if wdf lt 1 or wdf gt maxwdfarray then begin
        print, 'wdf array must be greater than 0 and </=', maxwdfarray
        return, 0
      endif
;
      nel = wdfnp(wdf-1)
      if nel eq 0 then begin
        print, '% GETXF: No valid data in the wdf array'
        return, 0
      endif
      get_wdfarray, array, wdf, /xy
      if n_elements(array) eq nel+nel then begin
        x = array(0:nel-1)
      endif else begin
        x = findgen(nel)*array(1)+array(0)
      endelse
      maximum = wdfmaxx(wdf-1)
      minimum = wdfminx(wdf-1)
      array=0
      return, x
      end
