; ------------------------------------------------------------------------ 
; $Id: gety.pro,v 1.3 2007/06/06 20:03:48 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro  Gety, y, wdf, maximum = maximum, minimum = minimum
;+
;     this procedure returns the ordinate values of an wdf array
;     format: gety, yarray, wdf, maximum = maximum, minimum = minimum
;     where yarray is the array of ordinate values
;           wdf is the WDF array number
;           minimum - minimum Y value
;           maximum - maximum Y value
;-
;
@com.dat
;
      if n_elements(initwdf) eq 0 then wdfinit
      nparams = n_params()
      if nparams eq 0 then begin
print, '% Format: GETY, y, WDF [, Maximum = maxi] [, Minimum = mini]'
        return
      endif
      if nparams lt 2 then begin
        print,'% GETY: 2 parameters are required'
        return
      endif
;
      if n_elements(wdf) eq 0 then begin
        print, '% GETY: WDF must be defined'
        return
      endif
      if wdf lt 1 or wdf gt maxwdfarray then begin
        print, '% GETY: WDF must be greater than 0 and </=', maxwdfarray
        return
      endif
;
      nel = wdfnp(wdf-1)
      if nel lt 2 then begin
        print, 'No valid data in the wdf array'
        return
      endif
      get_wdfarray, y, wdf, /xy
      if n_elements(y) eq nel+nel then begin
        y = y(nel:*)
      endif else begin
        y = y(2:*)
      endelse
      maximum = wdfmax(wdf-1)
      minimum = wdfmin(wdf-1)
      return
      end
