; ------------------------------------------------------------------------ 
; $Id: idl_functions.pro,v 1.3 2007/06/06 20:03:48 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
;+
; Perform standard IDL functions on an array; these functions include
;   absolute value, arc-cosine, natural and base 10 logarithm, arc-sine,
;   arc-tangent with 1 or 2 arguments, hyperbolic sine, cosine and tangent,
;   exponential function, square root, tangent, real and imaginary parts
;   of a complex array, forward and inverse Fourier transform, maximum,
;   minimum, total, complex conjugate, statistical functions --
;  (linear regression, analysis of variance, cluster analysis,...), and others.
;  Example:
;    Calculate an array of areas from an array of radii in WDF array 5
;    and store in array 6.
;      xfr, 5, 6  & cha, 6, scale = '!pi*y*y)'
;
;    Calculate an the sine of WDF array 5 times pi/2 
;      cha, 5, scale ='!pi*0.5*sin(y)'
;
;    Calculate and print the average of WDF array 6.
;      gety, array, 6
;      average = total(array)/n_elements(array)
;      print, `Average of array 6 is `, average
;    or 
;      print, `Average of array 6 is `, ave(6)
;
;    Calculate the log of array 7 divided by x with a cutoff of 1e-3
;      cha, 7, 'alog(y > 1e-3)/x'
;
;-
