; ------------------------------------------------------------------------ 
; $Id: med.pro,v 1.3 2007/06/06 20:03:49 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro  MED, wdf1, wdf2, width = width
;
;+
;     this procedure smooths an array using a median type filter
;     width is the width of the median
;           Default value = 5 
;     if wdf2 is a valid wdf array, the result is stored there.
;        if WDF2 is not valid or undefined, then result is stored in  WDF1
;-
;
@com.dat
;
      if n_elements(initwdf) eq 0 then wdfinit
      nparams = n_params()
      if nparams lt 1 then begin
        print,' MED must have at least 1 parameter'
        return
      endif
;
      if n_elements(wdf1) eq 0 then begin
        print, 'Parameters to MED must be defined'
        return
      endif
      if wdf1 lt 1 or wdf1 gt maxwdfarray then begin
        print, 'wdf array must be greater than 0 and </=', maxwdfarray
        return
      endif
;
      if nparams gt 1 then save = get_save_array(wdf2, wdf1) else save = wdf1
      if save lt 1 or save gt maxwdfarray then save = wdf1
      np = wdfnp(wdf1-1)
      if np eq 0 then begin
        print, 'No valid data in the first array'
        return
      endif
      if n_elements(width) gt 0 then boxwidth = width else boxwidth = 5
      if boxwidth lt 1 then begin
        boxwidth = 5
        print,'Width must be greater than 1; set to 5'
      endif
      xy = 1
      get_wdfarray, array1, wdf1, xydata = xy
      if n_elements(array1) eq (np+2) then begin
        array1(2:*) = median(array1(2:*), boxwidth)
        xy = 0
      endif else array1(np:*) = median(array1(np:*), boxwidth)
      put_wdfarray, array1, save, /no_copy, xydata = xy
      wdf2 = save
      wdfcomment(save-1)= wdfcomment(wdf1-1)
      wdffile(save-1)= wdffile(wdf1-1)
      wdfxlabel(save-1)= wdfxlabel(wdf1-1)
      wdfylabel(save-1)= wdfylabel(wdf1-1)
      return
      end
