; ------------------------------------------------------------------------ 
; $Id: pe_ave.pro,v 1.3 2007/06/06 20:03:50 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro pe_ave
;+
; Name: PE_AVE
;  Average Perkin-Elmer calibration data from a pff file. 
;  should have cal_top.pff and cal_bot.pff in the same directory.
; 
; Example:
;   pe_ave
;-

   window, 0
   openpff, 'cal_top.pff', ndset = nd
   mmax = nd+nd+50
   if (get_maxwdf() lt mmax) then set_maxwdfarray, mmax
   re, 21, '', nar = nar
   closepff
   plo, 21, nar, /over, /nl, /color 
   sum, 21, nar, 17, stand = -19, /aver
   lab, 17, 'Average Top'
   lab, 19, 'Std Dev Top'
   plo, 17, /over, /no, color = 0
hak, /mess
   wdst = (nar/10)*10 +10+21
   window, 1
   openpff, 'cal_bot.pff', ndset = nd
   if (get_maxwdf() lt wdst+nd) then set_maxwdfarray, wdst +nd +10
   re, wdst, '', nar = nar
   closepff
   plo, wdst, nar, /over, /nl, /color  
   sum, wdst, nar, 18, stand = -20, /aver
   lab, 18, 'Average Bot'
   lab, 20, 'Std Dev Bot'
   plo, 18, /over, /no, color = 0

end
