; ------------------------------------------------------------------------ 
; $Id: pe_wri.pro,v 1.3 2007/06/06 20:03:50 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro pe_wri
 
;+
; Name: PE_WRI
;  Write Perkin-Elmer calibration data to a pff file.
;  should have cal_top.pff and cal_bot.pff in the same directory.
; 
; Example:
;   pe_wri 
;-
 wdf = get_match('Top Calibration Data', /wdf, nelement = nwdf)
 if nwdf gt 0 then begin
   openpff, 'cal_top.pff', ndset = nar
   plo, wdf, /over, /noer, /nl, /ns, /color
   ans = ''
   read, ans,prompt= $
    'Do you wish to write the dataset(s) to the pff file? (y or n): '  
   if strlowcase(strtrim(ans, 2)) eq 'y' then $
     for i = 0, nwdf-1 do wri, wdf[i] 
   closepff
 endif else $
   Print, '% WRI_PE: No top calibration data'

 wdf = get_match('Bottom Calibration Data', /wdf, nelement = nwdf)
 if nwdf gt 0 then begin
   openpff, 'cal_bot.pff', ndset = nar
   plo, wdf, /over, /noer, /nl, /ns, /color
   ans = ''
   read, ans,prompt= $
    'Do you wish to write the dataset(s) to the pff file? (y or n): '
   if strlowcase(strtrim(ans, 2)) eq 'y' then $
     for i = 0, nwdf-1 do wri, wdf[i] 
   closepff
 endif else $
   Print, '% WRI_PE: No bottom calibration data'

end
