; ------------------------------------------------------------------------
; $Id: plot_spec.pro,v 1.2 2011/06/10 17:28:24 lpmix Exp $
; ------------------------------------------------------------------------
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
;+
; NAME:
;       PLOT_SPEC
;
; PURPOSE:
;       Plot the geometry for a spherical spectrometer
;       NOTE:  SPH_SPEC must be run first to solve the geometry.
;              The source code is in SPH_SPEC!
;
; CATEGORY:
;       Visualization
;
; CALLING SEQUENCE:
;
;       PLOT_SPEC
;       
; KEYWORD PARAMETERS:
;       XRANGE:  If present, the extent of the XRange for the plot
;       YRANGE:  If present, the extent of the YRange for the plot
;       TITLE:   Title for the plot, Default are the parameters for the calculation.
;       SKIP:    If present, the skip factor used when drawing the various
;                energies from the source to the film.
;
; EXAMPLE:
;       Plot the geometry for the current spherical spectrometer.
;         PLOT_SPEC
;
;       Plot the geometry for the current spherical spectrometer but use only 10% of 
;         energy values
;         PLOT_SPEC, SKIP = 10
;
; MODIFICATION HISTORY:
;       Written by:     L. P. Mix, Jr., December 3, 2010
;       February 16, 2011   Separated the plot routine as a separate procedure.
;-

