; ------------------------------------------------------------------------ 
; $Id: relnotes.pro,v 1.4 2010/09/17 21:20:35 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
;+NODOCUMENT
; NAME:
;       RELNOTES
;
; PURPOSE:
;	Print current IDL version release notes.
;       Accepts Q to quit
;
; CALLING SEQUENCE:
;
;	RELNOTES
;
; INPUTS:
;	None.
;
; KEYWORDS:
;	PAGE - Set to the page size for the printout.
;              Default = 40
;
; OUTPUT:
;	Basic information is printed.
;
; COMMON BLOCKS:
;       NONE.
;
; SIDE EFFECTS:
;       None.
;
; RESTRICTIONS:
;	None.
;
; MODIFICATION HISTORY:
;       Written, LPM, Sandia National Labs, 21 July 1999
;       Adapted from IDLinfo by DMS, RSI, 17 April 1997
;           
;-

pro relnotes, page = page
 on_error, 1
  FileName = filepath('relnotes.txt')
  openr, Lun, Filename, Error=err, /GET_LUN
  if err lt 0 then return
  if not keyword_set (page) then page = 40
  line = ''
  while not eof(Lun) do begin
  i = 0
  while not eof(Lun)  and i lt page do begin
    readf, lun, line
    print, line
    i = i+1
  endwhile
  if not eof(Lun) then hak,dummy, $
     message=' Hit any key to continue... (Q to quit)'
  if n_elements (dummy) gt 0 then if strlowcase(dummy) eq 'q' then begin
    free_lun, lun
    return
  endif
  endwhile
  free_lun, lun
end
