; ------------------------------------------------------------------------ 
; $Id: spict.pro,v 1.3 2007/06/06 20:03:54 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro spict, filename 
;+
;  Save the current screen information to a file.
;
;  Format: SPICT [, FILENAME]
;
;  where:
;    filename - optional filename.
;               Default is set by startgif
;               ('idl' is the default value if none is specified
;                 ie.  idl0001.pict, idl0002.pict  ....etc.)
;
;  Examples:
;  Send the plots to gif files of the form: movie0001.pict, movie0002.pict, ...
;    startgif, file =  'movie'
;    < do a plot >
;    spict
;    < do a plot >
;    spict
;    < do a plot >
;    spict    ; etc
;    endgif
;-
   common switchgif,xythicksave,thicksave,oldthick,oldxythick,oldfont, $
      gif_file, font_default, no_swap, character_size, file_number, $
      lc_gif_output, old_character_size

   if n_elements(filename) gt 0 then filename=strtrim(filename(0),2) else begin
     if n_elements (gif_file) eq 0 then begin
       print,' %SPICT: PICT file must be defined (Use STARTGIF).
       return
     endif

     filename = gif_file+string(file_number, format='(i4.4)')+'.pict'
     file_number = file_number +1
   endelse
   tvlct, /get, r, g, b
device, get_visual_depth = depth
tvlct, r, g, b, /get
if depth le 8 then write_pict, filename, tvrd() , r, g, b  $
else write_pict, filename, color_quan(tvrd(/true), 1, r, g,b, col=256), r, g, b
;
; note for true color displays:
; can also try , cube = 6
;

;   write_pict, filename, tvrd() , r, g, b  
   return
   end
