; ------------------------------------------------------------------------ 
; $Id: spng.pro,v 1.6 2008/10/06 15:07:01 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro spng, filename
;+
;  Save the current screen information to a file.
;
;  Format: SPNG [, FILENAME]
;
;  where:
;    filename - optional filename.
;               Default is set by startgif
;               ('idl' is the default value if none is specified
;                 ie.  idl0001.png, idl0002.png  ....etc.)
;
;  Examples:
;  Send the plots to gif files of the form: movie0001.png, movie0002.png, ...
;    startgif, file =  'movie'
;    < do a plot >
;    spng
;    < do a plot >
;    spng
;    < do a plot >
;    spng    ; etc
;    endgif
;-
on_error, 1
   common switchgif,xythicksave,thicksave,oldthick,oldxythick,oldfont, $
      gif_file, font_default, no_swap, character_size, file_number, $
      lc_gif_output, old_character_size


   if n_elements(filename) gt 0 then filename=strtrim(filename(0),2) else begin
     if n_elements (gif_file) eq 0 then begin
       print,' %SPNG: PNG file must be defined.'
       return
     endif

     filename = gif_file+string(file_number, format='(i4.4)')+'.png'
     file_number = file_number +1
   endelse
 
   device, get_visual_depth = depth
   if depth le 8 then begin
     tvlct, r, g, b, /get
     write_png, filename, tvrd() , r, g, b
   endif else begin
;    idl 5.5
     if  strmatch(!version.release, '5.5*') then device, /bypass_translation
     write_png, filename, tvrd(/true)
   endelse
   end
