; ------------------------------------------------------------------------ 
; $Id: stiff.pro,v 1.5 2007/06/06 20:03:54 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro stiff, filename , compress = compress
;+
;  Save the current screen information to a file.
;
;  Format: STIFF [, FILENAME] [, COMPRESSION = compression]
;
;  where:
;    filename - optional filename.
;               Default is set by startgif
;               ('idl' is the default value if none is specified
;                 ie.  idl0001.gif, idl0002.gif  ....etc.)
;    compression - Compression type (see Write_Tiff)
;                  Default = 1
;                  If set, all future calls will default to the value set.
;
;  Examples:
;  Send the plots to gif files of the form: movie0001.gif, movie0002.gif, ...
;    startgif, file =  'movie'
;    < do a plot >
;    sgif
;    < do a plot >
;    sgif
;    < do a plot >
;    sgif    ; etc
;    endgif
;-
   common switchgif,xythicksave,thicksave,oldthick,oldxythick,oldfont, $
      gif_file, font_default, no_swap, character_size, file_number, $
      lc_gif_output, old_character_size
   common switchtiff, compression_type

   if n_elements(filename) gt 0 then filename=strtrim(filename(0),2) else begin
     if n_elements (gif_file) eq 0 then begin
       print,' %STIFF: TIFF file must be defined.'
       return
     endif

     filename = gif_file+string(file_number, format='(i4.4)')+'.tiff'
     file_number = file_number +1
   endelse
   if n_elements( compression_type) eq 0 then  compression_type=1
   if n_elements(compress) eq 0 then compress =  compression_type else begin
     if compress lt 0 or compress gt 2 then compress =  compression_type 
     compression_type = compress
   endelse

 device, get_visual_depth = depth
 tvlct, r, g, b, /get
 if depth le 8 then begin
   image = reverse(tvrd(), 2)
   dims = size(image, /dimensions)
   true = bytarr(3, dims[0], dims[1])
   true [0, *, *] =r[image]
   true [1, *, *] =g[image]
   true [2, *, *] =b[image]
   write_tiff, filename, true, 1, compression= compress   
 endif else begin
;  idl 5.5
   if  strmatch(!version.release, '5.5*') then device, /bypass_translation
   image = reverse(tvrd(/true), 3)
   write_tiff, filename, image, 1, compression = compress
 endelse

;   write_tiff, filename, reverse(tvrd(),2), compress = compress, $
;     red =r, green= g, blue= b  
   return
   end
