; ------------------------------------------------------------------------ 
; $Id: today.pro,v 1.3 2007/06/06 20:03:55 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
;+
; NAME:
;       TODAY
;
; PURPOSE:
;       Return the Calendar day for the current day.
;
; CALLING SEQUENCE:
;       now = TODAY()
;
;
; OUTPUTS:
;       Return todays date in the form: Month day, year
;
; RESTRICTIONS:
;       No restrictions.
;
;
; EXAMPLE:
;       Label waveform 6 with today's date.
;          lab, today(), 6
;
;
; MODIFICATION HISTORY:
; 	Written by:	Paul Mix 
;-
 function today , par1, option = option
 on_error, 1
 b = systime()
 a = strsplit(b, /extract)
 return ,  a[1]+ ' '+ a[2]+ ', '+ a[4]
 end
