; ------------------------------------------------------------------------ 
; $Id: delstr.pro,v 1.4 2007/06/06 20:09:33 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro  delstr, wdfain
;+
;  format: delstr, STR
;  This routines clears structure arrays
;  If STR is zero or undefined; all arrays are cleared.
;  Otherwise, all valid structure arrays specified by STR are cleared.
;  example:
;  clear all structure arrays
;      delstr
; or   delstr, 0
;
;  clear structure array number 15 and 18
;      delstr, [15, 18]
;
;-
;
@qsstrcom.dat
;
      on_error, 1
;
      if n_elements (structinit) eq 0 then qsstruct_init
; 
     nel = n_elements (wdfain)
     if nel eq 0 then wdfa = 1+indgen(maxstructure) else wdfa = wdfain
     if nel eq 1 and wdfa[0] eq 0 then wdfa = 1+indgen(maxstructure)
     ok = where (wdfa gt 0 and wdfa le maxstructure, nok)
     if nok gt 0 then begin
;      the following is CLEAR_STRUCTURE from the util directory.
       ok = wdfa[ok]-1
       lcvalidstr(ok) = 0
       comment(ok) = ''
       oks = where (strarraycom[ok] gt 0, nok)
       for i = 0, nok-1 do $
         handle_value, strarraycom[ok[oks[i]]], 0.0, /set
     endif
     end
