; ------------------------------------------------------------------------ 
; $Id: i2s.pro,v 1.4 2011/12/01 21:44:14 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro i2s, structure, i , no_copy = no_copy
;+
; This function puts a structure into the qs structure common.
; Formmat:  i2s, structure, i, no_copy = no_copy
;   where:  structure is the structure to be stored in a sturcture array
;           i is the structure array number
;          no_copy is an optional keyword
;                 if set then structrue is undefined after the command
;                 if not set then structure is not affected
;           
; Example:
;    Store structure ff into the qs structure common at location 2
;        i2s, ff, 2
;-
;  Common block
 on_error, 1
@qsstrcom.dat
;
      if n_elements (structinit) eq 0 then qsstruct_init
;
      npar = n_params()
      if npar lt 2 then begin
        print,'% Format: I2S, IDL_Structure, STR_Array_Number'
        return
      endif
      if n_elements (i) eq 0 then begin
        print, '%% ERROR, S2I*Sturcture array number must be defined.'
        return
      endif
      j = fix (i)  
      if j lt 1 or j gt maxstructure then begin
        Print, '%I2S: Structure array value must be greater than zero'
        print, '    and less than', maxstructure
        return
      endif
      if n_elements(structure) eq 0 then begin
        Print, '%% ERROR, S2I*Structure must be defined - no action taken'
        return
      endif
      b = size(structure)
      if  b[b[0]+1] ne 8 then begin
        print, ' First parameter must be a structure'
        return
      endif
     if not keyword_set(no_copy) then no_copy = 0
     ok = where (tag_names(structure) eq 'CLAB', nok) 
     comment[j-1] = (nok eq 0) ? '' : structure.clab
     
     if strarraycom[j-1] eq 0 then strarraycom[j-1]= handle_create()
     handle_value, strarraycom[j-1], structure, /set, no_copy = no_copy
     lcvalidstr[j-1] = 1
     end
