; ------------------------------------------------------------------------ 
; $Id: xfrstr.pro,v 1.3 2007/06/06 20:09:38 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro  xfrstr , wdf1, wdf2
;
;+
;  Generates a duplicate Structure array in a second structure array.
;  WDF array labels, file name, etc. are also copied to the new WDF array.
;  Format:  XFRSTR, STR1, STR2
;  where:
;    STR1, STR2 - Structure array numbers
;  Example:
;  Copy structue array 4 to array 5
;    xfrstr , 4, 5 
;-
;
;
@qscom.dat
;  Common block
@qsstrcom.dat
;
;       return on an error
      on_error, 1
;
      if n_elements (structinit) eq 0 then qsstruct_init
      if n_elements (qsplotinit) eq 0 then qsinit
;
      nparams = n_params()
      if nparams lt 2 then begin
        print,' XFRSTR must have at least 2 parameters'
        return
      endif
;
      if n_elements(wdf1) eq 0 or  n_elements(wdf2) eq 0 then begin
        print, 'Parameters to XFRSTR must be defined'
        return
      endif
      if wdf1 lt 1 or wdf1 gt maxstructure then begin
        print, 'Structure array must be greater than 0 and </=', maxstructure
        return
      endif
;
      if wdf2 lt 1 or wdf2 gt maxstructure then begin
        print, 'Structure array must be greater than 0 and </=', maxstructure
        return
      endif
;
      if lcvalidstr(wdf1-1) eq 0  then begin
        print, 'No data in the first array'
        return
      endif
;
      s2i, st, wdf1
      i2s, st, wdf2, /no_copy
      return
      end
