; ------------------------------------------------------------------------ 
; $Id: closesaf.pro,v 1.3 2007/06/06 20:10:58 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
  pro closesaf, ierror = ier
;
;+
;   Close a saf file. If the current file is closed, the current file pointer
;   will be set to the next file opened or to the previous file if it is the
;   last file.
;   FORMAT:
;      CLOSESAF, IERROR = ierror
;   where:
;      IERROR    - Error flag on close
;
;   Example:
;      Close the current file.
;         closesaf
;
;      Written: October 23, 2002, LPMix
;-
      common safcom, initsaf, saf_exe
;
;     check to see if saf has been initialized
;
      if (n_elements(initsaf) eq 0) then initsaf = 0
      if (initsaf eq 0) then  begin
        print, '% CLOSESAF: No SAF files are open'
        return
      endif

;
;     check on the number of parameters
;
      nparams = long( n_params())
;
;     get integer
;
      ier = 0L
      if initsaf eq 1  then begin
; HP
        junk = call_external(SAF_EXE,'SAF_close',ier)
      endif else if initsaf eq 2 then begin
; Sun
        junk = call_external(SAF_EXE,'SAF_close',ier)
      endif else if initsaf eq 4  then begin
; WIN
        junk = call_external(SAF_EXE,'_SAF_CLOSE@8',ier)
      endif
;
      return
      end
