; ------------------------------------------------------------------------ 
; $Id: readsafhdr.pro,v 1.3 2007/06/06 20:10:58 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro readsafhdr, dataset, nblock = nblock, nxyz = nxyz, nvect = nvect

;
      on_error, 1
      common safcom, initsaf, SAF_EXE
;
@saf_com.dat
;
;     start the process

;
;     check to see if saf has been initialized
;
      if (n_elements(initsaf) eq 0) then init_saf else $
        if (initsaf eq 0) then init_saf
      if initsaf eq 0 then begin
        print, 'SAF libraries are not supported by this Operating System'
        return
      endif

      nblock = 0L
      nxyz = make_array(3, /long, value =0L)
      nvect = 0L
      dataset = long(dataset)
;     Limit to the number of characters is set by work arrays in pff_slgethdr.f
      if initsaf lt 3  then begin
; UNIX
        junk = call_external(saf_EXE,'saf_head', dataset, nblock, nxyz, nvect)

      endif else if initsaf eq 4 then begin
; WIN
       junk = call_external(PFF_EXE,'saf_head@8', dataset, nblock, nxyz, nvect)
      endif
      if nblock eq 0 then begin
        print, '% readsafhdr: Error reading header', nblock, nxyz, nvect
        return
      endif
      end
