; ------------------------------------------------------------------------ 
; $Id: make_grid.pro,v 1.3 2007/06/06 20:11:32 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro make_grid, strin, strout

on_error, 1


if n_elements(strin) eq 0 then begin
  print, '% MAKE_ONE: Input structure not defined.
  return
endif
str   = get_valid_structure(strin,'MAKE_GRID', lcstr=lcstr, ierror = ier)
if ier ne 0 then return

if str.type ne 1 then begin
  print, '% MAKE_ONE: Input structure must be a type 1 structure.
  return
endif

xx = str.x1
yy = str.x2
zz = str.x3

xx = xx(uniq(xx, sort(xx)))
yy = yy(uniq(yy, sort(yy)))
zz = zz(uniq(zz, sort(zz)))

if lcstr eq 1 then strout = get_save_str(strout, get_maxstr()) else $
  strout = get_save_str(strout, strin)

arr2str, strout, xx, yy, zz, /grid, file = str.file, clab = str.clab, $
  xlab = str.x1lab, ylab = str.x2lab, zlab = str.x3lab
end
