; ------------------------------------------------------------------------ 
; $Id: tqrestore.pro,v 1.3 2007/06/06 20:12:27 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 PRO tqrestore, file, filename = filenam, _extra= extrastuff
;+
;
;  Save the data stored in WDF arrays and in structure arrays
;
;  Format:  TQRESTORE, file [, filename = filename] [, _EXTRA = extrastuff]
;
;  where:
;      file    -  File in which the data is stored
;                 Default is 'tqsaveit.sav'
;      filename-  Optional way of specifying the file name.
;      _EXTRA  -  Any additional keywords recognized by RESTORE
;  Example:
;    Restore  the data from a previous session
;      tqrestore
;
;    Restore the data from the session in file 'qs5581.sav'
;      tqrestore,  'qs5581.sav'
;-
      on_error, 1
;  Common block
;
@pfidltq.com
;
@tq_qs_gridparam.com
;
      if n_elements (file) eq 0 then if n_elements(filenam) gt 0 then $
        file = filenam
;
      if n_elements (file) eq 0 then file = 'tqsaveit.sav' else $
          file = strtrim(file, 2)
      a = findfile (file, count= count)
      if count eq 0 then begin
         print, ' No file could be found with the specification: ', file
      endif else if count eq 1 then begin
        restore, file, _extra= extrastuff
      endif else begin
        print, ' Multiple files found'
        for i = 1, count do print , a(i-1)
        print, 'Please pick the correct file'
      endelse
      return
      end
