; ------------------------------------------------------------------------ 
; $Id: tqsave.pro,v 1.3 2007/06/06 20:12:27 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 PRO tqsave, file = file , _EXTRA = extrastuff
;
;+
;
;  Save the data stored in TQ common blocks
;
;  Format:  TQSAVE, FILE = file, _EXTRA = extrastuff
;
;  where:
;      file    -  File in which the data is stored
;                 Default is 'tqsaveit.sav'
;      _EXTRA  -  Any additional keywords recognized by SAVE
;  Example:
;    Save the data from the current session
;      tqsave
;
;    Save the data from the current session in file 'qs5581.sav'
;      tqsave, file = 'qs5581.sav'
;-
      on_error, 1
;  Common block
@pfidltq.com
;
@tq_qs_gridparam.com
;
      if n_elements (file) eq 0 then file = 'tqsaveit.sav'

      save, file = file, _extra= extrastuff

      return
      end
