; ------------------------------------------------------------------------ 
; $Id: array1pack.pro,v 1.3 2007/06/06 20:12:40 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro array1pack, j,nct, location, np,nix, ixx, keep = keep
;
;     j is the location
;     nct is the total number of arrays in the packed arrays
;     np is the number of points in ixx
;     ixx is the arrays to be put into the packed arrays
;     nix is  the packed arrays
;
      on_error, 1
      if n_elements (location) ne nct +1 then message, $
        'Number of conductors and pointer array are not consistent'
      if np eq 0 then begin
        if nct eq 0 then return
        if j eq 1 then begin
          nix = nix(location(1):*)
          location = location(1:*) - location(1)
          if keyword_set(keep) then location = [0, location]
        endif else if j eq nct then begin
          if location(nct-1) gt 0 then begin
            nix = nix(0:location(nct-1)-1)
          endif
          if keyword_set(keep) then location=[location(0:nct-1), $
             location(nct-1)] else location = location(0:nct-1)
        endif else begin
          cur = location(j)-location(j-1)
          if location(j- 1) gt 0 then begin
            nixt =nix(0:location(j-1)-1)
          endif else begin
            nixt = nix(0)
          endelse
          if location(nct) gt 0 then begin
            if location (j) lt location (nct) then begin
              nix =[nixt, nix(location(j):location(nct)-1)]
            endif else begin
              nix = nixt
            endelse
          endif else begin
            nix = [nixt, 0l]
          endelse
          if keyword_set(keep) then location(j:*) = location(j:*) -cur else $
            location = [location(0:j-1), location(j+1:nct)-cur]
        endelse
        if not  keyword_set(keep) then nct = nct-1
        return
      endif
      if n_elements (nix) eq 0 then begin
        nix = ixx
        location(j)= np
        if j lt nct then location (j+indgen(nct-j)+1) = np
      endif else if j eq nct then begin
        if j eq 1 then begin
          nix = ixx
          location(j)= np
        endif else if location (j-1) gt 0 then begin
          nix = [nix(0:location(j-1)-1), ixx]
          location (j) = location (j-1)+np
        endif else begin 
          nix = ixx
          location(j)= np
        endelse
      endif else if j eq 1 then begin
        addit = np - location(1)
        if location (1) lt n_elements(nix) then begin
          nix = [ixx, nix(location(1):*)]
          location (1:*) = location (1:*)+addit
        endif else begin
          nix = ixx
          location(j:*)= np
        endelse
      endif else begin
        addit = np -location(j)+location(j-1)
        if location(j-1) eq 0 then begin
          if location (j) ge n_elements (nix) then begin
            nix = ixx
            location(j:*)= np
          endif else begin
            nix = [ixx, nix(location(j):*)]
            location (j:*) = location (j:*)+addit
          endelse
        endif else if location(j) ge n_elements(nix) then begin
          nix = [nix(0:location(j-1)-1),ixx]
          location (j:*) = location(j:*) + addit
        endif else begin
          nix = [nix(0:location(j-1)-1),ixx, nix(location(j):*)]
          location (j:*) = location (j:*)+addit
        endelse
      endelse
      return
      end
