; ------------------------------------------------------------------------ 
; $Id: athprint.pro,v 1.3 2007/06/06 20:12:40 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro  athprint, unit, grid = grid, transp= transp
;+
; print tq common block to a file for ATHETA input
; format;
;     qsprint, unit
;        where unit is the logical unit 
;-
@pfidltq.com
;
;     common pfidltq, x, dx, y, dy, gx, gy, gdx, gdy, mult, x1grid, x2grid, $
;        cond, markx, marky, markerstring, lcfit
;
on_error, 1
  if n_elements(unit) eq 0 then message, $
   ' Unit for print must be defined'
if keyword_set(grid) then begin
  if cond.lcfit(0) eq 0 then begin
    print , ' Data must be fit to the grid'
    return
  endif
  xx = gx(cond.ix)
  yy = gy(cond.iy)
  loc = cond.loci
endif else begin
  xx = cond.x
  yy = cond.y
  loc = cond.locx
endelse
  nx = n_elements (xx)
  ny = n_elements (yy)
  offset = [20, 20]
  dimension = 0
  xunits = [1.0, 0.01, 0.001, 1.0e-6, 2.54e-2, 2.54e-5]
  units = ['Meters', 'Centimeters', 'Millimeters', 'Microns', 'Inches', 'Mils']
  ncon = n_elements(loc)-1
  for i = 1, ncon do begin
    plot, xx, yy, /nodata
    for ii = 1, ncon do oplot, xx(loc(ii-1):loc(ii)-1), $
      yy(loc(ii-1):loc(ii)-1), line = 2
    tx = xx(loc(i-1):loc(i)-1)
    ty = yy(loc(i-1):loc(i)-1)
    nc= n_elements (tx)
    if nc gt 0 then begin
      oplot, tx, ty, color = 4
      if keyword_set(transp) then begin
        temptx = temporary(tx)
        tx = temporary(ty)
        ty = temporary(temptx)
      endif
      get_athpart_info, lc,units,type,name,material,current,dimension,offset
      if lc eq 0 then begin
        con = reform( [tx, ty] * xunits(dimension), nc, 2)
        con = transpose(temporary(con))
        printf, unit, '!'
        printf, unit, '!*** START - ', name
        printf, unit, '!'
        if (nc/2)* 2 lt nc then begin
          if type eq 0 then begin  $
             printf, unit, ' part  ' , name, '    ', material, '  &'
          endif else if type eq 1 then begin
             printf, unit, ' curve  ' , name, '  &'
          endif else printf, ' coilset  ' , name, '   ', current, '  &'
          printf, unit,  format='(2(e16.5, e13.5 ), ''   & '')', con(*, 0:nc-2)
          printf, unit,  format='(e16.5, e13.5 , ''   . '')', con(*, nc-1)

        endif else begin
          if type eq 0 then begin  $
             printf, unit, ' part  ' , name, '    ', material, '  &'
          endif else if type eq 1 then begin
             printf, unit, ' curve  ' , name, '  &'
          endif else printf, ' coilset  ' , name, '   ', current, '  &'
          if nc gt 3 then $
          printf, unit,  format='(2(e16.5, e13.5 ), ''   & '')', con(*, 0:nc-3)
          printf, unit,  format='(2(e16.5, e13.5 ), ''   . '')', con(*, nc-2:nc-1)

        endelse
        printf, unit, '!'
        printf, unit, '!*** END - ', name
        printf, unit, '!'
      endif
    endif
  endfor
  return
  end
