; ------------------------------------------------------------------------ 
; $Id: cond2str.pro,v 1.3 2007/06/06 20:12:40 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro cond2str, array, xx, yy, loc, clabel = clabel, $
          xlabel = xlabel, ylabel= ylabel
;
; convert conductor segments to a conductor structure
;
       on_error, 1
;
      if n_elements(clabel) eq 0 then clabel = 'TQ Conductors'
      if n_elements(xlabel) eq 0 then xlabel = 'Xi' else xlabel=strtrim(xlabel,2)
      if n_elements(ylabel) eq 0 then ylabel = 'Xj' else ylabel=strtrim(ylabel,2)
      xlab = [xlabel, ylabel, 'Dummy']
      ndim = 3L
      nloc = n_elements(loc)
      np = n_elements(xx)
      plane = make_array(6*(np-1))
      normal = make_array(np-1, /int)
      slant = 0.0
      err = (max([xx, yy], min= mm)-mm)*6.1e-5
      minz = -1.0
      mz = 1.0
      np = 0
      for j = 0, nloc-2 do begin
        for i = loc(j), loc(j+1)-2 do begin
          minx = min([xx(i), xx(i+1)], max = mx)
          miny = min([yy(i), yy(i+1)], max = my)
          k6 = np*6
          plane(k6:k6+5) = [minx, mx, miny, my, minz, mz]
          if(mx - minx) lt err then normal(np) = 1 else $
          if(my - miny) lt err then normal(np) = 2 else begin
            slant = [slant,xx(i), yy(i), minz, xx(i+1), yy(i+1), mz]
            normal(np) = 0
          endelse
          np = np+1
        endfor
      endfor
      plane = plane(0:6*np-1)
      normal = normal(0:np-1)
      tot = np
      nsize = make_array(5, /long)
      plane = reform (plane, 2, 3, tot, /overwrite)
      nsize (4) = tot
      n0 = where (normal eq 0, ns)
       nsize(0) = ns
      n1 = where (normal eq 1,ns)
       nsize(1)= ns
      n2 = where (normal eq 2,ns)
       nsize(2) = ns
      n3 = -1
       nsize(3) = 0L
      if n_elements (slant) gt 1 then begin
        slant = slant(1:*)
        slant = reform (slant,3,2,nsize(0), /overwrite)
      endif
      spare = [-3, -3, -3, -3, -3]
      file='TQconductor'
      array = {type:4L, ndim:ndim,  block :1L, $
              size:nsize, plane : plane, slant : slant, $
              n0 :n0, n1:n1, n2:n2, n3: n3, xlab : xlab, $
              file : file, spare : spare, tlab : file, clab: clabel}
      return
      end
