; ------------------------------------------------------------------------ 
; $Id: diel2fill.pro,v 1.4 2010/09/29 20:59:14 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro diel2fill, value, ix, iy, np, temp, nx, ny
;
;    convert an index array to a dielectric image
;    ix iy arrays must be horizontal or vertical
; 
;      the location of conductors.
on_error, 1
;
; 
ok = where (ix(0:np-2) eq ix(1:np-1) , ni)
if ni eq 0 then begin
   print, ' No vertical lines - bad data'
   temp = 0
   return
endif
 yminv = make_array(/int, ni)
 ymaxv = yminv
 for i = 0, ni-1 do begin
   yminv(i) = min([iy(ok(i)), iy(ok(i)+1)], max = mmm)
   ymaxv(i) = mmm
 endfor
 ok2 = where(ymaxv gt yminv, n)
 if n eq ni then xvalue = ix(ok) else begin
   xvalue =  ix(ok(ok2))
   yminv = yminv(ok2)
   ymaxv = ymaxv(ok2)
 endelse
;
xmin = min(xvalue, max = xmax)
ymin = min(yminv)
ymax = max(ymaxv)
nnpy = ymax-ymin
npy = make_array(nnpy, /int)
elem = make_array(n, nnpy, /int)

for j = ymin, ymax-1 do begin
  ok = where ((j ge yminv) and (j lt ymaxv),  nok)
  npy(j-ymin) = nok
  if nok gt 0 then elem(0:nok-1, j-ymin) = ok
endfor

for i = xmin, xmax do begin
  for j = 0, nnpy-1 do begin
    if npy(j) gt 0 then begin
      ok = where ( (i ge xvalue(elem(0:npy(j)-1, j))) , nok)
      if 2*(nok/2) ne nok then temp(i, ymin+j) = value
    endif
  endfor
endfor
elem = 0
npy = 0
xvalue = 0
yvalue = 0
  return
  end
