; ------------------------------------------------------------------------ 
; $Id: get_athpart_info.pro,v 1.3 2007/06/06 20:12:41 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro get_ath_info_event, event
    but = event.value
    case but of 

 'PART' : BEGIN
          Widget_control, event.top, get_uvalue = info, /no_copy
          handle_value, info.handle, value, /no_copy
          widget_control, info.database, update = 0
          widget_control, info.entity_base(value.type), map = 0
          widget_control, info.entity_base(0), map = 1
          widget_control, info.database, update = 1
          value.type = 0
          handle_value, info.handle, value, /no_copy, /set
          Widget_control, event.top, set_uvalue = info, /no_copy
          END

 'CURVE' : BEGIN
          Widget_control, event.top, get_uvalue = info, /no_copy
          handle_value, info.handle, value, /no_copy
          widget_control, info.database, update = 0
          widget_control, info.entity_base(value.type), map = 0
          widget_control, info.entity_base(1), map = 1
          widget_control, info.database, update = 1
          value.type = 1
          handle_value, info.handle, value, /no_copy, /set
          Widget_control, event.top, set_uvalue = info, /no_copy
          END
          
 'COIL' : BEGIN
          Widget_control, event.top, get_uvalue = info, /no_copy
          handle_value, info.handle, value, /no_copy
          widget_control, info.database, update = 0
          widget_control, info.entity_base(value.type), map = 0
          widget_control, info.entity_base(2), map = 1
          widget_control, info.database, update = 1
          value.type = 2
          handle_value, info.handle, value, /no_copy, /set
          Widget_control, event.top, set_uvalue = info, /no_copy
          END
          
 'QUIT' : BEGIN
         Widget_control, event.top, get_uvalue= info,tlb_get_offset = offset, $
              /no_copy
          handle_value, info.handle, value, /no_copy
          value.quit = 1
          value.offset = offset
          handle_value, info.handle, value, /no_copy, /set
          widget_control, event.top, /destroy
          END
 'OK' : BEGIN
         Widget_control, event.top, get_uvalue= info,tlb_get_offset = offset, $
              /no_copy
          handle_value, info.handle, value, /no_copy
          if value.type eq 0 then begin
            widget_control,info.part_material, get_value = material
            value.material = sp2under(material(0))
          endif else if value.type eq 2 then begin
            widget_control,info.coil_current, get_value = current
            value.current = current
          endif
          widget_control,info.part_name(value.type), get_value = name
          value.name = sp2under(name(0))
          widget_control,info.dimen, get_value = dimension
          value.dimension = dimension
          value.offset = offset
          value.quit = 0
;    info = {handle: handle, entity_base:entity_base, part_name:part_name, $
;      dimen:butdim, database:database, coil_current:coil_current, $
;      part_material: part_material}
;    value = { quit: 0, type:type, name:name, material: material, $
;      current:current, dimension:dimension, offset:offset} 
          handle_value, info.handle, value, /no_copy, /set
          widget_control, event.top, /destroy
          END
     ELSE: 
     endcase
     end
 Pro get_athpart_info, lcquit, units,type, name, material, current, $
              dimension, offset
     on_error, 1
     if n_elements (xsize) eq 0 then xsize = 30
     base = widget_base(/column, title= 'ATHETA Parameters')
     lcquit = 1
     if n_elements (type) eq 0 then type = 0 else type = fix(type(0))
     buttyp = cw_bgroup( base, /row, $
          ['Part' , 'Curve', 'Coil'], $
          /exclusive, /NO_RELEASE, $
          label_top = 'Material Type', /frame, $
          button_uvalue= ['PART' , 'CURVE', 'COIL'] , set_value = type)
;
     entity_base= make_array(3, /long)
     part_name= make_array(3, /long)
     database = widget_base(base, /frame)
     if n_elements (name) eq 0 then name = ' '
;
     if type eq 0 then map = 1 else map = 0
     entity_base(0) = widget_base(database, /col, map = map)
     part_name(0) = cw_field(entity_base(0), title= 'Part Name:',  $
           value = name)
     if n_elements (material) eq 0 then material = ' '
     part_material = cw_field(entity_base(0), title= 'Part Material:',  $
           value = material)
;
     if type eq 1 then map = 1 else map = 0
     entity_base(1)  = widget_base(database, /col, map = map)
     part_name(1) = cw_field(entity_base(1), title= 'Part Name:',  $
           value = name)
;
     if type eq 2 then map = 1 else map = 0
     entity_base(2)  = widget_base(database, /col, map = map)
     part_name(2) = cw_field(entity_base(2), title= 'Part Name:',  $
           value = name)
     if n_elements (current) eq 0 then current = 0.0
     coil_current = cw_field(entity_base(2), title= 'Coilset Current:', /float, $
           value = current)
;
     if n_elements(dimension) eq 0 then dimension = 0
     butdim = cw_bgroup( base, column = 2,  units,/exclusive, $
          label_top = 'Dimension Units', /NO_RELEASE, /frame, $
          button_uvalue= units, set_value = dimension)

     menu = make_array(2, /string)
     menu(0) = '             OK             ' 
     menu(1) = '   Skip this Shape   '
     but = cw_bgroup(base, menu,/row,/NO_RELEASE, button_uvalue =['OK','QUIT'])

  if n_elements (offset) lt 2  then offset = [10, 10] else $
    offset = (offset(0:1)> 0)
  WIDGET_CONTROL, base, /REALIZE, tlb_set_xoffset = offset(0), $
       tlb_set_yoffset= offset(1)

     handle = handle_create()
     info = {handle: handle, entity_base:entity_base, part_name:part_name, $
      dimen:butdim, database:database, coil_current:coil_current, $
      part_material: part_material}
     widget_control, base, set_uvalue = info
     value = { quit: 1, type:type, name:name, material: material, $
          current:current, dimension:dimension, offset:offset} 
     handle_value, /set, handle, value, /no_copy

    widget_control, base, tlb_get_offset= offset_real
     offset_real = offset  - offset_real

     xmanager, 'get_ath_info', base,/modal
     handle_value,  handle, value, /no_copy
     handle_free, handle
     lcquit = value.quit
     offset = value.offset + offset_real

     if lcquit eq 1 then return
     type = value.type
     name = value.name
     material = value.material
     current = value.current
     dimension = value.dimension
;
     return
     end
;Pro get_athpart_info, lcquit, units,type, name, material, current, $
;             dimension, offset
