; ------------------------------------------------------------------------ 
; $Id: get_cdq.pro,v 1.4 2010/09/29 20:59:14 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
;+
; get the type of surface indicated by the border
; options are: conductor, dielectric, or uniform charge 
;-
PRO get_cdq_Event, Event

  on_error, 1
  WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev

  CASE Ev OF 

  'SELECT': BEGIN
      widget_control, event.top, get_uvalue= info
      widget_control, info.label, set_value=(info.labstring)(event.value)
      END
  'EXIT': BEGIN
      but = event.value
      widget_control, event.top, get_uvalue = info, /no_copy, $ 
              tlb_get_offset = offset
      
      case but of
 'QUIT' : lcquit = 1
 'OK' :   lcquit = 0
       ELSE: BEGIN
              lcquit = 1
              print, ' Unknown event - QUIT'
             END
       endcase
          widget_control,info.field, get_value = value
          widget_control,info.select, get_value = ltype
          pvalues = {lcquit:lcquit, value:value, ltype:ltype, offset:offset}
          widget_control, info.ptr, set_uvalue = pvalues, /no_copy
          widget_control, event.top, /destroy
      END
   ELSE:
  ENDCASE
END


PRO get_cdq, lcquit, ltype, value, offset,  GROUP=Group


on_error, 1
  IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0

  base = WIDGET_BASE(GROUP_LEADER=Group, $
      COLUMN=1, $
      MAP=1)

  Btns100 = [ $
    '   Conductor   ', $
    '  Dielectric  ', $
    'Unif Charge Dist' ]

  if n_elements(ltype) eq 0 then ltype = 0
  ltype = ltype(0) > 0
  if ltype gt 2 then ltype = 0

  select = CW_BGROUP( base, Btns100, $
      ROW=1,  $
      LABEL_TOP ='Identify the indicated geometry', $
      FRAME = 3, $
      EXCLUSIVE = 1, /NO_RELEASE, $
      SET_VALUE = ltype, $
      UVALUE='SELECT')

  labstring =['Potential on Conductor (V)', $
              'Relative Dielectirc Constant', $
              'Charge Density (Coul / m^2)']
  base2= widget_base(base, frame = 3, /COLUMN)
  LABEL = WIDGET_LABEL(base2, $
      UVALUE='LABEL', $
      VALUE= labstring(ltype))

  if n_elements (value) eq 0 then value = 0.0

  FIELD = CW_FIELD( base2,VALUE=value, $
      ROW=1, $
      FLOAT=1, $
      TITLE='Value:', $
      UVALUE='FIELD')

      menu = ['     OK     ',  '  Quit  ']
 but = cw_bgroup(base, menu,/row, /NO_RELEASE,  $
        uvalue = 'EXIT', button_uvalue =['OK','QUIT'])

  if n_elements (offset) lt 2  then offset = [10, 10] else $
    offset = (offset(0:1)> 0)
  WIDGET_CONTROL, base, /REALIZE, tlb_set_xoffset = offset(0), $
       tlb_set_yoffset= offset(1)


; Get drawable window index

  ptr = widget_base()
  info ={labstring:labstring, label:label, select:select, $
         field:field, ptr:ptr}
  lcquit = 1
  pvalues = {lcquit:lcquit, value:value, ltype:ltype, offset:offset}
  widget_control, base, set_uvalue = info, /no_copy
  widget_control, ptr, set_uvalue = pvalues, /no_copy

     widget_control, base, tlb_get_offset= offset_real
     offset_real = offset  - offset_real

  XMANAGER, 'get_cdq', base
  widget_control, ptr, get_uvalue = pvalues, /no_copy
  widget_control, ptr, /destroy
  lcquit = pvalues.lcquit
  value = pvalues.value
  ltype = pvalues.ltype
  offset = pvalues.offset + offset_real
END
