; ------------------------------------------------------------------------ 
; $Id: get_converg_iter.pro,v 1.3 2007/06/06 20:12:41 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
;
;+
; NAME:
;	GET_CONVERG_ITER
;
; PURPOSE:
;	Get the convergence criteria and maximum number of iterations
;
; MODIFICATION HISTORY:
; 	Written by:	L. P. Mix, June 30, 1994
;-


  PRO get_converg_iter, conv, maxiter, GROUP=Group

  on_error, 1

  IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0

  junk   = { CW_PDMENU_S, flags:0, name:'' }

  MAIN13 = WIDGET_BASE(GROUP_LEADER=Group, $
      COLUMN=1, $
      MAP=1, $
      TITLE='Convergence and Iteration Parameters', $
      UVALUE='MAIN13')

  if n_elements (conv) eq 0 then conv = 1.0e-5 else conv = abs(conv)
  FIELD2 = CW_FIELD( MAIN13,VALUE=conv, $
      ROW=1, $
      FLOAT=1, $
      TITLE='Convergence ratio for solution', $
      UVALUE='FIELD2')

   if n_elements (maxiter) eq 0 then maxiter = 100 else maxiter = abs(maxiter)
   FIELD3 = CW_FIELD( MAIN13,VALUE=maxiter, $
      ROW=1, $
      LONG=1, $
      TITLE='Maximum number of iterations allowed', $
      UVALUE='FIELD3')

   button = WIDGET_BUTTON(main13, VALUE = 'OK', UVALUE = 'DONE')

   WIDGET_CONTROL, MAIN13, /REALIZE

   event = WIDGET_EVENT (main13)
   widget_control, field2, get_value = conv
   widget_control, field3, get_value = maxiter
   widget_control, event.top, /destroy

END
