; ------------------------------------------------------------------------ 
; $Id: get_cxy_labels.pro,v 1.4 2010/09/29 20:59:14 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
;+
; get the comment, x and y labels for a conductor dataset
;-
PRO get_cxy_event, Event

  on_error, 1
  WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev

  CASE Ev OF 

  'EXIT': BEGIN
      but = event.value
      widget_control, event.top, get_uvalue = info
      
      case but of
 'QUIT' : lcquit = 1
 'OK' :   lcquit = 0
       ELSE: BEGIN
              lcquit = 1
              print, ' Unknown event - QUIT'
             END
       endcase
          widget_control,info.str, get_value = str
          widget_control,info.laba, get_value = clabel
          clabel = strtrim(clabel, 2)
          widget_control,info.labb, get_value = xlabel
          xlabel = strtrim(xlabel, 2)
          widget_control,info.labb, get_value = ylabel
          ylabel = strtrim(ylabel, 2)
          widget_control,event.top, tlb_get_offset = offset
          pvalues = {lcquit:lcquit, str:str, laba:clabel, $
            labb:xlabel, labc:ylabel, offset:offset}
          widget_control, info.ptr, set_uvalue = pvalues
          widget_control, event.top, /destroy
      END
   ELSE:
  ENDCASE
END


PRO get_cxy_labels, lcquit, str, clabel, xlabel, ylabel, offset, GROUP=Group


on_error, 1
  IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0

  base = WIDGET_BASE(GROUP_LEADER=Group, $
      COLUMN=1, $
      MAP=1)

  text = 'Enter the Structure array number, '
  text2 = 'Dataset Comment, X-Label, and Y-Label for the conductor'
  tbase = widget_label(base, value = text)
  tbase = widget_label(base, value = text2)

  if n_elements (str) eq 0 then str = 1

  FIELDs = CW_FIELD( base,VALUE=str, $
      ROW=1, $
      LONG = 1, $
      TITLE='Structure array #:', $
      UVALUE='FIELD')

  if n_elements (clabel) eq 0 then clabel  = 'TQ Conductor'

  FIELDa = CW_FIELD( base,VALUE=clabel, $
      ROW=1, $
      TITLE='Comment Label:', $
      UVALUE='FIELD')

  if n_elements (xlabel) eq 0 then xlabel  = 'Distance (m)'

  FIELDb = CW_FIELD( base,VALUE=xlabel, $
      ROW=1, $
      TITLE='X axis Label:', $$
      UVALUE='FIELD')

  if n_elements (ylabel) eq 0 then ylabel  = 'Distance (m)'

  FIELDc = CW_FIELD( base,VALUE=ylabel, $
      ROW=1, $
      TITLE='Y axis Label:', $$
      UVALUE='FIELD')



      menu = ['     OK     ',  '  Quit  ']
 but = cw_bgroup(base, menu,/row, /NO_RELEASE, $
        uvalue = 'EXIT', button_uvalue =['OK','QUIT'])

  if n_elements (offset) lt 2  then offset = [10, 10] else $
    offset = (offset(0:1)> 0)
  WIDGET_CONTROL, base, /REALIZE, tlb_set_xoffset = offset(0), $
       tlb_set_yoffset= offset(1)


; Get drawable window index

  ptr = widget_base()
  info ={str:fields, laba:fielda, labb:fieldb, labc:fieldc, $
          ptr:ptr}
  lcquit = 1
  pvalues = {lcquit:lcquit, str:str, laba:clabel, $
            labb:xlabel,labc:ylabel,offset:offset}
  widget_control, base, set_uvalue = info, /no_copy
  widget_control, ptr, set_uvalue = pvalues, /no_copy

     widget_control, base, tlb_get_offset= offset_real
     offset_real = offset  - offset_real

  XMANAGER, 'get_cxy', base
  widget_control, ptr, get_uvalue = pvalues, /no_copy
  widget_control, ptr, /destroy
  lcquit = pvalues.lcquit
  str = pvalues.str
  clabel = pvalues.laba
  xlabel = pvalues.labb
  ylabel = pvalues.labc
  offset = pvalues.offset + offset_real
END
