; ------------------------------------------------------------------------ 
; $Id: get_ics.pro,v 1.3 2007/06/06 20:12:41 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
PRO get_ics_event, Event


  WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev

  CASE Ev OF 

  'EXIT': BEGIN
      but = event.value
      widget_control, event.top, get_uvalue = info, tlb_get_offset = offset, $
              /no_copy


      case but of
    'QUIT' : lcquit = 1
      'OK' :   lcquit = 0
       ELSE: BEGIN
              lcquit = 1
              print, ' Unknown event - QUIT'
             END
       endcase
          widget_control,info.conv, get_value = conv
          widget_control,info.er, get_value = erdef
          widget_control,info.iter, get_value = itrnmax
          value = {lcquit:lcquit, conv:conv, niter:itrnmax, $
             offset:offset, er:erdef}
          widget_control, info.ptr, set_uvalue = value, /no_copy
          if erdef gt 0.0 then $
            widget_control, event.top, /destroy $
          else winformation, offset = offset, $
            ['Default dielectric constant must be', 'GREATER THAN ZERO']
      END
   ELSE:

  ENDCASE
END

; value = {lcquit:0, conv:conv, niter:itrnmax, val:xvalue, $
;        system:system, offset:offset}
; info={xval:field11, conv:field3, iter:field2, $
;      xbase: base8, labels:labels, lab:lab, ptr:ptr}

PRO get_ics, lcquit, itrnmax, conv, erdef, offset, message, $
           GROUP=Group

  IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0


  Base = WIDGET_BASE(GROUP_LEADER=Group, $
      COLUMN=1, $
      MAP=1, $
      TITLE='Iteration Parameters and Coordinate System', $
      UVALUE='MAIN13')

  if n_elements(itrnmax) eq 0 then itrnmax = 200L

  FIELD2 = CW_FIELD( base,VALUE=itrnmax, $
      ROW=1, $
      LONG=1, $
      FRAME=4, $
      TITLE='Maxinum Number of Iterations', $
      UVALUE='FIELD2')

  if n_elements (conv) eq 0 then conv = 3.00e-11

  FIELD3 = CW_FIELD( base,VALUE=conv, $
      ROW=1, $
      FLOAT=1, $
      FRAME=4, $
      TITLE='Convergence Ratio for Solution', $
      UVALUE='FIELD3')
  
  if n_elements (erdef) eq 0 then erdef = 1.0

  FIELD33 = CW_FIELD( base,VALUE=erdef, $
      ROW=1, $
      FLOAT=1, $
      FRAME=4, $
      TITLE='Default Relative Dielectric Constant', $
      UVALUE='FIELD33')

  if n_elements (message) gt 0 then begin
      BASE8 = WIDGET_BASE(BASE, $
      COLUMN=1, $
      FRAME = 2, $
      MAP=1, $
      UVALUE='BASE8')

      nel = n_elements(message) -1
      for i = 0, nel do $
        Label10 = WIDGET_LABEL( BASE8, $
        UVALUE='LABEL10', $
        VALUE= message(i))
      
        Label10 = WIDGET_LABEL( BASE8, $
        UVALUE='LABEL10', $
        VALUE= 'Quit and Use TQSET_SYSTEM to change')
  endif

  menu = ['       OK       ',  '    Quit    ']

  but = cw_bgroup(base, menu,/row, /NO_RELEASE, $
        uvalue = 'EXIT', button_uvalue =['OK','QUIT'])

  if n_elements (offset) lt 2  then offset = [10, 10] else $
    offset = (offset(0:1)> 0)
  WIDGET_CONTROL, base, /REALIZE, tlb_set_xoffset = offset(0), $
       tlb_set_yoffset= offset(1)

  ptr = widget_base ()
  value = {lcquit:0, conv:conv, niter:itrnmax, $
         er:erdef, offset:offset}
  info={conv:field3, iter:field2, er:field33, ptr:ptr}

  widget_control, ptr, set_uvalue = value, /no_copy
  Widget_control, base, set_uvalue = info, /no_copy

     widget_control, base, tlb_get_offset= offset_real
     offset_real = offset  - offset_real


  XMANAGER, 'get_ics', base
  widget_control, ptr, get_uvalue = value, /no_copy
  widget_control, ptr, /destroy
  lcquit= value.lcquit
  conv = value.conv
  itrnmax = value.niter
  offset = value.offset + offset_real
  erdef = value.er
END
