; ------------------------------------------------------------------------ 
; $Id: get_tqcond_info.pro,v 1.3 2007/06/06 20:12:41 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro get_tq_info_event, event
    but = event.value
    case but of 

 'QUIT' : BEGIN
          widget_control, event.top, get_uvalue = info, /no_copy, $
             tlb_get_offset = offset
          value = {varname: '', quit: 1, normal:0, offset:offset}
          widget_control, info.ptr, set_uvalue = value, /no_copy
          widget_control, event.top, /destroy
          END
 'OK' : BEGIN
          widget_control, event.top, get_uvalue = info, /no_copy, $
             tlb_get_offset = offset
          widget_control, info.con, get_value = j
          widget_control,info.var, get_value = varname 
          value = {varname: varname, quit: 0, normal:j, offset:offset}
          widget_control, info.ptr, set_uvalue = value, /no_copy
          widget_control, event.top, /destroy
          END
;    ignore conductor/vacuum pushes
     ELSE: 
     endcase
     end
 Pro get_tqcond_info, cx, cy, lcquit, string2, normal,offset, xsize = xsize, $
              group = group, modal = modal
     on_error, 1
     if n_elements (xsize) eq 0 then xsize = 30
     old = !d.window 
     if n_elements (group) eq 0 then group = 0
     base = widget_base(/column, title= 'Conductor Parameters', $
       group = group, modal = modal)
     lcquit = 1
     if n_elements (string2) eq 0 then string2 = ' '
     Var = cw_field(base, title= 'Enter Conductor Name', xsize = xsize, $
           value = string2)
     nor = widget_base(base, /row)
     tit = 'The material indicated by the arrow is:'
     label = widget_label(nor, value = tit)
     butcon = cw_bgroup( nor, /row, ['Conductor' , 'Vacuum'],/exclusive, $
          button_uvalue=['CON', 'VAC'], /NO_RELEASE, set_value = 0)
     plt = widget_draw( base, xsize = 450, ysize = 300)
     menu = make_array(2, /string)
     menu(0) = '       OK-Continue         ' 
     menu(1) = ' Quit & Return to Editor  '
     but = cw_bgroup(base, menu,/row, /NO_RELEASE,button_uvalue =['OK','QUIT'])
     ptr = widget_base()

  if n_elements (offset) lt 2  then offset = [10, 10] else $
    offset = (offset(0:1)> 0)
  WIDGET_CONTROL, base, /REALIZE, tlb_set_xoffset = offset(0), $
       tlb_set_yoffset= offset(1)


     info = {var: var,  con:butcon, ptr:ptr}
     widget_control, base, set_uvalue = info
     value = {varname: '', quit: 1, normal:0, offset:offset}
     widget_control, ptr, set_uvalue = value
     widget_control, plt, get_value = wid
     wset , wid
     plot, cx, cy
     if cx(0) eq cx(1) then begin
;      verticle line
       dist = (!x.crange(0)+!x.crange(1))*0.5
       yy = (cy(0)+cy(1))*0.5
       if cx(0) lt dist then begin
         normal= +1
         arrow,cx(0),yy, cx(0)+dist/5, yy, /data, /solid,hthick=4,thick=5,col=7
       endif else begin
         normal = -1
         arrow,cx(0),yy, cx(0)-dist/5, yy, /data, /solid,hthick=4,thick=5,col=7
       endelse 
     endif else begin
;      horizontal line or diagonal line
       dist = (!y.crange(0)+!y.crange(1))*0.5
       xx = (cx(0)+cx(1))*0.5
       yy = (cy(0)+cy(1))*0.5
       if yy lt dist then begin
         normal= +1
         arrow, xx, yy,xx, yy +dist/5, /data, /solid, hthick=4,thick=5,col=7
       endif else begin  
         normal = -1
         arrow, xx, yy,xx, yy-dist/5,  /data, /solid, hthick=4,thick=5,col=7
       endelse 
     endelse

     widget_control, base, tlb_get_offset= offset_real
     offset_real = offset  - offset_real

     xmanager, 'get_tq_info', base
     widget_control, ptr, get_uvalue = value
     widget_control, ptr, /destroy
     lcquit = value.quit
     offset = value.offset + offset_real
     string2 = strtrim(value.varname, 2)
     if value.normal eq 0 then normal = -normal
     if old ge 0 then wset, old
     return
     end
