; ------------------------------------------------------------------------ 
; $Id: get_tqconductor.pro,v 1.3 2007/06/06 20:12:41 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Function get_tqconductor, p1, lcsegment
;
; return the nearest point on a conductor to the point p1
;
@pfidltq.com
;
;
 on_error,1 
;
 if n_elements(p1) lt 2 then message,'Point must be defined'
 p1 = p1(0:1)
 if n_elements(cond.x) eq 0 or n_elements(cond.y) eq 0 then message, $
     'Conductor array must be defined'
 ratio = ((!x.crange(1)-!x.crange(0))/(!y.crange(1)-!y.crange(0)))^2
 if lcsegment lt 0 then begin
   dist = (cond.x-p1(0))^2 + ratio*(cond.y-p1(1))^2
   junk = min(dist, j)
   ok=where(j ge cond.locx(0:cond.ncon-1) and j lt cond.locx(1:cond.ncon),np)
   if np ne 1 then message, strtrim(np, 2)+' Conductor segments found'
   lcsegment  = ok(0)+1
   jr = j - cond.locx(lcsegment-1)
 endif else begin
   xx = cond.x(cond.locx(lcsegment-1):cond.locx(lcsegment) -1)
   yy = cond.y(cond.locx(lcsegment-1):cond.locx(lcsegment) -1)
   dist = (xx-p1(0))^2 + ratio*(yy-p1(1))^2
   junk = min(dist, jr)
    j = jr+cond.locx(lcsegment-1)
 endelse
 if jr eq 0 then begin
   resultb = pnt_line(p1, [cond.x(j),cond.y(j)], [cond.x(j+1),cond.y(j+1)], pb)
   return, pb
 endif
 np = cond.locx(lcsegment) - cond.locx(lcsegment-1)
 if j+1 eq np then begin
   resulta = pnt_line(p1, [cond.x(j),cond.y(j)], [cond.x(j-1),cond.y(j-1)], pa)
   return, pa
 endif
 resulta = pnt_line(p1, [cond.x(j),cond.y(j)], [cond.x(j-1),cond.y(j-1)], pa)
 resultb = pnt_line(p1, [cond.x(j),cond.y(j)], [cond.x(j+1),cond.y(j+1)], pb)
 if resulta lt resultb then return, pa else return, pb
 end
