; ------------------------------------------------------------------------ 
; $Id: interpoltq.pro,v 1.3 2007/06/06 20:12:42 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro interpoltq, ara, xan, yan, arb, xb, yb, default = default , half = half
;
;+
;  interpolate arb onto ara 
;  add an additional row/column to arb with value = default
;-
 on_error, 1
      nxa = n_elements(xan)
      nya = n_elements(yan)
      if nxa gt 0 then xa = xan else message, 'bad arguement; xan'
      if nya gt 0 then ya = yan else message, 'bad arguement; yan'
      if keyword_set (half) then begin
        xa(0:nxa-2) = xa(0:nxa-2)  +0.5*(xa(1:nxa-1)-xa(0:nxa-2))
        ya(0:nya-2) = ya(0:nya-2)  +0.5*(ya(1:nya-1)-ya(0:nya-2))
      endif
      nxb = n_elements(xb)
      nyb = n_elements(yb)
      a = size(ara) 
      b = size(arb)
      if a(0) ne 2 or a(1) ne nxa or a(2) ne nya then begin
         print, 'Incompatable elements for the first array'
         help, nxa, nya, ara
         return
      endif 
      if b(0) ne 2 or b(1) ne nxb or b(2) ne nyb then begin
         print, 'Incompatable elements for the first array'
         help, nxb, nyb, arb
         return
      endif 
      if xb(0) gt xa(nxa-1)  or xa(0) gt xb(nxb-1) then return
      if yb(0) gt ya(nya-1)  or ya(0) gt yb(nyb-1) then return
      if n_elements (default) eq  0 then default = 0.0 else $
          default = float(default(0))
      b = make_array(nxb+2, nyb+2, value = default)
      b(1:nxb, 1:nyb) = arb
      x = [2*xb(0)-xb(1), xb, 2*xb(nxb-1)-xb(nxb-2)]
      y = [2*yb(0)-yb(1), yb, 2*yb(nyb-1)-yb(nyb-2)]
      okx = where (xa gt x(0) and xa lt x(nxb+1), nokx)
      oky = where (ya gt y(0) and ya lt y(nyb+1), noky)
      p1 = get_yarr(x, findgen(nxb+2), xa(okx))
      p2 = get_yarr(y, findgen(nyb+2), ya(oky))
;     a = interpolate(b, p1, p2, /cubic, /grid)
      a = interpolate(b, p1, p2,  /grid)
      ara(okx(0):okx(nokx-1), oky(0):oky(noky-1)) = a
      return
      end
