; ------------------------------------------------------------------------ 
; $Id: mk_grid_textstr.pro,v 1.3 2007/06/06 20:12:42 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Function mk_grid_textstr, xin, dxin, n, grid
;
; convert block limits to a string
; assume blocks of the form: blocks(2,3, nblock)
       on_error, 1
      nel = n_elements(xin)
      if nel lt 2 then return, '0'
      x = float(xin)
      dx = float(dxin)
      str = make_array(nel, /string)
      ok = where (dx lt 0, nok)
      twidx = make_array(nel, /string, value = ' ')
      twiddx = make_array(nel, /string, value = '~')
      if nok eq 0 then twiddx(0) = ' ' else begin
        twiddx(ok) = ' '
        if nok gt 1 then twidx(ok(1:*)) = '~'
        dx(ok)= -dx(ok)
      endelse

      for i =0, nel-2 do begin
        if grid(i) le 0 then type ='Quad' else type = 'Geo'
        str(i) = string(format='(a, t15, a, t30, i4, t40,  a)', $
         twidx(i)+strtrim(x(i), 2), twiddx(i)+strtrim(dx(i), 2), n(i), type)
      endfor
      i = nel-1
      str(i) = string(format='(a, t15, a, t30, i4, t34,  a)', $
        twidx(i)+strtrim(x(i), 2), twiddx(i)+strtrim(dx(i), 2), $
         fix(total(n(0:nel-2))),'-Total') 
      return, str
      end
