; ------------------------------------------------------------------------ 
; $Id: outline_ins.pro,v 1.3 2007/06/06 20:12:42 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
  pro outline_ins_event, event
     print, ' top event handler'
     help, /str, event
     return
     end

    function make_outline,menubase, data, modal = modal
    common outline_draw_status, stat, ratio
 on_error, 1
    stat = 0
    if keyword_set(modal) then begin
      drawbase = widget_base(menubase, event_pro='outline_resize', $
         uvalue = menubase)
    endif else $
    drawbase = widget_base(/tlb_size_events, /row, event_pro='outline_resize', $
        xoffset = data.xoff2,  yoffset = data.yoff2 , group_leader = menubase, $
        Title = 'OUTLINE OBJECT (Re-Sizable)', uvalue = menubase)
    draw = widget_draw(drawbase, xsize = data.xsize, ysize= data.ysize, $
           /button_event, event_pro='outline_draw')
    if keyword_set(modal) then  $
    widget_control, menubase, /realize, xoffset= data.xoff1, $
      yoffset= data.yoff1 else widget_control, drawbase, $
      /realize, xoffset= data.xoff2, yoffset= data.yoff2
    widget_control, draw, get_value=windowid
    drawvalues = [drawbase, draw, windowid ]
    ratio = ((data.xran(1)-data.xran(0))/( data.yran(1)-data.yran(0))* $
            data.ysize/data.xsize)^2
    return, drawvalues
    end

  pro outline_keep, event
      common outline_draw_status, stat, ratio
      widget_control, event.top, get_uvalue = info, /no_copy, $
        tlb_get_offset= offset
      widget_control, info.draw(1), draw_motion_events=0, /clear_events
      offset = offset+100
      widget_control, info.base, sensitive = 0
      stat = widget_base(xoffset = offset(0), yoffset = offset(1))
      t1 = widget_label(stat, value = ' ')
      t2 = widget_label(stat, value = '    Indicate the desired conductor    ')
      t3 = widget_label(stat, value = ' ')
      widget_control, stat, /realize,xoffset = offset(0), yoffset = offset(1)
      widget_control, event.top, set_uvalue = info, /no_copy
      return
      end

  pro outline_cond_save, event, tlb
      common outline_draw_status, stat, ratio
      coord = convert_coord(event.x, event.y, /device, /to_data)
      widget_control, tlb, get_uvalue = info, /no_copy
      handle_value, info.data, data, /no_copy
      dist = (data.x-coord(0))^2 +ratio *(data.y-coord(1))^2
      junk = min(dist, j)
      ok = where(j ge data.loc, nok)+1
      if nok eq 0 then message, 'NOK equals zero'
      if data.nls eq data.nl then wmessage,'No more conductors can be saved' $
        else begin
        nc = ok(nok-1)
        data.consav(data.nls) = nc
        data.nls = data.nls+1
        wset, info.draw(2)
        plots,data.x(data.loc(nc-1):data.loc(nc)-1), $
          data.y(data.loc(nc-1):data.loc(nc)-1),psym =-8,thick =2,col=4
      endelse
      widget_control, stat, /destroy
      widget_control, info.base, sensitive = 1
      handle_value, info.data, data, /no_copy, /set
      widget_control, tlb, set_uvalue = info, /no_copy
      return
      end
      
  pro outline_draw, event
      common outline_draw_status, stat, ratio
      widget_control, event.top, get_uvalue = tlb
      b = size(tlb)
      if b(b(0)+1) eq 8 then tlb = event.top
      if ((stat gt 4) and (event.press gt 0)) then begin
        outline_cond_save, event, tlb
        stat = 0
      endif else if ((stat eq 0) and (event.press gt  0)) then begin
        coord = convert_coord(event.x, event.y, /device, /to_data)
        widget_control, tlb, get_uvalue = info, /no_copy
        handle_value, info.data, data, /no_copy
        wset, info.draw(2)
        if data.np gt data.npn then get_new_outline_pt,data,coord,ratio else $
          winformation, ['No more points may be','added to the insert outline']
        if event.press eq 4 then begin
          stat = 2
          widget_control, info.draw(1), draw_motion_events=1
        endif 
        handle_value, info.data, data, /no_copy, /set
        widget_control, tlb, set_uvalue = info, /no_copy
      endif else if ((stat eq 2)and(event.release eq 4))then begin
        stat = 0
        widget_control, tlb, get_uvalue = info, /no_copy
        widget_control, info.draw(1), draw_motion_events=0
        widget_control, tlb, set_uvalue = info, /no_copy
      endif else if stat eq 2 then begin
        coord = convert_coord(event.x, event.y, /device, /to_data)
        widget_control, tlb, get_uvalue = info, /no_copy
        handle_value, info.data, data, /no_copy
        wset, info.draw(2)
        if data.np gt data.npn then get_new_outline_pt, data, coord,ratio else $
          winformation, 'No more points may be added to the insert outline'
        handle_value, info.data, data, /no_copy, /set
        widget_control, tlb, set_uvalue = info, /no_copy
      endif
      return
      end

  pro get_new_outline_pt, data, coord, ratio
      dist = (data.x-coord(0))^2 +ratio *(data.y-coord(1))^2
      junk = min(dist, j)
      if data.npn gt data.locout(data.nout-1)  then begin
        k = data.ind(data.npn-1)
        if j eq k then return
        junk = (data.x(j)-data.x(k))^2 + $
          ratio*(data.y(j)-data.y(k))^2
        if junk gt data.err then begin
          data.ind(data.npn) = j
          data.npn = data.npn+1
          plots, data.x(data.ind(data.npn-2:data.npn-1)), $
          data.y(data.ind(data.npn-2:data.npn-1)),psym=(-8),col=4,thick=2
        endif
      endif else begin
        data.ind(data.npn) = j
        data.npn = data.npn+1
        plots, data.x(j), data.y(j), psym = 8, col = 4
      endelse
      return
      end
        
  pro outline_resize, event
      widget_control, event.top, get_uvalue = uval
      widget_control, uval, get_uvalue = info, /no_copy
      widget_control, info.draw(1), draw_xsize = event.x, draw_ysize= event.y
      handle_value, info.data, data, /no_copy
      data.xsize = event.x
      data.ysize = event.y
      widget_control, info.draw(0),tlb_get_offset= offset
      data.xoff2 = offset(0)
      data.yoff2 = offset(1)
      wset, info.draw(2)
      plot_outline_data, data
      handle_value, info.data, data, /no_copy, /set
      widget_control, uval, set_uvalue = info, /no_copy
      return
      end

  pro outline_done, event
      widget_control, event.top, get_uvalue = info, /no_copy
      widget_control, event.id, get_uvalue = uval, /no_copy
      handle_value, info.data, data, /no_copy
      widget_control, event.top, tlb_get_offset= offset
      data.xoff1 = offset(0)
      data.yoff1 = offset(1)
      exists = widget_info(info.draw(0), /valid_id)
      if exists ne 0 then begin
        widget_control, info.draw(0), tlb_get_offset= offset
        data.xoff2 = offset(0)
        data.yoff2 = offset(1)
      endif
      if uval eq 'SKIP' then data.lcq = 1
      handle_value, info.data, data, /set, /no_copy
      widget_control, event.top, /destroy
      return
      end

  pro outline_redraw, event
      widget_control, event.top, get_uvalue = info, /no_copy
      handle_value, info.data, data, /no_copy
      exists = widget_info(info.draw(0), /valid_id)
      if exists eq 0 then begin
        info.draw= $
        make_outline(event.top, xsize=data.xsize, ysize = data.ysize, $
        xoff= data.xoff2, yoff = data.yoff2, data)
      endif
      wset, info.draw(2)
      plot_outline_data, data
      handle_value, info.data, data, /no_copy, /set
      widget_control, event.top, set_uvalue = info, /no_copy
      return
      end

  pro plot_outline_data, data
      plot, data.x, data.y, psym = 8, xran =data.xran, yran= data.yran, $
        /xst, /yst
      for i = 0, data.nl-2 do $
        oplot, data.x(data.loc(i):data.loc(i+1)-1), $
          data.y(data.loc(i):data.loc(i+1)-1), linestyle=1
      if data.npn gt 0 then begin
        data.locout(data.nout)= data.npn
        for i = 0, data.nout-1 do begin
          xl = data.locout(i)
          xu = data.locout(i+1)-1
          plots, data.x(data.ind(xl:xu)), data.y(data.ind(xl:xu)), $
            psym=(-8),col=4, thick = 2
        endfor
        data.locout(data.nout)= 0
      endif
      if data.nls gt 0 then begin
        for i = 0, data.nls-1 do begin
          j = data.loc(data.consav(i)-1)
          k = data.loc(data.consav(i))-1
          oplot, data.x(j:k), data.y(j:k), psym=(-8),col=4, thick = 2
        endfor
      endif
      return
      end

  pro outline_newcon, event
      widget_control, event.top, get_uvalue = info, /no_copy
      handle_value, info.data, data, /no_copy
      nel = n_elements(data.locout)
      if data.locout(data.nout-1) lt data.npn then begin
        if data.nout+1 eq nel then $
          print, 'Cannot have more outlines than initial input' $
        else begin
          data.locout(data.nout) = data.npn
          data.nout = data.nout+1
        endelse
      endif
      handle_value, /set, info.data, data, /no_copy
      widget_control, event.top, set_uvalue = info, /no_copy
      end

  pro outline_delete, event
      widget_control, event.top, get_uvalue = info, /no_copy
      handle_value, info.data, data, /no_copy
      widget_control, event.id, get_uvalue = uval
      if ((uval eq 'DELETE') and (data.npn gt 0)) then begin
        data.npn = data.npn-1
        if data.npn eq data.locout(data.nout-1) then $
          data.nout = data.nout-1
      endif
      widok = widget_info(info.draw(0), /valid_id)
      if widok eq 0 then info.draw = make_outline(event.top,data, $
        xsize = data.xsize , ysize = data.ysize, $
          xoff = data.xoff2, yoff = data.yoff2)
      wset, info.draw(2) 
      plot_outline_data, data
      handle_value, /set, info.data, data, /no_copy     
      widget_control, event.top, set_uvalue = info, /no_copy
      end

  pro outline_ins, x, y, np, loc, lcquit, group = group, modal= modal
;  designed to generate an outline for insert data
on_error, 1
  common outline_comm, xoff1, yoff1, xoff2, yoff2, xsiz, ysiz
      xran = min(x, max = mm)
      del = (mm -xran)*0.03
      xran = [xran-del, mm+del]
      yran = min(y, max = mm)
      del = (mm -yran)*0.03
      yran = [yran-del, mm+del]
      mkcircle
      loadxyct
  if n_elements(xoff1) eq 0 then xoff1 = 10
  if n_elements(yoff1) eq 0 then yoff1 = 20
  if n_elements(xoff2) eq 0 then xoff2 = 20
  if n_elements(yoff2) eq 0 then yoff2 = 200
  oldwin = 0
  if !d.window lt 0 then window, oldwin else oldwin = !d.window
  if keyword_set(modal) then begin
    if n_elements(xsiz) eq 0 then xsiz = !d.x_size
    if n_elements(ysiz) eq 0 then ysiz = !d.y_size
  endif else begin
    if n_elements(xsiz) eq 0 then xsiz = 600
    if n_elements(ysiz) eq 0 then ysiz = 500
  endelse 
  menubase = widget_base(Title = 'Outline Object', /column, $
       xoffset = xoff1, yoffset = yoff1)
  txt1 = widget_label( menubase, /align_left, value= $
    'Hit DELETE to delete points from the outline data')
  txt5 = widget_label( menubase, /align_left, value= $
    'Hit REDRAW to redraw the outline data')
  txt6 = widget_label( menubase, /align_left, value= $
    'Hit NEW to make a new the outline conductor')
  txt2 = widget_label(menubase, /align_left, value= $
    'Hit KEEP to keep selected conductor data')
  txt2 = widget_label(menubase, /align_left, value= $
    'Hit SKIP to keep original data')
  txt3 = widget_label(menubase, /align_left, value= $
    'Hit LEFT mouse button to add points to the outline')
  txt1 = widget_label(menubase, /align_left, value= $
    'Hit RIGHT mouse button for continuous add start/stop')
  butbase = widget_base(menubase, /row, frame = 2)
  delbut = widget_button(butbase, value = 'DELETE POINT', $
           event_pro ='outline_delete', uvalue = 'DELETE')
  rdrawbut = widget_button(butbase, value = 'REDRAW PLOT', $
           event_pro ='outline_redraw', uvalue='REDRAW')
  newbut = widget_button(butbase, value = 'NEW CONDUCTOR', $
           event_pro ='outline_newcon', uvalue='NEW')
  keepbut = widget_button(butbase, value = 'KEEP Conductor', $
           event_pro ='outline_keep', uvalue='KEEP')
  skipbut = widget_button(butbase, value = 'SKIP OUTLINE', $
           event_pro ='outline_done', uvalue = 'SKIP')
  donbut = widget_button(butbase, value = 'DONE - EXIT', $
           event_pro ='outline_done', uvalue = 'EXIT')
   
  ind = make_array(np, /long)
  nl = n_elements(loc)
  nls = 0
  consav = make_array(nl, /long)
  locout = make_array(nl, /long, value=0L)
  nout = 1
  err = 0.10e-4*(xran(1)-xran(0))^2
;
;  x, y, np, loc are the input data
;  consav is an array of saved input conductors
;  npn is the number of new points
;  nls is the number of save conductors
;  locout is a pointer array (loc array) for the outline data
;  nout is the number of output outline arrays
;
  data = {x:x, y:y, np:np, ind:ind, npn:0L, loc:loc, consav:consav, nl:nl, $
   nls:nls, lcq:0, locout:locout, nout:nout, $
   xoff1:xoff1, xoff2:xoff2 , yoff1:yoff1, yoff2:yoff2, $
   xsize:xsiz, ysize:ysiz, xran:xran, yran:yran, err:err}
  draw = make_outline(menubase,data, modal= modal)
  if not keyword_set(modal) then $
    widget_control, menubase, /realize, xoffset = xoff1, yoffset = yoff1
  
  wset, draw(2)
  widget_control, menubase, tlb_get_offset= offset
  xframe = offset(0)-xoff1
  yframe = offset(1)-yoff1

  plot, x, y, psym = 8, xran = xran, yran= yran, /xst, /yst
  for i = 0, nl-2 do $
      oplot, x(loc(i):(loc(i+1)-1)), y(loc(i):(loc(i+1)-1)), linestyle=1
  datastr = handle_create(value = data, /no_copy)
  info = {base:butbase, draw:draw, data:datastr}
  widget_control, menubase, set_uvalue = info, /no_copy
  xmanager, 'outline_ins', menubase, group = group, modal = modal

  handle_value, datastr, data, /no_copy
  handle_free, datastr
  xoff1 = (data.xoff1 -xframe) > 0
  yoff1 = (data.yoff1 -yframe) > 0
  xoff2 = (data.xoff2 -xframe) > 0
  yoff2 = (data.yoff2 -yframe) > 0
  xsiz = data.xsize
  ysiz = data.ysize
  wset, oldwin

  lcquit = data.lcq
  if data.lcq eq 0 then begin
    if data.nls gt 0 then begin
      np = data.npn
      xx= data.x(data.ind(0:np-1))
      yy= data.y(data.ind(0:np-1))
      data.locout(data.nout) = np
      loc = data.locout(0:data.nout)
      nloc = data.nout
      for i = 0, data.nls-1 do begin
        nl = data.loc(data.consav(i)-1)
        nu = data.loc(data.consav(i))-1
        xx =[xx, data.x(nl:nu)]
        yy =[yy, data.y(nl:nu)]
;       yy =[yy, data.y(data.loc(data.consav(i)-1):data.loc(data.consav(i))-1)]
;       xx =[xx, data.x(data.loc(data.consav(i)-1):data.loc(data.consav(i))-1)]
        loc=[loc,loc(nloc+i)+ $
          data.loc(data.consav(i))-data.loc(data.consav(i)-1)]
      endfor
      x = temporary(xx)
      y = temporary(yy)
      np = loc(data.nls+1)
    endif else begin
      np = data.npn
      if np gt 0 then begin
        x= data.x(data.ind(0:np-1))
        y= data.y(data.ind(0:np-1))
        data.locout(data.nout) = np
        loc = data.locout(0:data.nout)
      endif else print, ' No data returned'
    endelse
  endif
  end
