; ------------------------------------------------------------------------ 
; $Id: qs_add_pnts.pro,v 1.3 2007/06/06 20:12:42 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro qs_add_pnts, axis, xx, dxx, mesh, ier, ncells= ncells, soft=soft
; 
; add grid points
;
@pfidltq.com
;
      ier = 0
      np = n_elements(xx)
      if np eq 0 then begin
        ier = 1
        return
      endif
      if n_elements(dxx) ne np then dxx = make_array(np, value = dxx(0))
      if n_elements(mesh) ne np then mesh = make_array(np, value = mesh(0))
      if n_elements(ncells) eq 0  then ncells =0
      if ncells gt 0 then dxx = 0*dxx else begin
        if min(dxx) le 0 then begin
          print, 'Cannot add these points- dxx le 0.0'
          ier = 2
          return
        endif
      endelse
      if axis eq 0 then begin
        xin = x
        dxin = dx
        xgridtypein = xgridtype
        for i =0, np-1 do begin
          if ier eq 0 then begin
            dist = (x-xx(i))^2 - 4.0*dx*dx
            ok = where(dist ge 0.0, nok)
            if nok gt 0 then begin
              x = x(ok)
              dx = dx(ok)
              xgridtype = xgridtype(ok)
            endif else ier = 1
          endif
        endfor
        if ier eq 1 then begin
          if np ge 2 then begin
            x = double(xx)
            dx = double(dxx)
            xgridtype  = mesh
            ier = 0
            j = sort(x)
            oksoft = indgen(n_elements(x))
          endif else begin
            print, 'Cannot add these points'
            x = xin
            dx = dxin
            xgridtype = xgridtypein
          endelse
        endif else begin
          nel = n_elements(x)
          x = [x, xx]
          dx = [dx, dxx]

          xgridtype = [xgridtype, mesh]
          j = sort(x)
          oksoft = where(j ge nel)
        endelse
        xin = 0
        dxin = 0
        xgridtypein = 0
        if ier ne 0 then return
        x = x(j)
        dx = dx(j)
        xgridtype = xgridtype(j)
        nel = n_elements(x)
        dxx = x(1:nel-1)-x(0:nel-2)
        dxx = [dxx(0), dxx]
        if ncells gt 0 then begin
          ok = where(dx eq 0.0, nok)
          if nok gt 0 then begin
            dx(ok) =dxx(ok)/ncells
          endif
        endif
        adx = abs(dx) 
        adx = adx(0:nel-2)+adx(1:nel-1)
        ok = where (adx*0.82 gt dxx(1:nel-1),nok)
        if nok gt 0 then begin
          for i =  nok-1, 0, -1 do begin
            junk = where (ok(i) eq oksoft, n)
            if n gt 0 then qs_del_pnts, axis, x(ok(i)+1) $
            else qs_del_pnts, axis, x(ok(i))
          endfor
        endif

        if soft eq 0 then dx(oksoft) = -dx(oksoft)
      endif else begin
        xin = y
        dxin = dy
        xgridtypein = ygridtype
        for i =0, np-1 do begin
          if ier eq 0 then begin
            dist = (y-xx(i))^2 - 4.0*dy*dy
            ok = where(dist ge 0.0, nok)
            if nok gt 0 then begin
              y = y(ok)
              dy = dy(ok)
              ygridtype = ygridtype(ok)
            endif else ier = 1
          endif
        endfor
        if ier eq 1 then begin
          if np ge 2 then begin
            y = double(xx)
            dy = double(dxx)
            ygridtype  = mesh
            ier = 0
            j = sort(y)
            oksoft = indgen(n_elements(y))
          endif else begin
            print, 'Cannot add these points'
            y = xin
            dy = dxin
            ygridtype = xgridtypein
          endelse
        endif else begin
          nel = n_elements(y)
          y = [y, xx]
          dy = [dy, dxx]
          ygridtype = [ygridtype, mesh]
          j = sort(y)
          oksoft = where(j ge nel)
        endelse
        xin = 0
        dxin = 0
        xgridtypein = 0
        if ier ne 0 then return
        y = y(j)
        dy = dy(j)
        ygridtype = ygridtype(j)
        nel = n_elements(y)
        dxx = y(1:nel-1)-y(0:nel-2)
        dxx = [dxx(0), dxx]
        if ncells gt 0 then begin
          ok = where(dy eq 0.0, nok)
          if nok gt 0 then begin
            dy(ok) =dxx(ok)/ncells
          endif
        endif
        if soft eq 0 then dy(oksoft) = -dy(oksoft)
        adx = abs(dy)
        adx = adx(0:nel-2)+adx(1:nel-1)
        ok = where (adx*0.82 gt dxx(1:nel-1),nok)
        if nok gt 0 then begin
          for i =  nok-1, 0, -1 do begin
            junk = where (ok(i) eq oksoft, n)
            if n gt 0 then qs_del_pnts, axis, y(ok(i)+1) $
            else qs_del_pnts, axis, y(ok(i))
          endfor
        endif
      endelse
      return
      end

