; ------------------------------------------------------------------------ 
; $Id: refine_rpos.pro,v 1.3 2007/06/06 20:12:42 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 function refine_rpos, rin, dist, d0, n
;
 r = rin
 rnew = (1.0d0 +dist/d0*alog(r))^(1.0d0/n)
 ea = d0/alog(r)*(r^n-1.0d0) -dist
 if abs(r-rnew) lt 1.0e-7 then begin
   if ea lt 1e-7*dist then return, r
   if ea gt 0 and r lt 1.0d0 then rnew = r + 5.0d-7 else rnew = r-5.0d-7
 endif
 eb = d0/alog(rnew)*(rnew^n-1.0d0) -dist
 error = 1
 ii = 0
 while error  gt 2.0e-7*dist and ii lt 40 do begin
   eb = d0/alog(rnew)*(rnew^n-1.0d0) -dist
   error = ea*(r-rnew)/(eb-ea)
   rn = error +r
   error = abs(error)
   if abs(ea) gt abs(eb) then begin
     r = rnew
     ea = eb 
   endif
   ii = ii+1
   rnew = rn
 endwhile
 if ii gt 39 then print, ii, 'Convergence problem'
 return, rnew
 end
