; ------------------------------------------------------------------------ 
; $Id: rm_dupes.pro,v 1.3 2007/06/06 20:12:42 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro rm_dupes, x, y, loc
; remove duplicate values
; criteria is dx/xrange and dy/yrange less than 1.5e-5
; eliminate single points
;
 on_error, 1
    if n_elements(x) lt 2 or n_elements(y) lt 2 or n_elements(loc) lt 2 $
      then begin
      print , 'Three arrays must be sent to RM_DUPES'
      return
    endif
    xrange = max(x, min= mm)-mm
    yrange = max(y, min= mm)-mm
    n = n_elements(loc)-1
    xtemp = x
    ytemp = y
    ltemp = loc
    dxt = abs(x(1:loc(n)-1) - x(0:loc(n)-2))
    dyt = abs(y(1:loc(n)-1) - y(0:loc(n)-2))
    errx = 1.5e-5* xrange
    erry = 1.5e-5* yrange
    nn = 0
    for i = 1, n do begin
      if (ltemp(i)- ltemp(i-1) gt 1) then begin
        ok = where(dxt(ltemp(i-1):ltemp(i)-2) gt errx or $
          dyt(ltemp(i-1):ltemp(i)-2) gt erry, nok) 
        if nok gt 0 then begin
          nn = nn+1
          loc(nn) = nok+1 +loc(nn-1)
          x(loc(nn-1):loc(nn)-1) = [xtemp(ltemp(i-1)), $
                 xtemp(ltemp(i-1)+1+ok)] 
          y(loc(nn-1):loc(nn)-1) = [ytemp(ltemp(i-1)), $
                 ytemp(ltemp(i-1)+1+ok)] 
        endif
      endif
    endfor
    loc = loc(0:nn)
    if nn gt 0 then begin
      x = x(0:loc(nn)-1)
      y = y(0:loc(nn)-1)
    endif else begin
      x = 0.0
      y = 0.0
    endelse
    return
    end
