; ------------------------------------------------------------------------ 
; $Id: tqjoin_cond.pro,v 1.3 2007/06/06 20:12:42 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro tqjoin_cond, i, j
; join conductors
;
@pfidltq.com
@tqeditevent.com
;
      i = min([i, j], max = j)
      old_cond = cond
      xx = cond.x
      yy = cond.y
      loc = cond.locx
; help, i, j
      x1 = xx(loc(i-1):loc(i)-1)
      y1 = yy(loc(i-1):loc(i)-1)
      x2 = xx(loc(j-1):loc(j)-1)
      y2 = yy(loc(j-1):loc(j)-1)
      n1 = n_elements(x1)
      n2 = n_elements(x2)
      a = (x1(0)-x2(0))^2 + (y1(0)-y2(0))^2
      b = (x1(n1-1)-x2(0))^2 + (y1(n1-1)-y2(0))^2
      c = (x1(0)-x2(n2-1))^2 + (y1(0)-y2(n2-1))^2
      d = (x1(n1-1)-x2(n2-1))^2 + (y1(n1-1)-y2(n2-1))^2
      m = min([a,b,c,d], k)
      if k eq 0 then begin
        e = rotate(x1, 2)
        f = rotate(y1, 2)
        g = x2
        h = y2
      endif else if k eq 1 then begin
        e = x1
        f = y1
        g = x2
        h = y2
      endif else if k eq 2 then begin
        e = x2
        f = y2
        g = x1
        h = y1
      endif else if k eq 3 then begin
        e = x1
        f = y1
        g = rotate(x2, 2)
        h = rotate(y2, 2)
      endif
      ncon= cond.ncon
      join2pack, e, g, f, h, i,ncon, loc,  xx, yy
        lcfit = cond.lcfit
        ix = cond.ix
        iy = cond.iy
        loci = cond.loci
        locp = cond.locp
        ipx = cond.iplotx
        ipy = cond.iploty
        nbad = cond.nbad
        badxy = cond.badxy
        locb  = cond.locb
        ixx = 0
        iyy = 0
        if n_elements (lcfit) lt ncon + 1 then $
          lcfit = make_array(ncon+1, /int, value = lcfit(0))
        if n_elements (nbad) lt ncon + 1 then $
          nbad = make_array(ncon+1, /int, value = nbad(0))

            array2pack, j, ncon, loc, 0, xx, ixx, yy, iyy
            ncon= ncon+1
            array2pack, j, ncon, loci, 0, ix, ixx, iy, iyy
            ncon= ncon+1
            array2pack, j, ncon, locp, 0, ipx, ixx, ipy, iyy
            ncon= ncon+1
            array1pack, j, ncon, locb, 0, badxy, ixx
            if j le ncon then begin
              lcfit = [lcfit(0:j-1), lcfit(j+1:*)]
              nbad = [nbad(0:j-1), nbad(j+1:*)]
            endif else begin
              nbad = nbad(0:ncon)
              lcfit = lcfit(0:ncon)
            endelse

        if ncon gt 0 then begin
          ok = where (lcfit(1:*) gt 0, nok)
          if nok eq ncon then lcfit (0) = 1 else lcfit(0) = 0
          nbad(0) = total(nbad(1:*))
        endif
        cond = {ncon:ncon, lcfit:lcfit, x:xx, y:yy, locx:loc, $
             ix:ix, iy:iy, loci:loci, iplotx:ipx, iploty:ipy, locp:locp, $
             badxy:badxy, locb:locb, nbad:nbad }
 
      return
      end
