; ------------------------------------------------------------------------ 
; $Id: tqprint.pro,v 1.4 2007/06/06 20:12:42 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro  tqprint, unit, group= group, modal = modal
;+
; print tq common block to a file for TQ input
; format;
;     tqprint, unit
;        where unit is the logical unit 
;-
@pfidltq.com
;
;     common pfidltq, x, dx, y, dy, gx, gy, gdx, gdy, mult, x1grid, x2grid, $
;        cond, markx, marky, markerstring, lcfit
;
  if n_elements(unit) eq 0 then message, $
   ' Unit for print must be defined'
  nx= n_elements(x1grid)
  ny= n_elements(x2grid)
;
 if nx eq 0 or ny eq 0 then print, ' Data is incomplete. Redo Grids', nx, ny
  if nx gt 0 then for i = 0, nx-1 do printf, unit, x1grid(i)
  if ny gt 0 then for i = 0, ny-1 do printf, unit, x2grid(i)
  nx = n_elements (gx)
  ny = n_elements (gy)
  if nx gt 0 and ny gt 0 then begin
    mdx = min(gdx, i)
    mdy = min(gdy, j) 
    if mdx gt 0 and mdy gt 0 then $
    TEMP = ' Maximum time step is ' + string ( $ 
      sqrt(1./(1./mdx/mdx + 1./mdy/mdy))*mult/2.9979246e8) else temp = 0.0
    print, temp
    printf, unit,'# ', temp
    temp = ' This occurs at the location (' + strtrim((gx(i)+gx(i+1))*0.5, 2) $
    + ', ' + strtrim( (gy(j)+gy(j+1))*0.5, 2) +')'
    print, temp
    printf, unit, '# ', temp
  end
  ncon = cond.ncon
  if cond.lcfit(0) eq 0 then begin
    print, 'Conductors must be fit to the grid before writing'
    return
  endif
  for i = 1, ncon do begin
    ix = cond.ix(cond.loci(i-1):cond.loci(i)-1)
    iy = cond.iy(cond.loci(i-1):cond.loci(i)-1)
    nc= n_elements (ix)
    if nc gt 0 then begin
;     cx = cond.x(cond.locx(i-1):cond.locx(i)-1)
;     cy = cond.y(cond.locx(i-1): cond.locx(i)-1)
      cx = gx(ix)
      cy = gy(iy)
      conductor = 'cond'+ strtrim(i, 2)
      get_tqcond_info, cx, cy, lc, conductor, normal, offset , group = group, $
          modal = modal
      if lc eq 0 then begin
        con = [ix, iy]+2
        con = reform (temporary(con), nc, 2)
        con = transpose(temporary(con))
        printf, unit, ' conductor '+strtrim(conductor,2)+'  '+strtrim(normal,2)+'  &'
        printf, unit, con,  format ='( 5(i8, i5, :),''   &'')'
      endif
    endif
  endfor
  if n_elements (markx) gt 0 then begin
    if markx(0) ge 0 then begin
      ns = n_elements(markerstring)
      for i = 0, ns-1 do printf, unit, markerstring(i)
    endif
  endif
  end
