; ------------------------------------------------------------------------ 
; $Id: add_mitlpnts.pro,v 1.4 2010/09/03 15:27:53 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro add_mitlpnts, nel, x, zv, zf, fit, zfcon, zfdwn, lcemit, nofill = nofill
;
@mitl_common.com
;
;
    if lcexpert eq 0 then begin
      if (min(zv(0:nel-1)) le 0.0) then begin
        print, ' Vacuum impedance must be greater than zero '
        return
      endif
    endif else begin
      if (min(zv(0:nel-1)) le 0.0) or (min(zf(0:nel-1)) le 0.0) then begin
        print, ' All parameters must be greater than zero '
        return
      endif
    endelse
    if n_elements(zfcon) eq 0 then zfcon = make_array(nel, value = 0.0)
    if n_elements(zfdwn) eq 0 then zfdwn = make_array(nel, value = 0.0)
    if n_elements(lcemit) eq 0 then lcemit=make_array(nel, value = lcflow)
    if str.np gt 0 then begin
      x = [str.x, x(0:nel-1)]
      zv = [str.zv, zv(0:nel-1)]
      zf = [str.zf, zf(0:nel-1)]
      fit = [str.fit, fit(0:nel-1)]
      zfcon = [str.zfcon, zfcon(0:nel-1)]
      zfdwn = [str.zfdwn, zfdwn(0:nel-1)]
      lcemit = [str.lcemit, lcemit(0:nel-1)]
      nel = nel+str.np
    endif
    if nel gt 1 then begin
      dx = x(1:nel-1)-x(0:nel-2)
      if min(dx) lt 0 then begin
        ok = sort(x)
        x= x(ok)
        zv = zv(ok)
        zf = zf(ok)
        fit = fit(ok)
        zfcon = zfcon(ok)
        zfdwn = zfdwn(ok)
        lcemit = lcemit(ok)
        dx = x(1:nel-1)-x(0:nel-2)
      endif
      bot = max(abs(x))
      list = where (dx/bot lt 1.0e-5, ind)
      if ind gt 0 then begin
        np = list
        if ind gt 1 then begin
;         use ni to count the number of intervals of zero derivative
;         use nl to count the number of points with the same ordinate value
;         use nst to mark the first point to in the series of nl points
          nl = 2L
          ni = 0L
          nst = list[0]
          for i = 1L, ind-1 do begin
            if (list[i-1]+1 eq list[i]) then nl = nl+1 else begin
              list[ni] = nst
              np [ni] = nl
              nst = list[i]
              nl = 2L
              ni = ni+1
            endelse
          endfor
          list[ni] = nst
          np(ni) = nl
          ni = ni+1
        endif else begin
          ni = 1L
          np(0) = 2L
        endelse
        nelim = 0
        for i = 0L, ni-1 do begin
          ind = list[i] - nelim
          x(ind) = total(x(ind+indgen(np(i))))/ float(np(i))
          zv(ind) = total(zv(ind+indgen(np(i))))/ float(np(i))
          zf(ind) = total(zf(ind+indgen(np(i))))/ float(np(i))
          fit(ind) = total(fit(ind+indgen(np(i))))/ float(np(i))
          zfcon(ind) = total(zfcon(ind+indgen(np(i))))/ float(np(i))
          zfdwn(ind) = total(zfdwn(ind+indgen(np(i))))/ float(np(i))
          lcemit(ind) = total(lcemit(ind+indgen(np(i))))/ float(np(i))
;         Move the arrays down if we are not at the end of the array
          if list[i]+np(i) lt nel then begin
            x(ind+1:nel-nelim-np(i)) = x (ind+np(i):nel-nelim-1)
            zv(ind+1:nel-nelim-np(i)) = zv (ind+np(i):nel-nelim-1)
            zf(ind+1:nel-nelim-np(i)) = zf (ind+np(i):nel-nelim-1)
            fit(ind+1:nel-nelim-np(i)) = fit(ind+np(i):nel-nelim-1)
            zfcon(ind+1:nel-nelim-np(i)) = zfcon (ind+np(i):nel-nelim-1)
            zfdwn(ind+1:nel-nelim-np(i)) = zfdwn (ind+np(i):nel-nelim-1)
            lcemit(ind+1:nel-nelim-np(i)) =lcemit(ind+np(i):nel-nelim-1)
          endif
          nelim = nelim -1 +np[i]
        endfor
        nel = nel - nelim
      endif
    endif
    str = {np: nel, x:x, zv:zv , zf:zf, fit:fit, zfcon:zfcon, zfdwn:zfdwn, $
          lcemit:lcemit, npos:0L }
    if str.np gt 1 then if not keyword_set (nofill) then fillmitlstr
    return
    end
