; ------------------------------------------------------------------------ 
; $Id: edit_curve.pro,v 1.4 2007/06/06 19:34:26 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
Pro edit_curve, x, y, np, xover = xover, yover= yover, $
    xsize = xsizein, ysize= ysizein, modal = modal, _extra = extra_stuff
 COMPILE_OPT hidden

   common ceditcurve, xx, yy, npxy, xov, yov, nover, xran, yran
   if n_elements (np) lt 1 then np = n_elements(y)
   if n_elements (np) ne 1 then begin
     print, ' Number of points is undefined - returning'
     return
   endif
   if np lt 2 then begin
     print, ' Number of points is less than two - returning'
     return
   endif
   if n_elements(x) lt np or n_elements(y) lt np then begin
     print, ' Number of points in the x and y arrays are less than NP'
     return
   endif
   npxy  = np
   xx = make_array(np+50)
   yy = xx
   xx(0:np-1) = x(0:np-1)
   yy(0:np-1) = y(0:np-1)
   if n_elements (xover) gt 0 and n_elements (yover) gt 0 then begin
     nover = min ([n_elements(xover), n_elements (yover)])
     xov = xover(0:nover-1)
     yov = yover(0:nover-1)
   endif else nover = 0
   wdigit_edit, modal = modal, xsize = xsizein, ysize= ysizein, $
          _extra = extra_stuff
   np = npxy
   x = xx(0:np-1)
   y = yy(0:np-1)
   return
   end
