; ------------------------------------------------------------------------ 
; $Id: f23.pro,v 1.2 2007/06/06 19:34:26 lpmix Exp $
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;

function f23, n_input, five = five
;+
;
; Determine the number greater than n that has only factors of 2 or 3
;  or with a keyword, the factors 2, 3, and 5
;
;-

on_error, 1
;
max_factor = keyword_set(five) ? 5:3
tot=1L
j = factors (n_input)
ok = where (j le max_factor, nok, comp = comp, ncomp= ncomp)
if ncomp eq 0 then return, long(n_input)
while ncomp gt 0 do begin
  if nok gt 0 then for i = 0, nok-1 do tot *= j[ok[i]]
  n= j[comp[0]]
  if ncomp gt 1 then for i = 1, ncomp-1 do n *= j[comp[i]]
  n += +1
  j = factors (n)
  ok = where (j le max_factor, nok, comp = comp, ncomp= ncomp)
endwhile
ans = n*tot
repeat begin
  ans1 = ans
  if (ans mod 4) eq 0 then if ans/4*3 ge n_input then ans = ans/4*3
  if (ans mod 9) eq 0 then if ans/9*8 ge n_input then ans = ans/9*8
  if (ans mod 32) eq 0 then if ans/32*27 ge n_input then ans = ans/32*27
  if (ans mod 256) eq 0 then if ans/256*243 ge n_input then ans = ans/256*243
  if (ans mod 2187) eq 0 then if ans/2187*2048 ge n_input then ans = ans/2187*2048
  if (ans mod  531441) eq 0 then if ans/531441*524288 ge n_input then ans = ans/531441*524288

  if (keyword_set(five)) then begin
    if (ans mod 5) eq 0 then if ans/5*4 ge n_input then ans=ans/5*4
    if (ans mod 6) eq 0 then if ans/6*5 ge n_input then ans=ans/6*5
    if (ans mod 16) eq 0 then if ans/16*15 ge n_input then ans=ans/16*15
    if (ans mod 10) eq 0 then if ans/10*9 ge n_input then ans=ans/10*9
    if (ans mod 27) eq 0 then if ans/27*25 ge n_input then ans=ans/27*25
    if (ans mod 25) eq 0 then if ans/25*24 ge n_input then ans=ans/25*24
    if (ans mod 81) eq 0 then if ans/81*80 ge n_input then ans=ans/81*80
    if (ans mod 125) eq 0 then if ans/125*64 ge n_input then ans=ans/125*64
    if (ans mod 128) eq 0 then if ans/128*125 ge n_input then ans=ans/128*125
    if (ans mod 135) eq 0 then if ans/135*128 ge n_input then ans=ans/135*128
    if (ans mod 250) eq 0 then if ans/250*243 ge n_input then ans=ans/250*243
    if (ans mod 2048) eq 0 then if ans/2048*2025 ge n_input then ans=ans/2048*2025
    if (ans mod 3125) eq 0 then if ans/3125*3072 ge n_input then ans=ans/3125*3072
    if (ans mod 15625) eq 0 then if ans/15625*15552 ge n_input then ans=ans/15625*15552
    if (ans mod 16875) eq 0 then if ans/16875*16384 ge n_input then ans=ans/16875*16384
    if (ans mod 20000) eq 0 then if ans/20000*19683 ge n_input then ans=ans/20000*19683
    if (ans mod 32805) eq 0 then if ans/32805*32768 ge n_input then ans=ans/32805*32768
    if (ans mod 46875) eq 0 then if ans/46875*46656 ge n_input then ans=ans/46875*46656
    if (ans mod 78732) eq 0 then if ans/78732*78125 ge n_input then ans=ans/78732*78125
    if (ans mod 393216) eq 0 then if ans/393216*390625 ge n_input then ans=ans/393216*390625
  endif
endrep until ans1 eq ans
return, ans
end
