; ------------------------------------------------------------------------ 
; $Id: fill_poly_arrays.pro,v 1.3 2007/06/06 19:34:26 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;

 function fill_poly_arrays, x, y, xx, yy

;+
; generates a connectivity array for a polygon object from a rectilinear 
; dataset with x and y values.  These values are converted to a linear array
; of x and y (xx and yy) which can be used with the field to generate a 
; polygon object
;-
on_error,2

 nx =  n_elements (x)
 ny =  n_elements (y)

 nxm = nx-1
 nym = ny-1
 row =[0L, 1L, nx+1, nx]
 npoly = nxm*nym

 xx = x # replicate(1.0, ny) 
 yy = replicate(1., nx) # y
 t2 = systime(1)
 con = lonarr(5,nxm, nym)
 con [0,*,*] = 4L

 for i = 0, nxm-1 do con[1: 4, i, 0] = i+row
 arr= reform( con[1:4, 0:nxm-1, 0], /over)
 for j = 1, nym-1 do con[1:4, 0:nxm-1, j] = arr + j*nx

 con = reform(con, 5*npoly, /overwrite)

return, con
end
