; ------------------------------------------------------------------------ 
; $Id: find_background.pro,v 1.3 2007/06/06 19:34:27 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 function find_background, image, nelem, dim = ok


;
; find pixels in an image with background colors.
;
on_error, 1
if size( /type, image) ne 1 then begin
  Print, '% FIND_BACKGROUD: Image must be a byte array.
  return , 0
endif

a = size(image, /dimensions)
if n_elements(a) eq 2 then begin
; pseudo color
  return, where (image eq !p.background, nelem)
endif

if n_elements(a) gt 3 then begin
  Print, '% FIND_BACKGROUD: True color image must have 3 dimensions.
  help, image
  return, 0
endif

ok = where (a eq 3, nok)
if  nok gt 1 or nok eq 0 then begin
  Print, '% FIND_BACKGROUD: image must have only one dimension with 3 elements.
  print, '             Dimensions: ', a
  return , 0
endif

ok = ok[0]+1
if ok ne 1 then Winformation, 'Contact Paul Mix, 845-7493, about this '

tvlct, /get, r, g, b
imb = make_array(a, /byte)

if ok eq 1 then begin
  imb [0, *, *] = r[!p.background]
  imb [1, *, *] = g[!p.background]
  imb [2, *, *] = b[!p.background]
endif else if ok eq 2 then begin
  imb [*, 0, *] = r[!p.background]
  imb [*, 1, *] = g[!p.background]
  imb [*, 2, *] = b[!p.background]
endif else begin
  imb [*, *, 0] = r[!p.background]
  imb [*, *, 1] = g[!p.background]
  imb [*, *, 2] = b[!p.background]
endelse
tmp = total (image-imb, ok)
bg = where (tmp eq 0, nelem)

return, bg
end
