pro get_average_uniq_values, y, ydata, float_indx, indw, indy
;
; Y      - Output data with abscissa = UNIQX[INDY]
; YDATA  - Input DATA with abscissa = XDATA
; FLOAT_INDX   - Result of findex of the YDATA coordinates with the Y coordinates
;                FLOAT_INDX = findex(uniqx, xdata)
; INDW   - ROUND(FLOAT_INDEX)
; INDY   - INDIX of Y values
;
;
 on_error,1
 
 indy = indw
 y = Ydata
; only one point
 If n_elements(indw) eq 1 then return

 nok = n_elements(indw)
 dindw = indw[1:nok-1] -indw[0:nok-2]
; sparse data
 if min(dindw) gt 0 then return

; continuous data
; Be sure that averages are not truncated.
 if size(/type, ydata) lt 4 then ydata = float(ydata)

 j = 0
 dind_st = 0
 dind = dind_st
 nokm= nok-1
 repeat begin
   while dind lt nokm && dindw[dind] eq 0 do dind = dind+1
   if dind gt dind_st then $
     y[j] = total(ydata[dind_st:dind])/(dind-dind_st+1) $
     else y[j] = ydata[dind_st]
   indy[j]  = indw[dind_st]
   j += 1
   dind += 1
   dind_st = dind
 endrep until  dind ge nokm
 if dindw[nokm-1] ne 0 then begin
   y[j] = ydata[nokm]
   indy[j] = indw[nokm]
   j = j+1
 endif
 indy = indy[0:j-1]
 y = y[0:j-1]
 end 
