; ------------------------------------------------------------------------ 
; $Id: get_blockorder.pro,v 1.3 2007/06/06 19:34:27 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 function  get_blockorder, range, ndim, mxbl 

;+
;
;  Generates an order to multiple block data
;    order - (ndim, nblock) Ordering of blocks in each dimension by initial 
;            value of the block, in units of block -1
;-
; generate the ordering
;
      if mxbl gt 1 then begin
        order = make_array(ndim, mxbl, /long)
        for i = 0, ndim-1 do order (i, *) = sort(range(0,i, 1:mxbl))
      endif else order = 1L
      return, order
      end
