; ------------------------------------------------------------------------ 
; $Id: get_dxdt.pro,v 1.3 2007/06/06 19:34:27 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
;
;  Tue Jul 12 09:15:48 MDT 1994
;

PRO get_dxdt_event, Event

  WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev
  sol = 0.2997925

  CASE Ev OF 

  'DXMAX': BEGIN
      widget_control, event.top, get_uvalue= info
      widget_control, info.dt, get_value = dt
      ctime = event.value/sol
      if dt ge ctime then begin
        widget_control, info.dt, set_value = 0.75*ctime
        winformation, ['c*Dt/Dx equals '+strtrim(dt/ctime, 2), $
              'Time step reduced to 75% of Maximum']
      endif
      END
  'DTMAX': BEGIN
      widget_control, event.top, get_uvalue= info
      widget_control, info.dx, get_value = dx
      cdist = event.value*sol
      if dx le cdist then begin
        widget_control, info.dx, set_value = cdist/0.75
        winformation, ['c*Dt/Dx equals '+strtrim(cdist/dx, 2), $
              'Spatial step increased to 133% of Minimum']
      endif
      END
  'DTOUT': 

  'TRANGE': 

  'RUN/QUIT': BEGIN
      widget_control, event.top, get_uvalue= info, tlb_get_offset= offset
      CASE Event.value OF
      0: Begin
         widget_control, info.file, get_value = file
         file = strtrim(file(0), 2)
         if strlen(file) gt 0 then begin
           widget_control, info.comment, get_value = comment
           comment = strtrim(comment, 2)
           widget_control, info.dx, get_value = dx
           widget_control, info.dt, get_value = dt
           if sol ge dx/dt then begin
             Winformation,['Reduce the time step or increase the spatial grid',$
                        'Current values are unstable: c*Dt/Dx equals ' $
                     +strtrim(sol*dt/dx, 2)]
           endif else begin
             widget_control, info.outdt, get_value = outdt
             widget_control, info.totalt, get_value = totalt
             if outdt le 0.0 or totalt le 0.0 then begin
               Winformation, ['Output time step and total run time', $
                              'MUST be greater than zero']
             endif else begin
               val = {lcquit:0, file:file, comment:comment, dx:dx, dt:dt, $
                 outdt:outdt, totalt:totalt, offset:offset}
               widget_control, info.ptr, set_uvalue = val
               widget_control, event.top, /destroy
             endelse
           endelse
         endif else Winformation, 'File name must be provided for output'
         END

      1: Begin
         val = {lcquit:1, file:' ', comment:' ', dx:0.0, dt:0.0, $
           outdt:0.0, totalt:0.0, offset:offset}
         widget_control, info.ptr, set_uvalue = val, /no_copy
         widget_control, event.top, /destroy
         End
      ELSE: Message,'Unknown button pressed'
      ENDCASE
      END
  ENDCASE
END


PRO get_dxdt,lcquit, file, comment, dx, dt, outdt, totalt, offset, GROUP=Group


  IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0

  junk   = { CW_PDMENU_S, flags:0, name:'' }


  MAIN13 = WIDGET_BASE(GROUP_LEADER=Group, $
      COLUMN=1,  $
      MAP=1, $
      TITLE='Output File, Grid Size, and Time Step')

  BASE17 = WIDGET_BASE(MAIN13, $
      COLUMN=1, $
      FRAME=4, $
      MAP=1, $
      UVALUE='BASE17')

  LABEL14 = WIDGET_LABEL( BASE17, $
      UVALUE='LABEL14', $
      VALUE='Output File and Comment')

  FieldVal180 = [ $
    '' ]
  FIELD15 = CW_FIELD( BASE17,VALUE=FieldVal180, $
      ROW=1, $
      STRING=1, $
      TITLE='Output File Name:', $
      UVALUE='FIELD15')

  FieldVal182 = [ $
    '' ]
  FIELD16 = CW_FIELD( BASE17,VALUE=FieldVal182, $
      COLUMN=1, $
      STRING=1, $
      TITLE='Run Comment:', $
      UVALUE='FIELD16')


  BASE2 = WIDGET_BASE(MAIN13, $
      COLUMN=1, $
      FRAME=4, $
      MAP=1, $
      UVALUE='BASE2')

  LABEL6 = WIDGET_LABEL( BASE2, $
      UVALUE='LABEL6', $
      VALUE='Calculational Parameters')

  dxmax =get_dxvalue(0.1) 
  if n_elements (dx) gt 0 then dx = dx(0) else dx = dxmax
    if dx le 0 then dx = dxmax
    
  FIELD7 = CW_FIELD( BASE2, VALUE= dx, $
      ROW=1, $
      FLOAT=1, $
      RETURN_EVENTS=1, $
      TITLE='Spatial Zone Width:', $
      UVALUE='DXMAX')

  sol = 0.2997925
  FieldVal126 = 0.75*dxmax/sol
  if n_elements (dt) gt 0 then dt = dt(0) else dt = 0.75*dx/sol
  FIELD8 = CW_FIELD( BASE2, VALUE=dt, $
      ROW=1, $
      FLOAT=1, $
      RETURN_EVENTS=1, $
      TITLE='Time Step (ns):', $
      UVALUE='DTMAX')


  BASE3 = WIDGET_BASE(MAIN13, $
      COLUMN=1, $
      FRAME=4, $
      MAP=1, $
      UVALUE='BASE3')

  LABEL4 = WIDGET_LABEL( BASE3, $
      UVALUE='LABEL4', $
      VALUE='Output Parameters')

  if n_elements ( outdt) gt 0 then outdt= outdt(0) else outdt=0.5

  FIELD9 = CW_FIELD( BASE3, VALUE=outdt, $
      ROW=1, $
      FLOAT=1, $
      TITLE='Output Time Steps (ns):', $
      UVALUE='DTOUT')

  if n_elements(totalt) gt 0 then totalt= totalt(0) else totalt = 100.0

  FIELD10 = CW_FIELD( BASE3, VALUE=totalt, $
      ROW=1, $
      FLOAT=1, $
      TITLE='Total Run Time (ns):', $
      UVALUE='TRANGE')


  BASE21 = WIDGET_BASE(MAIN13, $
      ROW=1, $
      MAP=1, $
      UVALUE='BASE21')

  Btns557 = [ $
    '  Run  ', $
    ' Cancel ' ]
  BGROUP22 = CW_BGROUP( BASE21, Btns557, $
      ROW=1, $
      SPACE=100, $
      UVALUE='RUN/QUIT')

  if n_elements (offset) lt 2  then offset = [10, 10] else $
    offset = (offset(0:1)> 0)
  WIDGET_CONTROL, main13, /REALIZE, tlb_set_xoffset = offset(0), $
       tlb_set_yoffset= offset(1)


  ptr = widget_base()
  val = {lcquit:0, file:' ', comment:' ', dx:dx, dt:dt, $
         outdt:outdt, totalt:totalt, offset:offset}
  info = {ptr:ptr, file:field15, comment:field16, dx:field7, $
         dt:field8, outdt:field9, totalt:field10}
  widget_control, ptr, set_uvalue = val, /no_copy
  widget_control, main13, set_uvalue= info, /no_copy

     widget_control, main13, tlb_get_offset= offset_real
     offset_real = offset  - offset_real

  XMANAGER, 'get_dxdt', MAIN13, /modal
  widget_control, ptr, get_uvalue = val, /no_copy
  widget_control, ptr, /destroy 
  lcquit = val.lcquit
  offset = val.offset  + offset_real
  if lcquit eq 1 then return
  file = val.file
  comment = val.comment
  dx = val.dx
  dt = val.dt
  outdt = val.outdt
  totalt = val.totalt
  return
END
