; ------------------------------------------------------------------------ 
; $Id: get_load.pro,v 1.3 2007/06/06 19:34:28 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
PRO get_load_Event, Event

  on_error, 2

  common get_load_common, pleng, pret, prad, plinitf, plretf
  WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev

  CASE Ev OF 

  'BGROUP6': BEGIN
               Widget_control, event.top, get_uvalue= info
               set_load_map, info, event.value
             END

  'FIELD30':

  'BGROUP15': BEGIN
      CASE Event.Value OF
      0:
      1:
      2:
      ELSE: Message,'Unknown button pressed'
      ENDCASE
      END

  'FIELD17':

  'BGROUP19': BEGIN
      CASE Event.Value OF
      0:
      1:
      2:
      ELSE: Message,'Unknown button pressed'
      ENDCASE
      END
  'FIELD27':

  'FIELD29':

  'PLINIT': Begin
            widget_control, event.id, get_value = linit
            if linit eq 0 then pret = prad else pret = prad*exp(linit/pleng*0.5)
            widget_control, plretf, set_value = pret
            end
  
  'PLRET' : Begin
            widget_control, event.id, get_value = pret
            if pret gt 0 then begin
              linit = 2.0*pleng*alog(pret/prad)
              widget_control, plinitf, set_value = linit
            endif
            END

  'PLENGTH': BEGIN
             widget_control, event.id, get_value = pleng
             if pleng gt 0 then begin
               linit = 2.0*pleng*alog(pret/prad)
               widget_control, plinitf, set_value = linit
             endif
             END

  'PRADIUS': Begin
             widget_control, event.id, get_value = prad
             if prad gt 0 then begin
               linit = 2.0*pleng*alog(pret/prad)
               widget_control, plinitf, set_value = linit
             endif
             END


  'FIELD34':

  'BGROUP23': BEGIN
      CASE Event.Value OF
      0: BEGIN
           Widget_control, event.top, get_uvalue= info, tlb_get_offset= offset
           Widget_control, info.ptr, get_uvalue= value
           get_zztz, info, value, ier, offset
           if (ier eq 0  and value.ltype ne 4) then begin
             if n_elements(value.uu) gt 260 then begin
               ok = where(value.uu(128:*) lt 0.005*max(value.uu), nok)
               if nok gt 0 then xrange = [0.0, value.tu(128+ok(0))] else xrange=0
               if nok gt 0 then plot, value.tu, value.uu, $
                 xrange = xrange,  tit ='Load Impedance vs Time', $
                 xtit = 'Time (ns)', ytit='Impedance (ohms)'
             endif else plot, value.tu, value.uu,tit='Load Impedance vs Time', $
                xtit = 'Time (ns)', ytit='Impedance (ohms)'
             widget_control, info.ptr, set_uvalue = value, /no_copy
           endif else if value.ltype eq 4 and ier eq 0 then begin
             winformation, [' Cannot plot impedance for an inploding ', $
                         'plasma load until after the calculation']
             widget_control, info.ptr, set_uvalue = value, /no_copy
           endif
         End
      1: Begin
           Widget_control, event.top, get_uvalue= info, /no_copy, $
                  tlb_get_offset= offset
           Widget_control, info.ptr, get_uvalue= value, /no_copy
;
           get_zztz, info, value, ier, offset
           if ier eq 0 then begin
             widget_control, info.ptr, set_uvalue = value, /no_copy
             widget_control, event.top, /destroy
           endif else begin
             Widget_control, info.ptr, set_uvalue= value, /no_copy
             Widget_control, event.top, set_uvalue= info, /no_copy
           endelse
         End
      2: BEGIN
           widget_control, event.top, get_uvalue  = info, /no_copy, $
                 tlb_get_offset= offset
           widget_control, info.ptr, get_uvalue = value, /no_copy
           value.lcquit = 1
           value.offset = offset
           widget_control, info.ptr, set_uvalue = value, /no_copy
           widget_control, event.top, /destroy
         END
       ELSE: Message,'Unknown button pressed'
     ENDCASE
     END
    ELSE: Message,'Unknown event: '+ ev
  ENDCASE
END


PRO get_load,lcquit, tz, zz, GROUP=Group, ltype, wdfb, rltype, tlpeak, $
            tlftype, tlfall, tlwidth, peakz, plmass, plength, pradius, $
            plmin, plret, offset

  on_error, 2

  common get_load_common, pleng, pret, prad, plinitf, plretf
  IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0

  junk   = { CW_PDMENU_S, flags:0, name:'' }


  MAIN13 = WIDGET_BASE(GROUP_LEADER=Group, $
      COLUMN=1, $
      MAP=1, $
      TITLE='Load Impedance', $
      UVALUE='MAIN13')

  BASE5 = WIDGET_BASE(main13, $
      COLUMN=1, $
      FRAME=4, $
      MAP=1, $
      UVALUE='BASE5')

  Btns3494 = [ $
    'Constant Z', $
    'Falling', $
    'Rising/Falling  ', $
    'WDF Array' , 'Imploding Plasma', 'Ion Diode']
  if n_elements(ltype) eq 0 then ltype = 0 else ltype = ltype(0)
  BGROUP6 = CW_BGROUP( BASE5, Btns3494, $
     set_value = ltype, $
      row=2,  /NO_RELEASE, $
      EXCLUSIVE=1, $
      LABEL_TOP='Load Type', $
      UVALUE='BGROUP6')
  
BASE2 = WIDGET_BASE(MAIN13, $
      ROW=1, $
      MAP=1, $
      UVALUE='BASE2')


  BASE11 = WIDGET_BASE(BASE2, $
      COLUMN=1, $
      FRAME=4, $
      MAP=1, $
      UVALUE='BASE11')

  BASE12 = WIDGET_BASE(BASE11, $
      COLUMN=1, $
      FRAME=2, $
      MAP=1, $
      UVALUE='BASE11')

  BASE13 = WIDGET_BASE(BASE11, $
      COLUMN=1, $
      FRAME=2, $
      MAP=1, $
      UVALUE='BASE11')


  Btns3499 = [ $
    'Linear', $
    'Sin^2', $
    't exp(-t)' ]
  if n_elements (rltype) eq 0 then rltype = 0 else rltype = rltype(0)
  BGROUP15 = CW_BGROUP( BASE12, Btns3499, $
      set_value = rltype, $
      ROW=1, $
      EXCLUSIVE=1, /NO_RELEASE, $
      LABEL_TOP='Analytic: Rise', $
      UVALUE='BGROUP15')

  if n_elements(tlpeak) eq 0 then tlpeak=10.0 else tlpeak=float(tlpeak(0))
  FIELD17 = CW_FIELD( BASE12,VALUE=tlpeak, $
      ROW=1, $
      FLOAT=1, $
      RETURN_EVENTS=0, $
      TITLE='Time to Peak (ns):', $
      UVALUE='FIELD17')

  Btns3503 = [ $
    'Linear', $
    'Sin^2', $
    't exp(-t)' ]
  if n_elements(tlftype) eq 0 then tlftype=0 else tlftype = tlftype(0)
  BGROUP19 = CW_BGROUP( BASE13, Btns3503, $
      set_value=tlftype, $
      ROW=1, $
      EXCLUSIVE=1, /NO_RELEASE, $
      LABEL_TOP='Analytic: Fall', $
      UVALUE='BGROUP19')

  if n_elements(tlfall) eq 0 then tlfall=10.0 else tlfall=float(tlfall(0))
  FIELD27 = CW_FIELD( BASE13,VALUE=tlfall, $
      ROW=1, $
      FLOAT=1, $
      RETURN_EVENTS=0, $
      TITLE='Fall Begin (ns):', $
      UVALUE='FIELD27')

  if n_elements(tlwidth) eq 0 then tlwidth=tlfall/2. else $
      tlwidth=float(tlwidth(0))
  FIELD29 = CW_FIELD( BASE13,VALUE=tlwidth, $
      ROW=1, $
      FLOAT=1, $
      RETURN_EVENTS=0, $
      TITLE='Half Width (ns):', $
      UVALUE='FIELD29')

  BASE15 = WIDGET_BASE(BASE2, $
      COLUMN=1, $
      FRAME=4, $
      MAP=1, $
      UVALUE='BASE11')

 textp = widget_label(base15, value ='Imploding Plasma Parameters')

 if n_elements(plmass) eq 0 then plmass= 1.0 else $
       plmass =float(plmass(0))

 plmassf = CW_FIELD( BASE15,VALUE=plmass, $
      ROW=1, $
      FLOAT=1, $
      RETURN_EVENTS=0, $
      TITLE='Plasma Mass (mg/cm):', $
      UVALUE='PLMASS')

 if n_elements(plength) eq 0 then plength= 1.0 else $
       plength =float(plength(0))
       pleng = plength

 plengthf = CW_FIELD( BASE15,VALUE=plength, $
      ROW=1, $
      FLOAT=1, $
      ALL_EVENTS=1, $
      TITLE='Plasma Length (cm):', $
      UVALUE='PLENGTH')

 if n_elements(pradius) eq 0 then pradius= 1.0 else $
       pradius =float(pradius(0))
       prad = pradius

 pradiusf = CW_FIELD( BASE15,VALUE=pradius, $
      ROW=1, $
      ALL_EVENTS=1, $
      FLOAT=1, $
      TITLE='Initial Plasma Radius (cm):', $
      UVALUE='PRADIUS')

 if n_elements(plmin) eq 0 then plmin= 10.0 else $
       plmin =float(plmin(0))

 plminf = CW_FIELD( BASE15,VALUE=plmin, $
      ROW=1, $
      FLOAT=1, $
      RETURN_EVENTS=0, $
      TITLE='Final to Initial Radius (%):' , $
      UVALUE='PLMIN')

  BASE43 = WIDGET_BASE(base15, $
      column=1, $
      FRAME=1, $
      MAP=1)

text2p = widget_label(base43, value ='Set one of the following:')
 
  BASE44 = WIDGET_BASE(base43, $
      ROW=1, $
      FRAME=0, $
      MAP=1, $
      UVALUE='BASE4')


  if n_elements(plret) eq 0 then plret= 1.5 else $
       plret =float(plret(0))
       pret = plret

 plretf = CW_FIELD( BASE44,VALUE=plret, $
      COLUMN=1, $
      FLOAT=1, $
      ALL_EVENTS=1, $
      TITLE='Return Current Radius (cm):', $
      UVALUE='PLRET')

 plinit = 2.*plength*alog (plret/pradius)
 plinitf = CW_FIELD( BASE44,VALUE=plinit, $
      COLUMN=1, $
      FLOAT=1, $
      ALL_EVENTS=1, $
      TITLE='Initial Load Inductance(nH):', $
      UVALUE='PLINIT')

  BASE4 = WIDGET_BASE(MAIN13, $
      COLUMN=1, $
      FRAME=4, $
      MAP=1, $
      UVALUE='BASE4')

  if n_elements(wdfb) eq 0 then wdfb = 1 else wdfb = wdfb(0)
  FIELD30 = CW_FIELD( BASE4,VALUE=wdfb, $
      row=1, $
      INTEGER=1, $
      RETURN_EVENTS=0, $
      TITLE='WDF Array Number', $
      UVALUE='FIELD30')
  
  BASE3 = WIDGET_BASE(MAIN13, $
      COLUMN=1, $
      FRAME=4, $
      MAP=1, $
      UVALUE='BASE3')

  if n_elements(peakz) eq 0 then peakz = 2.50 else peakz=float(peakz(0))
  ztitle  = widget_label(BASE3, value = $
       'Set value for peak or constant-Z value')
  FIELD34 = CW_FIELD( BASE3,VALUE=peakz, $
      ROW=1, $
      FLOAT=1, $
      RETURN_EVENTS=0, $
      TITLE='Peak Load Impedance (ohms):', $
      UVALUE='FIELD34')


  BASE22 = WIDGET_BASE(MAIN13, $
      ROW=1, $
      MAP=1, $
      UVALUE='BASE22')

  BASE24 = WIDGET_BASE(BASE22, $
      ROW=1, $
      MAP=1, $
      UVALUE='BASE24')

  Btns3516 = [ $
    '     Plot     ', $
    ' Continue ->  Define Geometry ', $
    '  Cancel  ' ]
  BGROUP23 = CW_BGROUP( BASE24, Btns3516, $
      ROW=1, $
      SPACE=75, $
      UVALUE='BGROUP23')

  if n_elements (offset) lt 2  then offset = [10, 10] else $
    offset = (offset(0:1)> 0)
  WIDGET_CONTROL, main13, /REALIZE, tlb_set_xoffset = offset(0), $
       tlb_set_yoffset= offset(1)

  ptr = widget_base() 
  value = {lcquit:0, uu:0.0, tu:0.0, ltype:ltype, wdfb:wdfb, $
    rltype:rltype, tlpeak:tlpeak, tlftype:tlftype, tlfall:tlfall, $
    tlwidth:tlwidth, peakz:peakz, plmass:plmass, plmin:plmin, $
     plength:plength, pradius:pradius, plret:plret, offset:offset}
  widget_control, ptr, set_uvalue = value
  info = {ptr:ptr, tpeak: field17, wdfa: field30, type:bgroup6, $
         typrise:bgroup15, typfall:bgroup19, fallstart:field27, $
         fallwidth: field29, peakZ:field34 , base2:base2, base11:base11, $
         base12:base12, base13:base13, base15:base15, base4:base4, $
         base3:base3,  plmass:plmassf, plmin:plminf,plength:plengthf, $
          pradius:pradiusf, plret:plretf, zlabel:ztitle}
  set_load_map, info, ltype
  widget_control, main13, set_uvalue = info, /no_copy
     widget_control, main13, tlb_get_offset= offset_real
     offset_real = offset  - offset_real
  XMANAGER, 'get_load', MAIN13, /modal
  widget_control, ptr, get_uvalue = value, /no_copy
  zz = value.uu
  tz = value.tu
  lcquit = value.lcquit
  widget_control, ptr, /destroy
  ltype = value.ltype
  wdfb = value.wdfb
  rltype = value.rltype
  tlpeak= value.tlpeak
  tlftype = value.tlftype
  tlfall = value.tlfall
  tlwidth = value.tlwidth
  peakz = value.peakz
  plmass = value.plmass
  plmin = value.plmin
  plength = value.plength
  pradius = value.pradius
  plret = value.plret
  offset = value.offset + offset_real
  return
 END
