; ------------------------------------------------------------------------ 
; $Id: get_point.pro,v 1.3 2007/06/06 19:34:28 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
PRO get_point_event, Event
  ;

  WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev
  
  CASE Ev OF 

  'VACUUM': 

  'POSITION': 

  'BGROUP2': 

  'BGROUP1': BEGIN
             widget_control, event.top, get_uvalue = info
             widget_control, info.lctype, sensitive = event.value
             END

  'FLOW': 
  'EFLOW': 

  'OK-BUT': BEGIN
            widget_control, event.top, get_uvalue = info,tlb_get_offset= offset
            widget_control, info.ptr, get_uvalue = val
            widget_control, info.zvac, get_value = zvac
            widget_control, info.mitltype, get_value = btype
            widget_control, info.lcemit, get_value = lcemit
            if btype eq 0 then begin
              zfcon=0.0
              zfdwn= 0.0
            endif else begin
              widget_control, info.zfcon, get_value=zfcon
              widget_control, info.zfdwn, get_value=zfdwn
              if zfcon le 0 then zfcon= -1.0
              if zfdwn le 0 or zfdwn gt zvac then zfdwon = -1
            endelse
            if info.zf gt 0 then WIDGET_CONTROL, INFO.Zf, GET_VALUE = FLOWIN $
              else flowin = -1
            WIDGET_CONTROL, INFO.X, GET_VALUE = POSITION
            if zvac le 0.0  then begin
	      winformation, ['WARNING:', 'Vacuum Impedance ', $
			'must be greater than zero']
            endif else if zfcon lt 0.0  then begin
	      winformation, ['WARNING:', 'Convolute Impedance ', $
			'must be greater than zero']
            endif else if zfdwn lt 0.0  then begin
	      winformation, ['WARNING:', 'Downstream Flow Impedance ', $
			'must be greater than zero and less than Zvac']
            endif else begin
              widget_control, info.fitbutton , get_value = btns2
              widget_control, info.ptr, set_uvalue = {Z:ZVAC, ZF:flowin, $
                    x: position, fitbutton : btns2, quit: 0L, $
                    zfcon:zfcon, zfdwn:zfdwn, lcemit:lcemit, offset:offset}
              widget_control, event.top,/destroy
            endelse
          END

  'QUIT-BUT': BEGIN
            widget_control, event.top, get_uvalue = info, tlb_get_offset= offset
            widget_control, info.ptr, get_uvalue = val
            widget_control, info.zvac, get_value = zvac
            widget_control, info.lcemit, get_value = lcemit
            if info.zf gt 0 then WIDGET_CONTROL, INFO.Zf, GET_VALUE = FLOWIN $
              else flowin = -1
            WIDGET_CONTROL, INFO.X, GET_VALUE = POSITION
            zfcon = 0.0
            zfdwn = 0.0
            widget_control, info.fitbutton , get_value = btns2
            widget_control, info.ptr, set_uvalue = {Z:ZVAC, ZF:flowin, $
                    x: position, fitbutton : btns2, quit:1L , $
                    zfcon:zfcon, zfdwn:zfdwn, lcemit:lcemit, offset:offset}

            WIDGET_CONTROL, EVENT.TOP,/DESTROY       
          END
  ENDCASE
END


PRO get_point, x, z, zf, fit, zfcon, zfdwn, lcemit, lcquit, $
      offset, modal = modal, GROUP=Group, expert= expert

  ;

  IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0
  IF N_ELEMENTS(expert) EQ 0 THEN expert=0



  SIMUL = WIDGET_BASE(GROUP_LEADER=Group, $
      COLUMN=1, $
      MAP=1, $
      TITLE='MITL Parameters')

  if n_elements(zfcon) gt 0 and n_elements(zfdwn) gt 0 then begin
      if zfcon gt 0.0 and zfdwn gt 0.0 then lccon = 1 else lccon = 0
  endif else lccon = 0

  btype = CW_BGROUP(simul, ['MITL Point', 'Convolute Point'], $
       ROW = 1, set_value = lccon, $
       LABEL_TOP='Select Transmission Line Element:', $
       EXCLUSIVE = 1, /NO_RELEASE, $
       UVALUE='BGROUP1')

  IF N_ELEMENTS(x) EQ 0.0 THEN XPOSITION = 0.0 else xposition = x
  POSITION = CW_FIELD( SIMUL,VALUE=xposition, $
      ROW=1, $
      FLOAT=1, $
      RETURN_EVENTS=1, $
      TITLE='            Position (m):', $
      UVALUE='POSITION')

 if n_elements(z) eq 0 then zvac = 10.0 else zvac = z
  VACUUM = CW_FIELD( SIMUL,VALUE=ZVAC, $
      ROW=1, $
      FLOAT=1, $
      RETURN_EVENTS=1, $
      TITLE='Vacuum Impedance:', $
      UVALUE='VACUUM')

  if n_elements (zf) eq 0.0 then flowin=0.0 else flowin = zf
  if expert ne 0 then $
  FLOW = CW_FIELD( SIMUL,VALUE=FLOWIN, $
      ROW=1, $
      FLOAT=1, $
      RETURN_EVENTS=1, $
      TITLE='     Flow Impedance:', $
      UVALUE='FLOW') else flow = -1
  
  if n_elements(lcemit) eq 0 then lcemit = 1 else lcemit = lcemit(0)
  Btns = [ $
    '  O F F ', $
    '  O N  ']
  eflow = CW_BGROUP( simul, Btns, $
      set_value = lcemit, $
      ROW=1, $
      EXCLUSIVE=1, /NO_RELEASE, $
      LABEL_LEFT='Electron Flow in MITL: ', $
      UVALUE='EFLOW')

  cbase = widget_base(simul, /column ) 
;
 if fix(strmid(!version.release, 0, 1)) gt 3  then $
   junk =  widget_label(cbase,/align_center, val='Convolute Parameters') $
   else  junk =  widget_label(cbase, val='Convolute Parameters')

 junk =  widget_label(cbase, val='Convolute Parameters')


  if n_elements(zfcon) eq 0 then zfcon = 0.0

  zfconp = CW_FIELD( cbase,VALUE= zfcon, $
      ROW=1, $
      FLOAT=1, $
      RETURN_EVENTS=0, $
      TITLE='Convolute Flow Impedance:', $
      UVALUE='ZFCON')

  if n_elements(zfdwn) eq 0 then zfdwn=0.0

  zfdwnp = CW_FIELD( cbase,VALUE= zfdwn, $
      ROW=1, $
      FLOAT=1, $
      RETURN_EVENTS=0, $
      TITLE='Down Stream Flow Impedance:', $
      UVALUE='ZFDWN')

  BTNS2 = [ $
    'LINEAR      ', $
    'SINE^2       ', $
    'LOG    ']
  if n_elements (fit) eq 0 then fit = 0 else fit = fit< 2
  bbase = widget_base(simul, frame= 2)
  BGROUP2 = CW_BGROUP(bbase, BTNS2, $
     ROW = 1, set_value = fit, $
     LABEL_TOP='Transition to Next Point:', $
     EXCLUSIVE = 1, /NO_RELEASE, $
     UVALUE='BGROUP2') 
 
  
  TBASE = WIDGET_BASE(SIMUL, /row, /FRAME)
  BUT1 = WIDGET_BUTTON(TBASE, VALUE='           OK           ', $
          UVALUE='OK-BUT')
  BUT2 = WIDGET_BUTTON(TBASE, VALUE='         QUIT          ', $
          UVALUE='QUIT-BUT') 

  if n_elements (offset) lt 2  then offset = [10, 10] else $
    offset = (offset(0:1)> 0)
  WIDGET_CONTROL, simul, /REALIZE, tlb_set_xoffset = offset(0), $
       tlb_set_yoffset= offset(1)

  widget_control, cbase, sensitive = lccon



  ptr = widget_base()
  val = {Z:ZVAC, ZF:flowin, x: xposition, fitbutton: fit, quit:1L, $
           zfcon:zfcon, zfdwn:zfdwn, lcemit:lcemit, offset:offset}
  info = {zvac:vacuum,  zf:flow, zfcon:zfconp, zfdwn:zfdwnp, lctype:cbase, $
         fitbutton: bgroup2, X:POSITION,lcemit:eflow, mitltype:btype, ptr: ptr}
 
  WIDGET_CONTROL, ptr, SET_UVALUE=VAL
  WIDGET_CONTROL, simul, SET_UVALUE = INFO

     widget_control, simul, tlb_get_offset= offset_real
     offset_real = offset  - offset_real

  XMANAGER, 'GET_POINT', SIMUL, modal = modal

  widget_control, ptr, get_uvalue=val
  z = val.z
  if expert eq 0 then zf = -1.0 else zf = val.zf
  x = val.x
  fit = val.fitbutton
  zfcon = val.zfcon
  zfdwn = val.zfdwn
  lcemit = val.lcemit
  lcquit= val.quit
  offset = val.offset + offset_real
   widget_control, ptr, /destroy
END
