; ------------------------------------------------------------------------ 
; $Id: get_source.pro,v 1.3 2007/06/06 19:34:29 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
PRO GET_source_event, Event

;
      on_error, 2

  WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev

  CASE Ev OF 

  'BGROUP6': BEGIN
      widget_control, event.top, get_uvalue= info
      CASE Event.Value OF
      0: BEGIN
           widget_control, info.wdfbase, sensitive = 0 
           widget_control, info.anabase, sensitive = 1 
         END
      1: BEGIN
           widget_control, info.wdfbase, sensitive = 1 
           widget_control, info.anabase, sensitive = 0
         END
      ELSE: Message,'Unknown button pressed'
      ENDCASE
      END

  'FIELD30': 

  'BGROUP15': BEGIN
      CASE Event.Value OF
      0:
      1:
      2:
      ELSE: Message,'Unknown button pressed'
      ENDCASE
      END
  'FIELD17':

  'BGROUP19': BEGIN
      CASE Event.Value OF
      0:
      1:
      2:
      ELSE: Message,'Unknown button pressed'
      ENDCASE
      END
  'FIELD27':

  'FIELD29':
      
  'FIELD4':
     
  'FIELD34':

   'EFLOW':
   'FLASH':
   'POS'  :

; 'EFLOW': Begin
;        widget_control, event.top, get_uvalue = info, /no_copy
;        widget_control, info.qlimit, sensitive = event.value
;        widget_control, event.top, set_uvalue = info, /no_copy
;          END

  'QLIMIT':
    
  'BGROUP23': BEGIN
      CASE Event.Value OF
      0: BEGIN
           Widget_control, event.top, get_uvalue= info,tlb_get_offset = offset
           Widget_control, info.ptr, get_uvalue= value
;
           get_uutu, info, value, ier, offset 
           if ier eq 0 then begin
             if n_elements(value.uu) gt 260 then begin
               ok = where(value.uu(128:*) lt 0.005*max(value.uu), nok)
               if nok gt 0 then xrange = [0.0, value.tu(128+ok(0))] else xrange=0
               if nok gt 0 then plot, value.tu, value.uu, $
                 xrange = xrange,  tit ='Source Voltage vs Time', $
                 xtit = 'Time (ns)', ytit='Voltage (MV)'
             endif else plot, value.tu, value.uu,tit='Source Voltage vs Time', $
                xtit = 'Time (ns)', ytit='Voltage (MV)'
             widget_control, info.ptr, set_uvalue = value
           endif
         END
      1: Begin
           Widget_control, event.top, get_uvalue= info, tlb_get_offset = offset
           Widget_control, info.ptr, get_uvalue= value
           value.offset = offset
;
;          following routine reads the button values.
;
           get_uutu, info, value, ier, offset
           if ier eq 0 then begin
             widget_control, info.ptr, set_uvalue = value
             widget_control, event.top, /destroy
           endif
         End
      2: BEGIN
           widget_control, event.top, get_uvalue  = info
           widget_control, info.ptr, get_uvalue = value
           value.lcquit = 1
           widget_control, info.ptr, set_uvalue = value
           widget_control, event.top, /destroy
         END
      ELSE: Message,'Unknown button pressed'
      ENDCASE
      END
  ENDCASE
END


PRO get_source,lcquit, tu, uu, zsource, GROUP=Group, $
      stype, wdfa, rtype, tpeak, ftype, tfall, twidth,umax , offset, $
      lcflow, qemit, lcflash, quiet = quiet


  IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0

  junk   = { CW_PDMENU_S, flags:0, name:'' }
  if n_elements(stype) eq 0 then stype = 0 else stype = stype(0)
  if n_elements(wdfa) eq 0 then wdfa = 1 else wdfa = wdfa(0)
  if n_elements(rtype) eq 0 then rtype = 0 else rtype = rtype(0)
  if n_elements(tpeak) eq 0 then tpeak = 10.0 else tpeak = float(tpeak(0))
  if n_elements(ftype) eq 0 then ftype = 0 else ftype = ftype(0)
  if n_elements (tfall) eq 0 then tfall= 10.0 else tfall = float(tfall(0))
  if n_elements(twidth) eq 0 then twidth=tfall/2.0 else twidth=float(twidth(0))
  if n_elements(umax) eq 0 then umax = 10.0 else umax = float(umax(0))
  if n_elements(zsource) eq 0 then zsource=10.0 else zsource=float(zsource(0))
  if n_elements(lcflow) eq 0 then lcflow = 1 else lcflow = fix(lcflow(0)) >0
  if n_elements(lcflash) eq 0 then lcflash = 0 else lcflash = fix(lcflash(0))
  if n_elements(qemit) eq 0 then qemit = 1.0 else qemit = float (qemit(0))

if not keyword_set(quiet) then begin

  MAIN13 = WIDGET_BASE(GROUP_LEADER=Group, $
      COLUMN=1,  $
      MAP=1, $
      TITLE='MITL Source Voltage and Impedance')

  BASE2 = WIDGET_BASE(MAIN13, $
      ROW=1, $
      MAP=1, $
      UVALUE='BASE2')

  BASE5 = WIDGET_BASE(BASE2, $
      COLUMN=1, $
      FRAME=4, $
      MAP=1, $
      UVALUE='BASE5')

  Btns366 = [ $
    'Analytic', $
    'WDF Array' ]

  BGROUP6 = CW_BGROUP( BASE5, Btns366, $
      set_value = stype, $
      COLUMN=1, $
      EXCLUSIVE=1, /NO_RELEASE, $
      LABEL_TOP='Source Type', $
      UVALUE='BGROUP6')

  base6 = widget_base(base5)
  FIELD30 = CW_FIELD( BASE6,VALUE=wdfa, $
      COLUMN=1, $
      INTEGER=1, $
      TITLE='WDF Array Number', $
      UVALUE='FIELD30')


  BASE11 = WIDGET_BASE(BASE2, $
      COLUMN=1, $
      FRAME=4, $
      MAP=1, $
      UVALUE='BASE11')

  Btns738 = [ $
    'Linear', $
    'Sin^2', $
    't exp(-t)' ]

  BGROUP15 = CW_BGROUP( BASE11, Btns738, $
      set_value = rtype, $
      ROW=1, $
      EXCLUSIVE=1, /NO_RELEASE, $
      LABEL_TOP='Analytic: Rise', $
      UVALUE='BGROUP15')

  FIELD17 = CW_FIELD( BASE11,VALUE=tpeak, $
      ROW=1, $
      FLOAT=1, $
      TITLE='Time to Peak (ns):', $
      UVALUE='FIELD17')

  Btns921 = [ $
    'Linear', $
    'Sin^2', $
    't exp(-t)' ]
  BGROUP19 = CW_BGROUP( BASE11, Btns921, $
      set_value = ftype, $
      ROW=1, $
      EXCLUSIVE=1, /NO_RELEASE, $
      LABEL_TOP='Analytic: Fall', $
      UVALUE='BGROUP19')

  FIELD27 = CW_FIELD( BASE11,VALUE= tfall, $
      ROW=1, $
      FLOAT=1, $
      TITLE='Fall Begin (ns):', $
      UVALUE='FIELD27')

  FIELD29 = CW_FIELD( BASE11,VALUE=twidth, $
      ROW=1, $
      FLOAT=1, $
      TITLE='Half Width (ns):', $
      UVALUE='FIELD29')



  BASE3 = WIDGET_BASE(MAIN13, $
      COLUMN=1, $
      FRAME=4, $
      MAP=1, $
      UVALUE='BASE3')

  base33= widget_base(base3, column=1, frame = 3, /map, uvalue = 'base33')
  lab = widget_label(base33,  /align_center, $
     value = 'Enter parameters for the first voltage adder section')
  
  FIELD4 = CW_FIELD( BASE33,VALUE=umax, $
      ROW=1, $
      FLOAT=1, $
      TITLE='Peak Voltage (MV):', $
      UVALUE='FIELD4')

  FIELD34 = CW_FIELD( BASE33,VALUE=zsource, $
      ROW=1, $
      FLOAT=1, $
      TITLE='Source Impedance (ohms):', $
      UVALUE='FIELD34')


  BASE22 = WIDGET_BASE(MAIN13, $
      COLUMN=1, $
      MAP=1, $
      FRAME = 4, $
      UVALUE='BASE22')

Btns = [ $
    '  O F F ', $
    '  O N  ']

  eflow = CW_BGROUP( BASE22, Btns, $
      set_value = lcflow, $
      ROW=1, $
      EXCLUSIVE=1, /NO_RELEASE, $
      LABEL_LEFT='Electron Flow in MITL: ', $
      UVALUE='EFLOW')

     qlimit = CW_FIELD( BASE22,VALUE=qemit, $
      ROW=1, $
      FLOAT=1, $
      TITLE='Threshold Electric Field (Er*Rc) (MV):', $
      UVALUE='QEMIT')
 
  flash = CW_BGROUP( BASE22, Btns, $
      set_value = lcflash, $
      ROW=1, $
      EXCLUSIVE=1, /NO_RELEASE, $
      LABEL_LEFT='Short Line at Voltage=0: ', $
      UVALUE='FLASH')

  BASE24 = WIDGET_BASE(main13, $
     ROW=1, $
     MAP=1, $
     UVALUE='BASE24')

  Btns1319 = [ $
    '       P l o t      ', $
    ' Continue -> Define Load ', $
    '    C a n c e l    ' ]

  BGROUP23 = CW_BGROUP(main13 , Btns1319, $
      ROW=1, $
      SPACE = 50,   $
      UVALUE='BGROUP23')

  if n_elements (offset) lt 2  then offset = [10, 10] else $
    offset = (offset(0:1)> 0)

  WIDGET_CONTROL, main13, /REALIZE, tlb_set_xoffset = offset(0), $
       tlb_set_yoffset= offset(1)
;  widget_control, qlimit, sensitive = lcflow

  ptr = widget_base() 
  value = {lcquit:0, uu:0.0, tu:0.0, zsource:zsource, stype:stype, $
    wdfa:wdfa, rtype:rtype, tpeak:tpeak, ftype:ftype, tfall:tfall, $
    twidth:twidth, umax:umax, offset:offset, lcflow:lcflow, qemit:qemit, $
    flash:lcflash}
;   flash:lcflash, pos: lcpos, nsource:numb_source}
  widget_control, ptr, set_uvalue = value
  info = {ptr:ptr, tpeak: field17, wdfa: field30, type:bgroup6, $
         typrise:bgroup15, typfall:bgroup19, fallstart:field27, $
         fallwidth: field29, peakV: field4, sourcez:field34, $
         wdfbase: base6, anabase:base11, eflow:eflow , qlimit:qlimit, $
         flash:flash}
  
  if stype eq 0 then begin
           widget_control, info.wdfbase, sensitive = 0 
           widget_control, info.anabase, sensitive = 1 
   endif else begin
           widget_control, info.wdfbase, sensitive = 1 
           widget_control, info.anabase, sensitive = 0
   endelse

   widget_control, main13, tlb_get_offset= offset_real
   offset_real = offset - offset_real

  widget_control, main13, set_uvalue = info, /no_copy
  XMANAGER, 'get_source', MAIN13, no_block = 0
  widget_control, ptr, get_uvalue = value, /no_copy
  widget_control, ptr, /destroy
endif else begin
  value = {lcquit:0, uu:0.0, tu:0.0, zsource:zsource, stype:stype, $
    wdfa:wdfa, rtype:rtype, tpeak:tpeak, ftype:ftype, tfall:tfall, $
    twidth:twidth, umax:umax, offset:offset, lcflow:lcflow, qemit:qemit, $
    flash:lcflash}
    get_uutu, info, value, ier, offset
    if ier eq 0 then begin
      print, '% GET_SOURCE: Error getting voltage and time.
      return
    endif
endelse
  zsource = value.zsource
  uu = value.uu
  tu = value.tu
  lcquit = value.lcquit
  stype = value.stype
  wdfa = value.wdfa
  rtype = value.rtype
  tpeak = value.tpeak
  ftype = value.ftype
  tfall = value.tfall
  twidth = value.twidth
  umax = value.umax
  offset = value.offset + offset_real
  lcflow = value.lcflow
  qemit = value.qemit
  lcflash=value.flash
  return
END
