pro  get_uniq_nodes, array, newcoord, ind, xgrid= xgrid, ygrid = ygrid, zgrid = zgrid, nxyz = nxyz
;
; Get the unique nodes from an array of nodes.
;   ARRAY    - an array of [3, N] of planes in a simulation with N nodes
;   NEWCOORD - an array of [3, M] where there are M unique nodes in array
;   IND      - an array of indexes into the NEWCOORD for the original planes 
;              NEWCOORD[*, IND[0:3] is the first plane
;              NEWCOORD[*, IND[4:7] is the second plane
;

on_error, 1
n = size(array)
nt = n[2]
x = array[0, *]
i = sort(x)
x = x[i]
ii = uniq(x)
nii = n_elements(ii)
xgrid = x[ii]
ii =[-1L, ii]
ind = make_array(nt, /long)

for k = 0L, nii-1 do ind[i[ii[k]+1 : ii[k+1]]]+= k

y = array[1, *]
j = sort(y)
y = y[j]
jj = uniq(y)
ygrid = y[jj]
njj = n_elements(jj)
jj =[-1L, jj]
for i = 0L, njj-1 do ind[j[jj[i]+1 : jj[i+1]]]+= i*nii

z = array[2, *]
k = sort(z)
z = z[k]
kk = uniq(z)
zgrid = z[kk]
nkk = n_elements(kk)
ndel = nii*njj
nxyz = ndel*nkk
kk =[-1L, kk]
for i = 0L, nkk-1 do ind[k[kk[i]+1 : kk[i+1]]] += i*ndel

ii = sort(ind)
ui = uniq(ind[ii])
nui = n_elements(ui)
newcoord = array[*, ii[ui]]
ui =[-1L, ui]
for i = 0L, nui-1 do ind[ii[ui[i]+1: ui[i+1]]] = i

end
