; ------------------------------------------------------------------------ 
; $Id: make_tet_obj.pro,v 1.3 2007/06/06 19:34:30 lpmix Exp $ 
; ------------------------------------------------------------------------ 
; 
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;

 function make_tet_obj, x, y, z, color = color, radius = radius

; make a polygon object

 on_error , 1
 if n_elements (radius) eq 0 then radius = 0.01
 h = sqrt(8.0/9)*radius
 h2 = h/2.0
 h3 = sqrt(2./3.)*radius
 zz = z-radius/3.0

 vv = [x, y, z+radius, h+x, y, zz, x-h2, y+h3, zz, x-h2, y-h3, zz]
 po=[3,0,1,2, 3, 0, 2, 3, 3, 0, 3, 1, 3, 3, 2, 1]
 if n_elements (color) eq 0 then color = 'b'
 vv = reform(vv, 3, 4, /over)
 return, obj_new('idlgrpolygon', vv, polygons= po, color = getcolor(color))
end



