; ------------------------------------------------------------------------ 
; $Id: put2uniform.pro,v 1.4 2010/09/03 16:10:39 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro  put2uniform, space, image, nel, start, delta, stop,wdfarray, yonly= yonly
;
;     put space and image into an wdf array 
;     space is sorted
;     nel are the number of values in space & image
;     start is the initial point, delta is the new spacing
;     if keyword_set(yonly) then return only ordinate values
;
      on_error, 1
      common pffcom, initpff, pff_exe
;     time1 = systime(1)
      if (n_elements(initpff) eq 0) then init_pff else $
        if initpff eq 0 then init_pff
;     np is the number of deltas in the range
      np = float(stop - start)/delta
;     limit the error allowance to 7/16 
;     error will always be > 0.0005
      err = (np/4194304) < 0.4375
;     nelem is the number of node points
      nelem = long((err > 0.0005)+np) +1L
      if nelem lt 2 then begin
        print, '% PUT2UNIFORM: Less than 2 data values'
        wdfarray = 0
        return
      endif
    if initpff gt 0 then begin
      space = float (space)
      image = float (image)
      nel = long(nel)
      start = float(start)
      delta = float(delta) 
      ist = 1L
      if keyword_set(yonly) then wdfarray = make_array(nelem) else begin
        wdfarray = make_array(nelem+2)
        wdfarray(0) = start
        wdfarray(1) = delta
        ist = 3L
      endelse
      if initpff eq 1 then begin
; HP
        junk = call_external(PFF_EXE, 'sl_put2uniform', space, image, nel, $
           start, delta, nelem, wdfarray, ist)
      endif else if initpff eq 2 then begin
; Sun
        junk = call_external(PFF_EXE, 'sl_put2uniform_', space, image, nel, $
           start, delta, nelem, wdfarray, ist)
      endif else if initpff eq 3 then begin
; VMS
        junk = call_external(PFF_EXE, 'sl_put2uniform', space, image, nel, $
           start, delta, nelem, wdfarray, ist)
      endif else if initpff eq 4 then begin
; WIN
        junk = call_external(PFF_EXE, '_SL_PUT2UNIFORM@8', space, image, nel, $
           start, delta, nelem, wdfarray, ist)
      endif else if initpff eq 5 then begin
; MAC
        junk = call_external(PFF_EXE, 'sl_put2uniform', space, image, nel, $
           start, delta, nelem, wdfarray, ist)
      endif
    endif else begin    
;
;  add some bullet proofing.
;
      dimage = float(space[1:nel-1]-space[0:nel-2])
      ok = where (dimage le 0, nok)
      if nok gt 0 then dimage[ok] = 1.0
      dimage =  (image[1:nel-1]-image[0:nel-2])/(temporary(dimage))
      if nok gt 0 then dimage[ok] = 0.0
      if keyword_set(yonly) then begin
        wdfarray = make_array(nelem, /float)
        j = 1L
        for i = 0L, nelem-1  do begin
          t = start +i*delta
          while t gt space(j) and j lt nel-1 do j = j+1
          wdfarray (i)= image[j-1]+(t-space[j-1])* dimage[j-1]
        endfor
      endif else begin
        wdfarray = make_array(nelem+2, /float)
        wdfarray[0] = start
        wdfarray[1] = delta
        j = 1L
        for i = 0L, nelem-1  do begin
          t = start +i*delta
          while t gt space[j] and j lt nel-1 do j = j+1
          wdfarray [2+i]= image[j-1]+(t-space[j-1])* dimage[j-1]
        endfor
      endelse
    endelse
    end
