c ------------------------------------------------------------------------ 
c $Id: qpfparam.inc,v 1.1.1.1 2002/11/12 23:05:51 lpmix Exp $ 
c ------------------------------------------------------------------------ 
*comdeck qpfparam
c***********************************************************************
c     Last modified:   2-MAY-1991 14:41:20.72   rsc
c***********************************************************************
c
c     Parameters for PFF usage, including QS's application-specific
c     datatypes
c
c   Parameters:
c     PFDFLT  -  PFF default word value
c     QSOPAR  -  PFF application dataset type offset for particle
c                snapshot dataset types
c     QSOSNP  -  PFF application dataset type offset for field snapshot
c                dataset types
c     QSTBBX  -  PFF application dataset type for bounding box
c     QSTCND  -  PFF application dataset type for conductor data
c     QSTGRD  -  PFF application dataset type for system grid data
c     QSTHIS  -  PFF application dataset type for time-history data
c     QSTDIE  -  PFF application dataset type for dielectric data
c     QSTPAR  -  PFF application dataset type for particle (only)
c                snapshot data
c     QSTPQ   -  PFF application dataset type for particle (w/ charge)
c                snapshot data
c     QSTPP   -  PFF application dataset type for particle (w/ momentum)
c                snapshot data
c     QSTPQP  -  PFF application dataset type for particle (w/ charge
c                and momentum) snapshot data
c     QSTSBF  -  PFF application dataset type for magnetic field
c                snapshot data
c     QSTSEF  -  PFF application dataset type for electric field
c                snapshot data
c     QSTSJF  -  PFF application dataset type for current density
c                snapshot data
c     QSTSRO  -  PFF application dataset type for charge density
c                snapshot data
c
      integer   PFDFLT
      integer   QSOPAR, QSOSNP
      integer   QSTBBX, QSTCND, QSTGRD, QSTHIS, QSTDIE, QSTPAR, QSTPQ
      integer   QSTPP , QSTPQP, QSTSEF, QSTSBF, QSTSJF, QSTSRO
c
      parameter ( PFDFLT = -3 )
c
      parameter ( QSOSNP = 10 )
      parameter ( QSOPAR = 20 )
c
      parameter ( QSTBBX = 1 )
      parameter ( QSTCND = 2 )
      parameter ( QSTHIS = 3 )
      parameter ( QSTDIE = 4 )
      parameter ( QSTGRD = 5 )
c
      parameter ( QSTSEF = QSOSNP + 1 )
      parameter ( QSTSBF = QSOSNP + 2 )
      parameter ( QSTSJF = QSOSNP + 3 )
      parameter ( QSTSRO = QSOSNP + 4 )
c
      parameter ( QSTPAR = QSOPAR )
      parameter ( QSTPQ  = QSOPAR + 1 )
      parameter ( QSTPP  = QSOPAR + 3 )
      parameter ( QSTPQP = QSOPAR + 4 )
c
