; ------------------------------------------------------------------------ 
; $Id: quadratic.pro,v 1.4 2007/06/06 19:34:31 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;

 function quadratic, ain, bin, cin, real_only = realonly
 npar = n_params()
 if npar eq 1 then begin
   if n_elements(a) ge 3 then begin
     c = double(ain[2])
     b = double(ain[1])
     a = double(ain[0])
   endif
 endif else begin
   if n_elements(a) ne 1 || n_elements(b) ne 1 || n_elements(c) ne 1 then begin
      Print, '% QUADRATIC: 3 scalar coefficients are required.'
      return, 0
   endif
   a = double(ain)
   b = double(bin)
   c = double(cin)
 endelse
 
 b4ac = b*b-4.0d0*a*c
 if b4ac lt 0 then begin
   if keyword_set (realonly) then begin
     Print, '% QUADRATIC: Quadratic coefficients have complex roots.'
     return, 0
   endif else begin
     z = sqrt(dcomplex(b4ac, 0.0d0))
     return, [(-b+z), -(b+z)]/ (a+a)
   endelse
 endif
 b4ac = sqrt(b4ac)
 q =  (b lt 0) ?  -0.5d0*(b-b4ac) : -0.5d0*(b+b4ac)

 return , [q/a, c/q]
 end
