; ------------------------------------------------------------------------ 
; $Id: rotate_xy.pro,v 1.3 2007/06/06 19:34:32 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro rotate_xy, x, y, w
; rotate a line xy by an amount w
;
on_error, 2
npar = n_params()
if npar ne 3 then begin
  print, '%ROTATE_XY: Must have three parameters'
  return
endif
nely = n_elements(y)
nelx = n_elements(x)
if nelx lt 2 or nely lt 2 then begin
   print, '%ROTATE_XY: X and Y must have at least 2 elements'
   return
endif
if n_elements(w) eq 0 then begin
   Print, '%ROTATE_XY: Angle must be defined'
   return
endif else ang = w(0)*!dtor
if nelx ne nely then print, $
  'Arrays are not the same length; longest will be terminated'
;
nel = min([nelx, nely])
xx = temporary(x(0:nel-1))
yy = temporary(y(0:nel-1))
 x = xx*cos(ang)-yy*sin(ang)
 y = yy*cos(ang)+xx*sin(ang)
return
end
  
