; ------------------------------------------------------------------------ 
; $Id: spec_write.pro,v 1.3 2007/06/06 19:34:33 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
  Pro spec_write, file, unit

@spec_common.dat

  printf, unit, ';  PFF outfile: ', file
  printf, unit, ';  Date : ', thin_date()
  printf, unit, ' ion_Z = ', ion_z, ' ; Particle Z'
  printf, unit, ' ion_A = ', ion_a, ' ; Particle weight (AMU)'
  printf, unit, ' ion_Q = ', ion_q, ' ; Particle charge'
  printf, unit, ' anode_dist = ', anode_dist, ' ; (cm) Distance from Scattering foil to source'
  printf, unit, ' anode_y    = ', anode_y, ' ; (cm) Y-Displacement from center of the anode'
  printf, unit, ' anode_z    = ', anode_z, ' ; (cm) Z-Displacement from center of the anode'
  printf, unit, ' GCell_1_Th = ', GCell_1_Th, ' ; (microns) Mylar thickness'
  printf, unit, ' GCell_1_Press = ', GCell_1_press, ' ; (torr) Gas Cell Fill Pressure'
  printf, unit, ' GCell_1_gas = ', GCell_1_gas, ' ; Z of gas cell fill'
  printf, unit, ' GCell_1_dist = ', GCell_1_dist
  printf, unit, '; (cm) Distance from Scattering foil to back Gas Cell 
  printf, unit, '; Assume a three element scattering foil with a scattering angle'
  printf, unit, ';   defined between the X-axis and the foil normal in the X-Z plane'
  printf, unit, ' scat_angle = ', scat_angle, ' ; (degrees) Scattering foil angle (up = positive)'
  printf, unit, ' Scat_th_1      = ', scat_th_1, ' ; (microns) First foil scattering thickness'
  printf, unit, ' Scat_mat_1     = ', scat_mat_1, ' ; (material number)'
  printf, unit, ' Scat_th_2      = ', scat_th_2, ' ; (microns) Actual foil scattering thickness'
  printf, unit, ' Scat_mat_2     = ', scat_mat_2, ' ; (Scatterer material number)'
  printf, unit, ' Scat_th_3      = ', scat_th_3, ' ; (microns) Last foil scattering thickness'
  printf, unit, ' Scat_mat_3     = ', scat_mat_3, ' ; (material number) Rear Foil'
  printf, unit, '; assume a rear gas cell'
  printf, unit, ' LC90    = ', lc90, ' ; Logical flag: 0=extraction , 1=radial  '
  printf, unit, ' GCell_2_press  = ', gcell_2_press, ' ; (torr) Gas Cell Fill Pressure'
  printf, unit, ' GCell_2_gas  = ', gcell_2_gas, ' ; Z of back gas cell fill'
  printf, unit, ' GCell_2_dist   = ', gcell_2_dist
  printf, unit, '; (cm) Distance from Scattering foil to back Gas Cell'
  printf, unit, ' GCell_2_Th = ', gcell_2_th, ' ; (microns) Mylar thickness'
  printf, unit, ' Spect_angle   = ', spect_angle
  printf, unit, '; (degrees) scattering angle relative to no scattering (up=+)'
  printf, unit, ' ph_dist_1 =  ', ph_dist_1, ' ; (cm) First pinhole distance from scat. foil'
  printf, unit, ' ph_mat    =  ', ph_mat, ' ; (Z) Pinhole foil Z'
  printf, unit, ' ph_thick  =  ', ph_thick, ' ; (microns) Pinhole foil thickness'
  printf, unit, ' ph_dist_2 =  ', ph_dist_2, ' ; (cm) Second pinhole distance from scat. foil'
  printf, unit, ' magnet_dist =', magnet_dist, ' ; (cm) Distance from foil to beginning of field'
  printf, unit, ' magnet_dia = ', magnet_dia, ' ; (cm) Diameter of magnet'
  printf, unit, ' Magnet_B   = ', magnet_b, ' ; (gauss) Magnetic Field in Spectrometer'
  printf, unit, ' CR39_radius =', cr39_radius, ' ; (cm) Radius of CR-39'
  printf, unit, ' Magnet_angle = [ $', magnet_angle , format = '(a, /,(9(f7.2,:,","), " $"), $)' 
  printf, unit, ' ]' 
  printf, unit, $
';        deflection angle from the center of the magnet to the exit point.'
  return
  end
