; ------------------------------------------------------------------------ 
; $Id: strip_spaces.pro,v 1.4 2007/06/06 19:34:33 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 function strip_spaces, ain
 COMPILE_OPT hidden

;+
;  strip all spaces from beginning and end of a string
;  strip extra spaces (5 or more) from the center of a string
;  and replace with ' - '
;  Only strip spaces to the first ;; 
;  Format: newstring= strip_spaces(fat_string)
;-
   if n_elements(ain) eq 0 then begin
     print, ' Error in call to strip_spaces, variable must be defined'
     return, ''
   endif
   b = size(ain(0))
   if (size(ain(0)))(1) ne  7 then begin
     print, ' Error in call to strip_spaces, variable must be a character'
     return, ain
   endif
   a = strtrim(ain(0), 2)
   maxlen = max([strpos(a, ';;'), strlen(a)]) 
   c = strpos(a, '     ')
   while (c gt 0) and (c lt maxlen) do begin
     cl = strlen(a) -c
     a = strmid (a, 0, c) + ' - ' + strtrim(strmid (temporary(a), c+3, cl), 1)
     c = strpos(a, '     ', c+3)
   endwhile
   return, a
   end
