; ------------------------------------------------------------------------ 
; $Id: wdigit_edit.pro,v 1.4 2007/06/06 19:34:33 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
;   This is designed to edit a curve and/or digitize a curve 
;   with the possibility of an overlay
;
 PRO wdigit_event, event
 COMPILE_OPT hidden

; The COMMON block is used because the event handler usually needs
; the window number and the size of the draw widget:
;
;  Common Blocks
;
      COMMON wdigitblock, win_num,wdrlabel,draw, x_im_sz,y_im_sz,xorig, $
        yorig,nporig
      Common ceditcurve, xval, yval, np, xover, yover, nover, xran, yran
      common wdigitevent, curoper, arr, narray, tempx, tempy,old_np, $
        old_x, old_y
      common colormap, cred, cgreen, cblue, cmagenta, corange, ccyan, $
        cyellow, cwhite
      common digitstuff, xlog, ylog, xscale, yscale, costheta, sintheta, $
         xinit, yinit, lxval, lyval, rxval, ryval
;  When a widget is manipulated,
;   put its User Value into the variable 'eventval':
;
      WIDGET_CONTROL, event.id, GET_UVALUE = eventval
; Perform actions based on the User Value of the event:
;
  CASE eventval OF
   'DRAW_WIN_EVENT': BEGIN
      CASE curoper of
         'DIGIT': digitize_data
         'ERASE': BEGIN
;            calculate the nearest point
             coord = convert_coord(event.x, event.y, /device, /to_data)
             if xlog eq 1 then dx=(alog10(coord[0])-lxval[0:np-1]) else $
                dx = xval[0:np-1]-coord[0]
             if ylog eq 1 then dy=(alog10(coord[1])-lyval[0:np-1]) else $
                dy = yval[0:np-1]-coord[1]
             m = min(((dx/xran)^2 + (dy/yran)^2), ip)
             if event.press EQ 1 then begin
                 delete_pnts , [ip, ip] 
                 if xlog eq 1 then $
                   lxval = alog10(xval[0:np-1]> rxval*max(xval))
                 if ylog eq 1 then $
                   lyval = alog10(yval[0:np-1]> ryval*max(yval))
                 
                 wdigit_plot, xval(0:np-1), yval(0:np-1), lin = 2, psym = -4, $
                   xr = !x.crange, yr = !y.crange ,  $
                   ytyp = ylog, xtyp = xlog
                 if nover gt 1 then  oplot, $
                   xover(0:nover-1), yover(0:nover-1), color = ccyan
                 curoper = 'WAIT'
                 widget_control, wdrlabel,set_value = $
                  'Pick an Activity or press DONE '
;                Clear events and make the draw widget insensitive 
                 widget_control, draw, /clear_events, sensitive = 0
              endif else begin
                 if arr gt 0 then plots, xval(arr), yval(arr), psym = 4
                 plots, xval(ip), yval(ip), color = cred, psym = 4
                 arr = ip
              endelse
              END
        'MERASE': BEGIN
;            calculate the nearest point
             coord = convert_coord(event.x, event.y, /device, /to_data)
             if xlog eq 1 then dx=(alog10(coord[0])-lxval[0:np-1]) else $
                dx = xval[0:np-1]-coord[0]
             if ylog eq 1 then dy=(alog10(coord[1])-lyval[0:np-1]) else $
                dy = yval[0:np-1]-coord[1]
             m = min(((dx/xran)^2 + (dy/yran)^2), ip)

             if event.press EQ 1 then begin
;                a point has been designated
                 if narray lt 0 then begin
                   narray = ip
                   arr = [ip, ip]
                   widget_control, wdrlabel,set_value = $
                   'Indicate the other end point for the points to be removed'
                 endif else begin
                   is = max([narray, ip], min = im)
                   delete_pnts , [im, is]
                   if xlog eq 1 then $
                     lxval = alog10(xval[0:np-1]> rxval*max(xval))
                   if ylog eq 1 then $
                     lyval = alog10(yval[0:np-1]> ryval*max(yval))

                   wdigit_plot, xval(0:np-1), yval(0:np-1), lin = 2, psym = -4, $
                     xr = !x.crange, yr = !y.crange , ytyp = ylog, xtyp = xlog
                   if nover gt 1 then oplot, $
                     xover(0:nover-1), yover(0:nover-1), color = ccyan
                   curoper = 'WAIT'
                   widget_control, wdrlabel,set_value = $
                   'Pick an Activity or press DONE '
;                Clear events and make the draw widget insensitive 
                    widget_control, draw, /clear_events, sensitive = 0
                 endelse
              endif else begin
                if narray lt 0 then begin
                   if arr gt 0 then plots, xval(arr), yval(arr), psym = 4
                   plots, xval(ip), yval(ip), color = cred, psym = 4
                   arr = ip
                endif else begin
                   s = arr(0)-1 
                   t = arr(1)+1 
                   is = max([narray, ip], min = im)
                   arr= [im, is]
                   if s gt -1 and t lt np then  begin 
                     plots, [xval(s),xval(t)], $
                       [yval(s), yval(t)], color = 0
                     if s lt  arr(0) then $
                     plots, xval(s:arr(0)), yval(s:arr(0)), lines=2, $
                       psym=-4, color = cwhite
                     if t gt arr(1) then $
                     plots, xval(arr(1):t), yval(arr(1):t), lines=2, $
                       psym=-4, color = cwhite
                   endif else begin
                     s = s> 0
                     t = t < np-1
                     if s lt arr(0) then $
                     plots, xval(s:arr(0)), yval(s:arr(0)), lines=2, $
                       psym=-4, color = cwhite
                     if t gt arr(1) then $
                     plots, xval(arr(1):t), yval(arr(1):t), lines=2, $
                       psym=-4, color = cwhite
                   endelse
                   plots, xval(arr(0):arr(1)), yval(arr(0):arr(1)), lines=2, $
                       psym=-4, color = cred
                   s = arr(0)-1 
                   t = arr(1)+1 
                   if s gt -1 and t lt np then $
                   plots, [xval(s),xval(t)], $
                       [yval(s), yval(t)], color = cgreen, psym = -4
                endelse
              endelse
              END
       'ADD': BEGIN
;            calculate the nearest point
             coord = convert_coord(event.x, event.y, /device, /to_data)
             if xlog eq 1 then dx=(alog10(coord[0])-lxval[0:np-1]) else $
                dx = xval[0:np-1]-coord[0]
             if ylog eq 1 then dy=(alog10(coord[1])-lyval[0:np-1]) else $
                dy = yval[0:np-1]-coord[1]
             m = min(((dx/xran)^2 + (dy/yran)^2), ip)

             if event.press EQ 1 then begin
;               a point has been designated
                if narray lt 0 then begin
                  narray = ip
                  widget_control, wdrlabel,set_value = $
                 'Indicate the new point to be added.'
                  arr= coord
                endif else begin
                  add_pnts , narray, coord
                  if xlog eq 1 then $
                    lxval = alog10(xval[0:np-1]> rxval*max(xval))
                  if ylog eq 1 then $
                    lyval = alog10(yval[0:np-1]> ryval*max(yval))

                  wdigit_plot, xval(0:np-1), yval(0:np-1), line = 2, psym = -4, $
                    xr = !x.crange, yr = !y.crange, ytyp = ylog, xtyp = xlog
                 if nover gt 1 then  oplot, $
                   xover(0:nover-1), yover(0:nover-1), color = ccyan
                  curoper = 'WAIT'
                  widget_control, wdrlabel,set_value = $
                  'Pick an Activity or press DONE '
;                 Clear events and make the draw widget insensitive 
                  widget_control, draw, /clear_events, sensitive = 0
                endelse
             endif else begin
;               we are moving the cursor over the plot
                if narray lt 0 then begin
;                 indicate the nearest point
                  if arr gt 0 then plots, xval(arr), yval(arr), psym = 4
                  plots, xval(ip), yval(ip), color = cred, psym = 4
                  arr = ip
                endif else begin
                  t = narray+1
                  if t lt np then  begin 
                    oplot, [xval(narray), arr(0), xval(t)], $
                      [yval(narray),arr(1),yval(t)], psym = -4,color= 0,line=2
                    oplot, xval(narray:t), yval(narray:t), lines=2, $
                      psym=-4, color = cwhite
                    oplot, [xval(narray), coord(0), xval(t)], $
                      [yval(narray),coord(1),yval(t)],psym= -4,color= cgreen, $
                       line=2
                  endif else begin
                    oplot, [xval(narray), arr(0)], $
                      [yval(narray), arr(1)], psym = -4, color = 0, line=2
                    oplot, [xval(narray), coord(0)], $
                      [yval(narray), coord(1)], psym= -4, color= cgreen, line=2
                  endelse
                  arr = coord
                endelse
              endelse
           END

         'ZOOM': BEGIN
;            calculate the nearest point
             coord = convert_coord(event.x, event.y, /device, /to_data)
             if event.press EQ 1 then begin
;            a point has been designated
                if narray lt 0 then begin
                   narray = 0
                   arr = coord
                   widget_control, wdrlabel,set_value = $
                   'Indicate opposite corner of the ZOOM region'
                 endif else begin
                   tempx = [min([arr(0), coord(0)], max = maxx) , maxx]
                   tempy = [min([arr(1), coord(1)], max = maxx) , maxx]
                   plot, xval(0:np-1), yval(0:np-1), lin = 2, psym = -4 ,$
                     yr = tempy, xr = tempx, ytyp = ylog, xtyp = xlog, /xst, /yst
                   if nover gt 1 then  oplot, $
                     xover(0:nover-1), yover(0:nover-1), color = ccyan
                   xran = (!x.crange(1) - !x.crange(0))/!d.x_size
                   yran = (!y.crange(1) - !y.crange(0))/!d.y_size
                   curoper = 'WAIT'
                   tempx = 0
                   widget_control, wdrlabel,set_value = $
                   'Pick an Activity or press DONE '
;                  Clear events and make the draw widget insensitive 
                    widget_control, draw, /clear_events, sensitive = 0
                 endelse
             endif else begin
;               we are moving the cursor over the plot
                if narray lt 0 then begin
;                 indicate the current point
                  if n_elements (arr) gt 1 then begin
                    oplot, [arr(0), arr(0)], !y.crange, color= 0, lines = 2
                    oplot, !x.crange, [arr(1), arr(1)], color= 0, lines = 2 
                  endif
                  arr = coord
                  oplot, [arr(0), arr(0)], !y.crange, color=cyellow, lines = 2
                  oplot, !x.crange, [arr(1), arr(1)], color=cyellow, lines = 2
                endif else begin
                  if (n_elements(tempx) gt 1) then $
                  oplot, [tempx(0), tempx(1), tempx(1), tempx(0), tempx(0)], $
                    [tempy(0), tempy(0), tempy(1), tempy(1), tempy(0)], $
                    color = 0, lines = 2  else begin
                    oplot, [arr(0), arr(0)], !y.crange, color= 0, lines = 2
                    oplot, !x.crange, [arr(1), arr(1)], color= 0, lines = 2 
                  endelse  
                  tempx = [min([arr(0), coord(0)], max = maxx) , maxx]
                  tempy = [min([arr(1), coord(1)], max = maxx) , maxx]
                  oplot, [tempx(0), tempx(1), tempx(1), tempx(0), tempx(0)], $
                    [tempy(0), tempy(0), tempy(1), tempy(1), tempy(0)], $
                    color = cyellow, lines = 2
                endelse
              endelse
           END

           ELSE: begin
                 wmessage, $
                  'Something is wrong-Pick another activity'
;                Clear events and make the draw widget insensitive 
                 widget_control, draw, /clear_events, sensitive = 0
                 curoper = 'WAIT'
           END
        ENDCASE
        END

   'DIGIT': if ((curoper eq 'DIGIT') or (curoper eq 'WAIT')) then digitize_data
   'ERASE': BEGIN
              if curoper eq 'WAIT' then begin
		; Set the window number - important for multiple windows
		WSET, win_num
                ; Find the point
                widget_control, draw, /clear_events, sensitive = 1
                curoper = 'ERASE'
                arr = -1
                narray = -1
                widget_control, wdrlabel,set_value = $
                  'Indicate the point to be removed'
              endif
             END
   'MERASE': BEGIN
              if curoper eq 'WAIT' then begin
		; Set the window number - important for multiple windows
		WSET, win_num
                curoper = 'MERASE'
                arr = -1
                narray = -1
                widget_control, draw, /clear_events, sensitive = 1
                widget_control, wdrlabel,set_value = $
                  'Indicate the first end point for the points to be removed'
              endif
             END
   'ADD': BEGIN
              if curoper eq 'WAIT' then begin
		; Set the window number - important for multiple windows
		WSET, win_num
;               Find the point
                if np lt min ([n_elements(xval), n_elements(yval)])then begin
                  arr = -1
                  curoper = 'ADD'
                  narray = -1
                  widget_control, draw, /clear_events, sensitive = 1
                  widget_control, wdrlabel,set_value = $
                 'Indicate the point immediately before the point to be added.'
                endif else print, $
                  'Sorry cannot add more points until some are deleted'
              endif
             END

      'UNDO': BEGIN
              if curoper eq 'WAIT' then begin
		; Set the window number - important for multiple windows
		WSET, win_num
                np = old_np
                xval = old_x
                yval = old_y
                if xlog eq 1 then $
                  lxval = alog10(xval[0:np-1]> rxval*max(xval))
                if ylog eq 1 then $
                  lyval = alog10(yval[0:np-1]> ryval*max(yval))
                ; Redraw the image
                wdigit_plot, xval(0:np-1), yval(0:np-1), lin = 2, psym = -4, $
                  xr = !x.crange, yr = !y.crange, ytyp = ylog, xtyp = xlog
                if nover gt 1 then oplot, $
                   xover(0:nover-1), yover(0:nover-1), color = ccyan
              endif
             END

   'REDRAW': BEGIN
              if curoper eq 'WAIT' then begin
		; Set the window number - important for multiple windows
		WSET, win_num
                ; Redraw the image
                xmin= min(xval(0:np-1), max = xmax)
                ymin= min(yval(0:np-1), max = ymax)
                
                if keyword_set(xlog) then xmin =rxval*xmax
                if keyword_set(ylog) then ymin =ryval*ymax

                plot, xval(0:np-1), yval(0:np-1), lin = 2, psym = -4 , $
                   ytyp = ylog, xtyp = xlog, xr = [xmin, xmax], yr =[ymin,ymax]
                if nover gt 1 then oplot, $
                   xover(0:nover-1), yover(0:nover-1), color = ccyan
                xran = (!x.crange(1) - !x.crange(0))/!d.x_size
                yran = (!y.crange(1) - !y.crange(0))/!d.y_size
              endif
             END

   'ZOOM': BEGIN
              if curoper eq 'WAIT' then begin
		; Set the window number - important for multiple windows
		WSET, win_num
                widget_control, draw, /clear_events, sensitive = 1
                widget_control, wdrlabel,set_value = $
                  'Indicate one corner of the ZOOM region'
                arr = -1
                narray = -1
                curoper = 'ZOOM'
              endif
             END

  'CANCEL': BEGIN
            widget_control, draw, /clear_events, sensitive = 0
            curoper = 'WAIT'
;           Use PLOT to display an image in the draw widget.
            WSET, win_num
            wdigit_plot, xval(0:np-1), yval(0:np-1), lin = 2, psym = -4 ,$
               xr = !x.crange, yr = !y.crange , ytyp = ylog, xtyp = xlog
            if nover gt 1 then oplot, $
               xover(0:nover-1), yover(0:nover-1), color = ccyan
            END

   'QUIT': BEGIN
             if curoper eq 'WAIT' then begin
               WIDGET_CONTROL, event.top, /DESTROY
               xval = xorig
               yval = yorig
               np = nporig
             endif
           END

   'DONE': BEGIN
                    WIDGET_CONTROL, event.top, /DESTROY
           END
      ENDCASE

      END
;
  PRO   wdigit_plot, x, y, linestyle = lin, psymbol = psym, $
                  xrange = xrange, yrange = yrange, ytype = ylog, xtype = xlog
  COMPILE_OPT hidden

          if xlog ne 0 then xrange = 10^xrange
          if ylog ne 0 then yrange = 10^yrange
          plot, x, y, lin = lin, psym = psym, /xstyle, /ystyle, $
                  xrange =xrange, yrange = yrange, ytyp = ylog, xtyp = xlog
        return
        end

 PRO   wdigit_edit,digit = digit,  XSIZE=xsizein, YSIZE=ysizein, $
        modal = modal, GROUP=GROUP, xtype = xtype, xlog = xlogin,  $
        ytype = ytype, ylog = ylogin, _extra = extra_stuff

 COMPILE_OPT hidden
;
; This is the procedure that creates a draw widget for digitizing and editing.
;
; The COMMON block is used because the event handler usually needs
; the window number, the size of the draw widget, and other stuff.
; Names of common variables must be distinct from keyword variables.
;
      common digitstuff
      COMMON wdbaseblock, base
      COMMON wdigitblock, win_num,wdrlabel,draw, x_im_sz,y_im_sz, $
          xorig, yorig,nporig
      common get_data_values, xmin, xmax, ymin, ymax, y0, y1, x0, x1
      Common ceditcurve, xval, yval, np, xover, yover, nover, xran, yran
      common wdigitevent, curoper, arr, narray, tempx, tempy,old_np, $
          old_x, old_y
      common colormap, cred, cgreen, cblue, cmagenta, corange, ccyan, $
          cyellow, cwhite
  common pffcom, initpff, pff_exe
@draw_defaults.com
  if n_elements(initpff) eq 0 then init_pff

;
;  if digit is not set then we are just editing
;

   if keyword_set(xlogin) then xlog = 1 else xlog =0
   if keyword_set(xtype) then xlog = 1
   if keyword_set(ylogin) then ylog = 1 else ylog =0
   if keyword_set(ytype) then ylog = 1
   
   xmin= min(xval(0:np-1), max = xmax)
   ymin= min(yval(0:np-1), max = ymax)

   if keyword_set(xlog) then begin
     if xlogin lt 1 then rxval = xlogin else rxval = 1e-4
     if xlogin gt 1 then rxval = 1.0/xlogin
     xmin =rxval*xmax
     lxval = alog10(xval[0:np-1] > xmin)
   endif 
   if keyword_set(ylog) then begin
     if ylogin lt 1 then ryval = ylogin else ryval = 1e-4
     if ylogin gt 1 then ryval = 1.0/ylogin
     ymin =ryval*ymax
     lyval = alog10(yval[0:np-1] > ymin)
   endif
   
      if n_elements (digit) eq 0 then digit = 0
;  do the color table
      loadxyct
      if !d.table_size gt 256 then  $
        colscale = !d.table_size/255 else colscale = 1
      cred = 1*colscale
      cgreen = 2*colscale
      cblue = 3*colscale
      cmagenta = 4*colscale
      corange = 5*colscale
      ccyan = 6*colscale
      cyellow = 7*colscale
      cwhite  = 8*colscale
;
; The size of the draw area is one of the more important parameters
; for a draw widget.  This example uses keywords to define the size
; of the draw area.  An alternative would be to use a fixed size draw area. 
;
  if n_elements(xsizein) eq 0 then x_size = bigsize(0) else x_size = xsizein
  if n_elements(ysizein) eq 0 then y_size = bigsize(1) else y_size = ysizein

;
; A top-level base widget with the title "Simple Draw Widget Example"
; will be created.  The size is left unspecified until the draw widget
; is created.
; Save the initial points.
;   and save the current values in the old values for "REDO"
      old_np = np
      nporig = np
      old_x = xval
      xorig = xval
      yorig = yval
      old_y = yval
;  Set the base widget
      base = WIDGET_BASE(TITLE = 'Edit Data', /COLUMN)
;
;  Now the Instructional widget base
;
      insbase =  WIDGET_BASE(base, /ROW, /FRAME)
;
; A widget for instructional text is created
;
      wdrlabel = WIDGET_LABEL(insbase, VALUE = 'Instructions:')
      wdrlabel = WIDGET_Text(insbase, xsize = 100, edit= 0, $
          value = 'Pick an Activity or press DONE ')
;  Now a base with the draw on the left and a column of buttons on the right
;
      dbase =  WIDGET_BASE(base, /ROW, /FRAME)
      lcol =  WIDGET_BASE(dbase, /COLUMN, /FRAME)
      rcol =  WIDGET_BASE(dbase, /COLUMN, /FRAME)
;
;  A widget called 'draw' is created.
      draw = WIDGET_DRAW(lcol, $
	/BUTTON_EVENTS, $	;generate events when buttons pressed
        /MOTION_EVENTS, $	;generate events when cursor moves over window
	/FRAME, $
	UVALUE = 'DRAW_WIN_EVENT', $
	RETAIN = 2, $		;make sure draw is redrawn when covered
	XSIZE = x_size, $
	YSIZE = y_size)
;
;  Now the buttons on the right
;
;  The DONE button:
      button1 = WIDGET_BUTTON(rcol, $
		UVALUE = 'DONE', $
		VALUE = 'DONE - EXIT')
;
;  Make a button which will digitize points if digit is nonzero
      if digit ne 0 then button10 = WIDGET_BUTTON(rcol, $
		UVALUE = 'DIGIT', $
		VALUE = 'DIGITIZE POINTS')
;
;  Make a button which will delete a point.
      button9 = WIDGET_BUTTON(rcol, $
		UVALUE = 'ERASE', $
		VALUE = 'DELETE A POINT')

;  Make a button which will delete a several points.
      button2 = WIDGET_BUTTON(rcol, $
		UVALUE = 'MERASE', $
		VALUE = 'DELETE A LINE')

;  Make a button which will add a point
      button8 = WIDGET_BUTTON(rcol, $
		UVALUE = 'ADD', $
		VALUE = 'ADD A POINT')

;  Make a button which will undo the last change
      button3 = WIDGET_BUTTON(rcol, $
		UVALUE = 'UNDO', $
		VALUE = 'UNDO LAST ACTION')

;  Make a button which will zoom the display 
      button4 = WIDGET_BUTTON(rcol, $
		UVALUE = 'ZOOM', $
		VALUE = 'ZOOM')

;  Make a button which will redisplay the image.
      button5 = WIDGET_BUTTON(rcol, $
		UVALUE = 'REDRAW', $
		VALUE = 'REDRAW')

;  Make a button which will cancel the current activity
      button7 = WIDGET_BUTTON(rcol, $
		UVALUE = 'CANCEL', $
		VALUE = 'CANCEL ACTIVITY')

;  Make a button which will quit without saving the changes
      button6 = WIDGET_BUTTON(rcol, $
		UVALUE = 'QUIT', $
		VALUE = 'QUIT WITHOUT SAVING')

;  Realize the widgets:
;
      WIDGET_CONTROL, base, /REALIZE
;
;  Get the window number from the draw widget.  This can only be done
;  after the widget has been realized.
;
      WIDGET_CONTROL, draw, GET_VALUE=win_num
      WSET, win_num
;
; Clear events and make the draw widget insensitive 
;
      if digit ne 0 then begin
        widget_control, wdrlabel,set_value = $
          'Mouse Buttons: Yellow = Digitize, ' + $
          'White = Delete Last Point, Green = Finished'
;
        widget_control, draw, /clear_events, sensitive = 0
        curoper = 'DIGIT'

        plot, xval(0:1), yval(0:1), /nodata, lin = 2, psym = -4, $
           xr = [xmin, xmax], yr = [ymin,ymax], ytyp = ylog, xtyp = xlog
        digitize_data
      endif else begin
;        
        widget_control, wdrlabel,set_value = $
                  'Pick an Activity or press DONE '
        widget_control, draw, /clear_events, sensitive = 0
        curoper = 'WAIT'
        plot, xval(0:np-1), yval(0:np-1), lin = 2, psym = -4, $
          ylog = ylog, xlog = xlog, xr = [xmin, xmax], yr = [ymin,ymax]
      endelse
;
;  Set the range for x and y
;
       xran = (!x.crange(1) - !x.crange(0))/!d.x_size
       yran = (!y.crange(1) - !y.crange(0))/!d.y_size
;  Over plot the other curve
;
        if nover gt 1 then oplot, xover(0:nover-1), yover(0:nover-1), $
                      color = ccyan
;        
;  Set the common values for the image size
      x_im_sz = x_size
      y_im_sz = y_size
;
;  Hand off control of the widget to the XMANAGER:
;
      XMANAGER, "wdigit", base, GROUP_LEADER=GROUP, modal = modal
;
      END
