; ------------------------------------------------------------------------ 
; $Id: window_it.pro,v 1.4 2011/05/19 13:45:32 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro window_it, ww, minw, maxw, vert, attr, nvert, m, n, error =error, quiet = quiet
;+
; format: window_it, w, minw, maxw, vert, attr, nvert, m, n, error = error, quiet = quiet
; window vert and attr for particle data
; If all data would be removed, nvert is set to zero but nothing is changed
;-
;

on_error, 1
  if n_elements (ww) eq 0 then begin
    if not keyword_set(quiet) then print, '%WINDOW_IT: W must be defined'
    return
  endif
  w = ww(0)
  if n_elements (error) eq 0 then err = 0.0 else err = abs(error)
  if w gt 0 then begin
    if  w gt m then begin
      if not keyword_set(quiet) then print, '%WINDOW_IT - Error, Invalid value of W space', w, m
      return
    endif
    ok = where (vert(*, w-1) ge minw-err and vert(*, w-1) le maxw+err, nvert)    
    if nvert eq 0 then begin
      if not keyword_set(quiet) then print, 'Filter Vertex:', w , minw, maxw, ' removes all data'
      return
    endif
  endif else begin
    w = -w
    if w gt n or w le 0 then begin
      if not keyword_set(quiet) then print, '%WINDOW_IT - Error, Invalid value of W - Attribute', w, n
      return
    endif
    ok = where (attr(*, w-1) ge minw-err and attr(*, w-1) le maxw+err, nvert)    
    if nvert eq 0 then begin
      if not keyword_set(quiet) then print, 'Filter Attr:', w , minw, maxw, ' removes all data'
      return
    endif
  endelse
  vert = temporary(vert(ok, *))
  attr = temporary(attr(ok, *))
  return
  end
