; ------------------------------------------------------------------------ 
; $Id: write_mitl_src.pro,v 1.3 2007/06/06 19:34:33 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 PRO write_mitl_src, unit, dx, dt, outdt, totalt, zsource, $
                   stype, wdfa, rtype, tpeak, ftype, tfall, twidth, $
                   umax, ltype, wdfb, rltype, tlpeak, fltype, tlfall, $
                   tlwidth, peakz, plmass, plength, pradius, plmin, $
                   plret, lcflow, qemit, lcflash
;
on_error, 2
 if n_elements (dx) eq 1 then $
 printf,unit,' Dx = ',strtrim(dx,2),' ; Axial Grid Spacing (m)' 

 if n_elements (dt) eq 1 then $
 printf,unit,' Dt = ',strtrim(dt,2),' ; Calculational Time Step (ns)' 

 if n_elements (lcflow) eq 1 then begin
    printf,unit,' LCFlow = ',strtrim(lcflow,2),' ; Logical for electron flow' 
    printf,unit,'         ;  0 = No Flow; 1 = Normal MITL Flow'
 endif

 if n_elements (lcflash) eq 1 then begin
   printf,unit,' LCFlash = ',strtrim(lcflash,2),' ; Logical for insulator flash' 
   printf,unit,'         ;  0 = No Flash; 1 = Flash when V=0 at start of emission'
 endif

 if n_elements (qemit) eq 1 then $
    printf, unit, ' Qemit = ', strtrim(qemit, 2), $
      ' ; Emission threshold for emission (Er*Rc)'

 if n_elements (outdt) eq 1 then $
 printf,unit,' OutDt = ',strtrim(outdt,2),' ; Output Time Step (ns)' 

 if n_elements (totalt) eq 1 then $
 printf,unit,' TotalT = ',strtrim(totalt,2),' ; Total Duration of Calc. (ns)'

 if n_elements (umax) eq 1 then $
 printf,unit,' Umax = ',strtrim(umax,2),' ; Peak Voltage (MV)' 

 if n_elements (zsource) eq 1 then $
 printf,unit,' Zsource = ',strtrim(zsource,2),'; Source Impedance (ohms)'

 if n_elements (stype) eq 1 then begin
 printf,unit,' Stype = ',strtrim(stype,2),' ; Source Type Index'
 printf,unit,'         ;  0 = Analytic; 1 = WDF array'
 endif

 if n_elements (wdfa) eq 1 then $
 printf,unit,' WDFA = ',strtrim(wdfa,2),' ; Waveform Array for Source'

 if n_elements (rtype) eq 1 then begin
 printf,unit,' Rtype = ',strtrim(rtype,2),' ; Source Rise Type'
 printf,unit,'         ;  0 = Linear; 1 = Sine^2; 2 = t exp(-t)'
 endif

 if n_elements (tpeak) eq 1 then $
 printf,unit,' Tpeak = ',strtrim(tpeak,2),' ; Source Time to Peak (ns)'

 if n_elements (ftype) eq 1 then begin
 printf,unit,' Ftype = ',strtrim(ftype,2),' ; Source Fall Type'
 printf,unit,'         ;  0 = Linear; 1 = Sine^2; 2 = t exp (-t)'
 endif

 if n_elements (tfall) eq 1 then $
 printf,unit,' Tfall = ',strtrim(tfall,2),' ; Fall Time Beginning (ns)' 

 if n_elements (twidth) eq 1 then $
 printf,unit,' Twidth = ',strtrim(twidth,2),' ; Half Width of Fall (ns)' 

 if n_elements (ltype) eq 1 then begin
 printf,unit,' Ltype = ',strtrim(Ltype,2),' ; Load type' 
 printf,unit,'         ;  0 = Constant; 1 = Falling; 2 = Rising/Falling;'
 printf,unit,'         ;  3= WDF Array; 4 = Imploding Plasma; 5= Ion Diode'
 endif

 if n_elements (wdfb) eq 1 then $
 printf,unit,' WDFB = ',strtrim(wdfb,2),' ; Waveform Array for Load'

 if n_elements (peakz) eq 1 then $
 printf,unit,' PeakZ = ',strtrim(peakz,2),' ; Peak Load Impedance'

 if n_elements (rltype) eq 1 then begin
 printf,unit,' RLtype = ',strtrim(rltype,2),' ; Load Rise type'
 printf,unit,'         ;  0 = Linear; 1 = Sine^2; 2 = t exp (-t)'
 endif

 if n_elements (tlpeak) eq 1 then $
 printf,unit,' TLpeak = ',strtrim(tlpeak,2),' ; Load Time to Peak (ns)'

 if n_elements (fltype) eq 1 then begin
 printf,unit,' FLtype = ',strtrim(fltype,2),' ; Load Rise type'
 printf,unit,'         ;  0 = Linear; 1 = Sine^2; 2 = t exp (-t)'
 endif

 if n_elements (tlfall) eq 1 then $
 printf,unit,' TLfall = ',strtrim(tlfall,2),' ; Load Fall Time Begin (ns)'

 if n_elements (tlwidth) eq 1 then $
 printf,unit,' TLwidth = ',strtrim(tlwidth,2),' ; Load Fall Half Width (ns)'

 if n_elements (plmass) eq 1 then $
 printf,unit,' PLMass = ',strtrim(plmass,2),' ; Plasma Load Mass (mg/cm)'

 if n_elements (plength) eq 1 then $
 printf,unit,' PLength = ',strtrim(plength,2),' ; Plasma Load Length (cm)'

 if n_elements (pradius) eq 1 then $
 printf,unit,' PRadius = ',strtrim(pradius,2),' ; Plasma Load Init Rad (cm)'

 if n_elements (plmin) eq 1 then $
 printf,unit,' PLmin = ',strtrim(plmin,2),' ; PL Final to Init Radius (%)'

 if n_elements (plret) eq 1 then $
 printf,unit,' PLret = ',strtrim(plret,2),' ; PL Return Current Radius (cm)'

 return
 end
