; ------------------------------------------------------------------------ 
; $Id: wsave_nosave.pro,v 1.4 2007/06/06 19:34:34 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
;
;+
;   Purpose: give the user a choice of 'Saving ' or 'Quit Without Saving'
;   Format:
;     wsave_nosave, lcquit, string1, string2
;     where , lcquit = 0 if Save Values
;             lcquit = 1 if Quit Without Saving
;             string1 is the question, This may be an array
;             string2 is the title for the widget
;      Example
;         wsave_nosave, lcnok, [ 'There is a LINEOUT defined', $
;                'Do you want to save it before EXIT'] $
;                 'Linstr EXIT'
;-
 pro wsave_nosave_event, event
 COMPILE_OPT hidden

    but = event.value
    widget_control, event.top, get_uvalue = info, /no_copy
    case but of 

 'QUIT' : BEGIN
          quitit = 1
          END
 'OK' : BEGIN
          quitit = 0
          END
     ELSE: Print, ' Not a known event'
     endcase
     value = {quit: quitit}
     widget_control, info.ptr, set_uvalue = value, /no_copy
     widget_control, event.top, /destroy
     end
 Pro wsave_nosave, lcquit, string1, string2, group = group
 COMPILE_OPT hidden

;
     if n_elements (string2) eq 0 then string2 = 'SAVE MENU'
     if n_elements (group) eq 0 then base = widget_base(/column, title=string2) $
 else base = widget_base(/column, title= string2, /modal , group = group)
      nstr1 = n_elements(string1)
     if nstr1 eq 0 then string1 = 'Save and Exit or Quit with Saving'
     wdrlabel = WIDGET_LABEL(base, VALUE = ' ')
     if nstr1 lt 2 then $
       wdrlabel = WIDGET_LABEL(base, VALUE = string1) else $
       for i = 1, nstr1 do wdrlabel = WIDGET_LABEL(base, VALUE = string1(i-1))
     wdrlabel = WIDGET_LABEL(base, VALUE = ' ')
     menu = make_array(2, /string)
     menu(0) = '     Save Values and Exit       ' 
     menu(1) = '      Exit Without Saving       '
     but = cw_bgroup(base, menu,/row, button_uvalue =['OK','QUIT'])
     ptr = widget_base()
     widget_control, base, /realize
     info = {ptr:ptr}
     widget_control, base, set_uvalue = info
     value = {quit:0}
     widget_control, ptr, set_uvalue = value
     xmanager, 'wsave_nosave', base
     widget_control, ptr, get_uvalue = value
     widget_control, ptr, /destroy
     lcquit = value.quit
     return
     end
