; ------------------------------------------------------------------------ 
; $Id: wselect_item.pro,v 1.9 2009/03/04 19:26:00 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
;
;+
;   form: wselect_item, list, selected = selected, exclusive = exclusive
;         list is a list of items to be selected
;         selected is an array with the same number of elements as list
;            array values are zero if they are not selected
;            array values are one if they are selected
;         exclusive is set for an exclusive widget.
; 
;         put "common wselect_com, selected" in the calling program to get results
;         or use keyword SELECTED.
; 
;  Modified July 26, 2005 - LPM 
;     Removed obsolete routine XMENU and added keywords
;   
;-
 Pro wselect_event, event
 COMPILE_OPT hidden
 on_error, 2

; This procedure is the event handler for a non-exclusive menu widget.

; Use WIDGET_CONTROL to get the VALUE of any action and put it into 'value':
;
  common wselect_com, array
  common wselect_work, cwbg
;
WIDGET_CONTROL, event.id, GET_VALUE = value, GET_UVALUE=eventval

 CASE string(eventval) of 
   'ALL':  BEGIN
                    widget_control,cwbg , get_value = array
                    if total(array) gt (n_elements(array)/2) then begin
                      array(0:*) = 0
                      widget_control, cwbg, set_value = array
                    endif else begin
                      array(0:*) = 1
                      widget_control, cwbg, set_value = array
                    endelse
           END
   'DONE': BEGIN
                    widget_control, cwbg, get_value = array
                    WIDGET_CONTROL, event.top, /DESTROY
           END
   'BUTTONS': BEGIN
           widget_control, cwbg, get_value = value
           array = value
           end
    endcase 
END

 Pro wselect_item, listin, selected = selected, exclusive = exclusiv, $
     instructions = instructions
 COMPILE_OPT hidden
 on_error, 2
; This procedure creates a non-exclusive menu widget.
  common wselect_com, selarray
  common wselect_work, cwbg
  if keyword_set(exclusiv) then exclu = 1 else exclu = 0
  if size(listin, /type) ne 7 then list = string(listin) else list = listin
  nel = n_elements (list) 
; Make the top-level base widget:
base = WIDGET_BASE(TITLE = 'Select Desired Items', /COLUMN )
if n_elements (instructions) gt 0 then begin
  nelinst = n_elements(instructions)
  for i = 0, nelinst-1 do $
    tx = widget_label(base, /align_center, value = instructions[i])
endif
;
nonexclu = (exclu +1) mod 2
cwbg = cw_bgroup(base, list, exclusive = exclu, nonexclusive = nonexclu, $
     /no_release, col = 1+nel/28, uvalue = 'BUTTONS')
if not keyword_set(exclu) then $
  button = WIDGET_BUTTON(base, VALUE = 'Select ALL', UVALUE = 'ALL')
button = WIDGET_BUTTON(base, VALUE = 'DONE', UVALUE = 'DONE')
; Realize the widgets:
WIDGET_CONTROL, base, /REALIZE
 if keyword_set (exclu) then begin
   selarray = (n_elements(selected) eq 1) ? selected : 0 
   selarray = (selarray > 0) < (n_elements(list)-1)
 endif else selarray = $
   (n_elements(selected) eq nel) ? selected : make_array(nel, /int, value = 1)
 widget_control, cwbg, set_value = selarray
   
; Hand off to the XMANAGER:
XMANAGER, 'wselect', base, GROUP_LEADER = GROUP
selected = selarray
end
