; ------------------------------------------------------------------------ 
; $Id: make_material.pro,v 1.4 2007/06/29 13:42:44 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
;+
; Utility to make filter_material.pff
;   Not for general use
;-


 pro make_material
 openr, unit, /get, '/home/work/dir.dat'
  str = ''
 readf, unit, str
 createpff, '/home/work/filter_material.pff'
 pff_precision, /full, /all
 end_of_data =0
 while end_of_data eq 0 do begin
   readf, unit, str
   ok = strpos(str, ';;')
   if ok gt 0 then begin
     comment = strtrim(strmid(str, ok+2), 2)
     str = strmid(str, 0, ok)
   endif else comment = ''
   br = strsplit(str, leng= leng)
   elem = strmid(str, br[0], leng[0])
   if n_elements (br) ne 4 then begin
     if elem ne 'END_OF_DATA' then $
       print, '% MAKE_MATERIAL: Bad ending, ', elem, str
     end_of_data =1
   endif else begin
     zval = strmid(str, br[1], leng[1])
     Aweight = strmid(str, br[2], leng[2])
     den = strmid(str, br[3], leng[3])
     i = strpos(elem, '(')
     cc = strlowcase(elem)
     if i gt 0 then begin
       filt = '/home/work/'+ strmid(elem, 0, i)+'.dat'
       cc= strupcase(strmid(cc, 0, 1))+strmid(cc, 1, i) + $
         strupcase(strmid(cc, i+1, 1)) +strmid(cc, i+2)
     endif else begin
       cc= strupcase(strmid(cc, 0, 1))+strmid(cc, 1)
       filt = '/home/work/'+ elem +'.dat'
     endelse
     if i gt 0 then cc = cc+' - Z='+zval+';;AWeight='+aweight+';;Density='$
        +den+';;'+comment else cc= cc+' - Density='+den+';;'+comment
     read_filter, 1, filt
     cha, 1, clab= cc, xlabel='Energy(eV)', $
         ylabel =  'Mass Absorption Coef.(cm2/g)'
     wri, 1, tlabel= 'Mass Atten.'
   endelse
endwhile
closepff

end
