; ------------------------------------------------------------------------ 
; $Id: init_cdf.pro,v 1.5 2008/02/27 22:51:09 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
  pro init_cdf
;+
;  Initialize CDF common block
;-
on_error, 1
@netcdfcom.dat
;
common copyright_common, copyright_init
;
      if n_elements (copyright_init) eq 0 then copyright_notice

;     CDF common block
;     All variables except initcdf will have an underscore.
;     initcdf      - flag for initialization
;     max_cdffile   - Maximum number of cdf files
;     cdf_id        - File ID of current file 
;     array_cdfid  - Array of user file ID's
;                    Second index is an identifier
;                    Third index is read_only = 0
;                                   read_write = 1
;     cdf_type      - Array of file types
;                    1 ExodusII data, Version 2
;                    2 WDF array data
;                    3 N-Dimensional Matrix Uniform
;                    4 N-Dimensional Matrix Non-Uniform
;     num_glo_var  - Number of time histories, or wdf arrays, in each file
;                    In Exodus file this is the number of global variables
;     num_nod_var  - Number of nodal variables
;     num_elem_var - Number of element or cell type variables 
;     file_title   - Title for the file
;     file_name    - Name of the file
;
     max_cdffile   = 16
     cdf_id        = -1
     fcdf_id       = make_array(max_cdffile, value = -1L, /long)
     api_version   = make_array(max_cdffile, value = 0.0)
     array_cdfid   = make_array(max_cdffile, 3, /int)
     cdf_type      = make_array(max_cdffile, /int, value = -1)
     num_glo_var   = make_array(max_cdffile, /int)
     num_nod_var   = make_array(max_cdffile, /int)
     num_elem_var  = make_array(max_cdffile, /int)
     file_title    = make_array(max_cdffile, /string)
     file_name     = make_array(max_cdffile, /string)
;    The file size attribute is 0 or 1 - use 0.5 to switch
     api_change    = 0.5
     osver = strupcase(strmid(!version.os, 0, 3))
     if osver eq 'HP-' then begin
       initcdf = 1
     endif else if osver eq 'SUN' then begin
       initcdf = 1
     endif else if osver eq 'WIN' then begin
       initcdf = 2
     endif else initcdf = 1
      return
      end
