; ------------------------------------------------------------------------
; $Id: init_exodus.pro,v 1.3 2008/02/27 22:48:12 lpmix Exp $
; ------------------------------------------------------------------------
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
;+
; NAME:
;       INIT_EXODUS
;
; PURPOSE:
;       Initialize the exodus common blocks.
;
; CALLING SEQUENCE:
;       INIT_EXODUS
;
; MODIFICATION HISTORY:
; 	Written by:	L. P. Mix, Jr., September 29, 2005
;-
pro init_exodus

on_error, 1
@exoduscom.dat
common copyright_common, copyright_init

;
;
      if n_elements (copyright_init) eq 0 then copyright_notice
;
     lexo_valid     = -1
     max_exofile   = 16
     exo_id        = -1
     api_version   = make_array(max_exofile, value = 0.0)
     fexo_id       = make_array(max_exofile, value = -1L, /long)
     array_exoid   = make_array(max_exofile, 3, /int)
     exo_type      = make_array(max_exofile, /int, value = -1)
     num_dim       = make_array(max_exofile, /int)
     num_glo_var   = make_array(max_exofile, /int)
     num_nod_var   = make_array(max_exofile, /int)
     num_elem_var  = make_array(max_exofile, /int)
     num_elem_blk  = make_array(max_exofile, /int)
     file_title    = make_array(max_exofile, /string)
     file_name     = make_array(max_exofile, /string)
;    The file_size attribute is zero or 1 - use 0.5 
     api_change    = 0.5

     osver = strupcase(strmid(!version.os, 0, 3))
     if osver eq 'HP-' then begin
       init_exo = 1
     endif else if osver eq 'SUN' then begin
       init_exo = 1
     endif else if osver eq 'IRI' then begin
       init_exo = 1
     endif else if osver eq 'WIN' then begin
       init_exo = 2
     endif else init_exo = 1

END
