pro check_orient_event, event
common check_orient_common, vim_0, vim_2, vim_5, vim_7, win4, val 

 widget_control, event.id, get_uvalue = uval
 case UVAL of
  'Button0': begin
     wset, win4
     tv, congrid(vim_0, 500, 300)
     val = 0
   end
  'Button2': begin
     wset, win4
     tv, congrid(vim_2, 500, 300)
     val = 2
   end
  'Button5': begin
     wset, win4
     tv, congrid(vim_5, 500, 300)
     val = 5
   end
  'Button7': begin
     wset, win4
     tv, congrid(vim_7, 500, 300)
     val = 7
   end
  'Quit': begin
     widget_control, event.top, /destroy
   end
  ELSE: Print, 'No Handler for event: ', UVAL 
  ENDCASE
end

pro check_orient, orient
;
common check_orient_common, vim_0, vim_2, vim_5, vim_7, win4, val

; Determine the orientation of the image from the micro D
;
; 
on_error, 2

orient = -1
sep = path_sep()
fil = get_pfidl_directory()+'pfidl'+sep+'local'+sep+'data'+sep+'bimage_250_150.dat'
openr, unit, /get, fil, error= ier
if ier ne 0 then begin
  print, '% CHECK_ORIENT: Unable to open file: ', fil
  return
endif
vim = make_array(250, 150, /byte)
readf, unit, vim
free_lun, unit

vim_0 = rotate(vim, 7)
vim_2 = rotate(vim, 5)
vim_5 = rotate(vim, 2)
vim_7 = temporary(vim)

tlb = widget_base(title = 'Pick Image Orientation', /column)

top = widget_base(tlb, /row)
b0 = widget_base(top, /row)
but0 = widget_button(b0, value = '0', uvalue = 'Button0')
draw0 = widget_draw(b0, xsize = 250, ysize = 150)

b1 = widget_base(top, /row)
but1 = widget_button(b1, value = '1', uvalue = 'Button2')
draw1 = widget_draw(b1, xsize = 250, ysize = 150)

bot = widget_base(tlb, /row)
b2 = widget_base(bot, /row)
but2 = widget_button(b2, value = '2', uvalue = 'Button5')
draw2 = widget_draw(b2, xsize = 250, ysize = 150)
b3 = widget_base(bot, /row)
but3 = widget_button(b3, value = '3', uvalue = 'Button7')
draw3 = widget_draw(b3, xsize = 250, ysize = 150)

done= widget_button(tlb, value = 'Orientation Selection Complete', uvalue = 'Quit')
txt = widget_label(tlb, /align_center, value = 'Selected Orientation Below')
draw4 = widget_draw(tlb, /align_center, xsize = 500, ysize =300 )

widget_control, tlb, /realize
widget_control, draw0, get_value = win0
widget_control, draw1, get_value = win1
widget_control, draw2, get_value = win2
widget_control, draw3, get_value = win3
widget_control, draw4, get_value = win4

wset, win0
tv, vim_0
wset, win1
tv, vim_2
wset, win2
tv, vim_5
wset, win3
tv, vim_7

wset, win4
tv, congrid(vim_0, 500, 300)
orient = 0
xmanager, 'check_orient', tlb

orient = val
end
