;code to make wKillFull initial checked insert after call to widget_control /realise line
;  wKillFull=Widget_info(WID_BASE_0, find_by_uname="WID_KILL_FULL")
;  widget_control, wKillFull, /SET_BUTTON
;end code to make wkillFull initial checked

; IDL Event Callback Procedures
; gideon1_eventcb
;
; Generated on:	04/03/2006 17:42.35
;
;-----------------------------------------------------------------
; Activate Button Callback Procedure.
; Argument:
;   Event structure:
;
;   {WIDGET_BUTTON, ID:0L, TOP:0L, HANDLER:0L, SELECT:0}
;
;   ID is the widget ID of the component generating the event. TOP is
;       the widget ID of the top level widget containing ID. HANDLER
;       contains the widget ID of the widget associated with the
;       handler routine.

;   SELECT is set to 1 if the button was set, and 0 if released.
;       Normal buttons do not generate events when released, so
;       SELECT will always be 1. However, toggle buttons (created by
;       parenting a button to an exclusive or non-exclusive base)
;       return separate events for the set and release actions.

;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
;**TODO: add option to change /noconvert in readinfpcb function
pro OnBrowse, Event

  fn=dialog_pickfile(filter='*.inf')

; get the Widget ID of the filename edit control
  wTextFilename = Widget_Info(Event.top, find_by_uname="WID_FILENAME")

; Now update the mapping.
  widget_control, wTextFilename, SET_VALUE=fn
end
;-----------------------------------------------------------------
; Text Insert String Callback Procedure.
; Argument:
;   Event structure:
;
;   {WIDGET_TEXT_STR, ID:0L, TOP:0L, HANDLER:0L, TYPE:1, OFFSET:0L,
;       STR:'' }

;   ID is the widget ID of the component generating the event. TOP is
;       the widget ID of the top level widget containing ID. HANDLER
;       contains the widget ID of the widget associated with the
;       handler routine.

;   OFFSET is the (zero-based) insertion position that will result
;       after the character is inserted. STR is the string to be
;       inserted.

;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
pro OnTypeFilename, Event

end
;
; Empty stub procedure used for autoloading.
;
pro gideon1_eventcb
end
;-----------------------------------------------------------------
; Activate Button Callback Procedure.
; Argument:
;   Event structure:
;
;   {WIDGET_BUTTON, ID:0L, TOP:0L, HANDLER:0L, SELECT:0}
;
;   ID is the widget ID of the component generating the event. TOP is
;       the widget ID of the top level widget containing ID. HANDLER
;       contains the widget ID of the widget associated with the
;       handler routine.

;   SELECT is set to 1 if the button was set, and 0 if released.
;       Normal buttons do not generate events when released, so
;       SELECT will always be 1. However, toggle buttons (created by
;       parenting a button to an exclusive or non-exclusive base)
;       return separate events for the set and release actions.

;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
pro OnRun, Event

common gideon1_common_mag, mag

on_error, 1
if n_elements (mag) eq 0 then mag = 0.1
;get values needed in code
	fn='filename'
	edgemag2=6.12
	gamma2=5.E4

   ; get the Widget IDs
   wTextFilename = Widget_Info(Event.top, find_by_uname="WID_FILENAME")
   wGamma = Widget_Info(Event.top, find_by_uname="WID_GAMMA")
   wMag = Widget_Info(Event.top, find_by_uname="WID_MAG")
   wDraw = Widget_info(Event.top, find_by_uname="WID_SPOT_ZOOM")

   wKillEdge = Widget_info(Event.top, find_by_uname="WID_KILL_EDGE")
   wKillEdgeZoom = Widget_info(Event.top, find_by_uname="WID_KILL_EDGE_ZOOM")
   wKillFull = Widget_info(Event.top, find_by_uname="WID_KILL_FULL")
   wKillZoom = Widget_info(Event.top, find_by_uname="WID_KILL_ZOOM")

   wMeanSpot = Widget_info(Event.top, find_by_uname="WID_SPOT_MEAN")
   wMinSpot = Widget_info(Event.top, find_by_uname="WID_SPOT_MIN")
   wMaxSpot = Widget_info(Event.top, find_by_uname="WID_SPOT_MAX")
   wSDSpot = Widget_info(Event.top, find_by_uname="WID_SPOT_SD")

   wUseDoseUnits = Widget_info(Event.top, find_by_uname="WID_USE_DOSE_UNITS")

   ; Now update the values
   widget_control, wTextFilename, GET_VALUE=fn
   widget_control, wGamma, GET_VALUE=gamma2
   widget_control, wMag, GET_VALUE=edgemag2
   widget_control, wDraw, GET_VALUE=spotZoomWindow

   drawEdgePic=WIDGET_INFO(wKillEdge, /BUTTON_SET)	;returns true if button is set
   drawEdgeZoom=WIDGET_INFO(wKillEdge, /BUTTON_SET)
   drawFull=WIDGET_INFO(wKillFull, /BUTTON_SET)
   drawZoom=WIDGET_INFO(wKillZoom, /BUTTON_SET)
   useDoseUnits=WIDGET_INFO(wUseDoseUnits, /BUTTON_SET)

; Magnification of edge = 2nd conjugate / 1st conjugate
edgemag= (edgemag2 gt 1) ? float(edgemag2) : 6.12
edgemag= edgemag[0]
widget_control, wMag, Set_Value = strtrim(edgemag, 2)

; some text to add to graphics titles
titlestring=FILE_BASENAME(fn)

; pixel coordinates of the centre of the edge, value not used but variable is
edgecentre=  [690,850]

; The gamma signal/noise parameter is used for the constrained least square 
;    image reconstruction below
; Gamma factor must be adjusted by hand until the reconstructed image looks best.
; the range of potential values is very large, depending on the s/n
; If the reconstructed PSF is noisy, run again with an increased gamma.
; If the reconstructed PSF is smooth and featureless, run again with an reduced gamma.

gamma = (gamma2 gt 1) ? FLOAT(gamma2[0]): 5.0e4
gamma = gamma[0]
widget_control, wGamma, Set_Value = strtrim (gamma, 2)

if (useDoseUnits) THEN $
  image1=readinfpcb(fn,/silent, lut=image1lut, header_data=img_data) $
ELSE image1=readinfpcb(fn,/noconvert,/silent, lut=image1lut, header_data=img_data)

image1 = float(image1) > 0.0

image1size=size(image1)

; Save the raw image
work = get_maxstr()-9
xscale = (0.05*img_data.xResolution/50)
yscale = (0.05*img_data.yResolution/50)
xx = findgen(image1size[1])*xscale
yy = findgen(image1size[2])*yscale
arr2str, work, float(image1), xx, yy, clab = 'Raw - '+fn, xlab = 'X (mm)', ylab='Y (mm)'
iwork = 1

;fiddle factor for mm at image plane, if xResolution=50 this should =0.05
mmFiddle=0.05*img_data.xResolution/50

;2048     select the subimage dimensions  ie the area of interest around the edge
bigwinsize=426*2
bws=bigwinsize/2

newbws=fltarr(4)

; Display image plate image and show area of interest
; Get user to define centre of edge first
xsiz = round (image1size[1]*mag)
ysiz = round (image1size[2]*mag)
window, 3, xs=xsiz, ys= ysiz

;fiddle factor to make dose units edge visible
lowerLimit=24.

;another fiddle factor like lowerLimit
lowerFactor=200.
largeIndex=WHERE(image1lut GT lowerLimit)

;dont want any negative numbers in image
image1lutScale=image1lut[largeIndex]
;variation was between about 24 and 25 so now its between 0 and 200
image1lutScale=(image1lutScale-lowerLimit)*lowerFactor

if (useDoseUnits) then $
  tvscl, image1lutScale[congrid(image1, xsiz, ysiz)] $
else $
  tvscl, image1lut[congrid(image1, xsiz, ysiz)]


edge_x= xsiz/3
edge_y= ysiz/3
edge_xLen= edge_x
edge_yLen= edge_y
BOX_CURSOR, edge_x, edge_y, edge_xLen, edge_yLen, /INIT
;CURSOR, edge_x, edge_y, /WAIT, /NORMAL  ;use normal as image has been reduced in size
;assume area of interest needs to be square (dont know if it does so **CHECK**)
;so use edge_xLen and it is by deff no the largest or they are equal
if (edge_yLen GT edge_xLen) THEN edge_xLen=edge_yLen
edgecentre=[(edge_x+0.5*edge_xLen)/mag, (edge_y+0.5*edge_yLen)/mag]

; Get the X size of the box cursor and half width of the box cursor

bigwinsize=edge_xLen/mag
bws=bigwinsize/2

edgecentrexcoords=[edgecentre[0]-bws+1,edgecentre[0]+bws]/mag
edgecentreycoords=[edgecentre[1]-bws+1,edgecentre[1]+bws]/mag

DEVICE, DECOMPOSED=1
TEK_COLOR

plots,[edgecentrexcoords[0], edgecentrexcoords[1], edgecentrexcoords[1], edgecentrexcoords[0], edgecentrexcoords[0]] ,$
      [edgecentreycoords[0], edgecentreycoords[0], edgecentreycoords[1], edgecentreycoords[1], edgecentreycoords[0]]  ,  color=250 ,/dev
loadct,0

IF (drawEdgePic EQ 0) THEN WDELETE, 3	;no longer needed


; check that the sub image lies within the image
maxx=edgecentre[0]+bws
if maxx gt image1size[1]-1 then newbws[0]= image1size[1]-1  -  edgecentre[0]

minx=edgecentre[0]-bws+1
if minx lt 0 then newbws[1]=   edgecentre[0]

maxy=edgecentre[1]+bws
if maxy gt image1size[2]-1 then newbws[2]= image1size[2]-1  -  edgecentre[1]

miny=edgecentre[1]-bws+1
if miny lt 0 then newbws[3]=   edgecentre[1]

if max( newbws) ne 0 then begin
  bws = min(newbws[where(newbws gt 0)])
  print,'bigwinsize too big -  trying: ', bws
  maxx= (edgecentre[0]+bws) < (image1size[1]-1)
  minx= (edgecentre[0]-bws) > 0
  maxy= (edgecentre[1]+bws) < (image1size[2]-1)
  miny= (edgecentre[1]-bws) > 0
end

image1small2=image1lut[image1[minx:maxx,miny:maxy ]]

arr2str, work+iwork, image1[minx:maxx,miny:maxy], clab = 'Image1'
arr2str, work+iwork+1, image1small2, clab = 'Image1 - Dose units'
iwork = iwork+2


winsize=1024.
image1small2size=size(image1small2)

xsiz=image1small2size[1]
ysiz=image1small2size[2]
scratio=float(ysiz)/float(xsiz)

image1small2rebin=congrid(image1small2,winsize,winsize,cubic=-0.5,/cen)
pixelmag=xsiz/winsize

IF (drawEdgeZoom EQ 1) THEN BEGIN
	;Display area of interest
	window,2,xs=512,ys=512

	tvscl,rebin(image1small2rebin,512,512)
ENDIF


; im1 ia a pseudo edge image
; im1 array is used later to calculate the extra blur added by Gideon's method

im1=fltarr(winsize,winsize)+0.1
im1[winsize/2:winsize-1,0:winsize/2-1]=1.



; do Gideon's method, force the minimum convolution kernal size (nsq=0)

 nsq=0
 b=fltarr(nsq*2+1,nsq*2+1)
 if nsq eq 0 then b=[[1,-1],[-1,1]] else $
   for i=0.,2.*nsq do for j= 0.,2.*nsq do b[i,j]=(i-nsq)*(j-nsq)/nsq^2
; Convolution
 datar=convol_mm(image1small2rebin,b,/clip)

 gidkernsize=nsq*2+1 > 2

; calculate the "extra blur" added by Gideon's method.
 extra_blur_psf=convol_mm(im1,b,/edge_truncate)

; Do an image reconstruction
; this one is based on a constrained least square filter hacked from digital
; image processing 2nd ed. by Gonzalez and woods
; uses gamma s/n parameter set at the top of the file

fhat=wienersq4(datar,-extra_blur_psf,gamma,gidkernsize=gidkernsize)/ (winsize*winsize)
s = size(fhat)
new_xyscale =  (pixelmag*mmFiddle/edgemag)
xarr = findgen(s[1])*new_xyscale
yarr = findgen(s[2])*new_xyscale
arr2str, work+iwork, fhat, xarr, yarr, clab = 'Filtered Spot'
iwork +=1


DEVICE, DECOMPOSED=0
loadct,39

; Display the 2D source map.   the xr and yr parameters will probably need adjusting to centre the map in the view

IF (drawFull EQ 1) THEN BEGIN
 window,17 , xsize=512.*1.4
 plotimage,bytscl(fhat ) , imgxrange=[0,(winsize-1.)*new_xyscale], $
   imgyrange=[0,(winsize-1.)*new_xyscale],/isotropic,  $
   tit=titlestring+' Source Distribution wiener',xtit='mm at source plane', $
   ytit='mm at source plane', BACKGROUND = 255, COLOR = 0
 colorbar, divisions=5 , ticknames=string(findgen(6)/5. , format='(f3.1)'  ), $
   /vert, BACKGROUND = 255, COLOR = 0
ENDIF

x_extent=winsize
y_extent=winsize
new_winsize=winsize

magFac=0.5
loadct, 39
window, 18, xs=new_winsize*magFac, ys=new_winsize*magFac
fhat2=ROT(fhat, 0, magFac)
fhat2=fhat2(0.5*new_winsize*(1-magFac):0.5*new_winsize*(1+magFac), $
          0.5*new_winsize*(1-magFac):0.5*new_winsize*(1+magFac))
tvscl, fhat2

xPos=new_winsize*magFac/3
yPos=new_winsize*magFac/3
xLen=xPos
yLen=yPos

BOX_CURSOR, xPos, yPos, xLen, yLen, /INIT

IF (drawZoom EQ 0) THEN WDELETE, 18


x_offset=xPos/(new_winsize*magFac)  ;as a ratio of full dimension
y_offset=yPos/(new_winsize*magFac)
if ((xPos+xLen) GE (new_winsize*magFac)) THEN x_Len=(1-x_offset) ELSE x_len=xLen/(new_winsize*magFac)
if ((yPos+yLen) GE (new_winsize*magFac)) THEN y_Len=(1-y_offset) ELSE y_len=yLen/(new_winsize*magFac)

if (x_len gt y_len) then y_len=x_len else x_len=y_len       ;retreived element needs to be square to conserve aspect ratio
;**SHOULD ADD A CHECHK THAT ABOVE LINE DOES NOT GO OUTSIDE IMAGE BOUNDRIES**


zoomData=fhat(x_offset*x_extent:(x_offset+x_len)*x_extent, y_offset*y_extent:(y_offset+y_len)*y_extent)

ss = size(zoomdata)
xarr = findgen(ss[1])*new_xyscale

arr2str, work+iwork, ZoomDATA, xarr, xarr, clab = 'zoomdata'
iwork += 1

;zoomDataBig=CONGRID(zoomData, 512, 512)   ;enlarge array
; zoomDataBig=CONGRID(zoomData, new_winsize, new_winsize)   ;enlarge array

loadct, 39
; zoomDataMag=ROT(zoomDataBig, 0, magFac)
; zoomDataMag=zoomDataMag(0.5*new_winsize*(1-magFac):0.5*new_winsize*(1+magFac), $
;          0.5*new_winsize*(1-magFac):0.5*new_winsize*(1+magFac))
zoomDataBig = ZoomData


loadct, 39
zoomDataMag=CONGRID(zoomdata, 250, 250)
WSET, spotZoomWindow
tvscl, zoomDataMag



;*********************loop over angle follows********************
;awe_spot=MAKE_ARRAY(180, /Double)
lpawe_spot = MAKE_ARRAY(180, /Double)
mmPerPixel= new_xyscale
sss= size(zoomDataBig)
new_winsize = sss[1]
;FOR angle=0, 179 DO BEGIN

;  zoomDataRotate=ROT(zoomDataBig, angle)
;;  lineSpread=TOTAL(zoomDataRotate, 1)

;  edgeScan=MAKE_ARRAY(new_winsize, /Double)
;  edgeScan[0]=lineSpread[0]
;  FOR i=1, (new_winsize-1) DO edgeScan[i]=edgeScan[i-1]+lineSpread[i]


; now need to find 10%, 25%, 75% and 100% points, NB e_x is stored as [y, x] not [x, y]
;  e_25=[edgeScan[(new_winsize-1)]*0.25, 0]
;  e_75=[edgeScan[(new_winsize-1)]*0.75, 0]
;
;  FOR i=1, (new_winsize-1) DO BEGIN
;    if ((edgeScan[i-1] LT e_25[0])&&(edgeScan[i] GT e_25[0])) THEN $
;        e_25[1]=pnm_linearInterpX(i-1, i, edgeScan[i-1], edgeScan[i], e_25[0])
;
;    if ((edgeScan[i-1] LT e_75[0])&&(edgeScan[i] GT e_75[0])) THEN $
;        e_75[1]=pnm_linearInterpX(i-1, i, edgeScan[i-1], edgeScan[i], e_75[0])
;  ENDFOR

;  line of fit for our 25 to 75 is y=pnm_m*x+pnm_c where
;  pnm_m=(e_75[0]-e_25[0])/(e_75[1]-e_25[1])
;  pnm_c=e_75[0]-e_75[1]*pnm_m

;  x value is where x=(y-c)/m
;  e_10=[0.1*edgeScan[(new_winsize-1)], (0.1*edgeScan[(new_winsize-1)]-pnm_c)/pnm_m]
;  e_100=[edgeScan[(new_winsize-1)], (edgeScan[(new_winsize-1)]-pnm_c)/pnm_m]

;  as x_len and y_len are the same we can use either
;  awe_spot[angle]=mmPerPixel*1.25*(e_100[1]-e_10[1])     ;in units of array index

;ENDFOR

values = [0.25, 0.75]
; fudge = 0.9*1.25
 fudge = 2.25*mmPerPixel
for iang = 0, 179 do begin
  zoomdatarotate = ROT(zoomDataBig, iang)
  edgescan=total(TOTAL(zoomDataRotate, 1, /double), /cum)
  n = n_elements(edgescan)
  tt = systime(1)
  e = findex(edgescan/edgescan[n-1], values)
;  pnm_m=0.5*edgescan[n-1]/(e[1]-e[0])
;  pnm_c= 0.5*edgescan[n-1]*(1.5 -e[1]/(e[1]-e[0]))
  lpawe_spot[iang] = fudge * (e[1]-e[0])
endfor  
;i2w, [0,1], awe_spot, 32, clab = 'Spotsize - old', xlab='Angle-deg'
i2w, [0,1], lpawe_spot, get_maxwdf()-2, clab = 'Spotsize - new', xlab='Angle-deg'

;*********************end loop over angle *************************

awe_mean=MEAN(lpawe_spot)
awe_max=MAX(lpawe_spot, min = awe_min)
awe_std=STDDEV(lpawe_spot)

awe_stats=CREATE_STRUCT('fileName', fn, 'mean', awe_mean ,'max',awe_max   , $
                            'min',awe_min  ,  'standard deviation',awe_std)

print, TAG_NAMES(awe_stats)
print, awe_stats


Widget_Control, wMeanSpot, SET_VALUE=STRING(awe_mean)
Widget_Control, wMinSpot, SET_VALUE=STRING(awe_min)
Widget_Control, wMaxSpot, SET_VALUE=STRING(awe_max)
Widget_Control, wSDSpot, SET_VALUE=STRING(awe_std)

loadct,0
;******************************END MAIN GIDEON PRO*******************************
end
