;------------------------------------------------------------------------------
;	Event Handlers
;------------------------------------------------------------------------------
; SUMMARY of handlers
;
; fileopen 	:
; menu_options	:
; output_options:
; out_opt2	:
; user_options	:
; ccontrol_event:
; bye		:
; buttons_event	:
; reset_event	:
; go_to_slider	:
; v_den		:
; v_press	:
; v_velx	:
;------------------------------------------------------------------------------

;_________________________OPEN FILE & INITIALIZE _________________________

PRO fileopen, event
;this event opens up the file, resets the slider, and reads in the info
common block, idnum
  widget_control, event.top, get_uvalue=info
  opencdf
  readcdf,s0,/str, /grid

; read the plot variables in the exodus file
  dircdf,comment=comment,ndset=ndset,/quiet
  temp_var=comment(ndset(0):*)

;create string array of all variables in EXODUS file
  widget_control, info.list, set_value=temp_var
  nelem=N_elements(temp_var)
  info.varlist(0:Nelem-1)=temp_var

;read in the exodus time dump information
  temp_time=s0.x4
  ntime=n_elements(temp_time)
  info.time(0:ntime-1)=s0.x4

;update the slider so that it has the correct length
  print,'number of time intervals =', ntime
  widget_control, info.slid_id, set_slider_max=ntime-1

;  result=execute(info.command) + execute(info.meshopt)

  WIDGET_CONTROL, event.top, set_uvalue=info
end

;_________________________COLOR & PALETTE WIDGET _________________________

PRO menu_options, event
;this event calls up xloadct and xpalette
widget_control, event.id, get_uvalue=options
case options(event.index) of
  "XLoadct": XLoadct, GROUP = event.top
  "XPalette": XPalette, GROUP = event.top
endcase
end

PRO output_options, event
;this is a chidl widget that calls up output options
onebase=WIDGET_BASE(TITLE = "Output Options", $
	/COLUMN)
smallbase=WIDGET_BASE(onebase, /ROW, /FRAME)
twobase=WIDGET_BASE(smallbase, /ROW, /FRAME, $
 	/EXCLUSIVE, group_leader=event.top)
psbutton=WIDGET_BUTTON(twobase, value="PS", $
  	uvalue="pstscr", event_pro='out_opt2')
epsbutton=WIDGET_BUTTON(twobase, value="EPS", $
  	uvalue="epstscr", event_pro='out_opt2')
jpegbutton=WIDGET_BUTTON(twobase, value="JPG", $
  	uvalue="jpeg", event_pro='out_opt2')
gifbutton=WIDGET_BUTTON(twobase, value="GIF", $
  	uvalue="gif", event_pro='out_opt2')
widget_control, onebase, /realize
widget_control, event.id, set_button=0
xmanager,'out_opt2',onebase

abase=WIDGET_BASE(/COLUMN)
;txwid = cw_field(abase,/string,title='Filename:',
;value='alegra.out',/all_events,/column,uvalue='filetext')
words=WIDGET_LABEL(abase, value = 'Filename:')
intext = widget_text(abase, /editable, $
 event_pro='out_opt3', value='alegra.out',uvalue='filetext')
widget_control, abase, /realize
xmanager,'out_opt3',abase
end

;_________________________OUTPUT WIDGET _________________________

PRO out_opt2, event
;this is the grandchild of the output widget.  This does the work.
common block, idnum
WIDGET_CONTROL, idnum, GET_UVALUE = info
WIDGET_CONTROL, event.id, GET_UVALUE = eventval
info.outtype=eventval
WIDGET_CONTROL, idnum, SET_UVALUE = info
widget_control,event.top,/destroy
end

;_________________________OUTPUT WIDGET _________________________

PRO out_opt3, event
;this is the grandchild of the output widget.  This does the work.
common block, idnum
WIDGET_CONTROL, idnum, GET_UVALUE = info
WIDGET_CONTROL, event.id, GET_UVALUE = eventval
olddevice=!d.name
case eventval of
  "filetext": begin
    widget_control, event.id, get_value=value, set_value=value
    info.fname=value
     if (info.outtype eq 'pstscr') then begin
 	set_plot, 'ps'
	c='device, /times, bits_per_pixel=8, /color, filename='
	cname="'"
	cfinal=c+cname+info.fname+cname
        result=execute(cfinal)
        print, cfinal
        result=execute(info.command) + result(info.meshopt)
        device, /close
        set_plot, olddevice
     endif
     if (info.outtype eq 'epstscr') then begin
 	set_plot, 'ps'
	c='device, /encapsulated, bits_per_pixel=8, /color, filename='
	cname="'"
	cfinal=c+cname+info.fname+cname
        result=execute(cfinal)
        print, cfinal
        result=execute(info.command) + result(info.meshopt)
        device, /close
        set_plot, olddevice
     endif
     if (info.outtype eq 'jpeg') then begin
 	print, info.fname
	pic=tvrd()
	write_jpeg, info.fname, pic
     endif
     if (info.outtype eq 'gif') then begin
 	print, info.fname
	pic=tvrd()
	write_gif, info.fname, pic
     endif
     widget_control,event.top,/destroy
   end
   else:; print, 'nothing is happening'
endcase
WIDGET_CONTROL, idnum, SET_UVALUE = info
end

PRO user_options, event
;this is a widget for controlling contours
common block, idnum
widget_control, event.id, get_uvalue=options2
rangebase= WIDGET_BASE(title='Contour Controls', $
		/COLUMN, $
		/FRAME)
numlevels= WIDGET_LABEL(rangebase, value = 'Levels (1-29):')
  intext = widget_text(rangebase, /editable, xsize=6, ysize=1, $
  event_pro='ccontrol_event', uvalue='nlevel')
min=WIDGET_LABEL(rangebase, value = 'min:')
  intext = widget_text(rangebase, /editable, xsize=6, ysize=1, $
  event_pro='ccontrol_event', uvalue='minlevel')
max=WIDGET_LABEL(rangebase, value = 'max:')
  intext = widget_text(rangebase, /editable, xsize=6, ysize=1, $
  event_pro='ccontrol_event', uvalue='maxlevel')
secondbase= WIDGET_BASE(rangebase, /ROW, /FRAME)
doitbutton=WIDGET_BUTTON(secondbase, value="DO IT", $
  	uvalue="doesit", event_pro='ccontrol_event')
byebutton=widget_button(secondbase, value='EXIT', $
  event_pro='bye')
widget_control, rangebase, /realize
end

;_________________________CONTOUR WIDGET _________________________

PRO ccontrol_event, event
;this is the grandchild of the contour widget.  This does the work.
numl=''
common block, idnum
WIDGET_CONTROL, idnum, GET_UVALUE = info
WIDGET_CONTROL, event.id, GET_UVALUE = eventval
CASE eventval OF
  "nlevel": begin
     widget_control, event.id, get_value=value, set_value=value
     info.numl=value
     print, info.numl
     end
  "minlevel": begin
     widget_control, event.id, get_value=value, set_value=value
     info.minl=value
     print, info.minl
    end
  "maxlevel": begin
     widget_control, event.id, get_value=value, set_value=value
     info.maxl=value
     print, info.maxl
    end
  "doesit": begin
     Val = info.minl+(info.maxl-info.minl)*(FINDGEN(info.numl)/(info.numl-1))
     a=string(Val)
     print, a
;stop
     info.levelopt=', levels=' + a
     if (info.shade eq 1) then begin
       info.command=info.commbase+info.legopt+ $
       info.conopt+info.aspopt+info.logopt+ $
       info.xrangeopt+info.yrangeopt+info.moveopt+info.plotopt+info.levelopt
     endif else begin
       info.command=info.commbase+info.legopt+ $
       info.conopt+info.fillopt+info.aspopt+info.logopt+ $
       info.xrangeopt+info.yrangeopt+info.moveopt+info.plotopt+info.levelopt
     endelse
     print, info.command
    result=execute(info.command) + execute(info.meshopt)
    WIDGET_CONTROL, idnum, SET_UVALUE = info
  end
endcase
WIDGET_CONTROL, idnum, SET_UVALUE = info
end

;_________________________DESTORY WIDGET CALL _________________________

PRO bye, event
;destroy widget
  print, 'goodbye'
  WIDGET_CONTROL, event.top, /DESTROY
end

;_________________________ROTATION/SCALING BUTTONS_________________________

PRO buttons_event, event
;this controls the margins and rotations.
common block, idnum
WIDGET_CONTROL, event.top, GET_UVALUE = info
WIDGET_CONTROL, event.id, GET_UVALUE = eventval
CASE eventval OF

  "       0": IF(event.select EQ 1) THEN BEGIN
                print, 'got it'
		info.zrot = (info.zrot + 15) mod 360
		IF(info.zrot LT 0) THEN info.zrot = 360 + info.zrot
		WIDGET_CONTROL, event.id, SET_BUTTON = 0
                info.c2 = STRING(info.zrot, FORMAT = '(", AZ = ",I3.3)')
	      endif else begin
                info.c2=''
  	      endelse

  "       1": IF(event.select EQ 1) THEN BEGIN
		info.zrot = (info.zrot - 15) mod 360
		IF(info.zrot LT 0) THEN info.zrot = 360 + info.zrot
		WIDGET_CONTROL, event.id, SET_BUTTON = 0
                  info.c2 = STRING(info.zrot, FORMAT = '(", AZ = ",I3.3)')
	      endif else begin
                  info.c2=''
	      endelse

  "       2": IF(event.select EQ 1) THEN BEGIN
		info.xrot = (info.xrot - 15) mod 360
		IF(info.xrot LT 0) THEN info.xrot = 360 + info.xrot
		WIDGET_CONTROL, event.id, SET_BUTTON = 0
                  info.c1 = STRING(info.xrot, FORMAT = '(", AX = ",I3.3)')
	      endif else begin
  		  info.c1=''
	      endelse

  "       3": IF(event.select EQ 1) THEN BEGIN
		info.xrot = (info.xrot + 15) mod 360
		IF(info.xrot LT 0) THEN info.xrot = 360 + info.xrot
		WIDGET_CONTROL, event.id, SET_BUTTON = 0
                  info.c1 = STRING(info.xrot, FORMAT = '(", AX = ",I3.3)')
	      endif else begin
  		  info.c1=''
	      endelse

  "       4": IF(event.select EQ 1) THEN BEGIN	;shrink
		info.xmargin = info.xmargin * 1.2
		info.ymargin = info.ymargin * 1.2
                XMARGIN=info.xmargin
                YMARGIN=info.ymargin
		WIDGET_CONTROL, event.id, SET_BUTTON = 0
	          info.c3 = STRING(xmargin, $
 	        FORMAT = '(", XMARGIN = [",F4.1,", ",F4.1,"]")')
    		  info.c4 = STRING(ymargin, $
		FORMAT = '(", YMARGIN = [",F4.1,", ",F4.1,"]")')
	      endif else begin
	          info.c3=''
	          info.c4=''
	      endelse

  "       5": IF(event.select EQ 1) THEN BEGIN	;grow
		info.xmargin = info.xmargin * 0.8
		info.ymargin = info.ymargin * 0.8
                XMARGIN=info.xmargin
                YMARGIN=info.ymargin
		WIDGET_CONTROL, event.id, SET_BUTTON = 0
	          info.c3 = STRING(xmargin, $
 	        FORMAT = '(", XMARGIN = [",F4.1,", ",F4.1,"]")')
    		  info.c4 = STRING(ymargin, $
		FORMAT = '(", YMARGIN = [",F4.1,", ",F4.1,"]")')
	      endif else begin
	          info.c3=''
	          info.c4=''
	      endelse

  ELSE:; MESSAGE, "Event User Value Not Found"
endcase
print, info.c1, info.c2, info.c3, info.c4
info.moveopt= info.c1+info.c2+info.c3+info.c4
print, info.moveopt
if (info.shade eq 1) then begin
info.command=info.commbase+info.legopt+ $
    info.conopt+info.aspopt+info.logopt+ $
    info.xrangeopt+info.yrangeopt+info.moveopt+info.plotopt+info.levelopt
endif else begin
info.command=info.commbase+info.legopt+ $
    info.conopt+info.fillopt+info.aspopt+info.logopt+ $
    info.xrangeopt+info.yrangeopt+info.moveopt+info.plotopt+info.levelopt
endelse
WIDGET_CONTROL, event.top, SET_UVALUE = info
print, info.command
  result=execute(info.command) + execute(info.meshopt)
end

;______________________ROTATION RESET_________________________

PRO reset_event, event
;this is for the rotation reset button.
common block, idnum
widget_control, event.top, get_uvalue=info
info.zrot=30
info.xrot=30
info.c1 = STRING(info.zrot, FORMAT = '(", AZ = ",I3.3)')
info.c2 = STRING(info.xrot, FORMAT = '(", AX = ",I3.3)')
info.moveopt= info.c1+info.c2+info.c3+info.c4
info.command=info.commbase+info.plotopt+info.legopt+ $
    info.conopt+info.aspopt+info.logopt+ $
    info.xrangeopt+info.yrangeopt+info.moveopt+info.levelopt
WIDGET_CONTROL, event.top, SET_UVALUE = info
  result=execute(info.command) + execute(info.meshopt)
end

;______________________TIME ASSOCIATED WITH SLIDER_______________

PRO go_to_slider, event
;this updates the slider and plots the resulting frame
common block, idnum
  widget_control, event.top, get_uvalue=info
  info.timeid = event.value
  print, info.timeid
  widget_control, event.top, set_uvalue=info
  name = strmid(tag_names(event, /structure_name), 7, 4)
  case (name) of
    "SLID": value = event.value
  else:
  endcase

  WIDGET_CONTROL, info.slidtxt,set_value='Time:  '+string(info.time(value))

  if (strmid(info.command,0,5) ne 'plotf') then begin
    ;plotfe9, info.strstr, info.timeid+1, /ind, /quiet
    if strpos(info.logopt, '1') gt 0 then m = 1 else m = 0
    plotfe9, info.strstr, info.timeid+1, /ind  

    
 ;   linstr2, 81, 81, info.plast, info.qlast

   linstr, 81, 81, info.plast, info.qlast, hor= info.horz, vert = info.vert, multiply=m
  endif

  result=execute(info.command) + execute(info.meshopt)

end

;_________________________STRUCTURE BUTTONS_________________________
PRO str_button, event
;this handler changes the current structure number to be read into
common block, idnum
widget_control, event.top, get_uvalue=info
IF(event.select EQ 1) THEN BEGIN
  WIDGET_CONTROL, event.id, GET_VALUE = eventval
  print,'structure eventval=',eventval
  info.strstr=eventval
 ENDIF
widget_control, event.top, set_uvalue=info
info.command=info.commbase
result=execute(info.command) + execute(info.meshopt)
end

;_________________________MAGNITUDE BUTTON_________________________
PRO mag_button, event
;this handler changes the current structure number to be read into
common block, idnum
widget_control, event.top, get_uvalue=info

s2i,s1,1
s2i,s2,2
s4=s2 ; dummy structure

s4.v1=SQRT(s1.v1^2+s2.v1^2)
s4.clab='Magntiude of vector'
i2s,s4,4
end

;_________________________CURRENT BUTTON_________________________
PRO cur_button, event
;this handler changes the current structure number to be read into
common block, idnum
widget_control, event.top, get_uvalue=info

s2i,s1,1
s2i,s2,2
s4=s2 ; dummy structure

s4.v1=SQRT(s1.v1*s2.v1)
s4.clab='Product'
i2s,s4,4
end


;___________________________VARIABLE LIST__________________________

PRO varlist_event, event
; this event handler is assigned to the variable listing
widget_control, event.top, get_uvalue=info
if (strmid(info.command,0,5) ne 'plotf') then info.command=info.commbase
res='readcdf,' + info.strstr + ',"' + info.varlist(event.index) + '"'

result=execute(res)
result=execute(info.command) + execute(info.meshopt)
print,res
WIDGET_CONTROL, event.top, set_uvalue=info
end

;___________________________PLOT TYPE__________________________

PRO bottom_event, event
;this event handler takes care of all of the plot options (mesh, surface
;fill, legend, aspect ratio, log contours.
common block, idnum
WIDGET_CONTROL, event.id, GET_UVALUE = eventval
widget_control, event.top, get_uvalue=info
extra=1
WIDGET_CONTROL, event.top, GET_UVALUE = info

CASE eventval OF


   "PLOTSURF": IF(event.select EQ 1) THEN BEGIN
                info.plotopt=',/sha'
                info.shade=1
	    endif else begin
		   extra=0
	    endelse
   "PLOTCONT": IF(event.select EQ 1) THEN BEGIN
                info.plotopt=''
                info.shade=0
	    endif else begin
		   extra=0
	    endelse
  "SKIRTON": IF(event.select EQ 1) THEN BEGIN
		skirt = 1
		XSurface_draw
	     ENDIF

  "LEGEND": begin
		info.legopt=',/thermo'
		if (event.select eq 0) then begin
		   info.legopt=''
                 endif
	    end

  "GRIDON": IF(event.select EQ 1) THEN BEGIN
      readcdf,66,/grid
      print,'overplot with the grid'
      info.meshopt='plotstr,66,1,2,info.timeid+1,/ind, info.aspopt, /ov, linestyle=0'
	    endif else begin
                info.meshopt=''
	    endelse

  "ASP":  IF(event.select EQ 1) THEN BEGIN
		info.aspopt=', aspect = 1'
	    endif else begin
                info.aspopt=', aspect = 0'
	    endelse

  "LOG":  IF(event.select EQ 1) THEN BEGIN
		info.logopt=', m=0'
	    endif else begin
                info.logopt=', m=1'
	    endelse

  "CONTOUR":  IF(event.select EQ 1) THEN BEGIN
		info.fillopt=', cn=1'
	    endif else begin
                info.fillopt=''
		extra=0
	    endelse

  "FILLED":  IF(event.select EQ 1) THEN BEGIN
		info.fillopt=', cn=2'
	    endif else begin
                info.fillopt=''
		extra=0
	    endelse

  "BOTH":  IF(event.select EQ 1) THEN BEGIN
		info.fillopt=', cn=3'
	    endif else begin
                info.fillopt=''
		extra=0
	    endelse
  ELSE:; MESSAGE, "Event User Value Not Found"
endcase
if (info.shade eq 1) then begin
info.command=info.commbase+info.legopt+ $
    info.conopt+info.aspopt+info.logopt+ $
    info.xrangeopt+info.yrangeopt+info.moveopt+info.plotopt+info.levelopt
endif else begin
info.command=info.commbase+info.legopt+ $
    info.conopt+info.fillopt+info.aspopt+info.logopt+ $
    info.xrangeopt+info.yrangeopt+info.moveopt+info.plotopt+info.levelopt
endelse
widget_control, event.top, set_uvalue=info
print,'bottom event:  ', info.command
if (extra eq 1) then begin
  result=execute(info.command) + execute(info.meshopt)
endif
end

PRO Tim_event, event
;this is the tim button
widget_control, event.top, get_uvalue=info
if strpos(info.logopt, '1') gt 0 then m = 1 else m = 0
linstr, 81, 81, xsize=350,ysize=350, plast=myplast, slop = slop, qlast=myqlast, multiply=m
;linstr2, 81, 81, xsize=350,ysize=350, plast=myplast, qlast=myqlast
info.command='plo, 81, charsize=1.5'
if slop eq 90.00 then begin
  info.vert = 1
  info.horz = 0
  myplast = myplast[0]
endif else if slop eq 0.00 then begin
  info.horz = 1
  info.vert = 0
  myplast = myplast[1]
endif else begin
  info.vert = 0
  info.horz = 0
endelse
info.plast=myplast
info.qlast=myqlast
result=execute(info.command)
widget_control, event.top, set_uvalue=info
end

PRO Insight_event, event
;this is the insight button
widget_control, event.top, get_uvalue=info

if (strmid(info.command,0,5) ne 'plotf') then begin
 w2i,x,y,81
 insight,x,y
endif

if (strmid(info.command,0,5) eq 'plotf') then begin
 s2i,s,81
 x = s.x1
 y = s.x2
 z = s.v1
 triangulate,x,y,tr,b
 s1 = trigrid(x,y,z,tr)
 x1 = min(x) + (findgen(51))*(max(x) - min(x))/50.0
 y1 = min(y) + (findgen(51))*(max(y) - min(y))/50.0
 insight,x1,y1,s1
endif

end

PRO anime_event, event
;this is the animation even handler
common anim_c, start,finish,number,size
widget_control, event.id, set_button=1
widget_control, event.top, get_uvalue=info
s2i, dtime2, info.strstr
temp_time=dtime2.x4
nframes=n_elements(temp_time)
start=0
finish=nframes-1
number=nframes
size=300

abase=WIDGET_BASE(/COLUMN)
words=CW_FIELD(abase, title= 'Starting frame:',$
 uvalue='start',/all_events,/integer,value=0)
words2=CW_FIELD(abase, title = 'Ending frame:',$
 uvalue='finish',/all_events,/integer,value=nframes-1)
words3=CW_FIELD(abase, title = 'Number of frames:',$
 uvalue='num',/all_events,/integer,value=nframes)
words4=CW_FIELD(abase, title = 'Size (in pixels):',$
 uvalue='size',/all_events,/integer,value=size)
butt=widget_button(abase,uvalue='end',value='OK')
widget_control, abase, /realize
xmanager,'anim_opt',abase

save_win=!D.WINDOW
window, 1, xsize=size, ysize=size
WSET, 1
frms = (indgen(number)*(finish-start)/(number-1))+start
xinteranimate,set=[size,size,number]
for j=0, number-1 do begin
; info.timeid=j-1
  info.timeid=frms(j)
  result=execute(info.command)+execute(info.meshopt)
  xinteranimate, frame=j, window= 1
endfor
xinteranimate
WDELETE, 1
WSET, save_win
event.select=0
widget_control, event.id, set_button=0
end

PRO anim_opt_event, event
common anim_c
WIDGET_CONTROL, event.id, GET_UVALUE = eventval
olddevice=!d.name
case eventval of
  "start": begin
    widget_control, event.id, get_value=value
    start=value
    end
  "finish": begin
    widget_control, event.id, get_value=value
    finish=value
    end
  "num": begin
    widget_control, event.id, get_value=value
    number=value
    end
  "size": begin
    widget_control, event.id, get_value=value
    size=value
    end
  "end": begin
    widget_control, event.top,/destroy
    end
   else:; print, 'nothing is happening'
endcase
end

PRO xrange_event, event
;this event takes care of the x zoom option
common block, idnum
widget_control, event.top, get_uvalue=info
widget_control, event.id, get_value=value, set_value=value
print, value
info.xrange=value
print, info.xrange
info.xrangeopt=', xrange=['+info.xrange+'], /xst'
;stop
if (info.shade eq 1) then begin
info.command=info.commbase+info.legopt+ $
    info.conopt+info.aspopt+info.logopt+ $
    info.xrangeopt+info.yrangeopt+info.moveopt+info.plotopt+info.levelopt
endif else begin
info.command=info.commbase+info.legopt+ $
    info.conopt+info.fillopt+info.aspopt+info.logopt+ $
    info.xrangeopt+info.yrangeopt+info.moveopt+info.plotopt+info.levelopt
endelse
print, info.command
widget_control, event.top, set_uvalue=info
result=execute(info.command)+execute(info.meshopt)
end

PRO yrange_event, event
;this event takes care of the y zoom option
common block, idnum
widget_control, event.top, get_uvalue=info
widget_control, event.id, get_value=value, set_value=value
print, value
info.yrange=value
print, info.yrange
info.yrangeopt=', yrange=['+info.yrange+'], /yst'
if (info.shade eq 1) then begin
info.command=info.commbase+info.legopt+ $
    info.conopt+info.aspopt+info.logopt+ $
    info.xrangeopt+info.yrangeopt+info.moveopt+info.plotopt+info.levelopt
endif else begin
info.command=info.commbase+info.legopt+ $
    info.conopt+info.fillopt+info.aspopt+info.logopt+ $
    info.xrangeopt+info.yrangeopt+info.moveopt+info.plotopt+info.levelopt
endelse
print, info.command
widget_control, event.top, set_uvalue=info
result=execute(info.command)+execute(info.meshopt)
end

;------------------------------------------------------------------------------
;	Main Procedure
;------------------------------------------------------------------------------
PRO gui

common block, idnum

if n_elements(block) eq 0 then block = 0
;initializing variables to be passed via common block

save_win = !D.WINDOW
thesize1 = SIZE(DATA)

tlb=WIDGET_BASE(TITLE = "IDL EXODUS VISUALIZER", $
		/COLUMN)

idnum=tlb

topbase=WIDGET_BASE(tlb, /ROW)

;________________________________________________________________top buttons

openbutton=widget_button(topbase, value='Open', $
  event_pro='fileopen')

options=['XLoadct', 'XPalette']
listmenu=widget_droplist(topbase, value=options, $
  title='Plot Options', frame=1, $
  event_pro='menu_options', uvalue=options)

outbutton=widget_button(topbase, value='Output', $
  event_pro='output_options')

options2=['contour control']
listmenu=widget_droplist(topbase, value=options2, $
  title='User Options', frame=1, $
  event_pro='user_options', uvalue=options2)

timbutton=WIDGET_BUTTON(topbase, $
		VALUE='Lineout', $
		event_pro='Tim_event')

inbutton=WIDGET_BUTTON(topbase, $
		VALUE='Import to Insight', $
		event_pro='Insight_event')

byebutton=widget_button(topbase, value='Exit', $
  event_pro='bye')

XSurfacebase = WIDGET_BASE(tlb, $
		/COLUMN)

thebase = WIDGET_BASE(XSurfacebase, /ROW)

partbase = WIDGET_BASE(thebase, /COLUMN)

ver	= widget_info(/version)
case ver.style OF
'OPEN LOOK': BEGIN
	  XSurfacepalette = WIDGET_BASE(partbase, $
				/COLUMN, $
				/FRAME, $
				/EXCLUSIVE)
	END
ELSE:	    BEGIN
	  XSurfacepalette = WIDGET_BASE(partbase, $
				/COLUMN, $
				/FRAME)
	END
ENDCASE

;_______________________________bitmap(?) info for the rotation/resize buttons
controls = [							$
		[						$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 248B, 255B, 063B, 000B],			$
		[128B, 007B, 000B, 224B, 001B],			$
		[112B, 000B, 000B, 000B, 014B],			$
		[136B, 000B, 016B, 000B, 016B],			$
		[052B, 000B, 048B, 000B, 056B],			$
		[172B, 000B, 080B, 000B, 032B],			$
		[124B, 000B, 144B, 000B, 040B],			$
		[164B, 007B, 016B, 001B, 048B],			$
		[012B, 248B, 031B, 062B, 056B],			$
		[036B, 000B, 000B, 228B, 033B],			$
		[004B, 000B, 000B, 008B, 062B],			$
		[012B, 000B, 000B, 016B, 048B],			$
		[036B, 000B, 000B, 016B, 032B],			$
		[008B, 000B, 000B, 008B, 000B],			$
		[112B, 000B, 000B, 004B, 000B],			$
		[128B, 007B, 000B, 002B, 000B],			$
		[000B, 248B, 031B, 001B, 000B],			$
		[000B, 000B, 144B, 000B, 000B],			$
		[000B, 000B, 080B, 000B, 000B],			$
		[000B, 000B, 048B, 000B, 000B],			$
		[000B, 000B, 016B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B]			$
		],						$
;		dnz.bmdef
		[						$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 252B, 255B, 031B, 000B],			$
		[128B, 007B, 000B, 224B, 001B],			$
		[112B, 000B, 000B, 000B, 014B],			$
		[008B, 000B, 008B, 000B, 017B],			$
		[028B, 000B, 012B, 000B, 044B],			$
		[004B, 000B, 010B, 000B, 053B],			$
		[020B, 000B, 009B, 000B, 062B],			$
		[012B, 128B, 008B, 224B, 037B],			$
		[028B, 124B, 248B, 031B, 048B],			$
		[132B, 039B, 000B, 000B, 036B],			$
		[124B, 016B, 000B, 000B, 032B],			$
		[012B, 008B, 000B, 000B, 048B],			$
		[004B, 008B, 000B, 000B, 036B],			$
		[000B, 016B, 000B, 000B, 016B],			$
		[000B, 032B, 000B, 000B, 014B],			$
		[000B, 064B, 000B, 224B, 001B],			$
		[000B, 128B, 248B, 031B, 000B],			$
		[000B, 000B, 009B, 000B, 000B],			$
		[000B, 000B, 010B, 000B, 000B],			$
		[000B, 000B, 012B, 000B, 000B],			$
		[000B, 000B, 008B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B]			$
		],						$
		;upz.bm
		[						$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 128B, 255B, 001B, 000B],			$
		[000B, 064B, 169B, 002B, 000B],			$
		[000B, 160B, 254B, 007B, 000B],			$
		[000B, 160B, 068B, 000B, 000B],			$
		[000B, 016B, 032B, 000B, 000B],			$
		[000B, 016B, 032B, 000B, 000B],			$
		[000B, 016B, 032B, 000B, 000B],			$
		[000B, 016B, 032B, 000B, 000B],			$
		[000B, 008B, 016B, 000B, 000B],			$
		[000B, 008B, 016B, 000B, 000B],			$
		[000B, 008B, 144B, 001B, 000B],			$
		[000B, 008B, 112B, 006B, 000B],			$
		[000B, 008B, 016B, 008B, 000B],			$
		[000B, 008B, 008B, 016B, 000B],			$
		[000B, 008B, 006B, 096B, 000B],			$
		[000B, 008B, 001B, 128B, 000B],			$
		[000B, 136B, 000B, 000B, 001B],			$
		[000B, 200B, 015B, 240B, 003B],			$
		[000B, 008B, 008B, 016B, 000B],			$
		[000B, 008B, 008B, 016B, 000B],			$
		[000B, 008B, 008B, 016B, 000B],			$
		[000B, 008B, 008B, 016B, 000B],			$
		[000B, 008B, 008B, 016B, 000B],			$
		[000B, 008B, 008B, 016B, 000B],			$
		[000B, 008B, 008B, 016B, 000B],			$
		[000B, 008B, 008B, 016B, 000B],			$
		[000B, 008B, 008B, 016B, 000B],			$
		[000B, 008B, 008B, 016B, 000B],			$
		[000B, 016B, 004B, 008B, 000B],			$
		[000B, 016B, 004B, 008B, 000B],			$
		[000B, 016B, 005B, 008B, 000B],			$
		[000B, 080B, 004B, 008B, 000B],			$
		[000B, 032B, 147B, 004B, 000B],			$
		[000B, 160B, 042B, 005B, 000B],			$
		[000B, 064B, 149B, 002B, 000B],			$
		[000B, 128B, 255B, 001B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B]			$
		],						$
		;dnx.bm
		[						$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 128B, 255B, 001B, 000B],			$
		[000B, 064B, 149B, 002B, 000B],			$
		[000B, 160B, 042B, 005B, 000B],			$
		[000B, 032B, 147B, 004B, 000B],			$
		[000B, 080B, 004B, 008B, 000B],			$
		[000B, 016B, 005B, 008B, 000B],			$
		[000B, 016B, 004B, 008B, 000B],			$
		[000B, 016B, 004B, 008B, 000B],			$
		[000B, 008B, 008B, 016B, 000B],			$
		[000B, 008B, 008B, 016B, 000B],			$
		[000B, 008B, 008B, 016B, 000B],			$
		[000B, 008B, 008B, 016B, 000B],			$
		[000B, 008B, 008B, 016B, 000B],			$
		[000B, 008B, 008B, 016B, 000B],			$
		[000B, 008B, 008B, 016B, 000B],			$
		[000B, 008B, 008B, 016B, 000B],			$
		[000B, 008B, 008B, 016B, 000B],			$
		[000B, 008B, 008B, 016B, 000B],			$
		[000B, 200B, 015B, 240B, 003B],			$
		[000B, 136B, 000B, 000B, 001B],			$
		[000B, 008B, 001B, 128B, 000B],			$
		[000B, 008B, 006B, 096B, 000B],			$
		[000B, 008B, 008B, 016B, 000B],			$
		[000B, 008B, 016B, 008B, 000B],			$
		[000B, 008B, 112B, 006B, 000B],			$
		[000B, 008B, 144B, 001B, 000B],			$
		[000B, 008B, 016B, 000B, 000B],			$
		[000B, 008B, 016B, 000B, 000B],			$
		[000B, 016B, 032B, 000B, 000B],			$
		[000B, 016B, 032B, 000B, 000B],			$
		[000B, 016B, 032B, 000B, 000B],			$
		[000B, 016B, 032B, 000B, 000B],			$
		[000B, 160B, 068B, 000B, 000B],			$
		[000B, 160B, 254B, 007B, 000B],			$
		[000B, 064B, 169B, 002B, 000B],			$
		[000B, 128B, 255B, 001B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B]			$
		],						$
		;shrink.bm
		[						$
		[000B, 000B, 008B, 000B, 000B],			$
		[000B, 000B, 008B, 000B, 000B],			$
		[000B, 000B, 073B, 000B, 000B],			$
		[000B, 000B, 042B, 000B, 000B],			$
		[000B, 000B, 028B, 000B, 000B],			$
		[000B, 000B, 008B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[128B, 255B, 255B, 255B, 001B],			$
		[128B, 000B, 000B, 000B, 001B],			$
		[128B, 000B, 000B, 000B, 001B],			$
		[128B, 000B, 000B, 000B, 001B],			$
		[128B, 000B, 000B, 000B, 001B],			$
		[128B, 000B, 000B, 000B, 001B],			$
		[128B, 000B, 000B, 000B, 001B],			$
		[128B, 000B, 000B, 000B, 001B],			$
		[128B, 000B, 000B, 000B, 001B],			$
		[132B, 000B, 000B, 000B, 033B],			$
		[136B, 000B, 000B, 000B, 017B],			$
		[144B, 000B, 000B, 000B, 009B],			$
		[191B, 000B, 000B, 000B, 253B],			$
		[144B, 000B, 000B, 000B, 009B],			$
		[136B, 000B, 000B, 000B, 017B],			$
		[132B, 000B, 000B, 000B, 033B],			$
		[128B, 000B, 000B, 000B, 001B],			$
		[128B, 000B, 000B, 000B, 001B],			$
		[128B, 000B, 000B, 000B, 001B],			$
		[128B, 000B, 000B, 000B, 001B],			$
		[128B, 000B, 000B, 000B, 001B],			$
		[128B, 000B, 000B, 000B, 001B],			$
		[128B, 000B, 000B, 000B, 001B],			$
		[128B, 000B, 000B, 000B, 001B],			$
		[128B, 000B, 000B, 000B, 001B],			$
		[128B, 255B, 255B, 255B, 001B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 008B, 000B, 000B],			$
		[000B, 000B, 028B, 000B, 000B],			$
		[000B, 000B, 042B, 000B, 000B],			$
		[000B, 000B, 073B, 000B, 000B],			$
		[000B, 000B, 008B, 000B, 000B],			$
		[000B, 000B, 008B, 000B, 000B]			$
		],						$
		;grow.bm
		[						$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[248B, 255B, 255B, 255B, 031B],			$
		[008B, 000B, 000B, 000B, 016B],			$
		[008B, 000B, 008B, 000B, 016B],			$
		[008B, 000B, 028B, 000B, 016B],			$
		[008B, 000B, 042B, 000B, 016B],			$
		[008B, 000B, 073B, 000B, 016B],			$
		[008B, 000B, 008B, 000B, 016B],			$
		[008B, 000B, 008B, 000B, 016B],			$
		[008B, 000B, 008B, 000B, 016B],			$
		[008B, 000B, 008B, 000B, 016B],			$
		[008B, 000B, 008B, 000B, 016B],			$
		[008B, 000B, 000B, 000B, 016B],			$
		[008B, 000B, 000B, 000B, 016B],			$
		[008B, 001B, 000B, 000B, 016B],			$
		[136B, 000B, 000B, 128B, 016B],			$
		[072B, 000B, 000B, 000B, 017B],			$
		[232B, 063B, 000B, 000B, 018B],			$
		[072B, 000B, 000B, 252B, 023B],			$
		[136B, 000B, 000B, 000B, 018B],			$
		[008B, 001B, 000B, 000B, 017B],			$
		[008B, 000B, 000B, 128B, 016B],			$
		[008B, 000B, 000B, 000B, 016B],			$
		[008B, 000B, 000B, 000B, 016B],			$
		[008B, 000B, 000B, 000B, 016B],			$
		[008B, 000B, 016B, 000B, 016B],			$
		[008B, 000B, 016B, 000B, 016B],			$
		[008B, 000B, 016B, 000B, 016B],			$
		[008B, 000B, 016B, 000B, 016B],			$
		[008B, 000B, 146B, 000B, 016B],			$
		[008B, 000B, 084B, 000B, 016B],			$
		[008B, 000B, 056B, 000B, 016B],			$
		[008B, 000B, 016B, 000B, 016B],			$
		[008B, 000B, 000B, 000B, 016B],			$
		[248B, 255B, 255B, 255B, 031B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B],			$
		[000B, 000B, 000B, 000B, 000B]			$
		]						$
	   ]

FOR i = 0,N_ELEMENTS(controls[0,0,*])-1 DO $
  toss = WIDGET_BUTTON(XSurfacepalette, $
		VALUE = controls[*,*,i], $
		UVALUE = STRING(i), event_pro='buttons_event')

resbutton = WIDGET_BUTTON(XSurfacepalette, $
		VALUE = "Reset", $
		event_pro='reset_event')

skirtbase = WIDGET_BASE(partbase, $
		/COLUMN, $
		/NONEXCLUSIVE, $
		/FRAME)

legbutton = WIDGET_BUTTON(skirtbase, $
		VALUE = "Legend", $
		UVALUE = "LEGEND",event_pro='bottom_event')

gridbutton = WIDGET_BUTTON(skirtbase, $
		VALUE = "Overlay Grid", $
		UVALUE = "GRIDON",event_pro='bottom_event')

timebutton = WIDGET_BUTTON(skirtbase, $
		VALUE = "Time Stamp", $
		UVALUE = "TIMEON",event_pro='bottom_event')

skirtbase2 = WIDGET_BASE(partbase, $
		/COLUMN, $
		/NONEXCLUSIVE, $
		/FRAME)

axesbutton = WIDGET_BUTTON(skirtbase2, $
		VALUE = "Show Axes", $
		UVALUE = "PLOTAXES",event_pro='bottom_event')

aspbutton = WIDGET_BUTTON(skirtbase2, $
		VALUE = "Aspect Ratio", $
		UVALUE = "ASP",event_pro='bottom_event')

logbutton = WIDGET_BUTTON(skirtbase2, $
		VALUE = "Log Contours", $
		UVALUE = "LOG",event_pro='bottom_event')

XSurfacedisplay = WIDGET_DRAW(thebase, $
		XSIZE = 600, $
		YSIZE = 600, $
		RETAIN = 2)

sidebase=WIDGET_BASE(thebase, $
		/COLUMN, $
		/FRAME, $
		space=30)

t2 = widget_text(sidebase,  $
		value='Time:           0')
widget_control, sidebase, set_uvalue=t2

t1 = widget_slider(sidebase, $
;		value=0, $
;		max=44,$
;		max=10, $
		event_pro='go_to_slider', $
		xsize=175)
;___________________________________________________ structure number buttons

varbase = WIDGET_BASE(sidebase,  $
 		/ROW, $
		/FRAME, $
		/EXCLUSIVE, $
		TITLE='Structures',$
		space=30)

den = WIDGET_BUTTON(varbase, $
		VALUE = '1', /no_release,$
		event_pro='str_button')

press = WIDGET_BUTTON(varbase, $
		VALUE = '2', /no_release,$
		event_pro='str_button')

velx  = WIDGET_BUTTON(varbase, $
		VALUE = '3', /no_release,$
		event_pro='str_button')

vely  = WIDGET_BUTTON(varbase, $
		VALUE = '4', /no_release,$
		event_pro='str_button')

magbase = WIDGET_BASE(sidebase,  $
              /ROW, $
              /FRAME, $
              TITLE='Magnitude',$
              space=30)

magbut = WIDGET_BUTTON(magbase, $
              VALUE = 'MAG[1,2]->4', $
              event_pro='mag_button')

magbut = WIDGET_BUTTON(magbase, $
              VALUE = '1*2->4', $
              event_pro='cur_button')

;___________________________________________________ variable list widget
;						  (update when file is opened)
list = WIDGET_LIST(sidebase, $
                   ysize=15, $
                   event_pro='varlist_event')

;___________________________________________________

XSurfacecontrols = WIDGET_BASE(Xsurfacebase, $
		/ROW)


shadebase = WIDGET_BASE(XSurfacecontrols, $
		/COLUMN, $
		/EXCLUSIVE, $
		/FRAME)

plotcont = WIDGET_BUTTON(shadebase, $
		VALUE = "Contour", $
		UVALUE = "PLOTCONT",event_pro='bottom_event')

plotsurf = WIDGET_BUTTON(shadebase, $
		VALUE = "Surfaceplot", $
		UVALUE = "PLOTSURF",event_pro='bottom_event')

plotvec  = WIDGET_BUTTON(shadebase, $
		VALUE = "Vector plot", $
		UVALUE = "PLOTVEC",event_pro='bottom_event')

;___________________________________________________
plotbase = WIDGET_BASE(XSurfacecontrols, $
		/COLUMN, $
		/EXCLUSIVE, $
		/FRAME)

conto = WIDGET_BUTTON(plotbase, $
		VALUE = "Contour", $
		UVALUE = "CONTOUR", event_pro='bottom_event')

fill = WIDGET_BUTTON(plotbase, $
		VALUE = "Filled", $
		UVALUE = "FILLED", event_pro='bottom_event')

botha = WIDGET_BUTTON(plotbase, $
		VALUE = "Both", $
		UVALUE = "BOTH", event_pro='bottom_event')

timbase = WIDGET_BASE(XSurfacecontrols, $
		/COLUMN, $
		/EXCLUSIVE, $
		/FRAME)

animebutton=WIDGET_BUTTON(timbase, $
		VALUE='ANIMATION', $
		event_pro='anime_event')

rangebase= WIDGET_BASE(XSurfacecontrols, $
		/COLUMN, $
		/FRAME)

xrangebase= WIDGET_BASE(rangebase, $
		/ROW, $
		/FRAME)

xrange=WIDGET_LABEL(xrangebase, value = 'Xrange: min, max')
  intext = widget_text(xrangebase, /editable, xsize=8, ysize=1, $
  event_pro='xrange_event')

yrangebase= WIDGET_BASE(rangebase, $
		/ROW, $
		/FRAME)

yrange=WIDGET_LABEL(yrangebase, value = 'Yrange: min, max')
  intext = widget_text(yrangebase, /editable, xsize=8, ysize=1, $
  event_pro='yrange_event')

WIDGET_CONTROL, XSurfacebase, /REALIZE

WIDGET_CONTROL, den, /SET_BUTTON
WIDGET_CONTROL, legbutton, /SET_BUTTON
WIDGET_CONTROL, timebutton, /SET_BUTTON
WIDGET_CONTROL, axesbutton, /SET_BUTTON

WIDGET_CONTROL, plotcont, /SET_BUTTON
WIDGET_CONTROL, conto, /SET_BUTTON
WIDGET_CONTROL, XSurfacedisplay, GET_VALUE = temp & thedraw = temp

IF(N_PARAMS() gt 0) THEN BEGIN
	thedata = DATA
	XSurface_draw
END

;setting info variables
d=1
p=1
v=1
s=0
ps=0
xmrgn = [10.0, 3.0]
ymrgn = [4.0, 2.0]
shade1 = 0
def_int=0
leg_txt=''
;default time information
t0=fltarr(1000)

info={ 	slidtxt  :t2, $		;slider value for the text, integer
	slid_id  :t1, $		;slider event id, integer
	time     :t0, $ 	;array of times (default is 500 elements)
	timeid   :0, $		;time array access index
	strstr   :'1', $	;string for variable structure number
	list:list,$		;widget id for variable list
	varlist:strarr(100),$	;list of variables in EXODUS file
	plast    :[0.0,0.0],$	;lineout variables
	qlast    :[0.0,0.0],$	;lineout variables
;
	shade    :s, $		;counter to regulate surface plot
	legopt   :',/thermo',$  ;legend option
	conopt   :'', $		;contour specification option
	plotopt  :'', $		;surface plot option
	fillopt  :'', $		;(non)filled option
	aspopt   :'', $		;aspect ratio options command
	logopt   :'', $		;log option command
	xrangeopt:'', $		;range commands
	xrange   :'', $		;xrange text
	yrangeopt:'', $		;range commands
	yrange   :'', $		;yrange text
;
	meshopt  :'', $		;command for mesh overlay
	contcount:0, $		;contour control counter, integer
	levelopt :'', $		;contour control command
	numl     :0, $		;contour control, number of levels
	minl     :0, $		;contour control, min value
	maxl     :0, $		;contour control, max value
;
	moveopt  :'', $		;rotation command
	c1       :'', $  	;xrotation command
	c2       :'', $		;zrotation command
	c3       :'', $		;xmargin command
	c4       :'', $		;ymargin command
 	xrot     :30, $ 	;altitude value
 	zrot     :30, $ 	;azimuthal value
;
        horz     : 0, $         ; flag for horizontal lineout
        vert     : 0, $         ; flag for vertical lineout
	xmargin  :xmrgn, $	;xmargin value
	ymargin  :ymrgn, $	;ymargin value
	outtype  :'', $		;type of output
	fname    :'', $		;output name
	command  :'plotfe9, info.strstr , info.timeid+1, /set, /ind', $
	commbase  :'plotfe9, info.strstr, info.timeid+1, /set, /ind' }


widget_control, tlb, set_uvalue=info

WSET, save_win
print, 'ready'
XMANAGER, 'z', tlb,/no_block

END ;================ end of XSurface background task =====================

