FUNCTION WIENERsq4,a,b,gamma,gidkernsize=gidkernsize  , residual=rbarsq

; weiner filter hacked from constrained least square iamge restoration chapter
; of "digital image processing" by Gonzalez and Wintz. Similar processes can be found in most
; similar texts.
; returns scalar total of residual squared as keyword
; attempt at measuring noise parameteres and comparing to residual
; now does a simple constrained least squares reconstruction  when a gamma value is supplied
; or attempts to locate a reasonable value if gamma  is set to zero 
; this doesn't work very well however it may get you to within a couple of orders of magnitude!!!

ss=size(a)
asize=ss[1]-3
pe=FFT([[0,1,0,fltarr(asize)],[1,-4,1,fltarr(asize)],[0,1,0,fltarr(asize)],[fltarr(asize+3,asize)]]  ,-1,/double)
peconjpe=pe*CONJ(pe)

;get some noise statistics

if keyword_set(gidkernsize) eq 0 then gidkernsize=10

noisestats=noisestats_wiener(a,gidkernsize)

g=(a)
h=(b)
g=FFT(g,-1,/double)
;g=g/total(g)
h=FFT(h,-1,/double)
;h=h/TOTAL(h)

xxxx=conj(h)
hxxxx=h*xxxx
wz=where(hxxxx eq complex(0.,0.,/double)  ,count)
if count ne 0 then hxxxx[wz]=complex(1.,1.,/double)

if gamma gt 0. then begin
  rbarsq1=gamma_guess(gamma ,h ,g  ,xxxx, hxxxx ,peconjpe,wien2=wien2)
  wien2=shift(abs(fft(wien2,1)),ss[1]/2,ss[2]/2)
endif else begin
  gamma1=1.
  rbarsq1=gamma_guess(gamma1 ,h ,g  ,xxxx, hxxxx ,peconjpe,wien2=wien2)
  while rbarsq1 gt noisestats   do begin
    gamma1=gamma1/10.
    if gamma1 lt 1e-4 then noisestats=noisestats*1.5
  endwhile
  gamma0=gamma1
  gamma2=gamma1*5.
  index=0
  window,27
  DEVICE, DECOMPOSED=0
  loadct,39
  loopcount=0
  REPEAT BEGIN
    rbarsq2=gamma_guess(gamma2 ,h ,g ,xxxx, hxxxx ,peconjpe,wien2=wien2)
    gradient=(rbarsq2-rbarsq1)/(gamma2-gamma1)
    gamma3=gamma2-(rbarsq2-noisestats)/gradient > gamma0

    print,loopcount,gamma1,gamma2,gamma3,gradient
    print,loopcount,rbarsq1,rbarsq2, noisestats
    print,''
    wien2=shift(abs(fft(wien2,1)),ss[1]/2,ss[2]/2)
    plotimage,bytscl(wien2 ) , xr=[250,750],yr=[200,900],/isotropic   $
      ,tit='wiener gamma'+string(gamma2)    , BACKGROUND = 255, COLOR = 0
      colorbar, divisions=5 , ticknames=string(findgen(6)/5. , format='(f3.1)'  ), $
      /vert, BACKGROUND = 255, COLOR = 0
    
;if gradient gt 10. then noisestats=noisestats*1.05
;if gradient gt 1e-4 then gamma0=gamma1
;if gradient lt 1e-12 then noisestats=noisestats/1.1

    gamma1=gamma2
    gamma2=gamma3
    rbarsq1=rbarsq2
    loopcount=loopcount+1
    requireddelta=noisestats/100.
  ENDREP UNTIL (rbarsq1 gt noisestats - requireddelta) and $
               (rbarsq1 lt noisestats + requireddelta) or $
               (loopcount ge 20) or (FINITE(gradient) EQ 0) $
               or (gradient le  1e-25)
    loadct,0
  print,'gamma =  ',gamma1
  print,'res sq =  ',rbarsq1
  print,'noisestats  =  ',noisestats
endelse

RETURN,wien2
end
