; ------------------------------------------------------------------------ 
; $Id: qs_cond_in.pro,v 1.2 2006/08/30 20:34:35 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2005 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
pro qs_cond_in, index, name, vertex, dielectric=dielectric

@qs_enums.com
@qs_data.com

;  Create vertex data from cim

size_v = n_elements(vertex)/3
vertex = reform(vertex, 3, size_v, /overwrite)
crdflg = qs_grid.spare[0]

;  Build vertex structure for each conductor or dielectric

if keyword_set(dielectric) then begin
  if index eq 1 then begin
    first_diel = first_cond + numbr_cond
    numbr_diel = 0
  endif
  current = first_diel + numbr_diel
  build_vertex_struct, current, index, name, crdflg, size_v, vertex
  numbr_diel = numbr_diel + 1

endif else begin
  if index eq 1 then begin
    first_cond = 20
    numbr_cond = 0
    numbr_diel = 0    ; conductors must be defined before dielectrics
  endif
  current = first_cond + numbr_cond
  build_vertex_struct, current, index, name, crdflg, size_v, vertex
  numbr_cond = numbr_cond + 1
endelse

return
end
