pro qsplot, cnormin, xnormin, polar=polarin, $
            conductors=lccondin, grid=lcgridin, $
            oto=lc1t1in, $
            xrange=xranin, yrange=yranin, xlabel=xlabin, ylabel=ylabin

@qs_enums.com
@qs_data.com
@qsplotpars.com

if n_elements(cnormin) eq 0 then cnorm = c_norm else cnorm = cnormin
if n_elements(xnormin) eq 0 then x_norm = zslice[c_norm-1] else x_norm = xnormin
if n_elements(polarin) ne 0 then pol = polarin else $
  if keyword_set(polarin) then pol = 1 else pol = polar
if n_elements(lccondin) ne 0 then lccon = lccondin else $
  if keyword_set(lccondin) then lccon = 1 else lccon = lccond
if n_elements(lcgridin) ne 0 then lcgrd = lcgridin else $
  if keyword_set(lcgridin) then lcgrd = 1 else lcgrd = lcgrid
if n_elements(lc1t1in) ne 0 then lc1t1 = lc1t1in else $
  if keyword_set(lc1t1in) then lc1t1 = 1 else lc1t1 = lc1to1
;;if n_elements(xranin) eq 0 then xran = dfxran else xran = xranin
;;if n_elements(yranin) eq 0 then yran = dfyran else yran = yranin
;;if n_elements(xlabin) eq 0 then xlab = xlabl else xlab = xlabin
;;if n_elements(ylabin) eq 0 then ylab = ylabl else ylab = ylabin

; Set up plot axes

if n_elements(xranin) eq 2 and n_elements(yranin) eq 2 then begin
  plotgrd, qs_grid, t1, t2, x_norm, aspect=lc1t1, $
    polarplot=polar, header=0, title=' ', /frame, /quiet, $
    xrange=xranin, yrange=yranin, /xstyle, /ystyle
endif else $
  plotgrd, qs_grid, t1, t2, x_norm, aspect=lc1t1, $
    polarplot=polar, header=0, title=' ', /frame, /quiet

; Plot grid 

if lcgrd then $
  plotgrd, qs_grid, t1, t2, x_norm, polarplot=polar, /overplot, /quiet


; Plot dielectrics 

if lcdiel then begin
  for n=first_diel, first_diel+numbr_diel-1 do $
    plotcon, n, t1, t2, x_norm, polarplot=polar, color=CYAN, $
      /overplot, /quiet

endif

; Plot conductors 

if lccon then begin
  for n=first_cond, first_cond+numbr_cond-1 do $
    plotcon, n, t1, t2, x_norm, polarplot=polar, color=YELLOW, $
      /overplot, /quiet

endif

;  Plot boundary conditions
if lcbcnd then begin
;;  color = RED
  for n=first_bc, first_bc+numbr_bc-1 do begin
    plotcon, n, t1, t2, x_norm, polarplot=polar, color=BLUE, $
      /overplot, /quiet
;;    color = color + 1
  endfor
endif

;  Plot history diagnostics

if lcdiag then begin
  for n=first_diag, first_diag+numbr_diag-1 do $
    plotcon, n, t1, t2, x_norm, polarplot=polar, color=MAGENTA, $
      /overplot, /quiet
endif

;  Plot slice locations
if lcslic then begin
vertex = make_array(3, 12, /float)
size_v = 0
for i=I_DIR-1, K_DIR-1 do begin
  tran1 = (i+1) mod 3
  tran2 = (i+2) mod 3
  vertex[i, size_v:size_v+4-1] = zslice[i]
  vertex[tran1, size_v] = qs_grid.range[0,tran1,0]
  vertex[tran2, size_v] = qs_grid.range[0,tran2,0]
  vertex[tran1, size_v+1] = qs_grid.range[1,tran1,0]
  vertex[tran2, size_v+1] = qs_grid.range[0,tran2,0]
  vertex[tran1, size_v+2] = qs_grid.range[1,tran1,0]
  vertex[tran2, size_v+2] = qs_grid.range[1,tran2,0]
  vertex[tran1, size_v+3] = qs_grid.range[0,tran1,0]
  vertex[tran2, size_v+3] = qs_grid.range[1,tran2,0]
  size_v = size_v + 4
endfor

temp = 1
build_vertex_struct, temp, temp, 'temp', qs_grid.spare[0], size_v, vertex
plotcon, temp, t1, t2, x_norm, polarplot=polar, color=GREEN, $
  linestyle=2, thick=1, /overplot, /quiet
endif

return
end
