; ------------------------------------------------------------------------ 
; $Id: cell2node.pro,v 1.4 2009/09/02 15:57:10 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro cell2node, values, imat, nodes, bad = bad, good = good
; 
; put cell values on nodes.
;
 nodes = 0
 ss = size(values)
 sss = size (imat)
 if ((ss(0) ne sss(0)) or (ss(1) ne sss(1))or (ss(2) ne sss(2)) $
   or (ss(0) ne 2)) then begin
   print, '% CELL2NODE:  Material and values matric must be the same size.'
   print, ss(0), ss(1), ss(2), sss(0), sss(1), sss(2)
   return
 endif
 if n_elements(bad) eq 0 then  $
  bad = where (imat(1:*, 1:*) eq 0)
 nx = ss(1)
 nxm = nx-1
 ny = ss(2)
 nym = ny-1
 nval = intarr(nx, ny)
 nvalr = make_array(nxm, nym, value = 1, /int)
 valr = values(1:nxm, 1:nym)
 if bad(0) ge 0 then begin
   nvalr[bad]= 0
   valr[bad]=0.0
 endif
 nodes = make_array(nx, ny, value = 0.0)
 nodes(0:nxm-1, 0:nym-1)= valr
 nval(0:nxm-1, 0:nym-1)= nvalr

 nodes(1:nxm, 0:nym-1)= nodes(1:nxm, 0:nym-1)+ valr
 nval(1:nxm, 0:nym-1) = nval(1:nxm, 0:nym-1) + nvalr

 nodes(1:nxm, 1:nym)= nodes(1:nxm, 1:nym)+ valr
 nval(1:nxm, 1:nym) = nval(1:nxm, 1:nym) + nvalr

 nodes(0:nxm-1, 1:nym)= nodes(0:nxm-1, 1:nym)+ valr
 nval(0:nxm-1, 1:nym) = nval(0:nxm-1, 1:nym) + nvalr

 
 good = where (nval gt 0)
 nodes = nodes/(nval > 1)
 end
