; ------------------------------------------------------------------------ 
; $Id: get_pdb_rzreg.pro,v 1.4 2007/06/06 19:45:14 lpmix Exp $
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;

 pro get_pdb_rzreg, x1, x2, ireg, ier, double = double
;+
; Utility to get spatial information from each file
; x1 = z
; x2 = r
; ireg = ireg
;
;-
      on_error, 1
;     add common block
@pdbcom.dat

      ier = 999
;
      info = *family_info(curfid)
;     get time and ntime
; ntime
      ntime = info.ntime

      nfile = info.nfile
      siza = info.size
      nelx = siza[0]
      nely = siza[1]
      siz = nelx*nely
      if siz lt 4 then begin
        print,  '% GET_PDB_RZREG: SIZE information is bad:', siz, siza
        return
      endif
      siz = [nelx, nely, 0L]
      lcireg = 1
      for ifil = 0, nfile-1 do begin
        finfo = *file_info[curfid*max_pdb_file +ifil]
        nt = info.loct[ifil+1]-info.loct[ifil]
        siz[2] = nt
; x1 data
        tmp = finfo.zt
        stmp = size(tmp)
        if nt eq 1 then lcomp = 2 else lcomp= 3
        if max(abs(stmp[1:lcomp] -siz)) ne 0 then begin
          print, '% GET_PDB_RZREG: Error reading zt@history', ifil,stmp, siz
          return
        endif
        if ifil eq 0 then begin
          if not keyword_set(double) or stmp[4] eq 4 then begin
            x1 = make_array(nelx, nely, info.ntime)
            x2 = make_array(nelx, nely, info.ntime)
          endif else begin
            x1 = make_array(nelx, nely, info.ntime, /double)
            x2 = make_array(nelx, nely, info.ntime, /double)
          endelse
          ireg  = make_array(nelx, nely, info.ntime, /long)
        endif
        x1[*,*, info.loct[ifil]:info.loct[ifil+1]-1] = tmp


; x2 data
        tmp = finfo.rt
        stmp = size(tmp)
        if max(abs(stmp[1:lcomp] -siz)) ne 0 then begin
          print, '% GET_PDB_RZREG: Error reading rt@history', ifil,stmp, siz
          return
        endif
        x2[*,*, info.loct[ifil]:info.loct[ifil+1]-1] = tmp

; ireg data
        if lcireg gt 0 then begin
          tmp = finfo.ireg
          stmp = size(tmp)
          if max(abs(stmp[1:2] -siz[0:1])) ne 0 then begin
            print, '% GET_PDB_RZREG: Error reading rt@history', ifil,stmp, siz
            return
          endif
          if (stmp[0] eq 3 and stmp[3] eq nt) or nt eq 1 then begin
            ireg[*,*, info.loct[ifil]:info.loct[ifil+1]-1] = tmp
          endif else begin
            lcireg = 0
            ireg = temporary(tmp)
          endelse
        endif
      endfor
      ier = 0
      return
      end
