; ------------------------------------------------------------------------ 
; $Id: init_pdb.pro,v 1.6 2009/03/04 19:37:49 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
  pro init_pdb, pdbexe = a
;
; This routine initializes parameters for PDB common block
;
@pdbcom.dat

; PDB common block
; 
;
; common pdbcommon, initpdb, pdb_exe, ufid, pdbfid, maxfid, curfid, file_info
;
;     start the process
;
;
common copyright_common, copyright_init
      if n_elements (copyright_init) eq 0 then copyright_notice

      on_error, 1
      if n_elements(initpdb) eq 0 then initpdb =0
      if initpdb gt 0 then return
      maxfid = 20
      p1 = 0L
;
      if n_elements (copyright_init) eq 0 then copyright_notice
      if n_elements(a) eq 0 then a = getenv('PDB_EXE') 
      b = get_pfidl_directory()
      if strlen(b) eq 0 then b = path_sep()
      name = strupcase(strmid(!version.os, 0, 3))
      if (name  eq 'HP-') then begin
        if strlen(a) lt 1 then begin
          pdb_exe = b+'lib/hp_pdblib.sl' 
        endif else begin
          pdb_exe = a
          print, ' PDB_EXE=',pdb_exe
        endelse
        junk = call_external(PDB_EXE,'pdb_init', p1)
        initpdb = 1
      endif else if (name eq 'SUN') then begin
        list= tag_names(!version)
        i = get_match('MEMORY_BITS', list, nel= nel)
        name = 'sun_pfidl.so'
        if nel gt 0  && !version.memory_bits eq 64 then begin
          print, '% INIT_PDB:  PDB is not supported with 64 bit executables'
          return
        endif
        if strlen(a) lt 1 then begin
          pdb_exe = b+'lib/sun_pdblib.so'
        endif else begin
           pdb_exe = a
           print, ' PDB_EXE=',pdb_exe
        endelse 
        junk = call_external(PDB_EXE,'pdb_init_', p1)
        initpdb = 2
      endif else if name eq 'WIN' then begin
        vr = strmid(!version.release, 0, 1)+ strmid(!version.release, 2, 1)
        if strlen(a) lt 1 then pdb_exe = b+'lib\win_pdblib.so' $
          else   pdb_exe = a
        junk = call_external(PDB_EXE,'_PDB_INIT@8' , p1)
        initpdb = 4
      endif else if name eq 'LIN' then begin
; use this for linux
        if strlen(a) lt 1 then begin
            pdb_exe = b+'lib/linux/lin_pdblib.so'
        endif else begin
           pdb_exe = a
           print, ' PDB_EXE=',pdb_exe
        endelse
        junk = call_external(PDB_EXE,'pdb_init_', p1)
        initpdb = 2
      endif else begin
        print, 'This operating system is not supported by PFIDL'
      endelse
      if initpdb eq 0 then return
;     curfid = current pdb file id index (ufid[curfid] and pdbfid[curfid])
      curfid = -1L
      maxfid = 3L
      n_pdbfile= make_array(3, /long)
      max_pdb_file = 256L
;     ufid = array of user file ids
      ufid = make_array(maxfid, /long)
;     pdbfid = array of pdb file ids.
      pdbfid = make_array(maxfid, /long)
;     family_info = array of file info structures
      family_info =  ptrarr(maxfid)
;     file_info = array of file info structures
      file_info =  ptrarr(max_pdb_file*maxfid)
      return
     end


