; ------------------------------------------------------------------------ 
; $Id: init_pds.pro,v 1.3 2007/06/06 19:50:17 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro INIT_PDS, nserver, pdsexe = a
;
;     this routine initializes the pds procedures
;
@pds_datacom.dat
@pds_info_types.dat

;
common copyright_common, copyright_init
      on_error, 1

      if n_elements (copyright_init) eq 0 then copyright_notice

      if n_elements(initpds) eq 0 then initpds = 0
      if initpds ne 0 then begin
;       If already initialized, then quit.
;       If previous failure, then quit.
        if initpds lt 0 then $
          print, '% PDS_INIT: This installation does not support PDS'
        return
      endif
      pds_id  = -1L
      initpds = -1L
      if n_elements(a) eq 0 then a = getenv('PDS_EXE')
      a = strtrim(a, 2)

      b = getenv('IDL_DIR')
      len = STRLEN(b) - 1
      IF STRPOS(b, '/', len) NE -1 and len gt 0 THEN b = strmid(b, 0, len)

      if strlen(a) gt 0 then pds_exe = a else $
         pds_exe = b + '/../pfidl/lib/pds_lib.so'
      if n_elements(nserver) eq 0 then nserver=1L else $
         nserver = long(nserver > 1L) 
      ier = 1L
      common_stuff= make_array(17, /long)
      junk = call_external(PDS_EXE, 'pdsp_init_', nserver,common_stuff, ier)
      pds_debug_level = 0
      if ier eq 0 then begin
        initpds = 1 
        PDS_TP            = common_stuff(0)       
        PDS_ST            = common_stuff(1)       
        PDS_SEG           = common_stuff(2)       
        PDS_VAR           = common_stuff(3)       
        PDS_DTF           = common_stuff(4)       
        PDS_INFO          = common_stuff(5)       
        PDS_SECT          = common_stuff(6)       
        PDS_DIM           = common_stuff(7)       
        PDS_NAME_SIZE     = common_stuff(8)       
        PDS_FILENAME_SIZE = common_stuff(9)       
        PIO_CHAR          = common_stuff(10)       
        PIO_SHORT         = common_stuff(11)       
        PIO_INT           = common_stuff(12)       
        PIO_FLOAT         = common_stuff(13)       
        PIO_DOUBLE        = common_stuff(14)       
        PDS_SCALAR        = common_stuff(15)       
        PDS_VECTOR        = common_stuff(16)
      endif else initpds = -1
      end
