; ------------------------------------------------------------------------ 
; $Id: endpff.pro,v 1.3 2007/06/06 19:59:46 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
  pro endpff
;+
;
;     this routine ends the pff procedures and closes files 
;     this procedure or CLOSEPFF should be used when writing to files 
;     to insure that the files are properly closed
;-
      common pffcom, initpff, pff_exe
;
;     check to see if pff has been initialized
;
      if (n_elements(initpff) eq 0) then initpff = 0
      if initpff eq 0 then begin
        print, '% ENDPFF: No PFF routines are active'
        return
      endif
;
;     end the process
;
      if initpff eq 1 or initpff eq 3 then begin
; HP
        junk = call_external(PFF_EXE,'pff_end')
      endif else if initpff eq 2 then begin
; Sun
        junk = call_external(PFF_EXE,'pff_end_')
      endif else if initpff eq 4 then begin
; WIN
        junk = call_external(PFF_EXE,'_PFF_END@8', 0)
      endif else if initpff eq 5 then begin
; MAC
        junk = call_external(PFF_EXE,'pff_end')
      endif
;
      initpff = 0
;
      return
      end
