; ------------------------------------------------------------------------ 
; $Id: curp.pro,v 1.3 2007/06/06 20:03:45 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro curp, point, wait, screen= screen,  _extra = extrastuff
;+
;   Name: CURP
;  
;   A wrapper for IDL cursor which prints the coordinates of the point.
;   
;   Format: curp [, P] [,WAIT] [, SCREEN = screen][, _EXTRA = extrastuff]
;     where
;           p    - Vector coordinates of the cursor location
;        wait    - Optional parameter to cursor command.
;                     Default = 3, return with a button down transition
;        screen  - Actual screen coordinates
;                  This may be different from P if engineering units are used.
;        extrastuff - any valid keywords for the IDL cursor command
;    Example:
;        Print the location of a point on a graph
;           curp 
;-
 common plot_grid_last, yeng_scale, xeng_scale

      if n_elements(yeng_scale) eq 0 then begin
        xeng_scale = 1.00
        yeng_scale = 1.00
      endif
     if n_elements(wait) eq 0 then wait = 3 else wait = (wait[0] > 0) < 4
     cursor , aa, bb, wait, _extra = extrastuff
     screen = [aa, bb]
     if xeng_scale ne 1.00 then aa = aa/xeng_scale
     if yeng_scale ne 1.00 then bb = bb/yeng_scale
     print, aa, bb
     point = [aa, bb]
     return
     end
