; ------------------------------------------------------------------------ 
; $Id: endvideo.pro,v 1.1 2011/05/05 18:38:59 lpmix Exp $
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
;+
;  Close the Video file and destroy the object.
;  Format: EndVideo
;
;  Examples:
;  Send the nframe images to a motion VIDEO file called: target.mp4
;; Initialize VIDEO
;    startVIDEO, 'target.mp4'
;; Generate frames
;    for i = 1L, nframe do begin
;      <Make a plot>
;      svideo
;    endfor
;; Close the file
;    endvideo
;;
;  View with xine on Linux or QuickTime on Windows.
;
;  MODIFICATION HISTORY:
;      Original version, L. P. Mix, May 4, 2011
;-
 
 Pro endVideo
on_error,1 

@switchvideo.dat

   if obj_valid(ovid_write) then begin
     ovid_write.Cleanup
     init_video = 1
   endif else print, '% EndVideo: No valid Video object'
     
   end
