; ------------------------------------------------------------------------ 
; $Id: getf.pro,v 1.3 2007/06/06 20:03:48 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro  Getf, f, wdf
;+
;     get the corresponding frequencies for a fft of an wdf array
;       format is: getf, freq, wdf
;       where freq is an IDL array of the frequencies and wdf is
;              the array number
;-
@com.dat
;
 on_error, 1
      if n_elements(initwdf) eq 0 then wdfinit
      nparams = n_params()
      if nparams lt 2 then begin
        print,' GETF must have at least 2 parameters'
        return
      endif
;
      if n_elements(wdf) eq 0 then begin
        print, 'Parameters to GETF must be defined'
        return
      endif
      if wdf lt 1 or wdf gt maxwdfarray then begin
        print, 'wdf array must be greater than 0 and </=', maxwdfarray
        return
      endif
;
      nel = wdfnp(wdf-1)
      if nel eq 0 then begin
        print, 'No valid data in the wdf array'
        return
      endif
      get_wdfarray, array1, wdf
      f = findgen(nel)
      f = f < (nel-f)
      total = nel * array1(1)
      f = f/total
      f(nel/2+1:*) = -f(nel/2+1:*)
      array1=0
      return
      end

