; ------------------------------------------------------------------------ 
; $Id: getyf.pro,v 1.3 2007/06/06 20:03:48 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Function  Getyf, wdf, maximum = maximum, minimum = minimum
;+
;     this procedure returns the ordinate values of an wdf array
;     format: yarray = getyf(wdf, maximum = maximum, minimum = minimum)
;     where yarray is the array of ordinate values
;           wdf is the WDF array number
;           minimum - minimum Y value
;           maximum - maximum Y value
;-
;
@com.dat
;
on_error, 1
      if n_elements(initwdf) eq 0 then wdfinit
      nparams = n_params()
      if nparams lt 1 then begin
        print,'% Format: y = GetYF( WDF [, Maximum = maxi] [, Minimum = mini])'
        return, 0.0
      endif
;
      if n_elements(wdf) eq 0 then begin
        print, '% GETYF: Parameters must be defined'
        return, 0.0
      endif
      if wdf lt 1 or wdf gt maxwdfarray then begin
        print, '% GETYF: wdf must be greater than 0 and </=', maxwdfarray
        return, 0.0
      endif
;
      nel = wdfnp(wdf-1)
      if nel lt 2 then begin
        print, 'No valid data in the wdf array'
        return, 0.0
      endif
      get_wdfarray, y, wdf, /xy
      if n_elements(y) eq nel+nel then begin
        y = y(nel:*)
      endif else begin
        y =y(2:*)
      endelse
      maximum = wdfmax(wdf-1)
      minimum = wdfmin(wdf-1)
      return, y
      end
