; ------------------------------------------------------------------------ 
; $Id: pwd.pro,v 1.4 2007/06/06 20:03:51 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro  pwd, current = current, quiet = quiet
;
;+
; NAME:
;       PWD
;
; PURPOSE:
;       Show current directory.
; CATEGORY:
;       UTILITY 
; CALLING SEQUENCE:
;       PWD [, CURRENT = current] [, /QUIET]
; KEYWORDS:
;       CURRENT   - Name of current directory.
;       QUIET     - NO output to terminal
; OUTPUTS:
;       CURRENT directory
; EXAMPLES:
;       Show current directory
;             PWD
; MODIFICATION HISTORY:
;      Original version, L. P. Mix, January 3, 1997
;-
;
;
      on_error, 1
       cd , current = current
      if strupcase(strmid(!version.os, 0, 3)) eq 'LIN' then resolve_it, current
;     get system variable substitution for unix systems
      if keyword_set(quiet) then return
      print, 'Present Directory: ', current
      return
      end
