; ------------------------------------------------------------------------
; $Id: read_pds.pro,v 1.2 2007/06/06 20:03:51 lpmix Exp $
; ------------------------------------------------------------------------
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
;+
; NAME:
;       READ_PDS
;
; PURPOSE:
;       Read a PDS Shrink data file in the LLNL, L-Division, file format.
;       This format is used by the Perkin-Elmer PDS machine.
;       (PDS files are PhotoDensitometer files in the L-Division format.)
;       The Perkin-Elmer file format utilizes a subset of L-Division PDS format.
;       For historical reasons, the READPE routine has been expanded to 
;       include the L-Division file extensions.
;
; CALLING SEQUENCE:
;       See READPE
;
; PROCEDURE:
;       Read the header file and then read the image file.
;       More details are in READPE
;
; MODIFICATION HISTORY:
;    Written by:       L. P. Mix, March 1, 2005
;-

PRO READ_PDS, a, b, c, d, _extra = extrastuff
on_error, 1
PRINT, '% READ_PDS:  See READPE for reading PDS files.'
print, '  Format: READPE , STR [, File_Name] [ , image] [ , space ]'
print, '            [, TLABEL = tlabel] [, CLABEL = clabel] [, BLABEL = blabel]'
print, '            [, XLABEL = xlabel] [, YLABEL = ylabel] [HEADER = header]'
print, '            [, NPOINTS = npoints] [, DELTA = delta] [, OUTFILE = outfile]'
print, '            [, XRANGE = xrange] [, YRANGE = yrange] [, SETVAL = setval]'
print, ' (input)    [, FILTER = filter] [, SCALE = scale] [SWAP = swap]'
print, '            [, PATH = path] [, MICRONS = microns] [, MMETERS = mmeters]'
print, '            [, XIMAGE = ximage] [, XHEADER = xheader] [PHEADER = pheader]'

END
