; ------------------------------------------------------------------------ 
; $Id: readtable.pro,v 1.3 2007/06/06 20:03:52 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro readtable, unit, nvar, ax, bx, np= np
;
;+
;    read an ascii table, as from a spread sheet
;    format is:  readtable, unit,nvar,x,y, np=np
;      NOTE
;     use readasc, unit, nvar, x,y, np= np in the future
;     this procedure is being eliminated!!
;
;    where 
;      unit    - the unit of the file which is open
;      nvar    - the number of variables in a record
;                form of the record is assumed to be: x, y1, y2, y3, ... 
;      x       - abscissa values - dimensioned x(np)
;      y       - ordinate values - dimensioned y(np, nvar-1)
;      np      - on input NP is the number of data values to be read
;                if np is less than or equal to zero or undefined
;                  4096 values will be attempted to be read 
;                  otherwise np values will be read 
;                np will always return the number of values read
;    Example:
;      A table contains time in the first column and voltage and current 
;      in the next two.  The file is called 'data'.
;        openr, unit, 'data', /get
;        readtable, unit, 3, time, stuff
;        volt = stuff(*, 0) & curr = stuff(*, 1)
;        free_lun, unit
;-
;
      on_error, 1
      print, ' This procedure is being eliminated'
      print, ' Use READASC in the future.
      if n_elements (np) eq 0 then np = 0
      if np le 0 then np = 4096L
      maxnp = np
      ax =make_array(maxnp)
; Time to start reading
      if nvar eq 1 then begin
        i=0
        while (not eof(unit)) and i lt maxnp do begin
          readf,unit,x
          ax(i) = x
          i = i+1
        endwhile
      endif else begin
        bx = make_array (maxnp, nvar-1)
        y = make_array (nvar-1)
        i=0
        while ((not eof(unit)) and i lt maxnp) do begin
          readf,unit,x, y
          ax(i) = x
          bx(i, *) = y
          i = i+1
        endwhile
      endelse
      if i eq 0 then begin
        np = 0
        print, ' Error reading file -- No data found'
        return
      endif
      np = i
      ax= ax(0:i-1)
      if nvar gt 1 then bx = bx(0:i-1, *)
      return
      end
