; ------------------------------------------------------------------------ 
; $Id: restorect.pro,v 1.3 2007/06/06 20:03:53 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro restorect, filename , filename = filnam
;
;+
;    restore  a color table from a file
;    special command to restore the bottom 8 colors and the last color and 
;       and scale the others to fill the table
;    if filename is no used then the keyword filename is used
;    format: restorect, filename, filename = filenam
;-
  on_error, 1
  if n_elements(filename) eq 0 then begin
    if n_elements(filnam) ne 0 then filename = filnam
  endif
  if n_elements(filename) eq 0 then filename = 'idl_color_table.dat'
;
  restore, filename
  nred = n_elements(r)
  if nred lt 9 then begin
    print, 'RESTORECT is unsuccessful'
    return
  endif
  ncol = !d.table_size - 10
  ninput = nred- 10
  if ninput ne ncol then begin
    x = 9+findgen(ncol) * (ninput-1)/(ncol-1)
    rr = [r(0:8), interpolate(r, x, /grid), r(nred-1)]
    gg = [g(0:8), interpolate(g, x, /grid), g(nred-1)]
    bb = [b(0:8), interpolate(b, x, /grid), b(nred-1)]
    tvlct, rr, gg, bb
  endif else tvlct, r, g, b
  return
  end
