; ------------------------------------------------------------------------ 
; $Id: setpff.pro,v 1.3 2007/06/06 20:03:53 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro  setpff, p1, ier
;+
;   Set the current file pointer to file with specified file id
;   Format: SETPFF,  fileid, ierror
;   where:
;      fileid - file id of desired file
;      ierror - Returns 0 if no errors
;   Note:  If fileid is undefined or is zero, nothing is done.
;    Example:
;   Set the current file pointer to the file with a file id (fid) of 3
;      setpff, 3
;-
;
      common pffcom, initpff, pff_exe
on_error, 1
;
;     check to see if pff has been initialized
;
;
;     check on the number of parameters
;
      ier =1L
      if n_params() eq 0 then begin
        print,'% Format: SETPFF,  fileid, IERROR'
        return
      endif

      if (n_elements(initpff) eq 0) then initpff=0
      if (initpff eq 0) then begin
        print, '% SETPFF: No PFF files are open'
        return
      endif
;     if no fid is entered then return
      if (n_elements(p1) eq 0) then begin
        print, '% SETPFF: File id must be provided'
        return
      endif
;     if p1 is zero then quit
      if p1 eq 0 then begin
        print ,'% SETPFF: File id is zero - nothing changed'
        return
      endif
;
;     get integers for the write
;
      ier = 0L
      fid = long(p1(0))
      if initpff eq 1 then begin
; HP
        junk=call_external(PFF_EXE,'pff_slset',fid, ier)
      endif else if initpff eq 2 then begin
; Sun
        junk=call_external(PFF_EXE,'pff_slset_',fid, ier)
      endif else if initpff eq 4 then begin
; WIN
        junk=call_external(PFF_EXE,'_PFF_SLSET@8',fid, ier)
      endif else if initpff eq 5 then begin
; MAC
        junk=call_external(PFF_EXE,'pff_slset',fid, ier)
      endif else if initpff eq 3 then begin
; VMS
        junk=call_external(PFF_EXE,'pff_set',fid, ier)
      endif
      return
      end
