; ------------------------------------------------------------------------ 
; $Id: sgif.pro,v 1.3 2007/06/06 20:03:53 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro sgif, filename 
;+
;  Save the current screen information to a file.
;
;  Format: SGIF [, FILENAME] [, NO_SORT = no_sort]
;
;  where:
;    filename - optional filename.
;               Default is set by startgif
;               ('idl' is the default value if none is specified
;                 ie.  idl0001.gif, idl0002.gif  ....etc.)
;
;  Examples:
;  Send the plots to gif files of the form: movie0001.gif, movie0002.gif, ...
;    startgif, file =  'movie'
;    < do a plot >
;    sgif
;    < do a plot >
;    sgif
;    < do a plot >
;    sgif    ; etc
;    endgif
;-
   common switchgif,xythicksave,thicksave,oldthick,oldxythick,oldfont, $
      gif_file, font_default, no_swap, character_size, file_number, $
      lc_gif_output, old_character_size


   if n_elements(filename) gt 0 then filename=strtrim(filename(0),2) else begin
     if n_elements (gif_file) eq 0 then begin
       print,' %SGIF: GIF file must be defined.
       return
     endif

     filename = gif_file+string(file_number, format='(i4.4)')+'.gif'
     file_number = file_number +1
   endelse
   if n_elements(no_sort) eq 0 then no_sort = 1
 
device, get_visual_depth = depth

tvlct, r, g, b, /get
if depth le 8 then write_gif, filename, tvrd() , r, g, b   else begin
;  idl 5.5
   if  strmatch(!version.release, '5.5*') then device, /bypass_translation
   write_gif, filename, color_quan(tvrd(/true), 1, r, g,b, cube=6), r, g, b
endelse

;    write_gif, filename, color_quan(tvrd(/true), 1, r, g,b, col=256), r, g, b
;
; note for true color displays:
; can also try , cube = 6 keyword to the color_quan() routine
; Cube = 6 produces 216 colors by dividing each axis of the color cube into 
;        6 colors.
; Default method uses statistical method. 
;
   return
   end
