; ------------------------------------------------------------------------ 
; $Id: swapct.pro,v 1.4 2010/09/17 21:23:38 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
  Pro swapct, reset = reset
;+ 
; Name:         SWAPCT
;
; Format:       SWAPCT [, /RESET]
;        where
;               RESET restores original color table.
; Purpose:      Reverses background and drawing colors for future plots by
;               exchanging the colors in the color table. 
;               Note: Existing plots are modified, but loading a new color 
;                     table will change everything back to the original colors.
;               See swap.pro to modify the drawing colors
; Technique: switches the color table entries for !p.color and !p.background
;-
  on_error, 1
@loadxyct_common.dat
; common loadxyct_common, loadct_init, max_color ,invertct_flag
  if keyword_set(reset) then begin
    invertct_flag = 0
    loadxyct, /quiet
    return
  endif
  if invertct_flag eq 0 then invertct_flag = -1 $
    else invertct_flag = -invertct_flag
  ncm = !d.table_size-1
  tvlct, r, g, b, /get
  tvlct, r[ncm], g[ncm], b[ncm], 0
  tvlct, r[0], g[0], b[0], ncm
  return
  end
