; ------------------------------------------------------------------------ 
; $Id: userqsinit.pro,v 1.4 2007/06/06 20:03:55 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro userqsinit
;+
;  Initialize default conductor/grad parameters and the plot orientation
;  format: this routine is called by the QS/PFIDL procedures
;         Each user can put his own version of this routine in his own 
;         procedure library and uncomment the lines he wishes.
;         The present version sets the following parameters.
;  use: cp /opt/rsi/pfidl/pfidl/pfidl_1d/userqsinit.pro {local directory}
;
;     transdefault - interchange x and y axis in field plots
;     load default color tables default values are 
;          loadxyct
;     concolor - store the default color for conductors 
;     conthick - store the default thickness for conductors
;     grdcolor - store the default color for grids
;     grdthick - store the default thickness for grids
;     fldcolor - store the default color for field plots (PLOTFLD)
;     directorypage - store the default page size for scroll directory (DIRP)
;     directoryhelp - store the default for directory help window
;     oldpath  - the default path for PICKFILE
;     oldfilter - the default filter for PICKFILE
;-
; insert a common block
;
@qscom.dat
COMMON savepicker, oldfilter, oldpath
 COMPILE_OPT hidden
;
;
; store the default for interchange of x and y in transdefault
; 0 = no interchange
;     transdefault = 0
; load default color tables, 5 is STD Gamma-II
;     loadxyct 
; store the default color for conductors
;     concolor = 0
; store the default thickness for conductors
;     conthick = 2
; store the default color for grids
;     grdcolor = 0
; store the default thickness for grids
;     grdthick = 0.6
; store a nonzero value in the initializaton parameter
;     qsplotinit = 1
; store the default color for field plots (PLOTFLD)
;     fldcolor = -1
; store the default page size for scroll directory (DIR)
;     directorypage = 24
; store the default font for the scroll directory (SUN is '6x12')
;     directoryfont = 'a14'
; store the default for the directory help window
;     0 = no help window 
;     directoryhelp = 1
; store the default path and filter for PICKFILE
;     oldpath = '/qs/'
      oldfilter ='*.pff'
        return
        end
