; ------------------------------------------------------------------------ 
; $Id: wdcomment.pro,v 1.3 2007/06/06 20:03:55 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Function wdcomment, wdfin

;
;+
;  This function returns the WDF comment for an array. 
;  Format:  com = WDCOMMENT(WDF)
;  where:
;    WDF - Valid WDF array number or an array numbers.
;  Example:
;    Print the comment label for array 5
;      Print, wdcomment(5)
;    Add the shot number to a comment of array 3, where shot number is SHOT.
;      cha, 3, c= wdcomment(3)+', Shot '+strtrim(shot, 2)
;
;-
;
;
@com.dat
;
      if n_elements(initwdf) eq 0 then wdfinit
;
      wdf = wdvalid(wdfin, /valid)
      if wdf[0] lt 0 then begin
        print, '% WDCOMMENT: Valid waveform array must be provided'
        return, ''
      endif
;
      return, wdfcomment(wdf-1) 
      end
