; ------------------------------------------------------------------------ 
; $Id: x2ps.pro,v 1.5 2010/09/20 14:29:06 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro x2ps, xsize = xsizein, ysize = ysizein, $
       landscape = landscape, portrait = portrait
;+
;   switch to postscript file for output
;
;   Format: 
;          x2ps [, xsize = xsize] [, ysize = ysize]
;               [, /landscape] [, /portrait]
;        The orientation and size can also be changed with the keywords
;        LANDSCAPE and PORTRAIT and XSIZE and YSIZE.
;           
;        Sets the output device to postscript
;        File must have been opened with STARTPOST
;        If PORTRAIT and LANDSCAPE are both set LANDSCAPE is used.
;-
;
@switchpost.com
on_error, 1
   if n_elements (lcopen) eq 0 then lcopen = 0
   if lcopen eq 0 then begin
     print, ' Use STARTPOST to initialize a PostScript file.'
     return
   endif
   if !d.name ne 'PS' then begin
     olddevice = !d.name
     set_plot, 'PS'
   endif
   !x.thick= xythicksave
   !y.thick= xythicksave
   !z.thick= xythicksave
   !p.thick= thicksave
   !p.font = 0
   get_ps_device_param, orientation = orientation
   if keyword_set(landscape) && (orientation ne 'Landscape') then $
       device, /landscape, xoffset= l_xoffset, yoffset =l_yoffset, xsize=l_xsize, $
         ysize =l_ysize, /inches else $
     if keyword_set(portrait) && (orientation ne 'Portrait') then device, /portrait, $
       xoffset= p_xoffset, yoffset =p_yoffset, xsize=p_xsize, ysize =p_ysize, /inches

   if keyword_set(xsizein) or keyword_set(ysizein) then begin
     get_ps_device_param, xsize = oldxsize, ysize =oldysize, orientation = orientation
     if keyword_set(xsizein) then xsize = xsizein else xsize = oldxsize
     if keyword_set(ysizein) then ysize = ysizein else ysize = oldysize
     if ((xsize eq oldxsize) and (ysize eq oldysize)) then return
     if orientation eq 'Portrait' then begin
       if ysize lt 10 then yoffset = 10.5-ysize else yoffset = 0.25
       if xsize gt 8.0 then begin
         print, '% X2PS: XSIZE set to 8'
         xsize =8.0
       endif
       xoffset = (8.5 -xsize)*0.5
       device, /inches, xoffset= xoffset, yoffset =yoffset, xsize=xsize, ysize =ysize, /port
     endif else begin
       if xsize gt 10.5 then begin
         print, '% X2PS: XSIZE set to 10.5'
         xsize = 10.50
       endif
       yoffset = 5.5 +0.5*xsize
       if ysize gt 8.0 then begin
         print, '% X2PS: YSIZE set to 8'
         ysize =8.0
       endif
       xoffset = (8.5 -ysize)*0.5
       device, /inches, xoffset= xoffset, yoffset =yoffset, xsize=xsize, ysize =ysize, /land
     endelse
   endif
   end

