; ------------------------------------------------------------------------ 
; $Id: s2i.pro,v 1.5 2007/06/06 20:09:36 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
   Pro  s2i, str, i, no_copy = no_copy
;+
; This function returns a structure from the structure arrays
; Formmat:  s2i, str, i, no_copy = no_copy
;   where:  str is the returned structure
;           i is the structure number
;          no_copy if set, the structure array  will become undefined
;
; Example:
;    Obtain sturcture 3 into variable, f1
;        s2i, f1,3
;-
;  Common block
@qsstrcom.dat
      on_error, 1
;
      if n_elements (structinit) eq 0 then qsstruct_init
;
      npar = n_params()
      if npar lt 2 then begin
        print,'% Format: S2I, IDL_Structure, STR_Array_Number'
        return
      endif
      if n_elements(i) eq 0 then begin
        print, '%% ERROR, S2I*Structure array number must be defined'
        return
      endif
      j = (size(i, /type) gt 3) ? i : round (float(i))
      if j lt 1 or j gt maxstructure then begin
        Print, ' Structure array value must be greater than zero'
        print, '    and less than', maxstructure
        str = 0
        return
      endif
      if lcvalidstr(i-1) eq 0 or strarraycom(i-1) eq 0 then begin
        Print, '%S2I - Structure ', strtrim(j, 2), ' is undefined'
        str = 0
        return
      endif
      
      if keyword_set(no_copy) then lcvalidstr(i-1) =0 else no_copy = 0
      handle_value, strarraycom(i-1), str,  no_copy = no_copy
     end
