; ------------------------------------------------------------------------ 
; $Id: init_saf.pro,v 1.6 2007/06/06 20:11:32 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
;
  pro init_saf, safexe = a
;
;     this routine initializes the saf procedures
;
      common safcom, initsaf, SAF_EXE
;
@saf_com.dat
;
;     start the process
;
common copyright_common, copyright_init
;
      on_error, 1

      if n_elements(initsaf) eq 0 then initsaf =0
      if initsaf gt 0 then return
;
      directory_list = ''
      saf_filename = ''
      n_elem_saf_dir = 0
      if n_elements (copyright_init) eq 0 then copyright_notice
      p1 = 0L
      if n_elements(a) eq 0 then a = getenv('SAF_EXE')
      b = !DIR
      len = STRLEN(b) - 1
      IF STRPOS(b, '/', len) NE -1 and len gt 0 THEN $
      b = strmid(b, 0, len)
      name = strupcase(strmid(!version.os, 0, 3))

      p1 = [byte('Initialize SAF'), 0b]
      if (name eq 'SUN') then begin
        name  ='sun_SAF_mesh_reader.so'
; use this for sun
        list= tag_names(!version)
        i = get_match('MEMORY_BITS', list, nel= nel)
        if nel gt 0 then if !version.memory_bits eq 64 then begin
          print, '% INIT_SAF: SAF libraries not available in 64-bit version.'
          name='sun8_saf_exe_64.so'
          return
        endif
        if strlen(a) lt 1 then begin
          saf_exe = b+'/../pfidl/lib/'+name
        endif else begin
          saf_exe = a
          print, ' SAF_EXE=',saf_exe
        endelse
        print, ' SAF_EXE=',saf_exe
        junk = call_external(SAF_EXE,'SAF_initialize', p1)
        initsaf = 2
      endif else if (name eq 'LIN') then begin
        name  ='lin_SAF_mesh_reader.so'
; use this for sun
        if strlen(a) lt 1 then begin
          saf_exe = b+'/../pfidl/lib/'+name
        endif else begin
          saf_exe = a
          print, ' SAF_EXE=',saf_exe
        endelse
        print, ' SAF_EXE=',saf_exe
        junk = call_external(SAF_EXE,'SAF_initialize', p1)
        initsaf = 2

      endif else begin
        print, 'This operating system does not support SAF files'
      endelse
      return
     end
