; ------------------------------------------------------------------------ 
; $Id: tqhelp.pro,v 1.3 2007/06/06 20:12:26 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro  tqhelp, x = xout, dx= dxout, y = yout, dy = dyout, cond = condout, $
              gx = gxout, gy = gyout, ghx = gxhalfout, ghy = gyhalfout, $
              markerstring = markersout
;+
;      purpose: 
;             return data in TQ common block
;      format:  tqhelp, x=xout, dx=dxout, y=yout, dy=dyout, cond=condout, $
;             gx=gxout, gy=gyout, gxhalf = gxhalfout, gyhalf = gyhalfout
;             markerstring = markerstring
;      where:
;              x and dx are TQgrid parameters for the x-grid
;              y and dy are TQgrid parameters for the y-grid
;              cond is the conductor structure 
;              gx and gy are the grid values.
;              ghx, ghy are half grid values
;              markerstring are the marker strings written to the output file
;       Example:
;              get the x and dx values for the current grid
;              tqhelp, x= x, dx= dx
;-
@pfidltq.com
;
;     common pfidltq, x, dx, y, dy, gx, gy, gdx, gdy, mult, x1grid, x2grid, $
;        cond, markx, marky, markerstring, lcfit
      if n_elements (x) gt 0 then xout = x
      if n_elements (y) gt 0 then yout = y
      if n_elements (dx) gt 0 then dxout = dx
      if n_elements (dy) gt 0 then dyout = dy
      if n_elements (cond) gt 0 then condout= cond
      if n_elements (gx) gt 0 then gxout = gx
      if n_elements (gy) gt 0 then gyout = gy
      if n_elements (gxhalf) gt 0 then gxhalfout = gxhalf
      if n_elements (gyhalf) gt 0 then gyhalfout = gyhalf
      if n_elements (markerstring) gt 0 then markersout = markerstring
      return
      end
