; ------------------------------------------------------------------------ 
; $Id: tqplot.pro,v 1.5 2011/11/02 16:22:43 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro tqplot, conductors = conductorin , grid = lcgridin , overlay = overlay, $
     mode = modein, symsize = symsize, xrange = xr, yrange = yr, _extra = extrastuff
;+
;     Purpose: This is primarily a plot utility for tqedit.
;     format:
;     tqplot, conductors = conductor , grid = lcgrid , overlay = overlay, $
;        mode = mode, _extra = extrastuff
;     in all cases below conductors should have as many elements as conductors
;         of value 0 or 1 
;     where mode = 'INPUT'
;           conductors = conductors to be plotted. If zero none plotted
;           grid       = 0 if no grid is to be plotted; otherwise, plot grid
;           overlay    = make a grid based on the conductor data.
;     where mode = 'COND'
;           conductors = conductors to be plotted in color.
;                        If zero, conductor is plotted dashed in white
;           grid       = 0 if no grid is to be plotted; otherwise, plot grid
;           overlay    = make a grid based on the conductor data.
;     extrastuff will be sent to the plot, plots, and oplot commands.
;-
 on_error, 1
@pfidltq.com
@tqeditevent.com
       col_offset = 2
;
;     common pfidltq, x, dx, y, dy, gx, gy, gdx, gdy, mult, x1grid, x2grid, $
;        cond, markx, marky, markerstring, lcfit
;  common tqeditevent, curoper, arr, narray, tempx, tempy,old_loc, $
;       old_x, old_y, lcconductor, lcgrid, lcmode, tqinstr, cerase, $
;       tempx2, tempy2, conductors, maxcond, cur_win, old_win
;
      if n_elements (lcgridin) eq 0 then lcgrd = lcgrid else lcgrd = lcgridin
      ncon = cond.ncon
;
      if n_elements (overlay) eq 0 then overlay = 0 
      if n_elements (lcmode) eq 0 then lcmode = 'INPUT'
      if n_elements(modein) eq 0 then mode = lcmode else mode = modein
      if n_elements (conductors) eq 0 then begin
        if mode eq  'COND' then conductors = [1,1] else conductors = [0,0]
      endif
      if n_elements (conductorin) eq 0 then lcc=conductors(1:*) else $
         lcc=conductorin
      if !p.thick eq 0 then thck = 1.0 else thck = !p.thick
      if n_elements(lcc) lt ncon then lcc = [lcc, $
           make_array(ncon-n_elements(lcc), /int, value = 1)*lcc(0)]
      if n_elements (lcconductor) eq  0 then lcconductor = 0
      if overlay eq 0 and lcaspect eq 0 then begin
        if n_elements(xr) eq 0 then xr = [min(gx, max = mx), mx]
        if n_elements(yr) eq 0 then yr = [min(gy,  max= my), my]
        plot, gx(0:1), gy(0:1) , /nodata, /xst, /yst, xr = xr, yr = yr, _extra = extrastuff
      endif else if lcaspect eq 1 then begin
        if overlay eq 0 then begin
          if n_elements(xr) eq 0 then xr = [min(gx, max = mx), mx]
          if n_elements(yr) eq 0 then yr = [min(gy,  max= my), my]
        endif else begin
          if n_elements(xr) eq 0 then xr = !x.crange
          if n_elements(yr) eq 0 then yr = !y.crange
        endelse
        xdel = xr(1)-xr(0)
        ydel = yr(1)-yr(0)
        xsiz = !d.x_size
        ysiz = !d.y_size
        xmin = round(0.08*xsiz)
        ymin = round(0.08*ysiz)
        xran = round(0.98*xsiz) - xmin
        yran = round(0.98*ysiz) - ymin
        if xdel*yran gt ydel*xran then begin
          posn = [0.08, 0.08, 0.98, $
                float(ymin+round(xran*ydel/xdel))/ysiz]
        endif else begin
          posn = [0.08, 0.08, $ 
             float(xmin+round(yran*xdel/ydel))/xsiz, 0.98]
        endelse
        plot, gx(0:1), gy(0:1) , /nodata, /xst, /yst, $
           xr = xr, yr = yr, position = posn, _extra = extrastuff
      endif
;     print, mode, lcsavmode
;     for qsedit, /cond    mode = cond and lcsavmode = cond
;     for qsedit, /grid    mode = cond and lcsavmode = grid if no valid fit
;                          mode = input and lcsavmode = grid if valid fit
;     for qsedit,          mode = input and lcsavmode = input
;     
      if mode eq 'COND' then begin
        if lcgrd ne 0 then tqplotgrid, /over
        if lcsavmode eq 'GRID' then begin
          plotcolor = 5
          if n_elements(symsize) eq 0 then symsize = 0.1
          gth = 2.0
        endif else begin
          gth = 3.0
          if n_elements(symsize) eq 0 then symsize = 1.0
        endelse
        
        if tqfast eq 0 then begin
          for i = 1, ncon do begin
            if lcsavmode ne 'GRID' then plotcolor = (i+col_offset) mod 7 + 1
            if lcc(i-1) eq 0 then oplot, cond.x(cond.locx(i-1): $
              cond.locx(i)-1), cond.y(cond.locx(i-1):cond.locx(i)-1), $
               color = 8, psym = -4, line=2 , thick = thck , symsize = symsize, _extra = extrastuff $
             else oplot,  cond.x(cond.locx(i-1):cond.locx(i)-1),  $
               cond.y(cond.locx(i-1):cond.locx(i)-1), $
               color = plotcolor, psym = -8, thick = gth*thck, symsize = symsize, _extra = extrastuff
          endfor
        endif else begin
          for i = 1, ncon do begin
            if lcsavmode ne 'GRID' then plotcolor = (i+col_offset) mod 7 + 1
            if lcc(i-1) eq 0 then oplot, cond.x(cond.locx(i-1): $
              cond.locx(i)-1), cond.y(cond.locx(i-1):cond.locx(i)-1), $
               color = 8, line=2 , thick = thck , psym = -8, symsize = symsize, _extra = extrastuff $
             else oplot,  cond.x(cond.locx(i-1):cond.locx(i)-1),  $
               cond.y(cond.locx(i-1):cond.locx(i)-1), $
               color = plotcolor, psym = -8, thick = gth*thck, symsize = symsize, _extra = extrastuff
          endfor
        endelse
      endif else begin
        if n_elements(symsize) eq 0 then begin
          if lcsavmode eq 'GRID' then symsize = 0.1 else symsize = 1.0
        endif
        if lcgrd ne 0 then tqplotgrid, /over
        
        if lcconductor ne 0 then begin
          plotcolor = 5
          for i = 1, ncon do begin
            if lcc(i-1) ne 0 then begin
              if lcsavmode ne 'GRID' then plotcolor = (i+col_offset) mod 7 +1
              oplot, $
                 cond.x(cond.locx(i-1):cond.locx(i)-1), $
                 cond.y(cond.locx(i-1):cond.locx(i)-1), $
                 color = plotcolor, _extra = extrastuff
            endif
          endfor 
        endif
        if n_elements (iplotx) eq 0 then get_tqplotpnts
        if lcsavmode eq 'GRID' then begin
          for i = 1, ncon do begin
            oplot, gx(cond.ix(cond.loci(i-1):cond.loci(i)-1)), $
             gy(cond.iy(cond.loci(i-1):cond.loci(i)-1)),  $
             color = 2, psym=8, symsize = symsize, _extra = extrastuff
            oplot, gx(cond.iplotx(cond.locp(i-1):cond.locp(i)-1)), $
              gy(cond.iploty(cond.locp(i-1):cond.locp(i)-1)), $
              color = 2,  thick = thck+thck, _extra = extrastuff
          endfor
        endif else begin
          for i = 1, ncon do begin
            if lcc(i-1) ne 0 then begin
              oplot, gx(cond.ix(cond.loci(i-1):cond.loci(i)-1)), $
               gy(cond.iy(cond.loci(i-1):cond.loci(i)-1)),  $
               color = (i+col_offset) mod 7 +1,psym=8, symsize = symsize, _extra = extrastuff
              oplot, gx(cond.iplotx(cond.locp(i-1):cond.locp(i)-1)), $
                gy(cond.iploty(cond.locp(i-1):cond.locp(i)-1)), $
                 color = (i+col_offset) mod 7 +1, line = 2, thick = 3*thck, _extra = extrastuff
            endif else begin
              oplot, gx(cond.ix(cond.loci(i-1):cond.loci(i)-1)), $
                gy(cond.iy(cond.loci(i-1):cond.loci(i)-1)), $
                color = 8, psym = 8, symsize = symsize, _extra = extrastuff
              oplot, gx(cond.iplotx(cond.locp(i-1):cond.locp(i)-1)), $
                gy(cond.iploty(cond.locp(i-1):cond.locp(i)-1)), $
                color = 8, line = 3, _extra = extrastuff
            endelse
          endfor 
        endelse
        if n_elements (cond.nbad) eq 0 then get_tqbad
        if cond.nbad(0) gt 0 then begin
          for i = 1, ncon do begin
            if cond.nbad(i) gt 0 then begin
                if n_elements (cond.badxy) eq 1 then j = cond.badxy else $
                  j = cond.badxy(cond.locb(i-1):cond.locb(i)-1)
              plots, psym = 8, syms=symsize, color=1,  $
                gx(cond.ix(j)), gy(cond.iy(j)), _extra = extrastuff
            endif
          endfor
        endif
        if n_elements(markx) gt 0 then begin
          if markx(0) ge 0 then plots, gx(markx), gy(marky), $
           psym = 8, syms=symsize*.8, color=2, _extra = extrastuff
        endif
      endelse
      if lcsavmode eq 'GRID' then begin
        if gridaxis eq 0 then begin
          nel = n_elements(x)
          ok = where(dx lt 0.0, nok)
          for i = 0, nel-1 do $
            oplot, [x(i), x(i)], !y.crange, color = 4, thick=1.5*thck, _extra = extrastuff
          nok = 0
          if nok gt 1 then begin
            for i = 1, nok-1 do $
              oplot, [x(ok(i)), x(ok(i))], !y.crange, color = 2, $
              thick = 1.5*thck, _extra = extrastuff
          endif
;         widget_control, fdelta, get_value = delta
;         widget_control, fncells, get_value = ncells
          if narr ge 0 then $
            oplot, [x(narr), x(narr)], !y.crange,thick = 2*thck, color = 1, _extra = extrastuff
          if widget_info(fendpoint, /valid_id) eq 1 then begin
            widget_control, fendpoint, get_value = endpoint
            oplot, [endpoint, endpoint], !y.crange,thick = 2*thck, color = 7, _extra = extrastuff
          endif
        endif else begin
          nel = n_elements(y)
          ok = where(dy lt 0.0, nok)
          for i = 0, nel-1 do $
            oplot, !x.crange, [y(i), y(i)], color = 4, thick=1.5*thck, _extra = extrastuff
          nok = 0
          if nok gt 1 then begin
            for i = 1, nok-1 do $
              oplot,!x.crange, [y(ok(i)), y(ok(i))], color = 2, thick = 1.5*thck, _extra = extrastuff
          endif
;         widget_control, fdelta, get_value = delta
;         widget_control, fncells, get_value = ncells
          if narr ge 0 then $
            oplot, !x.crange, [y(narr), y(narr)], thick = 2*thck, color = 1, _extra = extrastuff
          if widget_info(fendpoint, /valid_id) eq 1 then begin
            widget_control, fendpoint, get_value = endpoint
            oplot, !x.crange, [endpoint, endpoint], thick = 2*thck, color = 7, _extra = extrastuff
          endif
        endelse
      endif
      end
