; ------------------------------------------------------------------------ 
; $Id: fill_array.pro,v 1.3 2007/06/06 20:12:41 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro fill_array, arr, x, y, str, xstr, ystr, default=default, dielectric=diel
;
;
@qsstrcom.dat
      on_error, 1
      a = str
      b = size(a)
      if b(0) eq 2 then begin
        if n_elements(xstr) ne b(1) or n_elements(ystr) ne b(2) then begin
          print, 'Charge and Dielectric arrays must have compatable space arrays'
          return
        endif
        interpoltq, arr, x, y, default = default, a, xstr, ystr, half = diel
        return
      endif else if b(b(0)+1) ne 8 then begin
        if a gt 0 and a le maxstructure then begin
          s2i, a, a
          b = size (a)
          if b(b(0)+1) ne 8 then begin
            print, ' First parameter must be a structure or a QS array number'
            return
          endif
        endif  else begin
          print, ' First parameter must be a structure or a QS array number'
          return
        endelse
      endif
      tags = tag_names(a)
      ok = where (tags eq 'V1', nv1)
      ok = where (tags eq 'X1', nx1)
      ok = where (tags eq 'X2', nx2)
      ok = where (tags eq 'X3', nx3)
      if nv1 eq 0 or nx1 eq 0 or nx2 eq 0 or nx3 eq 0 then begin
        print, 'Required Structure tags do not exist -', nv1, nx1, nx2, nx3
        help, /str, a
        return
      endif

      if n_elements(xstr) gt 0 then begin
        xstr = round (xstr(0))
        if xstr eq 1 then xx = a.x1 $
          else if xstr eq 2 then  xx = a.x2 $
          else xx = a.x3
      endif else xx = a.x1
      if n_elements(ystr) gt 0 then begin
        ystr = round (ystr(0))
        if ystr eq 1 then yy = a.x1 $
          else if ystr eq 2 then  yy = a.x2 $
          else yy = a.x3
      endif else yy = a.x1
      nx = n_elements(xx)
      ny = n_elements(yy)
      ar = a.v1
      narr = n_elements (ar)
      if narr eq nx*ny then begin
        if xstr lt ystr then ar = reform (ar, nx, ny) else $
          ar = transpose(reform( ar, ny, nx))
      endif else begin
        Print, 'Array components in V1 are not compatable with x and y'
        print, narr, nx, ny
        return
      endelse
      interpoltq, arr, x, y, default = default, ar, xx, yy, half = diel
      return
      end
