; ------------------------------------------------------------------------ 
; $Id: get_boundary.pro,v 1.4 2010/09/29 20:59:14 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
PRO get_bound_event, Event

on_error, 1

  WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev

  CASE Ev OF 

  'BGROUP3': BEGIN
      widget_control, event.top, get_uvalue = info
      if event.value eq 0 then begin
        widget_control, info.b2, set_value = 0
        widget_control, info.base1, map = 0
        widget_control, info.base2, map = 0
      endif else begin
        widget_control, info.b2, get_value = b2
        if b2 eq 0 then begin
          widget_control, info.b2, set_value = event.value
          if event.value eq 2 then widget_control, info.base2, map = 1
        endif
        if event.value eq 1 then widget_control, info.base1, map = 0 $
          else widget_control, info.base1, map = 1
      endelse
      END

  'FIELD5':

  'BGROUP9': BEGIN
      widget_control, event.top, get_uvalue = info
      if event.value eq 0 then begin
        widget_control, info.b1, set_value = 0
        widget_control, info.base1, map = 0
        widget_control, info.base2, map = 0
      endif else begin
        widget_control, info.b1, get_value = b1
        if b1 eq 0 then begin
          widget_control, info.b1, set_value = event.value
          if event.value eq 2 then widget_control, info.base1, map = 1
        endif
        if event.value eq 1 then widget_control, info.base2, map = 0 $
          else widget_control, info.base2, map = 1
      endelse
      END

  'FIELD10': 

  'EXIT': BEGIN
      but = event.value
      widget_control, event.top, get_uvalue = info, /no_copy, $
           tlb_get_offset = offset
      case but of
 'QUIT' : lcquit = 1
 'OK' :   lcquit = 0
       ELSE: BEGIN
              lcquit = 1
              print, ' Unknown event - QUIT'
             END
       endcase
          widget_control,info.b1, get_value = bound1
          widget_control,info.b2, get_value = bound2
          widget_control,info.pot1, get_value = pot1
          widget_control,info.pot2, get_value = pot2
          values = {lcquit:lcquit, bound1:bound1, offset:offset, $
            bound2:bound2,pot1:pot1, pot2:pot2} 
          widget_control, info.ptr, set_uvalue = values, /no_copy
          widget_control, event.top, /destroy
      END
   ELSE:

  ENDCASE
END


 Pro get_boundary, lcquit, lchoriz, bound1, bound2, pot1,pot2,$
            offset, group= group

 on_error, 1

  IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0
  base = WIDGET_BASE(GROUP_LEADER=Group, $
      COLUMN=1, $
      MAP=1, $
      TITLE='Boundary Conditions')

  if n_elements (lchoriz) eq 0 then lchoriz = 0
  if lchoriz ne 0 then begin
    MAIN13 = WIDGET_BASE(base, $
      ROW=1, $
      MAP=1)
    label1 = 'Left Boundary' 
    label2 = 'Right Boundary' 
  endif ELSE begin
    MAIN13 = WIDGET_BASE(base, $
      COLUMN=1, $
      MAP=1)
    label1 = 'Top Boundary' 
    label2 = 'Bottom Boundary' 
  endelse

  BASE2 = WIDGET_BASE(MAIN13, $
      COLUMN=1, $
      FRAME=4, $
      MAP=1, $
      UVALUE='BASE2')

  if n_elements(bound1) eq 0 then bound1 = 0 
  if bound1 eq 2 then map1 = 1 else map1 = 0
  Btns = [ 'Periodic', $
    'Mirror (Neumann - PMC)', $
    'Conducting (Direchlet - PEC)' ]
  BGROUP3 = CW_BGROUP( BASE2, Btns, $
      SET_VALUE = bound1(0), $
      COLUMN=1, $
      EXCLUSIVE=1, /NO_RELEASE, $
      LABEL_TOP=Label1, $
      UVALUE='BGROUP3')

  BASE1 = WIDGET_BASE(BASE2, $
      ROW=1, $
      MAP=map1, $
      UVALUE='BASE4')

  if n_elements (pot1) eq 0 then pot1 = 0.0

  FIELD5 = CW_FIELD( BASE1,VALUE=pot1(0), $
      ROW=1, $
      FLOAT=1, $
      TITLE='Boundary Potential:', $
      UVALUE='FIELD5')



  BASE11 = WIDGET_BASE(MAIN13, $
      COLUMN=1, $
      FRAME=4, $
      MAP=1, $
      UVALUE='BASE11')

  if n_elements(bound2) eq 0 then bound2 = 0 
  if bound2 eq 2 then map2 = 1 else map2 = 0
  BGROUP9 = CW_BGROUP( BASE11, Btns, $
      SET_VALUE = bound2(0), $
      COLUMN=1, $
      EXCLUSIVE=1, /NO_RELEASE, $
      LABEL_TOP=Label2, $
      UVALUE='BGROUP9')

  BASE2 = WIDGET_BASE(BASE11, $
      ROW=1, $
      MAP=map2, $
      UVALUE='BASE4')

  if n_elements (pot2) eq 0 then pot2 = 0.0

  FIELD10 = CW_FIELD( BASE2,VALUE=pot2, $
      ROW=1, $
      FLOAT=1, $
      TITLE='Boundary Potential:', $
      UVALUE='FIELD10')

      menu = ['     OK     ',  '  Quit  ']
 but = cw_bgroup(base, menu,/row, $
        uvalue = 'EXIT', /NO_RELEASE, button_uvalue =['OK','QUIT'])

  if n_elements (offset) lt 2  then offset = [10, 10] else $
    offset = (offset(0:1)> 0)
  WIDGET_CONTROL, base, /REALIZE, tlb_set_xoffset = offset(0), $
       tlb_set_yoffset= offset(1)

  ptr = widget_base ()
  value = {lcquit:0, bound1:0, bound2:0, pot1:0.0, pot2:0.0, offset:offset}
  info =  {base1:base1, base2:base2,b1:bgroup3, b2:bgroup9, $
         pot1:field5, pot2:field10, ptr:ptr} 
  widget_control, ptr, set_uvalue = value, /no_copy
  Widget_control, base, set_uvalue = info, /no_copy

     widget_control, base, tlb_get_offset= offset_real
     offset_real = offset  - offset_real

  XMANAGER, 'get_bound', base
  widget_control, ptr, get_uvalue = value, /no_copy
  widget_control, ptr, /destroy
  bound1 = value.bound1
  bound2 = value.bound2
  pot1 = value.pot1
  pot2 = value.pot2
  offset = value.offset + offset_real
  lcquit = value.lcquit
END
