; ------------------------------------------------------------------------ 
; $Id: get_qscond_info.pro,v 1.5 2007/06/06 20:12:41 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro get_qs_info_event, event
    but = event.value
    case but of 

 'QUIT' : BEGIN
         Widget_control, event.top, get_uvalue= info,tlb_get_offset = offset, $
              /no_copy
         value = {varname: '', quit: 1, normal:0, type: 0, $
              dimen:0, maxf:0.0, minf:0.0, offset:offset}
          widget_control, info.ptr, set_uvalue = value, /no_copy
          widget_control, event.top, /destroy
          END
 'OK' : BEGIN
         Widget_control, event.top, get_uvalue= info,tlb_get_offset = offset, $
              /no_copy
          widget_control, info.nor, get_value = j
          widget_control,info.var, get_value = varname 
          widget_control,info.dimen, get_value = dim 
          widget_control,info.type, get_value = type 
          widget_control,info.min, get_value = zbot 
          if info.max ne 0 then widget_control,info.max, get_value = ztop else ztop = 0
          value = {varname: varname, quit: 0, normal:j, dimen:dim, maxf:ztop, $
                 minf:zbot, type:type, offset:offset}
          widget_control, info.ptr, set_uvalue = value, /no_copy
          widget_control, event.top, /destroy
          END
     ELSE: 
     endcase
     end
 Pro get_qscond_info, lcquit, units,string2,type, normal, zbeg, zend, $
              dimension, offset, group_leader = group_leader, modal = modal, path = path
     on_error, 1
     if n_elements (xsize) eq 0 then xsize = 30
     if n_elements(group_leader) eq 0 then group_leader = 0
     base = widget_base(/column, title= 'Material Parameters', $
            group_leader = group_leader, modal = modal)
     lcquit = 1
     if n_elements (string2) eq 0 then string2 = ' '
     Var = cw_field(base, title= 'Material Name',  $
           value = string2)
     if n_elements (type) eq 0 then type = 0 else type = fix(type(0))
     buttyp = cw_bgroup( base, /row, $
          ['Conductor' , 'Vacuum', 'Foil', 'Dielectric'], $
          /exclusive,  /NO_RELEASE, $
          label_top = 'Material Type', /frame, $
          button_uvalue= ['i' , 'j', 'k', 'l'] , set_value = type)
     if n_elements(normal) eq 0 then normal = 0 else normal = fix(normal(0))
     butnor = cw_bgroup( base, /row, ['i' , 'j', 'k'],/exclusive, $
          label_top = 'Normal Direction', /frame, /NO_RELEASE, $
          button_uvalue= ['i' , 'j', 'k'] , set_value = normal)
     if n_elements(dimension) eq 0 then dimension = 0
     butdim = cw_bgroup( base, column = 2,  units,/exclusive, $
          label_top = 'Normal Dimension Units',  /frame, /NO_RELEASE, $
          button_uvalue= units, set_value = dimension)
     if n_elements (zbeg) eq 0 then zbeg = 0.0
     lab_fmin = (keyword_set(path)) ? 'Diagnostic Value' : 'Minimum Value'
     fieldmin = cw_field(base, value = zbeg, /float, /row, title= lab_fmin)

     if n_elements (zend) eq 0 then zend = 1.0
     if keyword_set(path) then fieldmax = 0l else $
       fieldmax = cw_field(base, value = zend, /float, /row, title= $
            'Maximum Value')
     menu = make_array(2, /string)
     menu(0) = '             OK             ' 
     menu(1) = '  Skip this conductor  '
     but = cw_bgroup(base,menu,/row,/NO_RELEASE, button_uvalue =['OK','QUIT'])
  if n_elements (offset) lt 2  then offset = [10, 10] else $
    offset = (offset(0:1)> 0)
  WIDGET_CONTROL, base, /REALIZE, tlb_set_xoffset = offset(0), $
       tlb_set_yoffset= offset(1) 
     ptr = widget_base()
     info = {var: var, nor:butnor, ptr:ptr, $
            dimen:butdim ,type:buttyp,  min:fieldmin, max:fieldmax}
     widget_control, base, set_uvalue = info
     value = {varname: '', quit: 1, normal:normal, $
       dimen:dimension, type:type, maxf:zbeg, minf:zend, offset:offset}
     widget_control, ptr, set_uvalue = value
      widget_control, base, tlb_get_offset= offset_real
     offset_real = offset  - offset_real
     xmanager, 'get_qs_info', base
     widget_control, ptr, get_uvalue = value
     widget_control, ptr, /destroy
     lcquit = value.quit
     offset = value.offset+ offset_real
     if lcquit eq 1 then return
     string2 = strtrim(value.varname, 2)
     normal = value.normal
     type = value.type
     dimension = value.dimen
     zbeg = value.minf
     zend = value.maxf
     return
     end
