; ------------------------------------------------------------------------ 
; $Id: get_tqbad.pro,v 1.3 2007/06/06 20:12:41 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro  get_tqbad
;
; get the illegal grid points
;
@pfidltq.com
;
       on_error, 1
;
      if n_elements (cond) eq 0 then message, $
        'Conductor values must be defined.'
      ncon = cond.ncon
      if n_elements(cond.nbad) lt ncon+1 then nbadxy= make_array(/int,ncon+1) $
        else nbadxy = cond.nbad(0:ncon)
      if n_elements (cond.locb) lt ncon+1 then locb = make_array(/int,ncon+1) $
        else locb = cond.locb(0:ncon)
      badxy = cond.badxy
      locb(0) = 0
      for i = 1L, ncon do begin
        
        nx = cond.loci(i)-cond.loci(i-1)
      if nx lt 3 then begin
          dxx = cond.ix(cond.loci(i-1))-cond.ix(cond.loci(i)-1)
          dyy = cond.iy(cond.loci(i-1))-cond.iy(cond.loci(i)-1)
          if (dxx eq 0) or (dyy eq 0) or (abs(dxx) eq abs(dyy)) then begin
            nbadxy(i) = 0
            array1pack, i, ncon, locb, 0, badxy,0, /keep 
          endif else begin
            nbadxy(i) = 1
            badxyv = 1+cond.loci(i-1)
            array1pack, i, ncon, locb, nbadxy(i), badxy, badxyv, /keep
          endelse
      endif else begin
        if  cond.ix(cond.loci(i-1)) eq cond.ix(cond.loci(i)-1) and $
          cond.iy(cond.loci(i-1)) eq cond.iy(cond.loci(i)-1) then begin
; check x direction
          dxi = [cond.ix(cond.loci(i-1)+1:cond.loci(i)-1), $
                 cond.ix(cond.loci(i-1)+1)] -  $
             cond.ix(cond.loci(i-1):cond.loci(i)-1)
; Now do y
          dyi = [cond.iy(cond.loci(i-1)+1:cond.loci(i)-1), $
                  cond.iy(cond.loci(i-1)+1)] - $
             cond.iy(cond.loci(i-1):cond.loci(i)-1) 
          dx2 = dxi(0:nx-2)*dxi(1:nx-1)
          dy2 = dyi(0:nx-2)*dyi(1:nx-1)
                  
        endif else begin
; check x direction
          dxi = cond.ix(cond.loci(i-1)+1:cond.loci(i)-1) -  $
             cond.ix(cond.loci(i-1):cond.loci(i)-2)
          dx2 = dxi(0:nx-3)*dxi(1:nx-2)
; Now do y
          dyi = cond.iy(cond.loci(i-1)+1:cond.loci(i)-1) - $
             cond.iy(cond.loci(i-1):cond.loci(i)-2)
          dy2 = dyi(0:nx-3)*dyi(1:nx-2)
        endelse
        badx = where (dx2 lt 0, nbadx)
        bady = where (dy2 lt 0, nbady)
        dxi = abs(dxi)
        dyi = abs(dyi)
        skipxy = where (dxi ne dyi and ((dxi gt 1 and dyi gt 0) or $
               (dyi gt 1 and dxi gt 0)), nskipxy)
; Now Look at spacing in space
        nbadxy(i) = nbadx+nbady +nskipxy 
        if nbadxy(i) gt 0 then begin
          badxyv = [badx, bady, skipxy]
          ok = where(badxyv ge 0)
          badxyv = badxyv(ok) + 1+ cond.loci(i-1)
          array1pack, i, ncon, locb, nbadxy(i), badxy, badxyv, /keep
        endif
      endelse
     endfor
     nbadxy(0) = total(nbadxy(1:*))
     if nbadxy(0) gt 0 then print,' Bad points =', nbadxy(0)
     cond = {ncon:ncon, lcfit:cond.lcfit, x:cond.x, y:cond.y, $
          locx:cond.locx, ix:cond.ix, iy:cond.iy, loci:cond.loci, $
          iplotx:cond.iplotx, iploty:cond.iploty, locp:cond.locp, $
           badxy:badxy, locb:locb, nbad:nbadxy }
     return 
      end
