; ------------------------------------------------------------------------ 
; $Id: get_tqplotpnts.pro,v 1.3 2007/06/06 20:12:41 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro get_tqplotpnts
 on_error, 1
@pfidltq.com
      if n_elements (cond) eq 0 then message, $
        'Conductor values must be defined.'
      ncon = cond.ncon
      ntot = 0
      locp = 0L
      if n_elements (cond.ix) lt 2 then message, $
         'Conductors must be fit to the grid'
      for i = 1, ncon do begin
        ix = cond.ix(cond.loci(i-1):cond.loci(i)-1)
        iy = cond.iy(cond.loci(i-1):cond.loci(i)-1)
        nx = n_elements(ix)
;
        if nx gt 1 then begin
          dix = ix(1:nx-1)- ix(0:nx-2)
          diy = iy(1:nx-1)- iy(0:nx-2)
          adix = abs(dix)
          adiy = abs(diy)
          ok=  where ((adix eq adiy) and (adix gt 1), nok)
          nadd = 0
          ipx = ix
          ipy = iy
          if nok gt 0 then begin
            for j = 0, nok-1 do begin
              k = ok(j)
              iadd = (indgen(adix(k)-1)+1)*dix(k)/adix(k) +ix(k)
              jadd = (indgen(adiy(k)-1)+1)*diy(k)/adiy(k) +iy(k)
              ipx = [ipx(0:k+nadd), iadd, ipx(k+nadd+1:*)]
              ipy = [ipy(0:k+nadd), jadd, ipy(k+nadd+1:*)]
              nadd = nadd +n_elements(iadd)
            endfor
          endif
          if ntot eq  0 then begin
            iplotx =ipx 
            iploty =ipy
          endif else begin
            iplotx= [iplotx, ipx]
            iploty= [iploty, ipy]
          endelse
          ntot = ntot+nx+nadd
          locp = [locp, ntot]
        endif
      endfor
;     rebuild the structure
      cond = {ncon:ncon, lcfit:cond.lcfit, x:cond.x, y:cond.y, $
           locx:cond.locx, ix:cond.ix, iy:cond.iy, loci:cond.loci, $
           iplotx:iplotx, iploty:iploty, locp:locp, $
           badxy:cond.badxy, locb:cond.locb, nbad:cond.nbad }
      return 
      end
