; ------------------------------------------------------------------------ 
; $Id: ind2fill.pro,v 1.4 2010/09/29 20:59:14 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro ind2fill, value, ix, iy, np, temp, nx, ny
;
;    convert an index array to a fill image , use a work array to determine
;      the location of conductors.
on_error, 1
;
work = make_array(2*nx, ny, /int)
for i = 1, np-1 do begin
   if ix(i-1) eq ix(i) then begin
     lo = min([iy(i-1),iy(i)], max = hi)
     if hi-lo ge 1 then begin
       temp(ix(i), lo: hi) = value
       work(ix(i)*2, lo:hi-1) = 1
     endif
   endif else if iy(i-1) eq iy(i) then begin
     lo = min([ix(i-1),ix(i)], max = hi)
     if hi -lo ge 1 then temp(lo:hi, iy(i)) = value
   endif else if abs(ix(i)-ix(i-1)) eq abs(iy(i) -iy(i-1)) then begin
     nel = abs(ix(i)-ix(i-1))+1
     if nel gt 0 then begin
       if ix(i) gt ix(i-1) then ii = ix(i-1)+indgen(nel) else $
           ii = ix(i-1) - indgen(nel)
       if iy(i) gt iy(i-1) then begin
           jj = iy(i-1)+indgen(nel)
           for j = 0, nel-1 do temp(ii(j), jj(j)) = value
           for j = 0, nel-2 do work(ii(j)+ii(j+1), jj(j)) = 1
        endif else begin
           jj = iy(i-1) - indgen(nel)
           for j = 0, nel-1 do temp(ii(j), jj(j)) = value
           for j = 0, nel-2 do work(ii(j)+ii(j+1), jj(j+1)) = 1
        endelse
      endif
   endif else begin
     print, 'Bad value' , i, ix(i), iy(i)
     temp = 0
     return
   endelse
endfor
;
  for i = 0, ny-1 do begin
    ok = where(work(*, i) eq 1 , nok)
    if nok gt 0 then begin
      if nok eq 1  or 2*(nok/2) ne nok then begin
        print, ' BAD endpoint for y-index =' , i, nok
        return
      endif
      for j = 0, nok-1, 2 do work(ok(j):ok(j+1), i) = 1
    endif
  endfor
;
  work = reform(work, 2, nx, ny, /overwrite)
  work = reform(work(0, *,  *), /overwrite)

  for i = 1, ny-2 do begin
    ok = where(work(*, i-1) and work(*, i) , nok)
    if nok gt 0 then temp(ok, i) = value
  endfor
  work = 0
  return
  end
