; ------------------------------------------------------------------------ 
; $Id: join2pack.pro,v 1.3 2007/06/06 20:12:42 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro join2pack, ax, bx, ay, by, j, npack, loc, xpac, ypac, resol = resol
; 
;
;    join ax to bx and ay to by 
;    store the array [ax, bx] in the jth location of xpac
;    store the array [ay, by] in the jth location of ypac
;    the locations are specified by loc with npack+1 elements
;    if the two elements are closer than sqrt(resol) apart then 
;    one is dropped.
;
     nel= n_elements(ax)
;    use nel in the procedures below
; array2pack will calculate the correct number
     if n_elements(resol) eq 0 then resol = 0.0
     if (ax(nel-1)-bx(0))^2 + (ay(nel-1)-by(0))^2 ge resol then begin
       array2pack, j, npack, loc,nel, xpac, [ax, bx], ypac, [ay, by]
     endif else if (ax(nel-1)-ax(nel-2))^2 + (ay(nel-1)-ay(nel-2))^2 gt $
       (bx(0)-bx(1))^2 + (by(0)-by(1))^2 then begin
       array2pack,j,npack,loc,nel,xpac,[ax(0:nel-2), bx],ypac,[ay(0:nel-2),by]
     endif else begin
       array2pack, j, npack, loc,nel, xpac, [ax, bx(1:*)], ypac, [ay, by(1:*)]
     endelse
     return
     end
