; ------------------------------------------------------------------------ 
; $Id: get_array_var.pro,v 1.4 2007/06/06 19:34:27 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
; get the variables desired.
; pass in an array to select from.
PRO MY_CW_FIELD_EVENT, Event

;   state = {textid:event.id, Title:'wdfarray', Update:1, type :2}
        ;       At this point, we need to look at what kind of field
        ;       we have:

    ;   If the user has types <CR> then update field


        IF Event.Type LE 1 THEN BEGIN           ; Insert Characters?

            IF Event.Type EQ 0 THEN BEGIN
                MY_CW_FIELD_INT, Event.Ch, Event
            ENDIF ELSE BEGIN
                Chars   = BYTE(Event.Str)
                FOR I=0,N_ELEMENTS(Chars)-1 DO $
                     MY_CW_FIELD_INT, Chars[I], Event
            ENDELSE

        ENDIF ELSE IF Event.Type EQ 2 THEN BEGIN        ; Delete Text

            IF Event.Length GT 0 THEN BEGIN ; Bug in widget
                WIDGET_CONTROL, event.id, $
                        SET_TEXT_SELECT=[Event.Offset,Event.Length]
                WIDGET_CONTROL, event.id, SET_VALUE='', /USE_TEXT_SELECT

            ENDIF

        ENDIF

END

PRO MY_CW_FIELD_INT, Ch,  Event

    Altered     = 0             ; nothing so far
    Nil         = 0             ; field has contents
    Minus       = 0             ; field is not just a '-'
    Negate      = 0             ; new text has no '-'s in it
    TextId      = event.id

        ; Special Cases:
        ;       We don't actually care where in the input string a
        ;       '-' is.  If there is an odd number of them, we
        ;       negate the value (see below)
        ;
        ;       Current String          Char            Result
        ;       Nil                     '-'             '-'
        ;       -                       '-'             Nil
        ;       <any number>            '-'             -<number>

    WIDGET_CONTROL, TextId, GET_VALUE=Value
    Value       = Value[0]

    IF Value EQ '' THEN Nil = 1         ; Value is nil string
    IF Value EQ '-' THEN Minus = 1      ; Value is an invalid number


        ;       <CR>
    IF Ch EQ 10b THEN BEGIN
        Altered = 2
        RETURN
    ENDIF

    IF Ch EQ 45b THEN Negate = 1 $
    ELSE IF Ch GE 48b AND Ch LE 57b THEN BEGIN
        Nil = 0 & Minus = 0
    ENDIF ELSE RETURN   ; ![0-9]

    ;   Add new character (if any)

    Selection   = WIDGET_INFO(TextId, /TEXT_SELECT)
    TIP         = Selection[0]+1-Negate ; Text Insertion Point

    IF Negate EQ 0 THEN BEGIN
        WIDGET_CONTROL, TextId, SET_VALUE=STRING(Ch), /USE_TEXT_SELECT
        Altered = 1
    ENDIF

    IF Negate THEN BEGIN
        IF Nil THEN BEGIN
            WIDGET_CONTROL, TextId, SET_VALUE='-'
            TIP = 1
        ENDIF ELSE IF Minus THEN BEGIN
            WIDGET_CONTROL, TextId, SET_VALUE=''
        ENDIF ELSE BEGIN
            ;   We actually have a number to negate

            WIDGET_CONTROL, TextId, GET_VALUE=Value
            IValue      = LONG(Value)
            TIP         = TIP + (IValue GT 0) - (IValue LT 0)
            WIDGET_CONTROL, TextId, SET_VALUE=STRTRIM(-IValue,2)
        ENDELSE
        Altered = 1
    ENDIF

    ; Set selection point
    IF Altered THEN WIDGET_CONTROL, TextId, SET_TEXT_SELECT=[TIP,0]
END


 pro get_arr_var_event, event
  widget_control, event.id , get_uvalue = val

  case val of
       'select':
       'option': begin
                 if event.value eq 0 then begin
                   widget_control, event.top, get_uvalue = info
                   widget_control, info.button1, get_value = val
                   if total (val) le info.np/2 then $
                      val(0:*) = 1 else val(0:*) = 0
                   widget_control, info.button1, set_value=val
                 endif else begin
                   widget_control, event.top, get_uvalue = info
                   widget_control, info.button1, get_value = val
                   *info.ptr = val
                   if total(val) eq 0 then begin
                     winformation, 'At least one array must be selected'
                   endif else widget_control , event.top, /destroy
                 endelse
                 end
         ELSE: Begin
               print, '% GET_ARRAY_VAR: an unexpected event has occurred'
               help, /str, event
               end
          endcase
 end

pro get_arr_wdf_event, event
  widget_control, event.id , get_uvalue = val

  case val of
       'select': my_cw_field_event, event

       'DIRW'  : dirw

       'option': begin
                 widget_control, event.top, get_uvalue = info
                 w = *info.ptr
                 for i = 0 , info.np-1 do begin
                   widget_control, info.field[i], get_value = val
                   w[i]=val
                 endfor
                 *info.ptr = w
;                j = uniq(w, sort(w))
                 if n_elements(w) eq 1 then nok = 0 else begin
                   ww = w(sort(w))
                   ii = where (ww eq shift(ww, 1), nok)
                 endelse
                 if nok gt 0 then begin
                   winformation,$
                   ['Unique WDF arrays must be provided for each signal' , $
                      string(ww(ii) )]
                 endif else begin
                    ok = where (w le 0 or  w gt get_maxwdf(), nok)
                    if nok gt 0 then begin
                      winformation, $
                        ['Valid WDF array numbers must be provided', $
                        string(w(ok))]  
                    endif else widget_control, event.top, /destroy
                 endelse
                 end
         ELSE: Begin
               print, '% GET_ARRAY_VAR: an unexpected event has occurred'
               help, /str, event
               end
          endcase
 end

;
;       is a valid floating point number.
;
FUNCTION MY_CW_FIELD_VALIDATE, Value
        ;       Look for invalid mantissa

    IF Value EQ '' THEN RETURN, ''

    Chars       = [ BYTE(Value), 0b ]
    Curr        = 0
    NeedDecimal = 1

        ;       Valid #s
        ;       [+-]<number>[exponent]
        ;       number ::= [0-9]+[.[0-9]*] or .[0-9]+
        ;       exponent ::= {eEdD}[+-][0-9]+

        ;       Signed value?
    IF Chars[Curr] EQ 43b OR Chars[Curr] EQ 45b THEN Curr = Curr + 1

        ;       Look for digits before the decimal point
    IF Chars[Curr] GE 48b AND Chars[Curr] LE 57b THEN BEGIN
        NeedDecimal     = 0

        ;       while(isdigit(*p))++p;
        WHILE Chars[Curr] GE 48b AND Chars[Curr] LE 57b DO Curr = Curr + 1
    ENDIF

        ;       Must have .[0-9]+

    IF NeedDecimal THEN BEGIN
        IF Chars[Curr] NE 46b THEN RETURN,''    ; invalid #
        Curr    = Curr + 1
        IF Chars[Curr] LT 48b OR Chars[Curr] GT 57b THEN RETURN,''

        ;       while(isdigit(*p))++p;
        WHILE Chars[Curr] GE 48b AND Chars[Curr] LE 57b DO Curr = Curr + 1
    ENDIF ELSE BEGIN

        ;       Might have .[0-9]*

        IF Chars[Curr] EQ 46b THEN BEGIN
            Curr        = Curr + 1
                ;       while(isdigit(*p))++p;
            WHILE Chars[Curr] GE 48b AND Chars[Curr] LE 57b DO Curr = Curr + 1
        ENDIF
    ENDELSE

        ;       Exponent?
    Dummy       = WHERE(Chars[Curr] EQ BYTE("dDeE"), Count)
    IF Count THEN BEGIN
        ; Save exponent position in case the exponent is invalid
        ; and only mantissa is valid number.
        SaveCurr        = Curr - 1

        Curr            = Curr + 1      ; skip 'e'
        ;       Signed exponent?
        IF Chars[Curr] EQ 43b OR Chars[Curr] EQ 45b THEN Curr = Curr + 1

        ;       At least one digit after 'e' or exponent is malformed
        IF Chars[Curr] LT 48b OR Chars[Curr] GT 57b THEN BEGIN
                Curr    = SaveCurr      ; Revert -- invalid exponent
        ENDIF ELSE BEGIN
        ;       find end of exponent digits
            WHILE Chars[Curr] GE 48b AND Chars[Curr] LE 57b DO Curr = Curr + 1
        ENDELSE
    ENDIF

    RETURN,STRING(Chars[0:Curr])        ; Chars from 0-Curr are valid
END

FUNCTION MY_CW_FIELD_VALUE, Value, Type

    IF Type EQ 0 THEN RETURN, Value

    NValue      = MY_CW_FIELD_VALIDATE(Value[0])

    CASE Type OF
    1:  RETURN, FLOAT(NValue)
    2:  RETURN, FIX(NValue)
    3:  RETURN, LONG(NValue)
    ENDCASE
END



 function get_array_var, str, wdf, select_only = select_only, title = title
@com.dat
@draw_defaults.com
   if n_elements(initwdf) eq 0 then wdfinit

   nmax = 16L
   nwdf = n_elements(wdf)
   np = n_elements(str)
   if not keyword_set(select_only) and nwdf eq 0 then return, -1
   if n_elements(title) eq 0 then title =  'Select Desired Variables'
   tlb = widget_base(Title = title, /col  )
   base1 = widget_base(tlb, /frame) 
   base2 = widget_base(tlb, /frame) 
   if np le nmax  then $
   b1 = cw_bgroup(base1, str, /nonexclusive, uval = 'select')  else $
   b1 = cw_bgroup(base1, str, /scroll,y_scroll=bigsize[1]-50, x_scroll=300, $
         /nonexclusive, uval = 'select')
   b2 = cw_bgroup(base2, ['Select ALL', '  CONTINUE  '],/row, uval= 'option' )
   np = n_elements(str) 
   ptr = ptr_new( make_array(np, value = 0L, /int))
   info = {ptr:ptr, button1 :b1, np:np}
   widget_control, tlb, /realize
   widget_control, tlb, set_uvalue = info
   widget_control, b1, set_value = make_array(np, value =1)
   xmanager,  'get_arr_var', tlb
   val = *ptr
   ptr_free, ptr
   ok = where (val gt 0, nok)
   if keyword_set(select_only) then return, ok
   if nok eq 0 then  return, -1
   str2 = str(ok)
   if nwdf lt nok then begin
     print, '% GET_ARRAY_VAR: Error with Fewer WDF arrays than Signals'
     return, -1
   endif
   ww = wdf(0:nok-1)

;  now get the wdf arrays.
;

;first create a list with one element.  This will
;determine the vertical spacing for the labels, so
;that they will lign up with the list items.
junk = widget_base(col = 2)
junkSub2 = widget_base(junk, /row)
junktext = widget_text(junkSub2, value = 'X')
btnBaseSz = widget_info(junkSub2, /geom)
ysz = btnBaseSz.scr_ysize
widget_control, junk, /destroy


   b1 = make_array(nok, /long)
   if nok gt nmax then begin
     tlb = widget_base(Title = 'Select Storage Locations', /col )
     base0 = widget_base(tlb, /row, /frame)
     nbase = nok/nmax 
     if nmax*nbase lt nok then nbase = nbase +1
     npbase = nok/nbase
     for j = 1, nbase do begin
       base1= widget_base(base0,/column , /frame)
       t = widget_label( base1, /align_right, value = 'Signal        WDF Array')
       base00  = widget_base(base1, column = 2 )
       basea = widget_base(base00, /column)
       baseB = widget_base(base00, /column)
       if j lt nbase then mmax = j*npbase-1 else mmax = nok-1
       for i = (j-1)*npbase, mmax do begin
         baseAa = widget_base(basea, /col, /align_right)
         junk=widget_label(baseAa, value = strtrim(str2[i],2), scr_ysize = ysz)
       endfor
       for i = (j-1)*npbase, mmax do begin
         baseBa = widget_base(baseb, /col, /align_right)
         b1[i] = widget_text(baseBa, value = strtrim(ww[i],2), scr_ysize=ysz, $
         xsize = 4, uval = 'select',  /all )
       endfor
     endfor
   endif else begin
     tlb = widget_base(Title = 'Select Storage Locations', /col )
     base1 = widget_base(tlb,/column, /frame)
     t = widget_label( base1, /align_right, value = 'Signal        WDF Array')
     base0 = widget_base(base1, column = 2 )
     basea = widget_base(base0, /column)
     for i = 0, nok-1 do begin 
       baseAa = widget_base(basea, /col, /align_right)
        junk =widget_label(baseAa, value = strtrim(str2[i],2), scr_ysize = ysz)
     endfor
     baseb = widget_base(base0, /column)
     for i = 0, nok-1 do begin 
       baseBa = widget_base(baseb, /col, /align_right)
       b1[i] = widget_text(baseBa, value = strtrim(ww[i],2), scr_ysize = ysz, $
         xsize = 4, uval = 'select',  /all )
     endfor
   endelse
   base2 = widget_base(tlb,/row, /frame)
   b2 = widget_button(base2,value= '      DIRW     ', uval= 'DIRW' )
   b3 = widget_button(base2,value= '      SAVE     ', uval= 'option' )
   ptr = ptr_new( make_array(nok, value = 0, /int))
   info = {ptr:ptr, field:b1, np:nok}
   widget_control, tlb, /realize
   widget_control, tlb, set_uvalue = info
   xmanager,  'get_arr_wdf', tlb
   wdf = *ptr
   ptr_free, ptr
   wok = where (wdf gt 0 and wdf le get_maxwdf(), nwok)
   if nwok eq nok then return, ok
   if nwok eq 0 then return, -1
   wdf = wdf(wok)
   ok = ok(wok)
   return,ok 
   end

