; ------------------------------------------------------------------------ 
; $Id: get_bare_filename.pro,v 1.6 2011/06/15 17:05:01 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Function get_bare_filename, file_name, extension = myextension, $
              directory = mydirectory 

; Get the bare filename
; for example:
;   file_name = '/opt/rsi/idl_5.6/lib/pfidl/pfidl_1d/writehdf.pro'
;   bare_name = get_bare_filename(filename, extension = extension, $
;                 directory = directory)
; results:
;   bare_name = 'writehdf'
;   extension = '.pro'
;   directory = '/opt/rsi/idl_5.6/lib/pfidl/pfidl_1d/'
;
 COMPILE_OPT hidden
 on_error, 1
  mydirectory = ''
  myextension = '' 
  if n_elements(file_name) eq 0 then return , ''
  sep = path_sep()
  i = strpos(file_name, sep, /reverse_search)
  if i gt 0 then mydirectory = strmid(file_name, 0, i+1)
  j =  strpos(file_name, '.', /reverse_search)
  if j gt i+1 then begin
    myextension= strmid(file_name, j) 
    return, strmid(file_name, i+1, j-i-1)
  endif else return, strmid(file_name, i+1) 
end
