; ------------------------------------------------------------------------ 
; $Id: get_contour_lines.pro,v 1.3 2007/06/06 19:34:27 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;

 pro get_contour_lines, cont, xx, yy, wdf, levels, clabel = clab, $
    xlabel = xlab, ylabel = ylab, filename=file, lcall = lcall
;
;+
;  Name: get_contour_lines
;  Purpose: Get the xy plots for contour lines at levels and store
;           each line in a wdf array.
;-
;
       
on_error, 1
@com.dat
;     see if we are initialized
      if n_elements(initwdf) eq 0 then wdfinit

;help, levels, cont, xx, yy

 if n_elements(levels) gt 30 then begin
 print, '% GET_CONTOUR_LINES: This version limited to 30 levels.'
 print, '                     Please contact Paul Mix.'
    lev = levels[0:29]
  endif else lev = levels
  clabel = strtrim (clab, 2)
  i = strpos(clabel, ' - ')
  if i gt 0 then clabel= strmid(clabel, 0,i)
  contour, cont, xx, yy, level = lev, path_xy=xy, path_info=info, $
     /path_data_coords

; info is a structure
;   type : 0/1 for open or closed 
;   high_low : 1/0 for above or below surroundings (must be closed)
;   level  : index into the level array
;   n      : number of data points
;   offset : initial point
;   value  : contour value
  ncurv = n_elements(info)
 icurv = 0
 wdfa = wdf

while icurv lt ncurv and wdfa le maxwdfarray do begin
  cl = clabel+': '+strtrim (info[icurv].value, 2)
  ii = info[icurv].offset
  ij = ii +((info[icurv]).n)-1
  if (info[icurv].n gt 2) then begin
    put_wdfarray,[reform(xy[0, ii:ij]),reform(xy[1, ii:ij])], wdfa, $
        /xydata, file = file,  $
       clabel = cl, xlabel = xlab, ylabel = ylab
    wdfa = wdfa+1
  endif else if lcall gt 0 then begin
    xx = [xy[0, ii], 0, xy[0, ij]]
    yy = [xy[1, ii], 0, xy[1, ij]]
    xx[1]= total(xx)*0.5
    yy[1]= total(yy)*0.5
    put_wdfarray,[xx, yy], wdfa, /xydata, file = file, $
       clabel = cl, xlabel = xlab, ylabel = ylab
    wdfa = wdfa+1
  endif
  icurv = icurv+1
endwhile
if icurv lt ncurv then begin
 PRINT, '% GET_CONTOUR_LINES: ', strtrim(ncurv-icurv, 2), $
     ' contours were not saved'
 Print, '                     Please incease the number of WDF arrays'
endif
end
