; ------------------------------------------------------------------------ 
; $Id: get_engr.pro,v 1.4 2007/06/06 19:34:27 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
  Pro get_engr,value, multiplier, label
;+
; get engineering scale factor to make value in the range (1, 1000)
; value = abs(value)
; and get a label to correspond to the multiplier
; for example if value is 10e-9 then 
;         multiplier = 1e9 and label = '*1e-9'
;-
  on_error, 2
 COMPILE_OPT hidden

    multiplier = 1.000
    label = ''
  val = abs(value)
  if val eq 0.0  or val eq 1.000 then return
  
  val = alog10(val)
  if val gt 0.0 then $
    multiplier = (floor(val)/3)*3  $
  else multiplier = (ceil(val)/3-1)*3
;
  if multiplier eq 0 then begin
    multiplier = 1.000
    return
  endif
  label =' x1E'+strtrim(multiplier, 2)
  multiplier = 10.^(-multiplier)
  return
  end
    
