; ------------------------------------------------------------------------ 
; $Id: get_image_region.pro,v 1.3 2007/06/06 19:34:28 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
PRO get_region_event, Event

on_error , 1

  WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev

  print, '% GET_REGION_EVENT: EVENT UVALUE = ', Ev 
  help, /str, event
  END

  Pro get_region_doit
  common get_region_data_com, xx, yy, array, x, y, ix, iy, $
      nx, ny,  px, py, qx, qy
  common get_region_widget_com, xwindow1, ywindow1, xwindow2, ywindow2, $
   bset1, bset2, image, draw, draw_id, oldbx, oldby, $
   print_var, oldbp, npselect, base2, base7, clabel, xlabel, ylabel
; 
;
  on_error, 1
  device, copy = image
  widget_control, xwindow1, get_value = px
  widget_control, ywindow1, get_value = py
  if npselect le 1 then begin
    oplot, !x.crange, [py, py], psym = -8, thick = 2, col =7 
    oplot, [px, px], !y.crange, psym = -8, thick = 2, color = 7
  endif else begin
    widget_control, xwindow2, get_value = qx
    widget_control, ywindow2, get_value = qy
    oplot, [px, qx, qx, px, px], [py, py, qy, qy, py], thick = 2, color = 7
  endelse
  return
  end


  pro get_region_point_event, event
;
  on_error, 2
  common get_region_data_com
  common get_region_widget_com

  WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev
  CASE EV OF
   'DRAW':  Begin
            if event.press eq 4 then get_region_reset_button else begin
              if event.press eq 2 then begin
                if npselect eq 2 then save_region_button_event, event else $
                    winformation, 'Two points must be selected for a region'
              endif else begin
                if event.press eq 1 then begin
                  coord = convert_coord(event.x, event.y, /device, /to_data)
                  device, copy = image
                  if (npselect eq 0)  then begin
                    dmin = min(abs(x-coord(0)), ix)
                    dmin = min(abs(y-coord(1)), iy)

                    widget_control, xwindow1, set_value = x(ix)
                    widget_control, ywindow1, set_value = y(iy)
                    widget_control, draw, /draw_motion_events, /clear_events
                    oplot, [x(ix), x(ix)], !y.crange, color = 7, thick = 2
                    oplot, !x.crange, [y(iy), y(iy)], color = 7, thick = 2
                    npselect = 1
                  endif else begin
                    dmin = min(abs(x-coord(0)), ii)
                    dmin = min(abs(y-coord(1)), jj)

                    widget_control, xwindow2, set_value = x(ii)
                    widget_control, ywindow2, set_value = y(jj)
                    npselect = 2
                    ix = ix(0)
                    iy = iy(0)
                    widget_control, base7, map =1
                    widget_control, draw, /clear_events, draw_motion_events = 0
                    oplot, [x(ix), x(ii), x(ii), x(ix), x(ix)], $
                     [y(iy), y(iy), Y(jj), y(jj), y(iy)], $
                     color = 7, thick = 2
                    ix = [ix, ii]
                    iy = [iy, jj]
                  endelse
                endif else if event.release eq 0 then begin
                  coord = convert_coord(event.x, event.y, /device, /to_data)
                  dmin = min(abs(x-coord(0)), ii)
                  dmin = min(abs(y-coord(1)), jj)
                  device, copy = image
                  if npselect eq 0 then begin
                    widget_control, xwindow1, set_value = x(ii)
                    widget_control, ywindow1, set_value = y(jj)
                    oplot, [x(ii), x(ii)], !y.crange, color = 7, thick = 2
                    oplot, !x.crange, [y(jj), y(jj)], color = 7, thick = 2

                  endif else begin
                    widget_control, xwindow2, set_value = x(ii)
                    widget_control, ywindow2, set_value = y(jj)
                    oplot, [x(ix), x(ii), x(ii), x(ix), x(ix)], $
                     [y(iy), y(iy), Y(jj), y(jj), y(iy)], $
                     color = 7, thick = 2

                  endelse
                  
                endif else widget_control, draw, /clear_events
              endelse
            endelse
            END
  'XVALUE1': GET_REGION_HANDLE_1
  'YVALUE1': GET_REGION_HANDLE_1
  'BUTTON1': GET_REGION_HANDLE_1
  'XVALUE2': GET_REGION_HANDLE_2
  'YVALUE2': GET_REGION_HANDLE_2
  'BUTTON2': GET_REGION_HANDLE_2
  ELSE:   Begin
          print, ev
          help, /str, event
          END
  END
  return
  end

 Pro get_region_handle_1
   on_error, 2
  common get_region_data_com
  common get_region_widget_com
  device, copy = image
  widget_control, xwindow1, get_value = px
  widget_control, ywindow1, get_value = py
  dmin = min(abs(x-px), iix)
  dmin = min(abs(y-py), iiy)
  px = x(iix)
  py = y(iiy)
  ix(0) = iix
  iy(0) = iiy
  widget_control, xwindow1, set_value = px
  widget_control, ywindow1, set_value = py
  if npselect le 1 then begin
    oplot, !x.crange, [py, py], psym = -8, thick = 2, col =7
    oplot, [px, px], !y.crange, psym = -8, thick = 2, color = 7
    widget_control, draw, draw_motion_events = 1, /clear_events
  endif else begin
    widget_control, xwindow2, get_value = qx
    widget_control, ywindow2, get_value = qy
    oplot, [px, qx, qx, px, px], [py, py, qy, qy, py], thick = 2, color = 7
  endelse
  return
  end


 Pro get_region_handle_2
   on_error, 2
  common get_region_data_com
  common get_region_widget_com
  widget_control, xwindow2, get_value = qx
  widget_control, ywindow2, get_value = qy
  dmin = min(abs(x-qx), iix)
  dmin = min(abs(y-qy), iiy)
  qx = x(iix)
  qy = y(iiy)
  if (npselect eq 0) then begin
    ix(0) = iix
    iy(0) = iiy
    widget_control, xwindow1, get_value = px
    widget_control, ywindow1, get_value = py
    widget_control, xwindow1, set_value = qx
    widget_control, ywindow1, set_value = qy
    widget_control, xwindow2, set_value = px
    widget_control, ywindow2, set_value = py
    widget_control, draw, /clear_events, draw_motion_events = 1
    npselect = 1 
  endif else if (npselect eq 1) then begin
    widget_control, xwindow2, set_value = qx
    widget_control, ywindow2, set_value = qy
    widget_control, draw, /clear_events, draw_motion_events = 0
    widget_control, base7, map =1
    npselect = 2
    ix = [ix(0),iix]
    iy = [iy(0),iiy]
  endif else begin
    widget_control, xwindow2, set_value = qx
    widget_control, ywindow2, set_value = qy
    widget_control, draw, /clear_events, draw_motion_events = 0
    ix(1)=iix
    iy(1)=iiy
  endelse
  get_region_doit
  end


Pro save_region_button_event, event
  common get_region_data_com
  common get_region_widget_com
@com.dat
  if npselect eq 2 then widget_control, event.top, /destroy else $
  winformation, 'Two points must be selected '
  END

pro get_region_reset_button
; Handle the actual reset
  common get_region_data_com
  common get_region_widget_com
    npselect = 0
    wset, draw_id
    device , copy = image
    !x = oldbx
    !y = oldby
    !p = oldbp
    widget_control, draw, /clear_events
    widget_control, base2, map = 1
    widget_control, base7, map = 0
    widget_control, draw, /clear_events, draw_motion_events = 1 

  END

pro reset_region_button_event, event
;
; Handle the reset and the exit buttons
; First RESET
  on_error, 2
  common get_region_data_com
  common get_region_widget_com
  if event.value eq 0 then get_region_reset_button else begin
    if npselect eq 2 then $
        wsave_nosave, lcquit, [ 'There is a Region defined', $
          'Do you want to save it before EXIT'], 'Region  EXIT', $
           group = event.top else lcquit = 1
     
    if lcquit eq 0 then save_region_button_event
    widget_control, event.top, /destroy
  endelse
  end


 pro get_image_region, strin, ixin, iyin, snap=snap, box=box, _extra=extrastuff

;
;       return on an error
      on_error, 1
@com.dat
  common get_region_data_com
  common get_region_widget_com
      if n_elements(initwdf) eq 0 then wdfinit
;  Common block
@qscom.dat
@qsstrcom.dat
;
  common pffcom, initpff, pff_exe
@draw_defaults.com

      if n_elements (structinit) eq 0 then qsstruct_init
      if n_elements (qsplotinit) eq 0 then qsinit
      if n_elements (initpff) eq 0 then init_pff else $
       if initpff eq 0 then init_pff
;
      nparams = n_params()
      if nparams eq 0 then begin
        print,'% Format: ', $
       'GET_IMAGE_REGION, STR, IX, IY, /SNAP, /BOX'
        return
      endif
      if n_elements(strin) eq 0 then begin
        print, 'Structure for LINSTR must be defined'
        return
      endif else arr= strin
;
      b = size(arr)
      if b(b(0)+1) ne 8 then begin
        if arr gt 0 and arr le maxstructure then begin
          s2i, arr, arr
          b = size (arr)
          if b(b(0)+1) ne 8 then begin
            print, '% GET_IMAGE_REGION:', $
   ' First parameter must be a structure or a structure array number'
            return
          endif
        endif  else begin
          print, '% GET_IMAGE_REGION:', $
         ' Structure array number must be greater than 0 and </='+ $
          strtrim(maxstructure, 2)
          return
        endelse
      endif
      
;     if arr.type ne 1  and arr.type ne 8 then begin

      if arr.type ne 1   then begin
 Print, '% GET_IMAGE_REGION: Structure array must be a type 1 field structure'
        return
      endif

      if n_elements (group) eq 0 then group = 0


  tlbase = WIDGET_BASE(GROUP_LEADER=Group, $
      COLUMN=1, $
      MAP=1, $
      TITLE='Get Image Region')

  BASEINS  = WIDGET_BASE(tlbase, $
      COLUMN = 1, $
      MAP=1, $
      UVALUE = 'BASEINS')

 labelins1 =  WIDGET_LABEL( BASEins, $
      UVALUE='LABEL', $
  VALUE='Left Mouse = Designate Point,     Middle Mouse = Save,     Right Mouse = Reset')

  BASE0 = WIDGET_BASE(tlbase, $
      row=1, $
      FRAME=0, $
      MAP=1, $
      UVALUE='BASE0')

  BASE1 = WIDGET_BASE(base0, $
      column=1, $
      FRAME=2, $
      MAP=1, $
      event_pro = 'Get_region_Point_Event', $
      UVALUE='BASE1')

  BASE2 = WIDGET_BASE(base0, $
      column=1, $
      FRAME=2, $
      MAP=1, $
      event_pro = 'Get_region_Point_Event', $
      UVALUE='BASE2')

  BASE4 = WIDGET_BASE(tlbase, $
      ROW = 1, $
      MAP=1, $
      UVALUE = 'BASE4')

  BASE5 = WIDGET_BASE(tlbase, $
      ROW = 1, $ 
      MAP=1, $
      event_pro = 'Get_region_Point_Event', $
      UVALUE = 'BASE5')

  BASE6 = WIDGET_BASE(BASE4, $
      ROW = 1, $
      MAP=1, $
      FRAME = 2, $
      UVALUE = 'BASE6')

  BASE7 = WIDGET_BASE(BASE4, $
      ROW = 1, $
      MAP=1, $
      FRAME = 2, $
      event_pro = 'SAVE_REGION_BUTTON_EVENT', $
      UVALUE = 'BASE7')

  BASE8 = WIDGET_BASE(BASE4, $
      ROW = 1, $
      MAP=1, $
      FRAME = 2, $
      event_pro = 'RESET_REGION_BUTTON_EVENT', $
      UVALUE = 'BASE8')

   xvalue = 0.0
   yvalue = 0.0

   label1  =  WIDGET_LABEL( BASE1, $
      UVALUE='LABEL', $
      VALUE='First Point')

   xwindow1 = CW_FIELD( BASE1,VALUE=xvalue, $
      ROW=1, $
      FLOAT=1, $
      RETURN_EVENTS = 1, $
      TITLE='X-Value:', $
      UVALUE='XVALUE1')

   ywindow1 = CW_FIELD( BASE1,VALUE=yvalue, $
      ROW=1, $
      FLOAT=1, $
      RETURN_EVENTS = 1, $
      TITLE='Y-Value:', $
      UVALUE='YVALUE1')

   bset1 = WIDGET_BASE(BASE1, $
      ROW = 1, $
      MAP=1, $
      UVALUE = 'BSET1')

   set1= WIDGET_BUTTON( Bset1, $
      UVALUE='BUTTON1', $
      VALUE=' Set Point 1 Value ')

   label2  =  WIDGET_LABEL( BASE2, $
      UVALUE='LABEL', $
      VALUE='Second Point')

   xwindow2 = CW_FIELD( BASE2,VALUE=xvalue, $
      ROW=1, $
      FLOAT=1, $
      RETURN_EVENTS = 1, $
      TITLE='X-Value:', $
      UVALUE='XVALUE2')

   ywindow2 = CW_FIELD( BASE2,VALUE=yvalue, $
      ROW=1, $
      FLOAT=1, $
      RETURN_EVENTS = 1, $
      TITLE='Y-Value:', $
      UVALUE='YVALUE2')

   bset2 = WIDGET_BASE(BASE2, $
      ROW = 1, $
      MAP=1, $
      UVALUE = 'BSET2')

   set2= WIDGET_BUTTON( BSET2, $
      UVALUE='BUTTON2', $
      VALUE=' Set Point 2 Value ')




  SAVEB= WIDGET_BUTTON( base7, $
      UVALUE='SAVE_BUTTON', $
      VALUE=' Accept / Save Region ')

  Btns439 = [ $
    ' Reset All Points ', $
    '   Done  / Exit   ' ]
  ard_buttons = CW_BGROUP( base8, Btns439, $
      ROW=1,  /NO_RELEASE, $
      UVALUE='buttons')

  oldwin = !d.window
  pmulti_save=!p.multi 
  !p.multi = 0
  if n_elements(xsizein) eq 0 then begin
    if initpff gt 3  then xsize = medsize(0)*5/6 else xsize = medsize(0) 
  endif else xsize = xsizein
  if n_elements(ysizein) eq 0 then begin
    if initpff gt 3 then ysize = medsize(1)*5/6 else ysize = medsize(1) 
  endif else ysize = ysizein

  xpreviewsize = smaLlsize

  npselect = 0

  window, /free , /PIXMAP  , xsize = xsize, ysize = ysize
  pixwin = !d.window
  plotfld, arr, farray = array, xarray= x, yarray= y,  /xst, /yst, $
          nfarray = 256,cntour = 2,  _extra = extrastuff
  nx = n_elements(x)
  ny = n_elements(y)
  if nx eq 0 or ny eq 0 then begin
    !p.multi = pmulti_save
    return
  endif
  image = [0, 0, xsize, ysize, 0, 0, pixwin]

  DRAW = WIDGET_DRAW( base5, $
      BUTTON_EVENTS=1, $
      MOTION_EVENTS=1, $
      RETAIN=1, $
      UVALUE='DRAW', $
      XSIZE=xsize, $
      YSIZE=ysize)

  WIDGET_CONTROL, tlbase, /REALIZE
  widget_control, base7, map = 0
  widget_control, draw, /draw_motion_events 
; Get drawable window index
  WIDGET_CONTROL, DRAW, GET_VALUE=DRAW_Id
  mksymbol, 'plus', /fill, size = 1.5
  loadxyct
  if keyword_set(printit) then print_var =1 else print_var = 0
  npselect = 0
  wset , draw_id
  device , copy = image
  oldbx = !x
  oldby = !y
  oldbp = !p
  ix = -1L
  iy = -1L

  wset, draw_id

  !x = oldbx
  !y = oldby
  !p = oldbp
  npwdf = 0
  wdfarr= make_array(1024, /int, value = 0)
  XMANAGER, 'get_region', tlbase, group = group, modal = modal
  array = 0
  if n_elements(ix) lt 2 then begin
    ixin = ix
    iyin = iy
  endif else begin
    if ix(0) lt ix(1) then ixin = ix else ixin = [ix(1), ix(0)]
    if iy(0) lt iy(1) then iyin = iy else iyin = [iy(1), iy(0)]
  endelse
  wdelete, pixwin
  !p.multi = pmulti_save
  if oldwin ge 0 then wset, oldwin
END
