; ------------------------------------------------------------------------ 
; $Id: get_min_dist.pro,v 1.3 2007/06/06 19:34:28 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 function get_min_dist,p,x, y, screen= screen
;
; given a point p this function returns the index of the ordered
; pairs (x, y) which are closest to p
;
; If keyword(screen) is set, the distance is in terms of pixels on
; the current screen.

    if n_elements(p) ne 2 then return, -1
    if keyword_set (screen) then begin
      xpos = round(!x.window*!d.x_size)
      ypos = round(!y.window*!d.y_size)
      xr = !x.crange(1)-!x.crange(0)
      yr = !y.crange(1)-!y.crange(0)
      xsiz = xpos(1)-xpos(0)+1
      ysiz = ypos(1)-ypos(0)+1
      xx = xsiz/xr*(p(0)-x)
      yy = ysiz/yr*(p(1)-y)
    endif else begin
      xx = (p(0)-x)
      yy = (p(1)-y)
    endelse
    d = xx*xx+yy*yy
    d = min(d, val)
    xx = 0
    yy = 0 
    return, val
    end
