; ------------------------------------------------------------------------ 
; $Id: get_nice_values.pro,v 1.4 2007/06/06 19:34:28 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 function get_nice_values, range, noswap = noswap
 COMPILE_OPT hidden

   on_error, 2
   if n_elements (range) lt 2 then begin
     print, '% GET_NICE_VALUES:  Parameter must have two values'
     return, -1
   endif
   oldx = !x
   oldy = !y
   oldz = !z
   oldp = !p
   old_device = !d.name
   old_window = !d.window
   ok = where (old_device eq ['X', 'WIN', 'MAC'], nok)
   if nok eq 0 then begin
;     make sure we can open a pixmap
      vers = strupcase(strmid(!version.os, 0, 3))
      if (vers eq 'WIN') then set_plot, 'WIN' $
      else if (vers eq 'MAC') then set_plot, 'MAC' $
      else set_plot, 'X'
      lcswap = 1
   endif else lcswap = 0
   window, /free, /pix 
   P_multi = !p.multi 
   !p.multi =[1L, 0L, 0L,0L ,0L ] 
   if not keyword_set(noswap) then rang = [min(range, max = mm), mm] $
     else rang = range
   plot, rang, yrange = rang, /nodata, xstyle = 4, ystyle = 4
   val = !y.crange
   wdelete, !d.window
   if lcswap gt 0 then set_plot, old_device
   if old_window ge 0 then wset, old_window
   !p.multi = p_multi
   !z = oldz
   !y = oldy
   !x = oldx
   !p = oldp
   return, val
   end
