; ------------------------------------------------------------------------ 
; $Id: get_overlap.pro,v 1.3 2007/06/06 19:34:28 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
; fudge, if not specified is 5% of total range with a maximum of 90% of an
; end segment and 50% of a middle segment.
; If specified, value is reduced to above maxima.

function get_overlap, range, break, nbreak, fudgein
on_error,1

fudge = [0.0, 0.0]
if nbreak eq 0 then return, fudge
if nbreak gt 2 then begin
  Print, '% GET_OVERLAP: Maximum of 2 break points'
  return, fudge
endif

if n_elements(break) lt nbreak then return, fudge
if n_elements (fudgein) eq 0 then fin = fudge  else fin=float(fudgein)
if n_elements (fin) lt nbreak then fin = [fin, fin]

tot =  abs(range(1)-range(0))
deftot = 0.025*tot
if nbreak eq 1 then begin
  d1 = abs(break(0)-range(0))
  d2 = range(1)-break(0)

  if fin(0) le 0 then merg = deftot else  merg = fin(0)*d1

  if merg gt 0.9*d1 then merg = 0.9*d1
  if merg gt 0.9*d2 then merg = 0.9*d2
  fin(0)=float( merg/d1)
endif else begin
  d1 = abs(break(0)-range(0)) 
  d2 = abs(break(1)-break(0))
  if fin(0) le 0 then merg = deftot else  merg = fin(0)*d1
  if merg gt 0.9*d1 then merg = 0.9*d1
  if merg gt 0.5*d2 then merg = 0.5*d2
  fin(0)=float( merg/d1)
  d1 = d2
  d2 = abs(range(1)-break(1))
  if fin(1) le 0 then merg = deftot else  merg = fin(1)*d2
  if merg gt 0.5*d1 then merg = 0.5*d1
  if merg gt 0.9*d2 then merg = 0.9*d2
  fin(1)=float( merg/d2)
endelse
  return, fin
end
