 pro get_ps_device_param, xsize = xsize, ysize =ysize, xoffset= xoffset, yoffset = yoffset, $
       file = file, orientation = orientation, font_size = font_size, ierror = ier

;+
; Return parameters of a postscrip device, 
; get_ps_device_param, xsize = xsize, ysize =ysize, xoffset= xoffset, yoffset = yoffset, $
;       file = file, orientation = orient, font_size = font_size, ierror = ier
;-
 ier = 1
 xsize = 0.0
 ysize = 0.0
 xoffset = 0.0
 yoffset = 0.0
 file = ''
 orientation = ''
 font_size = 0
 if !d.name ne 'PS' then begin
   print, '% GET_PS_DEVICE_PARAM: Must be in postscript graphics mode'
   return
 endif
 help, /dev, output = output
 st = 2
 ok = strpos(output[st], 'File:')
 if ok lt 0 then ok = strpos(output[++st], 'File:')

 if ok lt 0 then $
   print, '% GET_PS_DEVICE_PARAM: File not found' $
 else file = strtrim(strmid(output[st], ok+5), 2)
 st++

 ok = strpos(output[st], 'Mode:')
 if ok lt 0 then ok = strpos(output[++st], 'Mode:')
 if ok lt 0 then $
   print, '% GET_PS_DEVICE_PARAM: Mode not found' $
 else orientation = (strpos(output[st], 'Landscape') gt 0) ? 'Landscape' : 'Portrait'
 st += 2
 ok = strpos(output[st], 'Offset (X,Y):')
 if ok lt 0 then ok = strpos(output[++st], 'Offset (X,Y):')
 if ok lt 0 then $
   print, '% GET_PS_DEVICE_PARAM: Offsets not found' else begin
   okc = strpos(output[st], 'cm., (') +6
   tmp = strmid(output[st], okc)
   okc = strpos(tmp, ',') 
   oke = strpos(tmp, ')') 
   xoffset = float(strmid(tmp, 0, okc))
   yoffset = float(strmid(tmp, okc+1, oke-okc-1))
 endelse
 st++
 ok = strpos(output[st], 'Size (X,Y):')
 if ok lt 0 then ok = strpos(output[++st], 'Size (X,Y):')
 if ok lt 0 then $
   print, '% GET_PS_DEVICE_PARAM: Sizes not found' else begin
   okc = strpos(output[st], 'cm., (') +6
   tmp = strmid(output[st], okc)
   okc = strpos(tmp, ',')
   oke = strpos(tmp, ')')
   xsize = float(strmid(tmp, 0, okc))
   ysize = float(strmid(tmp, okc+1, oke-okc-1))
 endelse
 st +=4
 ok = strpos(output[st], 'Font Size:')
 if ok lt 0 then ok = strpos(output[++st], 'Font Size:')

 if ok lt 0 then $
   print, '% GET_PS_DEVICE_PARAM: Font size not found' else begin
   font_size = (strmid(output[st], ok+10))
   ok = strpos(font_size, '.')
   font_size =  float(font_size)
   if ok lt 0 then font_size= round(font_size)
 endelse
 ier = 0
 end
