; ------------------------------------------------------------------------
; $Id: get_sph_database_values.pro,v 1.4 2011/03/28 21:44:00 lpmix Exp $
; ------------------------------------------------------------------------
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
; Routine to get the spherical spectrometer parameters from the CSV file
;
pro get_sph_database_values, i, rc, cry2d, order, length, width, distance, theta, $
    npoints, film, verbose = verbose

@sph_spec_common.dat
if size(/type, database_save) ne 8 then return
  tags = database_save.tag_names
  rr = get_match(db_keys[0], tags, nel = nel)
  rc = rc_save
  if nel eq 1 then begin
    a = (database_save.(rr[0]))[i]
    if a gt -0.8e30 then rc = a
  endif else if keyword_set(verbose) then $
    print, '% GET_SPH_DATABASE_VALUES: Unable to fine unique column for search string: ' $
    +db_keys[0]
  rr = get_match(db_keys[1], tags, nel = nel)
  cry2d = cry2d_save
  if nel eq 1 then begin
    a = (database_save.(rr[0]))[i]
    if a gt -0.8e30 then cry2d = a
  endif  else if keyword_set(verbose) then $
    print, '% GET_SPH_DATABASE_VALUES: Unable to fine unique column for search string: ' $
    +db_keys[1]
  rr = get_match(db_keys[2], tags, nel = nel)
  order = order_save
  if nel eq 1 then begin
    a =  (database_save.(rr[0]))[i]
    if a gt -0.8e30 then order = a
  endif else if keyword_set(verbose) then $
    print, '% GET_SPH_DATABASE_VALUES: Unable to fine unique column for search string: ' $
    +db_keys[2]
  rr = get_match(db_keys[3], tags, nel = nel)
  length = length_save
  if nel eq 1 then begin
    a = (database_save.(rr[0]))[i]
    if a gt -0.8e30 then length = a
  endif else if keyword_set(verbose) then $
    print, '% GET_SPH_DATABASE_VALUES: Unable to fine unique column for search string: ' $
    +db_keys[3]
  rr = get_match(db_keys[29], tags, nel = nel)
  width = width_save
  if nel eq 1 then begin
    a = (database_save.(rr[0]))[i]
    if a gt -0.8e30 then width = a
  endif else if keyword_set(verbose) then $
    print, '% GET_SPH_DATABASE_VALUES: Unable to fine unique column for search string: ' $
    +db_keys[29]
  rr = get_match(db_keys[4], tags, nel = nel)
  distance = distance_save
  if nel eq 1 then begin
    a = (database_save.(rr[0]))[i]
    if a gt -0.8e30 then distance = a
  endif else if keyword_set(verbose) then $
    print, '% GET_SPH_DATABASE_VALUES: Unable to fine unique column for search string: ' $
    +db_keys[4]
  rr = get_match(db_keys[5], tags, nel = nel)
  theta = theta_save
  if nel eq 1 then begin
    a = (database_save.(rr[0]))[i]
    if a gt -0.8e30 then theta = a
  endif else if keyword_set(verbose) then $
    print, '% GET_SPH_DATABASE_VALUES: Unable to fine unique column for search string: ' $
    +db_keys[5]
  rr = get_match(db_keys[24], tags, nel = nel)
  npoints = npoints_save
  if nel eq 1 then begin
    a = (database_save.(rr[0]))[i]
    if a gt -0.8e30 then npoints = a
  endif else if keyword_set(verbose) then $
    print, '% GET_SPH_DATABASE_VALUES: Unable to fine unique column for search string: ' $
    +db_keys[24]
  film = make_array(3, /double, value = -1e30)
  rr = get_match(db_keys[6], tags, nel = nel)
  if nel eq 1 then film[0] = (database_save.(rr[0]))[i] else begin
    if keyword_set(verbose) then print, '% GET_SPH_DATABASE_VALUES: '+ $
      'Unable to fine unique column for search string: '+db_keys[6]
  endelse
  rr = get_match(db_keys[7], tags, nel = nel)
  if nel eq 1 then film[1] = (database_save.(rr[0]))[i] else begin
    if keyword_set(verbose) then print, '% GET_SPH_DATABASE_VALUES: '+ $
      'Unable to fine unique column for search string: '+db_keys[7]
  endelse
  rr = get_match(db_keys[8], tags, nel = nel)
  if nel eq 1 then film[2] = (database_save.(rr[0]))[i] else begin
    if keyword_set(verbose) then print, '% GET_SPH_DATABASE_VALUES: '+ $
      'Unable to fine unique column for search string: '+db_keys[8]
  endelse
  if min(film) lt -0.8e30 then film = 0
end
