; ------------------------------------------------------------------------ 
; $Id: get_tet_faces.pro,v 1.3 2007/06/06 19:34:29 lpmix Exp $ 
; ------------------------------------------------------------------------ 
; 
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;

 pro get_tet_faces, x, y, z, tets, ctet, radius = radius

; make a polygon object

 on_error , 1
 if n_elements (radius) eq 0 then radius = 0.01
 h = sqrt(8.0/9)*radius
 h2 = h/2.0
 h3 = sqrt(2./3.)*radius
 zz = z-radius/3.0
 xh2 = x-h2
 nvert = n_elements(x)

 ctet = make_array(16*nvert, /long)
 po=[3,0,1,2, 3, 0, 2, 3, 3, 0, 3, 1, 3, 3, 2, 1L]
 for i = 0L, nvert-1 do ctet(i*16:i*16+15) = $
     po +i*4*[0,1,1,1,0,1,1,1,0,1,1,1,0,1,1,1]

 xx = [x, x+h, x-h2, xh2]
 yy = [y, y, y+h3, y-h3]
 zz = [z+radius, zz, zz, zz]
 nv4 = 4*nvert
 
 xx = reform(transpose(reform(xx, nvert, 4, /overwrite)), nv4, /overwrite)
 yy = reform(transpose(reform(yy, nvert, 4, /overwrite)), nv4, /overwrite)
 zz = reform(transpose(reform(zz, nvert, 4, /overwrite)), nv4, /overwrite)
 tets = [xx, yy, zz]
 tets = transpose(reform (tets, nv4, 3, /overwrite))
; vv = [x, y, z+radius, h+x, y, zz, x-h2, y+h3, zz, x-h2 y-h3, zz]
; return, obj_new('idlgrpolygon', vv, polygons= po, color = getcolor(color))
end



