; ------------------------------------------------------------------------ 
; $Id: get_uutu.pro,v 1.3 2007/06/06 19:34:29 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro get_uutu, info, value, ier, offset, quiet = quiet
;
;  info = {ptr:ptr, tpeak: field17, wdfa: field30, type:bgroup6, $
;        typrise:bgroup15, typfall:bgroup19, fallstart:field27, $
;        fallwidth: field29, peakV: field4, sourcez:field34}
;
@com.dat
   if n_elements(initwdf) eq 0 then wdfinit
   if n_elements (offset) lt 2 then offset = [0L, 0L]
   on_error, 2
   ier = 1
   if keyword_set (quiet) then begin
     quiet = 0 

   endif else begin
     widget_control, info.type, get_value = stype
     value.stype = stype
     widget_control, info.sourcez, get_value = zsource
     value.zsource = zsource
     widget_control, info.peakv, get_value = peakv
     value.umax = peakv
     if zsource le 0 then begin
       winformation, 'Source impedance must be greater than zero'
       return
     endif
   endelse
   if stype eq 0 then begin
;    analytic
     widget_control, info.tpeak, get_value= tpeak
     value.tpeak = tpeak
     widget_control, info.typrise, get_value = tr
     value.rtype = tr
     widget_control, info.typfall, get_value =tf
     value.ftype = tf
     widget_control, info.fallstart, get_value = fstart
     value.tfall = fstart
     widget_control, info.fallwidth, get_value = fwidth
     value.twidth = fwidth
     if fstart lt tpeak then begin
       winformation, $
               'Time to peak must be less than or equal to Fall Begin'
       return
     endif
     if tr eq 0 then begin
       uu = [0.0, 1.0]
       tu = [0.0, tpeak*0.9999]
     endif else if tr eq 1 then begin
       tu = findgen(128)*(tpeak*0.9999/127.0)
       uu = sin(!pi/254.0*findgen(128))^2
     endif else begin
       tu = findgen(128)/127.0
       uu = tu*exp(1-tu)
       tu = tu*(tpeak*0.9999)
     endelse
     if tf eq 0 then begin
       tu = [tu, fstart, fstart+2*fwidth]
       uu = [uu, 1.0, 0.0]
     endif else if tf eq 1 then begin
       tu = [tu, findgen(128)*(2*fwidth/127.0)+fstart]
       uu = [uu, 1-sin(!pi/254.0*findgen(128))^2]
     endif else begin
;      half max occurs at 2.678347 for peak at 1.0
         t = [findgen(128)/64.0, 2+findgen(128)/16., 8+findgen(64)/4.0]
       uu = [uu, (1.0+t)*exp(-t)]
       tu = [tu, fstart + t*(fwidth/1.678347)]
     endelse
     uu = uu*peakv
   endif else begin
;    wdf array
     widget_control, info.wdfa, get_value = wdfa
     value.wdfa = wdfa
     if wdfa lt 1 or wdfa gt maxwdfarray then begin
       winformation, 'WDF array must be greater than 0 and </= ' + $
                     strtrim(maxwdfarray, 2)
       return
     endif
     if wdfnp(wdfa-1) lt 2 then begin
       winformation, 'WDF array must have more than 1 point'
       return
     endif
     w2i, tu, uu, wdfa
     mm = wdfmax(wdfa-1)
     if mm ne peakv then uu = uu*(peakv/mm)
   endelse
   ier = 0
   widget_control, info.eflow, get_value = lcflow
   widget_control, info.flash, get_value = lcflash
   widget_control, info.qlimit, get_value = qemit
   value ={lcquit:0, uu:uu, tu:tu, zsource:value.zsource, $
     stype:value.stype, wdfa:value.wdfa, rtype:value.rtype, $
     tpeak:value.tpeak, ftype:value.ftype, tfall:value.tfall, $
     twidth :value.twidth, umax:value.umax, offset:offset, $
     lcflow:lcflow, qemit:qemit, flash: lcflash}
   return
   end
