; ------------------------------------------------------------------------ 
; $Id: get_zztz.pro,v 1.3 2007/06/06 19:34:30 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro get_zztz, info, value, ier, offset

; value = {lcquit:0, uu:0.0, tu:0.0, ltype:ltype, wdfb:wdfb, $
;   rltype:rltype, tlpeak:tlpeak, tlftype:tlftype, tlfall:tlfall, $
;   tlwidth:tlwidth, peakz:peakz, plmass:plmass, plmin:plmin, $
;    plength:plength, pradius:pradius, plret:plret, offset}
;
; info = {ptr:ptr, tpeak: field17, wdfa: field30, type:bgroup6, $
;        typrise:bgroup15, typfall:bgroup19, fallstart:field27, $
;        fallwidth: field29, peakZ:field34 , base2:base2, base11:base11, $
;        base12:base12, base13:base13, base15:base15, base4:base4, $
;        base3:base3,  plmass:plmassf, plmin:plminf,plength:plengthf, $
;         pradius:pradiusf, plret:plretf}
;
@com.dat
   if n_elements(initwdf) eq 0 then wdfinit

   on_error, 2
   ier = 1
   widget_control, info.type, get_value = stype
   value.ltype = stype
   if stype lt 4 or stype gt 4 then begin
     widget_control, info.peakz, get_value = peakz
     value.peakz = peakz
   endif
;
   if stype eq 0 or stype eq 5 then begin
;    constant
     uu = [1.0,1.0,  1.0]*peakz
     tu = [0.0,50.0, 100.0]
   endif else if stype eq 1 or stype eq 2  then begin
     if stype eq 2 then begin
;      rising
       widget_control, info.tpeak, get_value= tpeak
       value.tlpeak = tpeak
       widget_control, info.typrise, get_value = tr
       value.rltype = tr
       if tr eq 0 then begin
         uu = [0.0, 0.5, 1.0]
         tu = [0.0, tpeak*0.5, tpeak]
       endif else if tr eq 1 then begin
         tu = findgen(128)*(tpeak/127.0)
         uu = sin(!pi/254.0*findgen(128))^2
       endif else begin
         tu = findgen(128)/127.0
         uu = tu*exp(1-tu)
         tu = tu*tpeak
       endelse
     endif else begin
       tpeak = 0.0
       tu = 0.0
       uu = 1.0
     endelse
;    Falling
     widget_control, info.typfall, get_value =tf
     value.tlftype = tf
     widget_control, info.fallstart, get_value = fstart
     value.tlfall= fstart
     widget_control, info.fallwidth, get_value = fwidth
     value.tlwidth= fwidth
     if fstart lt tpeak then begin
       winformation, $
               'Time to peak must be less than or equal to Fall Begin'
       return
     endif
     if tf eq 0 then begin
       tu = [tu, fstart+findgen(3)*fwidth]
       uu = [uu, 1.0, 0.5, 0.0]
     endif else if tf eq 1 then begin
       tu = [tu, findgen(128)*(2*fwidth/127.0)+fstart]
       uu = [uu, 1-sin(!pi/254.0*findgen(128))^2]
     endif else begin
;      half max occurs at 2.678347 for peak at 1.0
         t = [findgen(128)/64.0, 2+findgen(128)/16., 8+findgen(64)/4.0]
       uu = [uu, (1.0+t)*exp(-t)]
       tu = [tu, fstart + t*(fwidth/1.678347)]
     endelse
     uu = uu*peakz
   endif else if stype eq 3 then begin
;    wdf array
     widget_control, info.wdfa, get_value = wdfa
     value.wdfb = wdfa
     if wdfa lt 1 or wdfa gt maxwdfarray then begin
       winformation, 'WDF array must be greater than 0 and </= ' + $
                     strtrim(maxwdfarray, 2)
       return
     endif
     if wdfnp(wdfa-1) lt 2 then begin
       winformation, 'WDF array must have more than 1 point'
       return
     endif
     w2i, tu, uu, wdfa
     mm = wdfmax(wdfa-1)
     if mm ne peakz then uu = uu*(peakz/mm)
   endif else if stype eq 4 then begin
     widget_control, info.plmass, get_value= plmass
     widget_control, info.plength, get_value= plength
     widget_control, info.pradius, get_value= pradius
     widget_control, info.plmin, get_value= plmin
     widget_control, info.plret, get_value= plret
     if plret gt 100.0 or plret le 0.0 then begin
       print,'Return current radius must be greater than 0.0 and less than 100%'
       return
     endif
     if plmin gt 100.0 or plmin le 0.0 then begin
       print, ' Minimum radius must be greater than 0.0 and less than 100%'
       return
     endif
     if plret lt pradius then begin
       print, ' Return current radius must be larger than initial plasma'
       return
     endif
     if plength le 0 then begin
       print, ' Plasma must have a finite length'
       return
     endif
     value.plmass = plmass
     value.plength = plength
     value.pradius = pradius
     value.plmin = plmin
     value.plret = plret
     tu = findgen(5)
     uu = [plmass, plength, pradius, plmin, plret]
   endif else begin
     print, ' This load type is not supported. - ', strtrim(stype, 2)
     return
   endelse

   if n_elements(offset) lt 2 then offset = [0l, 0l]
   ier = 0
   value ={lcquit:0, uu:uu, tu:tu, ltype:value.ltype, wdfb:value.wdfb, $
    rltype:value.rltype, tlpeak:value.tlpeak, tlftype:value.tlftype, $
    tlfall:value.tlfall, tlwidth:value.tlwidth, peakz:value.peakz, $
    plmass:value.plmass, plmin:value.plmin, plength:value.plength, $
    pradius:value.pradius, plret:value.plret, offset:offset}
   return
   end
