; ------------------------------------------------------------------------ 
; $Id: make_planes.pro,v 1.3 2007/06/06 19:34:30 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;

FUNCTION make_planes,Vertices, n0, n1, n2, n3, loc_con
; Original: HCLINE, RSI, January 1999
; Modified: lpmix June 3, 1999
;
; function to create rectangular meshs connectivity 
;   given an xyz list of vertices for the IDLgrPolygon object.
; Planes are separated by slants, X-normal, Y-normal, and Z-normal
; 
; The vertices (3, nvert) are the coordinates of each plane of conductor data
; These are from QuickSilver output files.
;

 Info = Size(Vertices)
 nVerts = Info[2]
 nPoly = nVerts/4
 Connectivity = LONARR(nVerts +nPoly)
 ii = LINDGEN(nPoly)*5
 Connectivity (ii) = 4L
 s= [0L,1L,2L,3L]
 j = 0L
 loc_con = make_array(5, value = 0L, /long)
 if n0[0] ge 0 then begin
   nn = n_elements(n0)
   for i = 0L, nn-1 do begin
     connectivity[(j+1):(j+4)] = s+4*n0[i]
     j = j+5L
   endfor
   loc_con[1] = j
 endif
 if n1[0] ge 0 then begin
   nn = n_elements(n1)
   loc_con[2] = j+nn*5
   for i = 0L, nn-1 do begin
     connectivity[(j+1):(j+4)] = s+4*n1[i]
     j = j+5L
   endfor
   loc_con[2] = j
 endif
 if n2[0] ge 0 then begin
   nn = n_elements(n2)
   for i = 0L, nn-1 do begin
     connectivity[(j+1):(j+4)] = s+4*n2[i]
     j = j+5L
   endfor
   loc_con[3] = j
 endif
 if n3[0] ge 0 then begin
   nn = n_elements(n3)
   loc_con[4] = j
   for i = 0L, nn-1 do begin
     connectivity[(j+1):(j+4)] = s+4*n3[i]
     j = j+5L
   endfor
   loc_con[4] = j
 endif

 RETURN,Connectivity

END
