; ------------------------------------------------------------------------ 
; $Id: make_triangles.pro,v 1.4 2007/06/06 19:34:30 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 function make_triangles, array , nx, ny, ndim= ndim, toggle = toggle, $
   quadrilateral = quadrilateral
 common make_triangle_common, toggle_value
 COMPILE_OPT hidden

 on_error, 1
; t = systime(1)
 if n_elements (toggle_value) eq 0 then toggle_value = 0
 if keyword_set (toggle) then begin
   toggle_value = (toggle_value + 1) mod 2
   print, '% MAKE_TRIANGLES: Toggle value set to: ', strtrim(toggle_value, 2)
   return, 0
 endif
 npar = n_params()
 if npar eq 0 then begin
   print, '% Format: TRIANGLES = MAKE_TRIANGLES (Array, nx, ny, ndim, /TOGGLE)'
   return, 0
 endif
 if n_elements (ndim) eq 0 then ndim =2
if n_params() eq 1 then begin
  ss = size(array)
  nodes = ss(1)
  if ndim eq 3 then nodes = nodes/2 > 3
  triangles  = ss(2)
  tri= ss(2)*(nodes-2)
  tri = make_array(3,tri, /long)
  if nodes eq 3 then begin
    tri = array
  endif else if nodes eq 4 then begin
    j = 0L
    val = [0L, 1L, 2L, 0, 2, 3]
    in6 = lindgen(6)
    for i = 0L, triangles -1 do begin
      tri(in6) = array(val)
      val = val +4L
      in6 = in6 +6l
    endfor
  endif else if nodes eq 5 then begin
    j = 0L
    val = [0L, 1L, 2, 0, 2, 3, 0, 3, 4]
    in9 = lindgen(9)
    for i = 0L, triangles -1 do begin
      tri(in9) = array(val)
      val = val +5L
      in9 = in9 +9L
    endfor
  endif else tri = 0
  return, tri
endif
;
; mapped mesh
;
  if n_elements (nx) eq 0 or n_elements(ny) eq 0 then begin
    tri = 0
    return, tri
  endif
  if nx eq 0 or ny eq 0 then begin
    tri = 0
    return, tri
  endif
  nxm = nx-1L 
  nym = ny-1L
;
; Quadrilaterals
;
  if keyword_set(quadrilateral) then begin
    tri = make_array(4*nxm,nym, /long)
    row = make_array (4, nxm, /long)
    if toggle_value eq 0 then $
      row(*, 0) =[ 0L, 1, nx+1,nx] $
    else row(*, 0) =[ 0L, nx, nx+1, 1]
    i = 1L
    while (i lt nxm) do begin
      if (i+i) lt nxm then $
        row(*, i:i+i-1) = i+row(*, 0:i-1) $
      else row(*, i:nxm-1) = i + row(*, 0:nxm-1-i)
      i = i+i
    endwhile
    j = 1L
    row = reform (row, 4*nxm, /overwrite)
    tri(*, 0) = row
    for i = 1L, nym-1 do tri(*, i) = i*nx+row
    row =0
    tri = reform (tri, 4, (nxm*nym), /overwrite)
    return, tri
  endif
; 
;  Triangles
;
  tri = make_array(6*nxm,nym, /long)
  row = make_array (6, nxm, /long)
  if toggle_value eq 0 then $
    row(*, 0) =[ 0L, 1, nx+1,0, nx+1, nx] $
  else row(*, 0) =[ 0L, 1, nx, 1, nx+1, nx]
  i = 1L
  while (i lt nxm) do begin
    if (i+i) lt nxm then $
      row(*, i:i+i-1) = i+row(*, 0:i-1) $
    else row(*, i:nxm-1) = i + row(*, 0:nxm-1-i)
    i = i+i
  endwhile
  j = 1L
  row = reform (row, 6*nxm, /overwrite)
  tri(*, 0) = row
; while j lt nym do begin
;  if j+j lt nym then $
;    tri (*,j:j+j-1) = j*nx+tri(*, 0:j-1) $
;    else tri(*, j:nym-1) = j*nx+tri(*, 0:nym-1-j)
;  j = j+j
; endwhile
  for i = 1L, nym-1 do tri(*, i) = i*nx+row
  row =0
  tri = reform (tri, 3, 2*(nxm)*(nym), /overwrite)
; print, systime(1)-t
  return , tri
 end
