; ------------------------------------------------------------------------ 
; $Id: mdata.pro,v 1.4 2007/06/06 19:34:30 lpmix Exp $ 
; ------------------------------------------------------------------------ 
; 
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;

 Pro mdata, plot = plot, dest = dest, cd = cd, delete = delete, swap = swap
;
;+
;  Move digitized data from Micro-d
; format: mdata 
;   this routine should be run in the directory where the files exist
;   Files should be of the form SXXXXyyyyy.hdr where 
;     S is required
;  XXXX is a 4 digit shot number
;  yyyyy is an arbitrary length identifier
;  .hdr is the extension for the header (.img is assumed for the image file)
;  The pff file will be put into /archive/jebailey/ShotXXXX/SXXXXyyyyy.pff
;-
  on_error, 1
 
 ls, '*.hdr', cur =pe_files, /quiet
 nfiles = n_elements(pe_files)
 
 if strlen(pe_files[0]) eq 0 then begin
   print,' No Perkin-Elmer files in this directory'
   print,'  with lower case extensions. (*.hdr)'
 endif else begin
 if n_elements(delete) eq 0 then delete = 1
 if n_elements(dest) eq 0 then cd = 1
 if keyword_set(cd) then cd, current = dest
 if n_elements (dest) eq 0 then destination = '/archive/jebailey/' else $
    dfile = dest
 print, 'Destination directory: ', dest
 Print, nfiles, ' Perkin Elmer files will be converted'

 for i = 0, nfiles-1 do begin
   file= pe_files(i)
   if n_elements (dest) eq 0 then begin
     ok = strpos(file, 'S')
     if ok(0) ne 0 then begin
       Print,' Files do not have a S as the first character'
       return
     endif
     snumb = strmid(file, 1, 4)
     dfile = destination + 'Shot'+snumb 
   endif
   pe2pff, /pheader, file, destination = dfile, plot = plot, $
        swap = swap, delete = delete
 endfor
 endelse
 if !version.os eq 'Win32' then return
 ls, '*.HDR', cur =pe_files, /quiet
 nfiles = n_elements(pe_files)
 if strlen(pe_files[0]) eq 0 then begin
   print,' No Perkin-Elmer files in this directory'
   print,'  with upper case extensions. (*.HDR)'
 endif else begin
 if n_elements(delete) eq 0 then delete = 1
 if n_elements(dest) eq 0 then cd = 1
 if keyword_set(cd) then cd, current = dest
 if n_elements (dest) eq 0 then destination = '/archive/jebailey/' else $
    dfile = dest
 print, 'Destination directory: ', dest
 Print, nfiles, ' Perkin Elmer files will be converted'
 for i = 0, nfiles-1 do begin
   file= pe_files(i)
   if n_elements (dest) eq 0 then begin
     ok = strpos(file, 'S')
     if ok(0) ne 0 then begin
       Print,' Files do not have a S as the first character'
       return
     endif
     snumb = strmid(file, 1, 4)
     dfile = destination + 'Shot'+snumb
   endif
   pe2pff, /pheader, file, destination = dfile, plot = plot, $
      swap= swap, ximage = '.IMG', xheader='.HDR', delete = delete
 endfor
 endelse

 return
 end

