; ------------------------------------------------------------------------ 
; $Id: mitl_plot.pro,v 1.3 2007/06/06 19:34:30 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro plot2, sty, ran
;
@mitl_common.com
;
 on_error, 2
 ok = where (str.pos ge ran(0) and str.pos le ran(1), nok)
 if nok eq 0 then begin
   Print, 'No data in the plot interval. Must have at least one point'
   return
 endif

 yr = [min([str.zf, str.zf-str.zv], max = mm), mm]

 ok = where (str.lcemit eq 1, nok)
 if nok eq 0 then ok = str.npos-1 else begin
   if ok(0) gt 0 then $
     ok = where (str.pos ge str.x(ok(0)))
 endelse

 plot, str.pos, str.zflow, /nodata, xtit='Distance', ytit= 'Ohms', yrange= yr, $
      tit = 'Flow and (Flow-Vacuum) Impedance', xrange = ran, xstyle=sty
 if ok(0) gt 0 then begin
   oplot, str.pos(0:ok(0)), str.zflow(0:ok(0))-str.zvac(0:ok(0)), color = 1 
   oplot, str.pos(0:ok(0)), str.zflow(0:ok(0)), color = 1
 endif
 if  ok(0) lt  str.npos-1 then begin
   oplot, str.pos(ok(0):*), str.zflow(ok(0):*)-str.zvac(ok(0):*), color = 2
   oplot, str.pos(ok(0):*), str.zflow(ok(0):*), color = 2
 endif
 oplot, str.x, str.zf, psym = 8, syms= 1.5
 oplot, str.x, str.zf-str.zv, psym = 8, syms= 1.5
 oplot, !x.crange, [0, 0] , color = 4
 ok = where (str.zfcon gt 0.0, nok)
 if nok gt 0 then begin
   mksymbol, 'X', /fill
   plots, str.x(ok), str.zf(ok), psym = 8, syms=2.0
   plots, str.x(ok), str.zf(ok)-str.zv(ok), psym = 8, syms=2.0 
 endif

 return
 end

 pro plot1, sty, ran
;
@mitl_common.com
;
 on_error, 2
 ok = where (str.pos ge ran(0) and str.pos le ran(1), nok)
 if nok eq 0 then begin
   Print, 'No data in the plot interval. Must have at least one point'
   return
 endif 

 ok = where (str.lcemit eq 1, nok)
 if nok eq 0 then ok = str.npos-1 else begin
   if ok(0) gt 0 then $
     ok = where (str.pos ge str.x(ok(0)))
 endelse

 plot, str.pos, str.zvac, /nodata, xtit= 'Distance', ytit= 'Ohms', $
      tit = 'Vacuum and Flow Impedance', xrange = ran, xstyle=sty
 if ok(0) gt 0 then begin
   oplot, str.pos(0:ok(0)), str.zvac(0:ok(0)), color = 1
   oplot, str.pos(0:ok(0)), str.zflow(0:ok(0)), color = 1
 endif
 if ok(0) lt  str.npos-1 then begin
   oplot, str.pos(ok(0):*), str.zvac(ok(0):*), color = 2
   oplot, str.pos(ok(0):*), str.zflow(ok(0):*), color = 2
 endif

 oplot, str.x, str.zf, psym = 8, syms= 1.5
 oplot, str.x, str.zv, psym = 8, syms= 1.5
 ok = where (str.zfcon gt 0.0, nok)
 if nok gt 0 then begin
   mksymbol, 'X', /fill
   plots, str.x(ok), str.zf(ok), psym = 8, syms=2.0
   plots, str.x(ok), str.zv(ok), psym = 8, syms=2.0 
 endif
 return
 end

 pro mitl_plot, type, xrange= xrange
;

@mitl_common.com
;
on_error, 1

  if str.np lt 2  then message, ' NOT enough points in MITL structure.'
    if n_elements (type) eq 0 then type = 0
    mkcircle
    if n_elements (xrange) lt 2 then begin
       xran = [str.pos(0), str.pos(str.npos-1)]
       xstyle = 0
    endif else begin
       xran = xrange(0:1)
       xstyle = 1
    endelse
    if type eq 0 then plot1, xstyle, xran else plot2, xstyle, xran
 return
 end
