; ------------------------------------------------------------------------ 
; $Id: qsinit.pro,v 1.4 2007/06/06 19:34:31 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro qsinit
;+
;  Initialize default conductor/grad parameters and the plot orientation
;  format; qsinit
;         Each user can put his own version of this routine in his own 
;         procedure library.
;         The present version sets the following parameters.
;
;
; common qsplotcom, xoldvalue, yoldvalue, zplaneold, zvalueold, lctwodim, $
;      qsplotinit, grdcolor, grdthick, transdefault
;       fldcolor, directorypage, directoryhelp
;  (@qscom.dat accesses the common block, setdefault changes values)
; store the x component of the current graph in xoldvalue
;     xoldvalue = 0.0
; store the y component of the current graph in yoldvalue
;     yoldvalue = 0.0
; store the z component in zplaneold where z is the plane cut in 3D space
;     zplaneold  = 0.0
; store the value of z in zvalueold
;     zvalueold = 0.0
; store zero in lctwom if 3D or store the dimension with zero data
;     lctwodim = 0.0
; store the default for interchange of x and y in transdefault
;     transdefault = 0.0
; load default color tables
;     loadxyct
; store the default color for conductors 
; Use plotcon, /set
; store the default thickness for conductors
; Use plotcon, /set
; store the default color for grids
;     grdcolor = 0
; store the default thickness for grids
;     grdthick = 0.6
; store a nonzero value in the initializaton parameter
;     qsplotinit = 1
; store the default color for field plots (PLOTFLD)
;     fldcolor = -1
; store the default page size for scroll directory (DIR)
;     directorypage = 24
; store the default font for the scroll directory
;     directoryfont = 'a14'(HP) or 6x12 (SUN)
; store the default for the directory help window (DIR)
;     directoryhelp = 1
; call userqsinit to allow the user to reset these values
;-
; insert a common block
;
 COMPILE_OPT hidden

@qscom.dat
@loadxyct_common.dat

;
on_error, 2
; store the x component of the current graph in xoldvalue
      xoldvalue = 0.0
; store the y component of the current graph in yoldvalue
      yoldvalue = 0.0
; store the z component in zplaneold where z is the plane cut in 3D space
      zplaneold  = 0.0
; store the value of z in zvalueold
      zvalueold = 0.0
; store zero in lctwom if 3D or store the dimension with zero data
      lctwodim = 0.0
; store the default for interchange of x and y in transdefault
      transdefault = 0.0
; load default color tables
  if n_elements(loadct_init) eq 0 then loadxyct
; store the default color for conductors
;      concolor = 0
; store the default thickness for conductors
;      conthick = 2
; store the default color for grids
      grdcolor = 0
; store the default thickness for grids
      grdthick = 0.6
; store a nonzero value in the initializaton parameter
      qsplotinit = 1
; store the default color for field plots (PLOTFLD)
      fldcolor = -1
; store the default page size for scroll directory (DIRP)
      directorypage = 24
; store the default font for the scroll directory
  if (strmid(!version.arch,0,2) eq 'hp') then begin
    directoryfont = 'a14'
  endif else begin
    directoryfont = '6x12'
  endelse
; store the default for the directory help window (DIR)
      directoryhelp = 1
        return
        end
