; ------------------------------------------------------------------------ 
; $Id: remove_extra.pro,v 1.3 2007/06/06 19:34:32 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro   remove_extra,axis, trans, nblo, farray, x, y, $
         locfa, locx, locy, lenfa,  nx, ny
; axis is x or y axis (1 or 2)
; trans is transpose flag(0 = no, 1 = yes)
; nblo = number of blocks
; farray, x, y are array and axes
; locfa, locx,locy are pointers to first element in x and y
; lenfa, nx, ny are number of elements in x and y in each direction 

ix = 0
iy = 0
fa = 0
lf = locfa
lx = locx
ly = locy
if axis eq 1 then begin
  nx = nx-2
  ny = ny-1
  for i = 0, nblo-1 do begin
    ib = locfa(i)
    ie = locfa(i+1)-1
    temp = reform (farray(ib:ie), nx(i)+2, ny(i)+1, /overwrite)
    temp = temp(1:nx(i), 1:ny(i))
    if (trans ne 0) then temp = transpose(temp)
    lenfa(i) = nx(i)*ny(i)
    farray(fa:fa+lenfa(i)-1) = temp
    fa = fa+lenfa(i)
    lf(i+1) = fa
    x(ix:ix+nx(i)-1) = x(locx(i)+1:locx(i+1)-2)
    ix = ix+nx(i)
    lx(i+1) = ix
    y(iy:iy+ny(i)-1) = y(locy(i)+1:locy(i+1)-1)
    iy = iy+ny(i)
    ly(i+1) = iy
  endfor
  farray = farray(0:fa-1)
  x = x(0:ix-1)
  y = y(0:iy-1)
  locfa = temporary(lf)
  locx = temporary(lx)
  locy = temporary(ly)
endif else begin
  nx = nx-1
  ny = ny-2
  for i = 0, nblo-1 do begin
    ib = locfa(i)
    ie = locfa(i+1)-1
    temp = reform (farray(ib:ie), nx(i)+1, ny(i)+2, /overwrite)
    temp = temp(1:nx(i), 1:ny(i))
    if (trans ne 0) then temp = transpose(temp)
    lenfa(i) = nx(i)*ny(i)
    farray(fa:fa+lenfa(i)-1) = temp
    fa = fa+lenfa(i)
    lf(i+1) = fa
    x(ix:ix+nx(i)-1) = x(locx(i)+1:locx(i+1)-1)
    ix = ix+nx(i)
    lx(i+1) = ix
    y(iy:iy+ny(i)-1) = y(locy(i)+1:locy(i+1)-2)
    iy = iy+ny(i)
    ly(i+1) = iy
  endfor
  farray = farray(0:fa-1)
  x = x(0:ix-1)
  y = y(0:iy-1)
  locfa = temporary(lf)
  locx = temporary(lx)
  locy = temporary(ly)

endelse
return
end
