pro  remove_ghost_cells, str, n

; str - structure to have ghost cells removed
; n   - number of ghost cells for each dimension
;       n[0] - lower end of i dimension
;       n[1] - upper end of i dimension
;       n[2] - lower end of j dimension
;       n[3] - upper end of j dimension
;       n[4] - lower end of k dimension
;       n[5] - upper end of k dimension
;
on_error, 1

s2i, s, str
typ = s.type

nblo = s.block
ndim = s.ndim
ssiz = make_array(ndim, nblo, /long)
locx = make_array(ndim, nblo+1, /long, value =0L)
range = make_array(2, ndim, nblo+1 )
if typ eq 1 then locv = make_array(nblo+1, /long, value = 0L)
x1 = s.x1
x2 = s.x2
x3 = s.x3
if typ eq 1 then v1 = s.v1
clab = s.clab +' - Ghost Cells removed'

for i = 1, nblo do begin
  x = s.x1[s.locx[0, i-1]+n[0]:s.locx[0, i]-1-n[1]]
  nelx= n_elements(x)
  locx[0, i]= locx[0, i-1]+nelx
  x1 [locx[0, i-1]:locx[0, i]-1]=x
  range[0, 0, i]= min(x, max = mm)
  range[1, 0, i]= mm

  y = s.x2[s.locx[1, i-1]+n[2]:s.locx[1, i]-1-n[3]]
  nely= n_elements(y)
  locx[1, i]= locx[1, i-1]+nely
  x2 [locx[1, i-1]:locx[1, i]-1]=y
  range[0, 1, i]= min(y, max = mm)
  range[1, 1, i]= mm

  z = s.x3[s.locx[2, i-1]+n[4]:s.locx[2, i]-1-n[5]]
  nelz= n_elements(z)
  locx[2, i]= locx[2, i-1]+nelz
  x3 [locx[2, i-1]:locx[2, i]-1]=z
  range[0, 2, i]= min(z, max = mm)
  range[1, 2, i]= mm
  ssiz[*, i-1]=[nelx, nely, nelz]
  if typ eq 1 then begin
    v = get_array(s, -1, i)
    v = v[n[0]:n[0]+nelx-1, n[2]:n[2]+nely-1, n[4]:n[4]+nelz-1]
    nelv = n_elements(v)
    locv[i]= locv[i-1]+nelv
    v1[locv[i-1]:locv[i]-1] = v
  endif
endfor
for i = 0, 2 do range[0, i, 0]= min(range[0, i, 1:*])
for i = 0, 2 do range[1, i, 0]= max(range[1, i, 1:*])
x1 = x1[0:locx[0, nblo]-1]
x2 = x2[0:locx[1, nblo]-1]
x3 = x3[0:locx[2, nblo]-1]
if typ eq 1 then v1=v1[0:locv[nblo]-1]

if typ eq 1 then ss = {type:1L, ndim:ndim, nvect: s.nvect, block :nblo, $
              two: s.two, slice: s.slice, size: ssiz, range: range, $
              order:s.order, locx:locx, locv: locv, x1:x1, x2:x2, $
              x3:x3, x4:s.x4, v1:v1, v2:s.v2, v3:s.v3, v4:s.v4, $
              v5:s.v5, v6:s.v6,x1lab :s.x1lab, x2lab :s.x2lab, $
              x3lab : s.x3lab, x4lab :s.x4lab,v1lab : s.v1lab, v2lab :s.v2lab, $
              v3lab : s.v3lab, v4lab :s.v4lab,v5lab : s.v5lab, v6lab :s.v6lab, $
              file :s.file, spare : s.spare, tlab : s.tlab, clab: clab} else $
   ss = {type:3L, ndim:3L,  block :nblo, two:s.two, range:range, $
              size: ssiz, locx : locx, slice: s.slice,  $
              x1:x1, x2:x2, x3:x3, x1lab : s.x1lab, x2lab :s.x2lab, $
              x3lab : s.x3lab, proc: 0, file : s.file, spare :s.spare, $
              tlab : s.tlab, clab: clab }
 i2s, ss, str, /no_copy
 s = 0
 end
