; ------------------------------------------------------------------------ 
; $Id: set_aspect.pro,v 1.3 2007/06/06 19:34:32 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
PRO SET_ASPECT, aspect, MARGIN = margin

; This program sets the plot position, !P.POSITION
; to ensure the desired aspect ratio for the final
; plot with a margin on each side.

;Find the aspect ratio of the current window
daspect = FLOAT(!D.Y_SIZE)/FLOAT(!D.X_SIZE)
IF NOT KEYWORD_SET(margin) THEN margin = 0.05

IF(aspect LE daspect) THEN BEGIN
   x0 = margin
   y0 = 0.50 - (0.5 - margin)*(aspect/daspect)
   x1 = 1.0 - margin
   y1 = 0.50 + (0.5 - margin)*(aspect/daspect)
ENDIF ELSE BEGIN
   x0 = 0.50 - (0.5 - margin)*(daspect/aspect)
   y0 = margin
   x1 = 0.50 + (0.5 - margin)*(daspect/aspect)
   y1 = 1.0 - margin
ENDELSE
!P.POSITION = [x0, y0, x1, y1]

RETURN
END
