; ------------------------------------------------------------------------ 
; $Id: sortxy.pro,v 1.4 2010/09/03 15:21:39 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro  sortxy, space, image, nel
;
;     sort pairs of points and eliminate by averaging multiple entries
;
      space = reform (space)
      image = reform (image)
      n = size(space)
      m = size(image)
;     Make sure the arrays are good
;
      if (n(0) ne 1) or (m(0) ne 1) then begin
        print, 'x and y arrays must be one dimensional to convert to wdf array'
        return
      endif
      nel = m(1)
      if nel lt 2 then begin
        print, 'Arrays must have at least 2 values'
        return
      endif
      if (n(1) lt m(1)) then begin
        print,'x array must be at least as large as the y array'
        return
      endif
;     set arrays to the same size
      space= space (0:nel-1)
;     determine if a sort is necessary
      diff = space(1:nel-1) - space(0:nel-2)
      maxdiff = max(diff, min=mindiff)
      if (mindiff lt 0.0) then begin
;     need to sort the data
        ind = sort (space)
        space = space[ind]
        image = image[ind]
        ind = 0
        diff = space[1:nel-1] - space[0:nel-2]
        maxdiff = max(diff, min=mindiff)
      endif
      if (mindiff eq 0.0) then begin
;     need to eliminate multiple x values
        list = where (diff eq 0.0 , ind)
        np = list
        if ind gt 1 then begin
          nl = 2
          ni = 0
          nst = list[0]
          for i = 1L, ind-1 do begin
            if (list[i-1]+1 eq list[i]) then nl = nl+1 else begin
              list[ni] = nst
              np [ni] = nl
              nst = list[i]
              nl = 2
              ni = ni+1
            endelse
          endfor
          list[ni] = nst
          np[ni] = nl
          ni = ni+1
        endif else begin
          ni = 1
          np(0) = 2
        endelse
        nelim = 0
        for i = 0L, ni-1 do begin
          ind = list[i] - nelim
          image[ind] = total(image[ind+indgen(np[i])])/ float(np[i])
          image[ind+1:nel-nelim-np[i]] = image [ind+np[i]:nel-nelim-1]
          space[ind+1:nel-nelim-np[i]] = space [ind+np[i]:nel-nelim-1]
          nelim = nelim -1 +np[i]
        endfor
        nel = nel - nelim
        if nel lt 2 then begin
          print, ' SORTXY error, number of elements is', nel
          return
        endif
        diff = space[1:nel-1] - space[0:nel-2]
        maxdiff = max(diff, min=mindiff)
        if mindiff eq 0 then print,' There is a problem in SORTXY; get help!!'
      endif
      space = space[0:nel-1]
      image = image[0:nel-1]
      return
      end
