; ------------------------------------------------------------------------ 
; $Id: thick_line.pro,v 1.3 2007/06/06 19:34:33 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro thick_line, x, y, w
; convert a line (x, y) into a thick changing each data points to 2 
;   data points for each segment.
;
on_error, 2
npar = n_params()
if npar ne 3 then begin
  print, '%THICK_LINE: Must have three parameters'
  return
endif
nely = n_elements(y)
nelx = n_elements(x)
if nelx lt 2 or nely lt 2 then begin
   print, '%THICK_LINE: X and Y must have at least 2 elements'
   return
endif
if n_elements(w) eq 0 then begin
   Print, '%THICK_LINE: Width must be defined'
   return
endif else w2 = 0.5*abs(w(0))
if nelx ne nely then print, $
  'Arrays are not the same length; longest will be terminated'
;
nel = min([nelx, nely])
xx = temporary(x(0:nel-1))
yy = temporary(y(0:nel-1))
nt = 2*nel
x = make_array(nt+1)
y = x

dx = xx(1:nel-1)-xx(0:nel-2)
dy = yy(1:nel-1)-yy(0:nel-2)
abc = sqrt(dx*dx + dy*dy)
lx  = make_array(nel+1)
ly = lx
lx(1:nel-1) = dx/abc
ly(1:nel-1) = dy/abc
lx(0) = lx(1)
ly(0) = ly(1)
lx(nel) = lx(nel-1)
ly(nel) = ly(nel-1)
lax = (lx(0:nel-1) +lx(1:nel))
lay = (ly(0:nel-1) +ly(1:nel))
abc = sqrt(lax*lax+lay*lay)
lax = lax/abc
lay = lay/abc
theta = -(lx(0:nel-1)*lx(1:nel)+ ly(0:nel-1)*ly(1:nel)) > (-1)
theta = acos(theta < 1.)
theta = (!pi -theta)*0.5
d = w2/cos(theta)
x (0:nel-1) =  -d*lay
x (nel:nt-1) =rotate( xx-x(0:nel-1) , 2)
x (0:nel-1) = x(0:nel-1) + xx
y (0:nel-1) =  d*lax
y (nel:nt-1) =rotate( yy-y(0:nel-1)  , 2)
y (0:nel-1) = y(0:nel-1) + yy
x (nt) = x(0)
y (nt) = y(0)

return
end
  
