; ------------------------------------------------------------------------ 
; $Id: widget_directory.pro,v 1.5 2008/06/19 17:25:58 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
; 
;    base is a base widget
;    page is the size of the page
;    list is the list for the list widget
;    Text1 is the top text widget (for filename, or column headings))
;    value1 goes into text1
;  note text2 and value 2 are not used for dirw, dirs
;    text2 is the second text widget (for column headings)
;    value2 goes into text2
;    Base_title is the title in the base widget
;    dirtype is the type of directory
;    0 is unknown
;    1 is pff
;    2 is cdf
;    3 is pdb
;    4 is saf
;    11 is wdf arrays
;    12 is structure arrays
;   
;
;
pro widget_directory_event, event
 on_error, 1

 common widget_directory, dir_offset
 common xrd_data_print_comm, str_com, def_filename, nfile

     if tag_names(event, /structure_name) eq 'WIDGET_KILL_REQUEST' then begin
       widget_control, event.top, get_uvalue= info
       widget_control, event.top, tlb_get_offset = offset
       dir_offset[*, info.dirtype] = offset   
       ptr_free, info.selptr
       widget_control, event.top, /destroy
       return
     endif
     if event.clicks eq 1 then begin
       list_select = widget_info(event.id, /list_select) 
       widget_control, event.top,  get_uvalue= info, /no_copy
       *(info.selptr) = list_select
       widget_control, event.top,  set_uvalue= info, /no_copy
       return
     endif

     widget_control, event.top, get_uvalue= info, /no_copy
     if (info.dirtype ne 1) or (info.fileid eq 0) then begin
       widget_control, event.top,  set_uvalue= info, /no_copy
       return
     endif
     indx = *(info.selptr)
     nsel = n_elements(indx)
     dataset = make_array(nsel, /long)
     for ii = 0, nsel-1 do begin
       j = strpos(info.list[indx[ii]], '-')
       dataset[ii] = long(strmid(info.list[indx[ii]], 0, j))
     endfor
     readhdr, /quiet, dataset[0], ier, fileid = info.fileid, pfftyp= pfftyp, $
       namefile = filename, aptype = aptype, clabel = clabel, $
       tlabel = tlabel, iextra = iextra 
     if ier ne 0 then begin
       print, '% WIDGET_DIRECTORY: Unable to read PFF dataset'
       widget_control, event.top,  set_uvalue= info, /no_copy
       return
     endif 
     if aptype le 30 or pfftyp eq 2 then begin
       lcstr = 1
;      pfftyp =2 >> uf1
       if pfftyp eq 2 then lcstr = 0 else begin
         if pfftyp eq 3 then begin
           if (iextra[2] eq 1) and (iextra[3] eq 1) then lcstr =0
;        pfftyp =7 >> ngd
         endif else if pfftyp eq 7 then begin 
           if (iextra[0]) eq 1 then lcstr = 0
         endif
       endelse
     endif else begin
       if aptype eq 101 and pfftyp eq 6 then begin
         readifl,str, dataset[0], structure = 101
         str_com = temporary (str)
         print, ' xrd header dataset'
         return
       endif else if aptype gt 100 and aptype le 130 then lcstr = 1 $
       else begin
         print, '% WIDGET_DIRECTORY: Unable to recognize pff application'
         widget_control, event.top,  set_uvalue= info, /no_copy
         return
       endelse
     endelse 
     if lcstr eq 1 then try = get_save_str(info.str, get_maxstr()) $
        else try = get_save_array(info.wdf , get_maxwdf())

     widget_control, event.top, tlb_get_offset = offset
     dir_offset[*, info.dirtype] = offset   
     widget_control, event.id, sensitive = 0
     widget_get_array, lcstr, dataset, filename, tlabel, clabel, try, $
       dirtype = info.dirtype, offset = offset
     if lcstr eq 1 then info.str =try else if lcstr eq 0 then info.wdf = try
     if (lcstr lt 0) or (info.lc_quit eq 0) then begin
       widget_control, event.id, sensitive = 1
       widget_control, event.top, set_uvalue= info, /no_copy
       return
     endif
     widget_control, event.top, tlb_get_offset = offset
     dir_offset[*, info.dirtype] = offset
     ptr_free, info.selptr
     widget_control, event.top, /destroy
end
     
pro widget_directory, base, page, list, line, base_title = base_title, $
     xsize = xsize,  dirtype = dirtype, fileid = fileid, no_block=no_block,  $
     text1 = text1, text2 = text2, value1 = value1, value2 = value2
;
on_error, 1
 common widget_directory, dir_offset

     if n_elements (dir_offset) eq 0 then dir_offset = make_array(2, 21, /long)
;  base is the old base
        if n_elements(no_block) eq 0 then begin
          defsysv, "!callable_idl", exists = block
          no_block = (block eq 0)
        endif
        if no_block eq 0 then lc_quit = 1 else lc_quit =0
	widget_control, base, bad_id = bad
	if (bad ne 0) then base = 0
        if n_elements(dirtype) eq 0 then dirtype =0
        if dirtype lt 0 or dirtype gt 20 then dirtype =0
        if n_elements(fileid) eq 0 then fileid =0
        if base gt 0 then begin
          widget_control, base, get_uvalue = info
          wdf = info.wdf
          str = info.str
        endif else begin
          wdf = 0L
          str =0L
        endelse

        info = { dirtype: dirtype, fileid:fileid, list:line, $
            selptr: ptr_new(0), lc_quit : lc_quit, wdf:wdf, str:str}
       
	if base gt 0 then begin
          widget_control, base, get_uvalue = tmp
          ptr_free, tmp.selptr
	  if page gt 0 then begin
            if text1 gt 0 then widget_control, text1, set_value = value1
	    widget_control, list, set_value = line
            widget_control, base, set_uvalue = info
	    return
	  endif else begin
            widget_control, base, tlb_get_offset = pp
	    widget_control, base, /destroy
            page = -page
	  endelse 
	endif else page = abs(page)

	if n_elements (xsize) eq 0 then $
	  if max(strlen(line)) lt 40 then xsize = 350 else xsize = 0
	if xsize gt 0 then $
	  base = WIDGET_BASE(TITLE = base_title, /column, xsize = xsize, $
           /tlb_kill_request_events) else base = $
           WIDGET_BASE(TITLE = base_title, /column, /tlb_kill_request_events)
; put in the filename
        if n_elements(value1) gt 0 then  $
          text1 = widget_text(base, /frame, value = value1)	  
;
        if n_elements(value2) gt 0 then  $
          text2 = widget_text(base, /frame, value = value2)	  

        list = widget_list(base, value = line, ysize = page, /multiple)
        if n_elements (pp) gt 1 then $
          widget_control, base, /realize, tlb_set_xoffset = pp[0], $
            tlb_set_yoffset = pp[1] else $
          widget_control, base, /realize, $
            tlb_set_xoffset = dir_offset[0, info.dirtype] > 10, $
            tlb_set_yoffset = dir_offset[1, info.dirtype] > 10
        
        widget_control, base, set_uvalue = info
        xmanager, 'widget_directory', base, no_block = no_block
	end
