; ------------------------------------------------------------------------ 
; $Id: widget_get_array.pro,v 1.3 2007/06/06 19:34:33 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;

 pro widget_get_array_event, event
 common widget_directory, dir_offset
 on_error , 1
 widget_control, event.id, get_uvalue = val
 widget_control, event.top, get_uvalue = info, /no_copy
 case val of 
   'ARRAY_TYPE' : BEGIN
                  if event.select eq 1 then begin
                    (*info.ptr).lcstr = event.value
                    if (*info.ptr).dirbase gt 0 then begin
                      widget_control,(*info.ptr).dirbase,tlb_get_offset=offset
                      widget_control, (*info.ptr).dirbase, get_uvalue = winfo
                      dir_offset[*, winfo.dirtype] = offset
                      widget_control, (*info.ptr).dirbase, /destroy
                      if event.value eq 0 then dirw, base = base $
                         else dirs, base = base
                      (*info.ptr).dirbase = base
                    endif
                  endif
                  END
    'READ'      : BEGIN
                  widget_control, info.wtry, get_value = try
                  n = n_elements(info.dataset)
                  if (*info.ptr).lcstr eq 0 then $
                    for i =0, n-1 do re, try+i , (info.dataset)[i] $
                  else for i =0, n-1 do readstr, try+i , (info.dataset)[i]
                  (*(info.ptr)).try = try+n
                  widget_control, (*info.ptr).dirbase > 1, bad_id = bad
                  if bad eq 0 then begin
                    widget_control, (*info.ptr).dirbase, tlb_get_offset = offset
                    widget_control, (*info.ptr).dirbase, get_uvalue = winfo
                    dir_offset[*, winfo.dirtype] = offset
                    widget_control, (*info.ptr).dirbase, /destroy
                  endif
                  widget_control, event.top, /destroy
                  return
                  END
    'QUIT'      : BEGIN
                  (*(info.ptr)).lcstr = -1
                  widget_control, (*info.ptr).dirbase > 1, bad_id = bad
                  if bad eq 0 then begin
                    widget_control, (*info.ptr).dirbase, tlb_get_offset = offset
                    widget_control, (*info.ptr).dirbase, get_uvalue = winfo
                    dir_offset[*, winfo.dirtype] = offset
                    widget_control, (*info.ptr).dirbase, /destroy
                  endif
                  widget_control, event.top, /destroy
                  return
                  END
    'DIRECTORY' : BEGIN
                  if (*info.ptr).lcstr eq 0 then dirw, base = base $
                         else dirs, base = base
                  (*info.ptr).dirbase = base
                  END
 endcase
 widget_control, event.top, set_uvalue = info, /no_copy
 end

 pro Widget_get_array, lcstr, dataset, filename, tlabel, clabel, try, $
                dirtype = dirtype, offset = offset
;
; dirtype = 1 - pff data
; 
;
on_error, 1 
;

if dirtype ne 1 then return
 
ndataset= n_elements(dataset)
tlb = widget_base(title='Read PFF Datasets', /column)

base_type = widget_base(tlb, /frame, /column)

selbut = cw_bgroup(base_type, ['Waveform Array', 'Structure Array'], $
  set_value = lcstr, /row, /exclusive, /no_release, $
              label_top ='Dataset Type', uvalue = 'ARRAY_TYPE')

if Ndataset eq 1 then stext = 'Storage and parameters for the dataset' else $
stext ='Storage and parameters for the first of ' +strtrim(ndataset, 2) $
        + ' datasets'
 
wtext = widget_label(tlb, value = stext)
wtry = cw_field ( tlb, value = try, xsize = 6, $
       Title = 'WDF / Structure Array:', /long)

wfile = cw_field (/noedit, tlb, value = filename, xsize = 50, $
       Title = 'File Name:', /string)

wtype = cw_field (/noedit, tlb, value = tlabel, xsize = 50, $
       Title = 'Type Label:', /string)

wcomm = cw_field (/noedit, tlb, value = clabel, xsize = 50, $
       Title = 'Comment Label:', /string)

bbase = widget_base(tlb, /row, /map, frame=2)

wread = widget_button(bbase, value = ' Read Dataset ', uvalue = 'READ')
wread = widget_button(bbase, value = ' DIRW / DIRS ', uvalue = 'DIRECTORY')
wread = widget_button(bbase, value = '  Q U I T  ', uvalue = 'QUIT')

str = {dirbase: 0L,  try :try, lcstr:lcstr}
ptr = ptr_new(str)
info = {ptr:ptr,  wtype:selbut, wtry:wtry, dataset:dataset}
  
if n_elements(offset) eq 0 then offset = [10, 10]

widget_control, tlb, /realize, $
            tlb_set_xoffset = offset[0] > 10, $
            tlb_set_yoffset = offset[1] > 10

widget_control, tlb, set_uvalue = info

xmanager, 'widget_get_array', tlb, no_block = 0

lcstr = (*ptr).lcstr
try = (*ptr).try
ptr_free, ptr
end
