; ------------------------------------------------------------------------ 
; $Id: cha_vida.pro,v 1.3 2007/06/06 20:13:25 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
;+ 
; NAME:
;       CHA_VIDA
;
; PURPOSE:
;       Scale a Vida Image from microns to millimeters.
;
; CATEGORY:
;       VIDA
;
; CALLING SEQUENCE:
;       CHA_VIDA, STR
;
; INPUTS:
;       STR  Structure or structure array number
;
; KEYWORD PARAMETERS:
;       Any valid keyword to CHASTR may be used.
;
; OUTPUTS:
;       Specified Structure will be scaled to millimeters
;
; PROCEDURE:
;       CHASTR, STR, MADIM= 1.0e-3, XLABEL = 'X (mm)', YLABEL = 'Y (mm)', $
;            _EXTRA = extrastuff
;
; EXAMPLE:
;       Scale structure 1 to mm.
;         CHA_VIDA, 1
;
; MODIFICATION HISTORY:
; 	Written by:	L. P. Mix, January 25, 2003
;-
 Pro CHA_VIDA, str, _extra = extrastuff
on_error, 2
       CHASTR, STR, MADIM= 1.0e-3, XLABEL = 'X (mm)', YLABEL = 'Y (mm)', $
         _extra = extrastuff
END
